(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $FixedPoint32_FixedPoint32 $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@0) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@0))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@1))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@2) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@2))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@3) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@3))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@4) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@4))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@5) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@5))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@6) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@6))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@6 () Bool)
(declare-fun dr_account () T@$Value)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory () T@$Memory)
(declare-fun $abort_code@9 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@4 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@4 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@3 () T@$Memory)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2 () T@$Memory)
(declare-fun $abort_code@7 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1 () T@$Memory)
(declare-fun $abort_code@6 () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@1 () T@$Memory)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $DiemConfig_DiemConfig_$memory@0 () T@$Memory)
(declare-fun $DiemConfig_ModifyConfigCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun call0formal@$tv0@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1 () T@$Value)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun inline$$Vector_empty$0$v@1 () T@$Value)
(declare-fun inline$$Vector_empty$0$ta@0 () T@$TypeValue)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 342889) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 165640) (- 0 347513)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347528)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347545)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347560)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347581)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347610)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347627)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347637)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account)))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347663)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347678)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347699)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347728)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@6) (and (=> (= (ControlFlow 0 165640) (- 0 347745)) (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))))) (=> (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (and (=> (= (ControlFlow 0 165640) (- 0 347966)) (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@6 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@9 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@9 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 165640) (- 0 348297)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))) ($Integer 0)))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))) ($Integer 0))))) (and (=> (= (ControlFlow 0 165640) (- 0 348317)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account)))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account))))) (and (=> (= (ControlFlow 0 165640) (- 0 348345)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 165640) (- 0 348357)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector_$empty ($VectorType $IntegerType))) (+ len@@0 1))))))))) (=> (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)) ($Vector (let ((len@@0 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@0 ($Vector_$empty ($VectorType $IntegerType))) (+ len@@0 1)))))))) (=> (= (ControlFlow 0 165640) (- 0 348385)) (=> (not $abort_flag@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_initialize_$def_verify$0$Abort_correct  (=> (= $DiemConfig_ModifyConfigCapability_$memory@4 $DiemConfig_ModifyConfigCapability_$memory@3) (=> (and (and (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@3) (= $abort_flag@6 true)) (and (= $abort_code@9 $abort_code@8) (= (ControlFlow 0 165586) 165640))) anon0$2_correct))))
(let ((inline$$Diem_initialize_$def_verify$0$anon5_correct  (=> (and (and (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory) (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory)) (and (= $abort_code@8 $abort_code@1) (= (ControlFlow 0 165618) 165586))) inline$$Diem_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 165616) 165618)) inline$$Diem_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 165626) 165618) inline$$Diem_initialize_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon14_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 165610) 165626) inline$$Diem_initialize_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 165610) 165616) inline$$Diem_initialize_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Diem_initialize_$def_verify$0$anon9_correct  (=> (and (and (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory) (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory)) (and (= $abort_code@8 $abort_code@2) (= (ControlFlow 0 165598) 165586))) inline$$Diem_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 165596) 165598)) inline$$Diem_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 165606) 165598) inline$$Diem_initialize_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 165590) 165606) inline$$Diem_initialize_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 165590) 165596) inline$$Diem_initialize_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_initialize_$def_verify$0$anon18_Then_correct  (=> $abort_flag@5 (=> (and (and (= $DiemConfig_ModifyConfigCapability_$memory@3 $DiemConfig_ModifyConfigCapability_$memory@2) (= $DiemConfig_DiemConfig_$memory@3 $DiemConfig_DiemConfig_$memory@2)) (and (= $abort_code@8 $abort_code@7) (= (ControlFlow 0 165582) 165586))) inline$$Diem_initialize_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_initialize_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@5) (= $DiemConfig_ModifyConfigCapability_$memory@4 $DiemConfig_ModifyConfigCapability_$memory@2)) (=> (and (and (= $DiemConfig_DiemConfig_$memory@4 $DiemConfig_DiemConfig_$memory@2) (= $abort_flag@6 $abort_flag@5)) (and (= $abort_code@9 $abort_code@7) (= (ControlFlow 0 165578) 165640))) anon0$2_correct))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@1) (= $abort_flag@5 true)) (and (= $abort_code@7 $abort_code@6) (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@1))) (and (=> (= (ControlFlow 0 165484) 165582) inline$$Diem_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 165484) 165578) inline$$Diem_initialize_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory)) (and (= $abort_code@6 $abort_code@3) (= (ControlFlow 0 165544) 165484))) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 165542) 165544)) inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 165552) 165544) inline$$RegisteredCurrencies_initialize_$def$0$anon5_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon20_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 165536) 165552) inline$$RegisteredCurrencies_initialize_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 165536) 165542) inline$$RegisteredCurrencies_initialize_$def$0$anon21_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory)) (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 165524) 165484))) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 165522) 165524)) inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 165532) 165524) inline$$RegisteredCurrencies_initialize_$def$0$anon9_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon22_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 165516) 165532) inline$$RegisteredCurrencies_initialize_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 165516) 165522) inline$$RegisteredCurrencies_initialize_$def$0$anon23_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory)) (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 165504) 165484))) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 165502) 165504)) inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon25_Then_correct  (=> (= (ControlFlow 0 165512) 165504) inline$$RegisteredCurrencies_initialize_$def$0$anon13_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 165496) 165512) inline$$RegisteredCurrencies_initialize_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 165496) 165502) inline$$RegisteredCurrencies_initialize_$def$0$anon25_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct  (=> (and (and (= $DiemConfig_DiemConfig_$memory@1 $DiemConfig_DiemConfig_$memory@0) (= $DiemConfig_ModifyConfigCapability_$memory@1 $DiemConfig_ModifyConfigCapability_$memory@0)) (and (= $abort_code@6 $abort_code@5) (= (ControlFlow 0 165480) 165484))) inline$$RegisteredCurrencies_initialize_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 165478) 165480)) inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon27_Then_correct  (=> (= (ControlFlow 0 165492) 165480) inline$$RegisteredCurrencies_initialize_$def$0$anon17_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon26_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 165472) 165492) inline$$RegisteredCurrencies_initialize_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 165472) 165478) inline$$RegisteredCurrencies_initialize_$def$0$anon27_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon26_Else_correct  (=> (not $abort_flag@4) (=> (and (and (= $DiemConfig_DiemConfig_$memory@2 $DiemConfig_DiemConfig_$memory@0) (= $abort_flag@5 $abort_flag@4)) (and (= $abort_code@7 $abort_code@5) (= $DiemConfig_ModifyConfigCapability_$memory@2 $DiemConfig_ModifyConfigCapability_$memory@0))) (and (=> (= (ControlFlow 0 165468) 165582) inline$$Diem_initialize_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 165468) 165578) inline$$Diem_initialize_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct  (=> (= call0formal@$tv0@0 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (= call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($ConstMemoryDomain true)) (= call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 165462) (- 0 346570)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_DiemConfig_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 165462) (- 0 346590)) (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call4formal@$DiemConfig_ModifyConfigCapability_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) $abort_flag@4) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account)))) $abort_flag@4)) (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@4))) (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@4) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@4)) (and (=> $abort_flag@4 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@4 (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@5 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@5 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@5 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@5 (|i#$Integer| ($Integer 2))))))))) (and (and (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| dr_account))))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1)))) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (= (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 165462) 165472) inline$$RegisteredCurrencies_initialize_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 165462) 165468) inline$$RegisteredCurrencies_initialize_$def$0$anon26_Else_correct)))))))))))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 165448) 165462)) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 165454) 165462) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 165442) 165454) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 165442) 165448) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon4_Else_correct)))))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 165434) 165462)) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else$1_correct)))
(let ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon0_correct  (=> (and (and (and ((_ is $Vector) inline$$Vector_empty$0$v@1) (let ((va@@8 (|v#$Vector| inline$$Vector_empty$0$v@1)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 0) (< inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0)) (let ((va@@9 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall ((inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 0) (< inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Vector_empty$0$v@1)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$$0))
))) (= inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Vector_empty$0$v@1) 1)))) (and (=> (= (ControlFlow 0 165426) 165442) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 165426) 165434) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon3_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 165460) 165426)) inline$$RegisteredCurrencies_RegisteredCurrencies_pack$0$anon0_correct)))
(let ((inline$$Vector_empty$0$anon0_correct  (=> (= inline$$Vector_empty$0$v@1 ($Vector $EmptyValueArray)) (and (=> (= (ControlFlow 0 165123) 165496) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 165123) 165460) inline$$RegisteredCurrencies_initialize_$def$0$anon24_Else_correct)))))
(let ((inline$$Vector_empty$0$Entry_correct  (=> (and (= inline$$Vector_empty$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 165119) 165123)) inline$$Vector_empty$0$anon0_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon22_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 165129) 165119)) inline$$Vector_empty$0$Entry_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon20_Else_correct  (=> (not $abort_flag@2) (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3)) (and (=> $abort_flag@3 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))))) (=> $abort_flag@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 165088) 165516) inline$$RegisteredCurrencies_initialize_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 165088) 165129) inline$$RegisteredCurrencies_initialize_$def$0$anon22_Else_correct)))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2) (=> (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@3 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 165082) 165536) inline$$RegisteredCurrencies_initialize_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 165082) 165088) inline$$RegisteredCurrencies_initialize_$def$0$anon20_Else_correct))))))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 165046) 165082)) inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 165560) 165082) inline$$RegisteredCurrencies_initialize_$def$0$anon2$1_correct)))
(let ((inline$$RegisteredCurrencies_initialize_$def$0$anon0_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 165040) 165560) inline$$RegisteredCurrencies_initialize_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 165040) 165046) inline$$RegisteredCurrencies_initialize_$def$0$anon19_Else_correct)))))
(let ((inline$$RegisteredCurrencies_initialize_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 165564) 165040)) inline$$RegisteredCurrencies_initialize_$def$0$anon0_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 165570) 165564)) inline$$RegisteredCurrencies_initialize_$direct_inter$0$anon0_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon14_Else_correct  (=> (and (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 164677) 165590) inline$$Diem_initialize_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 164677) 165570) inline$$Diem_initialize_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_initialize_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 164671) 165610) inline$$Diem_initialize_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 164671) 164677) inline$$Diem_initialize_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$Diem_initialize_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 164635) 164671)) inline$$Diem_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 165634) 164671) inline$$Diem_initialize_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 164629) 165634) inline$$Diem_initialize_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 164629) 164635) inline$$Diem_initialize_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct  (=> (and (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (and (forall (($inv_addr@@1 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@2))
)))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 165638) 164629)))) inline$$Diem_initialize_$def_verify$0$anon0_correct))))
(let ((anon0_correct  (=> (and ((_ is $Address) dr_account) (= (ControlFlow 0 163953) 165638)) anon0$1_correct)))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 342889) 163953) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $tv0@@7 () T@$TypeValue)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun inline$$Diem_currency_code_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_currency_code_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 348417) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 166618) (- 0 351179)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0) (and (=> (= (ControlFlow 0 166618) (- 0 351196)) (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351213)) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@0 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 166618) (- 0 351241)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_currency_code_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code)))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_currency_code_$def_verify$0$$ret0@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))) (and (=> (= (ControlFlow 0 166618) (- 0 351263)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351312)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@2))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@2)))))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@3))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@3))))))))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351392)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@4))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@5)))))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351460)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351509)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@6))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@6)))))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@7))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@7))))))))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351589)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@8))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@9)))))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351657)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351706)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351755)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@10))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@10)))))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@11))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@11))))))))))))))) (and (=> (= (ControlFlow 0 166618) (- 0 351835)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@12))))))))))))) (=> (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@13)))))))))))) (=> (= (ControlFlow 0 166618) (- 0 351903)) (=> (not $abort_flag@2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_currency_code_$def_verify$0$Abort_correct  (=> (= inline$$Diem_currency_code_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@4@@0 $abort_code@3@@0) (= inline$$Diem_currency_code_$def_verify$0$$ret0@2 inline$$Diem_currency_code_$def_verify$0$$ret0@1)) (and (= $abort_flag@2@@0 true) (= (ControlFlow 0 166578) 166618))) anon0$2_correct@@0))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon3_correct  (=> (and (= $abort_code@3@@0 $abort_code@1@@0) (= (ControlFlow 0 166602) 166578)) inline$$Diem_currency_code_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 166600) 166602)) inline$$Diem_currency_code_$def_verify$0$anon3_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 166610) 166602) inline$$Diem_currency_code_$def_verify$0$anon3_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 166594) 166610) inline$$Diem_currency_code_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 166594) 166600) inline$$Diem_currency_code_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon9_correct  (=> (and (= $abort_code@3@@0 $abort_code@2@@0) (= (ControlFlow 0 166572) 166578)) inline$$Diem_currency_code_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 166570) 166572)) inline$$Diem_currency_code_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 166586) 166572) inline$$Diem_currency_code_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 166564) 166586) inline$$Diem_currency_code_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 166564) 166570) inline$$Diem_currency_code_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@0 (=> (and (= $abort_code@3@@0 $abort_code@1@@0) (= (ControlFlow 0 166590) 166578)) inline$$Diem_currency_code_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon12_correct  (=> (and (and (= $abort_code@4@@0 $abort_code@2@@0) (= inline$$Diem_currency_code_$def_verify$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1)) (and (= $abort_flag@2@@0 $abort_flag@1@@0) (= (ControlFlow 0 166552) 166618))) anon0$2_correct@@0)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 166550) 166552)) inline$$Diem_currency_code_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 166560) 166552) inline$$Diem_currency_code_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Diem_CurrencyInfo_currency_code)) (and (=> (= (ControlFlow 0 166534) 166560) inline$$Diem_currency_code_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 166534) 166550) inline$$Diem_currency_code_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 166540) 166534)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@1@@0 true) (=> (and (= $abort_code@2@@0 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 166480) 166564) inline$$Diem_currency_code_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 166480) 166540) inline$$Diem_currency_code_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 166478) 166480)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1) (=> (and (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1))) (= $abort_flag@1@@0 $abort_flag@0@@0)) (and (= $abort_code@2@@0 $abort_code@1@@0) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 166426) 166564) inline$$Diem_currency_code_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 166426) 166540) inline$$Diem_currency_code_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 166408) 166478) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 166408) 166426) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1)) (and (=> (= (ControlFlow 0 166402) (- 0 350985)) true) (=> (= (ControlFlow 0 166402) 166408) inline$$GetGlobal$0$anon0_correct)))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 166486) 166402)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 166269) 166590) inline$$Diem_currency_code_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 166269) 166486) inline$$Diem_currency_code_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 166279) 166590) inline$$Diem_currency_code_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 166279) 166486) inline$$Diem_currency_code_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@0) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 166263) 166279) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 166263) 166269) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_currency_code_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@0) (= (ControlFlow 0 166293) 166263)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_currency_code_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@14))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@14))))))))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@15 T@$Value) )  (=> ((_ is $Address) addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@15)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@16))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@16)))))))))))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@17)))))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@18))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@18)))))))))))))))) (and (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean (forall ((addr@@19 T@$Value) )  (=> ((_ is $Address) addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| addr@@19)))))))))))) (=> (not $abort_flag@0@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 166158) 166594) inline$$Diem_currency_code_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 166158) 166293) inline$$Diem_currency_code_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@3 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_currency_code))) $$0))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@0))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@1))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@3))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 166616) 166158)) inline$$Diem_currency_code_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 348417) 166616) anon0$1_correct@@0)))
anon0_correct@@0))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@8 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun coin () T@$Value)
(declare-fun $Diem_Diem_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 351954) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 167039) (- 0 352829)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 352878)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@20))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@20)))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@21 T@$Value) )  (=> ((_ is $Address) addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@21))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@21))))))))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 352958)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@22 T@$Value) )  (=> ((_ is $Address) addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@22))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@23 T@$Value) )  (=> ((_ is $Address) addr@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@23)))))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353026)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353075)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@24 T@$Value) )  (=> ((_ is $Address) addr@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@24))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@24)))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@25 T@$Value) )  (=> ((_ is $Address) addr@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@25))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@25))))))))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353155)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@26 T@$Value) )  (=> ((_ is $Address) addr@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@26))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@27 T@$Value) )  (=> ((_ is $Address) addr@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@27)))))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353223)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353272)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353321)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@28 T@$Value) )  (=> ((_ is $Address) addr@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@28))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@28)))))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@29 T@$Value) )  (=> ((_ is $Address) addr@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@29))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@29))))))))))))))) (and (=> (= (ControlFlow 0 167039) (- 0 353401)) (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@30 T@$Value) )  (=> ((_ is $Address) addr@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@30))))))))))))) (=> (=> (not false) (|b#$Boolean| ($Boolean (forall ((addr@@31 T@$Value) )  (=> ((_ is $Address) addr@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@31)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| addr@@31)))))))))))) (=> (= (ControlFlow 0 167039) (- 0 353469)) (=> (not false) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_value_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 167013) 167039)) anon0$2_correct@@1)))
(let ((inline$$Diem_value_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 167023) 167039) anon0$2_correct@@1)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 166997) 167023) inline$$Diem_value_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 166997) 167013) inline$$Diem_value_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def_verify$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 166921) 166997)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Diem_value_$def_verify$0$anon5_Then_correct  (=> (= (ControlFlow 0 167031) 166997) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Diem_value_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 166915) 167031) inline$$Diem_value_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 166915) 166921) inline$$Diem_value_$def_verify$0$anon5_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@4 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4)) (let ((va@@27 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@4))
)) (= (ControlFlow 0 167037) 166915)) inline$$Diem_value_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) coin) (let ((va@@28 (|v#$Vector| coin)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 166749) 167037)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 351954) 166749) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@0)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $tv0@@9 () T@$TypeValue)
(declare-fun inline$$Diem_approx_xdx_for_coin_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun coin@@0 () T@$Value)
(declare-fun $FixedPoint32_FixedPoint32_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 353520) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 167926) (- 0 356400)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356449)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@32 T@$Value) )  (=> ((_ is $Address) addr@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@32))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@32)))))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@33 T@$Value) )  (=> ((_ is $Address) addr@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@33))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@33))))))))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356529)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@34 T@$Value) )  (=> ((_ is $Address) addr@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@34))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@35 T@$Value) )  (=> ((_ is $Address) addr@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@35)))))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356597)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356646)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@36 T@$Value) )  (=> ((_ is $Address) addr@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@36))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@36)))))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@37 T@$Value) )  (=> ((_ is $Address) addr@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@37))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@37))))))))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356726)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@38 T@$Value) )  (=> ((_ is $Address) addr@@38) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@38))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@39 T@$Value) )  (=> ((_ is $Address) addr@@39) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@39)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@39)))))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356794)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356843)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356892)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@40 T@$Value) )  (=> ((_ is $Address) addr@@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@40))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@40)))))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@41 T@$Value) )  (=> ((_ is $Address) addr@@41) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@41))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@41))))))))))))))) (and (=> (= (ControlFlow 0 167926) (- 0 356972)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@42 T@$Value) )  (=> ((_ is $Address) addr@@42) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@42)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@42))))))))))))) (=> (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean (forall ((addr@@43 T@$Value) )  (=> ((_ is $Address) addr@@43) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@43)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@43)))))))))))) (=> (= (ControlFlow 0 167926) (- 0 357040)) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$Abort_correct  (=> (= inline$$Diem_approx_xdx_for_coin_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@1 true) (= (ControlFlow 0 167898) 167926)) anon0$2_correct@@2))))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 167890) 167898)) inline$$Diem_approx_xdx_for_coin_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 167906) 167898) inline$$Diem_approx_xdx_for_coin_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 167884) 167906) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 167884) 167890) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon10_correct  (=> (and (= $abort_flag@1@@1 $abort_flag@0@@1) (= (ControlFlow 0 167872) 167926)) anon0$2_correct@@2)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 167870) 167872)) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 167880) 167872) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@0@@1) (and (=> (= (ControlFlow 0 167864) 167880) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 167864) 167870) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Else_correct  (=> (not false) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@1) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@0@@1)) (and (=> $abort_flag@0@@1 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (=> $abort_flag@0@@1 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@1@@1 (|i#$Integer| ($Integer 8)))))))) (=> (and (and (and (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1))))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@44 T@$Value) )  (=> ((_ is $Address) addr@@44) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@44))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@44))))))))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@45 T@$Value) )  (=> ((_ is $Address) addr@@45) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@45)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@45)))))))))))))) (and (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@46 T@$Value) )  (=> ((_ is $Address) addr@@46) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@46))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@46)))))))))))))))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@47 T@$Value) )  (=> ((_ is $Address) addr@@47) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@47)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@47)))))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))))) (and (and (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@48 T@$Value) )  (=> ((_ is $Address) addr@@48) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@48))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@48)))))))))))))))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean (forall ((addr@@49 T@$Value) )  (=> ((_ is $Address) addr@@49) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@49)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| addr@@49)))))))))))) (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))) (and (and ((_ is $Integer) call4formal@$ret0@0) (>= (|i#$Integer| call4formal@$ret0@0) 0)) (<= (|i#$Integer| call4formal@$ret0@0) $MAX_U64)))) (and (=> (= (ControlFlow 0 167856) 167884) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 167856) 167864) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon13_Else_correct)))))))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Then_correct true))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 167816) 167910) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 167816) 167856) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 167826) 167910) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 167826) 167856) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon12_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 167800) 167826) inline$$Diem_value_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 167800) 167816) inline$$Diem_value_$def$0$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 167724) 167800)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 167834) 167800) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 167718) 167834) inline$$Diem_value_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 167718) 167724) inline$$Diem_value_$def$0$anon5_Else_correct)))))
(let ((inline$$Diem_value_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) coin@@0) (let ((va@@29 (|v#$Vector| coin@@0)))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 167840) 167718)) inline$$Diem_value_$def$0$anon0_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 167522) 167840)) inline$$Diem_value_$direct_intra$0$anon0_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 167918) 167840) inline$$Diem_value_$direct_intra$0$anon0_correct)))
(let ((inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 167516) 167918) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 167516) 167522) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@30 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (and (forall (($inv_addr@@6 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6)) (let ((va@@31 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7)) (let ((va@@32 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code)) (let ((va@@34 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_currency_code))) $$0@@5))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events)) (let ((va@@35 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@6))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@38 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@7))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@8))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@41 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@42 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@9))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@43 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@44 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@7))
))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((addr3@@0 T@$Value) )  (=> ((_ is $Address) addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 167924) 167516))) inline$$Diem_approx_xdx_for_coin_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (and (and (and (and (and ((_ is $Vector) coin@@0) (let ((va@@45 (|v#$Vector| coin@@0)))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 167135) 167924)) anon0$1_correct@@2)))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 353520) 167135) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@1)))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@10 () T@$TypeValue)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun from_value () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun call4formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_xdx_exchange_rate_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 357092) (let ((anon0$2_correct@@3  (and (=> (= (ControlFlow 0 169265) (- 0 359072)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 169265) (- 0 359089)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@4@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@4@@0) (and (=> (= (ControlFlow 0 169265) (- 0 359116)) (=> $abort_flag@4@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@4@@0 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359159)) (=> $abort_flag@4@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@4@@0 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 8)))))) (and (=> (= (ControlFlow 0 169265) (- 0 359224)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@2 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359244)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359293)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@50 T@$Value) )  (=> ((_ is $Address) addr@@50) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@50))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@50)))))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@51 T@$Value) )  (=> ((_ is $Address) addr@@51) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@51))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@51))))))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359373)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@52 T@$Value) )  (=> ((_ is $Address) addr@@52) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@52)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@52))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@53 T@$Value) )  (=> ((_ is $Address) addr@@53) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@53)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@53)))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359441)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359490)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@54 T@$Value) )  (=> ((_ is $Address) addr@@54) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@54))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@54)))))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@55 T@$Value) )  (=> ((_ is $Address) addr@@55) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@55))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@55))))))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359570)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@56 T@$Value) )  (=> ((_ is $Address) addr@@56) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@56)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@56))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@57 T@$Value) )  (=> ((_ is $Address) addr@@57) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@57)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@57)))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359638)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359687)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359736)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@58 T@$Value) )  (=> ((_ is $Address) addr@@58) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@58))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@58)))))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@59 T@$Value) )  (=> ((_ is $Address) addr@@59) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@59))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@59))))))))))))))) (and (=> (= (ControlFlow 0 169265) (- 0 359816)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@60 T@$Value) )  (=> ((_ is $Address) addr@@60) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@60)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@60))))))))))))) (=> (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean (forall ((addr@@61 T@$Value) )  (=> ((_ is $Address) addr@@61) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@61)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| addr@@61)))))))))))) (=> (= (ControlFlow 0 169265) (- 0 359884)) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$Abort_correct  (=> (= inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@2 inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@1) (= $abort_flag@4@@0 true)) (and (= $abort_code@7@@0 $abort_code@6@@0) (= (ControlFlow 0 169237) 169265))) anon0$2_correct@@3))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon7_correct  (=> (and (= $abort_code@6@@0 $abort_code@5@@0) (= (ControlFlow 0 169231) 169237)) inline$$Diem_approx_xdx_for_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 169229) 169231)) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 169245) 169231) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon13_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 169223) 169245) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 169223) 169229) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Then_correct  (=> $abort_flag@2@@1 (=> (and (= $abort_code@6@@0 $abort_code@4@@1) (= (ControlFlow 0 169249) 169237)) inline$$Diem_approx_xdx_for_value_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon10_correct  (=> (and (and (= inline$$Diem_approx_xdx_for_value_$def_verify$0$$ret0@2 call4formal@$ret0@0@@0) (= $abort_flag@4@@0 $abort_flag@3@@0)) (and (= $abort_code@7@@0 $abort_code@5@@0) (= (ControlFlow 0 169211) 169265))) anon0$2_correct@@3)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 169209) 169211)) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 169219) 169211) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon13_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 169203) 169219) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 169203) 169209) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@2@@1) (=> (and (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@3@@0) (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@3@@0 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5@@0 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call4formal@$ret0@0@@0 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) from_value (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2)) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| from_value) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1))))))))))))) (and (and ((_ is $Integer) call4formal@$ret0@0@@0) (>= (|i#$Integer| call4formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call4formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 169195) 169223) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 169195) 169203) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_xdx_exchange_rate_$def$0$$ret0@1 $Error) (= $abort_code@4@@1 $abort_code@3@@1)) (and (= inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2 inline$$Diem_xdx_exchange_rate_$def$0$$ret0@1) (= $abort_flag@2@@1 true))) (and (=> (= (ControlFlow 0 169141) 169249) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 169141) 169195) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon3_correct  (=> (and (= $abort_code@3@@1 $abort_code@1@@2) (= (ControlFlow 0 169165) 169141)) inline$$Diem_xdx_exchange_rate_$def$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 169163) 169165)) inline$$Diem_xdx_exchange_rate_$def$0$anon3_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon14_Then_correct  (=> (= (ControlFlow 0 169173) 169165) inline$$Diem_xdx_exchange_rate_$def$0$anon3_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon13_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 169157) 169173) inline$$Diem_xdx_exchange_rate_$def$0$anon14_Then_correct) (=> (= (ControlFlow 0 169157) 169163) inline$$Diem_xdx_exchange_rate_$def$0$anon14_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon9_correct  (=> (and (= $abort_code@3@@1 $abort_code@2@@1) (= (ControlFlow 0 169135) 169141)) inline$$Diem_xdx_exchange_rate_$def$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 169133) 169135)) inline$$Diem_xdx_exchange_rate_$def$0$anon9_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 169149) 169135) inline$$Diem_xdx_exchange_rate_$def$0$anon9_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon16_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 169127) 169149) inline$$Diem_xdx_exchange_rate_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 169127) 169133) inline$$Diem_xdx_exchange_rate_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon15_Then_correct  (=> $abort_flag@0@@2 (=> (and (= $abort_code@3@@1 $abort_code@1@@2) (= (ControlFlow 0 169153) 169141)) inline$$Diem_xdx_exchange_rate_$def$0$Abort_correct))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon12_correct  (=> (= $abort_code@4@@1 $abort_code@2@@1) (=> (and (= inline$$Diem_xdx_exchange_rate_$def$0$$ret0@2 inline$$GetFieldFromValue$0$dst@1@@2) (= $abort_flag@2@@1 $abort_flag@1@@2)) (and (=> (= (ControlFlow 0 169115) 169249) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 169115) 169195) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 169113) 169115)) inline$$Diem_xdx_exchange_rate_$def$0$anon12_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 169123) 169115) inline$$Diem_xdx_exchange_rate_$def$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@2  (=> (= inline$$GetFieldFromValue$0$dst@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@0)) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (and (=> (= (ControlFlow 0 169097) 169123) inline$$Diem_xdx_exchange_rate_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 169097) 169113) inline$$Diem_xdx_exchange_rate_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 169103) 169097)) inline$$GetFieldFromValue$0$anon0_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@1@@2 true) (=> (and (= $abort_code@2@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 169043) 169127) inline$$Diem_xdx_exchange_rate_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 169043) 169103) inline$$Diem_xdx_exchange_rate_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 169041) 169043)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@0 inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0))) (= $abort_flag@1@@2 $abort_flag@0@@2)) (and (= $abort_code@2@@1 $abort_code@1@@2) (= inline$$GetGlobal$0$dst@2@@0 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 168989) 169127) inline$$Diem_xdx_exchange_rate_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 168989) 169103) inline$$Diem_xdx_exchange_rate_$def$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0)) (and (=> (= (ControlFlow 0 168971) 169041) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 168971) 168989) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (=> (= inline$$GetGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1)) (and (=> (= (ControlFlow 0 168965) (- 0 358683)) true) (=> (= (ControlFlow 0 168965) 168971) inline$$GetGlobal$0$anon0_correct@@0)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 169049) 168965)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 168832) 169153) inline$$Diem_xdx_exchange_rate_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 168832) 169049) inline$$Diem_xdx_exchange_rate_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 168842) 169153) inline$$Diem_xdx_exchange_rate_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 168842) 169049) inline$$Diem_xdx_exchange_rate_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@0@@2) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 168826) 168842) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 168826) 168832) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@2) (= (ControlFlow 0 168856) 168826)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$Diem_xdx_exchange_rate_$def$0$anon0_correct  (=> (and (and (not false) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@2)) (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 168721) 169157) inline$$Diem_xdx_exchange_rate_$def$0$anon13_Then_correct) (=> (= (ControlFlow 0 168721) 168856) inline$$Diem_xdx_exchange_rate_$def$0$anon13_Else_correct)))))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon11_Else_correct  (=> (and (not true) (= (ControlFlow 0 168423) 168721)) inline$$Diem_xdx_exchange_rate_$def$0$anon0_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon11_Then_correct  (=> (= (ControlFlow 0 169257) 168721) inline$$Diem_xdx_exchange_rate_$def$0$anon0_correct)))
(let ((inline$$Diem_approx_xdx_for_value_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 168417) 169257) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 168417) 168423) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@3  (=> (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@46 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9)) (let ((va@@47 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@48 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code)) (let ((va@@49 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_currency_code))) $$0@@11))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events)) (let ((va@@50 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@51 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@12))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events)) (let ((va@@52 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@53 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@13))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@54 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@55 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@14))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@56 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@57 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@15))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@9))
))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean (forall ((addr3@@1 T@$Value) )  (=> ((_ is $Address) addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 169263) 168417))) inline$$Diem_approx_xdx_for_value_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@3  (=> (and (and (and ((_ is $Integer) from_value) (>= (|i#$Integer| from_value) 0)) (<= (|i#$Integer| from_value) $MAX_U64)) (= (ControlFlow 0 168087) 169263)) anon0$1_correct@@3)))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (= (ControlFlow 0 357092) 168087) anon0_correct@@3)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $tv0@@11 () T@$TypeValue)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun inline$$Diem_is_SCS_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun inline$$Diem_assert_is_SCS_currency_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Diem_is_SCS_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun |inline$$Diem_is_SCS_currency_$def$0$tmp#$0@1| () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_is_SCS_currency_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@1@@3 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 359933) (let ((anon0$2_correct@@4  (and (=> (= (ControlFlow 0 171144) (- 0 363128)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363177)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@62 T@$Value) )  (=> ((_ is $Address) addr@@62) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@62))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@62)))))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@63 T@$Value) )  (=> ((_ is $Address) addr@@63) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@63))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@63))))))))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363257)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@64 T@$Value) )  (=> ((_ is $Address) addr@@64) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@64)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@64))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@65 T@$Value) )  (=> ((_ is $Address) addr@@65) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@65)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@65)))))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363325)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363374)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@66 T@$Value) )  (=> ((_ is $Address) addr@@66) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@66))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@66)))))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@67 T@$Value) )  (=> ((_ is $Address) addr@@67) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@67))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@67))))))))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363454)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@68 T@$Value) )  (=> ((_ is $Address) addr@@68) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@68)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@68))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@69 T@$Value) )  (=> ((_ is $Address) addr@@69) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@69)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@69)))))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363522)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363571)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363620)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@70 T@$Value) )  (=> ((_ is $Address) addr@@70) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@70))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@70)))))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@71 T@$Value) )  (=> ((_ is $Address) addr@@71) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@71))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@71))))))))))))))) (and (=> (= (ControlFlow 0 171144) (- 0 363700)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@72 T@$Value) )  (=> ((_ is $Address) addr@@72) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@72)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@72))))))))))))) (=> (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean (forall ((addr@@73 T@$Value) )  (=> ((_ is $Address) addr@@73) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@73)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@73)))))))))))) (=> (= (ControlFlow 0 171144) (- 0 363768)) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct  (=> (and (= $abort_flag@6@@0 true) (= (ControlFlow 0 171080) 171144)) anon0$2_correct@@4)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 171128) 171080)) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 171138) 171080) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@3 (and (=> (= (ControlFlow 0 171122) 171138) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 171122) 171128) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 171104) 171080)) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 171114) 171080) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon18_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 171098) 171114) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 171098) 171104) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 171074) 171080)) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 171088) 171080) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon20_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_SCS_currency_$def$0$$ret0@2)) (= $abort_code@3@@2 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 171068) 171088) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 171068) 171074) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Then_correct  (=> (and $abort_flag@4@@1 (= (ControlFlow 0 171118) 171080)) inline$$Diem_assert_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon20_Then_correct  (=> (|b#$Boolean| inline$$Diem_is_SCS_currency_$def$0$$ret0@2) (=> (and (= $abort_flag@6@@0 $abort_flag@5@@0) (= (ControlFlow 0 171094) 171144)) anon0$2_correct@@4))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon18_Else_correct  (=> (not $abort_flag@5@@0) (and (=> (= (ControlFlow 0 171056) 171094) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 171056) 171068) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@4@@1) (=> (and (and (and (= inline$$Diem_assert_is_SCS_currency_$def_verify$0$$t3@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@0)) (and (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 171050) 171098) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 171050) 171056) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon18_Else_correct))))))
(let ((inline$$Diem_is_SCS_currency_$def$0$Abort_correct  (=> (= inline$$Diem_is_SCS_currency_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@4@@1 true) (= inline$$Diem_is_SCS_currency_$def$0$$ret0@2 inline$$Diem_is_SCS_currency_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 171008) 171118) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 171008) 171050) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 171000) 171008)) inline$$Diem_is_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 171016) 171008) inline$$Diem_is_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon20_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 170994) 171016) inline$$Diem_is_SCS_currency_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 170994) 171000) inline$$Diem_is_SCS_currency_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon19_Then_correct  (=> (and $abort_flag@1@@3 (= (ControlFlow 0 171020) 171008)) inline$$Diem_is_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon17_Then_correct  (=> (and $abort_flag@1@@3 (= (ControlFlow 0 171024) 171008)) inline$$Diem_is_SCS_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon16_correct  (=> (and (= $abort_flag@4@@1 $abort_flag@3@@1) (= inline$$Diem_is_SCS_currency_$def$0$$ret0@2 |inline$$Diem_is_SCS_currency_$def$0$tmp#$0@1|)) (and (=> (= (ControlFlow 0 170524) 171118) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 170524) 171050) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 170522) 170524)) inline$$Diem_is_SCS_currency_$def$0$anon16_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 170532) 170524) inline$$Diem_is_SCS_currency_$def$0$anon16_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon12_correct  (=> (and (= |inline$$Diem_is_SCS_currency_$def$0$tmp#$0@1| inline$$Not$0$dst@1) (= $abort_flag@3@@1 $abort_flag@2@@2)) (and (=> (= (ControlFlow 0 170982) 170532) inline$$Diem_is_SCS_currency_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 170982) 170522) inline$$Diem_is_SCS_currency_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 170980) 170982)) inline$$Diem_is_SCS_currency_$def$0$anon12_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 170990) 170982) inline$$Diem_is_SCS_currency_$def$0$anon12_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$GetFieldFromValue$0$dst@1@@3)))) (and (=> (= (ControlFlow 0 170966) 170990) inline$$Diem_is_SCS_currency_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 170966) 170980) inline$$Diem_is_SCS_currency_$def$0$anon22_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 170956) (- 0 362886)) true) (=> (= (ControlFlow 0 170956) 170966) inline$$Not$0$anon0_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@3  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@1)) $Diem_CurrencyInfo_is_synthetic)) (= (ControlFlow 0 170916) 170956)) inline$$Not$0$Entry_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@2@@2) (= (ControlFlow 0 170922) 170916)) inline$$GetFieldFromValue$0$anon0_correct@@3)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@2@@2 true) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 170862) 170994) inline$$Diem_is_SCS_currency_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 170862) 170922) inline$$Diem_is_SCS_currency_$def$0$anon20_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@1 inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 170860) 170862)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@1 inline$$GetGlobal$0$a@1@@1) (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)))) (and (= $abort_flag@2@@2 $abort_flag@1@@3) (= inline$$GetGlobal$0$dst@2@@1 inline$$GetGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 170808) 170994) inline$$Diem_is_SCS_currency_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 170808) 170922) inline$$Diem_is_SCS_currency_$def$0$anon20_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 170790) 170860) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 170790) 170808) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (=> (= inline$$GetGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1)) (and (=> (= (ControlFlow 0 170784) (- 0 362786)) true) (=> (= (ControlFlow 0 170784) 170790) inline$$GetGlobal$0$anon0_correct@@1)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon19_Else_correct  (=> (and (not $abort_flag@1@@3) (= (ControlFlow 0 170868) 170784)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 170651) 171020) inline$$Diem_is_SCS_currency_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 170651) 170868) inline$$Diem_is_SCS_currency_$def$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 170661) 171020) inline$$Diem_is_SCS_currency_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 170661) 170868) inline$$Diem_is_SCS_currency_$def$0$anon19_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@1@@3) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 170645) 170661) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 170645) 170651) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon18_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2) (= (ControlFlow 0 170675) 170645)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon14_correct  (=> (and (= |inline$$Diem_is_SCS_currency_$def$0$tmp#$0@1| inline$$Diem_is_SCS_currency_$def$0$$t5@1) (= $abort_flag@3@@1 $abort_flag@1@@3)) (and (=> (= (ControlFlow 0 170512) 170532) inline$$Diem_is_SCS_currency_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 170512) 170522) inline$$Diem_is_SCS_currency_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 170510) 170512)) inline$$Diem_is_SCS_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon23_Then_correct  (=> (= (ControlFlow 0 170540) 170512) inline$$Diem_is_SCS_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon18_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2)) (= inline$$Diem_is_SCS_currency_$def$0$$t5@1 ($Boolean false))) (and (=> (= (ControlFlow 0 170502) 170540) inline$$Diem_is_SCS_currency_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 170502) 170510) inline$$Diem_is_SCS_currency_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon17_Else_correct  (=> (not $abort_flag@1@@3) (and (=> (= (ControlFlow 0 170458) 170675) inline$$Diem_is_SCS_currency_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 170458) 170502) inline$$Diem_is_SCS_currency_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon4_correct  (=> (and (= $abort_flag@1@@3 $abort_flag@0@@3) (= inline$$Diem_is_currency_$def$0$$ret0@2 inline$$Diem_is_currency_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 170420) 171024) inline$$Diem_is_SCS_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 170420) 170458) inline$$Diem_is_SCS_currency_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 170418) 170420)) inline$$Diem_is_currency_$def$0$anon4_correct)))
(let ((inline$$Diem_is_currency_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 170428) 170420) inline$$Diem_is_currency_$def$0$anon4_correct)))
(let ((inline$$Diem_is_currency_$def$0$anon5_Else_correct  (=> (and (not $abort_flag@0@@3) (= inline$$Diem_is_currency_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@1))))) (and (=> (= (ControlFlow 0 170412) 170428) inline$$Diem_is_currency_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 170412) 170418) inline$$Diem_is_currency_$def$0$anon6_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon5_Then_correct  (=> (and (and $abort_flag@0@@3 (= inline$$Diem_is_currency_$def$0$$ret0@1 $Error)) (and (= $abort_flag@1@@3 true) (= inline$$Diem_is_currency_$def$0$$ret0@2 inline$$Diem_is_currency_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 170436) 171024) inline$$Diem_is_SCS_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 170436) 170458) inline$$Diem_is_SCS_currency_$def$0$anon17_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 170358) 170436) inline$$Diem_is_currency_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 170358) 170412) inline$$Diem_is_currency_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 170368) 170436) inline$$Diem_is_currency_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 170368) 170412) inline$$Diem_is_currency_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@0@@3) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 170352) 170368) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 170352) 170358) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$Diem_is_currency_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 170382) 170352)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@1)))
(let ((inline$$Diem_is_SCS_currency_$def$0$anon0_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 170450) 170382)) inline$$Diem_is_currency_$def$0$anon0_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@3) (= (ControlFlow 0 171038) 170450)) inline$$Diem_is_SCS_currency_$def$0$anon0_correct)))
(let ((inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@3) (=> $abort_flag@0@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@3 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@74 T@$Value) )  (=> ((_ is $Address) addr@@74) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@74))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@74))))))))))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@75 T@$Value) )  (=> ((_ is $Address) addr@@75) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@75)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@75)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@76 T@$Value) )  (=> ((_ is $Address) addr@@76) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@76))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@76)))))))))))))))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@77 T@$Value) )  (=> ((_ is $Address) addr@@77) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@77)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@77)))))))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@78 T@$Value) )  (=> ((_ is $Address) addr@@78) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@78))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@78)))))))))))))))) (and (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean (forall ((addr@@79 T@$Value) )  (=> ((_ is $Address) addr@@79) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@79)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| addr@@79)))))))))))) (=> (not $abort_flag@0@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 169770) 171122) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 169770) 171038) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon15_Else_correct))))))))
(let ((anon0$1_correct@@4  (=> (forall (($inv_addr@@10 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10)) (let ((va@@60 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_currency_code))) $$0@@17))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@18))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
))))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@19))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
))))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@20))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@69 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@70 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@21))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@72 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@22))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@10))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean (forall ((addr3@@2 T@$Value) )  (=> ((_ is $Address) addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 171142) 169770)) inline$$Diem_assert_is_SCS_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@4  (=> (= (ControlFlow 0 359933) 171142) anon0$1_correct@@4)))
anon0_correct@@4)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@12 () T@$TypeValue)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_code@1@@4 () Int)
(declare-fun $abort_flag@1@@4 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun inline$$Diem_is_currency_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun $abort_flag@0@@4 () Bool)
(declare-fun $abort_code@0 () Int)
(declare-fun inline$$Diem_assert_is_currency_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$t1@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 363817) (let ((anon0$2_correct@@5  (and (=> (= (ControlFlow 0 172089) (- 0 365141)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@3) (and (=> (= (ControlFlow 0 172089) (- 0 365158)) (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (=> $abort_flag@2@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365175)) (=> $abort_flag@2@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@2 (|i#$Integer| ($Integer 5)))))) (=> (=> $abort_flag@2@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@2 (|i#$Integer| ($Integer 5))))) (and (=> (= (ControlFlow 0 172089) (- 0 365203)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365252)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@80 T@$Value) )  (=> ((_ is $Address) addr@@80) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@80))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@80)))))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@81 T@$Value) )  (=> ((_ is $Address) addr@@81) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@81))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@81))))))))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365332)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@82 T@$Value) )  (=> ((_ is $Address) addr@@82) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@82)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@82))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@83 T@$Value) )  (=> ((_ is $Address) addr@@83) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@83)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@83)))))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365400)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365449)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@84 T@$Value) )  (=> ((_ is $Address) addr@@84) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@84))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@84)))))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@85 T@$Value) )  (=> ((_ is $Address) addr@@85) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@85))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@85))))))))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365529)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@86 T@$Value) )  (=> ((_ is $Address) addr@@86) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@86)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@86))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@87 T@$Value) )  (=> ((_ is $Address) addr@@87) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@87)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@87)))))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365597)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365646)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365695)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@88 T@$Value) )  (=> ((_ is $Address) addr@@88) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@88))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@88)))))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@89 T@$Value) )  (=> ((_ is $Address) addr@@89) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@89))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@89))))))))))))))) (and (=> (= (ControlFlow 0 172089) (- 0 365775)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@90 T@$Value) )  (=> ((_ is $Address) addr@@90) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@90)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@90))))))))))))) (=> (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean (forall ((addr@@91 T@$Value) )  (=> ((_ is $Address) addr@@91) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@91)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| addr@@91)))))))))))) (=> (= (ControlFlow 0 172089) (- 0 365843)) (=> (not $abort_flag@2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$Abort_correct  (=> (= $abort_code@4@@2 $abort_code@3@@3) (=> (and (= $abort_flag@2@@3 true) (= (ControlFlow 0 172045) 172089)) anon0$2_correct@@5))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon5_correct  (=> (and (= $abort_code@3@@3 $abort_code@1@@4) (= (ControlFlow 0 172071) 172045)) inline$$Diem_assert_is_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 172069) 172071)) inline$$Diem_assert_is_currency_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 172079) 172071) inline$$Diem_assert_is_currency_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon12_Then_correct  (=> $abort_flag@1@@4 (and (=> (= (ControlFlow 0 172063) 172079) inline$$Diem_assert_is_currency_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 172063) 172069) inline$$Diem_assert_is_currency_$def_verify$0$anon13_Else_correct)))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon10_correct  (=> (and (= $abort_code@3@@3 $abort_code@2@@2) (= (ControlFlow 0 172041) 172045)) inline$$Diem_assert_is_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 172039) 172041)) inline$$Diem_assert_is_currency_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 172053) 172041) inline$$Diem_assert_is_currency_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon14_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2@@0)) (= $abort_code@2@@2 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 172033) 172053) inline$$Diem_assert_is_currency_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 172033) 172039) inline$$Diem_assert_is_currency_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon11_Then_correct  (=> $abort_flag@0@@4 (=> (and (= $abort_code@3@@3 $abort_code@0) (= (ControlFlow 0 172083) 172045)) inline$$Diem_assert_is_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon14_Then_correct  (=> (and (and (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2@@0) (= $abort_code@4@@2 $abort_code@1@@4)) (and (= $abort_flag@2@@3 $abort_flag@1@@4) (= (ControlFlow 0 172059) 172089))) anon0$2_correct@@5)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon12_Else_correct  (=> (not $abort_flag@1@@4) (and (=> (= (ControlFlow 0 172021) 172059) inline$$Diem_assert_is_currency_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 172021) 172033) inline$$Diem_assert_is_currency_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon11_Else_correct  (=> (not $abort_flag@0@@4) (=> (and (and (and (= inline$$Diem_assert_is_currency_$def_verify$0$$t3@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@4)) (and (=> $abort_flag@1@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 172015) 172063) inline$$Diem_assert_is_currency_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 172015) 172021) inline$$Diem_assert_is_currency_$def_verify$0$anon12_Else_correct))))))
(let ((inline$$Diem_is_currency_$def$0$anon4_correct@@0  (=> (and (= $abort_flag@0@@4 false) (= inline$$Diem_is_currency_$def$0$$ret0@2@@0 inline$$Diem_is_currency_$def$0$$t1@1@@0)) (and (=> (= (ControlFlow 0 171973) 172083) inline$$Diem_assert_is_currency_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 171973) 172015) inline$$Diem_assert_is_currency_$def_verify$0$anon11_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon6_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 171971) 171973)) inline$$Diem_is_currency_$def$0$anon4_correct@@0)))
(let ((inline$$Diem_is_currency_$def$0$anon6_Then_correct@@0  (=> (= (ControlFlow 0 171981) 171973) inline$$Diem_is_currency_$def$0$anon4_correct@@0)))
(let ((inline$$Diem_is_currency_$def$0$anon5_Else_correct@@0  (=> (and (not false) (= inline$$Diem_is_currency_$def$0$$t1@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@2))))) (and (=> (= (ControlFlow 0 171965) 171981) inline$$Diem_is_currency_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 171965) 171971) inline$$Diem_is_currency_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$Diem_is_currency_$def$0$anon5_Then_correct@@0 true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 171911) 171989) inline$$Diem_is_currency_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 171911) 171965) inline$$Diem_is_currency_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 171921) 171989) inline$$Diem_is_currency_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 171921) 171965) inline$$Diem_is_currency_$def$0$anon5_Else_correct@@0))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@2  (=> (and (not false) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@2 ($Address 173345816))) (and (=> (= (ControlFlow 0 171905) 171921) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 171905) 171911) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@2)))))
(let ((inline$$Diem_is_currency_$def$0$anon0_correct@@0  (=> (and (not false) (= (ControlFlow 0 171935) 171905)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@2)))
(let ((inline$$Diem_assert_is_currency_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 172003) 171935)) inline$$Diem_is_currency_$def$0$anon0_correct@@0)))
(let ((anon0$1_correct@@5  (=> (forall (($inv_addr@@11 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11)) (let ((va@@73 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@74 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_currency_code))) $$0@@23))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@24))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
))))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@25))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@26))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@82 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
))))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@27))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@84 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
))))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@28))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@11))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean (forall ((addr3@@3 T@$Value) )  (=> ((_ is $Address) addr3@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| addr3@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 172087) 172003)) inline$$Diem_assert_is_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@5  (=> (= (ControlFlow 0 363817) 172087) anon0$1_correct@@5)))
anon0_correct@@5)))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun account () T@$Value)
(declare-fun $abort_flag@18 () Bool)
(declare-fun preburn_address () T@$Value)
(declare-fun $abort_code@27 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@6 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@2 () T@$Memory)
(declare-fun $abort_flag@17 () Bool)
(declare-fun $abort_code@25 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@0 () T@$Memory)
(declare-fun $abort_code@26 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@1 () T@$Memory)
(declare-fun $abort_code@1@@5 () Int)
(declare-fun $abort_flag@0@@5 () Bool)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@5 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun $abort_flag@2@@4 () Bool)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun $abort_code@23 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@24 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun $abort_code@21 () Int)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$8$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@22 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$9$p@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1 () Int)
(declare-fun inline$$BorrowField$9$p@2 () T@$Path)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1 () T@$Value)
(declare-fun $abort_code@20 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun $abort_code@16 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@3 () T@$Value)
(declare-fun call4formal@$ret0@0@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun $abort_code@10 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@4 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$GetGlobal$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_burn_with_capability_$def$0$$t6@1 () T@$Value)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Diem_burn_with_capability_$def$0$$t7@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@2 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Diem_burn_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@4 () Int)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$Diem_burn_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 365895) (let ((anon0$2_correct@@6  (and (=> (= (ControlFlow 0 185389) (- 0 376001)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376034)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address))))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address))))))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376064)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376100)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376145)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376190)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@18) (and (=> (= (ControlFlow 0 185389) (- 0 376206)) (=> $abort_flag@18 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@18 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376406)) (=> $abort_flag@18 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) (= $abort_code@27 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@27 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@27 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@27 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@18 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| account))))))) (= $abort_code@27 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@27 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@27 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@27 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 185389) (- 0 376672)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376736)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376800)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376846)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@92 T@$Value) )  (=> ((_ is $Address) addr@@92) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@92))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@92)))))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@93 T@$Value) )  (=> ((_ is $Address) addr@@93) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@93))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@93))))))))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376926)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@94 T@$Value) )  (=> ((_ is $Address) addr@@94) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@94)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@94))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@95 T@$Value) )  (=> ((_ is $Address) addr@@95) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@95)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@95)))))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 376994)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@96 T@$Value) )  (=> ((_ is $Address) addr@@96) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@96))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@96)))))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@97 T@$Value) )  (=> ((_ is $Address) addr@@97) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@97))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@97))))))))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 377074)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@98 T@$Value) )  (=> ((_ is $Address) addr@@98) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@98)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@98))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@99 T@$Value) )  (=> ((_ is $Address) addr@@99) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@99)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@99)))))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 377142)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 377188)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@100 T@$Value) )  (=> ((_ is $Address) addr@@100) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@100))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@100)))))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@101 T@$Value) )  (=> ((_ is $Address) addr@@101) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@101))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@101))))))))))))))) (and (=> (= (ControlFlow 0 185389) (- 0 377266)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@102 T@$Value) )  (=> ((_ is $Address) addr@@102) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@102)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@102))))))))))))) (=> (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean (forall ((addr@@103 T@$Value) )  (=> ((_ is $Address) addr@@103) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@103)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| addr@@103)))))))))))) (=> (= (ControlFlow 0 185389) (- 0 377332)) (=> (not $abort_flag@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_burn_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@17) (= $abort_code@27 $abort_code@25)) (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@4) (= $abort_flag@18 $abort_flag@17)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@0) (= (ControlFlow 0 185303) 185389))) anon0$2_correct@@6))))
(let ((inline$$Diem_burn_$def_verify$0$Abort_correct  (=> (= $abort_code@27 $abort_code@26) (=> (and (and (= $Diem_CurrencyInfo_$memory@6 $Diem_CurrencyInfo_$memory@5) (= $abort_flag@18 true)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= (ControlFlow 0 173156) 185389))) anon0$2_correct@@6))))
(let ((inline$$Diem_burn_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@26 $abort_code@1@@5) (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= (ControlFlow 0 185359) 173156))) inline$$Diem_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 185357) 185359)) inline$$Diem_burn_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 185367) 185359) inline$$Diem_burn_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon25_Then_correct  (=> $abort_flag@0@@5 (and (=> (= (ControlFlow 0 185351) 185367) inline$$Diem_burn_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 185351) 185357) inline$$Diem_burn_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@26 $abort_code@2@@3) (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= (ControlFlow 0 185339) 173156))) inline$$Diem_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 185337) 185339)) inline$$Diem_burn_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 185347) 185339) inline$$Diem_burn_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon27_Then_correct  (=> $abort_flag@1@@5 (and (=> (= (ControlFlow 0 185331) 185347) inline$$Diem_burn_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 185331) 185337) inline$$Diem_burn_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@26 $abort_code@4@@3) (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= (ControlFlow 0 185319) 173156))) inline$$Diem_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 185317) 185319)) inline$$Diem_burn_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 185327) 185319) inline$$Diem_burn_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon31_Then_correct  (=> $abort_flag@2@@4 (and (=> (= (ControlFlow 0 185311) 185327) inline$$Diem_burn_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 185311) 185317) inline$$Diem_burn_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon33_Then_correct  (=> $abort_flag@17 (=> (and (and (= $abort_code@26 $abort_code@25) (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0) (= (ControlFlow 0 185307) 173156))) inline$$Diem_burn_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon27_Else$2_correct  (and (=> (= (ControlFlow 0 185225) (- 0 375627)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 185225) (- 0 375690)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def$0$tc_addr@@0))))))))))))))) (=> (and (and (= $abort_code@25 $abort_code@23) (= $abort_flag@17 $abort_flag@16)) (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@2) (= $Diem_Preburn_$memory@0 |inline$$WritebackToGlobal$3$m'@2|))) (and (=> (= (ControlFlow 0 185225) 185307) inline$$Diem_burn_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 185225) 185303) inline$$Diem_burn_$def_verify$0$anon33_Else_correct)))))))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $Diem_Preburn_$memory) (= (ControlFlow 0 185019) 185225)) inline$$Diem_burn_with_capability_$def$0$anon27_Else$2_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WriteRef$4$to'@1|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 185073) 185225))) inline$$Diem_burn_with_capability_$def$0$anon27_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (and (=> (= (ControlFlow 0 185009) 185073) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 185009) 185019) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$WriteRef$4$anon0_correct  (=> (and (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2)) (= (ControlFlow 0 184885) 185009)) inline$$WritebackToGlobal$3$anon0_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@16) (= (ControlFlow 0 184891) 184885)) inline$$WriteRef$4$anon0_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$Abort_correct  (=> (and (and (= $abort_code@25 $abort_code@24) (= $abort_flag@17 true)) (and (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3) (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory))) (and (=> (= (ControlFlow 0 174132) 185307) inline$$Diem_burn_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 174132) 185303) inline$$Diem_burn_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon7_correct  (=> (= $abort_code@24 $abort_code@5@@1) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 185261) 174132)) inline$$Diem_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 185259) 185261)) inline$$Diem_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon22_Then_correct  (=> (= (ControlFlow 0 185269) 185261) inline$$Diem_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon21_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 185253) 185269) inline$$Diem_burn_with_capability_$def$0$anon22_Then_correct) (=> (= (ControlFlow 0 185253) 185259) inline$$Diem_burn_with_capability_$def$0$anon22_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon15_correct  (=> (= $abort_code@24 $abort_code@7@@1) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 185241) 174132)) inline$$Diem_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 185239) 185241)) inline$$Diem_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 185249) 185241) inline$$Diem_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon25_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 185233) 185249) inline$$Diem_burn_with_capability_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 185233) 185239) inline$$Diem_burn_with_capability_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon27_Then_correct  (=> (and (and $abort_flag@16 (= $abort_code@24 $abort_code@23)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@2) (= (ControlFlow 0 185229) 174132))) inline$$Diem_burn_with_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct  (=> (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2|) (= $abort_code@23 $abort_code@21)) (and (= $abort_flag@16 $abort_flag@15) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@0))) (and (=> (= (ControlFlow 0 182983) 185229) inline$$Diem_burn_with_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 182983) 184891) inline$$Diem_burn_with_capability_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 182981) 182983)) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct  (=> (= (ControlFlow 0 182991) 182983) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct  (and (=> (= (ControlFlow 0 184496) (- 0 374909)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@0 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 184496) (- 0 375033)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 184496) (- 0 375086)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$2$m'@2|) (and (=> (= (ControlFlow 0 184496) 182991) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 184496) 182981) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184175) 184496)) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 184229) 184496))) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (and (=> (= (ControlFlow 0 184165) 184229) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 184165) 184175) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@1 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 184235) 184165)) inline$$WritebackToGlobal$2$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct  (and (=> (= (ControlFlow 0 183918) (- 0 374627)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 183918) 184235) inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 183870) 183918)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$2$dst'@2|) (= (ControlFlow 0 183739) 183870)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|) (|v#$Mutation| |inline$$WriteRef$3$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 183795) 183870))) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (and (=> (= (ControlFlow 0 183703) 183795) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 183703) 183739) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct  (=> (and (not true) (= (ControlFlow 0 183566) 183703)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 184506) 183703)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$9$dst@1) (|p#$Mutation| inline$$BorrowField$9$dst@1) inline$$ReadRef$8$v@1)) (and (=> (= (ControlFlow 0 183552) 184506) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct) (=> (= (ControlFlow 0 183552) 183566) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 183558) 183552)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct  (and (=> (= (ControlFlow 0 182971) (- 0 373973)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@2 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@3 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 182971) (- 0 374097)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 182971) (- 0 374150)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$1$m'@2|) (and (=> (= (ControlFlow 0 182971) 182991) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct) (=> (= (ControlFlow 0 182971) 182981) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 182650) 182971)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 182704) 182971))) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 182640) 182704) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 182640) 182650) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@4 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 182710) 182640)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 182393) (- 0 373691)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 182393) 182710) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (= (ControlFlow 0 182345) 182393)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= (ControlFlow 0 182397) 182345)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct  (=> (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2 inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1) (= $abort_code@23 $abort_code@22)) (and (= $abort_flag@16 true) (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1))) (and (=> (= (ControlFlow 0 177582) 185229) inline$$Diem_burn_with_capability_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 177582) 184891) inline$$Diem_burn_with_capability_$def$0$anon27_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct  (=> (= $abort_code@22 $abort_code@8@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184780) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 184778) 184780)) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 184788) 184780) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 184772) 184788) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 184772) 184778) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct  (=> (= $abort_code@22 $abort_code@9@@0) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184760) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 184758) 184760)) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 184768) 184760) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 184752) 184768) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 184752) 184758) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct  (=> (= $abort_code@22 $abort_code@11) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184740) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 184738) 184740)) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 184748) 184740) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 184732) 184748) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 184732) 184738) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct  (=> (= $abort_code@22 $abort_code@12) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184702) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 184700) 184702)) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 184710) 184702) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 184694) 184710) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 184694) 184700) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct  (=> (= $abort_code@22 $abort_code@13) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184678) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 184676) 184678)) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct  (=> (= (ControlFlow 0 184686) 184678) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 184670) 184686) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 184670) 184676) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct  (=> (= $abort_code@22 $abort_code@14) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184658) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 184656) 184658)) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct  (=> (= (ControlFlow 0 184666) 184658) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 184650) 184666) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 184650) 184656) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct  (=> (= $abort_code@22 $abort_code@15) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184638) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 184636) 184638)) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct  (=> (= (ControlFlow 0 184646) 184638) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 184630) 184646) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 184630) 184636) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct  (=> (= $abort_code@22 $abort_code@17) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184618) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 184616) 184618)) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct  (=> (= (ControlFlow 0 184626) 184618) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 184610) 184626) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 184610) 184616) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct  (=> (= $abort_code@22 $abort_code@18) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184598) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 184596) 184598)) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct  (=> (= (ControlFlow 0 184606) 184598) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 184590) 184606) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 184590) 184596) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct  (=> (= $abort_code@22 $abort_code@19) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184568) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 184566) 184568)) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct  (=> (= (ControlFlow 0 184576) 184568) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 184560) 184576) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 184560) 184566) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct  (=> (= $abort_code@22 $abort_code@21) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184548) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 184546) 184548)) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct  (=> (= (ControlFlow 0 184556) 184548) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 184540) 184556) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct) (=> (= (ControlFlow 0 184540) 184546) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct  (=> (= $abort_code@22 $abort_code@21) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184518) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 184516) 184518)) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct  (=> (= (ControlFlow 0 184526) 184518) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct  (=> $abort_flag@15 (and (=> (= (ControlFlow 0 184510) 184526) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct) (=> (= (ControlFlow 0 184510) 184516) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 183483) 184510) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct) (=> (= (ControlFlow 0 183483) 183558) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct  (and (=> (= (ControlFlow 0 183493) (- 0 374430)) true) (=> (= (ControlFlow 0 183493) 183483) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$8$anon0_correct  (=> (and (= inline$$ReadRef$8$v@1 (|v#$Mutation| inline$$BorrowField$9$dst@1)) (= (ControlFlow 0 183435) 183493)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 183391) 183435)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 183397) 183435) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 183385) 183397) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 183385) 183391) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 183377) 183435)) inline$$ReadRef$8$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@86 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0 0) (< inline$$Diem_BurnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$Diem_BurnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$Diem_BurnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$Diem_BurnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) inline$$Diem_BurnEvent_pack$0$$$0))
))) (and ((_ is $Address) preburn_address) (= inline$$Diem_BurnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1) 1 call3formal@$ret0@0@@1) 2 preburn_address) 3))))) (and (=> (= (ControlFlow 0 183369) 183385) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 183369) 183377) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$9$anon0_correct  (=> (= inline$$BorrowField$9$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$9$size@1 (|size#$Path| inline$$BorrowField$9$p@1)) (= inline$$BorrowField$9$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1) inline$$BorrowField$9$size@1 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$9$size@1 1)))) (and (= inline$$BorrowField$9$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$9$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 183113) 183369))) inline$$Diem_BurnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= (ControlFlow 0 183119) 183113)) inline$$BorrowField$9$anon0_correct)))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$7$v@1)))) (and (=> (= (ControlFlow 0 182262) 183119) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct) (=> (= (ControlFlow 0 182262) 182397) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 182252) (- 0 373652)) true) (=> (= (ControlFlow 0 182252) 182262) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 182204) 182252)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 182166) 182204))) inline$$ReadRef$7$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$1$dst'@2|) (= (ControlFlow 0 181950) 182166)) inline$$BorrowField$8$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 182006) 182166))) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (and (=> (= (ControlFlow 0 181914) 182006) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 181914) 181950) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 181777) 181914)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 184536) 181914)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1) (|p#$Mutation| inline$$BorrowField$7$dst@1) inline$$Sub$1$dst@2)) (and (=> (= (ControlFlow 0 181763) 184536) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct) (=> (= (ControlFlow 0 181763) 181777) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct)))))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 181704) 181763))) inline$$WriteRef$2$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 181710) 181704)) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct  (=> (= $abort_flag@15 true) (=> (and (= $abort_code@21 $EXEC_FAILURE_CODE) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@0)) (and (=> (= (ControlFlow 0 181574) 184540) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 181574) 181710) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct))))))
(let ((inline$$Sub$1$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= (ControlFlow 0 181572) 181574)) inline$$Sub$1$anon3_Then$1_correct)))
(let ((inline$$Sub$1$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) (|i#$Integer| inline$$ReadRef$6$v@1)) (=> (and (and (= inline$$Sub$1$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$6$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)))) (= $abort_flag@15 $abort_flag@14)) (and (= $abort_code@21 $abort_code@19) (= inline$$Sub$1$dst@2 inline$$Sub$1$dst@1))) (and (=> (= (ControlFlow 0 181520) 184540) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct) (=> (= (ControlFlow 0 181520) 181710) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct))))))
(let ((inline$$Sub$1$Entry_correct  (and (=> (= (ControlFlow 0 181494) (- 0 373234)) true) (and (=> (= (ControlFlow 0 181494) 181572) inline$$Sub$1$anon3_Then_correct) (=> (= (ControlFlow 0 181494) 181520) inline$$Sub$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$6$dst@1)) (= (ControlFlow 0 181395) 181494)) inline$$Sub$1$Entry_correct)))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 181357) 181395))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1) (= (ControlFlow 0 181409) 181357)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct  (=> (= $abort_code@22 $abort_code@20) (=> (and (= $Diem_CurrencyInfo_$memory@1 |inline$$WritebackToGlobal$0$m'@2|) (= (ControlFlow 0 181191) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 181189) 181191)) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct  (=> (= (ControlFlow 0 181199) 181191) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct  (and (=> (= (ControlFlow 0 181183) (- 0 372855)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@5) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@5))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@5 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@5)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@6) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@6))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@6 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@6))))))))))))))))))))) (and (=> (= (ControlFlow 0 181183) (- 0 372979)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@15 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@16 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 181183) (- 0 373032)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@17 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@17) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@3)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@18 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@18) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@4))))))))))))))) (=> (= $abort_code@20 (|i#$Integer| call3formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 181183) 181199) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct) (=> (= (ControlFlow 0 181183) 181189) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 180858) 181183)) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 180912) 181183))) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (and (=> (= (ControlFlow 0 180848) 180912) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 180848) 180858) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@7) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@7))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@7 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@7))))))))))))))))))))) (= (ControlFlow 0 180918) 180848)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 180601) (- 0 372573)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 180601) 180918) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 180553) 180601)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1)) (= (ControlFlow 0 180605) 180553)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 180478) 181409) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 180478) 180605) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t36@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 180472) 184560) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 180472) 180478) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct)))))
(let ((inline$$Ge$1$anon0_correct  (=> (and (= inline$$Ge$1$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$5$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)))) (= (ControlFlow 0 180460) 180472)) inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct)))
(let ((inline$$Ge$1$Entry_correct  (and (=> (= (ControlFlow 0 180446) (- 0 372463)) true) (=> (= (ControlFlow 0 180446) 180460) inline$$Ge$1$anon0_correct))))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 180388) 180446)) inline$$Ge$1$Entry_correct)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 180350) 180388))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 180134) 180350)) inline$$BorrowField$5$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 180190) 180350))) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 180098) 180190) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 180098) 180134) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 179961) 180098)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 184586) 180098)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1) (|p#$Mutation| inline$$BorrowField$4$dst@1) inline$$Sub$0$dst@2)) (and (=> (= (ControlFlow 0 179947) 184586) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 179947) 179961) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 179888) 179947))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct  (=> (and (not $abort_flag@13) (= (ControlFlow 0 179894) 179888)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_code@18 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@13 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 179758) 184590) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 179758) 179894) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$4$v@1) (|i#$Integer| inline$$CastU128$1$dst@1)) (= (ControlFlow 0 179756) 179758)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$CastU128$1$dst@1) (|i#$Integer| inline$$ReadRef$4$v@1)) (=> (and (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$4$v@1) (|i#$Integer| inline$$CastU128$1$dst@1)))) (= $abort_code@18 $abort_code@17)) (and (= $abort_flag@13 $abort_flag@12) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 179704) 184590) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 179704) 179894) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 179678) (- 0 372043)) true) (and (=> (= (ControlFlow 0 179678) 179756) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 179678) 179704) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 179764) 179678)) inline$$Sub$0$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct  (=> (= $abort_flag@12 true) (=> (and (= $abort_code@17 $EXEC_FAILURE_CODE) (= inline$$CastU128$1$dst@1 inline$$CastU128$1$dst@0)) (and (=> (= (ControlFlow 0 179581) 184610) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 179581) 179764) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 179579) 179581)) inline$$CastU128$1$anon3_Then$1_correct)))
(let ((inline$$CastU128$1$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= $abort_flag@12 $abort_flag@11)) (and (= $abort_code@17 $abort_code@15) (= inline$$CastU128$1$dst@1 inline$$Diem_Diem_unpack$0$value@1))) (and (=> (= (ControlFlow 0 179529) 184610) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 179529) 179764) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct  (and (=> (= (ControlFlow 0 179515) (- 0 371971)) true) (and (=> (= (ControlFlow 0 179515) 179579) inline$$CastU128$1$anon3_Then_correct) (=> (= (ControlFlow 0 179515) 179529) inline$$CastU128$1$anon3_Else_correct)))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 179434) 179515)) inline$$CastU128$1$Entry_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 179396) 179434))) inline$$ReadRef$4$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= (ControlFlow 0 179448) 179396)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct  (=> (= $abort_code@22 $abort_code@16) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 179230) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 179228) 179230)) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct  (=> (= (ControlFlow 0 179238) 179230) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct  (=> (= $abort_code@16 (|i#$Integer| call3formal@$ret0@0@@3)) (and (=> (= (ControlFlow 0 179222) 179238) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 179222) 179228) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 179212) (- 0 371805)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 179212) 179222) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 179164) 179212)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= (ControlFlow 0 179216) 179164)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct  (=> (not $abort_flag@11) (and (=> (= (ControlFlow 0 179089) 179448) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 179089) 179216) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t28@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11)) (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 179083) 184630) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 179083) 179089) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct  (=> (and (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$3$v@1) (|i#$Integer| inline$$CastU128$0$dst@1)))) (= (ControlFlow 0 179071) 179083)) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 179057) (- 0 371695)) true) (=> (= (ControlFlow 0 179057) 179071) inline$$Ge$0$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct  (=> (and (not $abort_flag@10) (= (ControlFlow 0 179077) 179057)) inline$$Ge$0$Entry_correct)))
(let ((inline$$CastU128$0$anon3_Then$1_correct  (=> (= $abort_code@14 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10 true) (= inline$$CastU128$0$dst@1 inline$$CastU128$0$dst@0)) (and (=> (= (ControlFlow 0 179001) 184650) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 179001) 179077) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U128) (= (ControlFlow 0 178999) 179001)) inline$$CastU128$0$anon3_Then$1_correct)))
(let ((inline$$CastU128$0$anon3_Else_correct  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1)) (= $abort_code@14 $abort_code@13)) (and (= $abort_flag@10 $abort_flag@9) (= inline$$CastU128$0$dst@1 inline$$Diem_Diem_unpack$0$value@1))) (and (=> (= (ControlFlow 0 178949) 184650) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 178949) 179077) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct  (and (=> (= (ControlFlow 0 178935) (- 0 371623)) true) (and (=> (= (ControlFlow 0 178935) 178999) inline$$CastU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 178935) 178949) inline$$CastU128$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 178854) 178935)) inline$$CastU128$0$Entry_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 178816) 178854))) inline$$ReadRef$3$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 178658) 178816)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 178652) 178658)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct  (=> (and (not $abort_flag@9) (= (ControlFlow 0 178662) 178652)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_flag@9 true) (=> (and (= $abort_code@13 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 178612) 184670) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 178612) 178662) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 178610) 178612)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1))) (= $abort_flag@9 $abort_flag@8)) (and (= $abort_code@13 $abort_code@12) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 178558) 184670) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 178558) 178662) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@3)) (and (=> (= (ControlFlow 0 178528) 178610) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 178528) 178558) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (=> (= inline$$BorrowGlobal$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 178522) (- 0 371410)) true) (=> (= (ControlFlow 0 178522) 178528) inline$$BorrowGlobal$1$anon0_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 178618) 178522)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct  (=> (and (and $abort_flag@8 (= $abort_code@22 $abort_code@12)) (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 184690) 177582))) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 178379) 184690) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 178379) 178618) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@3  (and (=> (= (ControlFlow 0 178389) 184690) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 178389) 178618) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@3  (=> (and (not $abort_flag@8) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@3 ($Address 173345816))) (and (=> (= (ControlFlow 0 178373) 178389) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 178373) 178379) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@3)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct  (=> (and (not $abort_flag@8) (= (ControlFlow 0 178403) 178373)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@3)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (=> (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 178268) 184694) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 178268) 178403) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 178266) 178268)) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 184718) 178268) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct  (=> (and ((_ is $Vector) call4formal@$ret0@0@@1) (= inline$$Diem_Diem_unpack$0$value@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1) $MAX_U64)) (and (=> (= (ControlFlow 0 178252) 184718) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 178252) 178266) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$0$v@1) (= (ControlFlow 0 178161) 178252)) inline$$Diem_Diem_unpack$0$anon0_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|) ($Local 12)) (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 inline$$ReadRef$0$v@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)))) (and (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|) (= (ControlFlow 0 178187) 178252))) inline$$Diem_Diem_unpack$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 178006) 178187) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 178006) 178161) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (and (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1|)))) (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|))) (and (=> (= (ControlFlow 0 178062) 178187) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 178062) 178161) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 177970) 178062) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 177970) 178006) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 177833) 177970)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def$0$info@0)) (= (ControlFlow 0 184728) 177970)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 177819) 184728) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 177819) 177833) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 177825) 177819)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct  (and (=> (= (ControlFlow 0 177762) (- 0 370912)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7) (=> $abort_flag@7 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@1) (let ((va@@87 (|v#$Vector| call4formal@$ret0@0@@1)))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@1)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@88 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 177762) 184732) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 177762) 177825) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct)))))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 177750) 177762)) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 177712) 177750))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 177718) 177712)) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct  (=> (= $abort_code@22 $abort_code@10) (=> (and (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 177576) 177582)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 177574) 177576)) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 177590) 177576) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= $abort_code@10 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 177568) 177590) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 177568) 177574) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct  (=> (not $abort_flag@6@@1) (and (=> (= (ControlFlow 0 177556) 177718) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 177556) 177568) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t19@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@1)) (and (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 177550) 184752) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 177550) 177556) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@4) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def$0$$t17@1)))) (= (ControlFlow 0 177538) 177550)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 177524) (- 0 370705)) true) (=> (= (ControlFlow 0 177524) 177538) inline$$Gt$0$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t17@1 ($Integer 0)) (= (ControlFlow 0 177544) 177524)) inline$$Gt$0$Entry_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@4  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $Diem_Diem_value)) (= (ControlFlow 0 177470) 177544)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct  (and (=> (= (ControlFlow 0 177476) (- 0 370668)) true) (=> (= (ControlFlow 0 177476) 177470) inline$$GetFieldFromValue$0$anon0_correct@@4))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 177410) 177476)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 177372) 177410))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@5@@1) (= (ControlFlow 0 177424) 177372)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@1) (=> $abort_flag@5@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@5@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@5@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@1) (let ((va@@89 (|v#$Vector| call3formal@$ret0@0@@1)))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
)))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@29)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@1)) $$0@@29))
)))) (and (=> (= (ControlFlow 0 177214) 184772) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 177214) 177424) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct)))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$0$v@1)) (= (ControlFlow 0 177206) 177214)) inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 177088) 177206)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 184796) 177206) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 177080) 184796) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 177080) 177088) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct  (and (=> (= (ControlFlow 0 184804) 184796) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 184804) 177088) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 177072) 184804) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 177072) 177080) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 184812) 184804) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 184812) 177080) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct  (=> (not $abort_flag@4@@2) (and (=> (= (ControlFlow 0 177066) 184812) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 177066) 177072) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1) (let ((va@@90 (|v#$Vector| inline$$ReadRef$0$v@1)))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn)) (let ((va@@91 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) preburn_address)) (=> (and (and (and (and (and ((_ is $Vector) inline$$GetGlobal$0$dst@2@@2) (let ((va@@92 (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 184818) 177066)) inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon25_Else$1_correct  (and (=> (= (ControlFlow 0 184826) (- 0 370180)) true) (=> (= (ControlFlow 0 184826) 184818) inline$$Diem_burn_with_resource_cap$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 174391) 184826)) inline$$Diem_burn_with_capability_$def$0$anon25_Else$1_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon25_Else_correct  (=> (and (not $abort_flag@4@@2) (= (ControlFlow 0 174397) 174391)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_code@7@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@2 true) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 174347) 185233) inline$$Diem_burn_with_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 174347) 174397) inline$$Diem_burn_with_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 174345) 174347)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1))) (= $abort_code@7@@1 $abort_code@5@@1)) (and (= $abort_flag@4@@2 $abort_flag@3@@2) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 174293) 185233) inline$$Diem_burn_with_capability_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 174293) 174397) inline$$Diem_burn_with_capability_$def$0$anon25_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| preburn_address)) (and (=> (= (ControlFlow 0 174263) 174345) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 174263) 174293) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 174257) (- 0 370067)) true) (=> (= (ControlFlow 0 174257) 174263) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_burn_with_capability_$def$0$$t6@1) (= (ControlFlow 0 174353) 174257)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon12_correct  (=> (= $abort_code@24 $abort_code@6@@1) (=> (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 174128) 174132)) inline$$Diem_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 174126) 174128)) inline$$Diem_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon24_Then_correct  (=> (= (ControlFlow 0 174140) 174128) inline$$Diem_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_burn_with_capability_$def$0$$t6@1)) (= $abort_code@6@@1 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 174120) 174140) inline$$Diem_burn_with_capability_$def$0$anon24_Then_correct) (=> (= (ControlFlow 0 174120) 174126) inline$$Diem_burn_with_capability_$def$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon21_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 174108) 174353) inline$$Diem_burn_with_capability_$def$0$anon23_Then_correct) (=> (= (ControlFlow 0 174108) 174120) inline$$Diem_burn_with_capability_$def$0$anon23_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon4$2_correct  (=> (= inline$$Diem_burn_with_capability_$def$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| preburn_address)))) (=> (and (and (and (= inline$$Diem_burn_with_capability_$def$0$$t7@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (and (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 174102) 185253) inline$$Diem_burn_with_capability_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 174102) 174108) inline$$Diem_burn_with_capability_$def$0$anon21_Else_correct))))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 174008) 174102)) inline$$Diem_burn_with_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 185277) 174102) inline$$Diem_burn_with_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_burn_with_capability_$def$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 174000) 185277) inline$$Diem_burn_with_capability_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 174000) 174008) inline$$Diem_burn_with_capability_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 185285) 185277) inline$$Diem_burn_with_capability_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 185285) 174008) inline$$Diem_burn_with_capability_$def$0$anon20_Else_correct))))
(let ((inline$$Diem_burn_with_capability_$def$0$anon0_correct  (=> (not $abort_flag@2@@4) (and (=> (= (ControlFlow 0 173994) 185285) inline$$Diem_burn_with_capability_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 173994) 174000) inline$$Diem_burn_with_capability_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$direct_intra$0$anon0_correct  (=> ((_ is $Address) preburn_address) (=> (and (and (and (and (and ((_ is $Vector) inline$$GetGlobal$0$dst@2@@2) (let ((va@@93 (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 185289) 173994)) inline$$Diem_burn_with_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@2@@4) (= (ControlFlow 0 185295) 185289)) inline$$Diem_burn_with_capability_$direct_intra$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@2@@4 true) (=> (and (= $abort_code@4@@3 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 173349) 185311) inline$$Diem_burn_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 173349) 185295) inline$$Diem_burn_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@2 inline$$GetGlobal$0$a@1@@2)) (= (ControlFlow 0 173347) 173349)) inline$$GetGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@2 inline$$GetGlobal$0$a@1@@2) (=> (and (and (= inline$$GetGlobal$0$dst@1@@2 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@2 (|a#$Address| call3formal@$ret0@0@@6))) (= $abort_flag@2@@4 $abort_flag@1@@5)) (and (= $abort_code@4@@3 $abort_code@2@@3) (= inline$$GetGlobal$0$dst@2@@2 inline$$GetGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 173295) 185311) inline$$Diem_burn_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 173295) 185295) inline$$Diem_burn_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@2  (=> (= inline$$GetGlobal$0$a@1@@2 (|a#$Address| call3formal@$ret0@0@@6)) (and (=> (= (ControlFlow 0 173277) 173347) inline$$GetGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 173277) 173295) inline$$GetGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$GetGlobal$0$Entry_correct@@2  (=> (= inline$$GetGlobal$0$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 173271) (- 0 369716)) true) (=> (= (ControlFlow 0 173271) 173277) inline$$GetGlobal$0$anon0_correct@@2)))))
(let ((inline$$Diem_burn_$def_verify$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_burn_$def_verify$0$$t7@1) (= (ControlFlow 0 173355) 173271)) inline$$GetGlobal$0$Entry_correct@@2)))
(let ((inline$$Diem_burn_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@26 $abort_code@3@@4) (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= (ControlFlow 0 173152) 173156))) inline$$Diem_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 173150) 173152)) inline$$Diem_burn_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 173164) 173152) inline$$Diem_burn_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon29_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_burn_$def_verify$0$$t7@1)) (= $abort_code@3@@4 (|i#$Integer| call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 173144) 173164) inline$$Diem_burn_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 173144) 173150) inline$$Diem_burn_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@1@@5) (and (=> (= (ControlFlow 0 173132) 173355) inline$$Diem_burn_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 173132) 173144) inline$$Diem_burn_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@0@@5) (= inline$$Diem_burn_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) (=> (and (and (and (= inline$$Diem_burn_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@5)) (and (=> $abort_flag@1@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@7) (>= (|i#$Integer| call3formal@$ret0@0@@7) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@7) $MAX_U64))) (and (=> (= (ControlFlow 0 173126) 185331) inline$$Diem_burn_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 173126) 173132) inline$$Diem_burn_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$Diem_burn_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@5) (=> $abort_flag@0@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 account)))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 173096) 185351) inline$$Diem_burn_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 173096) 173126) inline$$Diem_burn_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 173026) 173096)) inline$$Diem_burn_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 185375) 173096) inline$$Diem_burn_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_burn_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 173018) 185375) inline$$Diem_burn_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 173018) 173026) inline$$Diem_burn_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 185383) 185375) inline$$Diem_burn_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 185383) 173026) inline$$Diem_burn_$def_verify$0$anon24_Else_correct))))
(let ((inline$$Diem_burn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 173012) 185383) inline$$Diem_burn_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 173012) 173018) inline$$Diem_burn_$def_verify$0$anon23_Else_correct)))))
(let ((anon0$1_correct@@6  (=> (and (and (and (forall (($inv_addr@@12 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12)) (let ((va@@94 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@12))
)) (forall (($inv_addr@@13 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@13)) (let ((va@@95 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@13))))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@13))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@13))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@13))
))) (and (forall (($inv_addr@@14 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14)) (let ((va@@96 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@97 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code)) (let ((va@@98 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
))))))) (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))) $$0@@30)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))) $$0@@30)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))) $$0@@30)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_currency_code))) $$0@@30))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events)) (let ((va@@99 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@100 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@31)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@31))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events)) (let ((va@@101 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@102 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@32)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@32))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@103 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@104 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
))))))) (forall (($$0@@33 Int) ) (!  (=> (and (>= $$0@@33 0) (< $$0@@33 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@33)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@33)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@33)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@33))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@105 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@106 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
))))))) (forall (($$0@@34 Int) ) (!  (=> (and (>= $$0@@34 0) (< $$0@@34 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@34)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@34)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@34)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@34))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@107 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@108 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
))))))) (forall (($$0@@35 Int) ) (!  (=> (and (>= $$0@@35 0) (< $$0@@35 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@35)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@35)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@35)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@35))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15)) (let ((va@@109 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@15))
)))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean (forall ((addr3@@4 T@$Value) )  (=> ((_ is $Address) addr3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| addr3@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@8 T@$Value) )  (=> ((_ is $Type) coin_type@@8) (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@9 T@$Value) )  (=> ((_ is $Type) coin_type@@9) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 185387) 173012)))) inline$$Diem_burn_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@6  (=> ((_ is $Address) account) (=> (and ((_ is $Address) preburn_address) (= (ControlFlow 0 172210) 185387)) anon0$1_correct@@6))))
(let ((PreconditionGeneratedEntry_correct@@3  (=> (= (ControlFlow 0 365895) 172210) anon0_correct@@6)))
PreconditionGeneratedEntry_correct@@3)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin@@1 () T@$Value)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $tv0@@14 () T@$TypeValue)
(declare-fun preburn () T@$Value)
(declare-fun $abort_code@31 () Int)
(declare-fun inline$$Diem_burn_now_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@6@@0 () T@$Memory)
(declare-fun |inline$$WritebackToValue$2$vdst'@2| () T@$Value)
(declare-fun $abort_code@29 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@4@@0 () T@$Memory)
(declare-fun $abort_flag@20 () Bool)
(declare-fun |inline$$WriteRef$8$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$2$vdst'@1| () T@$Value)
(declare-fun |inline$$WriteRef$3$to'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@5@@0 () T@$Memory)
(declare-fun $abort_code@1@@6 () Int)
(declare-fun $abort_flag@0@@6 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@2@@0 () T@$Memory)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@27@@0 () Int)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@1@@0 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$6$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$5$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$7$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$6$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$6$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$6$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4@@0 () T@$Value)
(declare-fun inline$$BorrowField$16$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$15$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$3$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@3@@0 () T@$Memory)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun $abort_code@17@@0 () Int)
(declare-fun $abort_flag@11@@0 () Bool)
(declare-fun $abort_code@18@@0 () Int)
(declare-fun $abort_flag@12@@0 () Bool)
(declare-fun $abort_code@19@@0 () Int)
(declare-fun $abort_flag@13@@0 () Bool)
(declare-fun $abort_code@20@@0 () Int)
(declare-fun $abort_flag@14@@0 () Bool)
(declare-fun $abort_code@21@@0 () Int)
(declare-fun $abort_flag@15@@0 () Bool)
(declare-fun $abort_code@23@@0 () Int)
(declare-fun $abort_flag@16@@0 () Bool)
(declare-fun $abort_code@24@@0 () Int)
(declare-fun $abort_flag@17@@0 () Bool)
(declare-fun $abort_code@25@@0 () Int)
(declare-fun $abort_flag@18@@0 () Bool)
(declare-fun inline$$Event_emit_event$1$t@0 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun preburn_address@@0 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$16$p@1 () T@$Path)
(declare-fun inline$$BorrowField$16$size@1 () Int)
(declare-fun inline$$BorrowField$16$p@2 () T@$Path)
(declare-fun inline$$ReadRef$14$v@1 () T@$Value)
(declare-fun inline$$BorrowField$15$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$15$p@1 () T@$Path)
(declare-fun inline$$BorrowField$15$size@1 () Int)
(declare-fun inline$$BorrowField$15$p@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$5$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$5$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$5$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3@@0 () T@$Value)
(declare-fun inline$$BorrowField$14$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$2$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$14$p@1 () T@$Path)
(declare-fun inline$$BorrowField$14$size@1 () Int)
(declare-fun inline$$BorrowField$14$p@2 () T@$Path)
(declare-fun inline$$Sub$2$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$13$v@1 () T@$Value)
(declare-fun inline$$Sub$2$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$13$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$13$p@1 () T@$Path)
(declare-fun inline$$BorrowField$13$size@1 () Int)
(declare-fun inline$$BorrowField$13$p@2 () T@$Path)
(declare-fun inline$$Ge$2$dst@1 () T@$Value)
(declare-fun $abort_code@26@@0 () Int)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@0| () T@$Memory)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$WritebackToGlobal$2$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t36@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$12$v@1 () T@$Value)
(declare-fun inline$$BorrowField$12$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$12$p@1 () T@$Path)
(declare-fun inline$$BorrowField$12$size@1 () Int)
(declare-fun inline$$BorrowField$12$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$11$dst@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$11$p@1 () T@$Path)
(declare-fun inline$$BorrowField$11$size@1 () Int)
(declare-fun inline$$BorrowField$11$p@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$11$v@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1@@0 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@0 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0@@0 () T@$Value)
(declare-fun inline$$BorrowField$10$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$10$p@1 () T@$Path)
(declare-fun inline$$BorrowField$10$size@1 () Int)
(declare-fun inline$$BorrowField$10$p@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1@@0 () T@$Value)
(declare-fun $abort_code@22@@0 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t28@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$10$v@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1@@0 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0@@0 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$9$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1@@0 () Int)
(declare-fun inline$$BorrowField$9$p@2@@0 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@0 () T@$Value)
(declare-fun call4formal@$ret0@0@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$7$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$2$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$4$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$info@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$8$dst@1@@0 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$9$v@1 () T@$Value)
(declare-fun inline$$BorrowField$8$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1@@0 () Int)
(declare-fun inline$$BorrowField$8$p@2@@0 () T@$Path)
(declare-fun inline$$Gt$1$dst@1 () T@$Value)
(declare-fun $abort_code@16@@0 () Int)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t19@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$8$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$7$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1@@0 () Int)
(declare-fun inline$$BorrowField$7$p@2@@0 () T@$Path)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun capability () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@0| () T@$Value)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@0 () T@$Mutation)
(declare-fun inline$$ReadRef$6$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun $abort_code@3@@5 () Int)
(declare-fun $abort_flag@1@@6 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_flag@2@@5 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun $abort_flag@6@@2 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@0 () Int)
(declare-fun inline$$BorrowField$6$p@2@@0 () T@$Path)
(declare-fun inline$$ReadRef$5$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@0 () Int)
(declare-fun inline$$BorrowField$5$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@0 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t27@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t23@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@0| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@4@@4 () Int)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$Gt$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@2@@4 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def_verify$0$$t14@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@5 () T@$Value)
(declare-fun inline$$Diem_burn_now_$def_verify$0$$t12@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 377383) (let ((anon0$2_correct@@7  (and (=> (= (ControlFlow 0 207259) (- 0 391329)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) $abort_flag@21) (and (=> (= (ControlFlow 0 207259) (- 0 391348)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) $abort_flag@21) (and (=> (= (ControlFlow 0 207259) (- 0 391376)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@21) (and (=> (= (ControlFlow 0 207259) (- 0 391401)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@21) (and (=> (= (ControlFlow 0 207259) (- 0 391441)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21) (and (=> (= (ControlFlow 0 207259) (- 0 391457)) (=> $abort_flag@21 (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@21 (or (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 391581)) (=> $abort_flag@21 (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@31 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (= $abort_code@31 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@31 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@31 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@31 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@21 (or (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@31 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (= $abort_code@31 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@31 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@31 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@31 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 207259) (- 0 391760)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_burn_now_$def_verify$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_burn_now_$def_verify$0$$ret0@2)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 207259) (- 0 391784)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 207259) (- 0 391827)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 391873)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@104 T@$Value) )  (=> ((_ is $Address) addr@@104) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@104))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@104)))))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@105 T@$Value) )  (=> ((_ is $Address) addr@@105) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@105))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@105))))))))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 391953)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@106 T@$Value) )  (=> ((_ is $Address) addr@@106) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@106)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@106))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@107 T@$Value) )  (=> ((_ is $Address) addr@@107) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@107)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@107)))))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 392021)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@108 T@$Value) )  (=> ((_ is $Address) addr@@108) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@108))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@108)))))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@109 T@$Value) )  (=> ((_ is $Address) addr@@109) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@109))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@109))))))))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 392101)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@110 T@$Value) )  (=> ((_ is $Address) addr@@110) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@110)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@110))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@111 T@$Value) )  (=> ((_ is $Address) addr@@111) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@111)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@111)))))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 392169)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 392215)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@112 T@$Value) )  (=> ((_ is $Address) addr@@112) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@112))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@112)))))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@113 T@$Value) )  (=> ((_ is $Address) addr@@113) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@113))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@113))))))))))))))) (and (=> (= (ControlFlow 0 207259) (- 0 392295)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@114 T@$Value) )  (=> ((_ is $Address) addr@@114) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@114)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@114))))))))))))) (=> (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean (forall ((addr@@115 T@$Value) )  (=> ((_ is $Address) addr@@115) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@115)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@115)))))))))))) (=> (= (ControlFlow 0 207259) (- 0 392363)) (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@6@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon22_correct  (=> (= inline$$Diem_burn_now_$def_verify$0$$ret0@2 |inline$$WritebackToValue$2$vdst'@2|) (=> (and (and (= $abort_code@31 $abort_code@29) (= $Diem_CurrencyInfo_$memory@6@@0 $Diem_CurrencyInfo_$memory@4@@0)) (and (= $abort_flag@21 $abort_flag@20) (= (ControlFlow 0 207183) 207259))) anon0$2_correct@@7))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 207181) 207183)) inline$$Diem_burn_now_$def_verify$0$anon22_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 207191) 207183) inline$$Diem_burn_now_$def_verify$0$anon22_correct)))
(let ((inline$$WritebackToValue$2$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$8$to'@1|) ($Local 7))) (= |inline$$WritebackToValue$2$vdst'@2| preburn)) (and (=> (= (ControlFlow 0 207139) 207191) inline$$Diem_burn_now_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 207139) 207181) inline$$Diem_burn_now_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$WritebackToValue$2$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WriteRef$8$to'@1|) ($Local 7)) (=> (and (= |inline$$WritebackToValue$2$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$8$to'@1|) 0 preburn (|v#$Mutation| |inline$$WriteRef$8$to'@1|))) (= |inline$$WritebackToValue$2$vdst'@2| |inline$$WritebackToValue$2$vdst'@1|)) (and (=> (= (ControlFlow 0 207165) 207191) inline$$Diem_burn_now_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 207165) 207181) inline$$Diem_burn_now_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$WriteRef$8$anon0_correct  (=> (= |inline$$WriteRef$8$to'@1| ($Mutation (|l#$Mutation| |inline$$WriteRef$3$to'@1@@0|) (|p#$Mutation| |inline$$WriteRef$3$to'@1@@0|) inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@0)) (and (=> (= (ControlFlow 0 207040) 207165) inline$$WritebackToValue$2$anon3_Then_correct) (=> (= (ControlFlow 0 207040) 207139) inline$$WritebackToValue$2$anon3_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@20) (= (ControlFlow 0 207046) 207040)) inline$$WriteRef$8$anon0_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$Abort_correct  (=> (and (= inline$$Diem_burn_now_$def_verify$0$$ret0@1 $Error) (= inline$$Diem_burn_now_$def_verify$0$$ret0@2 inline$$Diem_burn_now_$def_verify$0$$ret0@1)) (=> (and (and (= $abort_code@31 $abort_code@30) (= $Diem_CurrencyInfo_$memory@6@@0 $Diem_CurrencyInfo_$memory@5@@0)) (and (= $abort_flag@21 true) (= (ControlFlow 0 188212) 207259))) anon0$2_correct@@7))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon11_correct  (=> (= $abort_code@30 $abort_code@1@@6) (=> (and (= $Diem_CurrencyInfo_$memory@5@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 207211) 188212)) inline$$Diem_burn_now_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 207209) 207211)) inline$$Diem_burn_now_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 207219) 207211) inline$$Diem_burn_now_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@6 (and (=> (= (ControlFlow 0 207203) 207219) inline$$Diem_burn_now_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 207203) 207209) inline$$Diem_burn_now_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon32_Then_correct  (=> (and (and $abort_flag@20 (= $abort_code@30 $abort_code@29)) (and (= $Diem_CurrencyInfo_$memory@5@@0 $Diem_CurrencyInfo_$memory@4@@0) (= (ControlFlow 0 207195) 188212))) inline$$Diem_burn_now_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@0  (=> (and (and (= $Diem_CurrencyInfo_$memory@4@@0 $Diem_CurrencyInfo_$memory@2@@0) (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@0 |inline$$WritebackToValue$1$vdst'@2|)) (and (= $abort_flag@20 $abort_flag@19) (= $abort_code@29 $abort_code@27@@0))) (and (=> (= (ControlFlow 0 205138) 207195) inline$$Diem_burn_now_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 205138) 207046) inline$$Diem_burn_now_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 205136) 205138)) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@0  (=> (= (ControlFlow 0 205146) 205138) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@0  (and (=> (= (ControlFlow 0 206651) (- 0 390578)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@20)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@8))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@8 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@8)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@21)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@9))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@9 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@9))))))))))))))))))))) (and (=> (= (ControlFlow 0 206651) (- 0 390702)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@22 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@22) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@22)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@23 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@23) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@23)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@23)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@23)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 206651) (- 0 390755)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@24 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@24) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@24)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@24)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@5)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@25 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@25) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@25)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$4$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@25)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@6))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@2@@0 |inline$$WritebackToGlobal$4$m'@2|) (and (=> (= (ControlFlow 0 206651) 205146) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@0) (=> (= (ControlFlow 0 206651) 205136) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@0)))))))))))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (=> (and (= |inline$$WritebackToGlobal$4$m'@2| $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206330) 206651)) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@0))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (=> (and (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$6$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|))) (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1)))) (and (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|) (= (ControlFlow 0 206384) 206651))) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@0)))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (and (=> (= (ControlFlow 0 206320) 206384) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 206320) 206330) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct@@0  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@26)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@10))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@10 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@10))))))))))))))))))))) (= (ControlFlow 0 206390) 206320)) inline$$WritebackToGlobal$4$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct  (and (=> (= (ControlFlow 0 206073) (- 0 390299)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 206073) 206390) inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$6$$after@0 (|v#$Mutation| |inline$$WritebackToReference$6$dst'@2|)) (= (ControlFlow 0 206025) 206073)) inline$$Diem_CurrencyInfo_$pack_ref$6$anon0_correct)))
(let ((inline$$WritebackToReference$6$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1))) (=> (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$5$dst'@2|) (= (ControlFlow 0 205894) 206025)) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct))))
(let ((inline$$WritebackToReference$6$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|l#$Mutation| |inline$$WriteRef$7$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|size#$Path| inline$$WritebackToReference$6$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$6$dstPath@1 inline$$WritebackToReference$6$srcPath@1)) (= |inline$$WritebackToReference$6$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$WritebackToReference$6$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$6$srcPath@1 (|size#$Path| inline$$WritebackToReference$6$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|) (|v#$Mutation| |inline$$WriteRef$7$to'@1|))))) (and (= |inline$$WritebackToReference$6$dst'@2| |inline$$WritebackToReference$6$dst'@1|) (= (ControlFlow 0 205950) 206025))) inline$$Diem_CurrencyInfo_$pack_ref$6$Entry_correct)))
(let ((inline$$WritebackToReference$6$anon0_correct  (=> (and (= inline$$WritebackToReference$6$srcPath@1 (|p#$Mutation| |inline$$WriteRef$7$to'@1|)) (= inline$$WritebackToReference$6$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (and (=> (= (ControlFlow 0 205858) 205950) inline$$WritebackToReference$6$anon3_Then_correct) (=> (= (ControlFlow 0 205858) 205894) inline$$WritebackToReference$6$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 205721) 205858)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct@@0  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4@@0 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 206661) 205858)) inline$$WritebackToReference$6$anon0_correct)))
(let ((inline$$WriteRef$7$anon0_correct  (=> (= |inline$$WriteRef$7$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$16$dst@1) (|p#$Mutation| inline$$BorrowField$16$dst@1) inline$$ReadRef$15$v@1)) (and (=> (= (ControlFlow 0 205707) 206661) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct@@0) (=> (= (ControlFlow 0 205707) 205721) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct@@0  (=> (and (not $abort_flag@19) (= (ControlFlow 0 205713) 205707)) inline$$WriteRef$7$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@0  (and (=> (= (ControlFlow 0 205126) (- 0 389645)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@11 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@11 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@27)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@11))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@11 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@11)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@12 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@12) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@12 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@28)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@12))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@12 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@12))))))))))))))))))))) (and (=> (= (ControlFlow 0 205126) (- 0 389769)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@29 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@29) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@29)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@29)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@29)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@30 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@30) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@30)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@30)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@30)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 205126) (- 0 389822)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@31 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@31) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@31)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@31)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@7)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@32 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@32) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@32)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@32)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@8))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@2@@0 |inline$$WritebackToGlobal$3$m'@2@@0|) (and (=> (= (ControlFlow 0 205126) 205146) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@0) (=> (= (ControlFlow 0 205126) 205136) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@0)))))))))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2@@0| $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 204805) 205126)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@0))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@0) (=> (and (= inline$$WritebackToGlobal$3$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$3$l@1@@0)) (= inline$$WritebackToGlobal$3$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$3$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$3$ta@1@@0 inline$$WritebackToGlobal$3$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) (= |inline$$WritebackToGlobal$3$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$3$ta@1@@0 inline$$WritebackToGlobal$3$a@1@@0 inline$$WritebackToGlobal$3$v@1@@0)))) (and (= |inline$$WritebackToGlobal$3$m'@2@@0| |inline$$WritebackToGlobal$3$m'@1@@0|) (= (ControlFlow 0 204859) 205126))) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@0)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$3$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (and (=> (= (ControlFlow 0 204795) 204859) inline$$WritebackToGlobal$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 204795) 204805) inline$$WritebackToGlobal$3$anon3_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct@@0  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@13 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@13) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@13 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@13)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@33)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@13))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@13 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@13))))))))))))))))))))) (= (ControlFlow 0 204865) 204795)) inline$$WritebackToGlobal$3$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct  (and (=> (= (ControlFlow 0 204548) (- 0 389366)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 204548) 204865) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$5$$after@0 (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (= (ControlFlow 0 204500) 204548)) inline$$Diem_CurrencyInfo_$pack_ref$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1)) (= (ControlFlow 0 204552) 204500)) inline$$Diem_CurrencyInfo_$pack_ref$5$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0  (=> (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@0 $Error) (=> (and (and (= $Diem_CurrencyInfo_$memory@4@@0 $Diem_CurrencyInfo_$memory@3@@0) (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@0 inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@0)) (and (= $abort_flag@20 true) (= $abort_code@29 $abort_code@28))) (and (=> (= (ControlFlow 0 199737) 207195) inline$$Diem_burn_now_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 199737) 207046) inline$$Diem_burn_now_$def_verify$0$anon32_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@0  (=> (= $abort_code@28 $abort_code@14@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206935) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206933) 206935)) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct@@0  (=> (= (ControlFlow 0 206943) 206935) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct@@0  (=> $abort_flag@9@@0 (and (=> (= (ControlFlow 0 206927) 206943) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct@@0) (=> (= (ControlFlow 0 206927) 206933) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@0  (=> (= $abort_code@28 $abort_code@15@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206915) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206913) 206915)) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct@@0  (=> (= (ControlFlow 0 206923) 206915) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct@@0  (=> $abort_flag@10@@0 (and (=> (= (ControlFlow 0 206907) 206923) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct@@0) (=> (= (ControlFlow 0 206907) 206913) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@0  (=> (= $abort_code@28 $abort_code@17@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206895) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206893) 206895)) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct@@0  (=> (= (ControlFlow 0 206903) 206895) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct@@0  (=> $abort_flag@11@@0 (and (=> (= (ControlFlow 0 206887) 206903) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct@@0) (=> (= (ControlFlow 0 206887) 206893) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@0  (=> (= $abort_code@28 $abort_code@18@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206857) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206855) 206857)) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct@@0  (=> (= (ControlFlow 0 206865) 206857) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct@@0  (=> $abort_flag@12@@0 (and (=> (= (ControlFlow 0 206849) 206865) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct@@0) (=> (= (ControlFlow 0 206849) 206855) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@0  (=> (= $abort_code@28 $abort_code@19@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206833) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206831) 206833)) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct@@0  (=> (= (ControlFlow 0 206841) 206833) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@0  (=> $abort_flag@13@@0 (and (=> (= (ControlFlow 0 206825) 206841) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct@@0) (=> (= (ControlFlow 0 206825) 206831) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@0  (=> (= $abort_code@28 $abort_code@20@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206813) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206811) 206813)) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct@@0  (=> (= (ControlFlow 0 206821) 206813) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@0  (=> $abort_flag@14@@0 (and (=> (= (ControlFlow 0 206805) 206821) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct@@0) (=> (= (ControlFlow 0 206805) 206811) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@0  (=> (= $abort_code@28 $abort_code@21@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206793) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206791) 206793)) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct@@0  (=> (= (ControlFlow 0 206801) 206793) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct@@0  (=> $abort_flag@15@@0 (and (=> (= (ControlFlow 0 206785) 206801) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct@@0) (=> (= (ControlFlow 0 206785) 206791) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@0  (=> (= $abort_code@28 $abort_code@23@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206773) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206771) 206773)) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct@@0  (=> (= (ControlFlow 0 206781) 206773) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@0  (=> $abort_flag@16@@0 (and (=> (= (ControlFlow 0 206765) 206781) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct@@0) (=> (= (ControlFlow 0 206765) 206771) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@0  (=> (= $abort_code@28 $abort_code@24@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206753) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206751) 206753)) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct@@0  (=> (= (ControlFlow 0 206761) 206753) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@0  (=> $abort_flag@17@@0 (and (=> (= (ControlFlow 0 206745) 206761) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct@@0) (=> (= (ControlFlow 0 206745) 206751) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@0  (=> (= $abort_code@28 $abort_code@25@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206723) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206721) 206723)) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct@@0  (=> (= (ControlFlow 0 206731) 206723) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct@@0  (=> $abort_flag@18@@0 (and (=> (= (ControlFlow 0 206715) 206731) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct@@0) (=> (= (ControlFlow 0 206715) 206721) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@0  (=> (= $abort_code@28 $abort_code@27@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206703) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206701) 206703)) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct@@0  (=> (= (ControlFlow 0 206711) 206703) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@0  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 206695) 206711) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct@@0) (=> (= (ControlFlow 0 206695) 206701) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@0  (=> (= $abort_code@28 $abort_code@27@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206673) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 206671) 206673)) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct@@0  (=> (= (ControlFlow 0 206681) 206673) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct@@0  (=> $abort_flag@19 (and (=> (= (ControlFlow 0 206665) 206681) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct@@0) (=> (= (ControlFlow 0 206665) 206671) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct@@0)))))
(let ((inline$$Event_emit_event$1$Entry_correct  (=> (= inline$$Event_emit_event$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 205638) 206665) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct@@0) (=> (= (ControlFlow 0 205638) 205713) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct@@0  (and (=> (= (ControlFlow 0 205648) (- 0 390102)) true) (=> (= (ControlFlow 0 205648) 205638) inline$$Event_emit_event$1$Entry_correct))))
(let ((inline$$ReadRef$15$anon0_correct  (=> (and (= inline$$ReadRef$15$v@1 (|v#$Mutation| inline$$BorrowField$16$dst@1)) (= (ControlFlow 0 205590) 205648)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct@@0)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 205546) 205590)) inline$$ReadRef$15$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 205552) 205590) inline$$ReadRef$15$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 205540) 205552) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 205540) 205546) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 205532) 205590)) inline$$ReadRef$15$anon0_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@0) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@8) (let ((va@@111 (|v#$Vector| call3formal@$ret0@0@@8)))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0@@0 0) (< inline$$Diem_BurnEvent_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$Diem_BurnEvent_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$Diem_BurnEvent_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$Diem_BurnEvent_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$Diem_BurnEvent_pack$0$$$0@@0))
))) (and ((_ is $Address) preburn_address@@0) (= inline$$Diem_BurnEvent_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1@@0) 1 call3formal@$ret0@0@@8) 2 preburn_address@@0) 3))))) (and (=> (= (ControlFlow 0 205524) 205540) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 205524) 205532) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$BorrowField$16$anon0_correct  (=> (= inline$$BorrowField$16$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$16$size@1 (|size#$Path| inline$$BorrowField$16$p@1)) (= inline$$BorrowField$16$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$16$p@1) inline$$BorrowField$16$size@1 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$16$size@1 1)))) (and (= inline$$BorrowField$16$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$16$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 205268) 205524))) inline$$Diem_BurnEvent_pack$0$anon0_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Not$1$dst@1) (= (ControlFlow 0 205274) 205268)) inline$$BorrowField$16$anon0_correct)))
(let ((inline$$Not$1$anon0_correct  (=> (= inline$$Not$1$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$14$v@1)))) (and (=> (= (ControlFlow 0 204417) 205274) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct@@0) (=> (= (ControlFlow 0 204417) 204552) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct@@0)))))
(let ((inline$$Not$1$Entry_correct  (and (=> (= (ControlFlow 0 204407) (- 0 389327)) true) (=> (= (ControlFlow 0 204407) 204417) inline$$Not$1$anon0_correct))))
(let ((inline$$ReadRef$14$anon0_correct  (=> (and (= inline$$ReadRef$14$v@1 (|v#$Mutation| inline$$BorrowField$15$dst@1)) (= (ControlFlow 0 204359) 204407)) inline$$Not$1$Entry_correct)))
(let ((inline$$BorrowField$15$anon0_correct  (=> (= inline$$BorrowField$15$p@1 (|p#$Mutation| |inline$$WritebackToReference$5$dst'@2|)) (=> (and (and (= inline$$BorrowField$15$size@1 (|size#$Path| inline$$BorrowField$15$p@1)) (= inline$$BorrowField$15$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$15$p@1) inline$$BorrowField$15$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$15$size@1 1)))) (and (= inline$$BorrowField$15$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$5$dst'@2|) inline$$BorrowField$15$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$5$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 204321) 204359))) inline$$ReadRef$14$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1))) (=> (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$4$dst'@2|) (= (ControlFlow 0 204105) 204321)) inline$$BorrowField$15$anon0_correct))))
(let ((inline$$WritebackToReference$5$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|size#$Path| inline$$WritebackToReference$5$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$5$dstPath@1 inline$$WritebackToReference$5$srcPath@1)) (= |inline$$WritebackToReference$5$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) inline$$WritebackToReference$5$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$5$srcPath@1 (|size#$Path| inline$$WritebackToReference$5$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|) (|v#$Mutation| |inline$$WriteRef$6$to'@1|))))) (and (= |inline$$WritebackToReference$5$dst'@2| |inline$$WritebackToReference$5$dst'@1|) (= (ControlFlow 0 204161) 204321))) inline$$BorrowField$15$anon0_correct)))
(let ((inline$$WritebackToReference$5$anon0_correct  (=> (and (= inline$$WritebackToReference$5$srcPath@1 (|p#$Mutation| |inline$$WriteRef$6$to'@1|)) (= inline$$WritebackToReference$5$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) (and (=> (= (ControlFlow 0 204069) 204161) inline$$WritebackToReference$5$anon3_Then_correct) (=> (= (ControlFlow 0 204069) 204105) inline$$WritebackToReference$5$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 203932) 204069)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct@@0  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3@@0 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (= (ControlFlow 0 206691) 204069)) inline$$WritebackToReference$5$anon0_correct)))
(let ((inline$$WriteRef$6$anon0_correct  (=> (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$14$dst@1) (|p#$Mutation| inline$$BorrowField$14$dst@1) inline$$Sub$2$dst@2)) (and (=> (= (ControlFlow 0 203918) 206691) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct@@0) (=> (= (ControlFlow 0 203918) 203932) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct@@0)))))
(let ((inline$$BorrowField$14$anon0_correct  (=> (= inline$$BorrowField$14$p@1 (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (=> (and (and (= inline$$BorrowField$14$size@1 (|size#$Path| inline$$BorrowField$14$p@1)) (= inline$$BorrowField$14$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$14$p@1) inline$$BorrowField$14$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$14$size@1 1)))) (and (= inline$$BorrowField$14$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) inline$$BorrowField$14$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 203859) 203918))) inline$$WriteRef$6$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@0  (=> (and (not $abort_flag@19) (= (ControlFlow 0 203865) 203859)) inline$$BorrowField$14$anon0_correct)))
(let ((inline$$Sub$2$anon3_Then$1_correct  (=> (= $abort_code@27@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@19 true) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@0)) (and (=> (= (ControlFlow 0 203729) 206695) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@0) (=> (= (ControlFlow 0 203729) 203865) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@0))))))
(let ((inline$$Sub$2$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0)) (= (ControlFlow 0 203727) 203729)) inline$$Sub$2$anon3_Then$1_correct)))
(let ((inline$$Sub$2$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) (|i#$Integer| inline$$ReadRef$13$v@1)) (=> (and (and (= inline$$Sub$2$dst@1 ($Integer (- (|i#$Integer| inline$$ReadRef$13$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0)))) (= $abort_code@27@@0 $abort_code@25@@0)) (and (= $abort_flag@19 $abort_flag@18@@0) (= inline$$Sub$2$dst@2 inline$$Sub$2$dst@1))) (and (=> (= (ControlFlow 0 203675) 206695) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@0) (=> (= (ControlFlow 0 203675) 203865) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@0))))))
(let ((inline$$Sub$2$Entry_correct  (and (=> (= (ControlFlow 0 203649) (- 0 388909)) true) (and (=> (= (ControlFlow 0 203649) 203727) inline$$Sub$2$anon3_Then_correct) (=> (= (ControlFlow 0 203649) 203675) inline$$Sub$2$anon3_Else_correct)))))
(let ((inline$$ReadRef$13$anon0_correct  (=> (and (= inline$$ReadRef$13$v@1 (|v#$Mutation| inline$$BorrowField$13$dst@1)) (= (ControlFlow 0 203550) 203649)) inline$$Sub$2$Entry_correct)))
(let ((inline$$BorrowField$13$anon0_correct  (=> (= inline$$BorrowField$13$p@1 (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (=> (and (and (= inline$$BorrowField$13$size@1 (|size#$Path| inline$$BorrowField$13$p@1)) (= inline$$BorrowField$13$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$13$p@1) inline$$BorrowField$13$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$13$size@1 1)))) (and (= inline$$BorrowField$13$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) inline$$BorrowField$13$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 203512) 203550))) inline$$ReadRef$13$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Ge$2$dst@1) (= (ControlFlow 0 203564) 203512)) inline$$BorrowField$13$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@0  (=> (= $abort_code@28 $abort_code@26@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 |inline$$WritebackToGlobal$2$m'@2@@0|) (= (ControlFlow 0 203346) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 203344) 203346)) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct@@0  (=> (= (ControlFlow 0 203354) 203346) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@0  (and (=> (= (ControlFlow 0 203338) (- 0 388530)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@14 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@14) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@14 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@14)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@34)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@14))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@14 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@14)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@15 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@15 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@15)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@35)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@15))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@15 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@15))))))))))))))))))))) (and (=> (= (ControlFlow 0 203338) (- 0 388654)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@36 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@36) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@36)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@9)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@36)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@36)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@37 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@37) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@37)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@37)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@37)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 203338) (- 0 388707)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@38 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@38) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@38)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@38)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@9)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@39 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@39) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@39)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@39)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@10))))))))))))))) (=> (= $abort_code@26@@0 (|i#$Integer| call3formal@$ret0@0@@9)) (and (=> (= (ControlFlow 0 203338) 203354) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct@@0) (=> (= (ControlFlow 0 203338) 203344) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct@@0)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@0| $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 203013) 203338)) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@0))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@0)) (= inline$$WritebackToGlobal$2$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0 inline$$WritebackToGlobal$2$v@1@@0)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@0| |inline$$WritebackToGlobal$2$m'@1@@0|) (= (ControlFlow 0 203067) 203338))) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@0)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$2$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (and (=> (= (ControlFlow 0 203003) 203067) inline$$WritebackToGlobal$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 203003) 203013) inline$$WritebackToGlobal$2$anon3_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct@@0  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@16 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@16 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@16)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@40)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@16))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@16 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@16))))))))))))))))))))) (= (ControlFlow 0 203073) 203003)) inline$$WritebackToGlobal$2$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct  (and (=> (= (ControlFlow 0 202756) (- 0 388251)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 202756) 203073) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$4$$after@0 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (= (ControlFlow 0 202708) 202756)) inline$$Diem_CurrencyInfo_$pack_ref$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Ge$2$dst@1)) (= (ControlFlow 0 202760) 202708)) inline$$Diem_CurrencyInfo_$pack_ref$4$Entry_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct@@0  (=> (not $abort_flag@18@@0) (and (=> (= (ControlFlow 0 202633) 203564) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct@@0) (=> (= (ControlFlow 0 202633) 202760) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct@@0  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t36@1@@0 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18@@0)) (and (=> $abort_flag@18@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 202627) 206715) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct@@0) (=> (= (ControlFlow 0 202627) 202633) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct@@0)))))
(let ((inline$$Ge$2$anon0_correct  (=> (and (= inline$$Ge$2$dst@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$12$v@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0)))) (= (ControlFlow 0 202615) 202627)) inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct@@0)))
(let ((inline$$Ge$2$Entry_correct  (and (=> (= (ControlFlow 0 202601) (- 0 388141)) true) (=> (= (ControlFlow 0 202601) 202615) inline$$Ge$2$anon0_correct))))
(let ((inline$$ReadRef$12$anon0_correct  (=> (and (= inline$$ReadRef$12$v@1 (|v#$Mutation| inline$$BorrowField$12$dst@1)) (= (ControlFlow 0 202543) 202601)) inline$$Ge$2$Entry_correct)))
(let ((inline$$BorrowField$12$anon0_correct  (=> (= inline$$BorrowField$12$p@1 (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (=> (and (and (= inline$$BorrowField$12$size@1 (|size#$Path| inline$$BorrowField$12$p@1)) (= inline$$BorrowField$12$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$12$p@1) inline$$BorrowField$12$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$12$size@1 1)))) (and (= inline$$BorrowField$12$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|) inline$$BorrowField$12$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 202505) 202543))) inline$$ReadRef$12$anon0_correct))))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (=> (and (= |inline$$WritebackToReference$4$dst'@2| inline$$BorrowGlobal$1$dst@2@@0) (= (ControlFlow 0 202289) 202505)) inline$$BorrowField$12$anon0_correct))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$5$to'@1|))))) (and (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|) (= (ControlFlow 0 202345) 202505))) inline$$BorrowField$12$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) (and (=> (= (ControlFlow 0 202253) 202345) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 202253) 202289) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 202116) 202253)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct@@0  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 206741) 202253)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$11$dst@1) (|p#$Mutation| inline$$BorrowField$11$dst@1) inline$$Sub$1$dst@2@@0)) (and (=> (= (ControlFlow 0 202102) 206741) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct@@0) (=> (= (ControlFlow 0 202102) 202116) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct@@0)))))
(let ((inline$$BorrowField$11$anon0_correct  (=> (= inline$$BorrowField$11$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$11$size@1 (|size#$Path| inline$$BorrowField$11$p@1)) (= inline$$BorrowField$11$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$11$p@1) inline$$BorrowField$11$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$11$size@1 1)))) (and (= inline$$BorrowField$11$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$11$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 202043) 202102))) inline$$WriteRef$5$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@0  (=> (and (not $abort_flag@17@@0) (= (ControlFlow 0 202049) 202043)) inline$$BorrowField$11$anon0_correct)))
(let ((inline$$Sub$1$anon3_Then$1_correct@@0  (=> (= $abort_flag@17@@0 true) (=> (and (= $abort_code@24@@0 $EXEC_FAILURE_CODE) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@0@@0)) (and (=> (= (ControlFlow 0 201913) 206745) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@0) (=> (= (ControlFlow 0 201913) 202049) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@0))))))
(let ((inline$$Sub$1$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$11$v@1) (|i#$Integer| inline$$CastU128$1$dst@1@@0)) (= (ControlFlow 0 201911) 201913)) inline$$Sub$1$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$1$anon3_Else_correct@@0  (=> (<= (|i#$Integer| inline$$CastU128$1$dst@1@@0) (|i#$Integer| inline$$ReadRef$11$v@1)) (=> (and (and (= inline$$Sub$1$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$11$v@1) (|i#$Integer| inline$$CastU128$1$dst@1@@0)))) (= $abort_flag@17@@0 $abort_flag@16@@0)) (and (= $abort_code@24@@0 $abort_code@23@@0) (= inline$$Sub$1$dst@2@@0 inline$$Sub$1$dst@1@@0))) (and (=> (= (ControlFlow 0 201859) 206745) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@0) (=> (= (ControlFlow 0 201859) 202049) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@0))))))
(let ((inline$$Sub$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 201833) (- 0 387721)) true) (and (=> (= (ControlFlow 0 201833) 201911) inline$$Sub$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 201833) 201859) inline$$Sub$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@0  (=> (and (not $abort_flag@16@@0) (= (ControlFlow 0 201919) 201833)) inline$$Sub$1$Entry_correct@@0)))
(let ((inline$$CastU128$1$anon3_Then$1_correct@@0  (=> (= $abort_code@23@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@16@@0 true) (= inline$$CastU128$1$dst@1@@0 inline$$CastU128$1$dst@0@@0)) (and (=> (= (ControlFlow 0 201736) 206765) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@0) (=> (= (ControlFlow 0 201736) 201919) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@0))))))
(let ((inline$$CastU128$1$anon3_Then_correct@@0  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) $MAX_U128) (= (ControlFlow 0 201734) 201736)) inline$$CastU128$1$anon3_Then$1_correct@@0)))
(let ((inline$$CastU128$1$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0)) (= $abort_code@23@@0 $abort_code@21@@0)) (and (= $abort_flag@16@@0 $abort_flag@15@@0) (= inline$$CastU128$1$dst@1@@0 inline$$Diem_Diem_unpack$0$value@1@@0))) (and (=> (= (ControlFlow 0 201684) 206765) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@0) (=> (= (ControlFlow 0 201684) 201919) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@0)))))
(let ((inline$$CastU128$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 201670) (- 0 387649)) true) (and (=> (= (ControlFlow 0 201670) 201734) inline$$CastU128$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 201670) 201684) inline$$CastU128$1$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$11$anon0_correct  (=> (and (= inline$$ReadRef$11$v@1 (|v#$Mutation| inline$$BorrowField$10$dst@1)) (= (ControlFlow 0 201589) 201670)) inline$$CastU128$1$Entry_correct@@0)))
(let ((inline$$BorrowField$10$anon0_correct  (=> (= inline$$BorrowField$10$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$10$size@1 (|size#$Path| inline$$BorrowField$10$p@1)) (= inline$$BorrowField$10$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$10$p@1) inline$$BorrowField$10$size@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$10$size@1 1)))) (and (= inline$$BorrowField$10$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$10$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 201551) 201589))) inline$$ReadRef$11$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1@@0) (= (ControlFlow 0 201603) 201551)) inline$$BorrowField$10$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@0  (=> (= $abort_code@28 $abort_code@22@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 201385) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 201383) 201385)) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct@@0  (=> (= (ControlFlow 0 201393) 201385) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct@@0  (=> (= $abort_code@22@@0 (|i#$Integer| call3formal@$ret0@0@@10)) (and (=> (= (ControlFlow 0 201377) 201393) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct@@0) (=> (= (ControlFlow 0 201377) 201383) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@0  (and (=> (= (ControlFlow 0 201367) (- 0 387483)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 201367) 201377) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 201319) 201367)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1@@0)) (= (ControlFlow 0 201371) 201319)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct@@0  (=> (not $abort_flag@15@@0) (and (=> (= (ControlFlow 0 201244) 201603) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct@@0) (=> (= (ControlFlow 0 201244) 201371) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct@@0  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t28@1@@0 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@15@@0)) (and (=> $abort_flag@15@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@15@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 201238) 206785) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct@@0) (=> (= (ControlFlow 0 201238) 201244) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct@@0)))))
(let ((inline$$Ge$1$anon0_correct@@0  (=> (and (= inline$$Ge$1$dst@1@@0 ($Boolean (>= (|i#$Integer| inline$$ReadRef$10$v@1) (|i#$Integer| inline$$CastU128$0$dst@1@@0)))) (= (ControlFlow 0 201226) 201238)) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct@@0)))
(let ((inline$$Ge$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 201212) (- 0 387373)) true) (=> (= (ControlFlow 0 201212) 201226) inline$$Ge$1$anon0_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@0  (=> (and (not $abort_flag@14@@0) (= (ControlFlow 0 201232) 201212)) inline$$Ge$1$Entry_correct@@0)))
(let ((inline$$CastU128$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@14@@0 true) (=> (and (= $abort_code@20@@0 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1@@0 inline$$CastU128$0$dst@0@@0)) (and (=> (= (ControlFlow 0 201156) 206805) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@0) (=> (= (ControlFlow 0 201156) 201232) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@0))))))
(let ((inline$$CastU128$0$anon3_Then_correct@@0  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) $MAX_U128) (= (ControlFlow 0 201154) 201156)) inline$$CastU128$0$anon3_Then$1_correct@@0)))
(let ((inline$$CastU128$0$anon3_Else_correct@@0  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0)) (= $abort_flag@14@@0 $abort_flag@13@@0)) (and (= $abort_code@20@@0 $abort_code@19@@0) (= inline$$CastU128$0$dst@1@@0 inline$$Diem_Diem_unpack$0$value@1@@0))) (and (=> (= (ControlFlow 0 201104) 206805) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@0) (=> (= (ControlFlow 0 201104) 201232) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@0)))))
(let ((inline$$CastU128$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 201090) (- 0 387301)) true) (and (=> (= (ControlFlow 0 201090) 201154) inline$$CastU128$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 201090) 201104) inline$$CastU128$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$10$anon0_correct  (=> (and (= inline$$ReadRef$10$v@1 (|v#$Mutation| inline$$BorrowField$9$dst@1@@0)) (= (ControlFlow 0 201009) 201090)) inline$$CastU128$0$Entry_correct@@0)))
(let ((inline$$BorrowField$9$anon0_correct@@0  (=> (= inline$$BorrowField$9$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$9$size@1@@0 (|size#$Path| inline$$BorrowField$9$p@1@@0)) (= inline$$BorrowField$9$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1@@0) inline$$BorrowField$9$size@1@@0 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$9$size@1@@0 1)))) (and (= inline$$BorrowField$9$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$9$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 200971) 201009))) inline$$ReadRef$10$anon0_correct))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 200813) 200971)) inline$$BorrowField$9$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$1$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 200807) 200813)) inline$$Diem_CurrencyInfo_$unpack_ref$1$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@0  (=> (and (not $abort_flag@13@@0) (= (ControlFlow 0 200817) 200807)) inline$$Diem_CurrencyInfo_$unpack_ref$1$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@0  (=> (= $abort_code@19@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@13@@0 true) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@0@@0)) (and (=> (= (ControlFlow 0 200767) 206825) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@0) (=> (= (ControlFlow 0 200767) 200817) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$BorrowGlobal$1$ta@0@@0 inline$$BorrowGlobal$1$a@1@@0)) (= (ControlFlow 0 200765) 200767)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$BorrowGlobal$1$ta@0@@0 inline$$BorrowGlobal$1$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0@@0 inline$$BorrowGlobal$1$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) inline$$BorrowGlobal$1$ta@0@@0 inline$$BorrowGlobal$1$a@1@@0))) (= $abort_code@19@@0 $abort_code@18@@0)) (and (= $abort_flag@13@@0 $abort_flag@12@@0) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@1@@0))) (and (=> (= (ControlFlow 0 200713) 206825) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@0) (=> (= (ControlFlow 0 200713) 200817) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@0  (=> (= inline$$BorrowGlobal$1$a@1@@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@0)) (and (=> (= (ControlFlow 0 200683) 200765) inline$$BorrowGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 200683) 200713) inline$$BorrowGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@0  (=> (= inline$$BorrowGlobal$1$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 200677) (- 0 387088)) true) (=> (= (ControlFlow 0 200677) 200683) inline$$BorrowGlobal$1$anon0_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@0  (=> (and (not $abort_flag@12@@0) (= (ControlFlow 0 200773) 200677)) inline$$BorrowGlobal$1$Entry_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@0  (=> (and (and $abort_flag@12@@0 (= $abort_code@28 $abort_code@18@@0)) (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 206845) 199737))) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 200534) 206845) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@0) (=> (= (ControlFlow 0 200534) 200773) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@0)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 200544) 206845) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@0) (=> (= (ControlFlow 0 200544) 200773) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@0))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct@@0  (=> (and (not $abort_flag@12@@0) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 200528) 200544) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 200528) 200534) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct@@0  (=> (and (not $abort_flag@12@@0) (= (ControlFlow 0 200558) 200528)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@0  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12@@0) (=> (and (=> $abort_flag@12@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@12@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 200423) 206849) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct@@0) (=> (= (ControlFlow 0 200423) 200558) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct@@0))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 200421) 200423)) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct@@0  (=> (= (ControlFlow 0 206873) 200423) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@0)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct@@0  (=> (and ((_ is $Vector) call4formal@$ret0@0@@2) (= inline$$Diem_Diem_unpack$0$value@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@0) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@0) $MAX_U64)) (and (=> (= (ControlFlow 0 200407) 206873) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct@@0) (=> (= (ControlFlow 0 200407) 200421) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct@@0))))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$ReadRef$7$v@1@@0) (= (ControlFlow 0 200316) 200407)) inline$$Diem_Diem_unpack$0$anon0_correct@@0))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) ($Local 12)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|) 0 inline$$ReadRef$7$v@1@@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 200342) 200407))) inline$$Diem_Diem_unpack$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0))) (= |inline$$WritebackToReference$3$dst'@2@@0| inline$$BorrowLoc$2$dst@1)) (and (=> (= (ControlFlow 0 200161) 200342) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 200161) 200316) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$2$dst@1) (|l#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@0 inline$$WritebackToReference$3$srcPath@1@@0)) (and (= |inline$$WritebackToReference$3$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$WritebackToReference$3$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$2$dst@1) (|v#$Mutation| |inline$$WriteRef$4$to'@1@@0|)))) (= |inline$$WritebackToReference$3$dst'@2@@0| |inline$$WritebackToReference$3$dst'@1@@0|))) (and (=> (= (ControlFlow 0 200217) 200342) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 200217) 200316) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$3$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$3$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$4$to'@1@@0|)) (= inline$$WritebackToReference$3$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$2$dst@1))) (and (=> (= (ControlFlow 0 200125) 200217) inline$$WritebackToReference$3$anon3_Then_correct@@0) (=> (= (ControlFlow 0 200125) 200161) inline$$WritebackToReference$3$anon3_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 199988) 200125)) inline$$WritebackToReference$3$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct@@0  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def$0$info@0@@0)) (= (ControlFlow 0 206883) 200125)) inline$$WritebackToReference$3$anon0_correct@@0)))
(let ((inline$$WriteRef$4$anon0_correct@@0  (=> (= |inline$$WriteRef$4$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1@@0) (|p#$Mutation| inline$$BorrowField$8$dst@1@@0) call5formal@$ret1@0@@0)) (and (=> (= (ControlFlow 0 199974) 206883) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct@@0) (=> (= (ControlFlow 0 199974) 199988) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct@@0  (=> (and (not $abort_flag@11@@0) (= (ControlFlow 0 199980) 199974)) inline$$WriteRef$4$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct@@0  (and (=> (= (ControlFlow 0 199917) (- 0 386594)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11@@0) (=> $abort_flag@11@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@11@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$9$v@1)) $Diem_Diem_value))))) (=> (not $abort_flag@11@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@2) (let ((va@@112 (|v#$Vector| call4formal@$ret0@0@@2)))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@2)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@0) (let ((va@@113 (|v#$Vector| call5formal@$ret1@0@@0)))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 199917) 206887) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct@@0) (=> (= (ControlFlow 0 199917) 199980) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct@@0)))))))
(let ((inline$$ReadRef$9$anon0_correct  (=> (and (= inline$$ReadRef$9$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1@@0)) (= (ControlFlow 0 199905) 199917)) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct@@0)))
(let ((inline$$BorrowField$8$anon0_correct@@0  (=> (= inline$$BorrowField$8$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$8$size@1@@0 (|size#$Path| inline$$BorrowField$8$p@1@@0)) (= inline$$BorrowField$8$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1@@0) inline$$BorrowField$8$size@1@@0 $Diem_Preburn_to_burn) (+ inline$$BorrowField$8$size@1@@0 1)))) (and (= inline$$BorrowField$8$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$8$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 199867) 199905))) inline$$ReadRef$9$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Gt$1$dst@1) (= (ControlFlow 0 199873) 199867)) inline$$BorrowField$8$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@0  (=> (= $abort_code@28 $abort_code@16@@0) (=> (and (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 199731) 199737)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 199729) 199731)) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct@@0  (=> (= (ControlFlow 0 199745) 199731) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Gt$1$dst@1)) (= $abort_code@16@@0 (|i#$Integer| call3formal@$ret0@0@@11))) (and (=> (= (ControlFlow 0 199723) 199745) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct@@0) (=> (= (ControlFlow 0 199723) 199729) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct@@0  (=> (not $abort_flag@10@@0) (and (=> (= (ControlFlow 0 199711) 199873) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct@@0) (=> (= (ControlFlow 0 199711) 199723) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct@@0  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t19@1@@0 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10@@0)) (and (=> $abort_flag@10@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@10@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@11) (>= (|i#$Integer| call3formal@$ret0@0@@11) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@11) $MAX_U64))) (and (=> (= (ControlFlow 0 199705) 206907) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct@@0) (=> (= (ControlFlow 0 199705) 199711) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct@@0)))))
(let ((inline$$Gt$1$anon0_correct  (=> (and (= inline$$Gt$1$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$3$dst@1) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@0)))) (= (ControlFlow 0 199693) 199705)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct@@0)))
(let ((inline$$Gt$1$Entry_correct  (and (=> (= (ControlFlow 0 199679) (- 0 386387)) true) (=> (= (ControlFlow 0 199679) 199693) inline$$Gt$1$anon0_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct@@0  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@0 ($Integer 0)) (= (ControlFlow 0 199699) 199679)) inline$$Gt$1$Entry_correct)))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (and (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$8$v@1@@0)) $Diem_Diem_value)) (= (ControlFlow 0 199625) 199699)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct@@0  (and (=> (= (ControlFlow 0 199631) (- 0 386350)) true) (=> (= (ControlFlow 0 199631) 199625) inline$$GetFieldFromValue$3$anon0_correct))))
(let ((inline$$ReadRef$8$anon0_correct@@0  (=> (and (= inline$$ReadRef$8$v@1@@0 (|v#$Mutation| inline$$BorrowField$7$dst@1@@0)) (= (ControlFlow 0 199565) 199631)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct@@0)))
(let ((inline$$BorrowField$7$anon0_correct@@0  (=> (= inline$$BorrowField$7$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$2$dst@1)) (=> (and (and (= inline$$BorrowField$7$size@1@@0 (|size#$Path| inline$$BorrowField$7$p@1@@0)) (= inline$$BorrowField$7$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1@@0) inline$$BorrowField$7$size@1@@0 $Diem_Preburn_to_burn) (+ inline$$BorrowField$7$size@1@@0 1)))) (and (= inline$$BorrowField$7$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$2$dst@1) inline$$BorrowField$7$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$2$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 199527) 199565))) inline$$ReadRef$8$anon0_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct@@0  (=> (and (not $abort_flag@9@@0) (= (ControlFlow 0 199579) 199527)) inline$$BorrowField$7$anon0_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct@@0  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@0) (=> $abort_flag@9@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@9@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@14@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@9@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@8) (let ((va@@114 (|v#$Vector| call3formal@$ret0@0@@8)))
(let ((l@@114 (|l#$ValueArray| va@@114)))
 (and (and (<= 0 l@@114) (<= l@@114 $MAX_U64)) (forall ((x@@114 Int) ) (!  (=> (or (< x@@114 0) (>= x@@114 l@@114)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114))
)))))) (forall (($$0@@36 Int) ) (!  (=> (and (>= $$0@@36 0) (< $$0@@36 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@36)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@36)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@36)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@36))
)))) (and (=> (= (ControlFlow 0 199369) 206927) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct@@0) (=> (= (ControlFlow 0 199369) 199579) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct@@0)))))
(let ((inline$$BorrowLoc$2$anon0_correct  (=> (and (= inline$$BorrowLoc$2$dst@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$7$v@1@@0)) (= (ControlFlow 0 199361) 199369)) inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct@@0)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 199243) 199361)) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@0  (=> (= (ControlFlow 0 206951) 199361) inline$$BorrowLoc$2$anon0_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 199235) 206951) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@0) (=> (= (ControlFlow 0 199235) 199243) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@0  (and (=> (= (ControlFlow 0 206959) 206951) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@0) (=> (= (ControlFlow 0 206959) 199243) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 199227) 206959) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@0) (=> (= (ControlFlow 0 199227) 199235) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct@@0  (and (=> (= (ControlFlow 0 206967) 206959) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@0) (=> (= (ControlFlow 0 206967) 199235) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@0))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct@@0  (=> (not $abort_flag@8@@0) (and (=> (= (ControlFlow 0 199221) 206967) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct@@0) (=> (= (ControlFlow 0 199221) 199227) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct@@0)))))
(let ((inline$$Diem_burn_with_resource_cap_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$7$v@1@@0) (let ((va@@115 (|v#$Vector| inline$$ReadRef$7$v@1@@0)))
(let ((l@@115 (|l#$ValueArray| va@@115)))
 (and (and (<= 0 l@@115) (<= l@@115 $MAX_U64)) (forall ((x@@115 Int) ) (!  (=> (or (< x@@115 0) (>= x@@115 l@@115)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn)) (let ((va@@116 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn))))
(let ((l@@116 (|l#$ValueArray| va@@116)))
 (and (and (<= 0 l@@116) (<= l@@116 $MAX_U64)) (forall ((x@@116 Int) ) (!  (=> (or (< x@@116 0) (>= x@@116 l@@116)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$7$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) preburn_address@@0)) (=> (and (and (and (and (and ((_ is $Vector) capability) (let ((va@@117 (|v#$Vector| capability)))
(let ((l@@117 (|l#$ValueArray| va@@117)))
 (and (and (<= 0 l@@117) (<= l@@117 $MAX_U64)) (forall ((x@@117 Int) ) (!  (=> (or (< x@@117 0) (>= x@@117 l@@117)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117))
)))))) (= (|l#$ValueArray| (|v#$Vector| capability)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| capability)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 206973) 199221)) inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct@@0))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon31_Else$2_correct  (and (=> (= (ControlFlow 0 206981) (- 0 385868)) true) (=> (= (ControlFlow 0 206981) 206973) inline$$Diem_burn_with_resource_cap_$direct_intra$0$anon0_correct))))
(let ((inline$$ReadRef$7$anon0_correct@@0  (=> (and (= inline$$ReadRef$7$v@1@@0 (|v#$Mutation| |inline$$WriteRef$3$to'@1@@0|)) (= (ControlFlow 0 196546) 206981)) inline$$Diem_burn_now_$def_verify$0$anon31_Else$2_correct)))
(let ((inline$$WriteRef$3$anon0_correct@@0  (=> (and (= |inline$$WriteRef$3$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@0) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@0) inline$$Diem_preburn_with_resource_$def$0$$ret0@2)) (= (ControlFlow 0 196508) 196546)) inline$$ReadRef$7$anon0_correct@@0)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@8@@0) (= (ControlFlow 0 196514) 196508)) inline$$WriteRef$3$anon0_correct@@0)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon31_Then_correct  (=> (and (and $abort_flag@8@@0 (= $abort_code@30 $abort_code@13@@0)) (and (= $Diem_CurrencyInfo_$memory@5@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 207199) 188212))) inline$$Diem_burn_now_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon62_correct  (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@0|) (= $abort_code@13@@0 $abort_code@11@@0)) (and (= $abort_flag@8@@0 $abort_flag@7@@0) (= $Diem_CurrencyInfo_$memory@1@@0 $Diem_CurrencyInfo_$memory@0@@0))) (and (=> (= (ControlFlow 0 194696) 207199) inline$$Diem_burn_now_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 194696) 196514) inline$$Diem_burn_now_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 194694) 194696)) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 194704) 194696) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct  (and (=> (= (ControlFlow 0 196209) (- 0 385365)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@0 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 196209) (- 0 385489)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 196209) (- 0 385542)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@0 |inline$$WritebackToGlobal$1$m'@2@@0|) (and (=> (= (ControlFlow 0 196209) 194704) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 196209) 194694) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 195888) 196209)) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 195942) 196209))) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (and (=> (= (ControlFlow 0 195878) 195942) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 195878) 195888) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@1 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 195948) 195878)) inline$$WritebackToGlobal$1$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@0  (and (=> (= (ControlFlow 0 195631) (- 0 385083)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 195631) 195948) inline$$Diem_preburn_with_resource_$def$0$anon60$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (= (ControlFlow 0 195583) 195631)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$1$dst'@2@@0|) (= (ControlFlow 0 195452) 195583)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0)) (= |inline$$WritebackToReference$2$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$WritebackToReference$2$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$2$dst'@1@@0|) (= (ControlFlow 0 195508) 195583))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (= inline$$WritebackToReference$2$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (and (=> (= (ControlFlow 0 195416) 195508) inline$$WritebackToReference$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 195416) 195452) inline$$WritebackToReference$2$anon3_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 195279) 195416)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 196219) 195416)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1@@0) (|p#$Mutation| inline$$BorrowField$6$dst@1@@0) inline$$ReadRef$6$v@1@@0)) (and (=> (= (ControlFlow 0 195265) 196219) inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 195265) 195279) inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 195271) 195265)) inline$$WriteRef$2$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct  (and (=> (= (ControlFlow 0 194684) (- 0 384429)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@2 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@3 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 194684) (- 0 384553)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 194684) (- 0 384606)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (and (=> (= (ControlFlow 0 194684) 194704) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 194684) 194694) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@0| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 194363) 194684)) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|) (= (ControlFlow 0 194417) 194684))) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 194353) 194417) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 194353) 194363) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@4 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 194423) 194353)) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 194106) (- 0 384147)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 194106) 194423) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 194058) 194106)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@1)) (= (ControlFlow 0 194110) 194058)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$Abort_correct  (=> (= inline$$Diem_preburn_with_resource_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 inline$$Diem_preburn_with_resource_$def$0$$ret0@1) (= $abort_code@13@@0 $abort_code@12@@0)) (and (= $abort_flag@8@@0 true) (= $Diem_CurrencyInfo_$memory@1@@0 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 191277) 207199) inline$$Diem_burn_now_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 191277) 196514) inline$$Diem_burn_now_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon13_correct  (=> (and (= $abort_code@12@@0 $abort_code@3@@5) (= (ControlFlow 0 196395) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 196393) 196395)) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 196403) 196395) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct  (=> $abort_flag@1@@6 (and (=> (= (ControlFlow 0 196387) 196403) inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 196387) 196393) inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon21_correct  (=> (and (= $abort_code@12@@0 $abort_code@5@@2) (= (ControlFlow 0 196375) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 196373) 196375)) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 196383) 196375) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct  (=> $abort_flag@2@@5 (and (=> (= (ControlFlow 0 196367) 196383) inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 196367) 196373) inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon27_correct  (=> (and (= $abort_code@12@@0 $abort_code@6@@2) (= (ControlFlow 0 196345) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 196343) 196345)) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 196353) 196345) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct  (=> $abort_flag@3@@3 (and (=> (= (ControlFlow 0 196337) 196353) inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 196337) 196343) inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon33_correct  (=> (and (= $abort_code@12@@0 $abort_code@7@@2) (= (ControlFlow 0 196321) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 196319) 196321)) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 196329) 196321) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct  (=> $abort_flag@4@@3 (and (=> (= (ControlFlow 0 196313) 196329) inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 196313) 196319) inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon37_correct  (=> (and (= $abort_code@12@@0 $abort_code@8@@1) (= (ControlFlow 0 196301) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 196299) 196301)) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 196309) 196301) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct  (=> $abort_flag@5@@2 (and (=> (= (ControlFlow 0 196293) 196309) inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 196293) 196299) inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon41_correct  (=> (and (= $abort_code@12@@0 $abort_code@9@@1) (= (ControlFlow 0 196281) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 196279) 196281)) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct  (=> (= (ControlFlow 0 196289) 196281) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct  (=> $abort_flag@6@@2 (and (=> (= (ControlFlow 0 196273) 196289) inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 196273) 196279) inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon49_correct  (=> (and (= $abort_code@12@@0 $abort_code@11@@0) (= (ControlFlow 0 196261) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 196259) 196261)) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 196269) 196261) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 196253) 196269) inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 196253) 196259) inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon57_correct  (=> (and (= $abort_code@12@@0 $abort_code@11@@0) (= (ControlFlow 0 196231) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 196229) 196231)) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 196239) 196231) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 196223) 196239) inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 196223) 196229) inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@0  (=> (= inline$$Event_emit_event$0$t@0@@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 195196) 196223) inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 195196) 195271) inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 195206) (- 0 384886)) true) (=> (= (ControlFlow 0 195206) 195196) inline$$Event_emit_event$0$Entry_correct@@0))))
(let ((inline$$ReadRef$6$anon0_correct@@0  (=> (and (= inline$$ReadRef$6$v@1@@0 (|v#$Mutation| inline$$BorrowField$6$dst@1@@0)) (= (ControlFlow 0 195148) 195206)) inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 195104) 195148)) inline$$ReadRef$6$anon0_correct@@0)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 195110) 195148) inline$$ReadRef$6$anon0_correct@@0)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 195098) 195110) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 195098) 195104) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 195090) 195148)) inline$$ReadRef$6$anon0_correct@@0)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$1$dst@1) (>= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@12) (let ((va@@118 (|v#$Vector| call3formal@$ret0@0@@12)))
(let ((l@@118 (|l#$ValueArray| va@@118)))
 (and (and (<= 0 l@@118) (<= l@@118 $MAX_U64)) (forall ((x@@118 Int) ) (!  (=> (or (< x@@118 0) (>= x@@118 l@@118)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0 0) (< inline$$Diem_PreburnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) inline$$Diem_PreburnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) inline$$Diem_PreburnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) inline$$Diem_PreburnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) inline$$Diem_PreburnEvent_pack$0$$$0))
))) (and ((_ is $Address) preburn_address@@0) (= inline$$Diem_PreburnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$1$dst@1) 1 call3formal@$ret0@0@@12) 2 preburn_address@@0) 3))))) (and (=> (= (ControlFlow 0 195082) 195098) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 195082) 195090) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$6$anon0_correct@@0  (=> (= inline$$BorrowField$6$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$6$size@1@@0 (|size#$Path| inline$$BorrowField$6$p@1@@0)) (= inline$$BorrowField$6$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@0) inline$$BorrowField$6$size@1@@0 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$6$size@1@@0 1)))) (and (= inline$$BorrowField$6$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$6$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 194826) 195082))) inline$$Diem_PreburnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@1) (= (ControlFlow 0 194832) 194826)) inline$$BorrowField$6$anon0_correct@@0)))
(let ((inline$$Not$0$anon0_correct@@1  (=> (= inline$$Not$0$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$5$v@1@@0)))) (and (=> (= (ControlFlow 0 193975) 194832) inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 193975) 194110) inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 193965) (- 0 384108)) true) (=> (= (ControlFlow 0 193965) 193975) inline$$Not$0$anon0_correct@@1))))
(let ((inline$$ReadRef$5$anon0_correct@@0  (=> (and (= inline$$ReadRef$5$v@1@@0 (|v#$Mutation| inline$$BorrowField$5$dst@1@@0)) (= (ControlFlow 0 193917) 193965)) inline$$Not$0$Entry_correct@@1)))
(let ((inline$$BorrowField$5$anon0_correct@@0  (=> (= inline$$BorrowField$5$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$5$size@1@@0 (|size#$Path| inline$$BorrowField$5$p@1@@0)) (= inline$$BorrowField$5$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@0) inline$$BorrowField$5$size@1@@0 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$5$size@1@@0 1)))) (and (= inline$$BorrowField$5$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$5$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 193879) 193917))) inline$$ReadRef$5$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 193663) 193879)) inline$$BorrowField$5$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 193719) 193879))) inline$$BorrowField$5$anon0_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 193627) 193719) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 193627) 193663) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 193490) 193627)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 196249) 193627)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@0) (|p#$Mutation| inline$$BorrowField$4$dst@1@@0) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 193476) 196249) inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 193476) 193490) inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 193417) 193476))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 193423) 193417)) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@7@@0 true) (=> (and (= $abort_code@11@@0 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 193287) 196253) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 193287) 193423) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)) $MAX_U64) (= (ControlFlow 0 193285) 193287)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$4$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (= $abort_flag@7@@0 $abort_flag@6@@2)) (and (= $abort_code@11@@0 $abort_code@9@@1) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 193229) 196253) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 193229) 193423) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 193199) (- 0 383682)) true) (and (=> (= (ControlFlow 0 193199) 193285) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 193199) 193229) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$4$anon0_correct@@0  (=> (and (= inline$$ReadRef$4$v@1@@0 (|v#$Mutation| inline$$BorrowField$3$dst@1@@0)) (= (ControlFlow 0 193092) 193199)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 193054) 193092))) inline$$ReadRef$4$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@0) (= (ControlFlow 0 193106) 193054)) inline$$BorrowField$3$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon46_correct  (=> (and (= $abort_code@12@@0 $abort_code@10@@0) (= (ControlFlow 0 192888) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 192886) 192888)) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 192896) 192888) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct  (=> (= $abort_code@10@@0 (|i#$Integer| call3formal@$ret0@0@@13)) (and (=> (= (ControlFlow 0 192880) 192896) inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 192880) 192886) inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 192870) (- 0 383514)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 192870) 192880) inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 192822) 192870)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@0)) (= (ControlFlow 0 192874) 192822)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct  (=> (not $abort_flag@6@@2) (and (=> (= (ControlFlow 0 192747) 193106) inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 192747) 192874) inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t27@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@2)) (and (=> $abort_flag@6@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 192741) 196273) inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 192741) 192747) inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@0  (=> (and (= inline$$Ge$0$dst@1@@0 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2@@0) (|i#$Integer| inline$$GetFieldFromValue$1$dst@1)))) (= (ControlFlow 0 192729) 192741)) inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 192715) (- 0 383404)) true) (=> (= (ControlFlow 0 192715) 192729) inline$$Ge$0$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@5@@2) (= (ControlFlow 0 192735) 192715)) inline$$Ge$0$Entry_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (= $abort_code@8@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@5@@2 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 192659) 196293) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 192659) 192735) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$3$v@1@@0)) (= (ControlFlow 0 192657) 192659)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (<= (|i#$Integer| inline$$ReadRef$3$v@1@@0) (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1)) (=> (and (and (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$3$v@1@@0)))) (= $abort_code@8@@1 $abort_code@7@@2)) (and (= $abort_flag@5@@2 $abort_flag@4@@3) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 192605) 196293) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 192605) 192735) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 192579) (- 0 383316)) true) (and (=> (= (ControlFlow 0 192579) 192657) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 192579) 192605) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$2$dst@1@@0)) (= (ControlFlow 0 192480) 192579)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 192442) 192480))) inline$$ReadRef$3$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 192494) 192442)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@0  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 192280) 192494)) inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 192274) 192280)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@4@@3) (= (ControlFlow 0 192284) 192274)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@4@@3 true) (=> (and (= $abort_code@7@@2 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 192234) 196313) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 192234) 192284) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 192232) 192234)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0))) (= $abort_flag@4@@3 $abort_flag@3@@3)) (and (= $abort_code@7@@2 $abort_code@6@@2) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 192180) 196313) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 192180) 192284) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@4)) (and (=> (= (ControlFlow 0 192150) 192232) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 192150) 192180) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 192144) (- 0 383091)) true) (=> (= (ControlFlow 0 192144) 192150) inline$$BorrowGlobal$0$anon0_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@3@@3) (= (ControlFlow 0 192240) 192144)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct  (=> $abort_flag@3@@3 (=> (and (= $abort_code@12@@0 $abort_code@6@@2) (= (ControlFlow 0 196333) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 192001) 196333) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 192001) 192240) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@4  (and (=> (= (ControlFlow 0 192011) 196333) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 192011) 192240) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@4  (=> (and (not $abort_flag@3@@3) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@4 ($Address 173345816))) (and (=> (= (ControlFlow 0 191995) 192011) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 191995) 192001) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@4)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@3@@3) (= (ControlFlow 0 192025) 191995)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@4)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@3) (=> $abort_flag@3@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@3@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@6@@2 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@3@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@12) (let ((va@@119 (|v#$Vector| call3formal@$ret0@0@@12)))
(let ((l@@119 (|l#$ValueArray| va@@119)))
 (and (and (<= 0 l@@119) (<= l@@119 $MAX_U64)) (forall ((x@@119 Int) ) (!  (=> (or (< x@@119 0) (>= x@@119 l@@119)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119))
)))))) (forall (($$0@@37 Int) ) (!  (=> (and (>= $$0@@37 0) (< $$0@@37 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) $$0@@37)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) $$0@@37)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) $$0@@37)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@12)) $$0@@37))
)))) (and (=> (= (ControlFlow 0 191890) 196337) inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 191890) 192025) inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@0  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 11))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@0| inline$$ReadRef$0$v@1@@0) (= (ControlFlow 0 191856) 191890)) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@0  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) ($Local 11)) (= |inline$$WritebackToValue$0$vdst'@1@@0| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 inline$$ReadRef$0$v@1@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@0| |inline$$WritebackToValue$0$vdst'@1@@0|) (= (ControlFlow 0 191882) 191890))) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 191701) 191882) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 191701) 191856) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (and (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|)))) (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|))) (and (=> (= (ControlFlow 0 191757) 191882) inline$$WritebackToValue$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 191757) 191856) inline$$WritebackToValue$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 191665) 191757) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 191665) 191701) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 191528) 191665)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def$0$info@0)) (= (ControlFlow 0 196363) 191665)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@0) (|p#$Mutation| inline$$BorrowField$1$dst@1@@0) call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 191514) 196363) inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 191514) 191528) inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct  (=> (and (not $abort_flag@2@@5) (= (ControlFlow 0 191520) 191514)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct  (and (=> (= (ControlFlow 0 191457) (- 0 382481)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@2@@5) (=> $abort_flag@2@@5 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@2@@5 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@5@@2 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@2@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@0)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@120 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@120 (|l#$ValueArray| va@@120)))
 (and (and (<= 0 l@@120) (<= l@@120 $MAX_U64)) (forall ((x@@120 Int) ) (!  (=> (or (< x@@120 0) (>= x@@120 l@@120)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 191457) 196367) inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 191457) 191520) inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct)))))))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 191445) 191457)) inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 191407) 191445))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1) (= (ControlFlow 0 191413) 191407)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon18_correct  (=> (and (= $abort_code@12@@0 $abort_code@4@@4) (= (ControlFlow 0 191271) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 191269) 191271)) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 191285) 191271) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1)) (= $abort_code@4@@4 (|i#$Integer| call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 191263) 191285) inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 191263) 191269) inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct  (=> (not $abort_flag@1@@6) (and (=> (= (ControlFlow 0 191251) 191413) inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 191251) 191263) inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct  (=> (not $abort_flag@0@@6) (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t16@1 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def$0$$t17@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$2$dst@1 inline$$Diem_preburn_with_resource_$def$0$$t16@1)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@6)) (and (=> $abort_flag@1@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@14) (>= (|i#$Integer| call3formal@$ret0@0@@14) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@14) $MAX_U64))) (and (=> (= (ControlFlow 0 191245) 196387) inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 191245) 191251) inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct)))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct  (=> $abort_flag@0@@6 (=> (and (= $abort_code@12@@0 $abort_code@1@@6) (= (ControlFlow 0 196407) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 191189) 196407) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 191189) 191245) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 191199) 196407) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 191199) 191245) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 191173) 191199) inline$$Diem_value_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 191173) 191189) inline$$Diem_value_$def$1$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 191097) 191173)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 191207) 191173) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon0_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 191091) 191207) inline$$Diem_value_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 191091) 191097) inline$$Diem_value_$def$1$anon5_Else_correct)))))
(let ((inline$$Diem_value$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@0) (let ((va@@121 (|v#$Vector| inline$$ReadRef$1$v@1@@0)))
(let ((l@@121 (|l#$ValueArray| va@@121)))
 (and (and (<= 0 l@@121) (<= l@@121 $MAX_U64)) (forall ((x@@121 Int) ) (!  (=> (or (< x@@121 0) (>= x@@121 l@@121)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 191213) 191091)) inline$$Diem_value_$def$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct  (and (=> (= (ControlFlow 0 191221) (- 0 382178)) true) (=> (= (ControlFlow 0 191221) 191213) inline$$Diem_value$1$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 190911) 191221)) inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 190873) 190911))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@0@@6) (= (ControlFlow 0 190925) 190873)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct  (=> $abort_flag@0@@6 (=> (and (= $abort_code@12@@0 $abort_code@1@@6) (= (ControlFlow 0 196411) 191277)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 190681) 196411) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 190681) 190925) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 190691) 196411) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 190691) 190925) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 190665) 190691) inline$$Diem_value_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 190665) 190681) inline$$Diem_value_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 190589) 190665)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 190699) 190665) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@0  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 190583) 190699) inline$$Diem_value_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 190583) 190589) inline$$Diem_value_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$Diem_value$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) coin@@1) (let ((va@@122 (|v#$Vector| coin@@1)))
(let ((l@@122 (|l#$ValueArray| va@@122)))
 (and (and (<= 0 l@@122) (<= l@@122 $MAX_U64)) (forall ((x@@122 Int) ) (!  (=> (or (< x@@122 0) (>= x@@122 l@@122)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 190705) 190583)) inline$$Diem_value_$def$0$anon0_correct@@0)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 11) $EmptyPath inline$$ReadRef$0$v@1@@0)) (= (ControlFlow 0 190415) 190705)) inline$$Diem_value$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 190263) 190415)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 196419) 190415) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 190255) 196419) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 190255) 190263) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct  (and (=> (= (ControlFlow 0 196427) 196419) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 196427) 190263) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 190247) 196427) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 190247) 190255) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 196435) 196427) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 196435) 190255) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon0_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 190241) 196435) inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 190241) 190247) inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$direct_intra$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) coin@@1) (let ((va@@123 (|v#$Vector| coin@@1)))
(let ((l@@123 (|l#$ValueArray| va@@123)))
 (and (and (<= 0 l@@123) (<= l@@123 $MAX_U64)) (forall ((x@@123 Int) ) (!  (=> (or (< x@@123 0) (>= x@@123 l@@123)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@0) (let ((va@@124 (|v#$Vector| inline$$ReadRef$0$v@1@@0)))
(let ((l@@124 (|l#$ValueArray| va@@124)))
 (and (and (<= 0 l@@124) (<= l@@124 $MAX_U64)) (forall ((x@@124 Int) ) (!  (=> (or (< x@@124 0) (>= x@@124 l@@124)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn)) (let ((va@@125 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn))))
(let ((l@@125 (|l#$ValueArray| va@@125)))
 (and (and (<= 0 l@@125) (<= l@@125 $MAX_U64)) (forall ((x@@125 Int) ) (!  (=> (or (< x@@125 0) (>= x@@125 l@@125)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) preburn_address@@0) (= (ControlFlow 0 196441) 190241))) inline$$Diem_preburn_with_resource_$def$0$anon0_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon29_Then$1_correct  (and (=> (= (ControlFlow 0 196449) (- 0 381747)) true) (=> (= (ControlFlow 0 196449) 196441) inline$$Diem_preburn_with_resource_$direct_intra$0$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@0)) (= (ControlFlow 0 188256) 196449)) inline$$Diem_burn_now_$def_verify$0$anon29_Then$1_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon29_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1@@0) (= (ControlFlow 0 188262) 188256)) inline$$ReadRef$0$anon0_correct@@0)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon16_correct  (=> (= $abort_code@30 $abort_code@2@@4) (=> (and (= $Diem_CurrencyInfo_$memory@5@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 188206) 188212)) inline$$Diem_burn_now_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 188204) 188206)) inline$$Diem_burn_now_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 188220) 188206) inline$$Diem_burn_now_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon29_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@0)) (= $abort_code@2@@4 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 188198) 188220) inline$$Diem_burn_now_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 188198) 188204) inline$$Diem_burn_now_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@0@@6) (and (=> (= (ControlFlow 0 188186) 188262) inline$$Diem_burn_now_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 188186) 188198) inline$$Diem_burn_now_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon8$7_correct  (=> (and (and (and (= inline$$Diem_burn_now_$def_verify$0$$t14@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@6)) (and (=> $abort_flag@0@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 188180) 207203) inline$$Diem_burn_now_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 188180) 188186) inline$$Diem_burn_now_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct@@0  (=> (and (= inline$$Gt$0$dst@1@@0 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@5) (|i#$Integer| inline$$Diem_burn_now_$def_verify$0$$t12@1)))) (= (ControlFlow 0 188168) 188180)) inline$$Diem_burn_now_$def_verify$0$anon8$7_correct)))
(let ((inline$$Gt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 188154) (- 0 381612)) true) (=> (= (ControlFlow 0 188154) 188168) inline$$Gt$0$anon0_correct@@0))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon8$6_correct  (=> (and (= inline$$Diem_burn_now_$def_verify$0$$t12@1 ($Integer 0)) (= (ControlFlow 0 188174) 188154)) inline$$Gt$0$Entry_correct@@0)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@5  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) (= (ControlFlow 0 188100) 188174)) inline$$Diem_burn_now_$def_verify$0$anon8$6_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@0  (=> (and (= inline$$BorrowLoc$0$dst@1@@0 ($Mutation ($Local 7) $EmptyPath preburn)) (= (ControlFlow 0 188052) 188100)) inline$$GetFieldFromValue$0$anon0_correct@@5)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 187866) 188052)) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 207227) 188052) inline$$BorrowLoc$0$anon0_correct@@0)))
(let ((inline$$Diem_burn_now_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 187858) 207227) inline$$Diem_burn_now_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 187858) 187866) inline$$Diem_burn_now_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 207235) 207227) inline$$Diem_burn_now_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 207235) 187866) inline$$Diem_burn_now_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon24_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 187850) 207235) inline$$Diem_burn_now_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 187850) 187858) inline$$Diem_burn_now_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon24_Then_correct  (and (=> (= (ControlFlow 0 207243) 207235) inline$$Diem_burn_now_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 207243) 187858) inline$$Diem_burn_now_$def_verify$0$anon25_Else_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon23_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 187842) 207243) inline$$Diem_burn_now_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 187842) 187850) inline$$Diem_burn_now_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon23_Then_correct  (and (=> (= (ControlFlow 0 207251) 207243) inline$$Diem_burn_now_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 207251) 187850) inline$$Diem_burn_now_$def_verify$0$anon24_Else_correct))))
(let ((inline$$Diem_burn_now_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 187836) 207251) inline$$Diem_burn_now_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 187836) 187842) inline$$Diem_burn_now_$def_verify$0$anon23_Else_correct)))))
(let ((anon0$1_correct@@7  (=> (and (forall (($inv_addr@@16 Int) ($inv_tv0@@12 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16)) (let ((va@@126 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))))
(let ((l@@126 (|l#$ValueArray| va@@126)))
 (and (and (<= 0 l@@126) (<= l@@126 $MAX_U64)) (forall ((x@@126 Int) ) (!  (=> (or (< x@@126 0) (>= x@@126 l@@126)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ($inv_tv0@@13 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17)) (let ((va@@127 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))))
(let ((l@@127 (|l#$ValueArray| va@@127)))
 (and (and (<= 0 l@@127) (<= l@@127 $MAX_U64)) (forall ((x@@127 Int) ) (!  (=> (or (< x@@127 0) (>= x@@127 l@@127)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@128 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@128 (|l#$ValueArray| va@@128)))
 (and (and (<= 0 l@@128) (<= l@@128 $MAX_U64)) (forall ((x@@128 Int) ) (!  (=> (or (< x@@128 0) (>= x@@128 l@@128)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code)) (let ((va@@129 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@129 (|l#$ValueArray| va@@129)))
 (and (and (<= 0 l@@129) (<= l@@129 $MAX_U64)) (forall ((x@@129 Int) ) (!  (=> (or (< x@@129 0) (>= x@@129 l@@129)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129))
))))))) (forall (($$0@@38 Int) ) (!  (=> (and (>= $$0@@38 0) (< $$0@@38 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))) $$0@@38)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))) $$0@@38)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))) $$0@@38)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_currency_code))) $$0@@38))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events)) (let ((va@@130 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@130 (|l#$ValueArray| va@@130)))
 (and (and (<= 0 l@@130) (<= l@@130 $MAX_U64)) (forall ((x@@130 Int) ) (!  (=> (or (< x@@130 0) (>= x@@130 l@@130)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@131 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@131 (|l#$ValueArray| va@@131)))
 (and (and (<= 0 l@@131) (<= l@@131 $MAX_U64)) (forall ((x@@131 Int) ) (!  (=> (or (< x@@131 0) (>= x@@131 l@@131)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131))
))))))) (forall (($$0@@39 Int) ) (!  (=> (and (>= $$0@@39 0) (< $$0@@39 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@39)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@39)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@39)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@39))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events)) (let ((va@@132 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@132 (|l#$ValueArray| va@@132)))
 (and (and (<= 0 l@@132) (<= l@@132 $MAX_U64)) (forall ((x@@132 Int) ) (!  (=> (or (< x@@132 0) (>= x@@132 l@@132)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@133 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@133 (|l#$ValueArray| va@@133)))
 (and (and (<= 0 l@@133) (<= l@@133 $MAX_U64)) (forall ((x@@133 Int) ) (!  (=> (or (< x@@133 0) (>= x@@133 l@@133)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133))
))))))) (forall (($$0@@40 Int) ) (!  (=> (and (>= $$0@@40 0) (< $$0@@40 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@40)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@40)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@40)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@40))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@134 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@134 (|l#$ValueArray| va@@134)))
 (and (and (<= 0 l@@134) (<= l@@134 $MAX_U64)) (forall ((x@@134 Int) ) (!  (=> (or (< x@@134 0) (>= x@@134 l@@134)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@135 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@135 (|l#$ValueArray| va@@135)))
 (and (and (<= 0 l@@135) (<= l@@135 $MAX_U64)) (forall ((x@@135 Int) ) (!  (=> (or (< x@@135 0) (>= x@@135 l@@135)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135))
))))))) (forall (($$0@@41 Int) ) (!  (=> (and (>= $$0@@41 0) (< $$0@@41 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@41)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@41)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@41)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@41))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@136 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@136 (|l#$ValueArray| va@@136)))
 (and (and (<= 0 l@@136) (<= l@@136 $MAX_U64)) (forall ((x@@136 Int) ) (!  (=> (or (< x@@136 0) (>= x@@136 l@@136)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@137 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@137 (|l#$ValueArray| va@@137)))
 (and (and (<= 0 l@@137) (<= l@@137 $MAX_U64)) (forall ((x@@137 Int) ) (!  (=> (or (< x@@137 0) (>= x@@137 l@@137)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137))
))))))) (forall (($$0@@42 Int) ) (!  (=> (and (>= $$0@@42 0) (< $$0@@42 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@42)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@42)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@42)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@42))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@138 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@138 (|l#$ValueArray| va@@138)))
 (and (and (<= 0 l@@138) (<= l@@138 $MAX_U64)) (forall ((x@@138 Int) ) (!  (=> (or (< x@@138 0) (>= x@@138 l@@138)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@139 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@139 (|l#$ValueArray| va@@139)))
 (and (and (<= 0 l@@139) (<= l@@139 $MAX_U64)) (forall ((x@@139 Int) ) (!  (=> (or (< x@@139 0) (>= x@@139 l@@139)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139))
))))))) (forall (($$0@@43 Int) ) (!  (=> (and (>= $$0@@43 0) (< $$0@@43 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@43)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@43)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@43)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@43))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@17))
))) (=> (and (and (forall (($inv_addr@@18 Int) ($inv_tv0@@14 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18)) (let ((va@@140 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))))
(let ((l@@140 (|l#$ValueArray| va@@140)))
 (and (and (<= 0 l@@140) (<= l@@140 $MAX_U64)) (forall ((x@@140 Int) ) (!  (=> (or (< x@@140 0) (>= x@@140 l@@140)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn)) (let ((va@@141 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn))))
(let ((l@@141 (|l#$ValueArray| va@@141)))
 (and (and (<= 0 l@@141) (<= l@@141 $MAX_U64)) (forall ((x@@141 Int) ) (!  (=> (or (< x@@141 0) (>= x@@141 l@@141)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@18))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@10 T@$Value) )  (=> ((_ is $Type) coin_type@@10) (|b#$Boolean| ($Boolean (forall ((addr3@@5 T@$Value) )  (=> ((_ is $Address) addr3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| addr3@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@11 T@$Value) )  (=> ((_ is $Type) coin_type@@11) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 207257) 187836))) inline$$Diem_burn_now_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@7  (=> (and (and (and (and ((_ is $Vector) coin@@1) (let ((va@@142 (|v#$Vector| coin@@1)))
(let ((l@@142 (|l#$ValueArray| va@@142)))
 (and (and (<= 0 l@@142) (<= l@@142 $MAX_U64)) (forall ((x@@142 Int) ) (!  (=> (or (< x@@142 0) (>= x@@142 l@@142)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@1)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and (and ((_ is $Vector) preburn) (let ((va@@143 (|v#$Vector| preburn)))
(let ((l@@143 (|l#$ValueArray| va@@143)))
 (and (and (<= 0 l@@143) (<= l@@143 $MAX_U64)) (forall ((x@@143 Int) ) (!  (=> (or (< x@@143 0) (>= x@@143 l@@143)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143))
)))))) (= (|l#$ValueArray| (|v#$Vector| preburn)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn)) (let ((va@@144 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))))
(let ((l@@144 (|l#$ValueArray| va@@144)))
 (and (and (<= 0 l@@144) (<= l@@144 $MAX_U64)) (forall ((x@@144 Int) ) (!  (=> (or (< x@@144 0) (>= x@@144 l@@144)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) ((_ is $Address) preburn_address@@0)) (and (and (and (and (and ((_ is $Vector) capability) (let ((va@@145 (|v#$Vector| capability)))
(let ((l@@145 (|l#$ValueArray| va@@145)))
 (and (and (<= 0 l@@145) (<= l@@145 $MAX_U64)) (forall ((x@@145 Int) ) (!  (=> (or (< x@@145 0) (>= x@@145 l@@145)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145))
)))))) (= (|l#$ValueArray| (|v#$Vector| capability)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| capability)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 187105) 207257))) anon0$1_correct@@7))))
(let ((PreconditionGeneratedEntry_correct@@4  (=> (= (ControlFlow 0 377383) 187105) anon0_correct@@7)))
PreconditionGeneratedEntry_correct@@4))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@15 () T@$TypeValue)
(declare-fun preburn_address@@1 () T@$Value)
(declare-fun $abort_flag@14@@1 () Bool)
(declare-fun $abort_code@21@@1 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@4@@1 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$3$m'@2@@1| () T@$Memory)
(declare-fun $abort_code@19@@1 () Int)
(declare-fun $abort_flag@13@@1 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@2@@1 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1@@1 () T@$Value)
(declare-fun |inline$$WriteRef$4$to'@1@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@1 () T@$Value)
(declare-fun $abort_code@20@@1 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@3@@1 () T@$Memory)
(declare-fun $abort_code@1@@7 () Int)
(declare-fun $abort_flag@0@@7 () Bool)
(declare-fun $abort_code@3@@6 () Int)
(declare-fun $abort_flag@1@@7 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@1| () T@$Value)
(declare-fun $abort_flag@12@@1 () Bool)
(declare-fun $abort_code@17@@1 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@1| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4@@1 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1@@1 () T@$Mutation)
(declare-fun inline$$ReadRef$8$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@1| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@2 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@1 () T@$Value)
(declare-fun $abort_code@18@@1 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@4@@5 () Int)
(declare-fun $abort_flag@2@@6 () Bool)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_flag@3@@4 () Bool)
(declare-fun $abort_code@7@@3 () Int)
(declare-fun $abort_flag@4@@4 () Bool)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun $abort_flag@5@@3 () Bool)
(declare-fun $abort_code@9@@2 () Int)
(declare-fun $abort_flag@6@@3 () Bool)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun $abort_code@11@@1 () Int)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun $abort_code@13@@1 () Int)
(declare-fun $abort_flag@9@@1 () Bool)
(declare-fun $abort_code@14@@1 () Int)
(declare-fun $abort_flag@10@@1 () Bool)
(declare-fun $abort_code@15@@1 () Int)
(declare-fun $abort_flag@11@@1 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@1 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$9$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1@@1 () Int)
(declare-fun inline$$BorrowField$9$p@2@@1 () T@$Path)
(declare-fun inline$$ReadRef$7$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$8$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1@@1 () Int)
(declare-fun inline$$BorrowField$8$p@2@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3@@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1@@1 () Int)
(declare-fun inline$$BorrowField$7$p@2@@1 () T@$Path)
(declare-fun inline$$Sub$1$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1@@1 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@1 () Int)
(declare-fun inline$$BorrowField$6$p@2@@1 () T@$Path)
(declare-fun inline$$Ge$1$dst@1@@1 () T@$Value)
(declare-fun $abort_code@16@@1 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t36@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@1 () Int)
(declare-fun inline$$BorrowField$5$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@1 () Int)
(declare-fun inline$$BorrowField$4$p@2@@1 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1@@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0@@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@1 () Int)
(declare-fun inline$$BorrowField$3$p@2@@1 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@12@@1 () Int)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t28@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1@@1 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0@@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@1 () Int)
(declare-fun inline$$BorrowField$2$p@2@@1 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@5 () T@$Value)
(declare-fun call4formal@$ret0@0@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1@@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$info@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$Gt$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t19@1@@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@6 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun capability@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun inline$$Diem_burn_with_capability_$def_verify$0$$t6@1 () T@$Value)
(declare-fun $abort_code@2@@5 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$Diem_burn_with_capability_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 392411) (let ((anon0$2_correct@@8  (and (=> (= (ControlFlow 0 222079) (- 0 401514)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 222079) (- 0 401544)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 222079) (- 0 401580)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 222079) (- 0 401625)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 222079) (- 0 401670)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14@@1)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14@@1) (and (=> (= (ControlFlow 0 222079) (- 0 401686)) (=> $abort_flag@14@@1 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@14@@1 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 401854)) (=> $abort_flag@14@@1 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@14@@1 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1))))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@21@@1 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 222079) (- 0 402077)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402141)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402205)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402251)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@116 T@$Value) )  (=> ((_ is $Address) addr@@116) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@116))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@116)))))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@117 T@$Value) )  (=> ((_ is $Address) addr@@117) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@117))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@117))))))))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402331)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@118 T@$Value) )  (=> ((_ is $Address) addr@@118) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@118)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@118))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@119 T@$Value) )  (=> ((_ is $Address) addr@@119) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@119)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@119)))))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402399)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@120 T@$Value) )  (=> ((_ is $Address) addr@@120) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@120))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@120)))))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@121 T@$Value) )  (=> ((_ is $Address) addr@@121) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@121))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@121))))))))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402479)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@122 T@$Value) )  (=> ((_ is $Address) addr@@122) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@122)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@122))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@123 T@$Value) )  (=> ((_ is $Address) addr@@123) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@123)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@123)))))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402547)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402593)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@124 T@$Value) )  (=> ((_ is $Address) addr@@124) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@124))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@124)))))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@125 T@$Value) )  (=> ((_ is $Address) addr@@125) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@125))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@125))))))))))))))) (and (=> (= (ControlFlow 0 222079) (- 0 402671)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@126 T@$Value) )  (=> ((_ is $Address) addr@@126) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@126)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@126))))))))))))) (=> (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean (forall ((addr@@127 T@$Value) )  (=> ((_ is $Address) addr@@127) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@127)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@127)))))))))))) (=> (= (ControlFlow 0 222079) (- 0 402737)) (=> (not $abort_flag@14@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@4@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else$2_correct  (and (=> (= (ControlFlow 0 222013) (- 0 401278)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 222013) (- 0 401341)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def_verify$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_capability_$def_verify$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_capability_$def_verify$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$3$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_capability_$def_verify$0$tc_addr@@0))))))))))))))) (=> (= $abort_code@21@@1 $abort_code@19@@1) (=> (and (and (= $abort_flag@14@@1 $abort_flag@13@@1) (= $Diem_CurrencyInfo_$memory@4@@1 $Diem_CurrencyInfo_$memory@2@@1)) (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$3$m'@2@@1|) (= (ControlFlow 0 222013) 222079))) anon0$2_correct@@8))))))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2@@1| $Diem_Preburn_$memory) (= (ControlFlow 0 221807) 222013)) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else$2_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1@@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1@@1)) (= inline$$WritebackToGlobal$3$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$4$to'@1@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$3$ta@1@@1 inline$$WritebackToGlobal$3$a@1@@1) (|v#$Mutation| |inline$$WriteRef$4$to'@1@@1|))) (= |inline$$WritebackToGlobal$3$m'@1@@1| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$3$ta@1@@1 inline$$WritebackToGlobal$3$a@1@@1 inline$$WritebackToGlobal$3$v@1@@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2@@1| |inline$$WritebackToGlobal$3$m'@1@@1|) (= (ControlFlow 0 221861) 222013))) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$3$l@1@@1 (|l#$Mutation| |inline$$WriteRef$4$to'@1@@1|)) (and (=> (= (ControlFlow 0 221797) 221861) inline$$WritebackToGlobal$3$anon3_Then_correct@@1) (=> (= (ControlFlow 0 221797) 221807) inline$$WritebackToGlobal$3$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$4$anon0_correct@@1  (=> (and (= |inline$$WriteRef$4$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@1)) (= (ControlFlow 0 221673) 221797)) inline$$WritebackToGlobal$3$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@13@@1) (= (ControlFlow 0 221679) 221673)) inline$$WriteRef$4$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$Abort_correct  (=> (= $abort_code@21@@1 $abort_code@20@@1) (=> (and (and (= $abort_flag@14@@1 true) (= $Diem_CurrencyInfo_$memory@4@@1 $Diem_CurrencyInfo_$memory@3@@1)) (and (= $Diem_Preburn_$memory@0@@0 $Diem_Preburn_$memory) (= (ControlFlow 0 210920) 222079))) anon0$2_correct@@8))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon7_correct  (=> (= $abort_code@20@@1 $abort_code@1@@7) (=> (and (= $Diem_CurrencyInfo_$memory@3@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 222049) 210920)) inline$$Diem_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 222047) 222049)) inline$$Diem_burn_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 222057) 222049) inline$$Diem_burn_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon21_Then_correct  (=> $abort_flag@0@@7 (and (=> (= (ControlFlow 0 222041) 222057) inline$$Diem_burn_with_capability_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 222041) 222047) inline$$Diem_burn_with_capability_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon15_correct  (=> (= $abort_code@20@@1 $abort_code@3@@6) (=> (and (= $Diem_CurrencyInfo_$memory@3@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 222029) 210920)) inline$$Diem_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 222027) 222029)) inline$$Diem_burn_with_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 222037) 222029) inline$$Diem_burn_with_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@7 (and (=> (= (ControlFlow 0 222021) 222037) inline$$Diem_burn_with_capability_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 222021) 222027) inline$$Diem_burn_with_capability_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon27_Then_correct  (=> (and (and $abort_flag@13@@1 (= $abort_code@20@@1 $abort_code@19@@1)) (and (= $Diem_CurrencyInfo_$memory@3@@1 $Diem_CurrencyInfo_$memory@2@@1) (= (ControlFlow 0 222017) 210920))) inline$$Diem_burn_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@1  (=> (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@1 |inline$$WritebackToValue$0$vdst'@2@@1|) (= $abort_flag@13@@1 $abort_flag@12@@1)) (and (= $abort_code@19@@1 $abort_code@17@@1) (= $Diem_CurrencyInfo_$memory@2@@1 $Diem_CurrencyInfo_$memory@0@@1))) (and (=> (= (ControlFlow 0 219771) 222017) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 219771) 221679) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 219769) 219771)) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@1  (=> (= (ControlFlow 0 219779) 219771) inline$$Diem_burn_with_resource_cap_$def$0$anon82_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@1  (and (=> (= (ControlFlow 0 221284) (- 0 400560)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@17 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@17) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@17 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@17)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@41)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@17))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@17 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@17)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@18 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@18) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@18 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@18)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@42)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@18))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@18 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@18))))))))))))))))))))) (and (=> (= (ControlFlow 0 221284) (- 0 400684)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@43 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@43) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@11 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@43)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@11)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@43)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@43)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@44 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@44) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@12 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@44)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@44)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@44)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 221284) (- 0 400737)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@45 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@45) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@11 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@45)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@45)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@11)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@46 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@46) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@12 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@46)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@46)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@12))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@1 |inline$$WritebackToGlobal$2$m'@2@@1|) (and (=> (= (ControlFlow 0 221284) 219779) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@1) (=> (= (ControlFlow 0 221284) 219769) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@1)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@1| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 220963) 221284)) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@1))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@1)) (= inline$$WritebackToGlobal$2$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@1 inline$$WritebackToGlobal$2$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@1|))) (= |inline$$WritebackToGlobal$2$m'@1@@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@1 inline$$WritebackToGlobal$2$a@1@@1 inline$$WritebackToGlobal$2$v@1@@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@1| |inline$$WritebackToGlobal$2$m'@1@@1|) (= (ControlFlow 0 221017) 221284))) inline$$Diem_burn_with_resource_cap_$def$0$anon80$3_correct@@1)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$2$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@1|)) (and (=> (= (ControlFlow 0 220953) 221017) inline$$WritebackToGlobal$2$anon3_Then_correct@@1) (=> (= (ControlFlow 0 220953) 220963) inline$$WritebackToGlobal$2$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct@@1  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@19 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@19) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@19 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@19)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@47)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@19))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@19 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@19))))))))))))))))))))) (= (ControlFlow 0 221023) 220953)) inline$$WritebackToGlobal$2$anon0_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@1  (and (=> (= (ControlFlow 0 220706) (- 0 400278)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 220706) 221023) inline$$Diem_burn_with_resource_cap_$def$0$anon80$2_correct@@1)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@1  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@1|)) (= (ControlFlow 0 220658) 220706)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@1)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$3$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@1 inline$$WritebackToReference$3$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2@@1| |inline$$WritebackToReference$2$dst'@2@@1|) (= (ControlFlow 0 220527) 220658)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@1))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$3$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@1 inline$$WritebackToReference$3$srcPath@1@@1)) (= |inline$$WritebackToReference$3$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) inline$$WritebackToReference$3$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) (|v#$Mutation| |inline$$WriteRef$3$to'@1@@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2@@1| |inline$$WritebackToReference$3$dst'@1@@1|) (= (ControlFlow 0 220583) 220658))) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@1)))
(let ((inline$$WritebackToReference$3$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$3$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1@@1|)) (= inline$$WritebackToReference$3$dstPath@1@@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|))) (and (=> (= (ControlFlow 0 220491) 220583) inline$$WritebackToReference$3$anon3_Then_correct@@1) (=> (= (ControlFlow 0 220491) 220527) inline$$WritebackToReference$3$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 220354) 220491)) inline$$WritebackToReference$3$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct@@1  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@4@@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (= (ControlFlow 0 221294) 220491)) inline$$WritebackToReference$3$anon0_correct@@1)))
(let ((inline$$WriteRef$3$anon0_correct@@1  (=> (= |inline$$WriteRef$3$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$9$dst@1@@1) (|p#$Mutation| inline$$BorrowField$9$dst@1@@1) inline$$ReadRef$8$v@1@@1)) (and (=> (= (ControlFlow 0 220340) 221294) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Then_correct@@1) (=> (= (ControlFlow 0 220340) 220354) inline$$Diem_burn_with_resource_cap_$def$0$anon122_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct@@1  (=> (and (not $abort_flag@12@@1) (= (ControlFlow 0 220346) 220340)) inline$$WriteRef$3$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@1  (and (=> (= (ControlFlow 0 219759) (- 0 399624)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@20 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@20) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@20 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@20)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@48)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@20))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@20 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@20)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@21 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@21) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@21 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@21)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@49)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@21))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@21 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@21))))))))))))))))))))) (and (=> (= (ControlFlow 0 219759) (- 0 399748)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@50 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@50) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@13 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@50)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@13)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@50)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@50)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@51 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@51) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@14 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@51)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@14)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@51)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@51)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 219759) (- 0 399801)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@52 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@52) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@13 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@52)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@13)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@52)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@13)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@53 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@53) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@14 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@53)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@14)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@53)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@14))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@1 |inline$$WritebackToGlobal$1$m'@2@@1|) (and (=> (= (ControlFlow 0 219759) 219779) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Then_correct@@1) (=> (= (ControlFlow 0 219759) 219769) inline$$Diem_burn_with_resource_cap_$def$0$anon123_Else_correct@@1)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@1| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 219438) 219759)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@1))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@1)) (= inline$$WritebackToGlobal$1$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@1 inline$$WritebackToGlobal$1$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|))) (= |inline$$WritebackToGlobal$1$m'@1@@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@1 inline$$WritebackToGlobal$1$a@1@@1 inline$$WritebackToGlobal$1$v@1@@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@1| |inline$$WritebackToGlobal$1$m'@1@@1|) (= (ControlFlow 0 219492) 219759))) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$2_correct@@1)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$1$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (and (=> (= (ControlFlow 0 219428) 219492) inline$$WritebackToGlobal$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 219428) 219438) inline$$WritebackToGlobal$1$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct@@1  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@22 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@22) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@22 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@54)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@22))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@22 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@22))))))))))))))))))))) (= (ControlFlow 0 219498) 219428)) inline$$WritebackToGlobal$1$anon0_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@1  (and (=> (= (ControlFlow 0 219181) (- 0 399342)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 219181) 219498) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else$1_correct@@1)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@1  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (= (ControlFlow 0 219133) 219181)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@2)) (= (ControlFlow 0 219185) 219133)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1  (=> (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@1 $Error) (=> (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$ret0@2@@1 inline$$Diem_burn_with_resource_cap_$def$0$$ret0@1@@1) (= $abort_flag@13@@1 true)) (and (= $abort_code@19@@1 $abort_code@18@@1) (= $Diem_CurrencyInfo_$memory@2@@1 $Diem_CurrencyInfo_$memory@1@@1))) (and (=> (= (ControlFlow 0 214370) 222017) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 214370) 221679) inline$$Diem_burn_with_capability_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@1  (=> (= $abort_code@18@@1 $abort_code@4@@5) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221568) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221566) 221568)) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct@@1  (=> (= (ControlFlow 0 221576) 221568) inline$$Diem_burn_with_resource_cap_$def$0$anon9_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct@@1  (=> $abort_flag@2@@6 (and (=> (= (ControlFlow 0 221560) 221576) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Then_correct@@1) (=> (= (ControlFlow 0 221560) 221566) inline$$Diem_burn_with_resource_cap_$def$0$anon87_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@1  (=> (= $abort_code@18@@1 $abort_code@5@@3) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221548) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221546) 221548)) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct@@1  (=> (= (ControlFlow 0 221556) 221548) inline$$Diem_burn_with_resource_cap_$def$0$anon13_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct@@1  (=> $abort_flag@3@@4 (and (=> (= (ControlFlow 0 221540) 221556) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Then_correct@@1) (=> (= (ControlFlow 0 221540) 221546) inline$$Diem_burn_with_resource_cap_$def$0$anon89_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@1  (=> (= $abort_code@18@@1 $abort_code@7@@3) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221528) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221526) 221528)) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct@@1  (=> (= (ControlFlow 0 221536) 221528) inline$$Diem_burn_with_resource_cap_$def$0$anon21_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct@@1  (=> $abort_flag@4@@4 (and (=> (= (ControlFlow 0 221520) 221536) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Then_correct@@1) (=> (= (ControlFlow 0 221520) 221526) inline$$Diem_burn_with_resource_cap_$def$0$anon93_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@1  (=> (= $abort_code@18@@1 $abort_code@8@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221490) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221488) 221490)) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct@@1  (=> (= (ControlFlow 0 221498) 221490) inline$$Diem_burn_with_resource_cap_$def$0$anon29_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct@@1  (=> $abort_flag@5@@3 (and (=> (= (ControlFlow 0 221482) 221498) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Then_correct@@1) (=> (= (ControlFlow 0 221482) 221488) inline$$Diem_burn_with_resource_cap_$def$0$anon97_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@1  (=> (= $abort_code@18@@1 $abort_code@9@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221466) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221464) 221466)) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct@@1  (=> (= (ControlFlow 0 221474) 221466) inline$$Diem_burn_with_resource_cap_$def$0$anon35_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@1  (=> $abort_flag@6@@3 (and (=> (= (ControlFlow 0 221458) 221474) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Then_correct@@1) (=> (= (ControlFlow 0 221458) 221464) inline$$Diem_burn_with_resource_cap_$def$0$anon100_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@1  (=> (= $abort_code@18@@1 $abort_code@10@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221446) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221444) 221446)) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct@@1  (=> (= (ControlFlow 0 221454) 221446) inline$$Diem_burn_with_resource_cap_$def$0$anon39_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@1  (=> $abort_flag@7@@1 (and (=> (= (ControlFlow 0 221438) 221454) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Then_correct@@1) (=> (= (ControlFlow 0 221438) 221444) inline$$Diem_burn_with_resource_cap_$def$0$anon102_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@1  (=> (= $abort_code@18@@1 $abort_code@11@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221426) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221424) 221426)) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct@@1  (=> (= (ControlFlow 0 221434) 221426) inline$$Diem_burn_with_resource_cap_$def$0$anon43_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct@@1  (=> $abort_flag@8@@1 (and (=> (= (ControlFlow 0 221418) 221434) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Then_correct@@1) (=> (= (ControlFlow 0 221418) 221424) inline$$Diem_burn_with_resource_cap_$def$0$anon104_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@1  (=> (= $abort_code@18@@1 $abort_code@13@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221406) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221404) 221406)) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct@@1  (=> (= (ControlFlow 0 221414) 221406) inline$$Diem_burn_with_resource_cap_$def$0$anon51_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@1  (=> $abort_flag@9@@1 (and (=> (= (ControlFlow 0 221398) 221414) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Then_correct@@1) (=> (= (ControlFlow 0 221398) 221404) inline$$Diem_burn_with_resource_cap_$def$0$anon108_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@1  (=> (= $abort_code@18@@1 $abort_code@14@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221386) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221384) 221386)) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct@@1  (=> (= (ControlFlow 0 221394) 221386) inline$$Diem_burn_with_resource_cap_$def$0$anon55_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@1  (=> $abort_flag@10@@1 (and (=> (= (ControlFlow 0 221378) 221394) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Then_correct@@1) (=> (= (ControlFlow 0 221378) 221384) inline$$Diem_burn_with_resource_cap_$def$0$anon110_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@1  (=> (= $abort_code@18@@1 $abort_code@15@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221356) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221354) 221356)) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct@@1  (=> (= (ControlFlow 0 221364) 221356) inline$$Diem_burn_with_resource_cap_$def$0$anon61_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct@@1  (=> $abort_flag@11@@1 (and (=> (= (ControlFlow 0 221348) 221364) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Then_correct@@1) (=> (= (ControlFlow 0 221348) 221354) inline$$Diem_burn_with_resource_cap_$def$0$anon113_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@1  (=> (= $abort_code@18@@1 $abort_code@17@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221336) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221334) 221336)) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct@@1  (=> (= (ControlFlow 0 221344) 221336) inline$$Diem_burn_with_resource_cap_$def$0$anon69_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@1  (=> $abort_flag@12@@1 (and (=> (= (ControlFlow 0 221328) 221344) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Then_correct@@1) (=> (= (ControlFlow 0 221328) 221334) inline$$Diem_burn_with_resource_cap_$def$0$anon117_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@1  (=> (= $abort_code@18@@1 $abort_code@17@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221306) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 221304) 221306)) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct@@1  (=> (= (ControlFlow 0 221314) 221306) inline$$Diem_burn_with_resource_cap_$def$0$anon77_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct@@1  (=> $abort_flag@12@@1 (and (=> (= (ControlFlow 0 221298) 221314) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Then_correct@@1) (=> (= (ControlFlow 0 221298) 221304) inline$$Diem_burn_with_resource_cap_$def$0$anon121_Else_correct@@1)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@1  (=> (= inline$$Event_emit_event$0$t@0@@1 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 220271) 221298) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Then_correct@@1) (=> (= (ControlFlow 0 220271) 220346) inline$$Diem_burn_with_resource_cap_$def$0$anon120_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct@@1  (and (=> (= (ControlFlow 0 220281) (- 0 400081)) true) (=> (= (ControlFlow 0 220281) 220271) inline$$Event_emit_event$0$Entry_correct@@1))))
(let ((inline$$ReadRef$8$anon0_correct@@1  (=> (and (= inline$$ReadRef$8$v@1@@1 (|v#$Mutation| inline$$BorrowField$9$dst@1@@1)) (= (ControlFlow 0 220223) 220281)) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then$3_correct@@1)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 220179) 220223)) inline$$ReadRef$8$anon0_correct@@1)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@1  (=> (= (ControlFlow 0 220185) 220223) inline$$ReadRef$8$anon0_correct@@1)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 220173) 220185) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 220173) 220179) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 220165) 220223)) inline$$ReadRef$8$anon0_correct@@1)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct@@1  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@16) (let ((va@@146 (|v#$Vector| call3formal@$ret0@0@@16)))
(let ((l@@146 (|l#$ValueArray| va@@146)))
 (and (and (<= 0 l@@146) (<= l@@146 $MAX_U64)) (forall ((x@@146 Int) ) (!  (=> (or (< x@@146 0) (>= x@@146 l@@146)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0@@1 0) (< inline$$Diem_BurnEvent_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$Diem_BurnEvent_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$Diem_BurnEvent_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$Diem_BurnEvent_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) inline$$Diem_BurnEvent_pack$0$$$0@@1))
))) (and ((_ is $Address) preburn_address@@1) (= inline$$Diem_BurnEvent_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1@@1) 1 call3formal@$ret0@0@@16) 2 preburn_address@@1) 3))))) (and (=> (= (ControlFlow 0 220157) 220173) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 220157) 220165) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@1))))))
(let ((inline$$BorrowField$9$anon0_correct@@1  (=> (= inline$$BorrowField$9$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$9$size@1@@1 (|size#$Path| inline$$BorrowField$9$p@1@@1)) (= inline$$BorrowField$9$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1@@1) inline$$BorrowField$9$size@1@@1 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$9$size@1@@1 1)))) (and (= inline$$BorrowField$9$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) inline$$BorrowField$9$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 219901) 220157))) inline$$Diem_BurnEvent_pack$0$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct@@1  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@2) (= (ControlFlow 0 219907) 219901)) inline$$BorrowField$9$anon0_correct@@1)))
(let ((inline$$Not$0$anon0_correct@@2  (=> (= inline$$Not$0$dst@1@@2 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$7$v@1@@1)))) (and (=> (= (ControlFlow 0 219050) 219907) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Then_correct@@1) (=> (= (ControlFlow 0 219050) 219185) inline$$Diem_burn_with_resource_cap_$def$0$anon119_Else_correct@@1)))))
(let ((inline$$Not$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 219040) (- 0 399303)) true) (=> (= (ControlFlow 0 219040) 219050) inline$$Not$0$anon0_correct@@2))))
(let ((inline$$ReadRef$7$anon0_correct@@1  (=> (and (= inline$$ReadRef$7$v@1@@1 (|v#$Mutation| inline$$BorrowField$8$dst@1@@1)) (= (ControlFlow 0 218992) 219040)) inline$$Not$0$Entry_correct@@2)))
(let ((inline$$BorrowField$8$anon0_correct@@1  (=> (= inline$$BorrowField$8$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$8$size@1@@1 (|size#$Path| inline$$BorrowField$8$p@1@@1)) (= inline$$BorrowField$8$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1@@1) inline$$BorrowField$8$size@1@@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$8$size@1@@1 1)))) (and (= inline$$BorrowField$8$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|) inline$$BorrowField$8$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@1|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 218954) 218992))) inline$$ReadRef$7$anon0_correct@@1))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@1 inline$$WritebackToReference$2$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@1| |inline$$WritebackToReference$1$dst'@2@@1|) (= (ControlFlow 0 218738) 218954)) inline$$BorrowField$8$anon0_correct@@1))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@1 inline$$WritebackToReference$2$srcPath@1@@1)) (= |inline$$WritebackToReference$2$dst'@1@@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$WritebackToReference$2$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@1| |inline$$WritebackToReference$2$dst'@1@@1|) (= (ControlFlow 0 218794) 218954))) inline$$BorrowField$8$anon0_correct@@1)))
(let ((inline$$WritebackToReference$2$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@1|)) (= inline$$WritebackToReference$2$dstPath@1@@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (and (=> (= (ControlFlow 0 218702) 218794) inline$$WritebackToReference$2$anon3_Then_correct@@1) (=> (= (ControlFlow 0 218702) 218738) inline$$WritebackToReference$2$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 218565) 218702)) inline$$WritebackToReference$2$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct@@1  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@3@@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 221324) 218702)) inline$$WritebackToReference$2$anon0_correct@@1)))
(let ((inline$$WriteRef$2$anon0_correct@@1  (=> (= |inline$$WriteRef$2$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1@@1) (|p#$Mutation| inline$$BorrowField$7$dst@1@@1) inline$$Sub$1$dst@2@@1)) (and (=> (= (ControlFlow 0 218551) 221324) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Then_correct@@1) (=> (= (ControlFlow 0 218551) 218565) inline$$Diem_burn_with_resource_cap_$def$0$anon118_Else_correct@@1)))))
(let ((inline$$BorrowField$7$anon0_correct@@1  (=> (= inline$$BorrowField$7$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$7$size@1@@1 (|size#$Path| inline$$BorrowField$7$p@1@@1)) (= inline$$BorrowField$7$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1@@1) inline$$BorrowField$7$size@1@@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$7$size@1@@1 1)))) (and (= inline$$BorrowField$7$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$BorrowField$7$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 218492) 218551))) inline$$WriteRef$2$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@1  (=> (and (not $abort_flag@12@@1) (= (ControlFlow 0 218498) 218492)) inline$$BorrowField$7$anon0_correct@@1)))
(let ((inline$$Sub$1$anon3_Then$1_correct@@1  (=> (= $abort_code@17@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@12@@1 true) (= inline$$Sub$1$dst@2@@1 inline$$Sub$1$dst@0@@1)) (and (=> (= (ControlFlow 0 218362) 221328) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@1) (=> (= (ControlFlow 0 218362) 218498) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@1))))))
(let ((inline$$Sub$1$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$ReadRef$6$v@1@@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1)) (= (ControlFlow 0 218360) 218362)) inline$$Sub$1$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$1$anon3_Else_correct@@1  (=> (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) (|i#$Integer| inline$$ReadRef$6$v@1@@1)) (=> (and (and (= inline$$Sub$1$dst@1@@1 ($Integer (- (|i#$Integer| inline$$ReadRef$6$v@1@@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1)))) (= $abort_code@17@@1 $abort_code@15@@1)) (and (= $abort_flag@12@@1 $abort_flag@11@@1) (= inline$$Sub$1$dst@2@@1 inline$$Sub$1$dst@1@@1))) (and (=> (= (ControlFlow 0 218308) 221328) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Then_correct@@1) (=> (= (ControlFlow 0 218308) 218498) inline$$Diem_burn_with_resource_cap_$def$0$anon116_Else_correct@@1))))))
(let ((inline$$Sub$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 218282) (- 0 398885)) true) (and (=> (= (ControlFlow 0 218282) 218360) inline$$Sub$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 218282) 218308) inline$$Sub$1$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$6$anon0_correct@@1  (=> (and (= inline$$ReadRef$6$v@1@@1 (|v#$Mutation| inline$$BorrowField$6$dst@1@@1)) (= (ControlFlow 0 218183) 218282)) inline$$Sub$1$Entry_correct@@1)))
(let ((inline$$BorrowField$6$anon0_correct@@1  (=> (= inline$$BorrowField$6$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$6$size@1@@1 (|size#$Path| inline$$BorrowField$6$p@1@@1)) (= inline$$BorrowField$6$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@1) inline$$BorrowField$6$size@1@@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1@@1 1)))) (and (= inline$$BorrowField$6$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$BorrowField$6$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 218145) 218183))) inline$$ReadRef$6$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct@@1  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1@@1) (= (ControlFlow 0 218197) 218145)) inline$$BorrowField$6$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@1  (=> (= $abort_code@18@@1 $abort_code@16@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 217979) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 217977) 217979)) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct@@1  (=> (= (ControlFlow 0 217987) 217979) inline$$Diem_burn_with_resource_cap_$def$0$anon66_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@1  (and (=> (= (ControlFlow 0 217971) (- 0 398506)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@23 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@23) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@23 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@23)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@55)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@23))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@23 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@23)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@24 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@24) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@24 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@24)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@56)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@24))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@24 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@24))))))))))))))))))))) (and (=> (= (ControlFlow 0 217971) (- 0 398630)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@57 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@57) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@15 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@57)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@15)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@57)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@57)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@58 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@58) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$addr3@@16 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$addr3@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@58)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$addr3@@16)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@58)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@58)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 217971) (- 0 398683)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@59 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@59) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@15 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@59)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@15)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@59)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@15)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@60 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@60) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@16 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@60)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@16)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@60)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$dr_addr@@16))))))))))))))) (=> (= $abort_code@16@@1 (|i#$Integer| call3formal@$ret0@0@@17)) (and (=> (= (ControlFlow 0 217971) 217987) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Then_correct@@1) (=> (= (ControlFlow 0 217971) 217977) inline$$Diem_burn_with_resource_cap_$def$0$anon115_Else_correct@@1)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 217646) 217971)) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@1))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 217700) 217971))) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$2_correct@@1)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (and (=> (= (ControlFlow 0 217636) 217700) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 217636) 217646) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct@@1  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@25 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@25) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@25 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@25)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def$0$coin_type@@61)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@25))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner1@@25 inline$$Diem_burn_with_resource_cap_$def$0$mint_cap_owner2@@25))))))))))))))))))))) (= (ControlFlow 0 217706) 217636)) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@1  (and (=> (= (ControlFlow 0 217389) (- 0 398224)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 217389) 217706) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else$1_correct@@1)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@1  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 217341) 217389)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1@@1)) (= (ControlFlow 0 217393) 217341)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct@@1  (=> (not $abort_flag@11@@1) (and (=> (= (ControlFlow 0 217266) 218197) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Then_correct@@1) (=> (= (ControlFlow 0 217266) 217393) inline$$Diem_burn_with_resource_cap_$def$0$anon114_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct@@1  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t36@1@@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@11@@1)) (and (=> $abort_flag@11@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@11@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@17) (>= (|i#$Integer| call3formal@$ret0@0@@17) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@17) $MAX_U64))) (and (=> (= (ControlFlow 0 217260) 221348) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Then_correct@@1) (=> (= (ControlFlow 0 217260) 217266) inline$$Diem_burn_with_resource_cap_$def$0$anon112_Else_correct@@1)))))
(let ((inline$$Ge$1$anon0_correct@@1  (=> (and (= inline$$Ge$1$dst@1@@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$5$v@1@@1) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1)))) (= (ControlFlow 0 217248) 217260)) inline$$Diem_burn_with_resource_cap_$def$0$anon58$3_correct@@1)))
(let ((inline$$Ge$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 217234) (- 0 398114)) true) (=> (= (ControlFlow 0 217234) 217248) inline$$Ge$1$anon0_correct@@1))))
(let ((inline$$ReadRef$5$anon0_correct@@1  (=> (and (= inline$$ReadRef$5$v@1@@1 (|v#$Mutation| inline$$BorrowField$5$dst@1@@1)) (= (ControlFlow 0 217176) 217234)) inline$$Ge$1$Entry_correct@@1)))
(let ((inline$$BorrowField$5$anon0_correct@@1  (=> (= inline$$BorrowField$5$p@1@@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (=> (and (and (= inline$$BorrowField$5$size@1@@1 (|size#$Path| inline$$BorrowField$5$p@1@@1)) (= inline$$BorrowField$5$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@1) inline$$BorrowField$5$size@1@@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1@@1 1)))) (and (= inline$$BorrowField$5$dst@1@@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) inline$$BorrowField$5$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 217138) 217176))) inline$$ReadRef$5$anon0_correct@@1))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowGlobal$1$dst@2@@1) (= (ControlFlow 0 216922) 217138)) inline$$BorrowField$5$anon0_correct@@1))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 216978) 217138))) inline$$BorrowField$5$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) (and (=> (= (ControlFlow 0 216886) 216978) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 216886) 216922) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 216749) 216886)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct@@1  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@2@@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (= (ControlFlow 0 221374) 216886)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@1) (|p#$Mutation| inline$$BorrowField$4$dst@1@@1) inline$$Sub$0$dst@2@@1)) (and (=> (= (ControlFlow 0 216735) 221374) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Then_correct@@1) (=> (= (ControlFlow 0 216735) 216749) inline$$Diem_burn_with_resource_cap_$def$0$anon111_Else_correct@@1)))))
(let ((inline$$BorrowField$4$anon0_correct@@1  (=> (= inline$$BorrowField$4$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (=> (and (and (= inline$$BorrowField$4$size@1@@1 (|size#$Path| inline$$BorrowField$4$p@1@@1)) (= inline$$BorrowField$4$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@1) inline$$BorrowField$4$size@1@@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$4$size@1@@1 1)))) (and (= inline$$BorrowField$4$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$BorrowField$4$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 216676) 216735))) inline$$WriteRef$1$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@1  (=> (and (not $abort_flag@10@@1) (= (ControlFlow 0 216682) 216676)) inline$$BorrowField$4$anon0_correct@@1)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@10@@1 true) (=> (and (= $abort_code@14@@1 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@0@@1)) (and (=> (= (ControlFlow 0 216546) 221378) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@1) (=> (= (ControlFlow 0 216546) 216682) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@1))))))
(let ((inline$$Sub$0$anon3_Then_correct@@1  (=> (and (< (|i#$Integer| inline$$ReadRef$4$v@1@@1) (|i#$Integer| inline$$CastU128$1$dst@1@@1)) (= (ControlFlow 0 216544) 216546)) inline$$Sub$0$anon3_Then$1_correct@@1)))
(let ((inline$$Sub$0$anon3_Else_correct@@1  (=> (<= (|i#$Integer| inline$$CastU128$1$dst@1@@1) (|i#$Integer| inline$$ReadRef$4$v@1@@1)) (=> (and (and (= inline$$Sub$0$dst@1@@1 ($Integer (- (|i#$Integer| inline$$ReadRef$4$v@1@@1) (|i#$Integer| inline$$CastU128$1$dst@1@@1)))) (= $abort_flag@10@@1 $abort_flag@9@@1)) (and (= $abort_code@14@@1 $abort_code@13@@1) (= inline$$Sub$0$dst@2@@1 inline$$Sub$0$dst@1@@1))) (and (=> (= (ControlFlow 0 216492) 221378) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Then_correct@@1) (=> (= (ControlFlow 0 216492) 216682) inline$$Diem_burn_with_resource_cap_$def$0$anon109_Else_correct@@1))))))
(let ((inline$$Sub$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 216466) (- 0 397694)) true) (and (=> (= (ControlFlow 0 216466) 216544) inline$$Sub$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 216466) 216492) inline$$Sub$0$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@1  (=> (and (not $abort_flag@9@@1) (= (ControlFlow 0 216552) 216466)) inline$$Sub$0$Entry_correct@@1)))
(let ((inline$$CastU128$1$anon3_Then$1_correct@@1  (=> (= $abort_code@13@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@9@@1 true) (= inline$$CastU128$1$dst@1@@1 inline$$CastU128$1$dst@0@@1)) (and (=> (= (ControlFlow 0 216369) 221398) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@1) (=> (= (ControlFlow 0 216369) 216552) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@1))))))
(let ((inline$$CastU128$1$anon3_Then_correct@@1  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) $MAX_U128) (= (ControlFlow 0 216367) 216369)) inline$$CastU128$1$anon3_Then$1_correct@@1)))
(let ((inline$$CastU128$1$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1)) (= $abort_code@13@@1 $abort_code@11@@1)) (and (= $abort_flag@9@@1 $abort_flag@8@@1) (= inline$$CastU128$1$dst@1@@1 inline$$Diem_Diem_unpack$0$value@1@@1))) (and (=> (= (ControlFlow 0 216317) 221398) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Then_correct@@1) (=> (= (ControlFlow 0 216317) 216552) inline$$Diem_burn_with_resource_cap_$def$0$anon107_Else_correct@@1)))))
(let ((inline$$CastU128$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 216303) (- 0 397622)) true) (and (=> (= (ControlFlow 0 216303) 216367) inline$$CastU128$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 216303) 216317) inline$$CastU128$1$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$4$anon0_correct@@1  (=> (and (= inline$$ReadRef$4$v@1@@1 (|v#$Mutation| inline$$BorrowField$3$dst@1@@1)) (= (ControlFlow 0 216222) 216303)) inline$$CastU128$1$Entry_correct@@1)))
(let ((inline$$BorrowField$3$anon0_correct@@1  (=> (= inline$$BorrowField$3$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (=> (and (and (= inline$$BorrowField$3$size@1@@1 (|size#$Path| inline$$BorrowField$3$p@1@@1)) (= inline$$BorrowField$3$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@1) inline$$BorrowField$3$size@1@@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$3$size@1@@1 1)))) (and (= inline$$BorrowField$3$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$BorrowField$3$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 216184) 216222))) inline$$ReadRef$4$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct@@1  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@1) (= (ControlFlow 0 216236) 216184)) inline$$BorrowField$3$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@1  (=> (= $abort_code@18@@1 $abort_code@12@@1) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 216018) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 216016) 216018)) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct@@1  (=> (= (ControlFlow 0 216026) 216018) inline$$Diem_burn_with_resource_cap_$def$0$anon48_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct@@1  (=> (= $abort_code@12@@1 (|i#$Integer| call3formal@$ret0@0@@18)) (and (=> (= (ControlFlow 0 216010) 216026) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Then_correct@@1) (=> (= (ControlFlow 0 216010) 216016) inline$$Diem_burn_with_resource_cap_$def$0$anon106_Else_correct@@1)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@1  (and (=> (= (ControlFlow 0 216000) (- 0 397456)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 216000) 216010) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else$1_correct@@1)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@1  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (= (ControlFlow 0 215952) 216000)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@1)) (= (ControlFlow 0 216004) 215952)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct@@1  (=> (not $abort_flag@8@@1) (and (=> (= (ControlFlow 0 215877) 216236) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Then_correct@@1) (=> (= (ControlFlow 0 215877) 216004) inline$$Diem_burn_with_resource_cap_$def$0$anon105_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct@@1  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t28@1@@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@1)) (and (=> $abort_flag@8@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@18) (>= (|i#$Integer| call3formal@$ret0@0@@18) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@18) $MAX_U64))) (and (=> (= (ControlFlow 0 215871) 221418) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Then_correct@@1) (=> (= (ControlFlow 0 215871) 215877) inline$$Diem_burn_with_resource_cap_$def$0$anon103_Else_correct@@1)))))
(let ((inline$$Ge$0$anon0_correct@@1  (=> (and (= inline$$Ge$0$dst@1@@1 ($Boolean (>= (|i#$Integer| inline$$ReadRef$3$v@1@@1) (|i#$Integer| inline$$CastU128$0$dst@1@@1)))) (= (ControlFlow 0 215859) 215871)) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else$1_correct@@1)))
(let ((inline$$Ge$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 215845) (- 0 397346)) true) (=> (= (ControlFlow 0 215845) 215859) inline$$Ge$0$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@1  (=> (and (not $abort_flag@7@@1) (= (ControlFlow 0 215865) 215845)) inline$$Ge$0$Entry_correct@@1)))
(let ((inline$$CastU128$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@7@@1 true) (=> (and (= $abort_code@10@@1 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1@@1 inline$$CastU128$0$dst@0@@1)) (and (=> (= (ControlFlow 0 215789) 221438) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@1) (=> (= (ControlFlow 0 215789) 215865) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@1))))))
(let ((inline$$CastU128$0$anon3_Then_correct@@1  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) $MAX_U128) (= (ControlFlow 0 215787) 215789)) inline$$CastU128$0$anon3_Then$1_correct@@1)))
(let ((inline$$CastU128$0$anon3_Else_correct@@1  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1)) (= $abort_flag@7@@1 $abort_flag@6@@3)) (and (= $abort_code@10@@1 $abort_code@9@@2) (= inline$$CastU128$0$dst@1@@1 inline$$Diem_Diem_unpack$0$value@1@@1))) (and (=> (= (ControlFlow 0 215737) 221438) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Then_correct@@1) (=> (= (ControlFlow 0 215737) 215865) inline$$Diem_burn_with_resource_cap_$def$0$anon101_Else_correct@@1)))))
(let ((inline$$CastU128$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 215723) (- 0 397274)) true) (and (=> (= (ControlFlow 0 215723) 215787) inline$$CastU128$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 215723) 215737) inline$$CastU128$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$3$anon0_correct@@1  (=> (and (= inline$$ReadRef$3$v@1@@1 (|v#$Mutation| inline$$BorrowField$2$dst@1@@1)) (= (ControlFlow 0 215642) 215723)) inline$$CastU128$0$Entry_correct@@1)))
(let ((inline$$BorrowField$2$anon0_correct@@1  (=> (= inline$$BorrowField$2$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (=> (and (and (= inline$$BorrowField$2$size@1@@1 (|size#$Path| inline$$BorrowField$2$p@1@@1)) (= inline$$BorrowField$2$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@1) inline$$BorrowField$2$size@1@@1 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$2$size@1@@1 1)))) (and (= inline$$BorrowField$2$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$BorrowField$2$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 215604) 215642))) inline$$ReadRef$3$anon0_correct@@1))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@1  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 215446) 215604)) inline$$BorrowField$2$anon0_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@1  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (= (ControlFlow 0 215440) 215446)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@1  (=> (and (not $abort_flag@6@@3) (= (ControlFlow 0 215450) 215440)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@1)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@1  (=> (= $abort_code@9@@2 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6@@3 true) (= inline$$BorrowGlobal$1$dst@2@@1 inline$$BorrowGlobal$1$dst@0@@1)) (and (=> (= (ControlFlow 0 215400) 221458) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@1) (=> (= (ControlFlow 0 215400) 215450) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@1))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@1 inline$$BorrowGlobal$1$a@1@@1)) (= (ControlFlow 0 215398) 215400)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@1 inline$$BorrowGlobal$1$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0@@1 inline$$BorrowGlobal$1$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@1 inline$$BorrowGlobal$1$a@1@@1))) (= $abort_code@9@@2 $abort_code@8@@2)) (and (= $abort_flag@6@@3 $abort_flag@5@@3) (= inline$$BorrowGlobal$1$dst@2@@1 inline$$BorrowGlobal$1$dst@1@@1))) (and (=> (= (ControlFlow 0 215346) 221458) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Then_correct@@1) (=> (= (ControlFlow 0 215346) 215450) inline$$Diem_burn_with_resource_cap_$def$0$anon99_Else_correct@@1))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@1  (=> (= inline$$BorrowGlobal$1$a@1@@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@5)) (and (=> (= (ControlFlow 0 215316) 215398) inline$$BorrowGlobal$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 215316) 215346) inline$$BorrowGlobal$1$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@1  (=> (= inline$$BorrowGlobal$1$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1)) (and (=> (= (ControlFlow 0 215310) (- 0 397061)) true) (=> (= (ControlFlow 0 215310) 215316) inline$$BorrowGlobal$1$anon0_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@1  (=> (and (not $abort_flag@5@@3) (= (ControlFlow 0 215406) 215310)) inline$$BorrowGlobal$1$Entry_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@1  (=> (and (and $abort_flag@5@@3 (= $abort_code@18@@1 $abort_code@8@@2)) (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 221478) 214370))) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@5  (=> (not true) (and (=> (= (ControlFlow 0 215167) 221478) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@1) (=> (= (ControlFlow 0 215167) 215406) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@1)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@5  (and (=> (= (ControlFlow 0 215177) 221478) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Then_correct@@1) (=> (= (ControlFlow 0 215177) 215406) inline$$Diem_burn_with_resource_cap_$def$0$anon98_Else_correct@@1))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@5  (=> (and (not $abort_flag@5@@3) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@5 ($Address 173345816))) (and (=> (= (ControlFlow 0 215161) 215177) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 215161) 215167) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@5)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct@@1  (=> (and (not $abort_flag@5@@3) (= (ControlFlow 0 215191) 215161)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@5)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@1  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@3) (=> (and (=> $abort_flag@5@@3 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@5@@3 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@8@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 215056) 221482) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Then_correct@@1) (=> (= (ControlFlow 0 215056) 215191) inline$$Diem_burn_with_resource_cap_$def$0$anon96_Else_correct@@1))))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 215054) 215056)) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct@@1  (=> (= (ControlFlow 0 221506) 215056) inline$$Diem_burn_with_resource_cap_$def$0$anon26_correct@@1)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct@@1  (=> (and ((_ is $Vector) call4formal@$ret0@0@@3) (= inline$$Diem_Diem_unpack$0$value@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@1) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@1) $MAX_U64)) (and (=> (= (ControlFlow 0 215040) 221506) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Then_correct@@1) (=> (= (ControlFlow 0 215040) 215054) inline$$Diem_burn_with_resource_cap_$def$0$anon95_Else_correct@@1))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@1  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 12))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@1| inline$$ReadRef$0$v@1@@1) (= (ControlFlow 0 214949) 215040)) inline$$Diem_Diem_unpack$0$anon0_correct@@1))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@1  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) ($Local 12)) (= |inline$$WritebackToValue$0$vdst'@1@@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 inline$$ReadRef$0$v@1@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@1| |inline$$WritebackToValue$0$vdst'@1@@1|) (= (ControlFlow 0 214975) 215040))) inline$$Diem_Diem_unpack$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowLoc$0$dst@1@@1)) (and (=> (= (ControlFlow 0 214794) 214975) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 214794) 214949) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (and (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|)))) (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|))) (and (=> (= (ControlFlow 0 214850) 214975) inline$$WritebackToValue$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 214850) 214949) inline$$WritebackToValue$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) (and (=> (= (ControlFlow 0 214758) 214850) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 214758) 214794) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 214621) 214758)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct@@1  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$trace_temp@1@@1 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def$0$info@0@@1)) (= (ControlFlow 0 221516) 214758)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) call5formal@$ret1@0@@1)) (and (=> (= (ControlFlow 0 214607) 221516) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Then_correct@@1) (=> (= (ControlFlow 0 214607) 214621) inline$$Diem_burn_with_resource_cap_$def$0$anon94_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct@@1  (=> (and (not $abort_flag@4@@4) (= (ControlFlow 0 214613) 214607)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct@@1  (and (=> (= (ControlFlow 0 214550) (- 0 396563)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@4) (=> $abort_flag@4@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@1)) $Diem_Diem_value))))) (=> (not $abort_flag@4@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@1)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@3) (let ((va@@147 (|v#$Vector| call4formal@$ret0@0@@3)))
(let ((l@@147 (|l#$ValueArray| va@@147)))
 (and (and (<= 0 l@@147) (<= l@@147 $MAX_U64)) (forall ((x@@147 Int) ) (!  (=> (or (< x@@147 0) (>= x@@147 l@@147)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@3)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@1) (let ((va@@148 (|v#$Vector| call5formal@$ret1@0@@1)))
(let ((l@@148 (|l#$ValueArray| va@@148)))
 (and (and (<= 0 l@@148) (<= l@@148 $MAX_U64)) (forall ((x@@148 Int) ) (!  (=> (or (< x@@148 0) (>= x@@148 l@@148)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@1)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 214550) 221520) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Then_correct@@1) (=> (= (ControlFlow 0 214550) 214613) inline$$Diem_burn_with_resource_cap_$def$0$anon92_Else_correct@@1)))))))
(let ((inline$$ReadRef$2$anon0_correct@@1  (=> (and (= inline$$ReadRef$2$v@1@@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@1)) (= (ControlFlow 0 214538) 214550)) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then$2_correct@@1)))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 214500) 214538))) inline$$ReadRef$2$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct@@1  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1@@1) (= (ControlFlow 0 214506) 214500)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@1  (=> (= $abort_code@18@@1 $abort_code@6@@3) (=> (and (= $Diem_CurrencyInfo_$memory@1@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 214364) 214370)) inline$$Diem_burn_with_resource_cap_$def$0$Abort_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 214362) 214364)) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct@@1  (=> (= (ControlFlow 0 214378) 214364) inline$$Diem_burn_with_resource_cap_$def$0$anon18_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct@@1  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@1)) (= $abort_code@6@@3 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 214356) 214378) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Then_correct@@1) (=> (= (ControlFlow 0 214356) 214362) inline$$Diem_burn_with_resource_cap_$def$0$anon91_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct@@1  (=> (not $abort_flag@3@@4) (and (=> (= (ControlFlow 0 214344) 214506) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Then_correct@@1) (=> (= (ControlFlow 0 214344) 214356) inline$$Diem_burn_with_resource_cap_$def$0$anon90_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct@@1  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t19@1@@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@4)) (and (=> $abort_flag@3@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 214338) 221540) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Then_correct@@1) (=> (= (ControlFlow 0 214338) 214344) inline$$Diem_burn_with_resource_cap_$def$0$anon88_Else_correct@@1)))))
(let ((inline$$Gt$0$anon0_correct@@1  (=> (and (= inline$$Gt$0$dst@1@@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@6) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@1)))) (= (ControlFlow 0 214326) 214338)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$3_correct@@1)))
(let ((inline$$Gt$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 214312) (- 0 396356)) true) (=> (= (ControlFlow 0 214312) 214326) inline$$Gt$0$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct@@1  (=> (and (= inline$$Diem_burn_with_resource_cap_$def$0$$t17@1@@1 ($Integer 0)) (= (ControlFlow 0 214332) 214312)) inline$$Gt$0$Entry_correct@@1)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@6  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@1)) $Diem_Diem_value)) (= (ControlFlow 0 214258) 214332)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$2_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct@@1  (and (=> (= (ControlFlow 0 214264) (- 0 396319)) true) (=> (= (ControlFlow 0 214264) 214258) inline$$GetFieldFromValue$0$anon0_correct@@6))))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 214198) 214264)) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else$1_correct@@1)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 214160) 214198))) inline$$ReadRef$1$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct@@1  (=> (and (not $abort_flag@2@@6) (= (ControlFlow 0 214212) 214160)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct@@1  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@6) (=> $abort_flag@2@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@2@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@5 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@2@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@16) (let ((va@@149 (|v#$Vector| call3formal@$ret0@0@@16)))
(let ((l@@149 (|l#$ValueArray| va@@149)))
 (and (and (<= 0 l@@149) (<= l@@149 $MAX_U64)) (forall ((x@@149 Int) ) (!  (=> (or (< x@@149 0) (>= x@@149 l@@149)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149))
)))))) (forall (($$0@@44 Int) ) (!  (=> (and (>= $$0@@44 0) (< $$0@@44 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@44)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@44)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@44)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@16)) $$0@@44))
)))) (and (=> (= (ControlFlow 0 214002) 221560) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Then_correct@@1) (=> (= (ControlFlow 0 214002) 214212) inline$$Diem_burn_with_resource_cap_$def$0$anon86_Else_correct@@1)))))
(let ((inline$$BorrowLoc$0$anon0_correct@@1  (=> (and (= inline$$BorrowLoc$0$dst@1@@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$0$v@1@@1)) (= (ControlFlow 0 213994) 214002)) inline$$Diem_burn_with_resource_cap_$def$0$anon6$3_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 213876) 213994)) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@1  (=> (= (ControlFlow 0 221584) 213994) inline$$BorrowLoc$0$anon0_correct@@1)))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 213868) 221584) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@1) (=> (= (ControlFlow 0 213868) 213876) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@1  (and (=> (= (ControlFlow 0 221592) 221584) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Then_correct@@1) (=> (= (ControlFlow 0 221592) 213876) inline$$Diem_burn_with_resource_cap_$def$0$anon85_Else_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 213860) 221592) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@1) (=> (= (ControlFlow 0 213860) 213868) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct@@1  (and (=> (= (ControlFlow 0 221600) 221592) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Then_correct@@1) (=> (= (ControlFlow 0 221600) 213868) inline$$Diem_burn_with_resource_cap_$def$0$anon84_Else_correct@@1))))
(let ((inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct@@1  (=> (not $abort_flag@1@@7) (and (=> (= (ControlFlow 0 213854) 221600) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Then_correct@@1) (=> (= (ControlFlow 0 213854) 213860) inline$$Diem_burn_with_resource_cap_$def$0$anon83_Else_correct@@1)))))
(let ((inline$$Diem_burn_with_resource_cap_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@1) (let ((va@@150 (|v#$Vector| inline$$ReadRef$0$v@1@@1)))
(let ((l@@150 (|l#$ValueArray| va@@150)))
 (and (and (<= 0 l@@150) (<= l@@150 $MAX_U64)) (forall ((x@@150 Int) ) (!  (=> (or (< x@@150 0) (>= x@@150 l@@150)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn)) (let ((va@@151 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn))))
(let ((l@@151 (|l#$ValueArray| va@@151)))
 (and (and (<= 0 l@@151) (<= l@@151 $MAX_U64)) (forall ((x@@151 Int) ) (!  (=> (or (< x@@151 0) (>= x@@151 l@@151)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) preburn_address@@1)) (=> (and (and (and (and (and ((_ is $Vector) capability@@0) (let ((va@@152 (|v#$Vector| capability@@0)))
(let ((l@@152 (|l#$ValueArray| va@@152)))
 (and (and (<= 0 l@@152) (<= l@@152 $MAX_U64)) (forall ((x@@152 Int) ) (!  (=> (or (< x@@152 0) (>= x@@152 l@@152)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152))
)))))) (= (|l#$ValueArray| (|v#$Vector| capability@@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| capability@@0)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 221606) 213854)) inline$$Diem_burn_with_resource_cap_$def$0$anon0_correct@@1))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon25_Else$1_correct  (and (=> (= (ControlFlow 0 221614) (- 0 395831)) true) (=> (= (ControlFlow 0 221614) 221606) inline$$Diem_burn_with_resource_cap_$direct_intra$0$anon0_correct@@0))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (= (ControlFlow 0 211179) 221614)) inline$$Diem_burn_with_capability_$def_verify$0$anon25_Else$1_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@7) (= (ControlFlow 0 211185) 211179)) inline$$ReadRef$0$anon0_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@1@@7 true) (=> (and (= $abort_code@3@@6 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 211135) 222021) inline$$Diem_burn_with_capability_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 211135) 211185) inline$$Diem_burn_with_capability_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 211133) 211135)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1))) (= $abort_flag@1@@7 $abort_flag@0@@7)) (and (= $abort_code@3@@6 $abort_code@1@@7) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 211081) 222021) inline$$Diem_burn_with_capability_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 211081) 211185) inline$$Diem_burn_with_capability_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| preburn_address@@1)) (and (=> (= (ControlFlow 0 211051) 211133) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 211051) 211081) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (=> (= inline$$BorrowGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1)) (and (=> (= (ControlFlow 0 211045) (- 0 395718)) true) (=> (= (ControlFlow 0 211045) 211051) inline$$BorrowGlobal$0$anon0_correct@@1)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon23_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_burn_with_capability_$def_verify$0$$t6@1) (= (ControlFlow 0 211141) 211045)) inline$$BorrowGlobal$0$Entry_correct@@1)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon12_correct  (=> (= $abort_code@20@@1 $abort_code@2@@5) (=> (and (= $Diem_CurrencyInfo_$memory@3@@1 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 210916) 210920)) inline$$Diem_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 210914) 210916)) inline$$Diem_burn_with_capability_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 210928) 210916) inline$$Diem_burn_with_capability_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon23_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_burn_with_capability_$def_verify$0$$t6@1)) (= $abort_code@2@@5 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 210908) 210928) inline$$Diem_burn_with_capability_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 210908) 210914) inline$$Diem_burn_with_capability_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon21_Else_correct  (=> (not $abort_flag@0@@7) (and (=> (= (ControlFlow 0 210896) 211141) inline$$Diem_burn_with_capability_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 210896) 210908) inline$$Diem_burn_with_capability_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon4$2_correct  (=> (= inline$$Diem_burn_with_capability_$def_verify$0$$t6@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| preburn_address@@1)))) (=> (and (and (and (= inline$$Diem_burn_with_capability_$def_verify$0$$t7@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@7)) (and (=> $abort_flag@0@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 210890) 222041) inline$$Diem_burn_with_capability_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 210890) 210896) inline$$Diem_burn_with_capability_$def_verify$0$anon21_Else_correct))))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 210796) 210890)) inline$$Diem_burn_with_capability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 222065) 210890) inline$$Diem_burn_with_capability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 210788) 222065) inline$$Diem_burn_with_capability_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 210788) 210796) inline$$Diem_burn_with_capability_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 222073) 222065) inline$$Diem_burn_with_capability_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 222073) 210796) inline$$Diem_burn_with_capability_$def_verify$0$anon20_Else_correct))))
(let ((inline$$Diem_burn_with_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 210782) 222073) inline$$Diem_burn_with_capability_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 210782) 210788) inline$$Diem_burn_with_capability_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@8  (=> (and (forall (($inv_addr@@19 Int) ($inv_tv0@@15 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19)) (let ((va@@153 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))))
(let ((l@@153 (|l#$ValueArray| va@@153)))
 (and (and (<= 0 l@@153) (<= l@@153 $MAX_U64)) (forall ((x@@153 Int) ) (!  (=> (or (< x@@153 0) (>= x@@153 l@@153)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@19))
)) (forall (($inv_addr@@20 Int) ($inv_tv0@@16 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20)) (let ((va@@154 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))))
(let ((l@@154 (|l#$ValueArray| va@@154)))
 (and (and (<= 0 l@@154) (<= l@@154 $MAX_U64)) (forall ((x@@154 Int) ) (!  (=> (or (< x@@154 0) (>= x@@154 l@@154)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@155 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@155 (|l#$ValueArray| va@@155)))
 (and (and (<= 0 l@@155) (<= l@@155 $MAX_U64)) (forall ((x@@155 Int) ) (!  (=> (or (< x@@155 0) (>= x@@155 l@@155)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code)) (let ((va@@156 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@156 (|l#$ValueArray| va@@156)))
 (and (and (<= 0 l@@156) (<= l@@156 $MAX_U64)) (forall ((x@@156 Int) ) (!  (=> (or (< x@@156 0) (>= x@@156 l@@156)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156))
))))))) (forall (($$0@@45 Int) ) (!  (=> (and (>= $$0@@45 0) (< $$0@@45 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))) $$0@@45)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))) $$0@@45)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))) $$0@@45)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_currency_code))) $$0@@45))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events)) (let ((va@@157 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@157 (|l#$ValueArray| va@@157)))
 (and (and (<= 0 l@@157) (<= l@@157 $MAX_U64)) (forall ((x@@157 Int) ) (!  (=> (or (< x@@157 0) (>= x@@157 l@@157)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@158 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@158 (|l#$ValueArray| va@@158)))
 (and (and (<= 0 l@@158) (<= l@@158 $MAX_U64)) (forall ((x@@158 Int) ) (!  (=> (or (< x@@158 0) (>= x@@158 l@@158)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158))
))))))) (forall (($$0@@46 Int) ) (!  (=> (and (>= $$0@@46 0) (< $$0@@46 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@46)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@46)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@46)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@46))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events)) (let ((va@@159 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@159 (|l#$ValueArray| va@@159)))
 (and (and (<= 0 l@@159) (<= l@@159 $MAX_U64)) (forall ((x@@159 Int) ) (!  (=> (or (< x@@159 0) (>= x@@159 l@@159)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@160 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@160 (|l#$ValueArray| va@@160)))
 (and (and (<= 0 l@@160) (<= l@@160 $MAX_U64)) (forall ((x@@160 Int) ) (!  (=> (or (< x@@160 0) (>= x@@160 l@@160)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160))
))))))) (forall (($$0@@47 Int) ) (!  (=> (and (>= $$0@@47 0) (< $$0@@47 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@47)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@47)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@47)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@47))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@161 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@161 (|l#$ValueArray| va@@161)))
 (and (and (<= 0 l@@161) (<= l@@161 $MAX_U64)) (forall ((x@@161 Int) ) (!  (=> (or (< x@@161 0) (>= x@@161 l@@161)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@162 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@162 (|l#$ValueArray| va@@162)))
 (and (and (<= 0 l@@162) (<= l@@162 $MAX_U64)) (forall ((x@@162 Int) ) (!  (=> (or (< x@@162 0) (>= x@@162 l@@162)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162))
))))))) (forall (($$0@@48 Int) ) (!  (=> (and (>= $$0@@48 0) (< $$0@@48 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@48)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@48)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@48)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@48))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@163 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@163 (|l#$ValueArray| va@@163)))
 (and (and (<= 0 l@@163) (<= l@@163 $MAX_U64)) (forall ((x@@163 Int) ) (!  (=> (or (< x@@163 0) (>= x@@163 l@@163)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@164 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@164 (|l#$ValueArray| va@@164)))
 (and (and (<= 0 l@@164) (<= l@@164 $MAX_U64)) (forall ((x@@164 Int) ) (!  (=> (or (< x@@164 0) (>= x@@164 l@@164)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164))
))))))) (forall (($$0@@49 Int) ) (!  (=> (and (>= $$0@@49 0) (< $$0@@49 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@49)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@49)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@49)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@49))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@165 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@165 (|l#$ValueArray| va@@165)))
 (and (and (<= 0 l@@165) (<= l@@165 $MAX_U64)) (forall ((x@@165 Int) ) (!  (=> (or (< x@@165 0) (>= x@@165 l@@165)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@166 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@166 (|l#$ValueArray| va@@166)))
 (and (and (<= 0 l@@166) (<= l@@166 $MAX_U64)) (forall ((x@@166 Int) ) (!  (=> (or (< x@@166 0) (>= x@@166 l@@166)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166))
))))))) (forall (($$0@@50 Int) ) (!  (=> (and (>= $$0@@50 0) (< $$0@@50 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@50)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@50)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@50)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@50))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@20))
))) (=> (and (and (forall (($inv_addr@@21 Int) ($inv_tv0@@17 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21)) (let ((va@@167 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))))
(let ((l@@167 (|l#$ValueArray| va@@167)))
 (and (and (<= 0 l@@167) (<= l@@167 $MAX_U64)) (forall ((x@@167 Int) ) (!  (=> (or (< x@@167 0) (>= x@@167 l@@167)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn)) (let ((va@@168 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn))))
(let ((l@@168 (|l#$ValueArray| va@@168)))
 (and (and (<= 0 l@@168) (<= l@@168 $MAX_U64)) (forall ((x@@168 Int) ) (!  (=> (or (< x@@168 0) (>= x@@168 l@@168)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@17) 1) $inv_addr@@21))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@12 T@$Value) )  (=> ((_ is $Type) coin_type@@12) (|b#$Boolean| ($Boolean (forall ((addr3@@6 T@$Value) )  (=> ((_ is $Address) addr3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| addr3@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@13 T@$Value) )  (=> ((_ is $Type) coin_type@@13) (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@13)) 1) (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 222077) 210782))) inline$$Diem_burn_with_capability_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@8  (=> ((_ is $Address) preburn_address@@1) (=> (and (and (and (and (and ((_ is $Vector) capability@@0) (let ((va@@169 (|v#$Vector| capability@@0)))
(let ((l@@169 (|l#$ValueArray| va@@169)))
 (and (and (<= 0 l@@169) (<= l@@169 $MAX_U64)) (forall ((x@@169 Int) ) (!  (=> (or (< x@@169 0) (>= x@@169 l@@169)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169))
)))))) (= (|l#$ValueArray| (|v#$Vector| capability@@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| capability@@0)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 209972) 222077)) anon0$1_correct@@8))))
(let ((PreconditionGeneratedEntry_correct@@5  (=> (= (ControlFlow 0 392411) 209972) anon0_correct@@8)))
PreconditionGeneratedEntry_correct@@5))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun preburn@@0 () T@$Value)
(declare-fun $abort_flag@11@@2 () Bool)
(declare-fun $tv0@@16 () T@$TypeValue)
(declare-fun $abort_code@16@@2 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2@@2 () T@$Memory)
(declare-fun $abort_code@14@@2 () Int)
(declare-fun $abort_flag@10@@2 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@2 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@2| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$BorrowField$9$dst@1@@2 () T@$Mutation)
(declare-fun inline$$ReadRef$7$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@2| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@3 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@15@@2 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@2 () T@$Memory)
(declare-fun $abort_code@1@@8 () Int)
(declare-fun $abort_flag@0@@8 () Bool)
(declare-fun $abort_code@2@@6 () Int)
(declare-fun $abort_flag@1@@8 () Bool)
(declare-fun $abort_code@4@@6 () Int)
(declare-fun $abort_flag@2@@7 () Bool)
(declare-fun $abort_code@5@@4 () Int)
(declare-fun $abort_flag@3@@5 () Bool)
(declare-fun $abort_code@6@@4 () Int)
(declare-fun $abort_flag@4@@5 () Bool)
(declare-fun $abort_code@7@@4 () Int)
(declare-fun $abort_flag@5@@4 () Bool)
(declare-fun $abort_code@8@@3 () Int)
(declare-fun $abort_flag@6@@4 () Bool)
(declare-fun $abort_code@10@@2 () Int)
(declare-fun $abort_flag@7@@2 () Bool)
(declare-fun $abort_code@11@@2 () Int)
(declare-fun $abort_flag@8@@2 () Bool)
(declare-fun $abort_code@12@@2 () Int)
(declare-fun $abort_flag@9@@2 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@2 () T@$TypeValue)
(declare-fun inline$$Diem_Diem_unpack$0$value@1@@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun preburn_address@@2 () T@$Value)
(declare-fun inline$$Diem_BurnEvent_pack$0$$struct@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$9$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$9$size@1@@2 () Int)
(declare-fun inline$$BorrowField$9$p@2@@2 () T@$Path)
(declare-fun inline$$ReadRef$6$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$8$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1@@2 () Int)
(declare-fun inline$$BorrowField$8$p@2@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1@@2 () T@$Mutation)
(declare-fun inline$$Sub$1$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$7$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1@@2 () Int)
(declare-fun inline$$BorrowField$7$p@2@@2 () T@$Path)
(declare-fun inline$$Sub$1$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1@@2 () T@$Value)
(declare-fun inline$$Sub$1$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$6$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@2 () Int)
(declare-fun inline$$BorrowField$6$p@2@@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1@@2 () T@$Value)
(declare-fun $abort_code@13@@2 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@2| () T@$Memory)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@2 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@2 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@2 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$t36@1 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@2 () Int)
(declare-fun inline$$BorrowField$5$p@2@@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@2 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@2 () Int)
(declare-fun inline$$BorrowField$4$p@2@@2 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@2 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1@@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@2 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0@@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@2 () Int)
(declare-fun inline$$BorrowField$3$p@2@@2 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@2 () T@$Value)
(declare-fun $abort_code@9@@3 () Int)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@2 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1@@2 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0@@2 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@2 () Int)
(declare-fun inline$$BorrowField$2$p@2@@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@2 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@6 () T@$Value)
(declare-fun call4formal@$ret0@0@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@2| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@2| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@2| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@2 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@2 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@2| () T@$Mutation)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@2 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@2 () Int)
(declare-fun inline$$BorrowField$1$p@2@@2 () T@$Path)
(declare-fun inline$$Gt$0$dst@1@@2 () T@$Value)
(declare-fun $abort_code@3@@7 () Int)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$t19@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@7 () T@$Value)
(declare-fun inline$$Diem_burn_with_resource_cap_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@2 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@2 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@2 () Int)
(declare-fun inline$$BorrowField$0$p@2@@2 () T@$Path)
(declare-fun _capability () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 402787) (let ((anon0$2_correct@@9  (and (=> (= (ControlFlow 0 234251) (- 0 414614)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@11@@2)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@11@@2) (and (=> (= (ControlFlow 0 234251) (- 0 414633)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@2)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@2) (and (=> (= (ControlFlow 0 234251) (- 0 414661)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@2)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@2) (and (=> (= (ControlFlow 0 234251) (- 0 414689)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@11@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@11@@2) (and (=> (= (ControlFlow 0 234251) (- 0 414705)) (=> $abort_flag@11@@2 (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@11@@2 (or (or (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 414793)) (=> $abort_flag@11@@2 (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@11@@2 (or (or (or (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 234251) (- 0 414925)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 234251) (- 0 414972)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415019)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415065)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@128 T@$Value) )  (=> ((_ is $Address) addr@@128) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@128))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@128)))))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@129 T@$Value) )  (=> ((_ is $Address) addr@@129) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@129))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@129))))))))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415145)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@130 T@$Value) )  (=> ((_ is $Address) addr@@130) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@130)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@130))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@131 T@$Value) )  (=> ((_ is $Address) addr@@131) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@131)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@131)))))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415213)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@132 T@$Value) )  (=> ((_ is $Address) addr@@132) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@132))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@132)))))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@133 T@$Value) )  (=> ((_ is $Address) addr@@133) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@133))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@133))))))))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415293)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@134 T@$Value) )  (=> ((_ is $Address) addr@@134) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@134)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@134))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@135 T@$Value) )  (=> ((_ is $Address) addr@@135) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@135)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@135)))))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415361)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415407)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@136 T@$Value) )  (=> ((_ is $Address) addr@@136) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@136))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@136)))))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@137 T@$Value) )  (=> ((_ is $Address) addr@@137) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@137))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@137))))))))))))))) (and (=> (= (ControlFlow 0 234251) (- 0 415487)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@138 T@$Value) )  (=> ((_ is $Address) addr@@138) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@138)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@138))))))))))))) (=> (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean (forall ((addr@@139 T@$Value) )  (=> ((_ is $Address) addr@@139) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@139)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@139)))))))))))) (=> (= (ControlFlow 0 234251) (- 0 415555)) (=> (not $abort_flag@11@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon82_correct  (=> (and (and (= $abort_code@16@@2 $abort_code@14@@2) (= $abort_flag@11@@2 $abort_flag@10@@2)) (and (= $Diem_CurrencyInfo_$memory@2@@2 $Diem_CurrencyInfo_$memory@0@@2) (= (ControlFlow 0 232414) 234251))) anon0$2_correct@@9)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 232412) 232414)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Then_correct  (=> (= (ControlFlow 0 232422) 232414) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon82_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon80$3_correct  (and (=> (= (ControlFlow 0 233927) (- 0 414047)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 233927) (- 0 414171)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 233927) (- 0 414224)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@2 |inline$$WritebackToGlobal$2$m'@2@@2|) (and (=> (= (ControlFlow 0 233927) 232422) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 233927) 232412) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 233606) 233927)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon80$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@2) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@2)) (= inline$$WritebackToGlobal$2$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@2 inline$$WritebackToGlobal$2$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@2|))) (= |inline$$WritebackToGlobal$2$m'@1@@2| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@2 inline$$WritebackToGlobal$2$a@1@@2 inline$$WritebackToGlobal$2$v@1@@2)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@2| |inline$$WritebackToGlobal$2$m'@1@@2|) (= (ControlFlow 0 233660) 233927))) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon80$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$2$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2@@2|)) (and (=> (= (ControlFlow 0 233596) 233660) inline$$WritebackToGlobal$2$anon3_Then_correct@@2) (=> (= (ControlFlow 0 233596) 233606) inline$$WritebackToGlobal$2$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon80$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 233666) 233596)) inline$$WritebackToGlobal$2$anon0_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@2  (and (=> (= (ControlFlow 0 233349) (- 0 413765)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 233349) 233666) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon80$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@2  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2@@2|)) (= (ControlFlow 0 233301) 233349)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@2)))
(let ((inline$$WritebackToReference$3$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@2 inline$$WritebackToReference$3$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$3$dst'@2@@2| |inline$$WritebackToReference$2$dst'@2@@2|) (= (ControlFlow 0 233170) 233301)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@2))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) (|l#$Mutation| |inline$$WriteRef$3$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$3$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1@@2 inline$$WritebackToReference$3$srcPath@1@@2)) (= |inline$$WritebackToReference$3$dst'@1@@2| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) inline$$WritebackToReference$3$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$3$dstPath@1@@2) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) (|v#$Mutation| |inline$$WriteRef$3$to'@1@@2|))))) (and (= |inline$$WritebackToReference$3$dst'@2@@2| |inline$$WritebackToReference$3$dst'@1@@2|) (= (ControlFlow 0 233226) 233301))) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@2)))
(let ((inline$$WritebackToReference$3$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$3$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$3$to'@1@@2|)) (= inline$$WritebackToReference$3$dstPath@1@@2 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|))) (and (=> (= (ControlFlow 0 233134) 233226) inline$$WritebackToReference$3$anon3_Then_correct@@2) (=> (= (ControlFlow 0 233134) 233170) inline$$WritebackToReference$3$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon122_Else_correct  (=> (and (not true) (= (ControlFlow 0 232997) 233134)) inline$$WritebackToReference$3$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon122_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (= (ControlFlow 0 233937) 233134)) inline$$WritebackToReference$3$anon0_correct@@2)))
(let ((inline$$WriteRef$3$anon0_correct@@2  (=> (= |inline$$WriteRef$3$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$9$dst@1@@2) (|p#$Mutation| inline$$BorrowField$9$dst@1@@2) inline$$ReadRef$7$v@1@@2)) (and (=> (= (ControlFlow 0 232983) 233937) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon122_Then_correct) (=> (= (ControlFlow 0 232983) 232997) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon122_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon120_Else_correct  (=> (and (not $abort_flag@10@@2) (= (ControlFlow 0 232989) 232983)) inline$$WriteRef$3$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else$2_correct  (and (=> (= (ControlFlow 0 232402) (- 0 413111)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@2 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@3 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 232402) (- 0 413235)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 232402) (- 0 413288)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@2 |inline$$WritebackToGlobal$1$m'@2@@2|) (and (=> (= (ControlFlow 0 232402) 232422) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 232402) 232412) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon123_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 232081) 232402)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@2) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@2)) (= inline$$WritebackToGlobal$1$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@2 inline$$WritebackToGlobal$1$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|))) (= |inline$$WritebackToGlobal$1$m'@1@@2| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@2 inline$$WritebackToGlobal$1$a@1@@2 inline$$WritebackToGlobal$1$v@1@@2)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@2| |inline$$WritebackToGlobal$1$m'@1@@2|) (= (ControlFlow 0 232135) 232402))) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$1$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (and (=> (= (ControlFlow 0 232071) 232135) inline$$WritebackToGlobal$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 232071) 232081) inline$$WritebackToGlobal$1$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@4 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 232141) 232071)) inline$$WritebackToGlobal$1$anon0_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@2  (and (=> (= (ControlFlow 0 231824) (- 0 412829)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 231824) 232141) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@2  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (= (ControlFlow 0 231776) 231824)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@3)) (= (ControlFlow 0 231828) 231776)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct  (=> (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@16@@2 $abort_code@15@@2) (= $abort_flag@11@@2 true)) (and (= $Diem_CurrencyInfo_$memory@2@@2 $Diem_CurrencyInfo_$memory@1@@2) (= (ControlFlow 0 227013) 234251))) anon0$2_correct@@9))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon9_correct  (=> (= $abort_code@15@@2 $abort_code@1@@8) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234211) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 234209) 234211)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 234219) 234211) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Then_correct  (=> $abort_flag@0@@8 (and (=> (= (ControlFlow 0 234203) 234219) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 234203) 234209) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon13_correct  (=> (= $abort_code@15@@2 $abort_code@2@@6) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234191) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 234189) 234191)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon89_Then_correct  (=> (= (ControlFlow 0 234199) 234191) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon88_Then_correct  (=> $abort_flag@1@@8 (and (=> (= (ControlFlow 0 234183) 234199) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 234183) 234189) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon21_correct  (=> (= $abort_code@15@@2 $abort_code@4@@6) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234171) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 234169) 234171)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 234179) 234171) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon92_Then_correct  (=> $abort_flag@2@@7 (and (=> (= (ControlFlow 0 234163) 234179) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 234163) 234169) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon29_correct  (=> (= $abort_code@15@@2 $abort_code@5@@4) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234133) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 234131) 234133)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon97_Then_correct  (=> (= (ControlFlow 0 234141) 234133) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon96_Then_correct  (=> $abort_flag@3@@5 (and (=> (= (ControlFlow 0 234125) 234141) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 234125) 234131) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon35_correct  (=> (= $abort_code@15@@2 $abort_code@6@@4) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234109) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon100_Else_correct  (=> (and (not true) (= (ControlFlow 0 234107) 234109)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon100_Then_correct  (=> (= (ControlFlow 0 234117) 234109) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon35_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Then_correct  (=> $abort_flag@4@@5 (and (=> (= (ControlFlow 0 234101) 234117) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 234101) 234107) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon39_correct  (=> (= $abort_code@15@@2 $abort_code@7@@4) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234089) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon102_Else_correct  (=> (and (not true) (= (ControlFlow 0 234087) 234089)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon102_Then_correct  (=> (= (ControlFlow 0 234097) 234089) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon39_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Then_correct  (=> $abort_flag@5@@4 (and (=> (= (ControlFlow 0 234081) 234097) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 234081) 234087) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon43_correct  (=> (= $abort_code@15@@2 $abort_code@8@@3) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234069) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon104_Else_correct  (=> (and (not true) (= (ControlFlow 0 234067) 234069)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon104_Then_correct  (=> (= (ControlFlow 0 234077) 234069) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon43_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon103_Then_correct  (=> $abort_flag@6@@4 (and (=> (= (ControlFlow 0 234061) 234077) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 234061) 234067) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon51_correct  (=> (= $abort_code@15@@2 $abort_code@10@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234049) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon108_Else_correct  (=> (and (not true) (= (ControlFlow 0 234047) 234049)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon108_Then_correct  (=> (= (ControlFlow 0 234057) 234049) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon51_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Then_correct  (=> $abort_flag@7@@2 (and (=> (= (ControlFlow 0 234041) 234057) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 234041) 234047) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon55_correct  (=> (= $abort_code@15@@2 $abort_code@11@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234029) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 234027) 234029)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon110_Then_correct  (=> (= (ControlFlow 0 234037) 234029) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon55_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Then_correct  (=> $abort_flag@8@@2 (and (=> (= (ControlFlow 0 234021) 234037) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 234021) 234027) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon110_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon61_correct  (=> (= $abort_code@15@@2 $abort_code@12@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 233999) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon113_Else_correct  (=> (and (not true) (= (ControlFlow 0 233997) 233999)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon113_Then_correct  (=> (= (ControlFlow 0 234007) 233999) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon61_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon112_Then_correct  (=> $abort_flag@9@@2 (and (=> (= (ControlFlow 0 233991) 234007) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 233991) 233997) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon69_correct  (=> (= $abort_code@15@@2 $abort_code@14@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 233979) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 233977) 233979)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon117_Then_correct  (=> (= (ControlFlow 0 233987) 233979) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon69_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Then_correct  (=> $abort_flag@10@@2 (and (=> (= (ControlFlow 0 233971) 233987) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 233971) 233977) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon117_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon77_correct  (=> (= $abort_code@15@@2 $abort_code@14@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 233949) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 233947) 233949)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon121_Then_correct  (=> (= (ControlFlow 0 233957) 233949) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon77_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon120_Then_correct  (=> $abort_flag@10@@2 (and (=> (= (ControlFlow 0 233941) 233957) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon121_Then_correct) (=> (= (ControlFlow 0 233941) 233947) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon121_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@2  (=> (= inline$$Event_emit_event$0$t@0@@2 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 232914) 233941) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 232914) 232989) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon120_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Then$3_correct  (and (=> (= (ControlFlow 0 232924) (- 0 413568)) true) (=> (= (ControlFlow 0 232924) 232914) inline$$Event_emit_event$0$Entry_correct@@2))))
(let ((inline$$ReadRef$7$anon0_correct@@2  (=> (and (= inline$$ReadRef$7$v@1@@2 (|v#$Mutation| inline$$BorrowField$9$dst@1@@2)) (= (ControlFlow 0 232866) 232924)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Then$3_correct)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 232822) 232866)) inline$$ReadRef$7$anon0_correct@@2)))
(let ((inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@2  (=> (= (ControlFlow 0 232828) 232866) inline$$ReadRef$7$anon0_correct@@2)))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@2  (=> (> 0 0) (and (=> (= (ControlFlow 0 232816) 232828) inline$$Diem_BurnEvent_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 232816) 232822) inline$$Diem_BurnEvent_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@2  (=> (and (>= 0 0) (= (ControlFlow 0 232808) 232866)) inline$$ReadRef$7$anon0_correct@@2)))
(let ((inline$$Diem_BurnEvent_pack$0$anon0_correct@@2  (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@2) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@21) (let ((va@@170 (|v#$Vector| call3formal@$ret0@0@@21)))
(let ((l@@170 (|l#$ValueArray| va@@170)))
 (and (and (<= 0 l@@170) (<= l@@170 $MAX_U64)) (forall ((x@@170 Int) ) (!  (=> (or (< x@@170 0) (>= x@@170 l@@170)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170))
)))))) (forall ((inline$$Diem_BurnEvent_pack$0$$$0@@2 Int) ) (!  (=> (and (>= inline$$Diem_BurnEvent_pack$0$$$0@@2 0) (< inline$$Diem_BurnEvent_pack$0$$$0@@2 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) inline$$Diem_BurnEvent_pack$0$$$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) inline$$Diem_BurnEvent_pack$0$$$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) inline$$Diem_BurnEvent_pack$0$$$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) inline$$Diem_BurnEvent_pack$0$$$0@@2))
))) (and ((_ is $Address) preburn_address@@2) (= inline$$Diem_BurnEvent_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_Diem_unpack$0$value@1@@2) 1 call3formal@$ret0@0@@21) 2 preburn_address@@2) 3))))) (and (=> (= (ControlFlow 0 232800) 232816) inline$$Diem_BurnEvent_pack$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 232800) 232808) inline$$Diem_BurnEvent_pack$0$anon3_Else_correct@@2))))))
(let ((inline$$BorrowField$9$anon0_correct@@2  (=> (= inline$$BorrowField$9$p@1@@2 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (=> (and (and (= inline$$BorrowField$9$size@1@@2 (|size#$Path| inline$$BorrowField$9$p@1@@2)) (= inline$$BorrowField$9$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$9$p@1@@2) inline$$BorrowField$9$size@1@@2 $Diem_CurrencyInfo_burn_events) (+ inline$$BorrowField$9$size@1@@2 1)))) (and (= inline$$BorrowField$9$dst@1@@2 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) inline$$BorrowField$9$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|))) $Diem_CurrencyInfo_burn_events))) (= (ControlFlow 0 232544) 232800))) inline$$Diem_BurnEvent_pack$0$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@3) (= (ControlFlow 0 232550) 232544)) inline$$BorrowField$9$anon0_correct@@2)))
(let ((inline$$Not$0$anon0_correct@@3  (=> (= inline$$Not$0$dst@1@@3 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$6$v@1@@2)))) (and (=> (= (ControlFlow 0 231693) 232550) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Then_correct) (=> (= (ControlFlow 0 231693) 231828) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon119_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 231683) (- 0 412790)) true) (=> (= (ControlFlow 0 231683) 231693) inline$$Not$0$anon0_correct@@3))))
(let ((inline$$ReadRef$6$anon0_correct@@2  (=> (and (= inline$$ReadRef$6$v@1@@2 (|v#$Mutation| inline$$BorrowField$8$dst@1@@2)) (= (ControlFlow 0 231635) 231683)) inline$$Not$0$Entry_correct@@3)))
(let ((inline$$BorrowField$8$anon0_correct@@2  (=> (= inline$$BorrowField$8$p@1@@2 (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|)) (=> (and (and (= inline$$BorrowField$8$size@1@@2 (|size#$Path| inline$$BorrowField$8$p@1@@2)) (= inline$$BorrowField$8$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1@@2) inline$$BorrowField$8$size@1@@2 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$8$size@1@@2 1)))) (and (= inline$$BorrowField$8$dst@1@@2 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|) inline$$BorrowField$8$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 231597) 231635))) inline$$ReadRef$6$anon0_correct@@2))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@2 inline$$WritebackToReference$2$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@2| |inline$$WritebackToReference$1$dst'@2@@2|) (= (ControlFlow 0 231381) 231597)) inline$$BorrowField$8$anon0_correct@@2))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@2 inline$$WritebackToReference$2$srcPath@1@@2)) (= |inline$$WritebackToReference$2$dst'@1@@2| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) inline$$WritebackToReference$2$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@2) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@2|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@2| |inline$$WritebackToReference$2$dst'@1@@2|) (= (ControlFlow 0 231437) 231597))) inline$$BorrowField$8$anon0_correct@@2)))
(let ((inline$$WritebackToReference$2$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@2|)) (= inline$$WritebackToReference$2$dstPath@1@@2 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) (and (=> (= (ControlFlow 0 231345) 231437) inline$$WritebackToReference$2$anon3_Then_correct@@2) (=> (= (ControlFlow 0 231345) 231381) inline$$WritebackToReference$2$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon118_Else_correct  (=> (and (not true) (= (ControlFlow 0 231208) 231345)) inline$$WritebackToReference$2$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon118_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (= (ControlFlow 0 233967) 231345)) inline$$WritebackToReference$2$anon0_correct@@2)))
(let ((inline$$WriteRef$2$anon0_correct@@2  (=> (= |inline$$WriteRef$2$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$7$dst@1@@2) (|p#$Mutation| inline$$BorrowField$7$dst@1@@2) inline$$Sub$1$dst@2@@2)) (and (=> (= (ControlFlow 0 231194) 233967) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 231194) 231208) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon118_Else_correct)))))
(let ((inline$$BorrowField$7$anon0_correct@@2  (=> (= inline$$BorrowField$7$p@1@@2 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (=> (and (and (= inline$$BorrowField$7$size@1@@2 (|size#$Path| inline$$BorrowField$7$p@1@@2)) (= inline$$BorrowField$7$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1@@2) inline$$BorrowField$7$size@1@@2 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$7$size@1@@2 1)))) (and (= inline$$BorrowField$7$dst@1@@2 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) inline$$BorrowField$7$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 231135) 231194))) inline$$WriteRef$2$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Else_correct  (=> (and (not $abort_flag@10@@2) (= (ControlFlow 0 231141) 231135)) inline$$BorrowField$7$anon0_correct@@2)))
(let ((inline$$Sub$1$anon3_Then$1_correct@@2  (=> (= $abort_flag@10@@2 true) (=> (and (= $abort_code@14@@2 $EXEC_FAILURE_CODE) (= inline$$Sub$1$dst@2@@2 inline$$Sub$1$dst@0@@2)) (and (=> (= (ControlFlow 0 231005) 233971) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 231005) 231141) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Else_correct))))))
(let ((inline$$Sub$1$anon3_Then_correct@@2  (=> (and (< (|i#$Integer| inline$$ReadRef$5$v@1@@2) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2)) (= (ControlFlow 0 231003) 231005)) inline$$Sub$1$anon3_Then$1_correct@@2)))
(let ((inline$$Sub$1$anon3_Else_correct@@2  (=> (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) (|i#$Integer| inline$$ReadRef$5$v@1@@2)) (=> (and (and (= inline$$Sub$1$dst@1@@2 ($Integer (- (|i#$Integer| inline$$ReadRef$5$v@1@@2) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2)))) (= $abort_flag@10@@2 $abort_flag@9@@2)) (and (= $abort_code@14@@2 $abort_code@12@@2) (= inline$$Sub$1$dst@2@@2 inline$$Sub$1$dst@1@@2))) (and (=> (= (ControlFlow 0 230951) 233971) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 230951) 231141) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon116_Else_correct))))))
(let ((inline$$Sub$1$Entry_correct@@2  (and (=> (= (ControlFlow 0 230925) (- 0 412372)) true) (and (=> (= (ControlFlow 0 230925) 231003) inline$$Sub$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 230925) 230951) inline$$Sub$1$anon3_Else_correct@@2)))))
(let ((inline$$ReadRef$5$anon0_correct@@2  (=> (and (= inline$$ReadRef$5$v@1@@2 (|v#$Mutation| inline$$BorrowField$6$dst@1@@2)) (= (ControlFlow 0 230826) 230925)) inline$$Sub$1$Entry_correct@@2)))
(let ((inline$$BorrowField$6$anon0_correct@@2  (=> (= inline$$BorrowField$6$p@1@@2 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (=> (and (and (= inline$$BorrowField$6$size@1@@2 (|size#$Path| inline$$BorrowField$6$p@1@@2)) (= inline$$BorrowField$6$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@2) inline$$BorrowField$6$size@1@@2 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1@@2 1)))) (and (= inline$$BorrowField$6$dst@1@@2 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) inline$$BorrowField$6$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 230788) 230826))) inline$$ReadRef$5$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1@@2) (= (ControlFlow 0 230840) 230788)) inline$$BorrowField$6$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon66_correct  (=> (= $abort_code@15@@2 $abort_code@13@@2) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 |inline$$WritebackToGlobal$0$m'@2@@2|) (= (ControlFlow 0 230622) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 230620) 230622)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon115_Then_correct  (=> (= (ControlFlow 0 230630) 230622) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon66_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else$2_correct  (and (=> (= (ControlFlow 0 230614) (- 0 411993)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@5) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@5))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@5 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@5)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@6) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@6))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@6 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@6))))))))))))))))))))) (and (=> (= (ControlFlow 0 230614) (- 0 412117)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@15 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@16 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$addr3@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 230614) (- 0 412170)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@17 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@17) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@3)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@18 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@18) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$dr_addr@@4))))))))))))))) (=> (= $abort_code@13@@2 (|i#$Integer| call3formal@$ret0@0@@22)) (and (=> (= (ControlFlow 0 230614) 230630) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 230614) 230620) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon115_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@2  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 230289) 230614)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@2  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@2) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@2 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@2)) (= inline$$WritebackToGlobal$0$a@1@@2 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@2))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@2 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) (= |inline$$WritebackToGlobal$0$m'@1@@2| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@2 inline$$WritebackToGlobal$0$a@1@@2 inline$$WritebackToGlobal$0$v@1@@2)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@2| |inline$$WritebackToGlobal$0$m'@1@@2|) (= (ControlFlow 0 230343) 230614))) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@2  (=> (= inline$$WritebackToGlobal$0$l@1@@2 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (and (=> (= (ControlFlow 0 230279) 230343) inline$$WritebackToGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 230279) 230289) inline$$WritebackToGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19 T@$Value) )  (=> ((_ is $Type) inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@7) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_burn_with_resource_cap_$def_verify$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@7))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner1@@7 inline$$Diem_burn_with_resource_cap_$def_verify$0$mint_cap_owner2@@7))))))))))))))))))))) (= (ControlFlow 0 230349) 230279)) inline$$WritebackToGlobal$0$anon0_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@2  (and (=> (= (ControlFlow 0 230032) (- 0 411711)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 230032) 230349) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@2  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@2 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (= (ControlFlow 0 229984) 230032)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1@@2)) (= (ControlFlow 0 230036) 229984)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon112_Else_correct  (=> (not $abort_flag@9@@2) (and (=> (= (ControlFlow 0 229909) 230840) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 229909) 230036) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon114_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon58$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$t36@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9@@2)) (and (=> $abort_flag@9@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@22 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@22) (>= (|i#$Integer| call3formal@$ret0@0@@22) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@22) $MAX_U64))) (and (=> (= (ControlFlow 0 229903) 233991) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 229903) 229909) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$Ge$1$anon0_correct@@2  (=> (and (= inline$$Ge$1$dst@1@@2 ($Boolean (>= (|i#$Integer| inline$$ReadRef$4$v@1@@2) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2)))) (= (ControlFlow 0 229891) 229903)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon58$3_correct)))
(let ((inline$$Ge$1$Entry_correct@@2  (and (=> (= (ControlFlow 0 229877) (- 0 411601)) true) (=> (= (ControlFlow 0 229877) 229891) inline$$Ge$1$anon0_correct@@2))))
(let ((inline$$ReadRef$4$anon0_correct@@2  (=> (and (= inline$$ReadRef$4$v@1@@2 (|v#$Mutation| inline$$BorrowField$5$dst@1@@2)) (= (ControlFlow 0 229819) 229877)) inline$$Ge$1$Entry_correct@@2)))
(let ((inline$$BorrowField$5$anon0_correct@@2  (=> (= inline$$BorrowField$5$p@1@@2 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|)) (=> (and (and (= inline$$BorrowField$5$size@1@@2 (|size#$Path| inline$$BorrowField$5$p@1@@2)) (= inline$$BorrowField$5$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@2) inline$$BorrowField$5$size@1@@2 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1@@2 1)))) (and (= inline$$BorrowField$5$dst@1@@2 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|) inline$$BorrowField$5$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@2|))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 229781) 229819))) inline$$ReadRef$4$anon0_correct@@2))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@2  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@2| inline$$BorrowGlobal$0$dst@2@@2) (= (ControlFlow 0 229565) 229781)) inline$$BorrowField$5$anon0_correct@@2))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@2  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@2 inline$$WritebackToReference$1$srcPath@1@@2)) (= |inline$$WritebackToReference$1$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$WritebackToReference$1$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@2) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@2|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@2| |inline$$WritebackToReference$1$dst'@1@@2|) (= (ControlFlow 0 229621) 229781))) inline$$BorrowField$5$anon0_correct@@2)))
(let ((inline$$WritebackToReference$1$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@2|)) (= inline$$WritebackToReference$1$dstPath@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) (and (=> (= (ControlFlow 0 229529) 229621) inline$$WritebackToReference$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 229529) 229565) inline$$WritebackToReference$1$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 229392) 229529)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon111_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 234017) 229529)) inline$$WritebackToReference$1$anon0_correct@@2)))
(let ((inline$$WriteRef$1$anon0_correct@@2  (=> (= |inline$$WriteRef$1$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@2) (|p#$Mutation| inline$$BorrowField$4$dst@1@@2) inline$$Sub$0$dst@2@@2)) (and (=> (= (ControlFlow 0 229378) 234017) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 229378) 229392) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct@@2  (=> (= inline$$BorrowField$4$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$4$size@1@@2 (|size#$Path| inline$$BorrowField$4$p@1@@2)) (= inline$$BorrowField$4$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@2) inline$$BorrowField$4$size@1@@2 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$4$size@1@@2 1)))) (and (= inline$$BorrowField$4$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$4$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 229319) 229378))) inline$$WriteRef$1$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Else_correct  (=> (and (not $abort_flag@8@@2) (= (ControlFlow 0 229325) 229319)) inline$$BorrowField$4$anon0_correct@@2)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@2  (=> (= $abort_code@11@@2 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@8@@2 true) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@0@@2)) (and (=> (= (ControlFlow 0 229189) 234021) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 229189) 229325) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@2  (=> (and (< (|i#$Integer| inline$$ReadRef$3$v@1@@2) (|i#$Integer| inline$$CastU128$1$dst@1@@2)) (= (ControlFlow 0 229187) 229189)) inline$$Sub$0$anon3_Then$1_correct@@2)))
(let ((inline$$Sub$0$anon3_Else_correct@@2  (=> (<= (|i#$Integer| inline$$CastU128$1$dst@1@@2) (|i#$Integer| inline$$ReadRef$3$v@1@@2)) (=> (and (and (= inline$$Sub$0$dst@1@@2 ($Integer (- (|i#$Integer| inline$$ReadRef$3$v@1@@2) (|i#$Integer| inline$$CastU128$1$dst@1@@2)))) (= $abort_code@11@@2 $abort_code@10@@2)) (and (= $abort_flag@8@@2 $abort_flag@7@@2) (= inline$$Sub$0$dst@2@@2 inline$$Sub$0$dst@1@@2))) (and (=> (= (ControlFlow 0 229135) 234021) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 229135) 229325) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon109_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 229109) (- 0 411181)) true) (and (=> (= (ControlFlow 0 229109) 229187) inline$$Sub$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 229109) 229135) inline$$Sub$0$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Else_correct  (=> (and (not $abort_flag@7@@2) (= (ControlFlow 0 229195) 229109)) inline$$Sub$0$Entry_correct@@2)))
(let ((inline$$CastU128$1$anon3_Then$1_correct@@2  (=> (= $abort_flag@7@@2 true) (=> (and (= $abort_code@10@@2 $EXEC_FAILURE_CODE) (= inline$$CastU128$1$dst@1@@2 inline$$CastU128$1$dst@0@@2)) (and (=> (= (ControlFlow 0 229012) 234041) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 229012) 229195) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct@@2  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) $MAX_U128) (= (ControlFlow 0 229010) 229012)) inline$$CastU128$1$anon3_Then$1_correct@@2)))
(let ((inline$$CastU128$1$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2)) (= $abort_flag@7@@2 $abort_flag@6@@4)) (and (= $abort_code@10@@2 $abort_code@8@@3) (= inline$$CastU128$1$dst@1@@2 inline$$Diem_Diem_unpack$0$value@1@@2))) (and (=> (= (ControlFlow 0 228960) 234041) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 228960) 229195) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct@@2  (and (=> (= (ControlFlow 0 228946) (- 0 411109)) true) (and (=> (= (ControlFlow 0 228946) 229010) inline$$CastU128$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 228946) 228960) inline$$CastU128$1$anon3_Else_correct@@2)))))
(let ((inline$$ReadRef$3$anon0_correct@@2  (=> (and (= inline$$ReadRef$3$v@1@@2 (|v#$Mutation| inline$$BorrowField$3$dst@1@@2)) (= (ControlFlow 0 228865) 228946)) inline$$CastU128$1$Entry_correct@@2)))
(let ((inline$$BorrowField$3$anon0_correct@@2  (=> (= inline$$BorrowField$3$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$3$size@1@@2 (|size#$Path| inline$$BorrowField$3$p@1@@2)) (= inline$$BorrowField$3$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@2) inline$$BorrowField$3$size@1@@2 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$3$size@1@@2 1)))) (and (= inline$$BorrowField$3$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$3$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 228827) 228865))) inline$$ReadRef$3$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@2) (= (ControlFlow 0 228879) 228827)) inline$$BorrowField$3$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon48_correct  (=> (= $abort_code@15@@2 $abort_code@9@@3) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 228661) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon106_Else_correct  (=> (and (not true) (= (ControlFlow 0 228659) 228661)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon106_Then_correct  (=> (= (ControlFlow 0 228669) 228661) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon48_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Else$1_correct  (=> (= $abort_code@9@@3 (|i#$Integer| call3formal@$ret0@0@@23)) (and (=> (= (ControlFlow 0 228653) 228669) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 228653) 228659) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@2  (and (=> (= (ControlFlow 0 228643) (- 0 410943)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 228643) 228653) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@2  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 228595) 228643)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@2)) (= (ControlFlow 0 228647) 228595)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon103_Else_correct  (=> (not $abort_flag@6@@4) (and (=> (= (ControlFlow 0 228520) 228879) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 228520) 228647) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon105_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Else$1_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$t28@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@4)) (and (=> $abort_flag@6@@4 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@23 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@23) (>= (|i#$Integer| call3formal@$ret0@0@@23) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@23) $MAX_U64))) (and (=> (= (ControlFlow 0 228514) 234061) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 228514) 228520) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@2  (=> (and (= inline$$Ge$0$dst@1@@2 ($Boolean (>= (|i#$Integer| inline$$ReadRef$2$v@1@@2) (|i#$Integer| inline$$CastU128$0$dst@1@@2)))) (= (ControlFlow 0 228502) 228514)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 228488) (- 0 410833)) true) (=> (= (ControlFlow 0 228488) 228502) inline$$Ge$0$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Else_correct  (=> (and (not $abort_flag@5@@4) (= (ControlFlow 0 228508) 228488)) inline$$Ge$0$Entry_correct@@2)))
(let ((inline$$CastU128$0$anon3_Then$1_correct@@2  (=> (= $abort_code@7@@4 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@5@@4 true) (= inline$$CastU128$0$dst@1@@2 inline$$CastU128$0$dst@0@@2)) (and (=> (= (ControlFlow 0 228432) 234081) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 228432) 228508) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct@@2  (=> (and (> (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) $MAX_U128) (= (ControlFlow 0 228430) 228432)) inline$$CastU128$0$anon3_Then$1_correct@@2)))
(let ((inline$$CastU128$0$anon3_Else_correct@@2  (=> (and (and (>= $MAX_U128 (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2)) (= $abort_code@7@@4 $abort_code@6@@4)) (and (= $abort_flag@5@@4 $abort_flag@4@@5) (= inline$$CastU128$0$dst@1@@2 inline$$Diem_Diem_unpack$0$value@1@@2))) (and (=> (= (ControlFlow 0 228380) 234081) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 228380) 228508) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 228366) (- 0 410761)) true) (and (=> (= (ControlFlow 0 228366) 228430) inline$$CastU128$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 228366) 228380) inline$$CastU128$0$anon3_Else_correct@@2)))))
(let ((inline$$ReadRef$2$anon0_correct@@2  (=> (and (= inline$$ReadRef$2$v@1@@2 (|v#$Mutation| inline$$BorrowField$2$dst@1@@2)) (= (ControlFlow 0 228285) 228366)) inline$$CastU128$0$Entry_correct@@2)))
(let ((inline$$BorrowField$2$anon0_correct@@2  (=> (= inline$$BorrowField$2$p@1@@2 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (=> (and (and (= inline$$BorrowField$2$size@1@@2 (|size#$Path| inline$$BorrowField$2$p@1@@2)) (= inline$$BorrowField$2$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@2) inline$$BorrowField$2$size@1@@2 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$2$size@1@@2 1)))) (and (= inline$$BorrowField$2$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@2) inline$$BorrowField$2$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 228247) 228285))) inline$$ReadRef$2$anon0_correct@@2))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@2  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@2)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@2)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 228089) 228247)) inline$$BorrowField$2$anon0_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@2  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@2)) (= (ControlFlow 0 228083) 228089)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Else_correct  (=> (and (not $abort_flag@4@@5) (= (ControlFlow 0 228093) 228083)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@4@@5 true) (=> (and (= $abort_code@6@@4 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@0@@2)) (and (=> (= (ControlFlow 0 228043) 234101) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 228043) 228093) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2)) (= (ControlFlow 0 228041) 228043)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@2 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@2 inline$$BorrowGlobal$0$a@1@@2))) (= $abort_flag@4@@5 $abort_flag@3@@5)) (and (= $abort_code@6@@4 $abort_code@5@@4) (= inline$$BorrowGlobal$0$dst@2@@2 inline$$BorrowGlobal$0$dst@1@@2))) (and (=> (= (ControlFlow 0 227989) 234101) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 227989) 228093) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon99_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@2  (=> (= inline$$BorrowGlobal$0$a@1@@2 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@6)) (and (=> (= (ControlFlow 0 227959) 228041) inline$$BorrowGlobal$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 227959) 227989) inline$$BorrowGlobal$0$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@2  (=> (= inline$$BorrowGlobal$0$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1)) (and (=> (= (ControlFlow 0 227953) (- 0 410548)) true) (=> (= (ControlFlow 0 227953) 227959) inline$$BorrowGlobal$0$anon0_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Else_correct  (=> (and (not $abort_flag@3@@5) (= (ControlFlow 0 228049) 227953)) inline$$BorrowGlobal$0$Entry_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Then_correct  (=> (and (and $abort_flag@3@@5 (= $abort_code@15@@2 $abort_code@5@@4)) (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 234121) 227013))) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@6  (=> (not true) (and (=> (= (ControlFlow 0 227810) 234121) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 227810) 228049) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@6  (and (=> (= (ControlFlow 0 227820) 234121) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 227820) 228049) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon98_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@6  (=> (and (not $abort_flag@3@@5) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@6 ($Address 173345816))) (and (=> (= (ControlFlow 0 227804) 227820) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 227804) 227810) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@6)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon96_Else_correct  (=> (and (not $abort_flag@3@@5) (= (ControlFlow 0 227834) 227804)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@6)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon26_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@5) (=> $abort_flag@3@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@3@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@4 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@140 T@$Value) )  (=> ((_ is $Address) addr@@140) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@140))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@140))))))))))))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@141 T@$Value) )  (=> ((_ is $Address) addr@@141) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@141)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@141)))))))))))))) (=> (and (and (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@142 T@$Value) )  (=> ((_ is $Address) addr@@142) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@142))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@142)))))))))))))))) (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@143 T@$Value) )  (=> ((_ is $Address) addr@@143) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@143)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@143)))))))))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@144 T@$Value) )  (=> ((_ is $Address) addr@@144) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@144))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@144)))))))))))))))) (and (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean (forall ((addr@@145 T@$Value) )  (=> ((_ is $Address) addr@@145) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@145)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@145)))))))))))) (=> (not $abort_flag@3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 227699) 234125) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 227699) 227834) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon96_Else_correct)))))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 227697) 227699)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon95_Then_correct  (=> (= (ControlFlow 0 234149) 227699) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct@@2  (=> (and ((_ is $Vector) call4formal@$ret0@0@@4) (= inline$$Diem_Diem_unpack$0$value@1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@2) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@2) $MAX_U64)) (and (=> (= (ControlFlow 0 227683) 234149) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 227683) 227697) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon95_Else_correct))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@2  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 12))) (= (ControlFlow 0 227592) 227683)) inline$$Diem_Diem_unpack$0$anon0_correct@@2)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@2  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) ($Local 12)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@2| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|) 0 preburn@@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@2|))) (= (ControlFlow 0 227618) 227683)) inline$$Diem_Diem_unpack$0$anon0_correct@@2))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@2  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2))) (= |inline$$WritebackToReference$0$dst'@2@@2| inline$$BorrowLoc$0$dst@1@@2)) (and (=> (= (ControlFlow 0 227437) 227618) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 227437) 227592) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@2  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@2))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@2 inline$$WritebackToReference$0$srcPath@1@@2)) (and (= |inline$$WritebackToReference$0$dst'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$WritebackToReference$0$dstPath@1@@2 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@2 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@2) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@2|)))) (= |inline$$WritebackToReference$0$dst'@2@@2| |inline$$WritebackToReference$0$dst'@1@@2|))) (and (=> (= (ControlFlow 0 227493) 227618) inline$$WritebackToValue$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 227493) 227592) inline$$WritebackToValue$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@2  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@2 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@2|)) (= inline$$WritebackToReference$0$dstPath@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) (and (=> (= (ControlFlow 0 227401) 227493) inline$$WritebackToReference$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 227401) 227437) inline$$WritebackToReference$0$anon3_Else_correct@@2)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 227264) 227401)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon94_Then_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_burn_with_resource_cap_$def_verify$0$info@0)) (= (ControlFlow 0 234159) 227401)) inline$$WritebackToReference$0$anon0_correct@@2)))
(let ((inline$$WriteRef$0$anon0_correct@@2  (=> (= |inline$$WriteRef$0$to'@1@@2| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@2) (|p#$Mutation| inline$$BorrowField$1$dst@1@@2) call5formal@$ret1@0@@2)) (and (=> (= (ControlFlow 0 227250) 234159) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 227250) 227264) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon92_Else_correct  (=> (and (not $abort_flag@2@@7) (= (ControlFlow 0 227256) 227250)) inline$$WriteRef$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Then$2_correct  (and (=> (= (ControlFlow 0 227193) (- 0 408742)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@7) (=> (and (=> $abort_flag@2@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@2)) $Diem_Diem_value)))))) (=> (and (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@2)) $Diem_Diem_value) ($Integer 0))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@146 T@$Value) )  (=> ((_ is $Address) addr@@146) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@146))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@146))))))))))))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@147 T@$Value) )  (=> ((_ is $Address) addr@@147) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@147)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@147)))))))))))))) (=> (and (and (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@148 T@$Value) )  (=> ((_ is $Address) addr@@148) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@148))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@148)))))))))))))))) (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@149 T@$Value) )  (=> ((_ is $Address) addr@@149) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@149)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@149)))))))))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@150 T@$Value) )  (=> ((_ is $Address) addr@@150) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@150))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@150)))))))))))))))) (and (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean (forall ((addr@@151 T@$Value) )  (=> ((_ is $Address) addr@@151) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@151)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@151)))))))))))) (=> (not $abort_flag@2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@4) (let ((va@@171 (|v#$Vector| call4formal@$ret0@0@@4)))
(let ((l@@171 (|l#$ValueArray| va@@171)))
 (and (and (<= 0 l@@171) (<= l@@171 $MAX_U64)) (forall ((x@@171 Int) ) (!  (=> (or (< x@@171 0) (>= x@@171 l@@171)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@4)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@2) (let ((va@@172 (|v#$Vector| call5formal@$ret1@0@@2)))
(let ((l@@172 (|l#$ValueArray| va@@172)))
 (and (and (<= 0 l@@172) (<= l@@172 $MAX_U64)) (forall ((x@@172 Int) ) (!  (=> (or (< x@@172 0) (>= x@@172 l@@172)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@2)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 227193) 234163) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 227193) 227256) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon92_Else_correct))))))))))
(let ((inline$$ReadRef$1$anon0_correct@@2  (=> (and (= inline$$ReadRef$1$v@1@@2 (|v#$Mutation| inline$$BorrowField$1$dst@1@@2)) (= (ControlFlow 0 227181) 227193)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Then$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@2  (=> (= inline$$BorrowField$1$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@2 (|size#$Path| inline$$BorrowField$1$p@1@@2)) (= inline$$BorrowField$1$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@2) inline$$BorrowField$1$size@1@@2 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1@@2 1)))) (and (= inline$$BorrowField$1$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$1$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 227143) 227181))) inline$$ReadRef$1$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1@@2) (= (ControlFlow 0 227149) 227143)) inline$$BorrowField$1$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon18_correct  (=> (= $abort_code@15@@2 $abort_code@3@@7) (=> (and (= $Diem_CurrencyInfo_$memory@1@@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 227007) 227013)) inline$$Diem_burn_with_resource_cap_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 227005) 227007)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 227021) 227007) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1@@2)) (= $abort_code@3@@7 (|i#$Integer| call3formal@$ret0@0@@24))) (and (=> (= (ControlFlow 0 226999) 227021) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 226999) 227005) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon88_Else_correct  (=> (not $abort_flag@1@@8) (and (=> (= (ControlFlow 0 226987) 227149) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 226987) 226999) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$3_correct  (=> (and (and (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$t19@1 ($Integer 4)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@8)) (and (=> $abort_flag@1@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@24 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@24) (>= (|i#$Integer| call3formal@$ret0@0@@24) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@24) $MAX_U64))) (and (=> (= (ControlFlow 0 226981) 234183) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 226981) 226987) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct@@2  (=> (and (= inline$$Gt$0$dst@1@@2 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@7) (|i#$Integer| inline$$Diem_burn_with_resource_cap_$def_verify$0$$t17@1)))) (= (ControlFlow 0 226969) 226981)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$3_correct)))
(let ((inline$$Gt$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 226955) (- 0 408535)) true) (=> (= (ControlFlow 0 226955) 226969) inline$$Gt$0$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$2_correct  (=> (and (= inline$$Diem_burn_with_resource_cap_$def_verify$0$$t17@1 ($Integer 0)) (= (ControlFlow 0 226975) 226955)) inline$$Gt$0$Entry_correct@@2)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@7  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@2)) $Diem_Diem_value)) (= (ControlFlow 0 226901) 226975)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$2_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$1_correct  (and (=> (= (ControlFlow 0 226907) (- 0 408498)) true) (=> (= (ControlFlow 0 226907) 226901) inline$$GetFieldFromValue$0$anon0_correct@@7))))
(let ((inline$$ReadRef$0$anon0_correct@@2  (=> (and (= inline$$ReadRef$0$v@1@@2 (|v#$Mutation| inline$$BorrowField$0$dst@1@@2)) (= (ControlFlow 0 226841) 226907)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@2  (=> (= inline$$BorrowField$0$p@1@@2 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@2)) (=> (and (and (= inline$$BorrowField$0$size@1@@2 (|size#$Path| inline$$BorrowField$0$p@1@@2)) (= inline$$BorrowField$0$p@2@@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@2) inline$$BorrowField$0$size@1@@2 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@2 1)))) (and (= inline$$BorrowField$0$dst@1@@2 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@2) inline$$BorrowField$0$p@2@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@2))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 226803) 226841))) inline$$ReadRef$0$anon0_correct@@2))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else_correct  (=> (and (not $abort_flag@0@@8) (= (ControlFlow 0 226855) 226803)) inline$$BorrowField$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@8) (=> (and (=> $abort_flag@0@@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@8 (|i#$Integer| ($Integer 5)))))) (=> (and (and (and (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@152 T@$Value) )  (=> ((_ is $Address) addr@@152) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@152))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@152))))))))))))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@153 T@$Value) )  (=> ((_ is $Address) addr@@153) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@153)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@153)))))))))))))) (and (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@154 T@$Value) )  (=> ((_ is $Address) addr@@154) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@154))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@154)))))))))))))))) (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@155 T@$Value) )  (=> ((_ is $Address) addr@@155) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@155)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@155)))))))))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))))) (and (and (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@156 T@$Value) )  (=> ((_ is $Address) addr@@156) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@156))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@156)))))))))))))))) (and (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean (forall ((addr@@157 T@$Value) )  (=> ((_ is $Address) addr@@157) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@157)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| addr@@157)))))))))))) (=> (not $abort_flag@0@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@16) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@21) (let ((va@@173 (|v#$Vector| call3formal@$ret0@0@@21)))
(let ((l@@173 (|l#$ValueArray| va@@173)))
 (and (and (<= 0 l@@173) (<= l@@173 $MAX_U64)) (forall ((x@@173 Int) ) (!  (=> (or (< x@@173 0) (>= x@@173 l@@173)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173))
)))))) (forall (($$0@@51 Int) ) (!  (=> (and (>= $$0@@51 0) (< $$0@@51 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) $$0@@51)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) $$0@@51)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) $$0@@51)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@21)) $$0@@51))
))))) (and (=> (= (ControlFlow 0 226645) 234203) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 226645) 226855) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon86_Else_correct)))))))
(let ((inline$$BorrowLoc$0$anon0_correct@@2  (=> (and (= inline$$BorrowLoc$0$dst@1@@2 ($Mutation ($Local 12) $EmptyPath preburn@@0)) (= (ControlFlow 0 226637) 226645)) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon6$3_correct)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 226519) 226637)) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Then_correct  (=> (= (ControlFlow 0 234227) 226637) inline$$BorrowLoc$0$anon0_correct@@2)))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 226511) 234227) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 226511) 226519) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Then_correct  (and (=> (= (ControlFlow 0 234235) 234227) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 234235) 226519) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon85_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon83_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 226503) 234235) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 226503) 226511) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon83_Then_correct  (and (=> (= (ControlFlow 0 234243) 234235) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 234243) 226511) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon84_Else_correct))))
(let ((inline$$Diem_burn_with_resource_cap_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 226497) 234243) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 226497) 226503) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon83_Else_correct)))))
(let ((anon0$1_correct@@9  (=> (and (forall (($inv_addr@@22 Int) ($inv_tv0@@18 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22)) (let ((va@@174 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))))
(let ((l@@174 (|l#$ValueArray| va@@174)))
 (and (and (<= 0 l@@174) (<= l@@174 $MAX_U64)) (forall ((x@@174 Int) ) (!  (=> (or (< x@@174 0) (>= x@@174 l@@174)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@18) 1) $inv_addr@@22))
)) (forall (($inv_addr@@23 Int) ($inv_tv0@@19 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23)) (let ((va@@175 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))))
(let ((l@@175 (|l#$ValueArray| va@@175)))
 (and (and (<= 0 l@@175) (<= l@@175 $MAX_U64)) (forall ((x@@175 Int) ) (!  (=> (or (< x@@175 0) (>= x@@175 l@@175)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@176 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@176 (|l#$ValueArray| va@@176)))
 (and (and (<= 0 l@@176) (<= l@@176 $MAX_U64)) (forall ((x@@176 Int) ) (!  (=> (or (< x@@176 0) (>= x@@176 l@@176)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code)) (let ((va@@177 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@177 (|l#$ValueArray| va@@177)))
 (and (and (<= 0 l@@177) (<= l@@177 $MAX_U64)) (forall ((x@@177 Int) ) (!  (=> (or (< x@@177 0) (>= x@@177 l@@177)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177))
))))))) (forall (($$0@@52 Int) ) (!  (=> (and (>= $$0@@52 0) (< $$0@@52 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))) $$0@@52)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))) $$0@@52)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))) $$0@@52)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_currency_code))) $$0@@52))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events)) (let ((va@@178 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@178 (|l#$ValueArray| va@@178)))
 (and (and (<= 0 l@@178) (<= l@@178 $MAX_U64)) (forall ((x@@178 Int) ) (!  (=> (or (< x@@178 0) (>= x@@178 l@@178)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@179 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@179 (|l#$ValueArray| va@@179)))
 (and (and (<= 0 l@@179) (<= l@@179 $MAX_U64)) (forall ((x@@179 Int) ) (!  (=> (or (< x@@179 0) (>= x@@179 l@@179)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179))
))))))) (forall (($$0@@53 Int) ) (!  (=> (and (>= $$0@@53 0) (< $$0@@53 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@53)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@53)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@53)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@53))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events)) (let ((va@@180 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@180 (|l#$ValueArray| va@@180)))
 (and (and (<= 0 l@@180) (<= l@@180 $MAX_U64)) (forall ((x@@180 Int) ) (!  (=> (or (< x@@180 0) (>= x@@180 l@@180)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@181 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@181 (|l#$ValueArray| va@@181)))
 (and (and (<= 0 l@@181) (<= l@@181 $MAX_U64)) (forall ((x@@181 Int) ) (!  (=> (or (< x@@181 0) (>= x@@181 l@@181)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181))
))))))) (forall (($$0@@54 Int) ) (!  (=> (and (>= $$0@@54 0) (< $$0@@54 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@54)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@54)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@54)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@54))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@182 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@182 (|l#$ValueArray| va@@182)))
 (and (and (<= 0 l@@182) (<= l@@182 $MAX_U64)) (forall ((x@@182 Int) ) (!  (=> (or (< x@@182 0) (>= x@@182 l@@182)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@183 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@183 (|l#$ValueArray| va@@183)))
 (and (and (<= 0 l@@183) (<= l@@183 $MAX_U64)) (forall ((x@@183 Int) ) (!  (=> (or (< x@@183 0) (>= x@@183 l@@183)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183))
))))))) (forall (($$0@@55 Int) ) (!  (=> (and (>= $$0@@55 0) (< $$0@@55 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@55)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@55)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@55)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@55))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@184 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@184 (|l#$ValueArray| va@@184)))
 (and (and (<= 0 l@@184) (<= l@@184 $MAX_U64)) (forall ((x@@184 Int) ) (!  (=> (or (< x@@184 0) (>= x@@184 l@@184)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@185 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@185 (|l#$ValueArray| va@@185)))
 (and (and (<= 0 l@@185) (<= l@@185 $MAX_U64)) (forall ((x@@185 Int) ) (!  (=> (or (< x@@185 0) (>= x@@185 l@@185)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185))
))))))) (forall (($$0@@56 Int) ) (!  (=> (and (>= $$0@@56 0) (< $$0@@56 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@56)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@56)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@56)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@56))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@186 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@186 (|l#$ValueArray| va@@186)))
 (and (and (<= 0 l@@186) (<= l@@186 $MAX_U64)) (forall ((x@@186 Int) ) (!  (=> (or (< x@@186 0) (>= x@@186 l@@186)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@187 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@187 (|l#$ValueArray| va@@187)))
 (and (and (<= 0 l@@187) (<= l@@187 $MAX_U64)) (forall ((x@@187 Int) ) (!  (=> (or (< x@@187 0) (>= x@@187 l@@187)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187))
))))))) (forall (($$0@@57 Int) ) (!  (=> (and (>= $$0@@57 0) (< $$0@@57 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@57)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@57)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@57)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@57))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@19) 1) $inv_addr@@23))
))) (=> (and (and (forall (($inv_addr@@24 Int) ($inv_tv0@@20 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24)) (let ((va@@188 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))))
(let ((l@@188 (|l#$ValueArray| va@@188)))
 (and (and (<= 0 l@@188) (<= l@@188 $MAX_U64)) (forall ((x@@188 Int) ) (!  (=> (or (< x@@188 0) (>= x@@188 l@@188)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn)) (let ((va@@189 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn))))
(let ((l@@189 (|l#$ValueArray| va@@189)))
 (and (and (<= 0 l@@189) (<= l@@189 $MAX_U64)) (forall ((x@@189 Int) ) (!  (=> (or (< x@@189 0) (>= x@@189 l@@189)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@20) 1) $inv_addr@@24))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@14 T@$Value) )  (=> ((_ is $Type) coin_type@@14) (|b#$Boolean| ($Boolean (forall ((addr3@@7 T@$Value) )  (=> ((_ is $Address) addr3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@14)) 1) (|a#$Address| addr3@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@15 T@$Value) )  (=> ((_ is $Type) coin_type@@15) (|b#$Boolean| ($Boolean (forall ((addr1@@5 T@$Value) )  (=> ((_ is $Address) addr1@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@15)) 1) (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 234249) 226497))) inline$$Diem_burn_with_resource_cap_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@9  (=> (and (and (and (and ((_ is $Vector) preburn@@0) (let ((va@@190 (|v#$Vector| preburn@@0)))
(let ((l@@190 (|l#$ValueArray| va@@190)))
 (and (and (<= 0 l@@190) (<= l@@190 $MAX_U64)) (forall ((x@@190 Int) ) (!  (=> (or (< x@@190 0) (>= x@@190 l@@190)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190))
)))))) (= (|l#$ValueArray| (|v#$Vector| preburn@@0)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn)) (let ((va@@191 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))))
(let ((l@@191 (|l#$ValueArray| va@@191)))
 (and (and (<= 0 l@@191) (<= l@@191 $MAX_U64)) (forall ((x@@191 Int) ) (!  (=> (or (< x@@191 0) (>= x@@191 l@@191)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@0)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) ((_ is $Address) preburn_address@@2)) (=> (and (and (and (and (and ((_ is $Vector) _capability) (let ((va@@192 (|v#$Vector| _capability)))
(let ((l@@192 (|l#$ValueArray| va@@192)))
 (and (and (<= 0 l@@192) (<= l@@192 $MAX_U64)) (forall ((x@@192 Int) ) (!  (=> (or (< x@@192 0) (>= x@@192 l@@192)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192))
)))))) (= (|l#$ValueArray| (|v#$Vector| _capability)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _capability)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 223663) 234249)) anon0$1_correct@@9))))
(let ((PreconditionGeneratedEntry_correct@@6  (=> (= (ControlFlow 0 402787) 223663) anon0_correct@@9)))
PreconditionGeneratedEntry_correct@@6)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@17 () T@$TypeValue)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@11@@3 () Bool)
(declare-fun preburn_address@@3 () T@$Value)
(declare-fun $abort_code@17@@2 () Int)
(declare-fun $Diem_Preburn_$memory@3 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@3@@2 () T@$Memory)
(declare-fun $abort_flag@10@@3 () Bool)
(declare-fun $abort_code@15@@3 () Int)
(declare-fun $Diem_Preburn_$memory@1@@0 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@1@@3 () T@$Memory)
(declare-fun inline$$Diem_cancel_burn_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@16@@3 () Int)
(declare-fun $Diem_Preburn_$memory@2@@0 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@2@@3 () T@$Memory)
(declare-fun $abort_code@1@@9 () Int)
(declare-fun $abort_flag@0@@9 () Bool)
(declare-fun $abort_code@2@@7 () Int)
(declare-fun $abort_flag@1@@9 () Bool)
(declare-fun $abort_code@4@@7 () Int)
(declare-fun $abort_flag@2@@8 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@3| () T@$Memory)
(declare-fun $abort_flag@9@@3 () Bool)
(declare-fun $abort_code@13@@3 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@3 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@3| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@3 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@3 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@3 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@3| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@3| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@3| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@5 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@3 () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@3| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@3 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@3 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@3 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@3| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@4 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_Preburn_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@14@@3 () Int)
(declare-fun $abort_code@5@@5 () Int)
(declare-fun $abort_flag@3@@6 () Bool)
(declare-fun $abort_code@7@@5 () Int)
(declare-fun $abort_flag@4@@6 () Bool)
(declare-fun $abort_code@8@@4 () Int)
(declare-fun $abort_flag@5@@5 () Bool)
(declare-fun $abort_code@9@@4 () Int)
(declare-fun $abort_flag@6@@5 () Bool)
(declare-fun $abort_code@10@@3 () Int)
(declare-fun $abort_flag@7@@3 () Bool)
(declare-fun $abort_code@11@@3 () Int)
(declare-fun $abort_flag@8@@3 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@3 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@8 () T@$Value)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$Diem_CancelBurnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@3 () Int)
(declare-fun inline$$BorrowField$5$p@2@@3 () T@$Path)
(declare-fun inline$$ReadRef$3$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@3 () Int)
(declare-fun inline$$BorrowField$4$p@2@@3 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@3 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@3 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@3 () Int)
(declare-fun inline$$BorrowField$3$p@2@@3 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@3 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@3 () Int)
(declare-fun inline$$BorrowField$2$p@2@@3 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@3 () T@$Value)
(declare-fun $abort_code@12@@3 () Int)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t21@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@3 () Int)
(declare-fun inline$$BorrowField$1$p@2@@3 () T@$Path)
(declare-fun call4formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@3 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@2 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@2 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@2 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@7 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@3 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@3 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@3 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@3| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@3| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@3 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@3 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@3| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@3 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@3 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@3 () Int)
(declare-fun inline$$BorrowField$0$p@2@@3 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@3 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@3 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@3 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@3 () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1 () T@$Value)
(declare-fun $abort_code@6@@5 () Int)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@3 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@3 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@3 () T@$Value)
(declare-fun call3formal@$ret0@0@@28 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@8 () Int)
(declare-fun call3formal@$ret0@0@@29 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 415604) (let ((anon0$2_correct@@10  (and (=> (= (ControlFlow 0 245019) (- 0 422890)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) $abort_flag@11@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) $abort_flag@11@@3) (and (=> (= (ControlFlow 0 245019) (- 0 422923)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3))))))) $abort_flag@11@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3))))))) $abort_flag@11@@3) (and (=> (= (ControlFlow 0 245019) (- 0 422953)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@3)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@11@@3) (and (=> (= (ControlFlow 0 245019) (- 0 422982)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@11@@3)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@11@@3) (and (=> (= (ControlFlow 0 245019) (- 0 422998)) (=> $abort_flag@11@@3 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@11@@3 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423103)) (=> $abort_flag@11@@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@11@@3 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| account@@0))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@17@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 245019) (- 0 423252)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 245019) (- 0 423274)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423310)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423356)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@158 T@$Value) )  (=> ((_ is $Address) addr@@158) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@158))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@158)))))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@159 T@$Value) )  (=> ((_ is $Address) addr@@159) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@159))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@159))))))))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423436)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@160 T@$Value) )  (=> ((_ is $Address) addr@@160) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@160)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@160))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@161 T@$Value) )  (=> ((_ is $Address) addr@@161) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@161)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@161)))))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423504)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423550)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@162 T@$Value) )  (=> ((_ is $Address) addr@@162) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@162))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@162)))))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@163 T@$Value) )  (=> ((_ is $Address) addr@@163) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@163))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@163))))))))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423630)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@164 T@$Value) )  (=> ((_ is $Address) addr@@164) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@164)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@164))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@165 T@$Value) )  (=> ((_ is $Address) addr@@165) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@165)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@165)))))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423698)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423744)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@166 T@$Value) )  (=> ((_ is $Address) addr@@166) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@166))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@166)))))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@167 T@$Value) )  (=> ((_ is $Address) addr@@167) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@167))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@167))))))))))))))) (and (=> (= (ControlFlow 0 245019) (- 0 423822)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@168 T@$Value) )  (=> ((_ is $Address) addr@@168) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@168)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@168))))))))))))) (=> (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean (forall ((addr@@169 T@$Value) )  (=> ((_ is $Address) addr@@169) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@169)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| addr@@169)))))))))))) (=> (= (ControlFlow 0 245019) (- 0 423888)) (=> (not $abort_flag@11@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon24_correct  (=> (= $abort_flag@11@@3 $abort_flag@10@@3) (=> (and (and (= $abort_code@17@@2 $abort_code@15@@3) (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@1@@0)) (and (= $Diem_CurrencyInfo_$memory@3@@2 $Diem_CurrencyInfo_$memory@1@@3) (= (ControlFlow 0 244923) 245019))) anon0$2_correct@@10))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 244921) 244923)) inline$$Diem_cancel_burn_$def_verify$0$anon24_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 244931) 244923) inline$$Diem_cancel_burn_$def_verify$0$anon24_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@10@@3) (and (=> (= (ControlFlow 0 244915) 244931) inline$$Diem_cancel_burn_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 244915) 244921) inline$$Diem_cancel_burn_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$Abort_correct  (=> (and (= inline$$Diem_cancel_burn_$def_verify$0$$ret0@1 $Error) (= $abort_flag@11@@3 true)) (=> (and (and (= $abort_code@17@@2 $abort_code@16@@3) (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@2@@0)) (and (= $Diem_CurrencyInfo_$memory@3@@2 $Diem_CurrencyInfo_$memory@2@@3) (= (ControlFlow 0 236626) 245019))) anon0$2_correct@@10))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon7_correct  (=> (and (and (= $abort_code@16@@3 $abort_code@1@@9) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory)) (and (= $Diem_CurrencyInfo_$memory@2@@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 244987) 236626))) inline$$Diem_cancel_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 244985) 244987)) inline$$Diem_cancel_burn_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 244995) 244987) inline$$Diem_cancel_burn_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon27_Then_correct  (=> $abort_flag@0@@9 (and (=> (= (ControlFlow 0 244979) 244995) inline$$Diem_cancel_burn_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 244979) 244985) inline$$Diem_cancel_burn_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon11_correct  (=> (and (and (= $abort_code@16@@3 $abort_code@2@@7) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory)) (and (= $Diem_CurrencyInfo_$memory@2@@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 244967) 236626))) inline$$Diem_cancel_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 244965) 244967)) inline$$Diem_cancel_burn_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 244975) 244967) inline$$Diem_cancel_burn_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon29_Then_correct  (=> $abort_flag@1@@9 (and (=> (= (ControlFlow 0 244959) 244975) inline$$Diem_cancel_burn_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 244959) 244965) inline$$Diem_cancel_burn_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon19_correct  (=> (and (and (= $abort_code@16@@3 $abort_code@4@@7) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory)) (and (= $Diem_CurrencyInfo_$memory@2@@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 244947) 236626))) inline$$Diem_cancel_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 244945) 244947)) inline$$Diem_cancel_burn_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 244955) 244947) inline$$Diem_cancel_burn_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon33_Then_correct  (=> $abort_flag@2@@8 (and (=> (= (ControlFlow 0 244939) 244955) inline$$Diem_cancel_burn_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 244939) 244945) inline$$Diem_cancel_burn_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon35_Then_correct  (=> $abort_flag@10@@3 (=> (and (and (= $abort_code@16@@3 $abort_code@15@@3) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory@1@@0)) (and (= $Diem_CurrencyInfo_$memory@2@@3 $Diem_CurrencyInfo_$memory@1@@3) (= (ControlFlow 0 244935) 236626))) inline$$Diem_cancel_burn_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct  (=> (and (and (= $Diem_Preburn_$memory@1@@0 |inline$$WritebackToGlobal$0$m'@2@@3|) (= $abort_flag@10@@3 $abort_flag@9@@3)) (and (= $abort_code@15@@3 $abort_code@13@@3) (= $Diem_CurrencyInfo_$memory@1@@3 $Diem_CurrencyInfo_$memory@0@@3))) (and (=> (= (ControlFlow 0 243118) 244935) inline$$Diem_cancel_burn_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 243118) 244915) inline$$Diem_cancel_burn_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 243116) 243118)) inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct  (=> (= (ControlFlow 0 243126) 243118) inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct  (and (=> (= (ControlFlow 0 244639) (- 0 422228)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@0 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 244639) (- 0 422352)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 244639) (- 0 422405)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@3 |inline$$WritebackToGlobal$2$m'@2@@3|) (and (=> (= (ControlFlow 0 244639) 243126) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 244639) 243116) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@3  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@3)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@3| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 244318) 244639)) inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@3  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@3) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@3 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@3)) (= inline$$WritebackToGlobal$2$a@1@@3 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@3))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@3 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@3 inline$$WritebackToGlobal$2$a@1@@3) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@3|))) (= |inline$$WritebackToGlobal$2$m'@1@@3| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@3 inline$$WritebackToGlobal$2$a@1@@3 inline$$WritebackToGlobal$2$v@1@@3)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@3| |inline$$WritebackToGlobal$2$m'@1@@3|) (= (ControlFlow 0 244372) 244639))) inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@3  (=> (= inline$$WritebackToGlobal$2$l@1@@3 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@3|)) (and (=> (= (ControlFlow 0 244308) 244372) inline$$WritebackToGlobal$2$anon3_Then_correct@@3) (=> (= (ControlFlow 0 244308) 244318) inline$$WritebackToGlobal$2$anon3_Else_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon64$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@1 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 244378) 244308)) inline$$WritebackToGlobal$2$anon0_correct@@3)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@3  (and (=> (= (ControlFlow 0 244061) (- 0 421946)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 244061) 244378) inline$$Diem_cancel_burn_with_capability_$def$0$anon64$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@3  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@3 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@3|)) (= (ControlFlow 0 244013) 244061)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@3)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@3 inline$$WritebackToReference$2$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@3| |inline$$WritebackToReference$1$dst'@2@@3|) (= (ControlFlow 0 243882) 244013)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@3))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@3 inline$$WritebackToReference$2$srcPath@1@@3)) (= |inline$$WritebackToReference$2$dst'@1@@3| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) inline$$WritebackToReference$2$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@3) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@3|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@3| |inline$$WritebackToReference$2$dst'@1@@3|) (= (ControlFlow 0 243938) 244013))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@3)))
(let ((inline$$WritebackToReference$2$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@3|)) (= inline$$WritebackToReference$2$dstPath@1@@3 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|))) (and (=> (= (ControlFlow 0 243846) 243938) inline$$WritebackToReference$2$anon3_Then_correct@@3) (=> (= (ControlFlow 0 243846) 243882) inline$$WritebackToReference$2$anon3_Else_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct  (=> (and (not true) (= (ControlFlow 0 243709) 243846)) inline$$WritebackToReference$2$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 244649) 243846)) inline$$WritebackToReference$2$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 243701) 244649) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 243701) 243709) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@5 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (and (=> (= (ControlFlow 0 244659) 244649) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 244659) 243709) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct@@3  (=> (= |inline$$WriteRef$2$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@3) (|p#$Mutation| inline$$BorrowField$5$dst@1@@3) inline$$ReadRef$4$v@1@@3)) (and (=> (= (ControlFlow 0 243687) 244659) inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 243687) 243701) inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Else_correct  (=> (and (not $abort_flag@9@@3) (= (ControlFlow 0 243693) 243687)) inline$$WriteRef$2$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct  (and (=> (= (ControlFlow 0 243106) (- 0 421274)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@2 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@3 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 243106) (- 0 421398)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 243106) (- 0 421451)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@3 |inline$$WritebackToGlobal$1$m'@2@@3|) (and (=> (= (ControlFlow 0 243106) 243126) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 243106) 243116) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@3  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@3)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@3| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 242785) 243106)) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@3  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@3) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@3 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@3)) (= inline$$WritebackToGlobal$1$a@1@@3 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@3))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@3 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@3 inline$$WritebackToGlobal$1$a@1@@3) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|))) (= |inline$$WritebackToGlobal$1$m'@1@@3| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@3 inline$$WritebackToGlobal$1$a@1@@3 inline$$WritebackToGlobal$1$v@1@@3)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@3| |inline$$WritebackToGlobal$1$m'@1@@3|) (= (ControlFlow 0 242839) 243106))) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@3  (=> (= inline$$WritebackToGlobal$1$l@1@@3 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (and (=> (= (ControlFlow 0 242775) 242839) inline$$WritebackToGlobal$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 242775) 242785) inline$$WritebackToGlobal$1$anon3_Else_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner1@@4 inline$$Diem_cancel_burn_with_capability_$def$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 242845) 242775)) inline$$WritebackToGlobal$1$anon0_correct@@3)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@3  (and (=> (= (ControlFlow 0 242528) (- 0 420992)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 242528) 242845) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@3  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (= (ControlFlow 0 242480) 242528)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@4)) (= (ControlFlow 0 242532) 242480)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@1 $Error) (=> (and (and (= $Diem_Preburn_$memory@1@@0 $Diem_Preburn_$memory@0@@1) (= $abort_flag@10@@3 true)) (and (= $abort_code@15@@3 $abort_code@14@@3) (= $Diem_CurrencyInfo_$memory@1@@3 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 239118) 244935) inline$$Diem_cancel_burn_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 239118) 244915) inline$$Diem_cancel_burn_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct  (=> (= $abort_code@14@@3 $abort_code@5@@5) (=> (and (= $Diem_Preburn_$memory@0@@1 $Diem_Preburn_$memory) (= (ControlFlow 0 244867) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 244865) 244867)) inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 244875) 244867) inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Then_correct  (=> $abort_flag@3@@6 (and (=> (= (ControlFlow 0 244859) 244875) inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 244859) 244865) inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct  (=> (= $abort_code@14@@3 $abort_code@7@@5) (=> (and (= $Diem_Preburn_$memory@0@@1 $Diem_Preburn_$memory) (= (ControlFlow 0 244847) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 244845) 244847)) inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 244855) 244847) inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct  (=> $abort_flag@4@@6 (and (=> (= (ControlFlow 0 244839) 244855) inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 244839) 244845) inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct  (=> (= $abort_code@14@@3 $abort_code@8@@4) (=> (and (= $Diem_Preburn_$memory@0@@1 $Diem_Preburn_$memory) (= (ControlFlow 0 244827) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 244825) 244827)) inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 244835) 244827) inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Then_correct  (=> $abort_flag@5@@5 (and (=> (= (ControlFlow 0 244819) 244835) inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 244819) 244825) inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct  (=> (= $abort_code@14@@3 $abort_code@9@@4) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244779) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 244777) 244779)) inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 244787) 244779) inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Then_correct  (=> $abort_flag@6@@5 (and (=> (= (ControlFlow 0 244771) 244787) inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 244771) 244777) inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct  (=> (= $abort_code@14@@3 $abort_code@10@@3) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244755) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 244753) 244755)) inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 244763) 244755) inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct  (=> $abort_flag@7@@3 (and (=> (= (ControlFlow 0 244747) 244763) inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 244747) 244753) inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct  (=> (= $abort_code@14@@3 $abort_code@11@@3) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244731) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 244729) 244731)) inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 244739) 244731) inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Then_correct  (=> $abort_flag@8@@3 (and (=> (= (ControlFlow 0 244723) 244739) inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 244723) 244729) inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct  (=> (= $abort_code@14@@3 $abort_code@13@@3) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244711) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 244709) 244711)) inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 244719) 244711) inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct  (=> $abort_flag@9@@3 (and (=> (= (ControlFlow 0 244703) 244719) inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 244703) 244709) inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct  (=> (= $abort_code@14@@3 $abort_code@13@@3) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244671) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 244669) 244671)) inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Then_correct  (=> (= (ControlFlow 0 244679) 244671) inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Then_correct  (=> $abort_flag@9@@3 (and (=> (= (ControlFlow 0 244663) 244679) inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 244663) 244669) inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@3  (=> (= inline$$Event_emit_event$0$t@0@@3 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 243618) 244663) inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 243618) 243693) inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then$3_correct  (and (=> (= (ControlFlow 0 243628) (- 0 421731)) true) (=> (= (ControlFlow 0 243628) 243618) inline$$Event_emit_event$0$Entry_correct@@3))))
(let ((inline$$ReadRef$4$anon0_correct@@3  (=> (and (= inline$$ReadRef$4$v@1@@3 (|v#$Mutation| inline$$BorrowField$5$dst@1@@3)) (= (ControlFlow 0 243570) 243628)) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then$3_correct)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 243526) 243570)) inline$$ReadRef$4$anon0_correct@@3)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 243532) 243570) inline$$ReadRef$4$anon0_correct@@3)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 243520) 243532) inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 243520) 243526) inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 243512) 243570)) inline$$ReadRef$4$anon0_correct@@3)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@8) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@25) (let ((va@@193 (|v#$Vector| call3formal@$ret0@0@@25)))
(let ((l@@193 (|l#$ValueArray| va@@193)))
 (and (and (<= 0 l@@193) (<= l@@193 $MAX_U64)) (forall ((x@@193 Int) ) (!  (=> (or (< x@@193 0) (>= x@@193 l@@193)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193))
)))))) (forall ((inline$$Diem_CancelBurnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CancelBurnEvent_pack$0$$$0 0) (< inline$$Diem_CancelBurnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) inline$$Diem_CancelBurnEvent_pack$0$$$0))
))) (and ((_ is $Address) preburn_address@@3) (= inline$$Diem_CancelBurnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@8) 1 call3formal@$ret0@0@@25) 2 preburn_address@@3) 3))))) (and (=> (= (ControlFlow 0 243504) 243520) inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 243504) 243512) inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$5$anon0_correct@@3  (=> (= inline$$BorrowField$5$p@1@@3 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (=> (and (and (= inline$$BorrowField$5$size@1@@3 (|size#$Path| inline$$BorrowField$5$p@1@@3)) (= inline$$BorrowField$5$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@3) inline$$BorrowField$5$size@1@@3 $Diem_CurrencyInfo_cancel_burn_events) (+ inline$$BorrowField$5$size@1@@3 1)))) (and (= inline$$BorrowField$5$dst@1@@3 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) inline$$BorrowField$5$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|))) $Diem_CurrencyInfo_cancel_burn_events))) (= (ControlFlow 0 243248) 243504))) inline$$Diem_CancelBurnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@4) (= (ControlFlow 0 243254) 243248)) inline$$BorrowField$5$anon0_correct@@3)))
(let ((inline$$Not$0$anon0_correct@@4  (=> (= inline$$Not$0$dst@1@@4 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$3$v@1@@3)))) (and (=> (= (ControlFlow 0 242397) 243254) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 242397) 242532) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 242387) (- 0 420953)) true) (=> (= (ControlFlow 0 242387) 242397) inline$$Not$0$anon0_correct@@4))))
(let ((inline$$ReadRef$3$anon0_correct@@3  (=> (and (= inline$$ReadRef$3$v@1@@3 (|v#$Mutation| inline$$BorrowField$4$dst@1@@3)) (= (ControlFlow 0 242339) 242387)) inline$$Not$0$Entry_correct@@4)))
(let ((inline$$BorrowField$4$anon0_correct@@3  (=> (= inline$$BorrowField$4$p@1@@3 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|)) (=> (and (and (= inline$$BorrowField$4$size@1@@3 (|size#$Path| inline$$BorrowField$4$p@1@@3)) (= inline$$BorrowField$4$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@3) inline$$BorrowField$4$size@1@@3 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$4$size@1@@3 1)))) (and (= inline$$BorrowField$4$dst@1@@3 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|) inline$$BorrowField$4$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@3|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 242301) 242339))) inline$$ReadRef$3$anon0_correct@@3))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@3| inline$$BorrowGlobal$1$dst@2@@2) (= (ControlFlow 0 242085) 242301)) inline$$BorrowField$4$anon0_correct@@3))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@3 inline$$WritebackToReference$1$srcPath@1@@3)) (= |inline$$WritebackToReference$1$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) inline$$WritebackToReference$1$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@3) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@3|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@3| |inline$$WritebackToReference$1$dst'@1@@3|) (= (ControlFlow 0 242141) 242301))) inline$$BorrowField$4$anon0_correct@@3)))
(let ((inline$$WritebackToReference$1$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@3|)) (= inline$$WritebackToReference$1$dstPath@1@@3 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@2))) (and (=> (= (ControlFlow 0 242049) 242141) inline$$WritebackToReference$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 242049) 242085) inline$$WritebackToReference$1$anon3_Else_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 241912) 242049)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (= (ControlFlow 0 244689) 242049)) inline$$WritebackToReference$1$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 241904) 244689) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 241904) 241912) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (and (=> (= (ControlFlow 0 244699) 244689) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 244699) 241912) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@3  (=> (= |inline$$WriteRef$1$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@3) (|p#$Mutation| inline$$BorrowField$3$dst@1@@3) inline$$Sub$0$dst@2@@3)) (and (=> (= (ControlFlow 0 241890) 244699) inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 241890) 241904) inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@3  (=> (= inline$$BorrowField$3$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (=> (and (and (= inline$$BorrowField$3$size@1@@3 (|size#$Path| inline$$BorrowField$3$p@1@@3)) (= inline$$BorrowField$3$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@3) inline$$BorrowField$3$size@1@@3 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@3 1)))) (and (= inline$$BorrowField$3$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) inline$$BorrowField$3$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 241831) 241890))) inline$$WriteRef$1$anon0_correct@@3))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@9@@3) (= (ControlFlow 0 241837) 241831)) inline$$BorrowField$3$anon0_correct@@3)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@3  (=> (= $abort_code@13@@3 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@9@@3 true) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@0@@3)) (and (=> (= (ControlFlow 0 241701) 244703) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 241701) 241837) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@3  (=> (and (< (|i#$Integer| inline$$ReadRef$2$v@1@@3) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8)) (= (ControlFlow 0 241699) 241701)) inline$$Sub$0$anon3_Then$1_correct@@3)))
(let ((inline$$Sub$0$anon3_Else_correct@@3  (=> (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8) (|i#$Integer| inline$$ReadRef$2$v@1@@3)) (=> (and (and (= inline$$Sub$0$dst@1@@3 ($Integer (- (|i#$Integer| inline$$ReadRef$2$v@1@@3) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8)))) (= $abort_code@13@@3 $abort_code@11@@3)) (and (= $abort_flag@9@@3 $abort_flag@8@@3) (= inline$$Sub$0$dst@2@@3 inline$$Sub$0$dst@1@@3))) (and (=> (= (ControlFlow 0 241647) 244703) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 241647) 241837) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 241621) (- 0 420517)) true) (and (=> (= (ControlFlow 0 241621) 241699) inline$$Sub$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 241621) 241647) inline$$Sub$0$anon3_Else_correct@@3)))))
(let ((inline$$ReadRef$2$anon0_correct@@3  (=> (and (= inline$$ReadRef$2$v@1@@3 (|v#$Mutation| inline$$BorrowField$2$dst@1@@3)) (= (ControlFlow 0 241522) 241621)) inline$$Sub$0$Entry_correct@@3)))
(let ((inline$$BorrowField$2$anon0_correct@@3  (=> (= inline$$BorrowField$2$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (=> (and (and (= inline$$BorrowField$2$size@1@@3 (|size#$Path| inline$$BorrowField$2$p@1@@3)) (= inline$$BorrowField$2$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@3) inline$$BorrowField$2$size@1@@3 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@3 1)))) (and (= inline$$BorrowField$2$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) inline$$BorrowField$2$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 241484) 241522))) inline$$ReadRef$2$anon0_correct@@3))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@3) (= (ControlFlow 0 241536) 241484)) inline$$BorrowField$2$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct  (=> (= $abort_code@14@@3 $abort_code@12@@3) (=> (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 241318) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 241316) 241318)) inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 241326) 241318) inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else$1_correct  (=> (= $abort_code@12@@3 (|i#$Integer| call3formal@$ret0@0@@26)) (and (=> (= (ControlFlow 0 241310) 241326) inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 241310) 241316) inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@3  (and (=> (= (ControlFlow 0 241300) (- 0 420349)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 241300) 241310) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@3  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@3 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (= (ControlFlow 0 241252) 241300)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@3)) (= (ControlFlow 0 241304) 241252)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Else_correct  (=> (not $abort_flag@8@@3) (and (=> (= (ControlFlow 0 241177) 241536) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 241177) 241304) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else$2_correct  (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@3)) (and (=> $abort_flag@8@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@26 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@26) (>= (|i#$Integer| call3formal@$ret0@0@@26) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@26) $MAX_U64))) (and (=> (= (ControlFlow 0 241171) 244723) inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 241171) 241177) inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@3  (=> (and (= inline$$Ge$0$dst@1@@3 ($Boolean (>= (|i#$Integer| inline$$ReadRef$1$v@1@@3) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@8)))) (= (ControlFlow 0 241159) 241171)) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else$2_correct)))
(let ((inline$$Ge$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 241145) (- 0 420239)) true) (=> (= (ControlFlow 0 241145) 241159) inline$$Ge$0$anon0_correct@@3))))
(let ((inline$$ReadRef$1$anon0_correct@@3  (=> (and (= inline$$ReadRef$1$v@1@@3 (|v#$Mutation| inline$$BorrowField$1$dst@1@@3)) (= (ControlFlow 0 241087) 241145)) inline$$Ge$0$Entry_correct@@3)))
(let ((inline$$BorrowField$1$anon0_correct@@3  (=> (= inline$$BorrowField$1$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (=> (and (and (= inline$$BorrowField$1$size@1@@3 (|size#$Path| inline$$BorrowField$1$p@1@@3)) (= inline$$BorrowField$1$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@3) inline$$BorrowField$1$size@1@@3 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$1$size@1@@3 1)))) (and (= inline$$BorrowField$1$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@2) inline$$BorrowField$1$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 241049) 241087))) inline$$ReadRef$1$anon0_correct@@3))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct  (=> (and (not $abort_flag@7@@3) (= (ControlFlow 0 241101) 241049)) inline$$BorrowField$1$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct  (=> (and (and $abort_flag@7@@3 (= $abort_code@14@@3 $abort_code@10@@3)) (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244743) 239118))) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 240857) 244743) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 240857) 241101) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 240867) 244743) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 240867) 241101) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@8  (=> (= inline$$GetFieldFromValue$0$dst@1@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 240841) 240867) inline$$Diem_value_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 240841) 240857) inline$$Diem_value_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 240765) 240841)) inline$$GetFieldFromValue$0$anon0_correct@@8)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 240875) 240841) inline$$GetFieldFromValue$0$anon0_correct@@8)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@1  (=> (not $abort_flag@7@@3) (and (=> (= (ControlFlow 0 240759) 240875) inline$$Diem_value_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 240759) 240765) inline$$Diem_value_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$Diem_value$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@5) (let ((va@@194 (|v#$Vector| call4formal@$ret0@0@@5)))
(let ((l@@194 (|l#$ValueArray| va@@194)))
 (and (and (<= 0 l@@194) (<= l@@194 $MAX_U64)) (forall ((x@@194 Int) ) (!  (=> (or (< x@@194 0) (>= x@@194 l@@194)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 240881) 240759)) inline$$Diem_value_$def$0$anon0_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@3  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 240593) 240881)) inline$$Diem_value$0$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@3  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@3 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@2)) (= (ControlFlow 0 240587) 240593)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct  (=> (and (not $abort_flag@7@@3) (= (ControlFlow 0 240597) 240587)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@3)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@2  (=> (= $abort_flag@7@@3 true) (=> (and (= $abort_code@10@@3 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$1$dst@2@@2 inline$$BorrowGlobal$1$dst@0@@2)) (and (=> (= (ControlFlow 0 240547) 244747) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 240547) 240597) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@2  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@2 inline$$BorrowGlobal$1$a@1@@2)) (= (ControlFlow 0 240545) 240547)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@2)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@2  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@2 inline$$BorrowGlobal$1$a@1@@2) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@2 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0@@2 inline$$BorrowGlobal$1$a@1@@2) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@2 inline$$BorrowGlobal$1$a@1@@2))) (= $abort_flag@7@@3 $abort_flag@6@@5)) (and (= $abort_code@10@@3 $abort_code@9@@4) (= inline$$BorrowGlobal$1$dst@2@@2 inline$$BorrowGlobal$1$dst@1@@2))) (and (=> (= (ControlFlow 0 240493) 244747) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 240493) 240597) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@2  (=> (= inline$$BorrowGlobal$1$a@1@@2 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@7)) (and (=> (= (ControlFlow 0 240463) 240545) inline$$BorrowGlobal$1$anon3_Then_correct@@2) (=> (= (ControlFlow 0 240463) 240493) inline$$BorrowGlobal$1$anon3_Else_correct@@2)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@2  (=> (= inline$$BorrowGlobal$1$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1)) (and (=> (= (ControlFlow 0 240457) (- 0 419930)) true) (=> (= (ControlFlow 0 240457) 240463) inline$$BorrowGlobal$1$anon0_correct@@2)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct  (=> (and (not $abort_flag@6@@5) (= (ControlFlow 0 240553) 240457)) inline$$BorrowGlobal$1$Entry_correct@@2)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct  (=> (and (and $abort_flag@6@@5 (= $abort_code@14@@3 $abort_code@9@@4)) (and (= $Diem_Preburn_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@3|) (= (ControlFlow 0 244767) 239118))) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@7  (=> (not true) (and (=> (= (ControlFlow 0 240314) 244767) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 240314) 240553) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@7  (and (=> (= (ControlFlow 0 240324) 244767) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 240324) 240553) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@7  (=> (and (not $abort_flag@6@@5) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@7 ($Address 173345816))) (and (=> (= (ControlFlow 0 240308) 240324) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 240308) 240314) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@7)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@6@@5) (= (ControlFlow 0 240338) 240308)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@7)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@5) (=> $abort_flag@6@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@4 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@6@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@25) (let ((va@@195 (|v#$Vector| call3formal@$ret0@0@@25)))
(let ((l@@195 (|l#$ValueArray| va@@195)))
 (and (and (<= 0 l@@195) (<= l@@195 $MAX_U64)) (forall ((x@@195 Int) ) (!  (=> (or (< x@@195 0) (>= x@@195 l@@195)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195))
)))))) (forall (($$0@@58 Int) ) (!  (=> (and (>= $$0@@58 0) (< $$0@@58 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) $$0@@58)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) $$0@@58)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) $$0@@58)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@25)) $$0@@58))
)))) (and (=> (= (ControlFlow 0 240203) 244771) inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 240203) 240338) inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 240201) 240203)) inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 244795) 240203) inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon24$2_correct  (and (=> (= (ControlFlow 0 240193) (- 0 419556)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@13 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@13) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@14 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@14) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 240193) (- 0 419619)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@15 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@16 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@3|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def$0$tc_addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 240193) 244795) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 240193) 240201) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Else_correct))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@3  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@3| $Diem_Preburn_$memory) (= (ControlFlow 0 239955) 240193)) inline$$Diem_cancel_burn_with_capability_$def$0$anon24$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@3  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@3) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@3 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@3)) (= inline$$WritebackToGlobal$0$a@1@@3 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@3))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@3 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|))) (= |inline$$WritebackToGlobal$0$m'@1@@3| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@3 inline$$WritebackToGlobal$0$a@1@@3 inline$$WritebackToGlobal$0$v@1@@3)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@3| |inline$$WritebackToGlobal$0$m'@1@@3|) (= (ControlFlow 0 240009) 240193))) inline$$Diem_cancel_burn_with_capability_$def$0$anon24$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@3  (=> (= inline$$WritebackToGlobal$0$l@1@@3 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@3|)) (and (=> (= (ControlFlow 0 239945) 240009) inline$$WritebackToGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 239945) 239955) inline$$WritebackToGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@3  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@3| inline$$BorrowGlobal$0$dst@2@@3) (= (ControlFlow 0 239765) 239945)) inline$$WritebackToGlobal$0$anon0_correct@@3))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@3  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@3))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@3 inline$$WritebackToReference$0$srcPath@1@@3)) (= |inline$$WritebackToReference$0$dst'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$WritebackToReference$0$dstPath@1@@3 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@3 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@3) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@3|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@3| |inline$$WritebackToReference$0$dst'@1@@3|) (= (ControlFlow 0 239821) 239945))) inline$$WritebackToGlobal$0$anon0_correct@@3)))
(let ((inline$$WritebackToReference$0$anon0_correct@@3  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@3 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@3|)) (= inline$$WritebackToReference$0$dstPath@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) (and (=> (= (ControlFlow 0 239729) 239821) inline$$WritebackToReference$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 239729) 239765) inline$$WritebackToReference$0$anon3_Else_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 239592) 239729)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (= (ControlFlow 0 244805) 239729)) inline$$WritebackToReference$0$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 239584) 244805) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 239584) 239592) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_cancel_burn_with_capability_$def$0$info@0)) (and (=> (= (ControlFlow 0 244815) 244805) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 244815) 239592) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@3  (=> (= |inline$$WriteRef$0$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@3) (|p#$Mutation| inline$$BorrowField$0$dst@1@@3) call5formal@$ret1@0@@3)) (and (=> (= (ControlFlow 0 239570) 244815) inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 239570) 239584) inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@5@@5) (= (ControlFlow 0 239576) 239570)) inline$$WriteRef$0$anon0_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else$2_correct  (and (=> (= (ControlFlow 0 239513) (- 0 419169)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@5) (=> $abort_flag@5@@5 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@3)) $Diem_Diem_value))))) (=> (not $abort_flag@5@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@3)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@5) (let ((va@@196 (|v#$Vector| call4formal@$ret0@0@@5)))
(let ((l@@196 (|l#$ValueArray| va@@196)))
 (and (and (<= 0 l@@196) (<= l@@196 $MAX_U64)) (forall ((x@@196 Int) ) (!  (=> (or (< x@@196 0) (>= x@@196 l@@196)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@5)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@3) (let ((va@@197 (|v#$Vector| call5formal@$ret1@0@@3)))
(let ((l@@197 (|l#$ValueArray| va@@197)))
 (and (and (<= 0 l@@197) (<= l@@197 $MAX_U64)) (forall ((x@@197 Int) ) (!  (=> (or (< x@@197 0) (>= x@@197 l@@197)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@3)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@3)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@3)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 239513) 244819) inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 239513) 239576) inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct@@3  (=> (and (= inline$$ReadRef$0$v@1@@3 (|v#$Mutation| inline$$BorrowField$0$dst@1@@3)) (= (ControlFlow 0 239501) 239513)) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@3  (=> (= inline$$BorrowField$0$p@1@@3 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@3 (|size#$Path| inline$$BorrowField$0$p@1@@3)) (= inline$$BorrowField$0$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@3) inline$$BorrowField$0$size@1@@3 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@3 1)))) (and (= inline$$BorrowField$0$dst@1@@3 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@3) inline$$BorrowField$0$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@3))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 239463) 239501))) inline$$ReadRef$0$anon0_correct@@3))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct  (=> (and (not $abort_flag@4@@6) (= (ControlFlow 0 239469) 239463)) inline$$BorrowField$0$anon0_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@3  (=> (= $abort_code@7@@5 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@6 true) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 239333) 244839) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 239333) 239469) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@3 inline$$BorrowGlobal$0$a@1@@3)) (= (ControlFlow 0 239331) 239333)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@3  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@3 inline$$BorrowGlobal$0$a@1@@3) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@3 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@3 inline$$BorrowGlobal$0$a@1@@3) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@3 inline$$BorrowGlobal$0$a@1@@3))) (= $abort_code@7@@5 $abort_code@5@@5)) (and (= $abort_flag@4@@6 $abort_flag@3@@6) (= inline$$BorrowGlobal$0$dst@2@@3 inline$$BorrowGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 239279) 244839) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 239279) 239469) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@3  (=> (= inline$$BorrowGlobal$0$a@1@@3 (|a#$Address| preburn_address@@3)) (and (=> (= (ControlFlow 0 239249) 239331) inline$$BorrowGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 239249) 239279) inline$$BorrowGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@3  (=> (= inline$$BorrowGlobal$0$ta@0@@3 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1)) (and (=> (= (ControlFlow 0 239243) (- 0 418984)) true) (=> (= (ControlFlow 0 239243) 239249) inline$$BorrowGlobal$0$anon0_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1) (= (ControlFlow 0 239339) 239243)) inline$$BorrowGlobal$0$Entry_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct  (=> (= $abort_code@14@@3 $abort_code@6@@5) (=> (and (= $Diem_Preburn_$memory@0@@1 $Diem_Preburn_$memory) (= (ControlFlow 0 239112) 239118)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 239110) 239112)) inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Then_correct  (=> (= (ControlFlow 0 239126) 239112) inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1)) (= $abort_code@6@@5 (|i#$Integer| call3formal@$ret0@0@@27))) (and (=> (= (ControlFlow 0 239104) 239126) inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 239104) 239110) inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Else_correct  (=> (not $abort_flag@3@@6) (and (=> (= (ControlFlow 0 239092) 239339) inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 239092) 239104) inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| preburn_address@@3)))) (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$t13@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@6)) (and (=> $abort_flag@3@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@27 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@27) (>= (|i#$Integer| call3formal@$ret0@0@@27) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@27) $MAX_U64))) (and (=> (= (ControlFlow 0 239086) 244859) inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 239086) 239092) inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 239026) 239086)) inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct  (=> (= (ControlFlow 0 244883) 239086) inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 239018) 244883) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 239018) 239026) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 244891) 244883) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 244891) 239026) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon0_correct  (=> (not $abort_flag@2@@8) (and (=> (= (ControlFlow 0 239012) 244891) inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 239012) 239018) inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$direct_intra$0$anon0_correct  (=> ((_ is $Address) preburn_address@@3) (=> (and (and (and (and (and ((_ is $Vector) inline$$GetGlobal$0$dst@2@@3) (let ((va@@198 (|v#$Vector| inline$$GetGlobal$0$dst@2@@3)))
(let ((l@@198 (|l#$ValueArray| va@@198)))
 (and (and (<= 0 l@@198) (<= l@@198 $MAX_U64)) (forall ((x@@198 Int) ) (!  (=> (or (< x@@198 0) (>= x@@198 l@@198)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@3)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@3)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 244897) 239012)) inline$$Diem_cancel_burn_with_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@2@@8) (= (ControlFlow 0 244905) 244897)) inline$$Diem_cancel_burn_with_capability_$direct_intra$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@2@@8 true) (=> (and (= $abort_code@4@@7 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@0@@3)) (and (=> (= (ControlFlow 0 236819) 244939) inline$$Diem_cancel_burn_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 236819) 244905) inline$$Diem_cancel_burn_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@3 inline$$GetGlobal$0$a@1@@3)) (= (ControlFlow 0 236817) 236819)) inline$$GetGlobal$0$anon3_Then$1_correct@@3)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@3  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@3 inline$$GetGlobal$0$a@1@@3) (=> (and (and (= inline$$GetGlobal$0$dst@1@@3 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0@@3 (|a#$Address| call3formal@$ret0@0@@28))) (= $abort_flag@2@@8 $abort_flag@1@@9)) (and (= $abort_code@4@@7 $abort_code@2@@7) (= inline$$GetGlobal$0$dst@2@@3 inline$$GetGlobal$0$dst@1@@3))) (and (=> (= (ControlFlow 0 236765) 244939) inline$$Diem_cancel_burn_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 236765) 244905) inline$$Diem_cancel_burn_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@3  (=> (= inline$$GetGlobal$0$a@1@@3 (|a#$Address| call3formal@$ret0@0@@28)) (and (=> (= (ControlFlow 0 236747) 236817) inline$$GetGlobal$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 236747) 236765) inline$$GetGlobal$0$anon3_Else_correct@@3)))))
(let ((inline$$GetGlobal$0$Entry_correct@@3  (=> (= inline$$GetGlobal$0$ta@0@@3 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1)) (and (=> (= (ControlFlow 0 236741) (- 0 418582)) true) (=> (= (ControlFlow 0 236741) 236747) inline$$GetGlobal$0$anon0_correct@@3)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_cancel_burn_$def_verify$0$$t7@1) (= (ControlFlow 0 236825) 236741)) inline$$GetGlobal$0$Entry_correct@@3)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon16_correct  (=> (and (and (= $abort_code@16@@3 $abort_code@3@@8) (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory)) (and (= $Diem_CurrencyInfo_$memory@2@@3 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 236620) 236626))) inline$$Diem_cancel_burn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 236618) 236620)) inline$$Diem_cancel_burn_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 236634) 236620) inline$$Diem_cancel_burn_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_cancel_burn_$def_verify$0$$t7@1)) (= $abort_code@3@@8 (|i#$Integer| call3formal@$ret0@0@@29))) (and (=> (= (ControlFlow 0 236612) 236634) inline$$Diem_cancel_burn_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 236612) 236618) inline$$Diem_cancel_burn_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@1@@9) (and (=> (= (ControlFlow 0 236600) 236825) inline$$Diem_cancel_burn_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 236600) 236612) inline$$Diem_cancel_burn_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@0@@9) (= inline$$Diem_cancel_burn_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@17) 1) (|a#$Address| call3formal@$ret0@0@@28))))) (=> (and (and (and (= inline$$Diem_cancel_burn_$def_verify$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@9)) (and (=> $abort_flag@1@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@29 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@29) (>= (|i#$Integer| call3formal@$ret0@0@@29) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@29) $MAX_U64))) (and (=> (= (ControlFlow 0 236594) 244959) inline$$Diem_cancel_burn_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 236594) 236600) inline$$Diem_cancel_burn_$def_verify$0$anon29_Else_correct))))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@9) (=> $abort_flag@0@@9 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@28 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@28))) (and (=> (= (ControlFlow 0 236564) 244979) inline$$Diem_cancel_burn_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 236564) 236594) inline$$Diem_cancel_burn_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 236494) 236564)) inline$$Diem_cancel_burn_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 245003) 236564) inline$$Diem_cancel_burn_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 236486) 245003) inline$$Diem_cancel_burn_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 236486) 236494) inline$$Diem_cancel_burn_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 245011) 245003) inline$$Diem_cancel_burn_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 245011) 236494) inline$$Diem_cancel_burn_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Diem_cancel_burn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 236480) 245011) inline$$Diem_cancel_burn_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 236480) 236486) inline$$Diem_cancel_burn_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@10  (=> (and (and (and (forall (($inv_addr@@25 Int) ($inv_tv0@@21 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25)) (let ((va@@199 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))))
(let ((l@@199 (|l#$ValueArray| va@@199)))
 (and (and (<= 0 l@@199) (<= l@@199 $MAX_U64)) (forall ((x@@199 Int) ) (!  (=> (or (< x@@199 0) (>= x@@199 l@@199)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@21) 1) $inv_addr@@25))
)) (forall (($inv_addr@@26 Int) ($inv_tv0@@22 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@22) 1) $inv_addr@@26)) (let ((va@@200 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@22) 1) $inv_addr@@26))))
(let ((l@@200 (|l#$ValueArray| va@@200)))
 (and (and (<= 0 l@@200) (<= l@@200 $MAX_U64)) (forall ((x@@200 Int) ) (!  (=> (or (< x@@200 0) (>= x@@200 l@@200)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@22) 1) $inv_addr@@26))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@22) 1) $inv_addr@@26))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@22) 1) $inv_addr@@26))
))) (and (forall (($inv_addr@@27 Int) ($inv_tv0@@23 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27)) (let ((va@@201 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))))
(let ((l@@201 (|l#$ValueArray| va@@201)))
 (and (and (<= 0 l@@201) (<= l@@201 $MAX_U64)) (forall ((x@@201 Int) ) (!  (=> (or (< x@@201 0) (>= x@@201 l@@201)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@201) x@@201) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@201) x@@201))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@202 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@202 (|l#$ValueArray| va@@202)))
 (and (and (<= 0 l@@202) (<= l@@202 $MAX_U64)) (forall ((x@@202 Int) ) (!  (=> (or (< x@@202 0) (>= x@@202 l@@202)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@202) x@@202) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@202) x@@202))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code)) (let ((va@@203 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@203 (|l#$ValueArray| va@@203)))
 (and (and (<= 0 l@@203) (<= l@@203 $MAX_U64)) (forall ((x@@203 Int) ) (!  (=> (or (< x@@203 0) (>= x@@203 l@@203)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@203) x@@203) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@203) x@@203))
))))))) (forall (($$0@@59 Int) ) (!  (=> (and (>= $$0@@59 0) (< $$0@@59 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@59)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@59)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@59)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@59))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events)) (let ((va@@204 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@204 (|l#$ValueArray| va@@204)))
 (and (and (<= 0 l@@204) (<= l@@204 $MAX_U64)) (forall ((x@@204 Int) ) (!  (=> (or (< x@@204 0) (>= x@@204 l@@204)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@204) x@@204) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@204) x@@204))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@205 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@205 (|l#$ValueArray| va@@205)))
 (and (and (<= 0 l@@205) (<= l@@205 $MAX_U64)) (forall ((x@@205 Int) ) (!  (=> (or (< x@@205 0) (>= x@@205 l@@205)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@205) x@@205) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@205) x@@205))
))))))) (forall (($$0@@60 Int) ) (!  (=> (and (>= $$0@@60 0) (< $$0@@60 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@60)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@60)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@60)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@60))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events)) (let ((va@@206 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@206 (|l#$ValueArray| va@@206)))
 (and (and (<= 0 l@@206) (<= l@@206 $MAX_U64)) (forall ((x@@206 Int) ) (!  (=> (or (< x@@206 0) (>= x@@206 l@@206)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@206) x@@206) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@206) x@@206))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@207 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@207 (|l#$ValueArray| va@@207)))
 (and (and (<= 0 l@@207) (<= l@@207 $MAX_U64)) (forall ((x@@207 Int) ) (!  (=> (or (< x@@207 0) (>= x@@207 l@@207)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@207) x@@207) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@207) x@@207))
))))))) (forall (($$0@@61 Int) ) (!  (=> (and (>= $$0@@61 0) (< $$0@@61 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@61)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@61)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@61)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@61))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@208 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@208 (|l#$ValueArray| va@@208)))
 (and (and (<= 0 l@@208) (<= l@@208 $MAX_U64)) (forall ((x@@208 Int) ) (!  (=> (or (< x@@208 0) (>= x@@208 l@@208)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@208) x@@208) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@208) x@@208))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@209 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@209 (|l#$ValueArray| va@@209)))
 (and (and (<= 0 l@@209) (<= l@@209 $MAX_U64)) (forall ((x@@209 Int) ) (!  (=> (or (< x@@209 0) (>= x@@209 l@@209)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@209) x@@209) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@209) x@@209))
))))))) (forall (($$0@@62 Int) ) (!  (=> (and (>= $$0@@62 0) (< $$0@@62 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@62)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@62)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@62)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@62))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@210 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@210 (|l#$ValueArray| va@@210)))
 (and (and (<= 0 l@@210) (<= l@@210 $MAX_U64)) (forall ((x@@210 Int) ) (!  (=> (or (< x@@210 0) (>= x@@210 l@@210)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@210) x@@210) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@210) x@@210))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@211 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@211 (|l#$ValueArray| va@@211)))
 (and (and (<= 0 l@@211) (<= l@@211 $MAX_U64)) (forall ((x@@211 Int) ) (!  (=> (or (< x@@211 0) (>= x@@211 l@@211)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@211) x@@211) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@211) x@@211))
))))))) (forall (($$0@@63 Int) ) (!  (=> (and (>= $$0@@63 0) (< $$0@@63 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@63)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@63)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@63)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@63))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@212 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@212 (|l#$ValueArray| va@@212)))
 (and (and (<= 0 l@@212) (<= l@@212 $MAX_U64)) (forall ((x@@212 Int) ) (!  (=> (or (< x@@212 0) (>= x@@212 l@@212)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@212) x@@212) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@212) x@@212))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@213 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@213 (|l#$ValueArray| va@@213)))
 (and (and (<= 0 l@@213) (<= l@@213 $MAX_U64)) (forall ((x@@213 Int) ) (!  (=> (or (< x@@213 0) (>= x@@213 l@@213)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@213) x@@213) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@213) x@@213))
))))))) (forall (($$0@@64 Int) ) (!  (=> (and (>= $$0@@64 0) (< $$0@@64 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@64)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@64)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@64)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@64))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@23) 1) $inv_addr@@27))
)) (forall (($inv_addr@@28 Int) ($inv_tv0@@24 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28)) (let ((va@@214 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))))
(let ((l@@214 (|l#$ValueArray| va@@214)))
 (and (and (<= 0 l@@214) (<= l@@214 $MAX_U64)) (forall ((x@@214 Int) ) (!  (=> (or (< x@@214 0) (>= x@@214 l@@214)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@214) x@@214) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@214) x@@214))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn)) (let ((va@@215 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))))
(let ((l@@215 (|l#$ValueArray| va@@215)))
 (and (and (<= 0 l@@215) (<= l@@215 $MAX_U64)) (forall ((x@@215 Int) ) (!  (=> (or (< x@@215 0) (>= x@@215 l@@215)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@215) x@@215) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@215) x@@215))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@24) 1) $inv_addr@@28))
)))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@16 T@$Value) )  (=> ((_ is $Type) coin_type@@16) (|b#$Boolean| ($Boolean (forall ((addr3@@8 T@$Value) )  (=> ((_ is $Address) addr3@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@16)) 1) (|a#$Address| addr3@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@17 T@$Value) )  (=> ((_ is $Type) coin_type@@17) (|b#$Boolean| ($Boolean (forall ((addr1@@6 T@$Value) )  (=> ((_ is $Address) addr1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@17)) 1) (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@18 T@$Value) )  (=> ((_ is $Type) coin_type@@18) (|b#$Boolean| ($Boolean (forall ((addr1@@7 T@$Value) )  (=> ((_ is $Address) addr1@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@18)) 1) (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 245017) 236480)))) inline$$Diem_cancel_burn_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@10  (=> ((_ is $Address) account@@0) (=> (and ((_ is $Address) preburn_address@@3) (= (ControlFlow 0 235637) 245017)) anon0$1_correct@@10))))
(let ((PreconditionGeneratedEntry_correct@@7  (=> (= (ControlFlow 0 415604) 235637) anon0_correct@@10)))
PreconditionGeneratedEntry_correct@@7)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@18 () T@$TypeValue)
(declare-fun preburn_address@@4 () T@$Value)
(declare-fun $abort_flag@7@@4 () Bool)
(declare-fun $abort_code@11@@4 () Int)
(declare-fun $Diem_Preburn_$memory@1@@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@1@@4 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@4| () T@$Memory)
(declare-fun $abort_code@9@@5 () Int)
(declare-fun $abort_flag@6@@6 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@4 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@4| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@4 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@4 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@4 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@4| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@4| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@4| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@4| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@5 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@4 () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@4| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@4 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@4 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@4 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@4| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@5 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $Diem_Preburn_$memory@0@@2 () T@$Memory)
(declare-fun $abort_code@10@@4 () Int)
(declare-fun $abort_code@1@@10 () Int)
(declare-fun $abort_flag@0@@10 () Bool)
(declare-fun $abort_code@3@@9 () Int)
(declare-fun $abort_flag@1@@10 () Bool)
(declare-fun $abort_code@4@@8 () Int)
(declare-fun $abort_flag@2@@9 () Bool)
(declare-fun $abort_code@5@@6 () Int)
(declare-fun $abort_flag@3@@7 () Bool)
(declare-fun $abort_code@6@@6 () Int)
(declare-fun $abort_flag@4@@7 () Bool)
(declare-fun $abort_code@7@@6 () Int)
(declare-fun $abort_flag@5@@6 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@4 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@9 () T@$Value)
(declare-fun call3formal@$ret0@0@@30 () T@$Value)
(declare-fun inline$$Diem_CancelBurnEvent_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@4 () Int)
(declare-fun inline$$BorrowField$5$p@2@@4 () T@$Path)
(declare-fun inline$$ReadRef$3$v@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@4 () Int)
(declare-fun inline$$BorrowField$4$p@2@@4 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@4 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@4 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@4 () Int)
(declare-fun inline$$BorrowField$3$p@2@@4 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@4 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@4 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@4 () Int)
(declare-fun inline$$BorrowField$2$p@2@@4 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@4 () T@$Value)
(declare-fun $abort_code@8@@5 () Int)
(declare-fun call3formal@$ret0@0@@31 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@4 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@4 () Int)
(declare-fun inline$$BorrowField$1$p@2@@4 () T@$Path)
(declare-fun call4formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@4 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@3 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0@@3 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@3 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@3 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@8 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@4 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@4 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@4 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@4| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@4| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@4 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@4 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@4| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@4 () T@$Mutation)
(declare-fun call5formal@$ret1@0@@4 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@4 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@4 () Int)
(declare-fun inline$$BorrowField$0$p@2@@4 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@4 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@4 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@4 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@4 () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t12@1 () T@$Value)
(declare-fun $abort_code@2@@8 () Int)
(declare-fun call3formal@$ret0@0@@32 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t13@1 () T@$Value)
(declare-fun _capability@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 423937) (let ((anon0$2_correct@@11  (and (=> (= (ControlFlow 0 254475) (- 0 432825)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) $abort_flag@7@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) $abort_flag@7@@4) (and (=> (= (ControlFlow 0 254475) (- 0 432855)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@7@@4)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@7@@4) (and (=> (= (ControlFlow 0 254475) (- 0 432884)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@4) (and (=> (= (ControlFlow 0 254475) (- 0 432900)) (=> $abort_flag@7@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@7@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 432973)) (=> $abort_flag@7@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@7@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4))))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11@@4 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 254475) (- 0 433079)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 254475) (- 0 433101)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433137)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433183)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@170 T@$Value) )  (=> ((_ is $Address) addr@@170) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@170))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@170)))))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@171 T@$Value) )  (=> ((_ is $Address) addr@@171) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@171))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@171))))))))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433263)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@172 T@$Value) )  (=> ((_ is $Address) addr@@172) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@172)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@172))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@173 T@$Value) )  (=> ((_ is $Address) addr@@173) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@173)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@173)))))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433331)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433377)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@174 T@$Value) )  (=> ((_ is $Address) addr@@174) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@174))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@174)))))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@175 T@$Value) )  (=> ((_ is $Address) addr@@175) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@175))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@175))))))))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433457)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@176 T@$Value) )  (=> ((_ is $Address) addr@@176) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@176)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@176))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@177 T@$Value) )  (=> ((_ is $Address) addr@@177) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@177)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@177)))))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433525)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433571)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@178 T@$Value) )  (=> ((_ is $Address) addr@@178) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@178))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@178)))))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@179 T@$Value) )  (=> ((_ is $Address) addr@@179) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@179))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@179))))))))))))))) (and (=> (= (ControlFlow 0 254475) (- 0 433649)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@180 T@$Value) )  (=> ((_ is $Address) addr@@180) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@180)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@180))))))))))))) (=> (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean (forall ((addr@@181 T@$Value) )  (=> ((_ is $Address) addr@@181) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@181)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@181)))))))))))) (=> (= (ControlFlow 0 254475) (- 0 433715)) (=> (not $abort_flag@7@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon66_correct  (=> (= $Diem_Preburn_$memory@1@@1 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (and (= $abort_code@11@@4 $abort_code@9@@5) (= $abort_flag@7@@4 $abort_flag@6@@6)) (and (= $Diem_CurrencyInfo_$memory@1@@4 $Diem_CurrencyInfo_$memory@0@@4) (= (ControlFlow 0 252694) 254475))) anon0$2_correct@@11))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 252692) 252694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Then_correct  (=> (= (ControlFlow 0 252702) 252694) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon64$3_correct  (and (=> (= (ControlFlow 0 254215) (- 0 432327)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 254215) (- 0 432451)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 254215) (- 0 432504)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@4 |inline$$WritebackToGlobal$2$m'@2@@4|) (and (=> (= (ControlFlow 0 254215) 252702) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 254215) 252692) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@4  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@4)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@4| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 253894) 254215)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@4  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@4) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@4 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@4)) (= inline$$WritebackToGlobal$2$a@1@@4 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@4))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@4 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@4|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@4 inline$$WritebackToGlobal$2$a@1@@4) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@4|))) (= |inline$$WritebackToGlobal$2$m'@1@@4| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@4 inline$$WritebackToGlobal$2$a@1@@4 inline$$WritebackToGlobal$2$v@1@@4)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@4| |inline$$WritebackToGlobal$2$m'@1@@4|) (= (ControlFlow 0 253948) 254215))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@4  (=> (= inline$$WritebackToGlobal$2$l@1@@4 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@4|)) (and (=> (= (ControlFlow 0 253884) 253948) inline$$WritebackToGlobal$2$anon3_Then_correct@@4) (=> (= (ControlFlow 0 253884) 253894) inline$$WritebackToGlobal$2$anon3_Else_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon64$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 253954) 253884)) inline$$WritebackToGlobal$2$anon0_correct@@4)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@4  (and (=> (= (ControlFlow 0 253637) (- 0 432045)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 253637) 253954) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon64$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@4  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@4 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@4|)) (= (ControlFlow 0 253589) 253637)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@4)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@4  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@4 inline$$WritebackToReference$2$srcPath@1@@4))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@4| |inline$$WritebackToReference$1$dst'@2@@4|) (= (ControlFlow 0 253458) 253589)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@4))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@4  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@4 inline$$WritebackToReference$2$srcPath@1@@4)) (= |inline$$WritebackToReference$2$dst'@1@@4| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) inline$$WritebackToReference$2$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@4) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@4|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@4| |inline$$WritebackToReference$2$dst'@1@@4|) (= (ControlFlow 0 253514) 253589))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@4)))
(let ((inline$$WritebackToReference$2$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@4|)) (= inline$$WritebackToReference$2$dstPath@1@@4 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|))) (and (=> (= (ControlFlow 0 253422) 253514) inline$$WritebackToReference$2$anon3_Then_correct@@4) (=> (= (ControlFlow 0 253422) 253458) inline$$WritebackToReference$2$anon3_Else_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Else_correct  (=> (and (not true) (= (ControlFlow 0 253285) 253422)) inline$$WritebackToReference$2$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|)) (= (ControlFlow 0 254225) 253422)) inline$$WritebackToReference$2$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon97_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 253277) 254225) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 253277) 253285) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon97_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@5 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (and (=> (= (ControlFlow 0 254235) 254225) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 254235) 253285) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct@@4  (=> (= |inline$$WriteRef$2$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@4) (|p#$Mutation| inline$$BorrowField$5$dst@1@@4) inline$$ReadRef$4$v@1@@4)) (and (=> (= (ControlFlow 0 253263) 254235) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 253263) 253277) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon95_Else_correct  (=> (and (not $abort_flag@6@@6) (= (ControlFlow 0 253269) 253263)) inline$$WriteRef$2$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else$2_correct  (and (=> (= (ControlFlow 0 252682) (- 0 431373)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@2 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@3 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 252682) (- 0 431497)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 252682) (- 0 431550)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@4 |inline$$WritebackToGlobal$1$m'@2@@4|) (and (=> (= (ControlFlow 0 252682) 252702) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 252682) 252692) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon99_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@4  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@4)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@4| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 252361) 252682)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@4  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@4) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@4 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@4)) (= inline$$WritebackToGlobal$1$a@1@@4 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@4))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@4 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@4 inline$$WritebackToGlobal$1$a@1@@4) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|))) (= |inline$$WritebackToGlobal$1$m'@1@@4| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@4 inline$$WritebackToGlobal$1$a@1@@4 inline$$WritebackToGlobal$1$v@1@@4)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@4| |inline$$WritebackToGlobal$1$m'@1@@4|) (= (ControlFlow 0 252415) 252682))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@4  (=> (= inline$$WritebackToGlobal$1$l@1@@4 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (and (=> (= (ControlFlow 0 252351) 252415) inline$$WritebackToGlobal$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 252351) 252361) inline$$WritebackToGlobal$1$anon3_Else_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner1@@4 inline$$Diem_cancel_burn_with_capability_$def_verify$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 252421) 252351)) inline$$WritebackToGlobal$1$anon0_correct@@4)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@4  (and (=> (= (ControlFlow 0 252104) (- 0 431091)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 252104) 252421) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@4  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@4 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (= (ControlFlow 0 252056) 252104)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@5)) (= (ControlFlow 0 252108) 252056)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$ret0@1 $Error) (= $Diem_Preburn_$memory@1@@1 $Diem_Preburn_$memory@0@@2)) (=> (and (and (= $abort_code@11@@4 $abort_code@10@@4) (= $abort_flag@7@@4 true)) (and (= $Diem_CurrencyInfo_$memory@1@@4 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 248694) 254475))) anon0$2_correct@@11))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon7_correct  (=> (= $Diem_Preburn_$memory@0@@2 $Diem_Preburn_$memory) (=> (and (= $abort_code@10@@4 $abort_code@1@@10) (= (ControlFlow 0 254443) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 254441) 254443)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 254451) 254443) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon69_Then_correct  (=> $abort_flag@0@@10 (and (=> (= (ControlFlow 0 254435) 254451) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 254435) 254441) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon15_correct  (=> (= $Diem_Preburn_$memory@0@@2 $Diem_Preburn_$memory) (=> (and (= $abort_code@10@@4 $abort_code@3@@9) (= (ControlFlow 0 254423) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 254421) 254423)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 254431) 254423) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Then_correct  (=> $abort_flag@1@@10 (and (=> (= (ControlFlow 0 254415) 254431) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 254415) 254421) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon19_correct  (=> (= $Diem_Preburn_$memory@0@@2 $Diem_Preburn_$memory) (=> (and (= $abort_code@10@@4 $abort_code@4@@8) (= (ControlFlow 0 254403) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 254401) 254403)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 254411) 254403) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon75_Then_correct  (=> $abort_flag@2@@9 (and (=> (= (ControlFlow 0 254395) 254411) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 254395) 254401) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon29_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@5@@6) (= (ControlFlow 0 254355) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 254353) 254355)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 254363) 254355) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon80_Then_correct  (=> $abort_flag@3@@7 (and (=> (= (ControlFlow 0 254347) 254363) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 254347) 254353) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon35_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@6@@6) (= (ControlFlow 0 254331) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 254329) 254331)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 254339) 254331) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Then_correct  (=> $abort_flag@4@@7 (and (=> (= (ControlFlow 0 254323) 254339) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 254323) 254329) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon41_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@7@@6) (= (ControlFlow 0 254307) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 254305) 254307)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 254315) 254307) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon86_Then_correct  (=> $abort_flag@5@@6 (and (=> (= (ControlFlow 0 254299) 254315) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 254299) 254305) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon49_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@9@@5) (= (ControlFlow 0 254287) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 254285) 254287)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 254295) 254287) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Then_correct  (=> $abort_flag@6@@6 (and (=> (= (ControlFlow 0 254279) 254295) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 254279) 254285) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon59_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@9@@5) (= (ControlFlow 0 254247) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 254245) 254247)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon96_Then_correct  (=> (= (ControlFlow 0 254255) 254247) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon95_Then_correct  (=> $abort_flag@6@@6 (and (=> (= (ControlFlow 0 254239) 254255) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 254239) 254245) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@4  (=> (= inline$$Event_emit_event$0$t@0@@4 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 253194) 254239) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 253194) 253269) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Then$3_correct  (and (=> (= (ControlFlow 0 253204) (- 0 431830)) true) (=> (= (ControlFlow 0 253204) 253194) inline$$Event_emit_event$0$Entry_correct@@4))))
(let ((inline$$ReadRef$4$anon0_correct@@4  (=> (and (= inline$$ReadRef$4$v@1@@4 (|v#$Mutation| inline$$BorrowField$5$dst@1@@4)) (= (ControlFlow 0 253146) 253204)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Then$3_correct)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 253102) 253146)) inline$$ReadRef$4$anon0_correct@@4)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 253108) 253146) inline$$ReadRef$4$anon0_correct@@4)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 253096) 253108) inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 253096) 253102) inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 253088) 253146)) inline$$ReadRef$4$anon0_correct@@4)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@9) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@30) (let ((va@@216 (|v#$Vector| call3formal@$ret0@0@@30)))
(let ((l@@216 (|l#$ValueArray| va@@216)))
 (and (and (<= 0 l@@216) (<= l@@216 $MAX_U64)) (forall ((x@@216 Int) ) (!  (=> (or (< x@@216 0) (>= x@@216 l@@216)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@216) x@@216) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@216) x@@216))
)))))) (forall ((inline$$Diem_CancelBurnEvent_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$Diem_CancelBurnEvent_pack$0$$$0@@0 0) (< inline$$Diem_CancelBurnEvent_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) inline$$Diem_CancelBurnEvent_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) inline$$Diem_CancelBurnEvent_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) inline$$Diem_CancelBurnEvent_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) inline$$Diem_CancelBurnEvent_pack$0$$$0@@0))
))) (and ((_ is $Address) preburn_address@@4) (= inline$$Diem_CancelBurnEvent_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@9) 1 call3formal@$ret0@0@@30) 2 preburn_address@@4) 3))))) (and (=> (= (ControlFlow 0 253080) 253096) inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 253080) 253088) inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$BorrowField$5$anon0_correct@@4  (=> (= inline$$BorrowField$5$p@1@@4 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (=> (and (and (= inline$$BorrowField$5$size@1@@4 (|size#$Path| inline$$BorrowField$5$p@1@@4)) (= inline$$BorrowField$5$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@4) inline$$BorrowField$5$size@1@@4 $Diem_CurrencyInfo_cancel_burn_events) (+ inline$$BorrowField$5$size@1@@4 1)))) (and (= inline$$BorrowField$5$dst@1@@4 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) inline$$BorrowField$5$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|))) $Diem_CurrencyInfo_cancel_burn_events))) (= (ControlFlow 0 252824) 253080))) inline$$Diem_CancelBurnEvent_pack$0$anon0_correct@@0))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@5) (= (ControlFlow 0 252830) 252824)) inline$$BorrowField$5$anon0_correct@@4)))
(let ((inline$$Not$0$anon0_correct@@5  (=> (= inline$$Not$0$dst@1@@5 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$3$v@1@@4)))) (and (=> (= (ControlFlow 0 251973) 252830) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 251973) 252108) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 251963) (- 0 431052)) true) (=> (= (ControlFlow 0 251963) 251973) inline$$Not$0$anon0_correct@@5))))
(let ((inline$$ReadRef$3$anon0_correct@@4  (=> (and (= inline$$ReadRef$3$v@1@@4 (|v#$Mutation| inline$$BorrowField$4$dst@1@@4)) (= (ControlFlow 0 251915) 251963)) inline$$Not$0$Entry_correct@@5)))
(let ((inline$$BorrowField$4$anon0_correct@@4  (=> (= inline$$BorrowField$4$p@1@@4 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|)) (=> (and (and (= inline$$BorrowField$4$size@1@@4 (|size#$Path| inline$$BorrowField$4$p@1@@4)) (= inline$$BorrowField$4$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@4) inline$$BorrowField$4$size@1@@4 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$4$size@1@@4 1)))) (and (= inline$$BorrowField$4$dst@1@@4 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|) inline$$BorrowField$4$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@4|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 251877) 251915))) inline$$ReadRef$3$anon0_correct@@4))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@4  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@4| inline$$BorrowGlobal$1$dst@2@@3) (= (ControlFlow 0 251661) 251877)) inline$$BorrowField$4$anon0_correct@@4))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@4  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@4 inline$$WritebackToReference$1$srcPath@1@@4)) (= |inline$$WritebackToReference$1$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) inline$$WritebackToReference$1$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@4) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@4|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@4| |inline$$WritebackToReference$1$dst'@1@@4|) (= (ControlFlow 0 251717) 251877))) inline$$BorrowField$4$anon0_correct@@4)))
(let ((inline$$WritebackToReference$1$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@4|)) (= inline$$WritebackToReference$1$dstPath@1@@4 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@3))) (and (=> (= (ControlFlow 0 251625) 251717) inline$$WritebackToReference$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 251625) 251661) inline$$WritebackToReference$1$anon3_Else_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 251488) 251625)) inline$$WritebackToReference$1$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|)) (= (ControlFlow 0 254265) 251625)) inline$$WritebackToReference$1$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon92_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 251480) 254265) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 251480) 251488) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon92_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (and (=> (= (ControlFlow 0 254275) 254265) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 254275) 251488) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@4  (=> (= |inline$$WriteRef$1$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@4) (|p#$Mutation| inline$$BorrowField$3$dst@1@@4) inline$$Sub$0$dst@2@@4)) (and (=> (= (ControlFlow 0 251466) 254275) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 251466) 251480) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@4  (=> (= inline$$BorrowField$3$p@1@@4 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (=> (and (and (= inline$$BorrowField$3$size@1@@4 (|size#$Path| inline$$BorrowField$3$p@1@@4)) (= inline$$BorrowField$3$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@4) inline$$BorrowField$3$size@1@@4 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@4 1)))) (and (= inline$$BorrowField$3$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) inline$$BorrowField$3$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 251407) 251466))) inline$$WriteRef$1$anon0_correct@@4))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Else_correct  (=> (and (not $abort_flag@6@@6) (= (ControlFlow 0 251413) 251407)) inline$$BorrowField$3$anon0_correct@@4)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@6@@6 true) (=> (and (= $abort_code@9@@5 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@4 inline$$Sub$0$dst@0@@4)) (and (=> (= (ControlFlow 0 251277) 254279) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 251277) 251413) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@4  (=> (and (< (|i#$Integer| inline$$ReadRef$2$v@1@@4) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9)) (= (ControlFlow 0 251275) 251277)) inline$$Sub$0$anon3_Then$1_correct@@4)))
(let ((inline$$Sub$0$anon3_Else_correct@@4  (=> (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9) (|i#$Integer| inline$$ReadRef$2$v@1@@4)) (=> (and (and (= inline$$Sub$0$dst@1@@4 ($Integer (- (|i#$Integer| inline$$ReadRef$2$v@1@@4) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9)))) (= $abort_flag@6@@6 $abort_flag@5@@6)) (and (= $abort_code@9@@5 $abort_code@7@@6) (= inline$$Sub$0$dst@2@@4 inline$$Sub$0$dst@1@@4))) (and (=> (= (ControlFlow 0 251223) 254279) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 251223) 251413) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 251197) (- 0 430616)) true) (and (=> (= (ControlFlow 0 251197) 251275) inline$$Sub$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 251197) 251223) inline$$Sub$0$anon3_Else_correct@@4)))))
(let ((inline$$ReadRef$2$anon0_correct@@4  (=> (and (= inline$$ReadRef$2$v@1@@4 (|v#$Mutation| inline$$BorrowField$2$dst@1@@4)) (= (ControlFlow 0 251098) 251197)) inline$$Sub$0$Entry_correct@@4)))
(let ((inline$$BorrowField$2$anon0_correct@@4  (=> (= inline$$BorrowField$2$p@1@@4 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (=> (and (and (= inline$$BorrowField$2$size@1@@4 (|size#$Path| inline$$BorrowField$2$p@1@@4)) (= inline$$BorrowField$2$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@4) inline$$BorrowField$2$size@1@@4 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@4 1)))) (and (= inline$$BorrowField$2$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) inline$$BorrowField$2$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 251060) 251098))) inline$$ReadRef$2$anon0_correct@@4))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@4) (= (ControlFlow 0 251112) 251060)) inline$$BorrowField$2$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon46_correct  (=> (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|) (=> (and (= $abort_code@10@@4 $abort_code@8@@5) (= (ControlFlow 0 250894) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 250892) 250894)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon89_Then_correct  (=> (= (ControlFlow 0 250902) 250894) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Else$1_correct  (=> (= $abort_code@8@@5 (|i#$Integer| call3formal@$ret0@0@@31)) (and (=> (= (ControlFlow 0 250886) 250902) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 250886) 250892) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@4  (and (=> (= (ControlFlow 0 250876) (- 0 430448)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 250876) 250886) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@4  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@4 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (= (ControlFlow 0 250828) 250876)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@4)) (= (ControlFlow 0 250880) 250828)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon86_Else_correct  (=> (not $abort_flag@5@@6) (and (=> (= (ControlFlow 0 250753) 251112) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 250753) 250880) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Else$2_correct  (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@6)) (and (=> $abort_flag@5@@6 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@6) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@31 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@31) (>= (|i#$Integer| call3formal@$ret0@0@@31) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@31) $MAX_U64))) (and (=> (= (ControlFlow 0 250747) 254299) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 250747) 250753) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@4  (=> (and (= inline$$Ge$0$dst@1@@4 ($Boolean (>= (|i#$Integer| inline$$ReadRef$1$v@1@@4) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@9)))) (= (ControlFlow 0 250735) 250747)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Else$2_correct)))
(let ((inline$$Ge$0$Entry_correct@@4  (and (=> (= (ControlFlow 0 250721) (- 0 430338)) true) (=> (= (ControlFlow 0 250721) 250735) inline$$Ge$0$anon0_correct@@4))))
(let ((inline$$ReadRef$1$anon0_correct@@4  (=> (and (= inline$$ReadRef$1$v@1@@4 (|v#$Mutation| inline$$BorrowField$1$dst@1@@4)) (= (ControlFlow 0 250663) 250721)) inline$$Ge$0$Entry_correct@@4)))
(let ((inline$$BorrowField$1$anon0_correct@@4  (=> (= inline$$BorrowField$1$p@1@@4 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (=> (and (and (= inline$$BorrowField$1$size@1@@4 (|size#$Path| inline$$BorrowField$1$p@1@@4)) (= inline$$BorrowField$1$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@4) inline$$BorrowField$1$size@1@@4 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$1$size@1@@4 1)))) (and (= inline$$BorrowField$1$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@3) inline$$BorrowField$1$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 250625) 250663))) inline$$ReadRef$1$anon0_correct@@4))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Else_correct  (=> (and (not $abort_flag@4@@7) (= (ControlFlow 0 250677) 250625)) inline$$BorrowField$1$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Then_correct  (=> (and (and $abort_flag@4@@7 (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|)) (and (= $abort_code@10@@4 $abort_code@6@@6) (= (ControlFlow 0 254319) 248694))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 250433) 254319) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 250433) 250677) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@2  (and (=> (= (ControlFlow 0 250443) 254319) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 250443) 250677) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon85_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@9  (=> (= inline$$GetFieldFromValue$0$dst@1@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 250417) 250443) inline$$Diem_value_$def$0$anon6_Then_correct@@2) (=> (= (ControlFlow 0 250417) 250433) inline$$Diem_value_$def$0$anon6_Else_correct@@2)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@2  (=> (and (not true) (= (ControlFlow 0 250341) 250417)) inline$$GetFieldFromValue$0$anon0_correct@@9)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@2  (=> (= (ControlFlow 0 250451) 250417) inline$$GetFieldFromValue$0$anon0_correct@@9)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@2  (=> (not $abort_flag@4@@7) (and (=> (= (ControlFlow 0 250335) 250451) inline$$Diem_value_$def$0$anon5_Then_correct@@2) (=> (= (ControlFlow 0 250335) 250341) inline$$Diem_value_$def$0$anon5_Else_correct@@2)))))
(let ((inline$$Diem_value_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@6) (let ((va@@217 (|v#$Vector| call4formal@$ret0@0@@6)))
(let ((l@@217 (|l#$ValueArray| va@@217)))
 (and (and (<= 0 l@@217) (<= l@@217 $MAX_U64)) (forall ((x@@217 Int) ) (!  (=> (or (< x@@217 0) (>= x@@217 l@@217)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@217) x@@217) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@217) x@@217))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 250457) 250335)) inline$$Diem_value_$def$0$anon0_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@4  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@4)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@4)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 250169) 250457)) inline$$Diem_value_$direct_intra$0$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@4  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@4 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@3)) (= (ControlFlow 0 250163) 250169)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Else_correct  (=> (and (not $abort_flag@4@@7) (= (ControlFlow 0 250173) 250163)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@4)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@3  (=> (= $abort_code@6@@6 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@7 true) (= inline$$BorrowGlobal$1$dst@2@@3 inline$$BorrowGlobal$1$dst@0@@3)) (and (=> (= (ControlFlow 0 250123) 254323) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 250123) 250173) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@3  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@3 inline$$BorrowGlobal$1$a@1@@3)) (= (ControlFlow 0 250121) 250123)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@3)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@3  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@3 inline$$BorrowGlobal$1$a@1@@3) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@3 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0@@3 inline$$BorrowGlobal$1$a@1@@3) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@3 inline$$BorrowGlobal$1$a@1@@3))) (= $abort_code@6@@6 $abort_code@5@@6)) (and (= $abort_flag@4@@7 $abort_flag@3@@7) (= inline$$BorrowGlobal$1$dst@2@@3 inline$$BorrowGlobal$1$dst@1@@3))) (and (=> (= (ControlFlow 0 250069) 254323) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 250069) 250173) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@3  (=> (= inline$$BorrowGlobal$1$a@1@@3 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@8)) (and (=> (= (ControlFlow 0 250039) 250121) inline$$BorrowGlobal$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 250039) 250069) inline$$BorrowGlobal$1$anon3_Else_correct@@3)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@3  (=> (= inline$$BorrowGlobal$1$ta@0@@3 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1)) (and (=> (= (ControlFlow 0 250033) (- 0 430029)) true) (=> (= (ControlFlow 0 250033) 250039) inline$$BorrowGlobal$1$anon0_correct@@3)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Else_correct  (=> (and (not $abort_flag@3@@7) (= (ControlFlow 0 250129) 250033)) inline$$BorrowGlobal$1$Entry_correct@@3)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Then_correct  (=> (and (and $abort_flag@3@@7 (= $Diem_Preburn_$memory@0@@2 |inline$$WritebackToGlobal$0$m'@2@@4|)) (and (= $abort_code@10@@4 $abort_code@5@@6) (= (ControlFlow 0 254343) 248694))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@8  (=> (not true) (and (=> (= (ControlFlow 0 249890) 254343) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 249890) 250129) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@8  (and (=> (= (ControlFlow 0 249900) 254343) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 249900) 250129) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon82_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@8  (=> (and (not $abort_flag@3@@7) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@8 ($Address 173345816))) (and (=> (= (ControlFlow 0 249884) 249900) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 249884) 249890) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@8)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon80_Else_correct  (=> (and (not $abort_flag@3@@7) (= (ControlFlow 0 249914) 249884)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@8)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon26_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@7) (=> (and (=> $abort_flag@3@@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@3@@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@6 (|i#$Integer| ($Integer 5)))))) (=> (and (and (and (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@30 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@182 T@$Value) )  (=> ((_ is $Address) addr@@182) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@182))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@182))))))))))))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@183 T@$Value) )  (=> ((_ is $Address) addr@@183) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@183)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@183)))))))))))))) (and (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@184 T@$Value) )  (=> ((_ is $Address) addr@@184) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@184))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@184)))))))))))))))) (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@185 T@$Value) )  (=> ((_ is $Address) addr@@185) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@185)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@185)))))))))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))))) (and (and (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@186 T@$Value) )  (=> ((_ is $Address) addr@@186) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@186))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@186)))))))))))))))) (and (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean (forall ((addr@@187 T@$Value) )  (=> ((_ is $Address) addr@@187) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@187)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@187)))))))))))) (=> (not $abort_flag@3@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@30) (let ((va@@218 (|v#$Vector| call3formal@$ret0@0@@30)))
(let ((l@@218 (|l#$ValueArray| va@@218)))
 (and (and (<= 0 l@@218) (<= l@@218 $MAX_U64)) (forall ((x@@218 Int) ) (!  (=> (or (< x@@218 0) (>= x@@218 l@@218)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@218) x@@218) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@218) x@@218))
)))))) (forall (($$0@@65 Int) ) (!  (=> (and (>= $$0@@65 0) (< $$0@@65 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) $$0@@65)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) $$0@@65)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) $$0@@65)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@30)) $$0@@65))
))))) (and (=> (= (ControlFlow 0 249779) 254347) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 249779) 249914) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon80_Else_correct)))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 249777) 249779)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon79_Then_correct  (=> (= (ControlFlow 0 254371) 249779) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon24$2_correct  (and (=> (= (ControlFlow 0 249769) (- 0 429001)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@13 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@13) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@14 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@14) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 249769) (- 0 429064)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@15 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@16 T@$Value) )  (=> ((_ is $Type) inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@4|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_cancel_burn_with_capability_$def_verify$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_cancel_burn_with_capability_$def_verify$0$tc_addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 249769) 254371) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 249769) 249777) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon79_Else_correct))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@4  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@4)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@4| $Diem_Preburn_$memory) (= (ControlFlow 0 249531) 249769)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon24$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@4  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@4) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@4 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@4)) (= inline$$WritebackToGlobal$0$a@1@@4 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@4))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@4 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@4 inline$$WritebackToGlobal$0$a@1@@4) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|))) (= |inline$$WritebackToGlobal$0$m'@1@@4| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@4 inline$$WritebackToGlobal$0$a@1@@4 inline$$WritebackToGlobal$0$v@1@@4)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@4| |inline$$WritebackToGlobal$0$m'@1@@4|) (= (ControlFlow 0 249585) 249769))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon24$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@4  (=> (= inline$$WritebackToGlobal$0$l@1@@4 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@4|)) (and (=> (= (ControlFlow 0 249521) 249585) inline$$WritebackToGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 249521) 249531) inline$$WritebackToGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@4  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@4| inline$$BorrowGlobal$0$dst@2@@4) (= (ControlFlow 0 249341) 249521)) inline$$WritebackToGlobal$0$anon0_correct@@4))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@4  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@4))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@4 inline$$WritebackToReference$0$srcPath@1@@4)) (= |inline$$WritebackToReference$0$dst'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) inline$$WritebackToReference$0$dstPath@1@@4 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@4 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@4) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@4|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@4| |inline$$WritebackToReference$0$dst'@1@@4|) (= (ControlFlow 0 249397) 249521))) inline$$WritebackToGlobal$0$anon0_correct@@4)))
(let ((inline$$WritebackToReference$0$anon0_correct@@4  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@4 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@4|)) (= inline$$WritebackToReference$0$dstPath@1@@4 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@4))) (and (=> (= (ControlFlow 0 249305) 249397) inline$$WritebackToReference$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 249305) 249341) inline$$WritebackToReference$0$anon3_Else_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 249168) 249305)) inline$$WritebackToReference$0$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4)) (= (ControlFlow 0 254381) 249305)) inline$$WritebackToReference$0$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 249160) 254381) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 249160) 249168) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon77_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_cancel_burn_with_capability_$def_verify$0$info@0)) (and (=> (= (ControlFlow 0 254391) 254381) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 254391) 249168) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@4  (=> (= |inline$$WriteRef$0$to'@1@@4| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@4) (|p#$Mutation| inline$$BorrowField$0$dst@1@@4) call5formal@$ret1@0@@4)) (and (=> (= (ControlFlow 0 249146) 254391) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 249146) 249160) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@2@@9) (= (ControlFlow 0 249152) 249146)) inline$$WriteRef$0$anon0_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Else$2_correct  (and (=> (= (ControlFlow 0 249089) (- 0 427956)) true) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@9) (=> (and (=> $abort_flag@2@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@4)) $Diem_Diem_value)))))) (=> (and (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@4)) $Diem_Diem_value) ($Integer 0))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@188 T@$Value) )  (=> ((_ is $Address) addr@@188) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@188))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@188))))))))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@189 T@$Value) )  (=> ((_ is $Address) addr@@189) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@189)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@189)))))))))))))) (=> (and (and (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@190 T@$Value) )  (=> ((_ is $Address) addr@@190) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@190))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@190)))))))))))))))) (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@191 T@$Value) )  (=> ((_ is $Address) addr@@191) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@191)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@191)))))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@192 T@$Value) )  (=> ((_ is $Address) addr@@192) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@192))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@192)))))))))))))))) (and (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean (forall ((addr@@193 T@$Value) )  (=> ((_ is $Address) addr@@193) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@193)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| addr@@193)))))))))))) (=> (not $abort_flag@2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0@@6) (let ((va@@219 (|v#$Vector| call4formal@$ret0@0@@6)))
(let ((l@@219 (|l#$ValueArray| va@@219)))
 (and (and (<= 0 l@@219) (<= l@@219 $MAX_U64)) (forall ((x@@219 Int) ) (!  (=> (or (< x@@219 0) (>= x@@219 l@@219)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@219) x@@219) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@219) x@@219))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0@@6)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0@@4) (let ((va@@220 (|v#$Vector| call5formal@$ret1@0@@4)))
(let ((l@@220 (|l#$ValueArray| va@@220)))
 (and (and (<= 0 l@@220) (<= l@@220 $MAX_U64)) (forall ((x@@220 Int) ) (!  (=> (or (< x@@220 0) (>= x@@220 l@@220)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@220) x@@220) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@220) x@@220))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0@@4)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 249089) 254395) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 249089) 249152) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon75_Else_correct))))))))))
(let ((inline$$ReadRef$0$anon0_correct@@4  (=> (and (= inline$$ReadRef$0$v@1@@4 (|v#$Mutation| inline$$BorrowField$0$dst@1@@4)) (= (ControlFlow 0 249077) 249089)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@4  (=> (= inline$$BorrowField$0$p@1@@4 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@4)) (=> (and (and (= inline$$BorrowField$0$size@1@@4 (|size#$Path| inline$$BorrowField$0$p@1@@4)) (= inline$$BorrowField$0$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@4) inline$$BorrowField$0$size@1@@4 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@4 1)))) (and (= inline$$BorrowField$0$dst@1@@4 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@4) inline$$BorrowField$0$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@4))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 249039) 249077))) inline$$ReadRef$0$anon0_correct@@4))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Else_correct  (=> (and (not $abort_flag@1@@10) (= (ControlFlow 0 249045) 249039)) inline$$BorrowField$0$anon0_correct@@4)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@1@@10 true) (=> (and (= $abort_code@3@@9 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@4 inline$$BorrowGlobal$0$dst@0@@4)) (and (=> (= (ControlFlow 0 248909) 254415) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 248909) 249045) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@4 inline$$BorrowGlobal$0$a@1@@4)) (= (ControlFlow 0 248907) 248909)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@4)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@4 inline$$BorrowGlobal$0$a@1@@4) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@4 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@4 inline$$BorrowGlobal$0$a@1@@4) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@4 inline$$BorrowGlobal$0$a@1@@4))) (= $abort_flag@1@@10 $abort_flag@0@@10)) (and (= $abort_code@3@@9 $abort_code@1@@10) (= inline$$BorrowGlobal$0$dst@2@@4 inline$$BorrowGlobal$0$dst@1@@4))) (and (=> (= (ControlFlow 0 248855) 254415) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 248855) 249045) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@4  (=> (= inline$$BorrowGlobal$0$a@1@@4 (|a#$Address| preburn_address@@4)) (and (=> (= (ControlFlow 0 248825) 248907) inline$$BorrowGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 248825) 248855) inline$$BorrowGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@4  (=> (= inline$$BorrowGlobal$0$ta@0@@4 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1)) (and (=> (= (ControlFlow 0 248819) (- 0 427771)) true) (=> (= (ControlFlow 0 248819) 248825) inline$$BorrowGlobal$0$anon0_correct@@4)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon71_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t12@1) (= (ControlFlow 0 248915) 248819)) inline$$BorrowGlobal$0$Entry_correct@@4)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon12_correct  (=> (= $Diem_Preburn_$memory@0@@2 $Diem_Preburn_$memory) (=> (and (= $abort_code@10@@4 $abort_code@2@@8) (= (ControlFlow 0 248688) 248694)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 248686) 248688)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 248702) 248688) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon71_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t12@1)) (= $abort_code@2@@8 (|i#$Integer| call3formal@$ret0@0@@32))) (and (=> (= (ControlFlow 0 248680) 248702) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 248680) 248686) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@0@@10) (and (=> (= (ControlFlow 0 248668) 248915) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 248668) 248680) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon4$1_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t12@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@18) 1) (|a#$Address| preburn_address@@4)))) (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def_verify$0$$t13@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@10)) (and (=> $abort_flag@0@@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@32 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@32) (>= (|i#$Integer| call3formal@$ret0@0@@32) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@32) $MAX_U64))) (and (=> (= (ControlFlow 0 248662) 254435) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 248662) 248668) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon69_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 248602) 248662)) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 254459) 248662) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 248594) 254459) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 248594) 248602) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 254467) 254459) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 254467) 248602) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon68_Else_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 248588) 254467) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 248588) 248594) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon67_Else_correct)))))
(let ((anon0$1_correct@@11  (=> (and (forall (($inv_addr@@29 Int) ($inv_tv0@@25 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29)) (let ((va@@221 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))))
(let ((l@@221 (|l#$ValueArray| va@@221)))
 (and (and (<= 0 l@@221) (<= l@@221 $MAX_U64)) (forall ((x@@221 Int) ) (!  (=> (or (< x@@221 0) (>= x@@221 l@@221)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@221) x@@221) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@221) x@@221))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@25) 1) $inv_addr@@29))
)) (forall (($inv_addr@@30 Int) ($inv_tv0@@26 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30)) (let ((va@@222 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))))
(let ((l@@222 (|l#$ValueArray| va@@222)))
 (and (and (<= 0 l@@222) (<= l@@222 $MAX_U64)) (forall ((x@@222 Int) ) (!  (=> (or (< x@@222 0) (>= x@@222 l@@222)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@222) x@@222) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@222) x@@222))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@223 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@223 (|l#$ValueArray| va@@223)))
 (and (and (<= 0 l@@223) (<= l@@223 $MAX_U64)) (forall ((x@@223 Int) ) (!  (=> (or (< x@@223 0) (>= x@@223 l@@223)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@223) x@@223) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@223) x@@223))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code)) (let ((va@@224 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@224 (|l#$ValueArray| va@@224)))
 (and (and (<= 0 l@@224) (<= l@@224 $MAX_U64)) (forall ((x@@224 Int) ) (!  (=> (or (< x@@224 0) (>= x@@224 l@@224)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@224) x@@224) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@224) x@@224))
))))))) (forall (($$0@@66 Int) ) (!  (=> (and (>= $$0@@66 0) (< $$0@@66 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))) $$0@@66)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))) $$0@@66)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))) $$0@@66)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_currency_code))) $$0@@66))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events)) (let ((va@@225 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@225 (|l#$ValueArray| va@@225)))
 (and (and (<= 0 l@@225) (<= l@@225 $MAX_U64)) (forall ((x@@225 Int) ) (!  (=> (or (< x@@225 0) (>= x@@225 l@@225)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@225) x@@225) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@225) x@@225))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@226 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@226 (|l#$ValueArray| va@@226)))
 (and (and (<= 0 l@@226) (<= l@@226 $MAX_U64)) (forall ((x@@226 Int) ) (!  (=> (or (< x@@226 0) (>= x@@226 l@@226)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@226) x@@226) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@226) x@@226))
))))))) (forall (($$0@@67 Int) ) (!  (=> (and (>= $$0@@67 0) (< $$0@@67 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@67)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@67)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@67)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@67))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events)) (let ((va@@227 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@227 (|l#$ValueArray| va@@227)))
 (and (and (<= 0 l@@227) (<= l@@227 $MAX_U64)) (forall ((x@@227 Int) ) (!  (=> (or (< x@@227 0) (>= x@@227 l@@227)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@227) x@@227) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@227) x@@227))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@228 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@228 (|l#$ValueArray| va@@228)))
 (and (and (<= 0 l@@228) (<= l@@228 $MAX_U64)) (forall ((x@@228 Int) ) (!  (=> (or (< x@@228 0) (>= x@@228 l@@228)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@228) x@@228) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@228) x@@228))
))))))) (forall (($$0@@68 Int) ) (!  (=> (and (>= $$0@@68 0) (< $$0@@68 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@68)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@68)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@68)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@68))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@229 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@229 (|l#$ValueArray| va@@229)))
 (and (and (<= 0 l@@229) (<= l@@229 $MAX_U64)) (forall ((x@@229 Int) ) (!  (=> (or (< x@@229 0) (>= x@@229 l@@229)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@229) x@@229) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@229) x@@229))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@230 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@230 (|l#$ValueArray| va@@230)))
 (and (and (<= 0 l@@230) (<= l@@230 $MAX_U64)) (forall ((x@@230 Int) ) (!  (=> (or (< x@@230 0) (>= x@@230 l@@230)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@230) x@@230) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@230) x@@230))
))))))) (forall (($$0@@69 Int) ) (!  (=> (and (>= $$0@@69 0) (< $$0@@69 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@69)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@69)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@69)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@69))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@231 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@231 (|l#$ValueArray| va@@231)))
 (and (and (<= 0 l@@231) (<= l@@231 $MAX_U64)) (forall ((x@@231 Int) ) (!  (=> (or (< x@@231 0) (>= x@@231 l@@231)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@231) x@@231) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@231) x@@231))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@232 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@232 (|l#$ValueArray| va@@232)))
 (and (and (<= 0 l@@232) (<= l@@232 $MAX_U64)) (forall ((x@@232 Int) ) (!  (=> (or (< x@@232 0) (>= x@@232 l@@232)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@232) x@@232) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@232) x@@232))
))))))) (forall (($$0@@70 Int) ) (!  (=> (and (>= $$0@@70 0) (< $$0@@70 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@70)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@70)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@70)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@70))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@233 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@233 (|l#$ValueArray| va@@233)))
 (and (and (<= 0 l@@233) (<= l@@233 $MAX_U64)) (forall ((x@@233 Int) ) (!  (=> (or (< x@@233 0) (>= x@@233 l@@233)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@233) x@@233) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@233) x@@233))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@234 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@234 (|l#$ValueArray| va@@234)))
 (and (and (<= 0 l@@234) (<= l@@234 $MAX_U64)) (forall ((x@@234 Int) ) (!  (=> (or (< x@@234 0) (>= x@@234 l@@234)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@234) x@@234) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@234) x@@234))
))))))) (forall (($$0@@71 Int) ) (!  (=> (and (>= $$0@@71 0) (< $$0@@71 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@71)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@71)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@71)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@71))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@26) 1) $inv_addr@@30))
))) (=> (and (and (forall (($inv_addr@@31 Int) ($inv_tv0@@27 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31)) (let ((va@@235 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))))
(let ((l@@235 (|l#$ValueArray| va@@235)))
 (and (and (<= 0 l@@235) (<= l@@235 $MAX_U64)) (forall ((x@@235 Int) ) (!  (=> (or (< x@@235 0) (>= x@@235 l@@235)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@235) x@@235) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@235) x@@235))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn)) (let ((va@@236 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn))))
(let ((l@@236 (|l#$ValueArray| va@@236)))
 (and (and (<= 0 l@@236) (<= l@@236 $MAX_U64)) (forall ((x@@236 Int) ) (!  (=> (or (< x@@236 0) (>= x@@236 l@@236)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@236) x@@236) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@236) x@@236))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@27) 1) $inv_addr@@31))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@19 T@$Value) )  (=> ((_ is $Type) coin_type@@19) (|b#$Boolean| ($Boolean (forall ((addr3@@9 T@$Value) )  (=> ((_ is $Address) addr3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@19)) 1) (|a#$Address| addr3@@9)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@20 T@$Value) )  (=> ((_ is $Type) coin_type@@20) (|b#$Boolean| ($Boolean (forall ((addr1@@8 T@$Value) )  (=> ((_ is $Address) addr1@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@20)) 1) (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 254473) 248588))) inline$$Diem_cancel_burn_with_capability_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@11  (=> ((_ is $Address) preburn_address@@4) (=> (and (and (and (and (and ((_ is $Vector) _capability@@0) (let ((va@@237 (|v#$Vector| _capability@@0)))
(let ((l@@237 (|l#$ValueArray| va@@237)))
 (and (and (<= 0 l@@237) (<= l@@237 $MAX_U64)) (forall ((x@@237 Int) ) (!  (=> (or (< x@@237 0) (>= x@@237 l@@237)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@237) x@@237) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@237) x@@237))
)))))) (= (|l#$ValueArray| (|v#$Vector| _capability@@0)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _capability@@0)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 246236) 254473)) anon0$1_correct@@11))))
(let ((PreconditionGeneratedEntry_correct@@8  (=> (= (ControlFlow 0 423937) 246236) anon0_correct@@11)))
PreconditionGeneratedEntry_correct@@8)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account () T@$Value)
(declare-fun $abort_flag@4@@8 () Bool)
(declare-fun $tv0@@19 () T@$TypeValue)
(declare-fun $abort_code@5@@7 () Int)
(declare-fun inline$$Diem_create_preburn_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@4@@9 () Int)
(declare-fun $abort_code@1@@11 () Int)
(declare-fun $abort_flag@0@@11 () Bool)
(declare-fun $abort_code@2@@9 () Int)
(declare-fun $abort_flag@1@@11 () Bool)
(declare-fun $abort_flag@3@@8 () Bool)
(declare-fun $abort_code@3@@10 () Int)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@2@@10 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 433763) (let ((anon0$2_correct@@12  (and (=> (= (ControlFlow 0 256856) (- 0 437693)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@4@@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@4@@8) (and (=> (= (ControlFlow 0 256856) (- 0 437714)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@4@@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@4@@8) (and (=> (= (ControlFlow 0 256856) (- 0 437743)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@4@@8)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@4@@8) (and (=> (= (ControlFlow 0 256856) (- 0 437760)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@8)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@8) (and (=> (= (ControlFlow 0 256856) (- 0 437777)) (=> $abort_flag@4@@8 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@4@@8 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 437858)) (=> $abort_flag@4@@8 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@4@@8 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@7 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 256856) (- 0 437983)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438032)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@194 T@$Value) )  (=> ((_ is $Address) addr@@194) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@194))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@194)))))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@195 T@$Value) )  (=> ((_ is $Address) addr@@195) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@195))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@195))))))))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438112)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@196 T@$Value) )  (=> ((_ is $Address) addr@@196) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@196)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@196))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@197 T@$Value) )  (=> ((_ is $Address) addr@@197) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@197)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@197)))))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438180)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438229)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@198 T@$Value) )  (=> ((_ is $Address) addr@@198) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@198))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@198)))))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@199 T@$Value) )  (=> ((_ is $Address) addr@@199) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@199))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@199))))))))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438309)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@200 T@$Value) )  (=> ((_ is $Address) addr@@200) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@200)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@200))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@201 T@$Value) )  (=> ((_ is $Address) addr@@201) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@201)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@201)))))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438377)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438426)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438475)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@202 T@$Value) )  (=> ((_ is $Address) addr@@202) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@202))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@202)))))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@203 T@$Value) )  (=> ((_ is $Address) addr@@203) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@203))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@203))))))))))))))) (and (=> (= (ControlFlow 0 256856) (- 0 438555)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@204 T@$Value) )  (=> ((_ is $Address) addr@@204) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@204)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@204))))))))))))) (=> (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean (forall ((addr@@205 T@$Value) )  (=> ((_ is $Address) addr@@205) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@205)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@205)))))))))))) (=> (= (ControlFlow 0 256856) (- 0 438623)) (=> (not $abort_flag@4@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_create_preburn_$def_verify$0$Abort_correct  (=> (and (and (= inline$$Diem_create_preburn_$def_verify$0$$ret0@1 $Error) (= $abort_flag@4@@8 true)) (and (= $abort_code@5@@7 $abort_code@4@@9) (= (ControlFlow 0 256800) 256856))) anon0$2_correct@@12)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon5_correct  (=> (and (= $abort_code@4@@9 $abort_code@1@@11) (= (ControlFlow 0 256832) 256800)) inline$$Diem_create_preburn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 256830) 256832)) inline$$Diem_create_preburn_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 256840) 256832) inline$$Diem_create_preburn_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon16_Then_correct  (=> $abort_flag@0@@11 (and (=> (= (ControlFlow 0 256824) 256840) inline$$Diem_create_preburn_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 256824) 256830) inline$$Diem_create_preburn_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon9_correct  (=> (and (= $abort_code@4@@9 $abort_code@2@@9) (= (ControlFlow 0 256812) 256800)) inline$$Diem_create_preburn_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 256810) 256812)) inline$$Diem_create_preburn_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 256820) 256812) inline$$Diem_create_preburn_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon18_Then_correct  (=> $abort_flag@1@@11 (and (=> (= (ControlFlow 0 256804) 256820) inline$$Diem_create_preburn_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 256804) 256810) inline$$Diem_create_preburn_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon20_Then_correct  (=> $abort_flag@3@@8 (=> (and (= $abort_code@4@@9 $abort_code@3@@10) (= (ControlFlow 0 256794) 256800)) inline$$Diem_create_preburn_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon14_correct  (=> (= $abort_flag@4@@8 $abort_flag@3@@8) (=> (and (= $abort_code@5@@7 $abort_code@3@@10) (= (ControlFlow 0 256782) 256856)) anon0$2_correct@@12))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 256780) 256782)) inline$$Diem_create_preburn_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 256790) 256782) inline$$Diem_create_preburn_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 256758) 256790) inline$$Diem_create_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 256758) 256780) inline$$Diem_create_preburn_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 256764) 256790) inline$$Diem_create_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 256764) 256780) inline$$Diem_create_preburn_$def_verify$0$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 256752) 256764) inline$$Diem_Preburn_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 256752) 256758) inline$$Diem_Preburn_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 256744) 256790) inline$$Diem_create_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 256744) 256780) inline$$Diem_create_preburn_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2) (let ((va@@238 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)))
(let ((l@@238 (|l#$ValueArray| va@@238)))
 (and (and (<= 0 l@@238) (<= l@@238 $MAX_U64)) (forall ((x@@238 Int) ) (!  (=> (or (< x@@238 0) (>= x@@238 l@@238)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@238) x@@238) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@238) x@@238))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2) 1)))) (and (=> (= (ControlFlow 0 256736) 256752) inline$$Diem_Preburn_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 256736) 256744) inline$$Diem_Preburn_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@3@@8) (= (ControlFlow 0 256770) 256736)) inline$$Diem_Preburn_pack$0$anon0_correct)))
(let ((inline$$Diem_zero_$def$0$anon3_correct  (=> (= inline$$Diem_zero_$def$0$$ret0@1 $Error) (=> (and (= $abort_flag@3@@8 true) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_zero_$def$0$$ret0@1)) (and (=> (= (ControlFlow 0 256575) 256794) inline$$Diem_create_preburn_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 256575) 256770) inline$$Diem_create_preburn_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 256569) 256575)) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct  (=> (= (ControlFlow 0 256583) 256575) inline$$Diem_zero_$def$0$anon3_correct)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct  (=> $abort_flag@2@@10 (and (=> (= (ControlFlow 0 256563) 256583) inline$$Diem_zero_$def$0$anon8_Then_correct) (=> (= (ControlFlow 0 256563) 256569) inline$$Diem_zero_$def$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct  (=> (and (= $abort_flag@3@@8 $abort_flag@2@@10) (= inline$$Diem_zero_$def$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1)) (and (=> (= (ControlFlow 0 256551) 256794) inline$$Diem_create_preburn_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 256551) 256770) inline$$Diem_create_preburn_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 256549) 256551)) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct  (=> (= (ControlFlow 0 256559) 256551) inline$$Diem_zero_$def$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 256527) 256559) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 256527) 256549) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 256533) 256559) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 256533) 256549) inline$$Diem_zero_$def$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 256521) 256533) inline$$Diem_Diem_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 256521) 256527) inline$$Diem_Diem_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 256513) 256559) inline$$Diem_zero_$def$0$anon9_Then_correct) (=> (= (ControlFlow 0 256513) 256549) inline$$Diem_zero_$def$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 256505) 256521) inline$$Diem_Diem_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 256505) 256513) inline$$Diem_Diem_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct  (=> (not $abort_flag@2@@10) (=> (and (= inline$$Diem_zero_$def$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 256539) 256505)) inline$$Diem_Diem_pack$0$anon0_correct))))
(let ((inline$$Diem_zero_$def$0$anon0_correct  (=> (and (and (not $abort_flag@1@@11) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@10)) (and (=> $abort_flag@2@@10 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2@@10 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@10 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 256364) 256563) inline$$Diem_zero_$def$0$anon7_Then_correct) (=> (= (ControlFlow 0 256364) 256539) inline$$Diem_zero_$def$0$anon7_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon18_Else_correct  (=> (and (not $abort_flag@1@@11) (= (ControlFlow 0 256597) 256364)) inline$$Diem_zero_$def$0$anon0_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon16_Else_correct  (=> (not $abort_flag@0@@11) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@11) (=> $abort_flag@1@@11 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@1@@11 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@9 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@206 T@$Value) )  (=> ((_ is $Address) addr@@206) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@206))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@206))))))))))))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@207 T@$Value) )  (=> ((_ is $Address) addr@@207) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@207)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@207)))))))))))))) (=> (and (and (and (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@208 T@$Value) )  (=> ((_ is $Address) addr@@208) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@208))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@208)))))))))))))))) (and (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@209 T@$Value) )  (=> ((_ is $Address) addr@@209) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@209)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@209)))))))))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@210 T@$Value) )  (=> ((_ is $Address) addr@@210) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@210))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@210)))))))))))))))) (and (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean (forall ((addr@@211 T@$Value) )  (=> ((_ is $Address) addr@@211) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@211)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| addr@@211)))))))))))) (=> (not $abort_flag@1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@19) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 256167) 256804) inline$$Diem_create_preburn_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 256167) 256597) inline$$Diem_create_preburn_$def_verify$0$anon18_Else_correct))))))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) $abort_flag@0@@11) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@11) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) $abort_flag@0@@11)) (and (=> $abort_flag@0@@11 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))))) (=> $abort_flag@0@@11 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account))))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account ($Address 186537453))))) (= $abort_code@1@@11 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 256161) 256824) inline$$Diem_create_preburn_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 256161) 256167) inline$$Diem_create_preburn_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 256125) 256161)) inline$$Diem_create_preburn_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 256848) 256161) inline$$Diem_create_preburn_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 256119) 256848) inline$$Diem_create_preburn_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 256119) 256125) inline$$Diem_create_preburn_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@12  (=> (forall (($inv_addr@@32 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32)) (let ((va@@239 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))))
(let ((l@@239 (|l#$ValueArray| va@@239)))
 (and (and (<= 0 l@@239) (<= l@@239 $MAX_U64)) (forall ((x@@239 Int) ) (!  (=> (or (< x@@239 0) (>= x@@239 l@@239)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@239) x@@239) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@239) x@@239))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@32))
)) (=> (and (forall (($inv_addr@@33 Int) ($inv_tv0@@28 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33)) (let ((va@@240 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))))
(let ((l@@240 (|l#$ValueArray| va@@240)))
 (and (and (<= 0 l@@240) (<= l@@240 $MAX_U64)) (forall ((x@@240 Int) ) (!  (=> (or (< x@@240 0) (>= x@@240 l@@240)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@240) x@@240) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@240) x@@240))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@241 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@241 (|l#$ValueArray| va@@241)))
 (and (and (<= 0 l@@241) (<= l@@241 $MAX_U64)) (forall ((x@@241 Int) ) (!  (=> (or (< x@@241 0) (>= x@@241 l@@241)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@241) x@@241) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@241) x@@241))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code)) (let ((va@@242 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@242 (|l#$ValueArray| va@@242)))
 (and (and (<= 0 l@@242) (<= l@@242 $MAX_U64)) (forall ((x@@242 Int) ) (!  (=> (or (< x@@242 0) (>= x@@242 l@@242)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@242) x@@242) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@242) x@@242))
))))))) (forall (($$0@@72 Int) ) (!  (=> (and (>= $$0@@72 0) (< $$0@@72 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))) $$0@@72)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))) $$0@@72)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))) $$0@@72)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_currency_code))) $$0@@72))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events)) (let ((va@@243 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@243 (|l#$ValueArray| va@@243)))
 (and (and (<= 0 l@@243) (<= l@@243 $MAX_U64)) (forall ((x@@243 Int) ) (!  (=> (or (< x@@243 0) (>= x@@243 l@@243)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@243) x@@243) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@243) x@@243))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@244 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@244 (|l#$ValueArray| va@@244)))
 (and (and (<= 0 l@@244) (<= l@@244 $MAX_U64)) (forall ((x@@244 Int) ) (!  (=> (or (< x@@244 0) (>= x@@244 l@@244)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@244) x@@244) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@244) x@@244))
))))))) (forall (($$0@@73 Int) ) (!  (=> (and (>= $$0@@73 0) (< $$0@@73 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@73)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@73)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@73)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@73))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events)) (let ((va@@245 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@245 (|l#$ValueArray| va@@245)))
 (and (and (<= 0 l@@245) (<= l@@245 $MAX_U64)) (forall ((x@@245 Int) ) (!  (=> (or (< x@@245 0) (>= x@@245 l@@245)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@245) x@@245) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@245) x@@245))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@246 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@246 (|l#$ValueArray| va@@246)))
 (and (and (<= 0 l@@246) (<= l@@246 $MAX_U64)) (forall ((x@@246 Int) ) (!  (=> (or (< x@@246 0) (>= x@@246 l@@246)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@246) x@@246) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@246) x@@246))
))))))) (forall (($$0@@74 Int) ) (!  (=> (and (>= $$0@@74 0) (< $$0@@74 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@74)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@74)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@74)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@74))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@247 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@247 (|l#$ValueArray| va@@247)))
 (and (and (<= 0 l@@247) (<= l@@247 $MAX_U64)) (forall ((x@@247 Int) ) (!  (=> (or (< x@@247 0) (>= x@@247 l@@247)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@247) x@@247) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@247) x@@247))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@248 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@248 (|l#$ValueArray| va@@248)))
 (and (and (<= 0 l@@248) (<= l@@248 $MAX_U64)) (forall ((x@@248 Int) ) (!  (=> (or (< x@@248 0) (>= x@@248 l@@248)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@248) x@@248) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@248) x@@248))
))))))) (forall (($$0@@75 Int) ) (!  (=> (and (>= $$0@@75 0) (< $$0@@75 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@75)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@75)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@75)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@75))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@249 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@249 (|l#$ValueArray| va@@249)))
 (and (and (<= 0 l@@249) (<= l@@249 $MAX_U64)) (forall ((x@@249 Int) ) (!  (=> (or (< x@@249 0) (>= x@@249 l@@249)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@249) x@@249) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@249) x@@249))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@250 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@250 (|l#$ValueArray| va@@250)))
 (and (and (<= 0 l@@250) (<= l@@250 $MAX_U64)) (forall ((x@@250 Int) ) (!  (=> (or (< x@@250 0) (>= x@@250 l@@250)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@250) x@@250) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@250) x@@250))
))))))) (forall (($$0@@76 Int) ) (!  (=> (and (>= $$0@@76 0) (< $$0@@76 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@76)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@76)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@76)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@76))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@251 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@251 (|l#$ValueArray| va@@251)))
 (and (and (<= 0 l@@251) (<= l@@251 $MAX_U64)) (forall ((x@@251 Int) ) (!  (=> (or (< x@@251 0) (>= x@@251 l@@251)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@251) x@@251) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@251) x@@251))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@252 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@252 (|l#$ValueArray| va@@252)))
 (and (and (<= 0 l@@252) (<= l@@252 $MAX_U64)) (forall ((x@@252 Int) ) (!  (=> (or (< x@@252 0) (>= x@@252 l@@252)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@252) x@@252) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@252) x@@252))
))))))) (forall (($$0@@77 Int) ) (!  (=> (and (>= $$0@@77 0) (< $$0@@77 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@77)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@77)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@77)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@77))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@28) 1) $inv_addr@@33))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@21 T@$Value) )  (=> ((_ is $Type) coin_type@@21) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@21)) 1) (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@22 T@$Value) )  (=> ((_ is $Type) coin_type@@22) (|b#$Boolean| ($Boolean (forall ((addr3@@10 T@$Value) )  (=> ((_ is $Address) addr3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@22)) 1) (|a#$Address| addr3@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@23 T@$Value) )  (=> ((_ is $Type) coin_type@@23) (|b#$Boolean| ($Boolean (forall ((addr1@@9 T@$Value) )  (=> ((_ is $Address) addr1@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@23)) 1) (|a#$Address| addr1@@9)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@9)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@24 T@$Value) )  (=> ((_ is $Type) coin_type@@24) (|b#$Boolean| ($Boolean (forall ((addr1@@10 T@$Value) )  (=> ((_ is $Address) addr1@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@24)) 1) (|a#$Address| addr1@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@10)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 256854) 256119))) inline$$Diem_create_preburn_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@12  (=> (and ((_ is $Address) tc_account) (= (ControlFlow 0 255544) 256854)) anon0$1_correct@@12)))
(let ((PreconditionGeneratedEntry_correct@@9  (=> (= (ControlFlow 0 433763) 255544) anon0_correct@@12)))
PreconditionGeneratedEntry_correct@@9))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin@@2 () T@$Value)
(declare-fun check () T@$Value)
(declare-fun $abort_flag@3@@9 () Bool)
(declare-fun $abort_code@6@@7 () Int)
(declare-fun inline$$Diem_deposit_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $tv0@@20 () T@$TypeValue)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@2| () T@$Value)
(declare-fun $abort_flag@2@@11 () Bool)
(declare-fun $abort_code@4@@10 () Int)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@3| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@3 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@5 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@5 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@5| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@5 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@5 () Int)
(declare-fun inline$$BorrowField$2$p@2@@5 () T@$Path)
(declare-fun inline$$Diem_deposit_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@8 () Int)
(declare-fun $abort_code@1@@12 () Int)
(declare-fun $abort_flag@0@@12 () Bool)
(declare-fun $abort_code@2@@10 () Int)
(declare-fun $abort_flag@1@@12 () Bool)
(declare-fun inline$$AddU64$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@5 () T@$Value)
(declare-fun inline$$Diem_Diem_unpack$0$value@1@@3 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@5 () Int)
(declare-fun inline$$BorrowField$1$p@2@@5 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@5 () T@$Value)
(declare-fun $abort_code@3@@11 () Int)
(declare-fun call3formal@$ret0@0@@33 () T@$Value)
(declare-fun inline$$Diem_deposit_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@5 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@5 () T@$Value)
(declare-fun inline$$Diem_deposit_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@5 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@5 () T@$Value)
(declare-fun $abort_code@0@@0 () Int)
(declare-fun inline$$BorrowField$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@5 () Int)
(declare-fun inline$$BorrowField$0$p@2@@5 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 438675) (let ((anon0$2_correct@@13  (and (=> (= (ControlFlow 0 259317) (- 0 440952)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@3@@9)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@3@@9) (and (=> (= (ControlFlow 0 259317) (- 0 440989)) (=> $abort_flag@3@@9 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (=> (=> $abort_flag@3@@9 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (and (=> (= (ControlFlow 0 259317) (- 0 441026)) (=> $abort_flag@3@@9 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@6@@7 (|i#$Integer| ($Integer 8)))))) (=> (=> $abort_flag@3@@9 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@6@@7 (|i#$Integer| ($Integer 8))))) (and (=> (= (ControlFlow 0 259317) (- 0 441074)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_deposit_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_deposit_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441110)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441159)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@212 T@$Value) )  (=> ((_ is $Address) addr@@212) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@212))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@212)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@213 T@$Value) )  (=> ((_ is $Address) addr@@213) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@213))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@213))))))))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441239)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@214 T@$Value) )  (=> ((_ is $Address) addr@@214) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@214)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@214))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@215 T@$Value) )  (=> ((_ is $Address) addr@@215) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@215)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@215)))))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441307)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441356)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@216 T@$Value) )  (=> ((_ is $Address) addr@@216) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@216))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@216)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@217 T@$Value) )  (=> ((_ is $Address) addr@@217) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@217))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@217))))))))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441436)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@218 T@$Value) )  (=> ((_ is $Address) addr@@218) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@218)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@218))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@219 T@$Value) )  (=> ((_ is $Address) addr@@219) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@219)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@219)))))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441504)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441553)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441602)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@220 T@$Value) )  (=> ((_ is $Address) addr@@220) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@220))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@220)))))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@221 T@$Value) )  (=> ((_ is $Address) addr@@221) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@221))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@221))))))))))))))) (and (=> (= (ControlFlow 0 259317) (- 0 441682)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@222 T@$Value) )  (=> ((_ is $Address) addr@@222) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@222)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@222))))))))))))) (=> (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean (forall ((addr@@223 T@$Value) )  (=> ((_ is $Address) addr@@223) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@223)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| addr@@223)))))))))))) (=> (= (ControlFlow 0 259317) (- 0 441750)) (=> (not $abort_flag@3@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@20) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_deposit_$def_verify$0$anon24_correct  (=> (and (and (= inline$$Diem_deposit_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@2|) (= $abort_flag@3@@9 $abort_flag@2@@11)) (and (= $abort_code@6@@7 $abort_code@4@@10) (= (ControlFlow 0 259217) 259317))) anon0$2_correct@@13)))
(let ((inline$$Diem_deposit_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 259215) 259217)) inline$$Diem_deposit_$def_verify$0$anon24_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 259225) 259217) inline$$Diem_deposit_$def_verify$0$anon24_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@3  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) ($Local 5))) (= |inline$$WritebackToValue$0$vdst'@2@@2| coin@@2)) (and (=> (= (ControlFlow 0 259173) 259225) inline$$Diem_deposit_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 259173) 259215) inline$$Diem_deposit_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@3  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) ($Local 5)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@3| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|) 0 coin@@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@5|))) (= |inline$$WritebackToValue$0$vdst'@2@@2| |inline$$WritebackToValue$0$vdst'@1@@3|)) (and (=> (= (ControlFlow 0 259199) 259225) inline$$Diem_deposit_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 259199) 259215) inline$$Diem_deposit_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@5  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5))) (= |inline$$WritebackToReference$0$dst'@2@@5| inline$$BorrowLoc$0$dst@1@@3)) (and (=> (= (ControlFlow 0 259018) 259199) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 259018) 259173) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@5  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@5 inline$$WritebackToReference$0$srcPath@1@@5)) (and (= |inline$$WritebackToReference$0$dst'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$WritebackToReference$0$dstPath@1@@5 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@5 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@5) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@5|)))) (= |inline$$WritebackToReference$0$dst'@2@@5| |inline$$WritebackToReference$0$dst'@1@@5|))) (and (=> (= (ControlFlow 0 259074) 259199) inline$$WritebackToValue$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 259074) 259173) inline$$WritebackToValue$0$anon3_Else_correct@@3)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@5  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@5 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@5|)) (= inline$$WritebackToReference$0$dstPath@1@@5 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) (and (=> (= (ControlFlow 0 258982) 259074) inline$$WritebackToReference$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 258982) 259018) inline$$WritebackToReference$0$anon3_Else_correct@@5)))))
(let ((inline$$WriteRef$0$anon0_correct@@5  (=> (and (= |inline$$WriteRef$0$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@5) (|p#$Mutation| inline$$BorrowField$2$dst@1@@5) inline$$AddU64$0$dst@2@@0)) (= (ControlFlow 0 258839) 258982)) inline$$WritebackToReference$0$anon0_correct@@5)))
(let ((inline$$BorrowField$2$anon0_correct@@5  (=> (= inline$$BorrowField$2$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$2$size@1@@5 (|size#$Path| inline$$BorrowField$2$p@1@@5)) (= inline$$BorrowField$2$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@5) inline$$BorrowField$2$size@1@@5 $Diem_Diem_value) (+ inline$$BorrowField$2$size@1@@5 1)))) (and (= inline$$BorrowField$2$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$2$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $Diem_Diem_value))) (= (ControlFlow 0 258780) 258839))) inline$$WriteRef$0$anon0_correct@@5))))
(let ((inline$$Diem_deposit_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@11) (= (ControlFlow 0 258786) 258780)) inline$$BorrowField$2$anon0_correct@@5)))
(let ((inline$$Diem_deposit_$def_verify$0$Abort_correct  (=> (= inline$$Diem_deposit_$def_verify$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_deposit_$def_verify$0$$ret0@2 inline$$Diem_deposit_$def_verify$0$$ret0@1) (= $abort_flag@3@@9 true)) (and (= $abort_code@6@@7 $abort_code@5@@8) (= (ControlFlow 0 258251) 259317))) anon0$2_correct@@13))))
(let ((inline$$Diem_deposit_$def_verify$0$anon9_correct  (=> (and (= $abort_code@5@@8 $abort_code@1@@12) (= (ControlFlow 0 259277) 258251)) inline$$Diem_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 259275) 259277)) inline$$Diem_deposit_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 259285) 259277) inline$$Diem_deposit_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon28_Then_correct  (=> $abort_flag@0@@12 (and (=> (= (ControlFlow 0 259269) 259285) inline$$Diem_deposit_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 259269) 259275) inline$$Diem_deposit_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_deposit_$def_verify$0$anon13_correct  (=> (and (= $abort_code@5@@8 $abort_code@2@@10) (= (ControlFlow 0 259257) 258251)) inline$$Diem_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 259255) 259257)) inline$$Diem_deposit_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 259265) 259257) inline$$Diem_deposit_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon30_Then_correct  (=> $abort_flag@1@@12 (and (=> (= (ControlFlow 0 259249) 259265) inline$$Diem_deposit_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 259249) 259255) inline$$Diem_deposit_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$Diem_deposit_$def_verify$0$anon21_correct  (=> (and (= $abort_code@5@@8 $abort_code@4@@10) (= (ControlFlow 0 259237) 258251)) inline$$Diem_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon35_Else_correct  (=> (and (not true) (= (ControlFlow 0 259235) 259237)) inline$$Diem_deposit_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon35_Then_correct  (=> (= (ControlFlow 0 259245) 259237) inline$$Diem_deposit_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon34_Then_correct  (=> $abort_flag@2@@11 (and (=> (= (ControlFlow 0 259229) 259245) inline$$Diem_deposit_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 259229) 259235) inline$$Diem_deposit_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@0  (=> (= $abort_code@4@@10 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@2@@11 true) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@0@@0)) (and (=> (= (ControlFlow 0 258650) 259229) inline$$Diem_deposit_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 258650) 258786) inline$$Diem_deposit_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@0  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1@@5) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3)) $MAX_U64) (= (ControlFlow 0 258648) 258650)) inline$$AddU64$0$anon3_Then$1_correct@@0)))
(let ((inline$$AddU64$0$anon3_Else_correct@@0  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1@@5) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3))) (=> (and (and (= inline$$AddU64$0$dst@1@@0 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1@@5) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3)))) (= $abort_code@4@@10 $abort_code@2@@10)) (and (= $abort_flag@2@@11 $abort_flag@1@@12) (= inline$$AddU64$0$dst@2@@0 inline$$AddU64$0$dst@1@@0))) (and (=> (= (ControlFlow 0 258592) 259229) inline$$Diem_deposit_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 258592) 258786) inline$$Diem_deposit_$def_verify$0$anon34_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 258562) (- 0 440489)) true) (and (=> (= (ControlFlow 0 258562) 258648) inline$$AddU64$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 258562) 258592) inline$$AddU64$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$1$anon0_correct@@5  (=> (and (= inline$$ReadRef$1$v@1@@5 (|v#$Mutation| inline$$BorrowField$1$dst@1@@5)) (= (ControlFlow 0 258455) 258562)) inline$$AddU64$0$Entry_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@5  (=> (= inline$$BorrowField$1$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$1$size@1@@5 (|size#$Path| inline$$BorrowField$1$p@1@@5)) (= inline$$BorrowField$1$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@5) inline$$BorrowField$1$size@1@@5 $Diem_Diem_value) (+ inline$$BorrowField$1$size@1@@5 1)))) (and (= inline$$BorrowField$1$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$1$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $Diem_Diem_value))) (= (ControlFlow 0 258417) 258455))) inline$$ReadRef$1$anon0_correct@@5))))
(let ((inline$$Diem_deposit_$def_verify$0$anon32_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@5) (= (ControlFlow 0 258469) 258417)) inline$$BorrowField$1$anon0_correct@@5)))
(let ((inline$$Diem_deposit_$def_verify$0$anon18_correct  (=> (and (= $abort_code@5@@8 $abort_code@3@@11) (= (ControlFlow 0 258245) 258251)) inline$$Diem_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 258243) 258245)) inline$$Diem_deposit_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 258259) 258245) inline$$Diem_deposit_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon32_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@5)) (= $abort_code@3@@11 (|i#$Integer| call3formal@$ret0@0@@33))) (and (=> (= (ControlFlow 0 258237) 258259) inline$$Diem_deposit_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 258237) 258243) inline$$Diem_deposit_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Diem_deposit_$def_verify$0$anon30_Else_correct  (=> (not $abort_flag@1@@12) (and (=> (= (ControlFlow 0 258225) 258469) inline$$Diem_deposit_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 258225) 258237) inline$$Diem_deposit_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_deposit_$def_verify$0$anon28_Else$1_correct  (=> (and (and (and (= inline$$Diem_deposit_$def_verify$0$$t12@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@12)) (and (=> $abort_flag@1@@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@33 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@33) (>= (|i#$Integer| call3formal@$ret0@0@@33) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@33) $MAX_U64))) (and (=> (= (ControlFlow 0 258219) 259249) inline$$Diem_deposit_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 258219) 258225) inline$$Diem_deposit_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@5  (=> (and (= inline$$Ge$0$dst@1@@5 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2@@5) (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3)))) (= (ControlFlow 0 258207) 258219)) inline$$Diem_deposit_$def_verify$0$anon28_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 258193) (- 0 440266)) true) (=> (= (ControlFlow 0 258193) 258207) inline$$Ge$0$anon0_correct@@5))))
(let ((inline$$Diem_deposit_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@0@@12) (= (ControlFlow 0 258213) 258193)) inline$$Ge$0$Entry_correct@@5)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@0@@12 true) (=> (and (= $abort_code@1@@12 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@5 inline$$Sub$0$dst@0@@5)) (and (=> (= (ControlFlow 0 258137) 259269) inline$$Diem_deposit_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 258137) 258213) inline$$Diem_deposit_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@5  (=> (and (< (|i#$Integer| inline$$Diem_deposit_$def_verify$0$$t8@1) (|i#$Integer| inline$$ReadRef$0$v@1@@5)) (= (ControlFlow 0 258135) 258137)) inline$$Sub$0$anon3_Then$1_correct@@5)))
(let ((inline$$Sub$0$anon3_Else_correct@@5  (=> (<= (|i#$Integer| inline$$ReadRef$0$v@1@@5) (|i#$Integer| inline$$Diem_deposit_$def_verify$0$$t8@1)) (=> (and (and (= inline$$Sub$0$dst@1@@5 ($Integer (- (|i#$Integer| inline$$Diem_deposit_$def_verify$0$$t8@1) (|i#$Integer| inline$$ReadRef$0$v@1@@5)))) (= $abort_flag@0@@12 false)) (and (= $abort_code@1@@12 $abort_code@0@@0) (= inline$$Sub$0$dst@2@@5 inline$$Sub$0$dst@1@@5))) (and (=> (= (ControlFlow 0 258083) 259269) inline$$Diem_deposit_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 258083) 258213) inline$$Diem_deposit_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@5  (and (=> (= (ControlFlow 0 258057) (- 0 440178)) true) (and (=> (= (ControlFlow 0 258057) 258135) inline$$Sub$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 258057) 258083) inline$$Sub$0$anon3_Else_correct@@5)))))
(let ((inline$$ReadRef$0$anon0_correct@@5  (=> (and (= inline$$ReadRef$0$v@1@@5 (|v#$Mutation| inline$$BorrowField$0$dst@1@@5)) (= (ControlFlow 0 257958) 258057)) inline$$Sub$0$Entry_correct@@5)))
(let ((inline$$BorrowField$0$anon0_correct@@5  (=> (= inline$$BorrowField$0$p@1@@5 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@3)) (=> (and (and (= inline$$BorrowField$0$size@1@@5 (|size#$Path| inline$$BorrowField$0$p@1@@5)) (= inline$$BorrowField$0$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@5) inline$$BorrowField$0$size@1@@5 $Diem_Diem_value) (+ inline$$BorrowField$0$size@1@@5 1)))) (and (= inline$$BorrowField$0$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@3) inline$$BorrowField$0$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@3))) $Diem_Diem_value))) (= (ControlFlow 0 257920) 257958))) inline$$ReadRef$0$anon0_correct@@5))))
(let ((inline$$Diem_deposit_$def_verify$0$anon6_correct  (=> (and (= inline$$Diem_deposit_$def_verify$0$$t8@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 257972) 257920)) inline$$BorrowField$0$anon0_correct@@5)))
(let ((inline$$Diem_deposit_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 257762) 257972)) inline$$Diem_deposit_$def_verify$0$anon6_correct)))
(let ((inline$$Diem_deposit_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 259293) 257972) inline$$Diem_deposit_$def_verify$0$anon6_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct@@3  (=> (and ((_ is $Vector) check) (= inline$$Diem_Diem_unpack$0$value@1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@3) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@3) $MAX_U64)) (and (=> (= (ControlFlow 0 257748) 259293) inline$$Diem_deposit_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 257748) 257762) inline$$Diem_deposit_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct@@3  (=> (and (= inline$$BorrowLoc$0$dst@1@@3 ($Mutation ($Local 5) $EmptyPath coin@@2)) (= (ControlFlow 0 257683) 257748)) inline$$Diem_Diem_unpack$0$anon0_correct@@3)))
(let ((inline$$Diem_deposit_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 257565) 257683)) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$Diem_deposit_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 259301) 257683) inline$$BorrowLoc$0$anon0_correct@@3)))
(let ((inline$$Diem_deposit_$def_verify$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 257557) 259301) inline$$Diem_deposit_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 257557) 257565) inline$$Diem_deposit_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_deposit_$def_verify$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 259309) 259301) inline$$Diem_deposit_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 259309) 257565) inline$$Diem_deposit_$def_verify$0$anon26_Else_correct))))
(let ((inline$$Diem_deposit_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 257551) 259309) inline$$Diem_deposit_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 257551) 257557) inline$$Diem_deposit_$def_verify$0$anon25_Else_correct)))))
(let ((anon0$1_correct@@13  (=> (and (forall (($inv_addr@@34 Int) ($inv_tv0@@29 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34)) (let ((va@@253 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))))
(let ((l@@253 (|l#$ValueArray| va@@253)))
 (and (and (<= 0 l@@253) (<= l@@253 $MAX_U64)) (forall ((x@@253 Int) ) (!  (=> (or (< x@@253 0) (>= x@@253 l@@253)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@253) x@@253) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@253) x@@253))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@29) 1) $inv_addr@@34))
)) (= (ControlFlow 0 259315) 257551)) inline$$Diem_deposit_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@13  (=> (and (and (and (and ((_ is $Vector) coin@@2) (let ((va@@254 (|v#$Vector| coin@@2)))
(let ((l@@254 (|l#$ValueArray| va@@254)))
 (and (and (<= 0 l@@254) (<= l@@254 $MAX_U64)) (forall ((x@@254 Int) ) (!  (=> (or (< x@@254 0) (>= x@@254 l@@254)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@254) x@@254) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@254) x@@254))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@2)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) check) (let ((va@@255 (|v#$Vector| check)))
(let ((l@@255 (|l#$ValueArray| va@@255)))
 (and (and (<= 0 l@@255) (<= l@@255 $MAX_U64)) (forall ((x@@255 Int) ) (!  (=> (or (< x@@255 0) (>= x@@255 l@@255)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@255) x@@255) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@255) x@@255))
)))))) (= (|l#$ValueArray| (|v#$Vector| check)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| check)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 257041) 259315)) anon0$1_correct@@13))))
(let ((PreconditionGeneratedEntry_correct@@10  (=> (= (ControlFlow 0 438675) 257041) anon0_correct@@13)))
PreconditionGeneratedEntry_correct@@10)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin@@3 () T@$Value)
(declare-fun $abort_flag@1@@13 () Bool)
(declare-fun $abort_code@4@@11 () Int)
(declare-fun $tv0@@21 () T@$TypeValue)
(declare-fun $abort_code@3@@12 () Int)
(declare-fun $abort_code@1@@13 () Int)
(declare-fun $abort_flag@0@@13 () Bool)
(declare-fun $abort_code@2@@11 () Int)
(declare-fun inline$$Diem_destroy_zero_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@34 () T@$Value)
(declare-fun inline$$Diem_destroy_zero_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Diem_Diem_unpack$0$value@1@@4 () T@$Value)
(declare-fun inline$$Diem_destroy_zero_$def_verify$0$$t7@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 441800) (let ((anon0$2_correct@@14  (and (=> (= (ControlFlow 0 260171) (- 0 442971)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0))))) $abort_flag@1@@13)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0))))) $abort_flag@1@@13) (and (=> (= (ControlFlow 0 260171) (- 0 442994)) (=> $abort_flag@1@@13 (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0))))))) (=> (=> $abort_flag@1@@13 (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0)))))) (and (=> (= (ControlFlow 0 260171) (- 0 443017)) (=> $abort_flag@1@@13 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 7)))))) (=> (=> $abort_flag@1@@13 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (|i#$Integer| ($Integer 0))))) (= $abort_code@4@@11 (|i#$Integer| ($Integer 7))))) (and (=> (= (ControlFlow 0 260171) (- 0 443051)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443100)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@224 T@$Value) )  (=> ((_ is $Address) addr@@224) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@224))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@224)))))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@225 T@$Value) )  (=> ((_ is $Address) addr@@225) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@225))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@225))))))))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443180)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@226 T@$Value) )  (=> ((_ is $Address) addr@@226) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@226)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@226))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@227 T@$Value) )  (=> ((_ is $Address) addr@@227) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@227)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@227)))))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443248)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443297)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@228 T@$Value) )  (=> ((_ is $Address) addr@@228) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@228))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@228)))))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@229 T@$Value) )  (=> ((_ is $Address) addr@@229) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@229))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@229))))))))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443377)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@230 T@$Value) )  (=> ((_ is $Address) addr@@230) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@230)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@230))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@231 T@$Value) )  (=> ((_ is $Address) addr@@231) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@231)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@231)))))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443445)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443494)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443543)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@232 T@$Value) )  (=> ((_ is $Address) addr@@232) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@232))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@232)))))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@233 T@$Value) )  (=> ((_ is $Address) addr@@233) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@233))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@233))))))))))))))) (and (=> (= (ControlFlow 0 260171) (- 0 443623)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@234 T@$Value) )  (=> ((_ is $Address) addr@@234) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@234)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@234))))))))))))) (=> (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean (forall ((addr@@235 T@$Value) )  (=> ((_ is $Address) addr@@235) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@235)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| addr@@235)))))))))))) (=> (= (ControlFlow 0 260171) (- 0 443691)) (=> (not $abort_flag@1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@21) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$Abort_correct  (=> (= $abort_flag@1@@13 true) (=> (and (= $abort_code@4@@11 $abort_code@3@@12) (= (ControlFlow 0 260115) 260171)) anon0$2_correct@@14))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon7_correct  (=> (and (= $abort_code@3@@12 $abort_code@1@@13) (= (ControlFlow 0 260141) 260115)) inline$$Diem_destroy_zero_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 260139) 260141)) inline$$Diem_destroy_zero_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 260149) 260141) inline$$Diem_destroy_zero_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@13 (and (=> (= (ControlFlow 0 260133) 260149) inline$$Diem_destroy_zero_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 260133) 260139) inline$$Diem_destroy_zero_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon12_correct  (=> (and (= $abort_code@3@@12 $abort_code@2@@11) (= (ControlFlow 0 260111) 260115)) inline$$Diem_destroy_zero_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 260109) 260111)) inline$$Diem_destroy_zero_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 260123) 260111) inline$$Diem_destroy_zero_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon17_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_destroy_zero_$def_verify$0$$t6@1)) (= $abort_code@2@@11 (|i#$Integer| call3formal@$ret0@0@@34))) (and (=> (= (ControlFlow 0 260103) 260123) inline$$Diem_destroy_zero_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 260103) 260109) inline$$Diem_destroy_zero_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon17_Then_correct  (=> (and (and (|b#$Boolean| inline$$Diem_destroy_zero_$def_verify$0$$t6@1) (= $abort_flag@1@@13 $abort_flag@0@@13)) (and (= $abort_code@4@@11 $abort_code@1@@13) (= (ControlFlow 0 260129) 260171))) anon0$2_correct@@14)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon15_Else_correct  (=> (not $abort_flag@0@@13) (and (=> (= (ControlFlow 0 260091) 260129) inline$$Diem_destroy_zero_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 260091) 260103) inline$$Diem_destroy_zero_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon4_correct  (=> (and (= inline$$Diem_destroy_zero_$def_verify$0$$t5@1 ($Integer 0)) (= inline$$Diem_destroy_zero_$def_verify$0$$t6@1 ($Boolean ($IsEqual_stratified inline$$Diem_Diem_unpack$0$value@1@@4 inline$$Diem_destroy_zero_$def_verify$0$$t5@1)))) (=> (and (and (and (= inline$$Diem_destroy_zero_$def_verify$0$$t7@1 ($Integer 8)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@13)) (and (=> $abort_flag@0@@13 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@34 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@34) (>= (|i#$Integer| call3formal@$ret0@0@@34) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@34) $MAX_U64))) (and (=> (= (ControlFlow 0 260085) 260133) inline$$Diem_destroy_zero_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 260085) 260091) inline$$Diem_destroy_zero_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 260067) 260085)) inline$$Diem_destroy_zero_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 260157) 260085) inline$$Diem_destroy_zero_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_Diem_unpack$0$anon0_correct@@4  (=> (and ((_ is $Vector) coin@@3) (= inline$$Diem_Diem_unpack$0$value@1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value))) (=> (and (and ((_ is $Integer) inline$$Diem_Diem_unpack$0$value@1@@4) (>= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@4) 0)) (<= (|i#$Integer| inline$$Diem_Diem_unpack$0$value@1@@4) $MAX_U64)) (and (=> (= (ControlFlow 0 260053) 260157) inline$$Diem_destroy_zero_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 260053) 260067) inline$$Diem_destroy_zero_$def_verify$0$anon14_Else_correct))))))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 259960) 260053)) inline$$Diem_Diem_unpack$0$anon0_correct@@4)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 260165) 260053) inline$$Diem_Diem_unpack$0$anon0_correct@@4)))
(let ((inline$$Diem_destroy_zero_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 259954) 260165) inline$$Diem_destroy_zero_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 259954) 259960) inline$$Diem_destroy_zero_$def_verify$0$anon13_Else_correct)))))
(let ((anon0_correct@@14  (=> (and (and (and (and (and ((_ is $Vector) coin@@3) (let ((va@@256 (|v#$Vector| coin@@3)))
(let ((l@@256 (|l#$ValueArray| va@@256)))
 (and (and (<= 0 l@@256) (<= l@@256 $MAX_U64)) (forall ((x@@256 Int) ) (!  (=> (or (< x@@256 0) (>= x@@256 l@@256)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@256) x@@256) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@256) x@@256))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@3)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 259702) 259954)) inline$$Diem_destroy_zero_$def_verify$0$anon0_correct)))
(let ((PreconditionGeneratedEntry_correct@@11  (=> (= (ControlFlow 0 441800) 259702) anon0_correct@@14)))
PreconditionGeneratedEntry_correct@@11))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@12 () Bool)
(declare-fun $tv0@@22 () T@$TypeValue)
(declare-fun inline$$Diem_fractional_part_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@14 () Bool)
(declare-fun $abort_flag@1@@14 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@10 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@4 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@4 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@4 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@9 () T@$Value)
(declare-fun $abort_code@1@@14 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 443741) (let ((anon0$2_correct@@15  (and (=> (= (ControlFlow 0 261060) (- 0 446366)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446415)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@236 T@$Value) )  (=> ((_ is $Address) addr@@236) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@236))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@236)))))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@237 T@$Value) )  (=> ((_ is $Address) addr@@237) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@237))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@237))))))))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446495)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@238 T@$Value) )  (=> ((_ is $Address) addr@@238) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@238)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@238))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@239 T@$Value) )  (=> ((_ is $Address) addr@@239) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@239)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@239)))))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446563)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446612)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@240 T@$Value) )  (=> ((_ is $Address) addr@@240) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@240))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@240)))))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@241 T@$Value) )  (=> ((_ is $Address) addr@@241) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@241))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@241))))))))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446692)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@242 T@$Value) )  (=> ((_ is $Address) addr@@242) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@242)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@242))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@243 T@$Value) )  (=> ((_ is $Address) addr@@243) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@243)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@243)))))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446760)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446809)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446858)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@244 T@$Value) )  (=> ((_ is $Address) addr@@244) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@244))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@244)))))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@245 T@$Value) )  (=> ((_ is $Address) addr@@245) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@245))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@245))))))))))))))) (and (=> (= (ControlFlow 0 261060) (- 0 446938)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@246 T@$Value) )  (=> ((_ is $Address) addr@@246) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@246)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@246))))))))))))) (=> (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean (forall ((addr@@247 T@$Value) )  (=> ((_ is $Address) addr@@247) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@247)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@247)))))))))))) (=> (= (ControlFlow 0 261060) (- 0 447006)) (=> (not $abort_flag@2@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_fractional_part_$def_verify$0$Abort_correct  (=> (= inline$$Diem_fractional_part_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@12 true) (= (ControlFlow 0 261020) 261060)) anon0$2_correct@@15))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 261042) 261020)) inline$$Diem_fractional_part_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 261052) 261020) inline$$Diem_fractional_part_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@14 (and (=> (= (ControlFlow 0 261036) 261052) inline$$Diem_fractional_part_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 261036) 261042) inline$$Diem_fractional_part_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 261012) 261020)) inline$$Diem_fractional_part_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 261028) 261020) inline$$Diem_fractional_part_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@14 (and (=> (= (ControlFlow 0 261006) 261028) inline$$Diem_fractional_part_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 261006) 261012) inline$$Diem_fractional_part_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@0@@14 (= (ControlFlow 0 261032) 261020)) inline$$Diem_fractional_part_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@2@@12 $abort_flag@1@@14) (= (ControlFlow 0 260994) 261060)) anon0$2_correct@@15)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 260992) 260994)) inline$$Diem_fractional_part_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 261002) 260994) inline$$Diem_fractional_part_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@10  (=> (= inline$$GetFieldFromValue$0$dst@1@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $Diem_CurrencyInfo_fractional_part)) (and (=> (= (ControlFlow 0 260976) 261002) inline$$Diem_fractional_part_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 260976) 260992) inline$$Diem_fractional_part_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@14) (= (ControlFlow 0 260982) 260976)) inline$$GetFieldFromValue$0$anon0_correct@@10)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@4  (=> (= $abort_flag@1@@14 true) (and (=> (= (ControlFlow 0 260922) 261006) inline$$Diem_fractional_part_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 260922) 260982) inline$$Diem_fractional_part_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@4 inline$$GetGlobal$0$a@1@@4)) (= (ControlFlow 0 260920) 260922)) inline$$GetGlobal$0$anon3_Then$1_correct@@4)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@4 inline$$GetGlobal$0$a@1@@4) (=> (and (= inline$$GetGlobal$0$dst@1@@4 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@4 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@9))) (= $abort_flag@1@@14 $abort_flag@0@@14)) (and (=> (= (ControlFlow 0 260868) 261006) inline$$Diem_fractional_part_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 260868) 260982) inline$$Diem_fractional_part_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@4  (=> (= inline$$GetGlobal$0$a@1@@4 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@9)) (and (=> (= (ControlFlow 0 260850) 260920) inline$$GetGlobal$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 260850) 260868) inline$$GetGlobal$0$anon3_Else_correct@@4)))))
(let ((inline$$GetGlobal$0$Entry_correct@@4  (=> (= inline$$GetGlobal$0$ta@0@@4 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1)) (and (=> (= (ControlFlow 0 260844) (- 0 446217)) true) (=> (= (ControlFlow 0 260844) 260850) inline$$GetGlobal$0$anon0_correct@@4)))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@14) (= (ControlFlow 0 260928) 260844)) inline$$GetGlobal$0$Entry_correct@@4)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@9  (=> (not true) (and (=> (= (ControlFlow 0 260711) 261032) inline$$Diem_fractional_part_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 260711) 260928) inline$$Diem_fractional_part_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@9  (and (=> (= (ControlFlow 0 260721) 261032) inline$$Diem_fractional_part_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 260721) 260928) inline$$Diem_fractional_part_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@9  (=> (and (not $abort_flag@0@@14) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@9 ($Address 173345816))) (and (=> (= (ControlFlow 0 260705) 260721) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 260705) 260711) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@9)))))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@14) (= (ControlFlow 0 260735) 260705)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@9)))
(let ((inline$$Diem_fractional_part_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@14) (=> $abort_flag@0@@14 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@14 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@14 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@248 T@$Value) )  (=> ((_ is $Address) addr@@248) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@248))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@248))))))))))))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@249 T@$Value) )  (=> ((_ is $Address) addr@@249) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@249)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@249)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@250 T@$Value) )  (=> ((_ is $Address) addr@@250) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@250))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@250)))))))))))))))) (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@251 T@$Value) )  (=> ((_ is $Address) addr@@251) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@251)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@251)))))))))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@252 T@$Value) )  (=> ((_ is $Address) addr@@252) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@252))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@252)))))))))))))))) (and (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean (forall ((addr@@253 T@$Value) )  (=> ((_ is $Address) addr@@253) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@253)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| addr@@253)))))))))))) (=> (not $abort_flag@0@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@22) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 260600) 261036) inline$$Diem_fractional_part_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 260600) 260735) inline$$Diem_fractional_part_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@14  (=> (forall (($inv_addr@@35 Int) ($inv_tv0@@30 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35)) (let ((va@@257 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))))
(let ((l@@257 (|l#$ValueArray| va@@257)))
 (and (and (<= 0 l@@257) (<= l@@257 $MAX_U64)) (forall ((x@@257 Int) ) (!  (=> (or (< x@@257 0) (>= x@@257 l@@257)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@257) x@@257) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@257) x@@257))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@258 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@258 (|l#$ValueArray| va@@258)))
 (and (and (<= 0 l@@258) (<= l@@258 $MAX_U64)) (forall ((x@@258 Int) ) (!  (=> (or (< x@@258 0) (>= x@@258 l@@258)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@258) x@@258) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@258) x@@258))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code)) (let ((va@@259 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@259 (|l#$ValueArray| va@@259)))
 (and (and (<= 0 l@@259) (<= l@@259 $MAX_U64)) (forall ((x@@259 Int) ) (!  (=> (or (< x@@259 0) (>= x@@259 l@@259)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@259) x@@259) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@259) x@@259))
))))))) (forall (($$0@@78 Int) ) (!  (=> (and (>= $$0@@78 0) (< $$0@@78 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))) $$0@@78)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))) $$0@@78)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))) $$0@@78)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_currency_code))) $$0@@78))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events)) (let ((va@@260 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@260 (|l#$ValueArray| va@@260)))
 (and (and (<= 0 l@@260) (<= l@@260 $MAX_U64)) (forall ((x@@260 Int) ) (!  (=> (or (< x@@260 0) (>= x@@260 l@@260)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@260) x@@260) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@260) x@@260))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@261 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@261 (|l#$ValueArray| va@@261)))
 (and (and (<= 0 l@@261) (<= l@@261 $MAX_U64)) (forall ((x@@261 Int) ) (!  (=> (or (< x@@261 0) (>= x@@261 l@@261)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@261) x@@261) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@261) x@@261))
))))))) (forall (($$0@@79 Int) ) (!  (=> (and (>= $$0@@79 0) (< $$0@@79 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@79)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@79)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@79)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@79))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events)) (let ((va@@262 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@262 (|l#$ValueArray| va@@262)))
 (and (and (<= 0 l@@262) (<= l@@262 $MAX_U64)) (forall ((x@@262 Int) ) (!  (=> (or (< x@@262 0) (>= x@@262 l@@262)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@262) x@@262) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@262) x@@262))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@263 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@263 (|l#$ValueArray| va@@263)))
 (and (and (<= 0 l@@263) (<= l@@263 $MAX_U64)) (forall ((x@@263 Int) ) (!  (=> (or (< x@@263 0) (>= x@@263 l@@263)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@263) x@@263) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@263) x@@263))
))))))) (forall (($$0@@80 Int) ) (!  (=> (and (>= $$0@@80 0) (< $$0@@80 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@80)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@80)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@80)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@80))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@264 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@264 (|l#$ValueArray| va@@264)))
 (and (and (<= 0 l@@264) (<= l@@264 $MAX_U64)) (forall ((x@@264 Int) ) (!  (=> (or (< x@@264 0) (>= x@@264 l@@264)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@264) x@@264) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@264) x@@264))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@265 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@265 (|l#$ValueArray| va@@265)))
 (and (and (<= 0 l@@265) (<= l@@265 $MAX_U64)) (forall ((x@@265 Int) ) (!  (=> (or (< x@@265 0) (>= x@@265 l@@265)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@265) x@@265) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@265) x@@265))
))))))) (forall (($$0@@81 Int) ) (!  (=> (and (>= $$0@@81 0) (< $$0@@81 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@81)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@81)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@81)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@81))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@266 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@266 (|l#$ValueArray| va@@266)))
 (and (and (<= 0 l@@266) (<= l@@266 $MAX_U64)) (forall ((x@@266 Int) ) (!  (=> (or (< x@@266 0) (>= x@@266 l@@266)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@266) x@@266) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@266) x@@266))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@267 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@267 (|l#$ValueArray| va@@267)))
 (and (and (<= 0 l@@267) (<= l@@267 $MAX_U64)) (forall ((x@@267 Int) ) (!  (=> (or (< x@@267 0) (>= x@@267 l@@267)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@267) x@@267) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@267) x@@267))
))))))) (forall (($$0@@82 Int) ) (!  (=> (and (>= $$0@@82 0) (< $$0@@82 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@82)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@82)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@82)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@82))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@268 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@268 (|l#$ValueArray| va@@268)))
 (and (and (<= 0 l@@268) (<= l@@268 $MAX_U64)) (forall ((x@@268 Int) ) (!  (=> (or (< x@@268 0) (>= x@@268 l@@268)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@268) x@@268) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@268) x@@268))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@269 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@269 (|l#$ValueArray| va@@269)))
 (and (and (<= 0 l@@269) (<= l@@269 $MAX_U64)) (forall ((x@@269 Int) ) (!  (=> (or (< x@@269 0) (>= x@@269 l@@269)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@269) x@@269) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@269) x@@269))
))))))) (forall (($$0@@83 Int) ) (!  (=> (and (>= $$0@@83 0) (< $$0@@83 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@83)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@83)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@83)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@83))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@30) 1) $inv_addr@@35))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@25 T@$Value) )  (=> ((_ is $Type) coin_type@@25) (|b#$Boolean| ($Boolean (forall ((addr3@@11 T@$Value) )  (=> ((_ is $Address) addr3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@25)) 1) (|a#$Address| addr3@@11)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@25)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@25)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 261058) 260600)) inline$$Diem_fractional_part_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@15  (=> (= (ControlFlow 0 443741) 261058) anon0$1_correct@@14)))
anon0_correct@@15))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@3@@10 () Bool)
(declare-fun $tv0@@23 () T@$TypeValue)
(declare-fun inline$$Diem_is_SCS_currency_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@1@@15 () Bool)
(declare-fun $abort_flag@0@@15 () Bool)
(declare-fun $abort_flag@2@@13 () Bool)
(declare-fun inline$$Not$0$dst@1@@6 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@11 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@5 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@5 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@5 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$ret0@2@@1 () T@$Value)
(declare-fun inline$$Diem_is_SCS_currency_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$Diem_is_currency_$def$0$$t1@1@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@10 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 447056) (let ((anon0$2_correct@@16  (and (=> (= (ControlFlow 0 262512) (- 0 448473)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448522)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@254 T@$Value) )  (=> ((_ is $Address) addr@@254) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@254))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@254)))))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@255 T@$Value) )  (=> ((_ is $Address) addr@@255) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@255))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@255))))))))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448602)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@256 T@$Value) )  (=> ((_ is $Address) addr@@256) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@256)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@256))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@257 T@$Value) )  (=> ((_ is $Address) addr@@257) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@257)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@257)))))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448670)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448719)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@258 T@$Value) )  (=> ((_ is $Address) addr@@258) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@258))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@258)))))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@259 T@$Value) )  (=> ((_ is $Address) addr@@259) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@259))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@259))))))))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448799)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@260 T@$Value) )  (=> ((_ is $Address) addr@@260) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@260)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@260))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@261 T@$Value) )  (=> ((_ is $Address) addr@@261) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@261)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@261)))))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448867)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448916)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 448965)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@262 T@$Value) )  (=> ((_ is $Address) addr@@262) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@262))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@262)))))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@263 T@$Value) )  (=> ((_ is $Address) addr@@263) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@263))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@263))))))))))))))) (and (=> (= (ControlFlow 0 262512) (- 0 449045)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@264 T@$Value) )  (=> ((_ is $Address) addr@@264) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@264)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@264))))))))))))) (=> (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean (forall ((addr@@265 T@$Value) )  (=> ((_ is $Address) addr@@265) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@265)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| addr@@265)))))))))))) (=> (= (ControlFlow 0 262512) (- 0 449113)) (=> (not $abort_flag@3@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$Abort_correct  (=> (= inline$$Diem_is_SCS_currency_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@3@@10 true) (= (ControlFlow 0 262488) 262512)) anon0$2_correct@@16))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 262480) 262488)) inline$$Diem_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 262496) 262488) inline$$Diem_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Then_correct  (=> $abort_flag@1@@15 (and (=> (= (ControlFlow 0 262474) 262496) inline$$Diem_is_SCS_currency_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 262474) 262480) inline$$Diem_is_SCS_currency_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Then_correct  (=> (and $abort_flag@0@@15 (= (ControlFlow 0 262500) 262488)) inline$$Diem_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon17_Then_correct  (=> (and $abort_flag@0@@15 (= (ControlFlow 0 262504) 262488)) inline$$Diem_is_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon16_correct  (=> (and (= $abort_flag@3@@10 $abort_flag@2@@13) (= (ControlFlow 0 262004) 262512)) anon0$2_correct@@16)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 262002) 262004)) inline$$Diem_is_SCS_currency_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 262012) 262004) inline$$Diem_is_SCS_currency_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon12_correct  (=> (= $abort_flag@2@@13 $abort_flag@1@@15) (and (=> (= (ControlFlow 0 262462) 262012) inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 262462) 262002) inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 262460) 262462)) inline$$Diem_is_SCS_currency_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 262470) 262462) inline$$Diem_is_SCS_currency_$def_verify$0$anon12_correct)))
(let ((inline$$Not$0$anon0_correct@@6  (=> (= inline$$Not$0$dst@1@@6 ($Boolean  (not (|b#$Boolean| inline$$GetFieldFromValue$0$dst@1@@11)))) (and (=> (= (ControlFlow 0 262446) 262470) inline$$Diem_is_SCS_currency_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 262446) 262460) inline$$Diem_is_SCS_currency_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@6  (and (=> (= (ControlFlow 0 262436) (- 0 448384)) true) (=> (= (ControlFlow 0 262436) 262446) inline$$Not$0$anon0_correct@@6))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@11  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@0)) $Diem_CurrencyInfo_is_synthetic)) (= (ControlFlow 0 262396) 262436)) inline$$Not$0$Entry_correct@@6)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Else_correct  (=> (and (not $abort_flag@1@@15) (= (ControlFlow 0 262402) 262396)) inline$$GetFieldFromValue$0$anon0_correct@@11)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@1@@15 true) (and (=> (= (ControlFlow 0 262342) 262474) inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 262342) 262402) inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@5  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@5 inline$$GetGlobal$0$a@1@@5)) (= (ControlFlow 0 262340) 262342)) inline$$GetGlobal$0$anon3_Then$1_correct@@5)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@5  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@5 inline$$GetGlobal$0$a@1@@5) (=> (and (= inline$$GetGlobal$0$dst@1@@5 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@5 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@1))) (= $abort_flag@1@@15 $abort_flag@0@@15)) (and (=> (= (ControlFlow 0 262288) 262474) inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 262288) 262402) inline$$Diem_is_SCS_currency_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@5  (=> (= inline$$GetGlobal$0$a@1@@5 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@1)) (and (=> (= (ControlFlow 0 262270) 262340) inline$$GetGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 262270) 262288) inline$$GetGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$GetGlobal$0$Entry_correct@@5  (=> (= inline$$GetGlobal$0$ta@0@@5 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1)) (and (=> (= (ControlFlow 0 262264) (- 0 448292)) true) (=> (= (ControlFlow 0 262264) 262270) inline$$GetGlobal$0$anon0_correct@@5)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Else_correct  (=> (and (not $abort_flag@0@@15) (= (ControlFlow 0 262348) 262264)) inline$$GetGlobal$0$Entry_correct@@5)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 262131) 262500) inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 262131) 262348) inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 262141) 262500) inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 262141) 262348) inline$$Diem_is_SCS_currency_$def_verify$0$anon19_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct@@1  (=> (and (not $abort_flag@0@@15) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 262125) 262141) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 262125) 262131) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon3_Else_correct@@1)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon18_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2@@1) (= (ControlFlow 0 262155) 262125)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$1$anon0_correct@@1)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon14_correct  (=> (= $abort_flag@2@@13 $abort_flag@0@@15) (and (=> (= (ControlFlow 0 261992) 262012) inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 261992) 262002) inline$$Diem_is_SCS_currency_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 261990) 261992)) inline$$Diem_is_SCS_currency_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 262020) 261992) inline$$Diem_is_SCS_currency_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon18_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_currency_$def$0$$ret0@2@@1)) (= inline$$Diem_is_SCS_currency_$def_verify$0$$t5@1 ($Boolean false))) (and (=> (= (ControlFlow 0 261982) 262020) inline$$Diem_is_SCS_currency_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 261982) 261990) inline$$Diem_is_SCS_currency_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon17_Else_correct  (=> (not $abort_flag@0@@15) (and (=> (= (ControlFlow 0 261938) 262155) inline$$Diem_is_SCS_currency_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 261938) 261982) inline$$Diem_is_SCS_currency_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon4_correct@@1  (=> (and (= $abort_flag@0@@15 false) (= inline$$Diem_is_currency_$def$0$$ret0@2@@1 inline$$Diem_is_currency_$def$0$$t1@1@@1)) (and (=> (= (ControlFlow 0 261900) 262504) inline$$Diem_is_SCS_currency_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 261900) 261938) inline$$Diem_is_SCS_currency_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_is_currency_$def$0$anon6_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 261898) 261900)) inline$$Diem_is_currency_$def$0$anon4_correct@@1)))
(let ((inline$$Diem_is_currency_$def$0$anon6_Then_correct@@1  (=> (= (ControlFlow 0 261908) 261900) inline$$Diem_is_currency_$def$0$anon4_correct@@1)))
(let ((inline$$Diem_is_currency_$def$0$anon5_Else_correct@@1  (=> (and (not false) (= inline$$Diem_is_currency_$def$0$$t1@1@@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@23) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@10))))) (and (=> (= (ControlFlow 0 261892) 261908) inline$$Diem_is_currency_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 261892) 261898) inline$$Diem_is_currency_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$Diem_is_currency_$def$0$anon5_Then_correct@@1 true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@10  (=> (not true) (and (=> (= (ControlFlow 0 261838) 261916) inline$$Diem_is_currency_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 261838) 261892) inline$$Diem_is_currency_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@10  (and (=> (= (ControlFlow 0 261848) 261916) inline$$Diem_is_currency_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 261848) 261892) inline$$Diem_is_currency_$def$0$anon5_Else_correct@@1))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@10  (=> (and (not false) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@10 ($Address 173345816))) (and (=> (= (ControlFlow 0 261832) 261848) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 261832) 261838) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@10)))))
(let ((inline$$Diem_is_currency_$def$0$anon0_correct@@1  (=> (and (not false) (= (ControlFlow 0 261862) 261832)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@10)))
(let ((inline$$Diem_is_SCS_currency_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 261930) 261862)) inline$$Diem_is_currency_$def$0$anon0_correct@@1)))
(let ((anon0$1_correct@@15  (=> (forall (($inv_addr@@36 Int) ($inv_tv0@@31 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36)) (let ((va@@270 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))))
(let ((l@@270 (|l#$ValueArray| va@@270)))
 (and (and (<= 0 l@@270) (<= l@@270 $MAX_U64)) (forall ((x@@270 Int) ) (!  (=> (or (< x@@270 0) (>= x@@270 l@@270)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@270) x@@270) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@270) x@@270))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@271 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@271 (|l#$ValueArray| va@@271)))
 (and (and (<= 0 l@@271) (<= l@@271 $MAX_U64)) (forall ((x@@271 Int) ) (!  (=> (or (< x@@271 0) (>= x@@271 l@@271)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@271) x@@271) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@271) x@@271))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code)) (let ((va@@272 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@272 (|l#$ValueArray| va@@272)))
 (and (and (<= 0 l@@272) (<= l@@272 $MAX_U64)) (forall ((x@@272 Int) ) (!  (=> (or (< x@@272 0) (>= x@@272 l@@272)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@272) x@@272) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@272) x@@272))
))))))) (forall (($$0@@84 Int) ) (!  (=> (and (>= $$0@@84 0) (< $$0@@84 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))) $$0@@84)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))) $$0@@84)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))) $$0@@84)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_currency_code))) $$0@@84))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events)) (let ((va@@273 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@273 (|l#$ValueArray| va@@273)))
 (and (and (<= 0 l@@273) (<= l@@273 $MAX_U64)) (forall ((x@@273 Int) ) (!  (=> (or (< x@@273 0) (>= x@@273 l@@273)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@273) x@@273) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@273) x@@273))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@274 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@274 (|l#$ValueArray| va@@274)))
 (and (and (<= 0 l@@274) (<= l@@274 $MAX_U64)) (forall ((x@@274 Int) ) (!  (=> (or (< x@@274 0) (>= x@@274 l@@274)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@274) x@@274) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@274) x@@274))
))))))) (forall (($$0@@85 Int) ) (!  (=> (and (>= $$0@@85 0) (< $$0@@85 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@85)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@85)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@85)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@85))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events)) (let ((va@@275 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@275 (|l#$ValueArray| va@@275)))
 (and (and (<= 0 l@@275) (<= l@@275 $MAX_U64)) (forall ((x@@275 Int) ) (!  (=> (or (< x@@275 0) (>= x@@275 l@@275)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@275) x@@275) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@275) x@@275))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@276 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@276 (|l#$ValueArray| va@@276)))
 (and (and (<= 0 l@@276) (<= l@@276 $MAX_U64)) (forall ((x@@276 Int) ) (!  (=> (or (< x@@276 0) (>= x@@276 l@@276)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@276) x@@276) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@276) x@@276))
))))))) (forall (($$0@@86 Int) ) (!  (=> (and (>= $$0@@86 0) (< $$0@@86 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@86)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@86)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@86)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@86))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@277 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@277 (|l#$ValueArray| va@@277)))
 (and (and (<= 0 l@@277) (<= l@@277 $MAX_U64)) (forall ((x@@277 Int) ) (!  (=> (or (< x@@277 0) (>= x@@277 l@@277)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@277) x@@277) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@277) x@@277))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@278 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@278 (|l#$ValueArray| va@@278)))
 (and (and (<= 0 l@@278) (<= l@@278 $MAX_U64)) (forall ((x@@278 Int) ) (!  (=> (or (< x@@278 0) (>= x@@278 l@@278)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@278) x@@278) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@278) x@@278))
))))))) (forall (($$0@@87 Int) ) (!  (=> (and (>= $$0@@87 0) (< $$0@@87 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@87)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@87)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@87)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@87))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@279 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@279 (|l#$ValueArray| va@@279)))
 (and (and (<= 0 l@@279) (<= l@@279 $MAX_U64)) (forall ((x@@279 Int) ) (!  (=> (or (< x@@279 0) (>= x@@279 l@@279)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@279) x@@279) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@279) x@@279))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@280 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@280 (|l#$ValueArray| va@@280)))
 (and (and (<= 0 l@@280) (<= l@@280 $MAX_U64)) (forall ((x@@280 Int) ) (!  (=> (or (< x@@280 0) (>= x@@280 l@@280)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@280) x@@280) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@280) x@@280))
))))))) (forall (($$0@@88 Int) ) (!  (=> (and (>= $$0@@88 0) (< $$0@@88 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@88)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@88)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@88)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@88))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@281 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@281 (|l#$ValueArray| va@@281)))
 (and (and (<= 0 l@@281) (<= l@@281 $MAX_U64)) (forall ((x@@281 Int) ) (!  (=> (or (< x@@281 0) (>= x@@281 l@@281)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@281) x@@281) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@281) x@@281))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@282 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@282 (|l#$ValueArray| va@@282)))
 (and (and (<= 0 l@@282) (<= l@@282 $MAX_U64)) (forall ((x@@282 Int) ) (!  (=> (or (< x@@282 0) (>= x@@282 l@@282)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@282) x@@282) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@282) x@@282))
))))))) (forall (($$0@@89 Int) ) (!  (=> (and (>= $$0@@89 0) (< $$0@@89 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@89)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@89)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@89)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@89))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@31) 1) $inv_addr@@36))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@26 T@$Value) )  (=> ((_ is $Type) coin_type@@26) (|b#$Boolean| ($Boolean (forall ((addr3@@12 T@$Value) )  (=> ((_ is $Address) addr3@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@26)) 1) (|a#$Address| addr3@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 262510) 261930)) inline$$Diem_is_SCS_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@16  (=> (= (ControlFlow 0 447056) 262510) anon0$1_correct@@15)))
anon0_correct@@16)))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@0@@16 () Bool)
(declare-fun $tv0@@24 () T@$TypeValue)
(declare-fun inline$$Diem_is_currency_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@11 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 449164) (let ((anon0$2_correct@@17  (and (=> (= (ControlFlow 0 263138) (- 0 450143)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450192)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@266 T@$Value) )  (=> ((_ is $Address) addr@@266) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@266))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@266)))))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@267 T@$Value) )  (=> ((_ is $Address) addr@@267) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@267))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@267))))))))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450272)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@268 T@$Value) )  (=> ((_ is $Address) addr@@268) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@268)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@268))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@269 T@$Value) )  (=> ((_ is $Address) addr@@269) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@269)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@269)))))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450340)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450389)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@270 T@$Value) )  (=> ((_ is $Address) addr@@270) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@270))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@270)))))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@271 T@$Value) )  (=> ((_ is $Address) addr@@271) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@271))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@271))))))))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450469)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@272 T@$Value) )  (=> ((_ is $Address) addr@@272) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@272)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@272))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@273 T@$Value) )  (=> ((_ is $Address) addr@@273) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@273)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@273)))))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450537)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450586)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450635)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@274 T@$Value) )  (=> ((_ is $Address) addr@@274) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@274))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@274)))))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@275 T@$Value) )  (=> ((_ is $Address) addr@@275) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@275))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@275))))))))))))))) (and (=> (= (ControlFlow 0 263138) (- 0 450715)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@276 T@$Value) )  (=> ((_ is $Address) addr@@276) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@276)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@276))))))))))))) (=> (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean (forall ((addr@@277 T@$Value) )  (=> ((_ is $Address) addr@@277) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@277)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| addr@@277)))))))))))) (=> (= (ControlFlow 0 263138) (- 0 450783)) (=> (not $abort_flag@0@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_is_currency_$def_verify$0$anon4_correct  (=> (and (= $abort_flag@0@@16 false) (= (ControlFlow 0 263114) 263138)) anon0$2_correct@@17)))
(let ((inline$$Diem_is_currency_$def_verify$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 263112) 263114)) inline$$Diem_is_currency_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_is_currency_$def_verify$0$anon6_Then_correct  (=> (= (ControlFlow 0 263122) 263114) inline$$Diem_is_currency_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_is_currency_$def_verify$0$anon5_Else_correct  (=> (and (not false) (= inline$$Diem_is_currency_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@24) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@11))))) (and (=> (= (ControlFlow 0 263106) 263122) inline$$Diem_is_currency_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 263106) 263112) inline$$Diem_is_currency_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$Diem_is_currency_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@11  (=> (not true) (and (=> (= (ControlFlow 0 263052) 263130) inline$$Diem_is_currency_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 263052) 263106) inline$$Diem_is_currency_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@11  (and (=> (= (ControlFlow 0 263062) 263130) inline$$Diem_is_currency_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 263062) 263106) inline$$Diem_is_currency_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@11  (=> (and (not false) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@11 ($Address 173345816))) (and (=> (= (ControlFlow 0 263046) 263062) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 263046) 263052) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@11)))))
(let ((inline$$Diem_is_currency_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 263076) 263046)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@11)))
(let ((anon0$1_correct@@16  (=> (forall (($inv_addr@@37 Int) ($inv_tv0@@32 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37)) (let ((va@@283 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))))
(let ((l@@283 (|l#$ValueArray| va@@283)))
 (and (and (<= 0 l@@283) (<= l@@283 $MAX_U64)) (forall ((x@@283 Int) ) (!  (=> (or (< x@@283 0) (>= x@@283 l@@283)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@283) x@@283) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@283) x@@283))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@284 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@284 (|l#$ValueArray| va@@284)))
 (and (and (<= 0 l@@284) (<= l@@284 $MAX_U64)) (forall ((x@@284 Int) ) (!  (=> (or (< x@@284 0) (>= x@@284 l@@284)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@284) x@@284) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@284) x@@284))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code)) (let ((va@@285 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@285 (|l#$ValueArray| va@@285)))
 (and (and (<= 0 l@@285) (<= l@@285 $MAX_U64)) (forall ((x@@285 Int) ) (!  (=> (or (< x@@285 0) (>= x@@285 l@@285)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@285) x@@285) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@285) x@@285))
))))))) (forall (($$0@@90 Int) ) (!  (=> (and (>= $$0@@90 0) (< $$0@@90 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))) $$0@@90)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))) $$0@@90)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))) $$0@@90)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_currency_code))) $$0@@90))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events)) (let ((va@@286 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@286 (|l#$ValueArray| va@@286)))
 (and (and (<= 0 l@@286) (<= l@@286 $MAX_U64)) (forall ((x@@286 Int) ) (!  (=> (or (< x@@286 0) (>= x@@286 l@@286)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@286) x@@286) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@286) x@@286))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@287 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@287 (|l#$ValueArray| va@@287)))
 (and (and (<= 0 l@@287) (<= l@@287 $MAX_U64)) (forall ((x@@287 Int) ) (!  (=> (or (< x@@287 0) (>= x@@287 l@@287)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@287) x@@287) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@287) x@@287))
))))))) (forall (($$0@@91 Int) ) (!  (=> (and (>= $$0@@91 0) (< $$0@@91 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@91)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@91)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@91)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@91))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events)) (let ((va@@288 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@288 (|l#$ValueArray| va@@288)))
 (and (and (<= 0 l@@288) (<= l@@288 $MAX_U64)) (forall ((x@@288 Int) ) (!  (=> (or (< x@@288 0) (>= x@@288 l@@288)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@288) x@@288) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@288) x@@288))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@289 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@289 (|l#$ValueArray| va@@289)))
 (and (and (<= 0 l@@289) (<= l@@289 $MAX_U64)) (forall ((x@@289 Int) ) (!  (=> (or (< x@@289 0) (>= x@@289 l@@289)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@289) x@@289) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@289) x@@289))
))))))) (forall (($$0@@92 Int) ) (!  (=> (and (>= $$0@@92 0) (< $$0@@92 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@92)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@92)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@92)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@92))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@290 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@290 (|l#$ValueArray| va@@290)))
 (and (and (<= 0 l@@290) (<= l@@290 $MAX_U64)) (forall ((x@@290 Int) ) (!  (=> (or (< x@@290 0) (>= x@@290 l@@290)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@290) x@@290) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@290) x@@290))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@291 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@291 (|l#$ValueArray| va@@291)))
 (and (and (<= 0 l@@291) (<= l@@291 $MAX_U64)) (forall ((x@@291 Int) ) (!  (=> (or (< x@@291 0) (>= x@@291 l@@291)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@291) x@@291) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@291) x@@291))
))))))) (forall (($$0@@93 Int) ) (!  (=> (and (>= $$0@@93 0) (< $$0@@93 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@93)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@93)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@93)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@93))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@292 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@292 (|l#$ValueArray| va@@292)))
 (and (and (<= 0 l@@292) (<= l@@292 $MAX_U64)) (forall ((x@@292 Int) ) (!  (=> (or (< x@@292 0) (>= x@@292 l@@292)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@292) x@@292) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@292) x@@292))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@293 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@293 (|l#$ValueArray| va@@293)))
 (and (and (<= 0 l@@293) (<= l@@293 $MAX_U64)) (forall ((x@@293 Int) ) (!  (=> (or (< x@@293 0) (>= x@@293 l@@293)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@293) x@@293) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@293) x@@293))
))))))) (forall (($$0@@94 Int) ) (!  (=> (and (>= $$0@@94 0) (< $$0@@94 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@94)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@94)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@94)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@94))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@294 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@294 (|l#$ValueArray| va@@294)))
 (and (and (<= 0 l@@294) (<= l@@294 $MAX_U64)) (forall ((x@@294 Int) ) (!  (=> (or (< x@@294 0) (>= x@@294 l@@294)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@294) x@@294) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@294) x@@294))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@295 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@295 (|l#$ValueArray| va@@295)))
 (and (and (<= 0 l@@295) (<= l@@295 $MAX_U64)) (forall ((x@@295 Int) ) (!  (=> (or (< x@@295 0) (>= x@@295 l@@295)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@295) x@@295) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@295) x@@295))
))))))) (forall (($$0@@95 Int) ) (!  (=> (and (>= $$0@@95 0) (< $$0@@95 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@95)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@95)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@95)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@95))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@32) 1) $inv_addr@@37))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@27 T@$Value) )  (=> ((_ is $Type) coin_type@@27) (|b#$Boolean| ($Boolean (forall ((addr3@@13 T@$Value) )  (=> ((_ is $Address) addr3@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@27)) 1) (|a#$Address| addr3@@13)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@27)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@27)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 263136) 263076)) inline$$Diem_is_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@17  (=> (= (ControlFlow 0 449164) 263136) anon0$1_correct@@16)))
anon0_correct@@17)))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@14 () Bool)
(declare-fun $tv0@@25 () T@$TypeValue)
(declare-fun inline$$Diem_is_synthetic_currency_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@17 () Bool)
(declare-fun $abort_flag@1@@16 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@12 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@6 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@6 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@6 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@12 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def_verify$0$$t2@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def_verify$0$$t5@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 450834) (let ((anon0$2_correct@@18  (and (=> (= (ControlFlow 0 264203) (- 0 452078)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452127)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@278 T@$Value) )  (=> ((_ is $Address) addr@@278) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@278))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@278)))))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@279 T@$Value) )  (=> ((_ is $Address) addr@@279) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@279))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@279))))))))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452207)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@280 T@$Value) )  (=> ((_ is $Address) addr@@280) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@280)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@280))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@281 T@$Value) )  (=> ((_ is $Address) addr@@281) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@281)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@281)))))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452275)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452324)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@282 T@$Value) )  (=> ((_ is $Address) addr@@282) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@282))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@282)))))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@283 T@$Value) )  (=> ((_ is $Address) addr@@283) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@283))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@283))))))))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452404)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@284 T@$Value) )  (=> ((_ is $Address) addr@@284) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@284)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@284))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@285 T@$Value) )  (=> ((_ is $Address) addr@@285) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@285)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@285)))))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452472)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452521)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452570)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@286 T@$Value) )  (=> ((_ is $Address) addr@@286) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@286))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@286)))))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@287 T@$Value) )  (=> ((_ is $Address) addr@@287) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@287))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@287))))))))))))))) (and (=> (= (ControlFlow 0 264203) (- 0 452650)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@288 T@$Value) )  (=> ((_ is $Address) addr@@288) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@288)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@288))))))))))))) (=> (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean (forall ((addr@@289 T@$Value) )  (=> ((_ is $Address) addr@@289) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@289)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| addr@@289)))))))))))) (=> (= (ControlFlow 0 264203) (- 0 452718)) (=> (not $abort_flag@2@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$Abort_correct  (=> (= inline$$Diem_is_synthetic_currency_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@14 true) (= (ControlFlow 0 264183) 264203)) anon0$2_correct@@18))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 264175) 264183)) inline$$Diem_is_synthetic_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 264191) 264183) inline$$Diem_is_synthetic_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@17 (and (=> (= (ControlFlow 0 264169) 264191) inline$$Diem_is_synthetic_currency_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 264169) 264175) inline$$Diem_is_synthetic_currency_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon14_correct  (=> (and (= $abort_flag@2@@14 $abort_flag@1@@16) (= (ControlFlow 0 263852) 264203)) anon0$2_correct@@18)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 263850) 263852)) inline$$Diem_is_synthetic_currency_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 263860) 263852) inline$$Diem_is_synthetic_currency_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon10_correct  (=> (= $abort_flag@1@@16 $abort_flag@0@@17) (and (=> (= (ControlFlow 0 264157) 263860) inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 264157) 263850) inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 264155) 264157)) inline$$Diem_is_synthetic_currency_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon19_Then_correct  (=> (= (ControlFlow 0 264165) 264157) inline$$Diem_is_synthetic_currency_$def_verify$0$anon10_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@12  (=> (= inline$$GetFieldFromValue$0$dst@1@@12 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@1)) $Diem_CurrencyInfo_is_synthetic)) (and (=> (= (ControlFlow 0 264107) 264165) inline$$Diem_is_synthetic_currency_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 264107) 264155) inline$$Diem_is_synthetic_currency_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0@@17) (= (ControlFlow 0 264113) 264107)) inline$$GetFieldFromValue$0$anon0_correct@@12)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@6  (=> (= $abort_flag@0@@17 true) (and (=> (= (ControlFlow 0 264053) 264169) inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 264053) 264113) inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@6  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@6 inline$$GetGlobal$0$a@1@@6)) (= (ControlFlow 0 264051) 264053)) inline$$GetGlobal$0$anon3_Then$1_correct@@6)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@6  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@6 inline$$GetGlobal$0$a@1@@6) (=> (and (= inline$$GetGlobal$0$dst@1@@6 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@6 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@12))) (= $abort_flag@0@@17 false)) (and (=> (= (ControlFlow 0 263999) 264169) inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 263999) 264113) inline$$Diem_is_synthetic_currency_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@6  (=> (= inline$$GetGlobal$0$a@1@@6 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@12)) (and (=> (= (ControlFlow 0 263981) 264051) inline$$GetGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 263981) 263999) inline$$GetGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$GetGlobal$0$Entry_correct@@6  (=> (= inline$$GetGlobal$0$ta@0@@6 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1)) (and (=> (= (ControlFlow 0 263975) (- 0 451910)) true) (=> (= (ControlFlow 0 263975) 263981) inline$$GetGlobal$0$anon0_correct@@6)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon16_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def_verify$0$$t2@1) (= (ControlFlow 0 264059) 263975)) inline$$GetGlobal$0$Entry_correct@@6)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon12_correct  (=> (= $abort_flag@1@@16 false) (and (=> (= (ControlFlow 0 263840) 263860) inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 263840) 263850) inline$$Diem_is_synthetic_currency_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 263838) 263840)) inline$$Diem_is_synthetic_currency_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon20_Then_correct  (=> (= (ControlFlow 0 263868) 263840) inline$$Diem_is_synthetic_currency_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon16_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def_verify$0$$t2@1)) (= inline$$Diem_is_synthetic_currency_$def_verify$0$$t5@1 ($Boolean false))) (and (=> (= (ControlFlow 0 263830) 263868) inline$$Diem_is_synthetic_currency_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 263830) 263838) inline$$Diem_is_synthetic_currency_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Else_correct  (=> (and (not false) (= inline$$Diem_is_synthetic_currency_$def_verify$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@25) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@12))))) (and (=> (= (ControlFlow 0 263786) 264059) inline$$Diem_is_synthetic_currency_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 263786) 263830) inline$$Diem_is_synthetic_currency_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Then_correct true))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@12  (=> (not true) (and (=> (= (ControlFlow 0 263734) 264195) inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 263734) 263786) inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@12  (and (=> (= (ControlFlow 0 263744) 264195) inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 263744) 263786) inline$$Diem_is_synthetic_currency_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@12  (=> (and (not false) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@12 ($Address 173345816))) (and (=> (= (ControlFlow 0 263728) 263744) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@12) (=> (= (ControlFlow 0 263728) 263734) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@12)))))
(let ((inline$$Diem_is_synthetic_currency_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 263758) 263728)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@12)))
(let ((anon0$1_correct@@17  (=> (forall (($inv_addr@@38 Int) ($inv_tv0@@33 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38)) (let ((va@@296 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))))
(let ((l@@296 (|l#$ValueArray| va@@296)))
 (and (and (<= 0 l@@296) (<= l@@296 $MAX_U64)) (forall ((x@@296 Int) ) (!  (=> (or (< x@@296 0) (>= x@@296 l@@296)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@296) x@@296) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@296) x@@296))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@297 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@297 (|l#$ValueArray| va@@297)))
 (and (and (<= 0 l@@297) (<= l@@297 $MAX_U64)) (forall ((x@@297 Int) ) (!  (=> (or (< x@@297 0) (>= x@@297 l@@297)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@297) x@@297) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@297) x@@297))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code)) (let ((va@@298 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@298 (|l#$ValueArray| va@@298)))
 (and (and (<= 0 l@@298) (<= l@@298 $MAX_U64)) (forall ((x@@298 Int) ) (!  (=> (or (< x@@298 0) (>= x@@298 l@@298)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@298) x@@298) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@298) x@@298))
))))))) (forall (($$0@@96 Int) ) (!  (=> (and (>= $$0@@96 0) (< $$0@@96 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))) $$0@@96)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))) $$0@@96)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))) $$0@@96)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_currency_code))) $$0@@96))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events)) (let ((va@@299 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@299 (|l#$ValueArray| va@@299)))
 (and (and (<= 0 l@@299) (<= l@@299 $MAX_U64)) (forall ((x@@299 Int) ) (!  (=> (or (< x@@299 0) (>= x@@299 l@@299)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@299) x@@299) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@299) x@@299))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@300 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@300 (|l#$ValueArray| va@@300)))
 (and (and (<= 0 l@@300) (<= l@@300 $MAX_U64)) (forall ((x@@300 Int) ) (!  (=> (or (< x@@300 0) (>= x@@300 l@@300)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@300) x@@300) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@300) x@@300))
))))))) (forall (($$0@@97 Int) ) (!  (=> (and (>= $$0@@97 0) (< $$0@@97 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@97)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@97)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@97)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@97))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events)) (let ((va@@301 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@301 (|l#$ValueArray| va@@301)))
 (and (and (<= 0 l@@301) (<= l@@301 $MAX_U64)) (forall ((x@@301 Int) ) (!  (=> (or (< x@@301 0) (>= x@@301 l@@301)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@301) x@@301) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@301) x@@301))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@302 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@302 (|l#$ValueArray| va@@302)))
 (and (and (<= 0 l@@302) (<= l@@302 $MAX_U64)) (forall ((x@@302 Int) ) (!  (=> (or (< x@@302 0) (>= x@@302 l@@302)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@302) x@@302) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@302) x@@302))
))))))) (forall (($$0@@98 Int) ) (!  (=> (and (>= $$0@@98 0) (< $$0@@98 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@98)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@98)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@98)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@98))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@303 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@303 (|l#$ValueArray| va@@303)))
 (and (and (<= 0 l@@303) (<= l@@303 $MAX_U64)) (forall ((x@@303 Int) ) (!  (=> (or (< x@@303 0) (>= x@@303 l@@303)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@303) x@@303) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@303) x@@303))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@304 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@304 (|l#$ValueArray| va@@304)))
 (and (and (<= 0 l@@304) (<= l@@304 $MAX_U64)) (forall ((x@@304 Int) ) (!  (=> (or (< x@@304 0) (>= x@@304 l@@304)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@304) x@@304) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@304) x@@304))
))))))) (forall (($$0@@99 Int) ) (!  (=> (and (>= $$0@@99 0) (< $$0@@99 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@99)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@99)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@99)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@99))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@305 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@305 (|l#$ValueArray| va@@305)))
 (and (and (<= 0 l@@305) (<= l@@305 $MAX_U64)) (forall ((x@@305 Int) ) (!  (=> (or (< x@@305 0) (>= x@@305 l@@305)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@305) x@@305) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@305) x@@305))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@306 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@306 (|l#$ValueArray| va@@306)))
 (and (and (<= 0 l@@306) (<= l@@306 $MAX_U64)) (forall ((x@@306 Int) ) (!  (=> (or (< x@@306 0) (>= x@@306 l@@306)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@306) x@@306) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@306) x@@306))
))))))) (forall (($$0@@100 Int) ) (!  (=> (and (>= $$0@@100 0) (< $$0@@100 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@100)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@100)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@100)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@100))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@307 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@307 (|l#$ValueArray| va@@307)))
 (and (and (<= 0 l@@307) (<= l@@307 $MAX_U64)) (forall ((x@@307 Int) ) (!  (=> (or (< x@@307 0) (>= x@@307 l@@307)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@307) x@@307) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@307) x@@307))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@308 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@308 (|l#$ValueArray| va@@308)))
 (and (and (<= 0 l@@308) (<= l@@308 $MAX_U64)) (forall ((x@@308 Int) ) (!  (=> (or (< x@@308 0) (>= x@@308 l@@308)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@308) x@@308) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@308) x@@308))
))))))) (forall (($$0@@101 Int) ) (!  (=> (and (>= $$0@@101 0) (< $$0@@101 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@101)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@101)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@101)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@101))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@33) 1) $inv_addr@@38))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@28 T@$Value) )  (=> ((_ is $Type) coin_type@@28) (|b#$Boolean| ($Boolean (forall ((addr3@@14 T@$Value) )  (=> ((_ is $Address) addr3@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@28)) 1) (|a#$Address| addr3@@14)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@28)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@28)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 264201) 263758)) inline$$Diem_is_synthetic_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@18  (=> (= (ControlFlow 0 450834) 264201) anon0$1_correct@@17)))
anon0_correct@@18))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin1 () T@$Value)
(declare-fun coin2 () T@$Value)
(declare-fun $abort_flag@1@@17 () Bool)
(declare-fun $abort_code@1@@15 () Int)
(declare-fun inline$$Diem_join_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $tv0@@26 () T@$TypeValue)
(declare-fun inline$$Diem_join_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@18 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@3| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@4| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@4 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@6 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 452771) (let ((anon0$2_correct@@19  (and (=> (= (ControlFlow 0 265100) (- 0 455744)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@17)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@1@@17) (and (=> (= (ControlFlow 0 265100) (- 0 455781)) (=> $abort_flag@1@@17 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> (=> $abort_flag@1@@17 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))) (and (=> (= (ControlFlow 0 265100) (- 0 455818)) (=> $abort_flag@1@@17 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 8)))))) (=> (=> $abort_flag@1@@17 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 8))))) (and (=> (= (ControlFlow 0 265100) (- 0 455866)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_join_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_join_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 265100) (- 0 455902)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 455951)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@290 T@$Value) )  (=> ((_ is $Address) addr@@290) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@290))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@290)))))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@291 T@$Value) )  (=> ((_ is $Address) addr@@291) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@291))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@291))))))))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456031)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@292 T@$Value) )  (=> ((_ is $Address) addr@@292) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@292)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@292))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@293 T@$Value) )  (=> ((_ is $Address) addr@@293) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@293)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@293)))))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456099)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456148)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@294 T@$Value) )  (=> ((_ is $Address) addr@@294) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@294))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@294)))))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@295 T@$Value) )  (=> ((_ is $Address) addr@@295) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@295))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@295))))))))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456228)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@296 T@$Value) )  (=> ((_ is $Address) addr@@296) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@296)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@296))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@297 T@$Value) )  (=> ((_ is $Address) addr@@297) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@297)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@297)))))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456296)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456345)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456394)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@298 T@$Value) )  (=> ((_ is $Address) addr@@298) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@298))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@298)))))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@299 T@$Value) )  (=> ((_ is $Address) addr@@299) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@299))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@299))))))))))))))) (and (=> (= (ControlFlow 0 265100) (- 0 456474)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@300 T@$Value) )  (=> ((_ is $Address) addr@@300) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@300)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@300))))))))))))) (=> (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean (forall ((addr@@301 T@$Value) )  (=> ((_ is $Address) addr@@301) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@301)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@301)))))))))))) (=> (= (ControlFlow 0 265100) (- 0 456542)) (=> (not $abort_flag@1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_join_$def_verify$0$anon7_correct  (=> (and (and (= inline$$Diem_join_$def_verify$0$$ret0@1 $Error) (= $abort_flag@1@@17 true)) (and (= inline$$Diem_join_$def_verify$0$$ret0@2 inline$$Diem_join_$def_verify$0$$ret0@1) (= (ControlFlow 0 265068) 265100))) anon0$2_correct@@19)))
(let ((inline$$Diem_join_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 265062) 265068)) inline$$Diem_join_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_join_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 265076) 265068) inline$$Diem_join_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_join_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@18 (and (=> (= (ControlFlow 0 265056) 265076) inline$$Diem_join_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 265056) 265062) inline$$Diem_join_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_join_$def_verify$0$anon10_correct  (=> (= $abort_flag@1@@17 $abort_flag@0@@18) (=> (and (= inline$$Diem_join_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@3|) (= (ControlFlow 0 265044) 265100)) anon0$2_correct@@19))))
(let ((inline$$Diem_join_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 265042) 265044)) inline$$Diem_join_$def_verify$0$anon10_correct)))
(let ((inline$$Diem_join_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 265052) 265044) inline$$Diem_join_$def_verify$0$anon10_correct)))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@4  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@3| coin1)) (and (=> (= (ControlFlow 0 265000) 265052) inline$$Diem_join_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 265000) 265042) inline$$Diem_join_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@4  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@6|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@4| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@6|) 0 coin1 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@6|))) (= |inline$$WritebackToValue$0$vdst'@2@@3| |inline$$WritebackToValue$0$vdst'@1@@4|)) (and (=> (= (ControlFlow 0 265026) 265052) inline$$Diem_join_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 265026) 265042) inline$$Diem_join_$def_verify$0$anon15_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@6  (=> (= |inline$$WriteRef$0$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@4) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@4) call5formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 264901) 265026) inline$$WritebackToValue$0$anon3_Then_correct@@4) (=> (= (ControlFlow 0 264901) 265000) inline$$WritebackToValue$0$anon3_Else_correct@@4)))))
(let ((inline$$Diem_join_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@18) (= (ControlFlow 0 264907) 264901)) inline$$WriteRef$0$anon0_correct@@6)))
(let ((inline$$Diem_join_$def_verify$0$anon4$4_correct  (and (=> (= (ControlFlow 0 264844) (- 0 454770)) true) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@0@@18) (=> (and (=> $abort_flag@0@@18 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (=> $abort_flag@0@@18 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@1@@15 (|i#$Integer| ($Integer 8)))))) (=> (and (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value)))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@302 T@$Value) )  (=> ((_ is $Address) addr@@302) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@302))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@302))))))))))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@303 T@$Value) )  (=> ((_ is $Address) addr@@303) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@303)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@303)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@304 T@$Value) )  (=> ((_ is $Address) addr@@304) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@304))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@304)))))))))))))))) (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@305 T@$Value) )  (=> ((_ is $Address) addr@@305) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@305)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@305)))))))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@306 T@$Value) )  (=> ((_ is $Address) addr@@306) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@306))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@306)))))))))))))))) (and (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean (forall ((addr@@307 T@$Value) )  (=> ((_ is $Address) addr@@307) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@307)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| addr@@307)))))))))))) (=> (not $abort_flag@0@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@26) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@0) (let ((va@@309 (|v#$Vector| call5formal@$ret0@0@@0)))
(let ((l@@309 (|l#$ValueArray| va@@309)))
 (and (and (<= 0 l@@309) (<= l@@309 $MAX_U64)) (forall ((x@@309 Int) ) (!  (=> (or (< x@@309 0) (>= x@@309 l@@309)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@309) x@@309) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@309) x@@309))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 264844) 265056) inline$$Diem_join_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 264844) 264907) inline$$Diem_join_$def_verify$0$anon13_Else_correct))))))))))
(let ((inline$$ReadRef$0$anon0_correct@@6  (=> (and (= inline$$ReadRef$0$v@1@@6 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@4)) (= (ControlFlow 0 264832) 264844)) inline$$Diem_join_$def_verify$0$anon4$4_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@4  (=> (and (= inline$$BorrowLoc$0$dst@1@@4 ($Mutation ($Local 2) $EmptyPath coin1)) (= (ControlFlow 0 264794) 264832)) inline$$ReadRef$0$anon0_correct@@6)))
(let ((inline$$Diem_join_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 264676) 264794)) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$Diem_join_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 265084) 264794) inline$$BorrowLoc$0$anon0_correct@@4)))
(let ((inline$$Diem_join_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 264668) 265084) inline$$Diem_join_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 264668) 264676) inline$$Diem_join_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$Diem_join_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 265092) 265084) inline$$Diem_join_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 265092) 264676) inline$$Diem_join_$def_verify$0$anon12_Else_correct))))
(let ((inline$$Diem_join_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 264662) 265092) inline$$Diem_join_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 264662) 264668) inline$$Diem_join_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@18  (=> (and (forall (($inv_addr@@39 Int) ($inv_tv0@@34 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39)) (let ((va@@310 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))))
(let ((l@@310 (|l#$ValueArray| va@@310)))
 (and (and (<= 0 l@@310) (<= l@@310 $MAX_U64)) (forall ((x@@310 Int) ) (!  (=> (or (< x@@310 0) (>= x@@310 l@@310)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@310) x@@310) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@310) x@@310))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@34) 1) $inv_addr@@39))
)) (= (ControlFlow 0 265098) 264662)) inline$$Diem_join_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@19  (=> (and (and (and (and ((_ is $Vector) coin1) (let ((va@@311 (|v#$Vector| coin1)))
(let ((l@@311 (|l#$ValueArray| va@@311)))
 (and (and (<= 0 l@@311) (<= l@@311 $MAX_U64)) (forall ((x@@311 Int) ) (!  (=> (or (< x@@311 0) (>= x@@311 l@@311)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@311) x@@311) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@311) x@@311))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin1)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) coin2) (let ((va@@312 (|v#$Vector| coin2)))
(let ((l@@312 (|l#$ValueArray| va@@312)))
 (and (and (<= 0 l@@312) (<= l@@312 $MAX_U64)) (forall ((x@@312 Int) ) (!  (=> (or (< x@@312 0) (>= x@@312 l@@312)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@312) x@@312) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@312) x@@312))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin2)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 264375) 265098)) anon0$1_correct@@18))))
(let ((PreconditionGeneratedEntry_correct@@12  (=> (= (ControlFlow 0 452771) 264375) anon0_correct@@19)))
PreconditionGeneratedEntry_correct@@12))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@15 () Bool)
(declare-fun $tv0@@27 () T@$TypeValue)
(declare-fun inline$$Diem_market_cap_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@19 () Bool)
(declare-fun $abort_flag@1@@18 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@13 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@7 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@7 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@7 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@13 () T@$Value)
(declare-fun $abort_code@1@@16 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 456592) (let ((anon0$2_correct@@20  (and (=> (= (ControlFlow 0 266044) (- 0 459217)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459266)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@308 T@$Value) )  (=> ((_ is $Address) addr@@308) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@308))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@308)))))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@309 T@$Value) )  (=> ((_ is $Address) addr@@309) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@309))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@309))))))))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459346)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@310 T@$Value) )  (=> ((_ is $Address) addr@@310) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@310)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@310))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@311 T@$Value) )  (=> ((_ is $Address) addr@@311) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@311)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@311)))))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459414)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459463)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@312 T@$Value) )  (=> ((_ is $Address) addr@@312) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@312))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@312)))))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@313 T@$Value) )  (=> ((_ is $Address) addr@@313) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@313))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@313))))))))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459543)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@314 T@$Value) )  (=> ((_ is $Address) addr@@314) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@314)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@314))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@315 T@$Value) )  (=> ((_ is $Address) addr@@315) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@315)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@315)))))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459611)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459660)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459709)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@316 T@$Value) )  (=> ((_ is $Address) addr@@316) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@316))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@316)))))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@317 T@$Value) )  (=> ((_ is $Address) addr@@317) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@317))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@317))))))))))))))) (and (=> (= (ControlFlow 0 266044) (- 0 459789)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@318 T@$Value) )  (=> ((_ is $Address) addr@@318) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@318)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@318))))))))))))) (=> (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean (forall ((addr@@319 T@$Value) )  (=> ((_ is $Address) addr@@319) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@319)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@319)))))))))))) (=> (= (ControlFlow 0 266044) (- 0 459857)) (=> (not $abort_flag@2@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_market_cap_$def_verify$0$Abort_correct  (=> (= inline$$Diem_market_cap_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@15 true) (= (ControlFlow 0 266004) 266044)) anon0$2_correct@@20))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 266026) 266004)) inline$$Diem_market_cap_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 266036) 266004) inline$$Diem_market_cap_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@19 (and (=> (= (ControlFlow 0 266020) 266036) inline$$Diem_market_cap_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 266020) 266026) inline$$Diem_market_cap_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 265996) 266004)) inline$$Diem_market_cap_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 266012) 266004) inline$$Diem_market_cap_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@18 (and (=> (= (ControlFlow 0 265990) 266012) inline$$Diem_market_cap_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 265990) 265996) inline$$Diem_market_cap_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@0@@19 (= (ControlFlow 0 266016) 266004)) inline$$Diem_market_cap_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@2@@15 $abort_flag@1@@18) (= (ControlFlow 0 265978) 266044)) anon0$2_correct@@20)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 265976) 265978)) inline$$Diem_market_cap_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 265986) 265978) inline$$Diem_market_cap_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@13  (=> (= inline$$GetFieldFromValue$0$dst@1@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@2)) $Diem_CurrencyInfo_total_value)) (and (=> (= (ControlFlow 0 265960) 265986) inline$$Diem_market_cap_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 265960) 265976) inline$$Diem_market_cap_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@18) (= (ControlFlow 0 265966) 265960)) inline$$GetFieldFromValue$0$anon0_correct@@13)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@7  (=> (= $abort_flag@1@@18 true) (and (=> (= (ControlFlow 0 265906) 265990) inline$$Diem_market_cap_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 265906) 265966) inline$$Diem_market_cap_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@7  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@7 inline$$GetGlobal$0$a@1@@7)) (= (ControlFlow 0 265904) 265906)) inline$$GetGlobal$0$anon3_Then$1_correct@@7)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@7  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@7 inline$$GetGlobal$0$a@1@@7) (=> (and (= inline$$GetGlobal$0$dst@1@@7 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@7 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@13))) (= $abort_flag@1@@18 $abort_flag@0@@19)) (and (=> (= (ControlFlow 0 265852) 265990) inline$$Diem_market_cap_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 265852) 265966) inline$$Diem_market_cap_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@7  (=> (= inline$$GetGlobal$0$a@1@@7 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@13)) (and (=> (= (ControlFlow 0 265834) 265904) inline$$GetGlobal$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 265834) 265852) inline$$GetGlobal$0$anon3_Else_correct@@7)))))
(let ((inline$$GetGlobal$0$Entry_correct@@7  (=> (= inline$$GetGlobal$0$ta@0@@7 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1)) (and (=> (= (ControlFlow 0 265828) (- 0 459068)) true) (=> (= (ControlFlow 0 265828) 265834) inline$$GetGlobal$0$anon0_correct@@7)))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@19) (= (ControlFlow 0 265912) 265828)) inline$$GetGlobal$0$Entry_correct@@7)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@13  (=> (not true) (and (=> (= (ControlFlow 0 265695) 266016) inline$$Diem_market_cap_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 265695) 265912) inline$$Diem_market_cap_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@13  (and (=> (= (ControlFlow 0 265705) 266016) inline$$Diem_market_cap_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 265705) 265912) inline$$Diem_market_cap_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@13  (=> (and (not $abort_flag@0@@19) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@13 ($Address 173345816))) (and (=> (= (ControlFlow 0 265689) 265705) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@13) (=> (= (ControlFlow 0 265689) 265695) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@13)))))
(let ((inline$$Diem_market_cap_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@19) (= (ControlFlow 0 265719) 265689)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@13)))
(let ((inline$$Diem_market_cap_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@19) (=> $abort_flag@0@@19 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@19 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@16 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@320 T@$Value) )  (=> ((_ is $Address) addr@@320) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@320))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@320))))))))))))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@321 T@$Value) )  (=> ((_ is $Address) addr@@321) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@321)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@321)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@322 T@$Value) )  (=> ((_ is $Address) addr@@322) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@322))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@322)))))))))))))))) (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@323 T@$Value) )  (=> ((_ is $Address) addr@@323) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@323)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@323)))))))))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@324 T@$Value) )  (=> ((_ is $Address) addr@@324) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@324))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@324)))))))))))))))) (and (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean (forall ((addr@@325 T@$Value) )  (=> ((_ is $Address) addr@@325) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@325)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| addr@@325)))))))))))) (=> (not $abort_flag@0@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@27) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 265584) 266020) inline$$Diem_market_cap_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 265584) 265719) inline$$Diem_market_cap_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@19  (=> (forall (($inv_addr@@40 Int) ($inv_tv0@@35 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40)) (let ((va@@313 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))))
(let ((l@@313 (|l#$ValueArray| va@@313)))
 (and (and (<= 0 l@@313) (<= l@@313 $MAX_U64)) (forall ((x@@313 Int) ) (!  (=> (or (< x@@313 0) (>= x@@313 l@@313)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@313) x@@313) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@313) x@@313))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@314 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@314 (|l#$ValueArray| va@@314)))
 (and (and (<= 0 l@@314) (<= l@@314 $MAX_U64)) (forall ((x@@314 Int) ) (!  (=> (or (< x@@314 0) (>= x@@314 l@@314)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@314) x@@314) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@314) x@@314))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code)) (let ((va@@315 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@315 (|l#$ValueArray| va@@315)))
 (and (and (<= 0 l@@315) (<= l@@315 $MAX_U64)) (forall ((x@@315 Int) ) (!  (=> (or (< x@@315 0) (>= x@@315 l@@315)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@315) x@@315) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@315) x@@315))
))))))) (forall (($$0@@102 Int) ) (!  (=> (and (>= $$0@@102 0) (< $$0@@102 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))) $$0@@102)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))) $$0@@102)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))) $$0@@102)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_currency_code))) $$0@@102))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events)) (let ((va@@316 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@316 (|l#$ValueArray| va@@316)))
 (and (and (<= 0 l@@316) (<= l@@316 $MAX_U64)) (forall ((x@@316 Int) ) (!  (=> (or (< x@@316 0) (>= x@@316 l@@316)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@316) x@@316) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@316) x@@316))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@317 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@317 (|l#$ValueArray| va@@317)))
 (and (and (<= 0 l@@317) (<= l@@317 $MAX_U64)) (forall ((x@@317 Int) ) (!  (=> (or (< x@@317 0) (>= x@@317 l@@317)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@317) x@@317) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@317) x@@317))
))))))) (forall (($$0@@103 Int) ) (!  (=> (and (>= $$0@@103 0) (< $$0@@103 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@103)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@103)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@103)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@103))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events)) (let ((va@@318 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@318 (|l#$ValueArray| va@@318)))
 (and (and (<= 0 l@@318) (<= l@@318 $MAX_U64)) (forall ((x@@318 Int) ) (!  (=> (or (< x@@318 0) (>= x@@318 l@@318)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@318) x@@318) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@318) x@@318))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@319 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@319 (|l#$ValueArray| va@@319)))
 (and (and (<= 0 l@@319) (<= l@@319 $MAX_U64)) (forall ((x@@319 Int) ) (!  (=> (or (< x@@319 0) (>= x@@319 l@@319)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@319) x@@319) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@319) x@@319))
))))))) (forall (($$0@@104 Int) ) (!  (=> (and (>= $$0@@104 0) (< $$0@@104 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@104)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@104)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@104)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@104))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@320 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@320 (|l#$ValueArray| va@@320)))
 (and (and (<= 0 l@@320) (<= l@@320 $MAX_U64)) (forall ((x@@320 Int) ) (!  (=> (or (< x@@320 0) (>= x@@320 l@@320)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@320) x@@320) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@320) x@@320))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@321 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@321 (|l#$ValueArray| va@@321)))
 (and (and (<= 0 l@@321) (<= l@@321 $MAX_U64)) (forall ((x@@321 Int) ) (!  (=> (or (< x@@321 0) (>= x@@321 l@@321)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@321) x@@321) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@321) x@@321))
))))))) (forall (($$0@@105 Int) ) (!  (=> (and (>= $$0@@105 0) (< $$0@@105 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@105)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@105)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@105)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@105))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@322 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@322 (|l#$ValueArray| va@@322)))
 (and (and (<= 0 l@@322) (<= l@@322 $MAX_U64)) (forall ((x@@322 Int) ) (!  (=> (or (< x@@322 0) (>= x@@322 l@@322)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@322) x@@322) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@322) x@@322))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@323 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@323 (|l#$ValueArray| va@@323)))
 (and (and (<= 0 l@@323) (<= l@@323 $MAX_U64)) (forall ((x@@323 Int) ) (!  (=> (or (< x@@323 0) (>= x@@323 l@@323)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@323) x@@323) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@323) x@@323))
))))))) (forall (($$0@@106 Int) ) (!  (=> (and (>= $$0@@106 0) (< $$0@@106 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@106)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@106)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@106)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@106))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@324 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@324 (|l#$ValueArray| va@@324)))
 (and (and (<= 0 l@@324) (<= l@@324 $MAX_U64)) (forall ((x@@324 Int) ) (!  (=> (or (< x@@324 0) (>= x@@324 l@@324)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@324) x@@324) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@324) x@@324))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@325 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@325 (|l#$ValueArray| va@@325)))
 (and (and (<= 0 l@@325) (<= l@@325 $MAX_U64)) (forall ((x@@325 Int) ) (!  (=> (or (< x@@325 0) (>= x@@325 l@@325)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@325) x@@325) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@325) x@@325))
))))))) (forall (($$0@@107 Int) ) (!  (=> (and (>= $$0@@107 0) (< $$0@@107 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@107)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@107)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@107)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@107))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@35) 1) $inv_addr@@40))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@29 T@$Value) )  (=> ((_ is $Type) coin_type@@29) (|b#$Boolean| ($Boolean (forall ((addr3@@15 T@$Value) )  (=> ((_ is $Address) addr3@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@29)) 1) (|a#$Address| addr3@@15)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@29)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@29)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 266042) 265584)) inline$$Diem_market_cap_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@20  (=> (= (ControlFlow 0 456592) 266042) anon0$1_correct@@19)))
anon0_correct@@20))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@28 () T@$TypeValue)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@4@@9 () Bool)
(declare-fun value () T@$Value)
(declare-fun $abort_code@7@@7 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2@@4 () T@$Memory)
(declare-fun inline$$Diem_mint_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@5@@9 () Int)
(declare-fun call7formal@$ret0@0 () T@$Value)
(declare-fun $abort_flag@3@@11 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@5 () T@$Memory)
(declare-fun inline$$Diem_mint_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@6@@8 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@5 () T@$Memory)
(declare-fun $abort_code@1@@17 () Int)
(declare-fun $abort_flag@0@@20 () Bool)
(declare-fun $abort_code@2@@12 () Int)
(declare-fun $abort_flag@1@@19 () Bool)
(declare-fun $abort_code@4@@12 () Int)
(declare-fun $abort_flag@2@@16 () Bool)
(declare-fun inline$$Diem_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$GetGlobal$0$ta@0@@8 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@8 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@8 () T@$Value)
(declare-fun call3formal@$ret0@0@@35 () T@$Value)
(declare-fun inline$$Diem_mint_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@13 () Int)
(declare-fun call3formal@$ret0@0@@36 () T@$Value)
(declare-fun inline$$Diem_mint_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 459910) (let ((anon0$2_correct@@21  (and (=> (= (ControlFlow 0 267409) (- 0 464369)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 267409) (- 0 464402)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 267409) (- 0 464422)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 267409) (- 0 464458)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@9)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@4@@9) (and (=> (= (ControlFlow 0 267409) (- 0 464474)) (=> $abort_flag@4@@9 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@4@@9 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 464576)) (=> $abort_flag@4@@9 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@4@@9 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| account@@1))))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7@@7 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 267409) (- 0 464722)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 267409) (- 0 464748)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 267409) (- 0 464774)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 464818)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_mint_$def_verify$0$$ret0@2)) $Diem_Diem_value) value))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_mint_$def_verify$0$$ret0@2)) $Diem_Diem_value) value)))) (and (=> (= (ControlFlow 0 267409) (- 0 464836)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@326 T@$Value) )  (=> ((_ is $Address) addr@@326) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@326))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@326)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@327 T@$Value) )  (=> ((_ is $Address) addr@@327) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@327))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@327))))))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 464916)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@328 T@$Value) )  (=> ((_ is $Address) addr@@328) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@328)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@328))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@329 T@$Value) )  (=> ((_ is $Address) addr@@329) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@329)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@329)))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 464984)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465030)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@330 T@$Value) )  (=> ((_ is $Address) addr@@330) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@330))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@330)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@331 T@$Value) )  (=> ((_ is $Address) addr@@331) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@331))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@331))))))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465110)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@332 T@$Value) )  (=> ((_ is $Address) addr@@332) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@332)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@332))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@333 T@$Value) )  (=> ((_ is $Address) addr@@333) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@333)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@333)))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465178)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465224)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465270)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@334 T@$Value) )  (=> ((_ is $Address) addr@@334) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@334))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@334)))))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@335 T@$Value) )  (=> ((_ is $Address) addr@@335) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@335))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@335))))))))))))))) (and (=> (= (ControlFlow 0 267409) (- 0 465350)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@336 T@$Value) )  (=> ((_ is $Address) addr@@336) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@336)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@336))))))))))))) (=> (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean (forall ((addr@@337 T@$Value) )  (=> ((_ is $Address) addr@@337) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@337)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@337)))))))))))) (=> (= (ControlFlow 0 267409) (- 0 465418)) (=> (not $abort_flag@4@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@2@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_mint_$def_verify$0$anon26_correct  (=> (= $abort_code@7@@7 $abort_code@5@@9) (=> (and (and (= inline$$Diem_mint_$def_verify$0$$ret0@2 call7formal@$ret0@0) (= $abort_flag@4@@9 $abort_flag@3@@11)) (and (= $Diem_CurrencyInfo_$memory@2@@4 $Diem_CurrencyInfo_$memory@0@@5) (= (ControlFlow 0 267297) 267409))) anon0$2_correct@@21))))
(let ((inline$$Diem_mint_$def_verify$0$anon39_Else_correct  (=> (and (not true) (= (ControlFlow 0 267295) 267297)) inline$$Diem_mint_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon39_Then_correct  (=> (= (ControlFlow 0 267305) 267297) inline$$Diem_mint_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@3@@11) (and (=> (= (ControlFlow 0 267289) 267305) inline$$Diem_mint_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 267289) 267295) inline$$Diem_mint_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$Abort_correct  (=> (and (= inline$$Diem_mint_$def_verify$0$$ret0@1 $Error) (= $abort_code@7@@7 $abort_code@6@@8)) (=> (and (and (= inline$$Diem_mint_$def_verify$0$$ret0@2 inline$$Diem_mint_$def_verify$0$$ret0@1) (= $abort_flag@4@@9 true)) (and (= $Diem_CurrencyInfo_$memory@2@@4 $Diem_CurrencyInfo_$memory@1@@5) (= (ControlFlow 0 267074) 267409))) anon0$2_correct@@21))))
(let ((inline$$Diem_mint_$def_verify$0$anon7_correct  (=> (= $abort_code@6@@8 $abort_code@1@@17) (=> (and (= $Diem_CurrencyInfo_$memory@1@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 267377) 267074)) inline$$Diem_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 267375) 267377)) inline$$Diem_mint_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 267385) 267377) inline$$Diem_mint_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon29_Then_correct  (=> $abort_flag@0@@20 (and (=> (= (ControlFlow 0 267369) 267385) inline$$Diem_mint_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 267369) 267375) inline$$Diem_mint_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon11_correct  (=> (= $abort_code@6@@8 $abort_code@2@@12) (=> (and (= $Diem_CurrencyInfo_$memory@1@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 267357) 267074)) inline$$Diem_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 267355) 267357)) inline$$Diem_mint_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 267365) 267357) inline$$Diem_mint_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon31_Then_correct  (=> $abort_flag@1@@19 (and (=> (= (ControlFlow 0 267349) 267365) inline$$Diem_mint_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 267349) 267355) inline$$Diem_mint_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon19_correct  (=> (= $abort_code@6@@8 $abort_code@4@@12) (=> (and (= $Diem_CurrencyInfo_$memory@1@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 267337) 267074)) inline$$Diem_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 267335) 267337)) inline$$Diem_mint_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 267345) 267337) inline$$Diem_mint_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@16 (and (=> (= (ControlFlow 0 267329) 267345) inline$$Diem_mint_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 267329) 267335) inline$$Diem_mint_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon23_correct  (=> (= $abort_code@6@@8 $abort_code@5@@9) (=> (and (= $Diem_CurrencyInfo_$memory@1@@5 $Diem_CurrencyInfo_$memory@0@@5) (= (ControlFlow 0 267317) 267074)) inline$$Diem_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 267315) 267317)) inline$$Diem_mint_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 267325) 267317) inline$$Diem_mint_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon37_Then_correct  (=> $abort_flag@3@@11 (and (=> (= (ControlFlow 0 267309) 267325) inline$$Diem_mint_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 267309) 267315) inline$$Diem_mint_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@2@@16) (and (=> (= (ControlFlow 0 267281) (- 0 463137)) (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@3@@11) (=> (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@3@@11) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@11)) (=> (and (and (and (and (=> $abort_flag@3@@11 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))))) (=> $abort_flag@3@@11 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@5@@9 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@5@@9 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@9 (|i#$Integer| ($Integer 5))))))) (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value) value))))) (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@338 T@$Value) )  (=> ((_ is $Address) addr@@338) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@338))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@338))))))))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@339 T@$Value) )  (=> ((_ is $Address) addr@@339) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@339)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@339))))))))))))))) (and (and (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@340 T@$Value) )  (=> ((_ is $Address) addr@@340) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@340))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@340)))))))))))))))) (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@341 T@$Value) )  (=> ((_ is $Address) addr@@341) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@341)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@341)))))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@342 T@$Value) )  (=> ((_ is $Address) addr@@342) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@342))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@342)))))))))))))))) (and (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean (forall ((addr@@343 T@$Value) )  (=> ((_ is $Address) addr@@343) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@343)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| addr@@343)))))))))))) (=> (not $abort_flag@3@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call7formal@$ret0@0) (let ((va@@326 (|v#$Vector| call7formal@$ret0@0)))
(let ((l@@326 (|l#$ValueArray| va@@326)))
 (and (and (<= 0 l@@326) (<= l@@326 $MAX_U64)) (forall ((x@@326 Int) ) (!  (=> (or (< x@@326 0) (>= x@@326 l@@326)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@326) x@@326) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@326) x@@326))
)))))) (= (|l#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call7formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (= (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $Diem_CurrencyInfo_$memory@0@@5) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@0@@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 267281) 267309) inline$$Diem_mint_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 267281) 267289) inline$$Diem_mint_$def_verify$0$anon37_Else_correct)))))))))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@8  (=> (and (= $abort_flag@2@@16 true) (= $abort_code@4@@12 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 267267) 267329) inline$$Diem_mint_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 267267) 267281) inline$$Diem_mint_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@8  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@8 inline$$GetGlobal$0$a@1@@8)) (= (ControlFlow 0 267265) 267267)) inline$$GetGlobal$0$anon3_Then$1_correct@@8)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@8  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@8 inline$$GetGlobal$0$a@1@@8) (= inline$$GetGlobal$0$dst@1@@8 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) inline$$GetGlobal$0$ta@0@@8 (|a#$Address| call3formal@$ret0@0@@35)))) (and (= $abort_flag@2@@16 $abort_flag@1@@19) (= $abort_code@4@@12 $abort_code@2@@12))) (and (=> (= (ControlFlow 0 267213) 267329) inline$$Diem_mint_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 267213) 267281) inline$$Diem_mint_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@8  (=> (= inline$$GetGlobal$0$a@1@@8 (|a#$Address| call3formal@$ret0@0@@35)) (and (=> (= (ControlFlow 0 267195) 267265) inline$$GetGlobal$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 267195) 267213) inline$$GetGlobal$0$anon3_Else_correct@@8)))))
(let ((inline$$GetGlobal$0$Entry_correct@@8  (=> (= inline$$GetGlobal$0$ta@0@@8 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1)) (and (=> (= (ControlFlow 0 267189) (- 0 463050)) true) (=> (= (ControlFlow 0 267189) 267195) inline$$GetGlobal$0$anon0_correct@@8)))))
(let ((inline$$Diem_mint_$def_verify$0$anon33_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_mint_$def_verify$0$$t7@1) (= (ControlFlow 0 267273) 267189)) inline$$GetGlobal$0$Entry_correct@@8)))
(let ((inline$$Diem_mint_$def_verify$0$anon16_correct  (=> (= $abort_code@6@@8 $abort_code@3@@13) (=> (and (= $Diem_CurrencyInfo_$memory@1@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 267068) 267074)) inline$$Diem_mint_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 267066) 267068)) inline$$Diem_mint_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 267082) 267068) inline$$Diem_mint_$def_verify$0$anon16_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon33_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_mint_$def_verify$0$$t7@1)) (= $abort_code@3@@13 (|i#$Integer| call3formal@$ret0@0@@36))) (and (=> (= (ControlFlow 0 267060) 267082) inline$$Diem_mint_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 267060) 267066) inline$$Diem_mint_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@1@@19) (and (=> (= (ControlFlow 0 267048) 267273) inline$$Diem_mint_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 267048) 267060) inline$$Diem_mint_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon29_Else_correct  (=> (and (not $abort_flag@0@@20) (= inline$$Diem_mint_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| call3formal@$ret0@0@@35))))) (=> (and (and (and (= inline$$Diem_mint_$def_verify$0$$t8@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@19)) (and (=> $abort_flag@1@@19 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@19) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@36 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@36) (>= (|i#$Integer| call3formal@$ret0@0@@36) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@36) $MAX_U64))) (and (=> (= (ControlFlow 0 267042) 267349) inline$$Diem_mint_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 267042) 267048) inline$$Diem_mint_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$Diem_mint_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@20) (=> $abort_flag@0@@20 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@35 account@@1)))) ((_ is $Address) call3formal@$ret0@0@@35))) (and (=> (= (ControlFlow 0 267012) 267369) inline$$Diem_mint_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 267012) 267042) inline$$Diem_mint_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon4_correct  (=> (and (= inline$$Diem_mint_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 266976) 267012)) inline$$Diem_mint_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 266916) 266976)) inline$$Diem_mint_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 267393) 266976) inline$$Diem_mint_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_mint_$def_verify$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 266908) 267393) inline$$Diem_mint_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 266908) 266916) inline$$Diem_mint_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Diem_mint_$def_verify$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 267401) 267393) inline$$Diem_mint_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 267401) 266916) inline$$Diem_mint_$def_verify$0$anon28_Else_correct))))
(let ((inline$$Diem_mint_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 266902) 267401) inline$$Diem_mint_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 266902) 266908) inline$$Diem_mint_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@20  (=> (forall (($inv_addr@@41 Int) ($inv_tv0@@36 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41)) (let ((va@@327 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))))
(let ((l@@327 (|l#$ValueArray| va@@327)))
 (and (and (<= 0 l@@327) (<= l@@327 $MAX_U64)) (forall ((x@@327 Int) ) (!  (=> (or (< x@@327 0) (>= x@@327 l@@327)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@327) x@@327) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@327) x@@327))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@328 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@328 (|l#$ValueArray| va@@328)))
 (and (and (<= 0 l@@328) (<= l@@328 $MAX_U64)) (forall ((x@@328 Int) ) (!  (=> (or (< x@@328 0) (>= x@@328 l@@328)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@328) x@@328) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@328) x@@328))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code)) (let ((va@@329 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@329 (|l#$ValueArray| va@@329)))
 (and (and (<= 0 l@@329) (<= l@@329 $MAX_U64)) (forall ((x@@329 Int) ) (!  (=> (or (< x@@329 0) (>= x@@329 l@@329)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@329) x@@329) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@329) x@@329))
))))))) (forall (($$0@@108 Int) ) (!  (=> (and (>= $$0@@108 0) (< $$0@@108 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))) $$0@@108)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))) $$0@@108)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))) $$0@@108)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_currency_code))) $$0@@108))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events)) (let ((va@@330 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@330 (|l#$ValueArray| va@@330)))
 (and (and (<= 0 l@@330) (<= l@@330 $MAX_U64)) (forall ((x@@330 Int) ) (!  (=> (or (< x@@330 0) (>= x@@330 l@@330)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@330) x@@330) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@330) x@@330))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@331 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@331 (|l#$ValueArray| va@@331)))
 (and (and (<= 0 l@@331) (<= l@@331 $MAX_U64)) (forall ((x@@331 Int) ) (!  (=> (or (< x@@331 0) (>= x@@331 l@@331)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@331) x@@331) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@331) x@@331))
))))))) (forall (($$0@@109 Int) ) (!  (=> (and (>= $$0@@109 0) (< $$0@@109 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@109)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@109)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@109)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@109))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events)) (let ((va@@332 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@332 (|l#$ValueArray| va@@332)))
 (and (and (<= 0 l@@332) (<= l@@332 $MAX_U64)) (forall ((x@@332 Int) ) (!  (=> (or (< x@@332 0) (>= x@@332 l@@332)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@332) x@@332) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@332) x@@332))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@333 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@333 (|l#$ValueArray| va@@333)))
 (and (and (<= 0 l@@333) (<= l@@333 $MAX_U64)) (forall ((x@@333 Int) ) (!  (=> (or (< x@@333 0) (>= x@@333 l@@333)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@333) x@@333) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@333) x@@333))
))))))) (forall (($$0@@110 Int) ) (!  (=> (and (>= $$0@@110 0) (< $$0@@110 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@110)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@110)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@110)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@110))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@334 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@334 (|l#$ValueArray| va@@334)))
 (and (and (<= 0 l@@334) (<= l@@334 $MAX_U64)) (forall ((x@@334 Int) ) (!  (=> (or (< x@@334 0) (>= x@@334 l@@334)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@334) x@@334) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@334) x@@334))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@335 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@335 (|l#$ValueArray| va@@335)))
 (and (and (<= 0 l@@335) (<= l@@335 $MAX_U64)) (forall ((x@@335 Int) ) (!  (=> (or (< x@@335 0) (>= x@@335 l@@335)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@335) x@@335) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@335) x@@335))
))))))) (forall (($$0@@111 Int) ) (!  (=> (and (>= $$0@@111 0) (< $$0@@111 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@111)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@111)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@111)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@111))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@336 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@336 (|l#$ValueArray| va@@336)))
 (and (and (<= 0 l@@336) (<= l@@336 $MAX_U64)) (forall ((x@@336 Int) ) (!  (=> (or (< x@@336 0) (>= x@@336 l@@336)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@336) x@@336) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@336) x@@336))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@337 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@337 (|l#$ValueArray| va@@337)))
 (and (and (<= 0 l@@337) (<= l@@337 $MAX_U64)) (forall ((x@@337 Int) ) (!  (=> (or (< x@@337 0) (>= x@@337 l@@337)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@337) x@@337) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@337) x@@337))
))))))) (forall (($$0@@112 Int) ) (!  (=> (and (>= $$0@@112 0) (< $$0@@112 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@112)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@112)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@112)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@112))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@338 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@338 (|l#$ValueArray| va@@338)))
 (and (and (<= 0 l@@338) (<= l@@338 $MAX_U64)) (forall ((x@@338 Int) ) (!  (=> (or (< x@@338 0) (>= x@@338 l@@338)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@338) x@@338) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@338) x@@338))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@339 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@339 (|l#$ValueArray| va@@339)))
 (and (and (<= 0 l@@339) (<= l@@339 $MAX_U64)) (forall ((x@@339 Int) ) (!  (=> (or (< x@@339 0) (>= x@@339 l@@339)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@339) x@@339) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@339) x@@339))
))))))) (forall (($$0@@113 Int) ) (!  (=> (and (>= $$0@@113 0) (< $$0@@113 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@113)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@113)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@113)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@113))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@36) 1) $inv_addr@@41))
)) (=> (and (and (forall (($inv_addr@@42 Int) ($inv_tv0@@37 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@37) 1) $inv_addr@@42)) (let ((va@@340 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@37) 1) $inv_addr@@42))))
(let ((l@@340 (|l#$ValueArray| va@@340)))
 (and (and (<= 0 l@@340) (<= l@@340 $MAX_U64)) (forall ((x@@340 Int) ) (!  (=> (or (< x@@340 0) (>= x@@340 l@@340)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@340) x@@340) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@340) x@@340))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@37) 1) $inv_addr@@42))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@37) 1) $inv_addr@@42))) $Diem_MintCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@37) 1) $inv_addr@@42))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@30 T@$Value) )  (=> ((_ is $Type) coin_type@@30) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@1 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@30)) 1) (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@31 T@$Value) )  (=> ((_ is $Type) coin_type@@31) (|b#$Boolean| ($Boolean (forall ((addr3@@16 T@$Value) )  (=> ((_ is $Address) addr3@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@31)) 1) (|a#$Address| addr3@@16)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@31)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@31)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 267407) 266902))) inline$$Diem_mint_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@21  (=> ((_ is $Address) account@@1) (=> (and (and (and ((_ is $Integer) value) (>= (|i#$Integer| value) 0)) (<= (|i#$Integer| value) $MAX_U64)) (= (ControlFlow 0 266179) 267407)) anon0$1_correct@@20))))
(let ((PreconditionGeneratedEntry_correct@@13  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Diem_CurrencyInfo_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@28) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 459910) 266179)) anon0_correct@@21)))
PreconditionGeneratedEntry_correct@@13))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@29 () T@$TypeValue)
(declare-fun $abort_flag@9@@4 () Bool)
(declare-fun value@@0 () T@$Value)
(declare-fun $abort_code@13@@4 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@6 () T@$Memory)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1@@0 () T@$Value)
(declare-fun $abort_code@11@@5 () Int)
(declare-fun $abort_flag@8@@4 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@6 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@5| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@5 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@5 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@5 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@5| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@6| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@5 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@5 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@5| () T@$Mutation)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@5 () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@5| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@5 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@5 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@5 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@5 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@5| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@7 () T@$Value)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@12@@4 () Int)
(declare-fun $abort_code@1@@18 () Int)
(declare-fun $abort_flag@0@@21 () Bool)
(declare-fun $abort_code@2@@13 () Int)
(declare-fun $abort_flag@1@@20 () Bool)
(declare-fun $abort_code@3@@14 () Int)
(declare-fun $abort_flag@2@@17 () Bool)
(declare-fun $abort_code@4@@13 () Int)
(declare-fun $abort_flag@3@@12 () Bool)
(declare-fun $abort_code@6@@9 () Int)
(declare-fun $abort_flag@4@@10 () Bool)
(declare-fun $abort_code@7@@8 () Int)
(declare-fun $abort_flag@5@@7 () Bool)
(declare-fun $abort_code@8@@6 () Int)
(declare-fun $abort_flag@6@@7 () Bool)
(declare-fun $abort_code@10@@5 () Int)
(declare-fun $abort_flag@7@@5 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@5 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@37 () T@$Value)
(declare-fun inline$$Diem_MintEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@5 () Int)
(declare-fun inline$$BorrowField$5$p@2@@5 () T@$Path)
(declare-fun inline$$ReadRef$3$v@1@@5 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@5 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@5 () Int)
(declare-fun inline$$BorrowField$4$p@2@@5 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@5 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@7| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@6 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@6 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@6| () T@$Mutation)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@5 () T@$Mutation)
(declare-fun inline$$AddU128$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@5 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@5 () Int)
(declare-fun inline$$BorrowField$3$p@2@@5 () T@$Path)
(declare-fun inline$$AddU128$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@5 () T@$Value)
(declare-fun inline$$CastU128$1$dst@1@@3 () T@$Value)
(declare-fun inline$$AddU128$0$dst@1 () T@$Value)
(declare-fun inline$$CastU128$1$dst@0@@3 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@6 () Int)
(declare-fun inline$$BorrowField$2$p@2@@6 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@6 () T@$Value)
(declare-fun $abort_code@9@@6 () Int)
(declare-fun call3formal@$ret0@0@@38 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5 () T@$Value)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@6 () T@$Value)
(declare-fun inline$$CastU128$0$dst@1@@3 () T@$Value)
(declare-fun inline$$CastU128$0$dst@0@@3 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@6 () T@$Value)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$t13@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@6 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@6 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@6 () Int)
(declare-fun inline$$BorrowField$1$p@2@@6 () T@$Path)
(declare-fun inline$$ReadRef$0$v@1@@7 () T@$Value)
(declare-fun $abort_code@5@@10 () Int)
(declare-fun call3formal@$ret0@0@@39 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5 () T@$Value)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$t11@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@6 () Int)
(declare-fun inline$$BorrowField$0$p@2@@6 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@5 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@5 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@5 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@5 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@5 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@14 () T@$Value)
(declare-fun inline$$Diem_mint_with_capability_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun _capability@@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 465468) (let ((anon0$2_correct@@22  (and (=> (= (ControlFlow 0 275050) (- 0 473870)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@9@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) $abort_flag@9@@4) (and (=> (= (ControlFlow 0 275050) (- 0 473890)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@9@@4)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128))))) $abort_flag@9@@4) (and (=> (= (ControlFlow 0 275050) (- 0 473926)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@4) (and (=> (= (ControlFlow 0 275050) (- 0 473942)) (=> $abort_flag@9@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@9@@4 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474012)) (=> $abort_flag@9@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@9@@4 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|i#$Integer| ($Integer $MAX_U128))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13@@4 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 275050) (- 0 474115)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 275050) (- 0 474141)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 275050) (- 0 474167)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| value@@0)))) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474211)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_mint_with_capability_$def_verify$0$$ret0@2)) $Diem_Diem_value) value@@0))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_mint_with_capability_$def_verify$0$$ret0@2)) $Diem_Diem_value) value@@0)))) (and (=> (= (ControlFlow 0 275050) (- 0 474229)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@344 T@$Value) )  (=> ((_ is $Address) addr@@344) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@344))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@344)))))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@345 T@$Value) )  (=> ((_ is $Address) addr@@345) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@345))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@345))))))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474309)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@346 T@$Value) )  (=> ((_ is $Address) addr@@346) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@346)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@346))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@347 T@$Value) )  (=> ((_ is $Address) addr@@347) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@347)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@347)))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474377)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474423)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@348 T@$Value) )  (=> ((_ is $Address) addr@@348) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@348))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@348)))))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@349 T@$Value) )  (=> ((_ is $Address) addr@@349) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@349))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@349))))))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474503)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@350 T@$Value) )  (=> ((_ is $Address) addr@@350) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@350)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@350))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@351 T@$Value) )  (=> ((_ is $Address) addr@@351) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@351)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@351)))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474571)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474617)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474663)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@352 T@$Value) )  (=> ((_ is $Address) addr@@352) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@352))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@352)))))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@353 T@$Value) )  (=> ((_ is $Address) addr@@353) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@353))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@353))))))))))))))) (and (=> (= (ControlFlow 0 275050) (- 0 474743)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@354 T@$Value) )  (=> ((_ is $Address) addr@@354) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@354)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@354))))))))))))) (=> (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean (forall ((addr@@355 T@$Value) )  (=> ((_ is $Address) addr@@355) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@355)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@355)))))))))))) (=> (= (ControlFlow 0 275050) (- 0 474811)) (=> (not $abort_flag@9@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@6) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon62_correct  (=> (= inline$$Diem_mint_with_capability_$def_verify$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1@@0) (=> (and (and (= $abort_code@13@@4 $abort_code@11@@5) (= $abort_flag@9@@4 $abort_flag@8@@4)) (and (= $Diem_CurrencyInfo_$memory@1@@6 $Diem_CurrencyInfo_$memory@0@@6) (= (ControlFlow 0 273315) 275050))) anon0$2_correct@@22))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 273313) 273315)) inline$$Diem_mint_with_capability_$def_verify$0$anon62_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 273323) 273315) inline$$Diem_mint_with_capability_$def_verify$0$anon62_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 273291) 273323) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 273291) 273313) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 273297) 273323) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 273297) 273313) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 273285) 273297) inline$$Diem_Diem_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 273285) 273291) inline$$Diem_Diem_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 273277) 273323) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 273277) 273313) inline$$Diem_mint_with_capability_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) value@@0) (>= (|i#$Integer| value@@0) 0)) (<= (|i#$Integer| value@@0) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 value@@0) 1)))) (and (=> (= (ControlFlow 0 273269) 273285) inline$$Diem_Diem_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 273269) 273277) inline$$Diem_Diem_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon60$3_correct  (and (=> (= (ControlFlow 0 274802) (- 0 473330)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 274802) (- 0 473454)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 274802) (- 0 473507)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@0))))))))))))))) (=> (and (= $Diem_CurrencyInfo_$memory@0@@6 |inline$$WritebackToGlobal$1$m'@2@@5|) (= (ControlFlow 0 274802) 273269)) inline$$Diem_Diem_pack$0$anon0_correct@@0)))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@5  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@5)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@5| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 274481) 274802)) inline$$Diem_mint_with_capability_$def_verify$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@5  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@5) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@5 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@5)) (= inline$$WritebackToGlobal$1$a@1@@5 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@5))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@5 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@5|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@5 inline$$WritebackToGlobal$1$a@1@@5) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@5|))) (= |inline$$WritebackToGlobal$1$m'@1@@5| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@5 inline$$WritebackToGlobal$1$a@1@@5 inline$$WritebackToGlobal$1$v@1@@5)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@5| |inline$$WritebackToGlobal$1$m'@1@@5|) (= (ControlFlow 0 274535) 274802))) inline$$Diem_mint_with_capability_$def_verify$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@5  (=> (= inline$$WritebackToGlobal$1$l@1@@5 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@5|)) (and (=> (= (ControlFlow 0 274471) 274535) inline$$WritebackToGlobal$1$anon3_Then_correct@@5) (=> (= (ControlFlow 0 274471) 274481) inline$$WritebackToGlobal$1$anon3_Else_correct@@5)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon60$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 274541) 274471)) inline$$WritebackToGlobal$1$anon0_correct@@5)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@3  (and (=> (= (ControlFlow 0 274224) (- 0 473048)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 274224) 274541) inline$$Diem_mint_with_capability_$def_verify$0$anon60$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@3  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$3$$after@0@@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@5|)) (= (ControlFlow 0 274176) 274224)) inline$$Diem_CurrencyInfo_$pack_ref$3$anon0_correct@@3)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@5  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@5 inline$$WritebackToReference$1$srcPath@1@@5))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@5| |inline$$WritebackToReference$0$dst'@2@@6|) (= (ControlFlow 0 274045) 274176)) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@3))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@5  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@5 inline$$WritebackToReference$1$srcPath@1@@5)) (= |inline$$WritebackToReference$1$dst'@1@@5| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) inline$$WritebackToReference$1$dstPath@1@@5 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@5 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@5) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@5|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@5| |inline$$WritebackToReference$1$dst'@1@@5|) (= (ControlFlow 0 274101) 274176))) inline$$Diem_CurrencyInfo_$pack_ref$3$Entry_correct@@3)))
(let ((inline$$WritebackToReference$1$anon0_correct@@5  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@5 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@5|)) (= inline$$WritebackToReference$1$dstPath@1@@5 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) (and (=> (= (ControlFlow 0 274009) 274101) inline$$WritebackToReference$1$anon3_Then_correct@@5) (=> (= (ControlFlow 0 274009) 274045) inline$$WritebackToReference$1$anon3_Else_correct@@5)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 273872) 274009)) inline$$WritebackToReference$1$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon92_Then_correct  (=> (and (= inline$$Diem_mint_with_capability_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (= (ControlFlow 0 274812) 274009)) inline$$WritebackToReference$1$anon0_correct@@5)))
(let ((inline$$WriteRef$1$anon0_correct@@5  (=> (= |inline$$WriteRef$1$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@5) (|p#$Mutation| inline$$BorrowField$5$dst@1@@5) inline$$ReadRef$4$v@1@@5)) (and (=> (= (ControlFlow 0 273858) 274812) inline$$Diem_mint_with_capability_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 273858) 273872) inline$$Diem_mint_with_capability_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon90_Else_correct  (=> (and (not $abort_flag@8@@4) (= (ControlFlow 0 273864) 273858)) inline$$WriteRef$1$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else$2_correct  (and (=> (= (ControlFlow 0 273136) (- 0 472404)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@2 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@3 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 273136) (- 0 472528)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 273136) (- 0 472581)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$dr_addr@@2))))))))))))))) (=> (and (= $Diem_CurrencyInfo_$memory@0@@6 |inline$$WritebackToGlobal$0$m'@2@@5|) (= (ControlFlow 0 273136) 273269)) inline$$Diem_Diem_pack$0$anon0_correct@@0)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@5  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@5)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@5| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 272815) 273136)) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@5  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@5) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@5 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@5)) (= inline$$WritebackToGlobal$0$a@1@@5 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@5))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@5 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@5 inline$$WritebackToGlobal$0$a@1@@5) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) (= |inline$$WritebackToGlobal$0$m'@1@@5| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@5 inline$$WritebackToGlobal$0$a@1@@5 inline$$WritebackToGlobal$0$v@1@@5)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@5| |inline$$WritebackToGlobal$0$m'@1@@5|) (= (ControlFlow 0 272869) 273136))) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@5  (=> (= inline$$WritebackToGlobal$0$l@1@@5 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (and (=> (= (ControlFlow 0 272805) 272869) inline$$WritebackToGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 272805) 272815) inline$$WritebackToGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_mint_with_capability_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner1@@4 inline$$Diem_mint_with_capability_$def_verify$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 272875) 272805)) inline$$WritebackToGlobal$0$anon0_correct@@5)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@5  (and (=> (= (ControlFlow 0 272558) (- 0 472122)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 272558) 272875) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@5  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@5 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (= (ControlFlow 0 272510) 272558)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@7)) (= (ControlFlow 0 272562) 272510)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct  (=> (and (= inline$$Diem_mint_with_capability_$def_verify$0$$ret0@1 $Error) (= inline$$Diem_mint_with_capability_$def_verify$0$$ret0@2 inline$$Diem_mint_with_capability_$def_verify$0$$ret0@1)) (=> (and (and (= $abort_code@13@@4 $abort_code@12@@4) (= $abort_flag@9@@4 true)) (and (= $Diem_CurrencyInfo_$memory@1@@6 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 270434) 275050))) anon0$2_correct@@22))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon7_correct  (=> (and (= $abort_code@12@@4 $abort_code@1@@18) (= (ControlFlow 0 275018) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 275016) 275018)) inline$$Diem_mint_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon66_Then_correct  (=> (= (ControlFlow 0 275026) 275018) inline$$Diem_mint_with_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon65_Then_correct  (=> $abort_flag@0@@21 (and (=> (= (ControlFlow 0 275010) 275026) inline$$Diem_mint_with_capability_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 275010) 275016) inline$$Diem_mint_with_capability_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon11_correct  (=> (and (= $abort_code@12@@4 $abort_code@2@@13) (= (ControlFlow 0 274998) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 274996) 274998)) inline$$Diem_mint_with_capability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 275006) 274998) inline$$Diem_mint_with_capability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon67_Then_correct  (=> $abort_flag@1@@20 (and (=> (= (ControlFlow 0 274990) 275006) inline$$Diem_mint_with_capability_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 274990) 274996) inline$$Diem_mint_with_capability_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon17_correct  (=> (and (= $abort_code@12@@4 $abort_code@3@@14) (= (ControlFlow 0 274974) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 274972) 274974)) inline$$Diem_mint_with_capability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 274982) 274974) inline$$Diem_mint_with_capability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon70_Then_correct  (=> $abort_flag@2@@17 (and (=> (= (ControlFlow 0 274966) 274982) inline$$Diem_mint_with_capability_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 274966) 274972) inline$$Diem_mint_with_capability_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon21_correct  (=> (and (= $abort_code@12@@4 $abort_code@4@@13) (= (ControlFlow 0 274954) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 274952) 274954)) inline$$Diem_mint_with_capability_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 274962) 274954) inline$$Diem_mint_with_capability_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon72_Then_correct  (=> $abort_flag@3@@12 (and (=> (= (ControlFlow 0 274946) 274962) inline$$Diem_mint_with_capability_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 274946) 274952) inline$$Diem_mint_with_capability_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon29_correct  (=> (and (= $abort_code@12@@4 $abort_code@6@@9) (= (ControlFlow 0 274934) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 274932) 274934)) inline$$Diem_mint_with_capability_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 274942) 274934) inline$$Diem_mint_with_capability_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon76_Then_correct  (=> $abort_flag@4@@10 (and (=> (= (ControlFlow 0 274926) 274942) inline$$Diem_mint_with_capability_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 274926) 274932) inline$$Diem_mint_with_capability_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon33_correct  (=> (and (= $abort_code@12@@4 $abort_code@7@@8) (= (ControlFlow 0 274914) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 274912) 274914)) inline$$Diem_mint_with_capability_$def_verify$0$anon33_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon79_Then_correct  (=> (= (ControlFlow 0 274922) 274914) inline$$Diem_mint_with_capability_$def_verify$0$anon33_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon78_Then_correct  (=> $abort_flag@5@@7 (and (=> (= (ControlFlow 0 274906) 274922) inline$$Diem_mint_with_capability_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 274906) 274912) inline$$Diem_mint_with_capability_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon37_correct  (=> (and (= $abort_code@12@@4 $abort_code@8@@6) (= (ControlFlow 0 274894) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 274892) 274894)) inline$$Diem_mint_with_capability_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 274902) 274894) inline$$Diem_mint_with_capability_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon80_Then_correct  (=> $abort_flag@6@@7 (and (=> (= (ControlFlow 0 274886) 274902) inline$$Diem_mint_with_capability_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 274886) 274892) inline$$Diem_mint_with_capability_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon45_correct  (=> (and (= $abort_code@12@@4 $abort_code@10@@5) (= (ControlFlow 0 274874) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 274872) 274874)) inline$$Diem_mint_with_capability_$def_verify$0$anon45_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon85_Then_correct  (=> (= (ControlFlow 0 274882) 274874) inline$$Diem_mint_with_capability_$def_verify$0$anon45_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon84_Then_correct  (=> $abort_flag@7@@5 (and (=> (= (ControlFlow 0 274866) 274882) inline$$Diem_mint_with_capability_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 274866) 274872) inline$$Diem_mint_with_capability_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon49_correct  (=> (and (= $abort_code@12@@4 $abort_code@11@@5) (= (ControlFlow 0 274854) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 274852) 274854)) inline$$Diem_mint_with_capability_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 274862) 274854) inline$$Diem_mint_with_capability_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon86_Then_correct  (=> $abort_flag@8@@4 (and (=> (= (ControlFlow 0 274846) 274862) inline$$Diem_mint_with_capability_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 274846) 274852) inline$$Diem_mint_with_capability_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon57_correct  (=> (and (= $abort_code@12@@4 $abort_code@11@@5) (= (ControlFlow 0 274824) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 274822) 274824)) inline$$Diem_mint_with_capability_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 274832) 274824) inline$$Diem_mint_with_capability_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon90_Then_correct  (=> $abort_flag@8@@4 (and (=> (= (ControlFlow 0 274816) 274832) inline$$Diem_mint_with_capability_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 274816) 274822) inline$$Diem_mint_with_capability_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@5  (=> (= inline$$Event_emit_event$0$t@0@@5 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 273789) 274816) inline$$Diem_mint_with_capability_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 273789) 273864) inline$$Diem_mint_with_capability_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 273799) (- 0 472851)) true) (=> (= (ControlFlow 0 273799) 273789) inline$$Event_emit_event$0$Entry_correct@@5))))
(let ((inline$$ReadRef$4$anon0_correct@@5  (=> (and (= inline$$ReadRef$4$v@1@@5 (|v#$Mutation| inline$$BorrowField$5$dst@1@@5)) (= (ControlFlow 0 273741) 273799)) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Then$3_correct)))
(let ((inline$$Diem_MintEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 273697) 273741)) inline$$ReadRef$4$anon0_correct@@5)))
(let ((inline$$Diem_MintEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 273703) 273741) inline$$ReadRef$4$anon0_correct@@5)))
(let ((inline$$Diem_MintEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 273691) 273703) inline$$Diem_MintEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 273691) 273697) inline$$Diem_MintEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_MintEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 273683) 273741)) inline$$ReadRef$4$anon0_correct@@5)))
(let ((inline$$Diem_MintEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) value@@0) (>= (|i#$Integer| value@@0) 0)) (<= (|i#$Integer| value@@0) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@37) (let ((va@@341 (|v#$Vector| call3formal@$ret0@0@@37)))
(let ((l@@341 (|l#$ValueArray| va@@341)))
 (and (and (<= 0 l@@341) (<= l@@341 $MAX_U64)) (forall ((x@@341 Int) ) (!  (=> (or (< x@@341 0) (>= x@@341 l@@341)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@341) x@@341) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@341) x@@341))
)))))) (forall ((inline$$Diem_MintEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_MintEvent_pack$0$$$0 0) (< inline$$Diem_MintEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) inline$$Diem_MintEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) inline$$Diem_MintEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) inline$$Diem_MintEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) inline$$Diem_MintEvent_pack$0$$$0))
))) (= inline$$Diem_MintEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 value@@0) 1 call3formal@$ret0@0@@37) 2)))) (and (=> (= (ControlFlow 0 273675) 273691) inline$$Diem_MintEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 273675) 273683) inline$$Diem_MintEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$5$anon0_correct@@5  (=> (= inline$$BorrowField$5$p@1@@5 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (=> (and (and (= inline$$BorrowField$5$size@1@@5 (|size#$Path| inline$$BorrowField$5$p@1@@5)) (= inline$$BorrowField$5$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@5) inline$$BorrowField$5$size@1@@5 $Diem_CurrencyInfo_mint_events) (+ inline$$BorrowField$5$size@1@@5 1)))) (and (= inline$$BorrowField$5$dst@1@@5 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) inline$$BorrowField$5$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) $Diem_CurrencyInfo_mint_events))) (= (ControlFlow 0 273445) 273675))) inline$$Diem_MintEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@7) (= (ControlFlow 0 273451) 273445)) inline$$BorrowField$5$anon0_correct@@5)))
(let ((inline$$Not$0$anon0_correct@@7  (=> (= inline$$Not$0$dst@1@@7 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$3$v@1@@5)))) (and (=> (= (ControlFlow 0 272427) 273451) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 272427) 272562) inline$$Diem_mint_with_capability_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@7  (and (=> (= (ControlFlow 0 272417) (- 0 472083)) true) (=> (= (ControlFlow 0 272417) 272427) inline$$Not$0$anon0_correct@@7))))
(let ((inline$$ReadRef$3$anon0_correct@@5  (=> (and (= inline$$ReadRef$3$v@1@@5 (|v#$Mutation| inline$$BorrowField$4$dst@1@@5)) (= (ControlFlow 0 272369) 272417)) inline$$Not$0$Entry_correct@@7)))
(let ((inline$$BorrowField$4$anon0_correct@@5  (=> (= inline$$BorrowField$4$p@1@@5 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|)) (=> (and (and (= inline$$BorrowField$4$size@1@@5 (|size#$Path| inline$$BorrowField$4$p@1@@5)) (= inline$$BorrowField$4$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@5) inline$$BorrowField$4$size@1@@5 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$4$size@1@@5 1)))) (and (= inline$$BorrowField$4$dst@1@@5 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|) inline$$BorrowField$4$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@6|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 272331) 272369))) inline$$ReadRef$3$anon0_correct@@5))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@6  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@6| inline$$BorrowGlobal$0$dst@2@@5) (= (ControlFlow 0 272115) 272331)) inline$$BorrowField$4$anon0_correct@@5))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@6  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@6 inline$$WritebackToReference$0$srcPath@1@@6)) (= |inline$$WritebackToReference$0$dst'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$WritebackToReference$0$dstPath@1@@6 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@6 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@6) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@7|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@6| |inline$$WritebackToReference$0$dst'@1@@6|) (= (ControlFlow 0 272171) 272331))) inline$$BorrowField$4$anon0_correct@@5)))
(let ((inline$$WritebackToReference$0$anon0_correct@@6  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@6 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@7|)) (= inline$$WritebackToReference$0$dstPath@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) (and (=> (= (ControlFlow 0 272079) 272171) inline$$WritebackToReference$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 272079) 272115) inline$$WritebackToReference$0$anon3_Else_correct@@6)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 271942) 272079)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon88_Then_correct  (=> (and (= inline$$Diem_mint_with_capability_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (= (ControlFlow 0 274842) 272079)) inline$$WritebackToReference$0$anon0_correct@@6)))
(let ((inline$$WriteRef$0$anon0_correct@@7  (=> (= |inline$$WriteRef$0$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@5) (|p#$Mutation| inline$$BorrowField$3$dst@1@@5) inline$$AddU128$0$dst@2)) (and (=> (= (ControlFlow 0 271928) 274842) inline$$Diem_mint_with_capability_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 271928) 271942) inline$$Diem_mint_with_capability_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@5  (=> (= inline$$BorrowField$3$p@1@@5 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$3$size@1@@5 (|size#$Path| inline$$BorrowField$3$p@1@@5)) (= inline$$BorrowField$3$p@2@@5 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@5) inline$$BorrowField$3$size@1@@5 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$3$size@1@@5 1)))) (and (= inline$$BorrowField$3$dst@1@@5 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$3$p@2@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 271869) 271928))) inline$$WriteRef$0$anon0_correct@@7))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon86_Else_correct  (=> (and (not $abort_flag@8@@4) (= (ControlFlow 0 271875) 271869)) inline$$BorrowField$3$anon0_correct@@5)))
(let ((inline$$AddU128$0$anon3_Then$1_correct  (=> (= $abort_flag@8@@4 true) (=> (and (= $abort_code@11@@5 $EXEC_FAILURE_CODE) (= inline$$AddU128$0$dst@2 inline$$AddU128$0$dst@0)) (and (=> (= (ControlFlow 0 271739) 274846) inline$$Diem_mint_with_capability_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 271739) 271875) inline$$Diem_mint_with_capability_$def_verify$0$anon86_Else_correct))))))
(let ((inline$$AddU128$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$2$v@1@@5) (|i#$Integer| inline$$CastU128$1$dst@1@@3)) $MAX_U128) (= (ControlFlow 0 271737) 271739)) inline$$AddU128$0$anon3_Then$1_correct)))
(let ((inline$$AddU128$0$anon3_Else_correct  (=> (>= $MAX_U128 (+ (|i#$Integer| inline$$ReadRef$2$v@1@@5) (|i#$Integer| inline$$CastU128$1$dst@1@@3))) (=> (and (and (= inline$$AddU128$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$2$v@1@@5) (|i#$Integer| inline$$CastU128$1$dst@1@@3)))) (= $abort_flag@8@@4 $abort_flag@7@@5)) (and (= $abort_code@11@@5 $abort_code@10@@5) (= inline$$AddU128$0$dst@2 inline$$AddU128$0$dst@1))) (and (=> (= (ControlFlow 0 271681) 274846) inline$$Diem_mint_with_capability_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 271681) 271875) inline$$Diem_mint_with_capability_$def_verify$0$anon86_Else_correct))))))
(let ((inline$$AddU128$0$Entry_correct  (and (=> (= (ControlFlow 0 271651) (- 0 471657)) true) (and (=> (= (ControlFlow 0 271651) 271737) inline$$AddU128$0$anon3_Then_correct) (=> (= (ControlFlow 0 271651) 271681) inline$$AddU128$0$anon3_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon84_Else_correct  (=> (and (not $abort_flag@7@@5) (= (ControlFlow 0 271745) 271651)) inline$$AddU128$0$Entry_correct)))
(let ((inline$$CastU128$1$anon3_Then$1_correct@@3  (=> (= $abort_code@10@@5 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7@@5 true) (= inline$$CastU128$1$dst@1@@3 inline$$CastU128$1$dst@0@@3)) (and (=> (= (ControlFlow 0 271546) 274866) inline$$Diem_mint_with_capability_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 271546) 271745) inline$$Diem_mint_with_capability_$def_verify$0$anon84_Else_correct))))))
(let ((inline$$CastU128$1$anon3_Then_correct@@3  (=> (and (> (|i#$Integer| value@@0) $MAX_U128) (= (ControlFlow 0 271544) 271546)) inline$$CastU128$1$anon3_Then$1_correct@@3)))
(let ((inline$$CastU128$1$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U128 (|i#$Integer| value@@0)) (= $abort_code@10@@5 $abort_code@8@@6)) (and (= $abort_flag@7@@5 $abort_flag@6@@7) (= inline$$CastU128$1$dst@1@@3 value@@0))) (and (=> (= (ControlFlow 0 271494) 274866) inline$$Diem_mint_with_capability_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 271494) 271745) inline$$Diem_mint_with_capability_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$CastU128$1$Entry_correct@@3  (and (=> (= (ControlFlow 0 271480) (- 0 471585)) true) (and (=> (= (ControlFlow 0 271480) 271544) inline$$CastU128$1$anon3_Then_correct@@3) (=> (= (ControlFlow 0 271480) 271494) inline$$CastU128$1$anon3_Else_correct@@3)))))
(let ((inline$$ReadRef$2$anon0_correct@@5  (=> (and (= inline$$ReadRef$2$v@1@@5 (|v#$Mutation| inline$$BorrowField$2$dst@1@@6)) (= (ControlFlow 0 271399) 271480)) inline$$CastU128$1$Entry_correct@@3)))
(let ((inline$$BorrowField$2$anon0_correct@@6  (=> (= inline$$BorrowField$2$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$2$size@1@@6 (|size#$Path| inline$$BorrowField$2$p@1@@6)) (= inline$$BorrowField$2$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@6) inline$$BorrowField$2$size@1@@6 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$2$size@1@@6 1)))) (and (= inline$$BorrowField$2$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$2$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 271361) 271399))) inline$$ReadRef$2$anon0_correct@@5))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon82_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@6) (= (ControlFlow 0 271413) 271361)) inline$$BorrowField$2$anon0_correct@@6)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon42_correct  (=> (and (= $abort_code@12@@4 $abort_code@9@@6) (= (ControlFlow 0 271195) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 271193) 271195)) inline$$Diem_mint_with_capability_$def_verify$0$anon42_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 271203) 271195) inline$$Diem_mint_with_capability_$def_verify$0$anon42_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon82_Else$1_correct  (=> (= $abort_code@9@@6 (|i#$Integer| call3formal@$ret0@0@@38)) (and (=> (= (ControlFlow 0 271187) 271203) inline$$Diem_mint_with_capability_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 271187) 271193) inline$$Diem_mint_with_capability_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@5  (and (=> (= (ControlFlow 0 271177) (- 0 471419)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 271177) 271187) inline$$Diem_mint_with_capability_$def_verify$0$anon82_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@5  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@5 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (= (ControlFlow 0 271129) 271177)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon82_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@6)) (= (ControlFlow 0 271181) 271129)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon80_Else_correct  (=> (not $abort_flag@6@@7) (and (=> (= (ControlFlow 0 271054) 271413) inline$$Diem_mint_with_capability_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 271054) 271181) inline$$Diem_mint_with_capability_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon78_Else$1_correct  (=> (and (and (and (= inline$$Diem_mint_with_capability_$def_verify$0$$t18@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@7)) (and (=> $abort_flag@6@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@6@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@38 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@38) (>= (|i#$Integer| call3formal@$ret0@0@@38) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@38) $MAX_U64))) (and (=> (= (ControlFlow 0 271048) 274886) inline$$Diem_mint_with_capability_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 271048) 271054) inline$$Diem_mint_with_capability_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@6  (=> (and (= inline$$Ge$0$dst@1@@6 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2@@6) (|i#$Integer| inline$$CastU128$0$dst@1@@3)))) (= (ControlFlow 0 271036) 271048)) inline$$Diem_mint_with_capability_$def_verify$0$anon78_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct@@6  (and (=> (= (ControlFlow 0 271022) (- 0 471309)) true) (=> (= (ControlFlow 0 271022) 271036) inline$$Ge$0$anon0_correct@@6))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon78_Else_correct  (=> (and (not $abort_flag@5@@7) (= (ControlFlow 0 271042) 271022)) inline$$Ge$0$Entry_correct@@6)))
(let ((inline$$CastU128$0$anon3_Then$1_correct@@3  (=> (= $abort_flag@5@@7 true) (=> (and (= $abort_code@7@@8 $EXEC_FAILURE_CODE) (= inline$$CastU128$0$dst@1@@3 inline$$CastU128$0$dst@0@@3)) (and (=> (= (ControlFlow 0 270966) 274906) inline$$Diem_mint_with_capability_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 270966) 271042) inline$$Diem_mint_with_capability_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$CastU128$0$anon3_Then_correct@@3  (=> (and (> (|i#$Integer| value@@0) $MAX_U128) (= (ControlFlow 0 270964) 270966)) inline$$CastU128$0$anon3_Then$1_correct@@3)))
(let ((inline$$CastU128$0$anon3_Else_correct@@3  (=> (and (and (>= $MAX_U128 (|i#$Integer| value@@0)) (= $abort_flag@5@@7 $abort_flag@4@@10)) (and (= $abort_code@7@@8 $abort_code@6@@9) (= inline$$CastU128$0$dst@1@@3 value@@0))) (and (=> (= (ControlFlow 0 270914) 274906) inline$$Diem_mint_with_capability_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 270914) 271042) inline$$Diem_mint_with_capability_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$CastU128$0$Entry_correct@@3  (and (=> (= (ControlFlow 0 270900) (- 0 471237)) true) (and (=> (= (ControlFlow 0 270900) 270964) inline$$CastU128$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 270900) 270914) inline$$CastU128$0$anon3_Else_correct@@3)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon76_Else_correct  (=> (and (not $abort_flag@4@@10) (= (ControlFlow 0 270972) 270900)) inline$$CastU128$0$Entry_correct@@3)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@6  (=> (= $abort_code@6@@9 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@10 true) (= inline$$Sub$0$dst@2@@6 inline$$Sub$0$dst@0@@6)) (and (=> (= (ControlFlow 0 270821) 274926) inline$$Diem_mint_with_capability_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 270821) 270972) inline$$Diem_mint_with_capability_$def_verify$0$anon76_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@6  (=> (and (< (|i#$Integer| inline$$Diem_mint_with_capability_$def_verify$0$$t13@1) (|i#$Integer| inline$$ReadRef$1$v@1@@6)) (= (ControlFlow 0 270819) 270821)) inline$$Sub$0$anon3_Then$1_correct@@6)))
(let ((inline$$Sub$0$anon3_Else_correct@@6  (=> (<= (|i#$Integer| inline$$ReadRef$1$v@1@@6) (|i#$Integer| inline$$Diem_mint_with_capability_$def_verify$0$$t13@1)) (=> (and (and (= inline$$Sub$0$dst@1@@6 ($Integer (- (|i#$Integer| inline$$Diem_mint_with_capability_$def_verify$0$$t13@1) (|i#$Integer| inline$$ReadRef$1$v@1@@6)))) (= $abort_code@6@@9 $abort_code@4@@13)) (and (= $abort_flag@4@@10 $abort_flag@3@@12) (= inline$$Sub$0$dst@2@@6 inline$$Sub$0$dst@1@@6))) (and (=> (= (ControlFlow 0 270767) 274926) inline$$Diem_mint_with_capability_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 270767) 270972) inline$$Diem_mint_with_capability_$def_verify$0$anon76_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@6  (and (=> (= (ControlFlow 0 270741) (- 0 471151)) true) (and (=> (= (ControlFlow 0 270741) 270819) inline$$Sub$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 270741) 270767) inline$$Sub$0$anon3_Else_correct@@6)))))
(let ((inline$$ReadRef$1$anon0_correct@@6  (=> (and (= inline$$ReadRef$1$v@1@@6 (|v#$Mutation| inline$$BorrowField$1$dst@1@@6)) (= (ControlFlow 0 270642) 270741)) inline$$Sub$0$Entry_correct@@6)))
(let ((inline$$BorrowField$1$anon0_correct@@6  (=> (= inline$$BorrowField$1$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$1$size@1@@6 (|size#$Path| inline$$BorrowField$1$p@1@@6)) (= inline$$BorrowField$1$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@6) inline$$BorrowField$1$size@1@@6 $Diem_CurrencyInfo_total_value) (+ inline$$BorrowField$1$size@1@@6 1)))) (and (= inline$$BorrowField$1$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$1$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $Diem_CurrencyInfo_total_value))) (= (ControlFlow 0 270604) 270642))) inline$$ReadRef$1$anon0_correct@@6))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon74_Then_correct  (=> (|b#$Boolean| inline$$ReadRef$0$v@1@@7) (=> (and (= inline$$Diem_mint_with_capability_$def_verify$0$$t13@1 ($Integer 340282366920938463463374607431768211455)) (= (ControlFlow 0 270656) 270604)) inline$$BorrowField$1$anon0_correct@@6))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon26_correct  (=> (and (= $abort_code@12@@4 $abort_code@5@@10) (= (ControlFlow 0 270428) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon75_Else_correct  (=> (and (not true) (= (ControlFlow 0 270426) 270428)) inline$$Diem_mint_with_capability_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon75_Then_correct  (=> (= (ControlFlow 0 270442) 270428) inline$$Diem_mint_with_capability_$def_verify$0$anon26_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon74_Else$1_correct  (=> (= $abort_code@5@@10 (|i#$Integer| call3formal@$ret0@0@@39)) (and (=> (= (ControlFlow 0 270420) 270442) inline$$Diem_mint_with_capability_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 270420) 270426) inline$$Diem_mint_with_capability_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@5  (and (=> (= (ControlFlow 0 270410) (- 0 470983)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 270410) 270420) inline$$Diem_mint_with_capability_$def_verify$0$anon74_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@5  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@5 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (= (ControlFlow 0 270362) 270410)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon74_Else_correct  (=> (and (not (|b#$Boolean| inline$$ReadRef$0$v@1@@7)) (= (ControlFlow 0 270414) 270362)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon72_Else_correct  (=> (not $abort_flag@3@@12) (and (=> (= (ControlFlow 0 270287) 270656) inline$$Diem_mint_with_capability_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 270287) 270414) inline$$Diem_mint_with_capability_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon70_Else$2_correct  (=> (and (and (and (= inline$$Diem_mint_with_capability_$def_verify$0$$t11@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@12)) (and (=> $abort_flag@3@@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@39 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@39) (>= (|i#$Integer| call3formal@$ret0@0@@39) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@39) $MAX_U64))) (and (=> (= (ControlFlow 0 270281) 274946) inline$$Diem_mint_with_capability_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 270281) 270287) inline$$Diem_mint_with_capability_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$ReadRef$0$anon0_correct@@7  (=> (and (= inline$$ReadRef$0$v@1@@7 (|v#$Mutation| inline$$BorrowField$0$dst@1@@6)) (= (ControlFlow 0 270261) 270281)) inline$$Diem_mint_with_capability_$def_verify$0$anon70_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@6  (=> (= inline$$BorrowField$0$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (=> (and (and (= inline$$BorrowField$0$size@1@@6 (|size#$Path| inline$$BorrowField$0$p@1@@6)) (= inline$$BorrowField$0$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@6) inline$$BorrowField$0$size@1@@6 $Diem_CurrencyInfo_can_mint) (+ inline$$BorrowField$0$size@1@@6 1)))) (and (= inline$$BorrowField$0$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@5) inline$$BorrowField$0$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5))) $Diem_CurrencyInfo_can_mint))) (= (ControlFlow 0 270223) 270261))) inline$$ReadRef$0$anon0_correct@@7))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@5  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@5)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@5)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 270065) 270223)) inline$$BorrowField$0$anon0_correct@@6)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@5  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@5 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@5)) (= (ControlFlow 0 270059) 270065)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@5)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon70_Else_correct  (=> (and (not $abort_flag@2@@17) (= (ControlFlow 0 270069) 270059)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@5)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@5  (=> (= $abort_flag@2@@17 true) (=> (and (= $abort_code@3@@14 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@5 inline$$BorrowGlobal$0$dst@0@@5)) (and (=> (= (ControlFlow 0 270019) 274966) inline$$Diem_mint_with_capability_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 270019) 270069) inline$$Diem_mint_with_capability_$def_verify$0$anon70_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@5  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@5 inline$$BorrowGlobal$0$a@1@@5)) (= (ControlFlow 0 270017) 270019)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@5)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@5  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@5 inline$$BorrowGlobal$0$a@1@@5) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@5 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@5 inline$$BorrowGlobal$0$a@1@@5) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@5 inline$$BorrowGlobal$0$a@1@@5))) (= $abort_flag@2@@17 $abort_flag@1@@20)) (and (= $abort_code@3@@14 $abort_code@2@@13) (= inline$$BorrowGlobal$0$dst@2@@5 inline$$BorrowGlobal$0$dst@1@@5))) (and (=> (= (ControlFlow 0 269965) 274966) inline$$Diem_mint_with_capability_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 269965) 270069) inline$$Diem_mint_with_capability_$def_verify$0$anon70_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@5  (=> (= inline$$BorrowGlobal$0$a@1@@5 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@14)) (and (=> (= (ControlFlow 0 269935) 270017) inline$$BorrowGlobal$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 269935) 269965) inline$$BorrowGlobal$0$anon3_Else_correct@@5)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@5  (=> (= inline$$BorrowGlobal$0$ta@0@@5 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1)) (and (=> (= (ControlFlow 0 269929) (- 0 470675)) true) (=> (= (ControlFlow 0 269929) 269935) inline$$BorrowGlobal$0$anon0_correct@@5)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@1@@20) (and (=> (= (ControlFlow 0 270025) (- 0 470632)) (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_with_capability_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@14))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_mint_with_capability_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@14)) (=> (= (ControlFlow 0 270025) 269929) inline$$BorrowGlobal$0$Entry_correct@@5))))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon69_Then_correct  (=> $abort_flag@1@@20 (=> (and (= $abort_code@12@@4 $abort_code@2@@13) (= (ControlFlow 0 274986) 270434)) inline$$Diem_mint_with_capability_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@14  (=> (not true) (and (=> (= (ControlFlow 0 269764) 274986) inline$$Diem_mint_with_capability_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 269764) 270025) inline$$Diem_mint_with_capability_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@14  (and (=> (= (ControlFlow 0 269774) 274986) inline$$Diem_mint_with_capability_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 269774) 270025) inline$$Diem_mint_with_capability_$def_verify$0$anon69_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@14  (=> (and (not $abort_flag@1@@20) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@14 ($Address 173345816))) (and (=> (= (ControlFlow 0 269758) 269774) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@14) (=> (= (ControlFlow 0 269758) 269764) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@14)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon67_Else_correct  (=> (and (not $abort_flag@1@@20) (= (ControlFlow 0 269788) 269758)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@14)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon65_Else_correct  (=> (and (and (not $abort_flag@0@@21) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@20)) (and (=> $abort_flag@1@@20 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@1@@20 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@13 (|i#$Integer| ($Integer 5))))))) (=> (and (and (and (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@37 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@356 T@$Value) )  (=> ((_ is $Address) addr@@356) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@356))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@356))))))))))))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@357 T@$Value) )  (=> ((_ is $Address) addr@@357) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@357)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@357)))))))))))))) (and (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@358 T@$Value) )  (=> ((_ is $Address) addr@@358) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@358))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@358)))))))))))))))) (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@359 T@$Value) )  (=> ((_ is $Address) addr@@359) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@359)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@359)))))))))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))))) (and (and (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@360 T@$Value) )  (=> ((_ is $Address) addr@@360) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@360))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@360)))))))))))))))) (and (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean (forall ((addr@@361 T@$Value) )  (=> ((_ is $Address) addr@@361) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@361)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@361)))))))))))) (=> (not $abort_flag@1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@37) (let ((va@@342 (|v#$Vector| call3formal@$ret0@0@@37)))
(let ((l@@342 (|l#$ValueArray| va@@342)))
 (and (and (<= 0 l@@342) (<= l@@342 $MAX_U64)) (forall ((x@@342 Int) ) (!  (=> (or (< x@@342 0) (>= x@@342 l@@342)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@342) x@@342) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@342) x@@342))
)))))) (forall (($$0@@114 Int) ) (!  (=> (and (>= $$0@@114 0) (< $$0@@114 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) $$0@@114)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) $$0@@114)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) $$0@@114)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@37)) $$0@@114))
))))) (and (=> (= (ControlFlow 0 269653) 274990) inline$$Diem_mint_with_capability_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 269653) 269788) inline$$Diem_mint_with_capability_$def_verify$0$anon67_Else_correct))))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon4$1_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@21) (=> $abort_flag@0@@21 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@21 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@18 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@362 T@$Value) )  (=> ((_ is $Address) addr@@362) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@362))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@362))))))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@363 T@$Value) )  (=> ((_ is $Address) addr@@363) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@363)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@363)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@364 T@$Value) )  (=> ((_ is $Address) addr@@364) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@364))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@364)))))))))))))))) (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@365 T@$Value) )  (=> ((_ is $Address) addr@@365) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@365)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@365)))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@366 T@$Value) )  (=> ((_ is $Address) addr@@366) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@366))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@366)))))))))))))))) (and (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean (forall ((addr@@367 T@$Value) )  (=> ((_ is $Address) addr@@367) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@367)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| addr@@367)))))))))))) (=> (not $abort_flag@0@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 269647) 275010) inline$$Diem_mint_with_capability_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 269647) 269653) inline$$Diem_mint_with_capability_$def_verify$0$anon65_Else_correct)))))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon4_correct  (=> (and (= inline$$Diem_mint_with_capability_$def_verify$0$$Diem_CurrencyInfo_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 269645) 269647)) inline$$Diem_mint_with_capability_$def_verify$0$anon4$1_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon64_Else_correct  (=> (and (not true) (= (ControlFlow 0 269585) 269645)) inline$$Diem_mint_with_capability_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon64_Then_correct  (=> (= (ControlFlow 0 275034) 269645) inline$$Diem_mint_with_capability_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 269577) 275034) inline$$Diem_mint_with_capability_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 269577) 269585) inline$$Diem_mint_with_capability_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 275042) 275034) inline$$Diem_mint_with_capability_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 275042) 269585) inline$$Diem_mint_with_capability_$def_verify$0$anon64_Else_correct))))
(let ((inline$$Diem_mint_with_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 269571) 275042) inline$$Diem_mint_with_capability_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 269571) 269577) inline$$Diem_mint_with_capability_$def_verify$0$anon63_Else_correct)))))
(let ((anon0$1_correct@@21  (=> (forall (($inv_addr@@43 Int) ($inv_tv0@@38 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43)) (let ((va@@343 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))))
(let ((l@@343 (|l#$ValueArray| va@@343)))
 (and (and (<= 0 l@@343) (<= l@@343 $MAX_U64)) (forall ((x@@343 Int) ) (!  (=> (or (< x@@343 0) (>= x@@343 l@@343)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@343) x@@343) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@343) x@@343))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@344 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@344 (|l#$ValueArray| va@@344)))
 (and (and (<= 0 l@@344) (<= l@@344 $MAX_U64)) (forall ((x@@344 Int) ) (!  (=> (or (< x@@344 0) (>= x@@344 l@@344)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@344) x@@344) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@344) x@@344))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code)) (let ((va@@345 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@345 (|l#$ValueArray| va@@345)))
 (and (and (<= 0 l@@345) (<= l@@345 $MAX_U64)) (forall ((x@@345 Int) ) (!  (=> (or (< x@@345 0) (>= x@@345 l@@345)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@345) x@@345) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@345) x@@345))
))))))) (forall (($$0@@115 Int) ) (!  (=> (and (>= $$0@@115 0) (< $$0@@115 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))) $$0@@115)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))) $$0@@115)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))) $$0@@115)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_currency_code))) $$0@@115))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events)) (let ((va@@346 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@346 (|l#$ValueArray| va@@346)))
 (and (and (<= 0 l@@346) (<= l@@346 $MAX_U64)) (forall ((x@@346 Int) ) (!  (=> (or (< x@@346 0) (>= x@@346 l@@346)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@346) x@@346) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@346) x@@346))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@347 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@347 (|l#$ValueArray| va@@347)))
 (and (and (<= 0 l@@347) (<= l@@347 $MAX_U64)) (forall ((x@@347 Int) ) (!  (=> (or (< x@@347 0) (>= x@@347 l@@347)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@347) x@@347) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@347) x@@347))
))))))) (forall (($$0@@116 Int) ) (!  (=> (and (>= $$0@@116 0) (< $$0@@116 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@116)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@116)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@116)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@116))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events)) (let ((va@@348 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@348 (|l#$ValueArray| va@@348)))
 (and (and (<= 0 l@@348) (<= l@@348 $MAX_U64)) (forall ((x@@348 Int) ) (!  (=> (or (< x@@348 0) (>= x@@348 l@@348)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@348) x@@348) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@348) x@@348))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@349 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@349 (|l#$ValueArray| va@@349)))
 (and (and (<= 0 l@@349) (<= l@@349 $MAX_U64)) (forall ((x@@349 Int) ) (!  (=> (or (< x@@349 0) (>= x@@349 l@@349)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@349) x@@349) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@349) x@@349))
))))))) (forall (($$0@@117 Int) ) (!  (=> (and (>= $$0@@117 0) (< $$0@@117 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@117)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@117)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@117)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@117))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@350 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@350 (|l#$ValueArray| va@@350)))
 (and (and (<= 0 l@@350) (<= l@@350 $MAX_U64)) (forall ((x@@350 Int) ) (!  (=> (or (< x@@350 0) (>= x@@350 l@@350)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@350) x@@350) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@350) x@@350))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@351 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@351 (|l#$ValueArray| va@@351)))
 (and (and (<= 0 l@@351) (<= l@@351 $MAX_U64)) (forall ((x@@351 Int) ) (!  (=> (or (< x@@351 0) (>= x@@351 l@@351)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@351) x@@351) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@351) x@@351))
))))))) (forall (($$0@@118 Int) ) (!  (=> (and (>= $$0@@118 0) (< $$0@@118 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@118)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@118)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@118)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@118))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@352 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@352 (|l#$ValueArray| va@@352)))
 (and (and (<= 0 l@@352) (<= l@@352 $MAX_U64)) (forall ((x@@352 Int) ) (!  (=> (or (< x@@352 0) (>= x@@352 l@@352)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@352) x@@352) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@352) x@@352))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@353 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@353 (|l#$ValueArray| va@@353)))
 (and (and (<= 0 l@@353) (<= l@@353 $MAX_U64)) (forall ((x@@353 Int) ) (!  (=> (or (< x@@353 0) (>= x@@353 l@@353)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@353) x@@353) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@353) x@@353))
))))))) (forall (($$0@@119 Int) ) (!  (=> (and (>= $$0@@119 0) (< $$0@@119 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@119)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@119)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@119)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@119))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@354 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@354 (|l#$ValueArray| va@@354)))
 (and (and (<= 0 l@@354) (<= l@@354 $MAX_U64)) (forall ((x@@354 Int) ) (!  (=> (or (< x@@354 0) (>= x@@354 l@@354)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@354) x@@354) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@354) x@@354))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@355 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@355 (|l#$ValueArray| va@@355)))
 (and (and (<= 0 l@@355) (<= l@@355 $MAX_U64)) (forall ((x@@355 Int) ) (!  (=> (or (< x@@355 0) (>= x@@355 l@@355)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@355) x@@355) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@355) x@@355))
))))))) (forall (($$0@@120 Int) ) (!  (=> (and (>= $$0@@120 0) (< $$0@@120 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@120)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@120)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@120)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@120))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@38) 1) $inv_addr@@43))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@32 T@$Value) )  (=> ((_ is $Type) coin_type@@32) (|b#$Boolean| ($Boolean (forall ((addr3@@17 T@$Value) )  (=> ((_ is $Address) addr3@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@32)) 1) (|a#$Address| addr3@@17)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@32)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@32)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 275048) 269571)) inline$$Diem_mint_with_capability_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@22  (=> (and (and ((_ is $Integer) value@@0) (>= (|i#$Integer| value@@0) 0)) (<= (|i#$Integer| value@@0) $MAX_U64)) (=> (and (and (and (and (and ((_ is $Vector) _capability@@1) (let ((va@@356 (|v#$Vector| _capability@@1)))
(let ((l@@356 (|l#$ValueArray| va@@356)))
 (and (and (<= 0 l@@356) (<= l@@356 $MAX_U64)) (forall ((x@@356 Int) ) (!  (=> (or (< x@@356 0) (>= x@@356 l@@356)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@356) x@@356) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@356) x@@356))
)))))) (= (|l#$ValueArray| (|v#$Vector| _capability@@1)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| _capability@@1)) $Diem_MintCapability_dummy_field))) true) (= (ControlFlow 0 267597) 275048)) anon0$1_correct@@21))))
(let ((PreconditionGeneratedEntry_correct@@14  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Diem_CurrencyInfo_$CallerDomain@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@29) 1) (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 465468) 267597)) anon0_correct@@22)))
PreconditionGeneratedEntry_correct@@14)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@2 () T@$Value)
(declare-fun $abort_flag@12@@2 () Bool)
(declare-fun $tv0@@30 () T@$TypeValue)
(declare-fun coin@@4 () T@$Value)
(declare-fun $abort_code@18@@2 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@3@@3 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@0@@3 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@5| () T@$Memory)
(declare-fun $abort_flag@11@@4 () Bool)
(declare-fun $abort_code@16@@4 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@7 () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@5 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@5 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@5 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@5 () T@$Value)
(declare-fun |inline$$WriteRef$3$to'@1@@3| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@5| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@6 () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun $abort_code@17@@3 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2@@5 () T@$Memory)
(declare-fun $abort_code@1@@19 () Int)
(declare-fun $abort_flag@0@@22 () Bool)
(declare-fun $abort_code@2@@14 () Int)
(declare-fun $abort_flag@1@@21 () Bool)
(declare-fun $abort_code@3@@15 () Int)
(declare-fun $abort_flag@2@@18 () Bool)
(declare-fun $abort_code@5@@11 () Int)
(declare-fun $abort_flag@3@@13 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@4| () T@$Value)
(declare-fun $abort_flag@10@@4 () Bool)
(declare-fun $abort_code@14@@4 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@7 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@6| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@6 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@6 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@6 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@5| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@6| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@6| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@5| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@5 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@5 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@5| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3@@0 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@3 () T@$Mutation)
(declare-fun inline$$ReadRef$6$v@1@@3 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@6| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@6 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@6 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@6 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@6 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@6| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@8 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_code@15@@4 () Int)
(declare-fun $abort_code@6@@10 () Int)
(declare-fun $abort_flag@4@@11 () Bool)
(declare-fun $abort_code@8@@7 () Int)
(declare-fun $abort_flag@5@@8 () Bool)
(declare-fun $abort_code@9@@7 () Int)
(declare-fun $abort_flag@6@@8 () Bool)
(declare-fun $abort_code@10@@6 () Int)
(declare-fun $abort_flag@7@@6 () Bool)
(declare-fun $abort_code@11@@6 () Int)
(declare-fun $abort_flag@8@@5 () Bool)
(declare-fun $abort_code@12@@5 () Int)
(declare-fun $abort_flag@9@@5 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@6 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@14 () T@$Value)
(declare-fun call3formal@$ret0@0@@40 () T@$Value)
(declare-fun call3formal@$ret0@0@@41 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1@@3 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@3 () Int)
(declare-fun inline$$BorrowField$6$p@2@@3 () T@$Path)
(declare-fun inline$$ReadRef$5$v@1@@3 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@6 () Int)
(declare-fun inline$$BorrowField$5$p@2@@6 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@4 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@6| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@6 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@6 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@6| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@6 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@1 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@6 () Int)
(declare-fun inline$$BorrowField$4$p@2@@6 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$4$v@1@@6 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@6 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@6 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@6 () Int)
(declare-fun inline$$BorrowField$3$p@2@@6 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@7 () T@$Value)
(declare-fun $abort_code@13@@5 () Int)
(declare-fun call3formal@$ret0@0@@42 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t27@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@7 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@7 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t23@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@6 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@7 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@7 () Int)
(declare-fun inline$$BorrowField$2$p@2@@7 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@6 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@4 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0@@4 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@4 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@4 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@15 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@7| () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1@@8 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@5| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@5 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@8| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@7 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@7 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@7| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1@@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$info@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@7 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@6 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@7 () Int)
(declare-fun inline$$BorrowField$1$p@2@@7 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t17@1@@0 () T@$Value)
(declare-fun $abort_code@7@@9 () Int)
(declare-fun call3formal@$ret0@0@@43 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t16@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t18@1@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@7 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@7 () Int)
(declare-fun inline$$BorrowField$0$p@2@@7 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@6 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@6 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@6 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@6 () T@$Mutation)
(declare-fun inline$$Diem_preburn_to_$def_verify$0$$t7@1 () T@$Value)
(declare-fun $abort_code@4@@14 () Int)
(declare-fun call3formal@$ret0@0@@44 () T@$Value)
(declare-fun inline$$Diem_preburn_to_$def_verify$0$$t8@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 474859) (let ((anon0$2_correct@@23  (and (=> (= (ControlFlow 0 286132) (- 0 483219)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483240)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483269)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2))))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2))))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483303)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483333)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483373)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12@@2) (and (=> (= (ControlFlow 0 286132) (- 0 483389)) (=> $abort_flag@12@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@12@@2 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 483554)) (=> $abort_flag@12@@2 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@12@@2 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| account@@2)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18@@2 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 286132) (- 0 483785)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 286132) (- 0 483828)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 483874)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@368 T@$Value) )  (=> ((_ is $Address) addr@@368) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@368))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@368)))))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@369 T@$Value) )  (=> ((_ is $Address) addr@@369) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@369))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@369))))))))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 483954)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@370 T@$Value) )  (=> ((_ is $Address) addr@@370) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@370)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@370))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@371 T@$Value) )  (=> ((_ is $Address) addr@@371) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@371)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@371)))))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484022)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484068)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@372 T@$Value) )  (=> ((_ is $Address) addr@@372) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@372))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@372)))))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@373 T@$Value) )  (=> ((_ is $Address) addr@@373) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@373))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@373))))))))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484148)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@374 T@$Value) )  (=> ((_ is $Address) addr@@374) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@374)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@374))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@375 T@$Value) )  (=> ((_ is $Address) addr@@375) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@375)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@375)))))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484216)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484262)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@376 T@$Value) )  (=> ((_ is $Address) addr@@376) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@376))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@376)))))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@377 T@$Value) )  (=> ((_ is $Address) addr@@377) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@377))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@377))))))))))))))) (and (=> (= (ControlFlow 0 286132) (- 0 484340)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@378 T@$Value) )  (=> ((_ is $Address) addr@@378) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@378)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@378))))))))))))) (=> (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean (forall ((addr@@379 T@$Value) )  (=> ((_ is $Address) addr@@379) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@379)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@0@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| addr@@379)))))))))))) (=> (= (ControlFlow 0 286132) (- 0 484406)) (=> (not $abort_flag@12@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon39_Else$2_correct  (and (=> (= (ControlFlow 0 286026) (- 0 482947)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_to_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_to_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_to_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_to_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 286026) (- 0 483010)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_to_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_to_$def_verify$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_to_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_to_$def_verify$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_to_$def_verify$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$2$m'@2@@5|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_to_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_preburn_to_$def_verify$0$tc_addr@@0))))))))))))))) (=> (= $abort_flag@12@@2 $abort_flag@11@@4) (=> (and (and (= $abort_code@18@@2 $abort_code@16@@4) (= $Diem_CurrencyInfo_$memory@3@@3 $Diem_CurrencyInfo_$memory@1@@7)) (and (= $Diem_Preburn_$memory@0@@3 |inline$$WritebackToGlobal$2$m'@2@@5|) (= (ControlFlow 0 286026) 286132))) anon0$2_correct@@23))))))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@5  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@5)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@5| $Diem_Preburn_$memory) (= (ControlFlow 0 285820) 286026)) inline$$Diem_preburn_to_$def_verify$0$anon39_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@5  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@5) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@5 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@5)) (= inline$$WritebackToGlobal$2$a@1@@5 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@5))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@5 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$3$to'@1@@3|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$2$ta@1@@5 inline$$WritebackToGlobal$2$a@1@@5) (|v#$Mutation| |inline$$WriteRef$3$to'@1@@3|))) (= |inline$$WritebackToGlobal$2$m'@1@@5| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$2$ta@1@@5 inline$$WritebackToGlobal$2$a@1@@5 inline$$WritebackToGlobal$2$v@1@@5)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@5| |inline$$WritebackToGlobal$2$m'@1@@5|) (= (ControlFlow 0 285874) 286026))) inline$$Diem_preburn_to_$def_verify$0$anon39_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@5  (=> (= inline$$WritebackToGlobal$2$l@1@@5 (|l#$Mutation| |inline$$WriteRef$3$to'@1@@3|)) (and (=> (= (ControlFlow 0 285810) 285874) inline$$WritebackToGlobal$2$anon3_Then_correct@@5) (=> (= (ControlFlow 0 285810) 285820) inline$$WritebackToGlobal$2$anon3_Else_correct@@5)))))
(let ((inline$$WriteRef$3$anon0_correct@@3  (=> (and (= |inline$$WriteRef$3$to'@1@@3| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@6) inline$$Diem_preburn_with_resource_$def$0$$ret0@2@@0)) (= (ControlFlow 0 285686) 285810)) inline$$WritebackToGlobal$2$anon0_correct@@5)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@11@@4) (= (ControlFlow 0 285692) 285686)) inline$$WriteRef$3$anon0_correct@@3)))
(let ((inline$$Diem_preburn_to_$def_verify$0$Abort_correct  (=> (= $abort_flag@12@@2 true) (=> (and (and (= $abort_code@18@@2 $abort_code@17@@3) (= $Diem_CurrencyInfo_$memory@3@@3 $Diem_CurrencyInfo_$memory@2@@5)) (and (= $Diem_Preburn_$memory@0@@3 $Diem_Preburn_$memory) (= (ControlFlow 0 277175) 286132))) anon0$2_correct@@23))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon7_correct  (=> (= $abort_code@17@@3 $abort_code@1@@19) (=> (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 286102) 277175)) inline$$Diem_preburn_to_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 286100) 286102)) inline$$Diem_preburn_to_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 286110) 286102) inline$$Diem_preburn_to_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon29_Then_correct  (=> $abort_flag@0@@22 (and (=> (= (ControlFlow 0 286094) 286110) inline$$Diem_preburn_to_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 286094) 286100) inline$$Diem_preburn_to_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon11_correct  (=> (= $abort_code@17@@3 $abort_code@2@@14) (=> (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 286082) 277175)) inline$$Diem_preburn_to_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 286080) 286082)) inline$$Diem_preburn_to_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 286090) 286082) inline$$Diem_preburn_to_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon31_Then_correct  (=> $abort_flag@1@@21 (and (=> (= (ControlFlow 0 286074) 286090) inline$$Diem_preburn_to_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 286074) 286080) inline$$Diem_preburn_to_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon15_correct  (=> (= $abort_code@17@@3 $abort_code@3@@15) (=> (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 286062) 277175)) inline$$Diem_preburn_to_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 286060) 286062)) inline$$Diem_preburn_to_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 286070) 286062) inline$$Diem_preburn_to_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon33_Then_correct  (=> $abort_flag@2@@18 (and (=> (= (ControlFlow 0 286054) 286070) inline$$Diem_preburn_to_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 286054) 286060) inline$$Diem_preburn_to_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon23_correct  (=> (= $abort_code@17@@3 $abort_code@5@@11) (=> (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 286042) 277175)) inline$$Diem_preburn_to_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 286040) 286042)) inline$$Diem_preburn_to_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 286050) 286042) inline$$Diem_preburn_to_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon37_Then_correct  (=> $abort_flag@3@@13 (and (=> (= (ControlFlow 0 286034) 286050) inline$$Diem_preburn_to_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 286034) 286040) inline$$Diem_preburn_to_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon39_Then_correct  (=> (and (and $abort_flag@11@@4 (= $abort_code@17@@3 $abort_code@16@@4)) (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory@1@@7) (= (ControlFlow 0 286030) 277175))) inline$$Diem_preburn_to_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon62_correct@@0  (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2@@0 |inline$$WritebackToValue$0$vdst'@2@@4|) (= $abort_flag@11@@4 $abort_flag@10@@4)) (and (= $abort_code@16@@4 $abort_code@14@@4) (= $Diem_CurrencyInfo_$memory@1@@7 $Diem_CurrencyInfo_$memory@0@@7))) (and (=> (= (ControlFlow 0 283874) 286030) inline$$Diem_preburn_to_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 283874) 285692) inline$$Diem_preburn_to_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 283872) 283874)) inline$$Diem_preburn_with_resource_$def$0$anon62_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct@@0  (=> (= (ControlFlow 0 283882) 283874) inline$$Diem_preburn_with_resource_$def$0$anon62_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct@@0  (and (=> (= (ControlFlow 0 285387) (- 0 482347)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@13 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@13)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@5) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@13)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@5))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@5 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@5)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@14 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@14)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@6) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@14)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@6))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@6 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@6))))))))))))))))))))) (and (=> (= (ControlFlow 0 285387) (- 0 482471)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@15 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@15) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@15)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@15)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@16 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@16) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@16)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@16)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 285387) (- 0 482524)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@17 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@17) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@17)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@3)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@18 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@18) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@18)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@4))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@7 |inline$$WritebackToGlobal$1$m'@2@@6|) (and (=> (= (ControlFlow 0 285387) 283882) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct@@0) (=> (= (ControlFlow 0 285387) 283872) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct@@0)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@6  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@6)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@6| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 285066) 285387)) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct@@0))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@6  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@6) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@6 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@6)) (= inline$$WritebackToGlobal$1$a@1@@6 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@6))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@6 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@5|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@6 inline$$WritebackToGlobal$1$a@1@@6) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@5|))) (= |inline$$WritebackToGlobal$1$m'@1@@6| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@6 inline$$WritebackToGlobal$1$a@1@@6 inline$$WritebackToGlobal$1$v@1@@6)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@6| |inline$$WritebackToGlobal$1$m'@1@@6|) (= (ControlFlow 0 285120) 285387))) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct@@0)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@6  (=> (= inline$$WritebackToGlobal$1$l@1@@6 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@5|)) (and (=> (= (ControlFlow 0 285056) 285120) inline$$WritebackToGlobal$1$anon3_Then_correct@@6) (=> (= (ControlFlow 0 285056) 285066) inline$$WritebackToGlobal$1$anon3_Else_correct@@6)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$2_correct@@0  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@19 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@19)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@7) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@7 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@19)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@7))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@7 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@7))))))))))))))))))))) (= (ControlFlow 0 285126) 285056)) inline$$WritebackToGlobal$1$anon0_correct@@6)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@6  (and (=> (= (ControlFlow 0 284809) (- 0 482065)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 284809) 285126) inline$$Diem_preburn_with_resource_$def$0$anon60$2_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@6  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@6 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@5|)) (= (ControlFlow 0 284761) 284809)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@6)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@5  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@5 inline$$WritebackToReference$2$srcPath@1@@5))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@5| |inline$$WritebackToReference$1$dst'@2@@6|) (= (ControlFlow 0 284630) 284761)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@6))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@5  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@5|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@5) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@5))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@5 inline$$WritebackToReference$2$srcPath@1@@5)) (= |inline$$WritebackToReference$2$dst'@1@@5| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) inline$$WritebackToReference$2$dstPath@1@@5 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@5 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@5) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@5|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@5| |inline$$WritebackToReference$2$dst'@1@@5|) (= (ControlFlow 0 284686) 284761))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@6)))
(let ((inline$$WritebackToReference$2$anon0_correct@@5  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@5 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@5|)) (= inline$$WritebackToReference$2$dstPath@1@@5 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|))) (and (=> (= (ControlFlow 0 284594) 284686) inline$$WritebackToReference$2$anon3_Then_correct@@5) (=> (= (ControlFlow 0 284594) 284630) inline$$WritebackToReference$2$anon3_Else_correct@@5)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 284457) 284594)) inline$$WritebackToReference$2$anon0_correct@@5)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct@@0  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|)) (= (ControlFlow 0 285397) 284594)) inline$$WritebackToReference$2$anon0_correct@@5)))
(let ((inline$$WriteRef$2$anon0_correct@@5  (=> (= |inline$$WriteRef$2$to'@1@@5| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1@@3) (|p#$Mutation| inline$$BorrowField$6$dst@1@@3) inline$$ReadRef$6$v@1@@3)) (and (=> (= (ControlFlow 0 284443) 285397) inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct@@0) (=> (= (ControlFlow 0 284443) 284457) inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct@@0  (=> (and (not $abort_flag@10@@4) (= (ControlFlow 0 284449) 284443)) inline$$WriteRef$2$anon0_correct@@5)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct@@0  (and (=> (= (ControlFlow 0 283862) (- 0 481411)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@20 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@20)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@20)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@8 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@20)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@20)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@8))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@8 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@8)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@21 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@21)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@21)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@9 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@21)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@21)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@9))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@9 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@9))))))))))))))))))))) (and (=> (= (ControlFlow 0 283862) (- 0 481535)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@22 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@22) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@22)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@22)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@23 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@23) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$addr3@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$addr3@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@23)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$addr3@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@23)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@23)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 283862) (- 0 481588)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@24 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@24) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@24)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@24)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@5)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@25 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@25) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$dr_addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$dr_addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@25)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@6|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@25)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$dr_addr@@6))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@7 |inline$$WritebackToGlobal$0$m'@2@@6|) (and (=> (= (ControlFlow 0 283862) 283882) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct@@0) (=> (= (ControlFlow 0 283862) 283872) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct@@0)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@6  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@6)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@6| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 283541) 283862)) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct@@0))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@6  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@6) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@6 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@6)) (= inline$$WritebackToGlobal$0$a@1@@6 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@6))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@6 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@6 inline$$WritebackToGlobal$0$a@1@@6) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|))) (= |inline$$WritebackToGlobal$0$m'@1@@6| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@6 inline$$WritebackToGlobal$0$a@1@@6 inline$$WritebackToGlobal$0$v@1@@6)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@6| |inline$$WritebackToGlobal$0$m'@1@@6|) (= (ControlFlow 0 283595) 283862))) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct@@0)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@6  (=> (= inline$$WritebackToGlobal$0$l@1@@6 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|)) (and (=> (= (ControlFlow 0 283531) 283595) inline$$WritebackToGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 283531) 283541) inline$$WritebackToGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$1_correct@@0  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$coin_type@@26 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def$0$coin_type@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@26)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@10 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@26)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def$0$coin_type@@26)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@10))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner1@@10 inline$$Diem_preburn_with_resource_$def$0$mint_cap_owner2@@10))))))))))))))))))))) (= (ControlFlow 0 283601) 283531)) inline$$WritebackToGlobal$0$anon0_correct@@6)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@6  (and (=> (= (ControlFlow 0 283284) (- 0 481129)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 283284) 283601) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$1_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@6  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@6 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|)) (= (ControlFlow 0 283236) 283284)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@8)) (= (ControlFlow 0 283288) 283236)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0  (=> (= inline$$Diem_preburn_with_resource_$def$0$$ret0@1@@0 $Error) (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2@@0 inline$$Diem_preburn_with_resource_$def$0$$ret0@1@@0) (= $abort_flag@11@@4 true)) (and (= $abort_code@16@@4 $abort_code@15@@4) (= $Diem_CurrencyInfo_$memory@1@@7 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 280455) 286030) inline$$Diem_preburn_to_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 280455) 285692) inline$$Diem_preburn_to_$def_verify$0$anon39_Else_correct))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon13_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@6@@10) (= (ControlFlow 0 285573) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285571) 285573)) inline$$Diem_preburn_with_resource_$def$0$anon13_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct@@0  (=> (= (ControlFlow 0 285581) 285573) inline$$Diem_preburn_with_resource_$def$0$anon13_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct@@0  (=> $abort_flag@4@@11 (and (=> (= (ControlFlow 0 285565) 285581) inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct@@0) (=> (= (ControlFlow 0 285565) 285571) inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon21_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@8@@7) (= (ControlFlow 0 285553) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285551) 285553)) inline$$Diem_preburn_with_resource_$def$0$anon21_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct@@0  (=> (= (ControlFlow 0 285561) 285553) inline$$Diem_preburn_with_resource_$def$0$anon21_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct@@0  (=> $abort_flag@5@@8 (and (=> (= (ControlFlow 0 285545) 285561) inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct@@0) (=> (= (ControlFlow 0 285545) 285551) inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon27_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@9@@7) (= (ControlFlow 0 285523) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285521) 285523)) inline$$Diem_preburn_with_resource_$def$0$anon27_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct@@0  (=> (= (ControlFlow 0 285531) 285523) inline$$Diem_preburn_with_resource_$def$0$anon27_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct@@0  (=> $abort_flag@6@@8 (and (=> (= (ControlFlow 0 285515) 285531) inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct@@0) (=> (= (ControlFlow 0 285515) 285521) inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon33_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@10@@6) (= (ControlFlow 0 285499) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285497) 285499)) inline$$Diem_preburn_with_resource_$def$0$anon33_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct@@0  (=> (= (ControlFlow 0 285507) 285499) inline$$Diem_preburn_with_resource_$def$0$anon33_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct@@0  (=> $abort_flag@7@@6 (and (=> (= (ControlFlow 0 285491) 285507) inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct@@0) (=> (= (ControlFlow 0 285491) 285497) inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon37_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@11@@6) (= (ControlFlow 0 285479) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285477) 285479)) inline$$Diem_preburn_with_resource_$def$0$anon37_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct@@0  (=> (= (ControlFlow 0 285487) 285479) inline$$Diem_preburn_with_resource_$def$0$anon37_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct@@0  (=> $abort_flag@8@@5 (and (=> (= (ControlFlow 0 285471) 285487) inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct@@0) (=> (= (ControlFlow 0 285471) 285477) inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon41_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@12@@5) (= (ControlFlow 0 285459) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285457) 285459)) inline$$Diem_preburn_with_resource_$def$0$anon41_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct@@0  (=> (= (ControlFlow 0 285467) 285459) inline$$Diem_preburn_with_resource_$def$0$anon41_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct@@0  (=> $abort_flag@9@@5 (and (=> (= (ControlFlow 0 285451) 285467) inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct@@0) (=> (= (ControlFlow 0 285451) 285457) inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon49_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@14@@4) (= (ControlFlow 0 285439) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285437) 285439)) inline$$Diem_preburn_with_resource_$def$0$anon49_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct@@0  (=> (= (ControlFlow 0 285447) 285439) inline$$Diem_preburn_with_resource_$def$0$anon49_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct@@0  (=> $abort_flag@10@@4 (and (=> (= (ControlFlow 0 285431) 285447) inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct@@0) (=> (= (ControlFlow 0 285431) 285437) inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon57_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@14@@4) (= (ControlFlow 0 285409) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 285407) 285409)) inline$$Diem_preburn_with_resource_$def$0$anon57_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct@@0  (=> (= (ControlFlow 0 285417) 285409) inline$$Diem_preburn_with_resource_$def$0$anon57_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct@@0  (=> $abort_flag@10@@4 (and (=> (= (ControlFlow 0 285401) 285417) inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct@@0) (=> (= (ControlFlow 0 285401) 285407) inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct@@0)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@6  (=> (= inline$$Event_emit_event$0$t@0@@6 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 284374) 285401) inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct@@0) (=> (= (ControlFlow 0 284374) 284449) inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct@@0  (and (=> (= (ControlFlow 0 284384) (- 0 481868)) true) (=> (= (ControlFlow 0 284384) 284374) inline$$Event_emit_event$0$Entry_correct@@6))))
(let ((inline$$ReadRef$6$anon0_correct@@3  (=> (and (= inline$$ReadRef$6$v@1@@3 (|v#$Mutation| inline$$BorrowField$6$dst@1@@3)) (= (ControlFlow 0 284326) 284384)) inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct@@0)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 284282) 284326)) inline$$ReadRef$6$anon0_correct@@3)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 284288) 284326) inline$$ReadRef$6$anon0_correct@@3)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 284276) 284288) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 284276) 284282) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 284268) 284326)) inline$$ReadRef$6$anon0_correct@@3)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct@@0  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@14) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@40) (let ((va@@357 (|v#$Vector| call3formal@$ret0@0@@40)))
(let ((l@@357 (|l#$ValueArray| va@@357)))
 (and (and (<= 0 l@@357) (<= l@@357 $MAX_U64)) (forall ((x@@357 Int) ) (!  (=> (or (< x@@357 0) (>= x@@357 l@@357)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@357) x@@357) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@357) x@@357))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0@@0 0) (< inline$$Diem_PreburnEvent_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) inline$$Diem_PreburnEvent_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) inline$$Diem_PreburnEvent_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) inline$$Diem_PreburnEvent_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) inline$$Diem_PreburnEvent_pack$0$$$0@@0))
))) (and ((_ is $Address) call3formal@$ret0@0@@41) (= inline$$Diem_PreburnEvent_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@14) 1 call3formal@$ret0@0@@40) 2 call3formal@$ret0@0@@41) 3))))) (and (=> (= (ControlFlow 0 284260) 284276) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 284260) 284268) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct@@0))))))
(let ((inline$$BorrowField$6$anon0_correct@@3  (=> (= inline$$BorrowField$6$p@1@@3 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|)) (=> (and (and (= inline$$BorrowField$6$size@1@@3 (|size#$Path| inline$$BorrowField$6$p@1@@3)) (= inline$$BorrowField$6$p@2@@3 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@3) inline$$BorrowField$6$size@1@@3 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$6$size@1@@3 1)))) (and (= inline$$BorrowField$6$dst@1@@3 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) inline$$BorrowField$6$p@2@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 284004) 284260))) inline$$Diem_PreburnEvent_pack$0$anon0_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@8) (= (ControlFlow 0 284010) 284004)) inline$$BorrowField$6$anon0_correct@@3)))
(let ((inline$$Not$0$anon0_correct@@8  (=> (= inline$$Not$0$dst@1@@8 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$5$v@1@@3)))) (and (=> (= (ControlFlow 0 283153) 284010) inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct@@0) (=> (= (ControlFlow 0 283153) 283288) inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct@@0)))))
(let ((inline$$Not$0$Entry_correct@@8  (and (=> (= (ControlFlow 0 283143) (- 0 481090)) true) (=> (= (ControlFlow 0 283143) 283153) inline$$Not$0$anon0_correct@@8))))
(let ((inline$$ReadRef$5$anon0_correct@@3  (=> (and (= inline$$ReadRef$5$v@1@@3 (|v#$Mutation| inline$$BorrowField$5$dst@1@@6)) (= (ControlFlow 0 283095) 283143)) inline$$Not$0$Entry_correct@@8)))
(let ((inline$$BorrowField$5$anon0_correct@@6  (=> (= inline$$BorrowField$5$p@1@@6 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|)) (=> (and (and (= inline$$BorrowField$5$size@1@@6 (|size#$Path| inline$$BorrowField$5$p@1@@6)) (= inline$$BorrowField$5$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@6) inline$$BorrowField$5$size@1@@6 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$5$size@1@@6 1)))) (and (= inline$$BorrowField$5$dst@1@@6 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|) inline$$BorrowField$5$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@6|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 283057) 283095))) inline$$ReadRef$5$anon0_correct@@3))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@6  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@6 inline$$WritebackToReference$1$srcPath@1@@6))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@6| inline$$BorrowGlobal$1$dst@2@@4) (= (ControlFlow 0 282841) 283057)) inline$$BorrowField$5$anon0_correct@@6))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@6  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@6 inline$$WritebackToReference$1$srcPath@1@@6)) (= |inline$$WritebackToReference$1$dst'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) inline$$WritebackToReference$1$dstPath@1@@6 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@6 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@6) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@6|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@6| |inline$$WritebackToReference$1$dst'@1@@6|) (= (ControlFlow 0 282897) 283057))) inline$$BorrowField$5$anon0_correct@@6)))
(let ((inline$$WritebackToReference$1$anon0_correct@@6  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@6 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@6|)) (= inline$$WritebackToReference$1$dstPath@1@@6 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@4))) (and (=> (= (ControlFlow 0 282805) 282897) inline$$WritebackToReference$1$anon3_Then_correct@@6) (=> (= (ControlFlow 0 282805) 282841) inline$$WritebackToReference$1$anon3_Else_correct@@6)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 282668) 282805)) inline$$WritebackToReference$1$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct@@0  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (= (ControlFlow 0 285427) 282805)) inline$$WritebackToReference$1$anon0_correct@@6)))
(let ((inline$$WriteRef$1$anon0_correct@@6  (=> (= |inline$$WriteRef$1$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@6) (|p#$Mutation| inline$$BorrowField$4$dst@1@@6) inline$$AddU64$0$dst@2@@1)) (and (=> (= (ControlFlow 0 282654) 285427) inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct@@0) (=> (= (ControlFlow 0 282654) 282668) inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct@@0)))))
(let ((inline$$BorrowField$4$anon0_correct@@6  (=> (= inline$$BorrowField$4$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (=> (and (and (= inline$$BorrowField$4$size@1@@6 (|size#$Path| inline$$BorrowField$4$p@1@@6)) (= inline$$BorrowField$4$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@6) inline$$BorrowField$4$size@1@@6 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1@@6 1)))) (and (= inline$$BorrowField$4$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) inline$$BorrowField$4$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 282595) 282654))) inline$$WriteRef$1$anon0_correct@@6))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct@@0  (=> (and (not $abort_flag@10@@4) (= (ControlFlow 0 282601) 282595)) inline$$BorrowField$4$anon0_correct@@6)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@1  (=> (= $abort_code@14@@4 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@10@@4 true) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@0@@1)) (and (=> (= (ControlFlow 0 282465) 285431) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct@@0) (=> (= (ControlFlow 0 282465) 282601) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct@@0))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@1  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$4$v@1@@6) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14)) $MAX_U64) (= (ControlFlow 0 282463) 282465)) inline$$AddU64$0$anon3_Then$1_correct@@1)))
(let ((inline$$AddU64$0$anon3_Else_correct@@1  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$4$v@1@@6) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14))) (=> (and (and (= inline$$AddU64$0$dst@1@@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$4$v@1@@6) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14)))) (= $abort_code@14@@4 $abort_code@12@@5)) (and (= $abort_flag@10@@4 $abort_flag@9@@5) (= inline$$AddU64$0$dst@2@@1 inline$$AddU64$0$dst@1@@1))) (and (=> (= (ControlFlow 0 282407) 285431) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct@@0) (=> (= (ControlFlow 0 282407) 282601) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct@@0))))))
(let ((inline$$AddU64$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 282377) (- 0 480664)) true) (and (=> (= (ControlFlow 0 282377) 282463) inline$$AddU64$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 282377) 282407) inline$$AddU64$0$anon3_Else_correct@@1)))))
(let ((inline$$ReadRef$4$anon0_correct@@6  (=> (and (= inline$$ReadRef$4$v@1@@6 (|v#$Mutation| inline$$BorrowField$3$dst@1@@6)) (= (ControlFlow 0 282270) 282377)) inline$$AddU64$0$Entry_correct@@1)))
(let ((inline$$BorrowField$3$anon0_correct@@6  (=> (= inline$$BorrowField$3$p@1@@6 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (=> (and (and (= inline$$BorrowField$3$size@1@@6 (|size#$Path| inline$$BorrowField$3$p@1@@6)) (= inline$$BorrowField$3$p@2@@6 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@6) inline$$BorrowField$3$size@1@@6 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@6 1)))) (and (= inline$$BorrowField$3$dst@1@@6 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) inline$$BorrowField$3$p@2@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 282232) 282270))) inline$$ReadRef$4$anon0_correct@@6))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@7) (= (ControlFlow 0 282284) 282232)) inline$$BorrowField$3$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon46_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@13@@5) (= (ControlFlow 0 282066) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 282064) 282066)) inline$$Diem_preburn_with_resource_$def$0$anon46_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct@@0  (=> (= (ControlFlow 0 282074) 282066) inline$$Diem_preburn_with_resource_$def$0$anon46_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct@@0  (=> (= $abort_code@13@@5 (|i#$Integer| call3formal@$ret0@0@@42)) (and (=> (= (ControlFlow 0 282058) 282074) inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct@@0) (=> (= (ControlFlow 0 282058) 282064) inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@6  (and (=> (= (ControlFlow 0 282048) (- 0 480496)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 282048) 282058) inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@6  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@6 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (= (ControlFlow 0 282000) 282048)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@7)) (= (ControlFlow 0 282052) 282000)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct@@0  (=> (not $abort_flag@9@@5) (and (=> (= (ControlFlow 0 281925) 282284) inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct@@0) (=> (= (ControlFlow 0 281925) 282052) inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct@@0  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t27@1@@0 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9@@5)) (and (=> $abort_flag@9@@5 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9@@5) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@42 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@42) (>= (|i#$Integer| call3formal@$ret0@0@@42) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@42) $MAX_U64))) (and (=> (= (ControlFlow 0 281919) 285451) inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct@@0) (=> (= (ControlFlow 0 281919) 281925) inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct@@0)))))
(let ((inline$$Ge$0$anon0_correct@@7  (=> (and (= inline$$Ge$0$dst@1@@7 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2@@7) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@14)))) (= (ControlFlow 0 281907) 281919)) inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct@@0)))
(let ((inline$$Ge$0$Entry_correct@@7  (and (=> (= (ControlFlow 0 281893) (- 0 480386)) true) (=> (= (ControlFlow 0 281893) 281907) inline$$Ge$0$anon0_correct@@7))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct@@0  (=> (and (not $abort_flag@8@@5) (= (ControlFlow 0 281913) 281893)) inline$$Ge$0$Entry_correct@@7)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@7  (=> (= $abort_flag@8@@5 true) (=> (and (= $abort_code@11@@6 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@7 inline$$Sub$0$dst@0@@7)) (and (=> (= (ControlFlow 0 281837) 285471) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct@@0) (=> (= (ControlFlow 0 281837) 281913) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct@@0))))))
(let ((inline$$Sub$0$anon3_Then_correct@@7  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1@@0) (|i#$Integer| inline$$ReadRef$3$v@1@@6)) (= (ControlFlow 0 281835) 281837)) inline$$Sub$0$anon3_Then$1_correct@@7)))
(let ((inline$$Sub$0$anon3_Else_correct@@7  (=> (<= (|i#$Integer| inline$$ReadRef$3$v@1@@6) (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1@@0)) (=> (and (and (= inline$$Sub$0$dst@1@@7 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1@@0) (|i#$Integer| inline$$ReadRef$3$v@1@@6)))) (= $abort_flag@8@@5 $abort_flag@7@@6)) (and (= $abort_code@11@@6 $abort_code@10@@6) (= inline$$Sub$0$dst@2@@7 inline$$Sub$0$dst@1@@7))) (and (=> (= (ControlFlow 0 281783) 285471) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct@@0) (=> (= (ControlFlow 0 281783) 281913) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct@@0))))))
(let ((inline$$Sub$0$Entry_correct@@7  (and (=> (= (ControlFlow 0 281757) (- 0 480298)) true) (and (=> (= (ControlFlow 0 281757) 281835) inline$$Sub$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 281757) 281783) inline$$Sub$0$anon3_Else_correct@@7)))))
(let ((inline$$ReadRef$3$anon0_correct@@6  (=> (and (= inline$$ReadRef$3$v@1@@6 (|v#$Mutation| inline$$BorrowField$2$dst@1@@7)) (= (ControlFlow 0 281658) 281757)) inline$$Sub$0$Entry_correct@@7)))
(let ((inline$$BorrowField$2$anon0_correct@@7  (=> (= inline$$BorrowField$2$p@1@@7 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (=> (and (and (= inline$$BorrowField$2$size@1@@7 (|size#$Path| inline$$BorrowField$2$p@1@@7)) (= inline$$BorrowField$2$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@7) inline$$BorrowField$2$size@1@@7 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@7 1)))) (and (= inline$$BorrowField$2$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@4) inline$$BorrowField$2$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 281620) 281658))) inline$$ReadRef$3$anon0_correct@@6))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct@@0  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t23@1@@0 ($Integer 18446744073709551615)) (= (ControlFlow 0 281672) 281620)) inline$$BorrowField$2$anon0_correct@@7)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@6  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@6)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@6)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 281458) 281672)) inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@6  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@6 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@4)) (= (ControlFlow 0 281452) 281458)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct@@0  (=> (and (not $abort_flag@7@@6) (= (ControlFlow 0 281462) 281452)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@6)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@4  (=> (= $abort_code@10@@6 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7@@6 true) (= inline$$BorrowGlobal$1$dst@2@@4 inline$$BorrowGlobal$1$dst@0@@4)) (and (=> (= (ControlFlow 0 281412) 285491) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct@@0) (=> (= (ControlFlow 0 281412) 281462) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@4  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@4 inline$$BorrowGlobal$1$a@1@@4)) (= (ControlFlow 0 281410) 281412)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@4)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@4  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@4 inline$$BorrowGlobal$1$a@1@@4) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@4 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0@@4 inline$$BorrowGlobal$1$a@1@@4) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0@@4 inline$$BorrowGlobal$1$a@1@@4))) (= $abort_code@10@@6 $abort_code@9@@7)) (and (= $abort_flag@7@@6 $abort_flag@6@@8) (= inline$$BorrowGlobal$1$dst@2@@4 inline$$BorrowGlobal$1$dst@1@@4))) (and (=> (= (ControlFlow 0 281358) 285491) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct@@0) (=> (= (ControlFlow 0 281358) 281462) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct@@0))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@4  (=> (= inline$$BorrowGlobal$1$a@1@@4 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@15)) (and (=> (= (ControlFlow 0 281328) 281410) inline$$BorrowGlobal$1$anon3_Then_correct@@4) (=> (= (ControlFlow 0 281328) 281358) inline$$BorrowGlobal$1$anon3_Else_correct@@4)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@4  (=> (= inline$$BorrowGlobal$1$ta@0@@4 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1)) (and (=> (= (ControlFlow 0 281322) (- 0 480073)) true) (=> (= (ControlFlow 0 281322) 281328) inline$$BorrowGlobal$1$anon0_correct@@4)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct@@0  (=> (and (not $abort_flag@6@@8) (= (ControlFlow 0 281418) 281322)) inline$$BorrowGlobal$1$Entry_correct@@4)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct@@0  (=> $abort_flag@6@@8 (=> (and (= $abort_code@15@@4 $abort_code@9@@7) (= (ControlFlow 0 285511) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@15  (=> (not true) (and (=> (= (ControlFlow 0 281179) 285511) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct@@0) (=> (= (ControlFlow 0 281179) 281418) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct@@0)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@15  (and (=> (= (ControlFlow 0 281189) 285511) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct@@0) (=> (= (ControlFlow 0 281189) 281418) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct@@0))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@15  (=> (and (not $abort_flag@6@@8) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@15 ($Address 173345816))) (and (=> (= (ControlFlow 0 281173) 281189) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@15) (=> (= (ControlFlow 0 281173) 281179) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@15)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct@@0  (=> (and (not $abort_flag@6@@8) (= (ControlFlow 0 281203) 281173)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@15)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct@@0  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@8) (=> $abort_flag@6@@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@7 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@6@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@40) (let ((va@@358 (|v#$Vector| call3formal@$ret0@0@@40)))
(let ((l@@358 (|l#$ValueArray| va@@358)))
 (and (and (<= 0 l@@358) (<= l@@358 $MAX_U64)) (forall ((x@@358 Int) ) (!  (=> (or (< x@@358 0) (>= x@@358 l@@358)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@358) x@@358) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@358) x@@358))
)))))) (forall (($$0@@121 Int) ) (!  (=> (and (>= $$0@@121 0) (< $$0@@121 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) $$0@@121)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) $$0@@121)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) $$0@@121)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@40)) $$0@@121))
)))) (and (=> (= (ControlFlow 0 281068) 285515) inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct@@0) (=> (= (ControlFlow 0 281068) 281203) inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct@@0)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@5  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) ($Local 11))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@4| inline$$ReadRef$0$v@1@@8) (= (ControlFlow 0 281034) 281068)) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct@@0))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@5  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) ($Local 11)) (= |inline$$WritebackToValue$0$vdst'@1@@5| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|) 0 inline$$ReadRef$0$v@1@@8 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@7|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@4| |inline$$WritebackToValue$0$vdst'@1@@5|) (= (ControlFlow 0 281060) 281068))) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@7  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7))) (= |inline$$WritebackToReference$0$dst'@2@@7| inline$$BorrowLoc$0$dst@1@@5)) (and (=> (= (ControlFlow 0 280879) 281060) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 280879) 281034) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@7  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@8|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@7 inline$$WritebackToReference$0$srcPath@1@@7)) (and (= |inline$$WritebackToReference$0$dst'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$WritebackToReference$0$dstPath@1@@7 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@7 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@7) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@8|)))) (= |inline$$WritebackToReference$0$dst'@2@@7| |inline$$WritebackToReference$0$dst'@1@@7|))) (and (=> (= (ControlFlow 0 280935) 281060) inline$$WritebackToValue$0$anon3_Then_correct@@5) (=> (= (ControlFlow 0 280935) 281034) inline$$WritebackToValue$0$anon3_Else_correct@@5)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@7  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@7 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@8|)) (= inline$$WritebackToReference$0$dstPath@1@@7 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) (and (=> (= (ControlFlow 0 280843) 280935) inline$$WritebackToReference$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 280843) 280879) inline$$WritebackToReference$0$anon3_Else_correct@@7)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 280706) 280843)) inline$$WritebackToReference$0$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct@@0  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1@@0 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def$0$info@0@@0)) (= (ControlFlow 0 285541) 280843)) inline$$WritebackToReference$0$anon0_correct@@7)))
(let ((inline$$WriteRef$0$anon0_correct@@8  (=> (= |inline$$WriteRef$0$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@7) (|p#$Mutation| inline$$BorrowField$1$dst@1@@7) call5formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 280692) 285541) inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct@@0) (=> (= (ControlFlow 0 280692) 280706) inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct@@0  (=> (and (not $abort_flag@5@@8) (= (ControlFlow 0 280698) 280692)) inline$$WriteRef$0$anon0_correct@@8)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct@@0  (and (=> (= (ControlFlow 0 280635) (- 0 479463)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@5@@8) (=> $abort_flag@5@@8 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@5@@8 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@8@@7 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@5@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1@@6)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@1) (let ((va@@359 (|v#$Vector| call5formal@$ret0@0@@1)))
(let ((l@@359 (|l#$ValueArray| va@@359)))
 (and (and (<= 0 l@@359) (<= l@@359 $MAX_U64)) (forall ((x@@359 Int) ) (!  (=> (or (< x@@359 0) (>= x@@359 l@@359)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@359) x@@359) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@359) x@@359))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 280635) 285545) inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct@@0) (=> (= (ControlFlow 0 280635) 280698) inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct@@0)))))))
(let ((inline$$ReadRef$2$anon0_correct@@6  (=> (and (= inline$$ReadRef$2$v@1@@6 (|v#$Mutation| inline$$BorrowField$1$dst@1@@7)) (= (ControlFlow 0 280623) 280635)) inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@7  (=> (= inline$$BorrowField$1$p@1@@7 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (=> (and (and (= inline$$BorrowField$1$size@1@@7 (|size#$Path| inline$$BorrowField$1$p@1@@7)) (= inline$$BorrowField$1$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@7) inline$$BorrowField$1$size@1@@7 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1@@7 1)))) (and (= inline$$BorrowField$1$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$BorrowField$1$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 280585) 280623))) inline$$ReadRef$2$anon0_correct@@6))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1@@0) (= (ControlFlow 0 280591) 280585)) inline$$BorrowField$1$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon18_correct@@0  (=> (and (= $abort_code@15@@4 $abort_code@7@@9) (= (ControlFlow 0 280449) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 280447) 280449)) inline$$Diem_preburn_with_resource_$def$0$anon18_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct@@0  (=> (= (ControlFlow 0 280463) 280449) inline$$Diem_preburn_with_resource_$def$0$anon18_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1@@0)) (= $abort_code@7@@9 (|i#$Integer| call3formal@$ret0@0@@43))) (and (=> (= (ControlFlow 0 280441) 280463) inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct@@0) (=> (= (ControlFlow 0 280441) 280447) inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct@@0  (=> (not $abort_flag@4@@11) (and (=> (= (ControlFlow 0 280429) 280591) inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct@@0) (=> (= (ControlFlow 0 280429) 280441) inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct@@0  (=> (not $abort_flag@3@@13) (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t16@1@@0 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def$0$$t17@1@@0 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1@@0 inline$$Diem_preburn_with_resource_$def$0$$t16@1@@0)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t18@1@@0 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@11)) (and (=> $abort_flag@4@@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@43 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@43) (>= (|i#$Integer| call3formal@$ret0@0@@43) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@43) $MAX_U64))) (and (=> (= (ControlFlow 0 280423) 285565) inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct@@0) (=> (= (ControlFlow 0 280423) 280429) inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct@@0)))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct@@0  (=> $abort_flag@3@@13 (=> (and (= $abort_code@15@@4 $abort_code@5@@11) (= (ControlFlow 0 285585) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 280367) 285585) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct@@0) (=> (= (ControlFlow 0 280367) 280423) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct@@0)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 280377) 285585) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct@@0) (=> (= (ControlFlow 0 280377) 280423) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct@@0))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 280351) 280377) inline$$Diem_value_$def$1$anon6_Then_correct@@0) (=> (= (ControlFlow 0 280351) 280367) inline$$Diem_value_$def$1$anon6_Else_correct@@0)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 280275) 280351)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct@@0  (=> (= (ControlFlow 0 280385) 280351) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$Diem_value_$def$1$anon0_correct@@0  (=> (not $abort_flag@3@@13) (and (=> (= (ControlFlow 0 280269) 280385) inline$$Diem_value_$def$1$anon5_Then_correct@@0) (=> (= (ControlFlow 0 280269) 280275) inline$$Diem_value_$def$1$anon5_Else_correct@@0)))))
(let ((inline$$Diem_value$1$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@7) (let ((va@@360 (|v#$Vector| inline$$ReadRef$1$v@1@@7)))
(let ((l@@360 (|l#$ValueArray| va@@360)))
 (and (and (<= 0 l@@360) (<= l@@360 $MAX_U64)) (forall ((x@@360 Int) ) (!  (=> (or (< x@@360 0) (>= x@@360 l@@360)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@360) x@@360) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@360) x@@360))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@7)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 280391) 280269)) inline$$Diem_value_$def$1$anon0_correct@@0)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct@@0  (and (=> (= (ControlFlow 0 280399) (- 0 479160)) true) (=> (= (ControlFlow 0 280399) 280391) inline$$Diem_value$1$anon0_correct@@0))))
(let ((inline$$ReadRef$1$anon0_correct@@7  (=> (and (= inline$$ReadRef$1$v@1@@7 (|v#$Mutation| inline$$BorrowField$0$dst@1@@7)) (= (ControlFlow 0 280089) 280399)) inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@7  (=> (= inline$$BorrowField$0$p@1@@7 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@5)) (=> (and (and (= inline$$BorrowField$0$size@1@@7 (|size#$Path| inline$$BorrowField$0$p@1@@7)) (= inline$$BorrowField$0$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@7) inline$$BorrowField$0$size@1@@7 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@7 1)))) (and (= inline$$BorrowField$0$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@5) inline$$BorrowField$0$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@5))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 280051) 280089))) inline$$ReadRef$1$anon0_correct@@7))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct@@0  (=> (and (not $abort_flag@3@@13) (= (ControlFlow 0 280103) 280051)) inline$$BorrowField$0$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct@@0  (=> $abort_flag@3@@13 (=> (and (= $abort_code@15@@4 $abort_code@5@@11) (= (ControlFlow 0 285589) 280455)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct@@0))))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 279859) 285589) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct@@0) (=> (= (ControlFlow 0 279859) 280103) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct@@0)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@3  (and (=> (= (ControlFlow 0 279869) 285589) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct@@0) (=> (= (ControlFlow 0 279869) 280103) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct@@0))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@14  (=> (= inline$$GetFieldFromValue$0$dst@1@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 279843) 279869) inline$$Diem_value_$def$0$anon6_Then_correct@@3) (=> (= (ControlFlow 0 279843) 279859) inline$$Diem_value_$def$0$anon6_Else_correct@@3)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@3  (=> (and (not true) (= (ControlFlow 0 279767) 279843)) inline$$GetFieldFromValue$0$anon0_correct@@14)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@3  (=> (= (ControlFlow 0 279877) 279843) inline$$GetFieldFromValue$0$anon0_correct@@14)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@3  (=> (not $abort_flag@3@@13) (and (=> (= (ControlFlow 0 279761) 279877) inline$$Diem_value_$def$0$anon5_Then_correct@@3) (=> (= (ControlFlow 0 279761) 279767) inline$$Diem_value_$def$0$anon5_Else_correct@@3)))))
(let ((inline$$Diem_value$0$anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) coin@@4) (let ((va@@361 (|v#$Vector| coin@@4)))
(let ((l@@361 (|l#$ValueArray| va@@361)))
 (and (and (<= 0 l@@361) (<= l@@361 $MAX_U64)) (forall ((x@@361 Int) ) (!  (=> (or (< x@@361 0) (>= x@@361 l@@361)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@361) x@@361) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@361) x@@361))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 279883) 279761)) inline$$Diem_value_$def$0$anon0_correct@@3)))
(let ((inline$$BorrowLoc$0$anon0_correct@@5  (=> (and (= inline$$BorrowLoc$0$dst@1@@5 ($Mutation ($Local 11) $EmptyPath inline$$ReadRef$0$v@1@@8)) (= (ControlFlow 0 279593) 279883)) inline$$Diem_value$0$anon0_correct@@1)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 279441) 279593)) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct@@0  (=> (= (ControlFlow 0 285597) 279593) inline$$BorrowLoc$0$anon0_correct@@5)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 279433) 285597) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct@@0) (=> (= (ControlFlow 0 279433) 279441) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct@@0  (and (=> (= (ControlFlow 0 285605) 285597) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct@@0) (=> (= (ControlFlow 0 285605) 279441) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 279425) 285605) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct@@0) (=> (= (ControlFlow 0 279425) 279433) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct@@0  (and (=> (= (ControlFlow 0 285613) 285605) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct@@0) (=> (= (ControlFlow 0 285613) 279433) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct@@0))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon0_correct@@0  (=> (not $abort_flag@3@@13) (and (=> (= (ControlFlow 0 279419) 285613) inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct@@0) (=> (= (ControlFlow 0 279419) 279425) inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct@@0)))))
(let ((inline$$Diem_preburn_with_resource_$direct_intra$0$anon0_correct@@0  (=> (and (and (and (and ((_ is $Vector) coin@@4) (let ((va@@362 (|v#$Vector| coin@@4)))
(let ((l@@362 (|l#$ValueArray| va@@362)))
 (and (and (<= 0 l@@362) (<= l@@362 $MAX_U64)) (forall ((x@@362 Int) ) (!  (=> (or (< x@@362 0) (>= x@@362 l@@362)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@362) x@@362) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@362) x@@362))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@8) (let ((va@@363 (|v#$Vector| inline$$ReadRef$0$v@1@@8)))
(let ((l@@363 (|l#$ValueArray| va@@363)))
 (and (and (<= 0 l@@363) (<= l@@363 $MAX_U64)) (forall ((x@@363 Int) ) (!  (=> (or (< x@@363 0) (>= x@@363 l@@363)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@363) x@@363) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@363) x@@363))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn)) (let ((va@@364 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn))))
(let ((l@@364 (|l#$ValueArray| va@@364)))
 (and (and (<= 0 l@@364) (<= l@@364 $MAX_U64)) (forall ((x@@364 Int) ) (!  (=> (or (< x@@364 0) (>= x@@364 l@@364)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@364) x@@364) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@364) x@@364))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@8)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) call3formal@$ret0@0@@41) (= (ControlFlow 0 285619) 279419))) inline$$Diem_preburn_with_resource_$def$0$anon0_correct@@0))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon37_Else$1_correct  (and (=> (= (ControlFlow 0 285627) (- 0 478729)) true) (=> (= (ControlFlow 0 285627) 285619) inline$$Diem_preburn_with_resource_$direct_intra$0$anon0_correct@@0))))
(let ((inline$$ReadRef$0$anon0_correct@@8  (=> (and (= inline$$ReadRef$0$v@1@@8 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@6)) (= (ControlFlow 0 277434) 285627)) inline$$Diem_preburn_to_$def_verify$0$anon37_Else$1_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon37_Else_correct  (=> (and (not $abort_flag@3@@13) (= (ControlFlow 0 277440) 277434)) inline$$ReadRef$0$anon0_correct@@8)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@6  (=> (= $abort_flag@3@@13 true) (=> (and (= $abort_code@5@@11 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@6 inline$$BorrowGlobal$0$dst@0@@6)) (and (=> (= (ControlFlow 0 277390) 286034) inline$$Diem_preburn_to_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 277390) 277440) inline$$Diem_preburn_to_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@6  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@6 inline$$BorrowGlobal$0$a@1@@6)) (= (ControlFlow 0 277388) 277390)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@6)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@6  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@6 inline$$BorrowGlobal$0$a@1@@6) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@6 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@6 inline$$BorrowGlobal$0$a@1@@6) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@6 inline$$BorrowGlobal$0$a@1@@6))) (= $abort_flag@3@@13 $abort_flag@2@@18)) (and (= $abort_code@5@@11 $abort_code@3@@15) (= inline$$BorrowGlobal$0$dst@2@@6 inline$$BorrowGlobal$0$dst@1@@6))) (and (=> (= (ControlFlow 0 277336) 286034) inline$$Diem_preburn_to_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 277336) 277440) inline$$Diem_preburn_to_$def_verify$0$anon37_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@6  (=> (= inline$$BorrowGlobal$0$a@1@@6 (|a#$Address| call3formal@$ret0@0@@41)) (and (=> (= (ControlFlow 0 277306) 277388) inline$$BorrowGlobal$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 277306) 277336) inline$$BorrowGlobal$0$anon3_Else_correct@@6)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@6  (=> (= inline$$BorrowGlobal$0$ta@0@@6 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1)) (and (=> (= (ControlFlow 0 277300) (- 0 478616)) true) (=> (= (ControlFlow 0 277300) 277306) inline$$BorrowGlobal$0$anon0_correct@@6)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_to_$def_verify$0$$t7@1) (= (ControlFlow 0 277396) 277300)) inline$$BorrowGlobal$0$Entry_correct@@6)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon20_correct  (=> (= $abort_code@17@@3 $abort_code@4@@14) (=> (and (= $Diem_CurrencyInfo_$memory@2@@5 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 277171) 277175)) inline$$Diem_preburn_to_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 277169) 277171)) inline$$Diem_preburn_to_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 277183) 277171) inline$$Diem_preburn_to_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_to_$def_verify$0$$t7@1)) (= $abort_code@4@@14 (|i#$Integer| call3formal@$ret0@0@@44))) (and (=> (= (ControlFlow 0 277163) 277183) inline$$Diem_preburn_to_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 277163) 277169) inline$$Diem_preburn_to_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon33_Else_correct  (=> (not $abort_flag@2@@18) (and (=> (= (ControlFlow 0 277151) 277396) inline$$Diem_preburn_to_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 277151) 277163) inline$$Diem_preburn_to_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon31_Else_correct  (=> (and (not $abort_flag@1@@21) (= inline$$Diem_preburn_to_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@30) 1) (|a#$Address| call3formal@$ret0@0@@41))))) (=> (and (and (and (= inline$$Diem_preburn_to_$def_verify$0$$t8@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@18)) (and (=> $abort_flag@2@@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@44 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@44) (>= (|i#$Integer| call3formal@$ret0@0@@44) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@44) $MAX_U64))) (and (=> (= (ControlFlow 0 277145) 286054) inline$$Diem_preburn_to_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 277145) 277151) inline$$Diem_preburn_to_$def_verify$0$anon33_Else_correct))))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon29_Else_correct  (=> (not $abort_flag@0@@22) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@21) (=> $abort_flag@1@@21 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@41 account@@2)))) ((_ is $Address) call3formal@$ret0@0@@41))) (and (=> (= (ControlFlow 0 277115) 286074) inline$$Diem_preburn_to_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 277115) 277145) inline$$Diem_preburn_to_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) $abort_flag@0@@22) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@0@@22)) (and (=> $abort_flag@0@@22 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))))) (=> $abort_flag@0@@22 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2))))))) (= $abort_code@1@@19 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@2)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@1@@19 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 277109) 286094) inline$$Diem_preburn_to_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 277109) 277115) inline$$Diem_preburn_to_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 277039) 277109)) inline$$Diem_preburn_to_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 286118) 277109) inline$$Diem_preburn_to_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 277031) 286118) inline$$Diem_preburn_to_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 277031) 277039) inline$$Diem_preburn_to_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 286126) 286118) inline$$Diem_preburn_to_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 286126) 277039) inline$$Diem_preburn_to_$def_verify$0$anon28_Else_correct))))
(let ((inline$$Diem_preburn_to_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 277025) 286126) inline$$Diem_preburn_to_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 277025) 277031) inline$$Diem_preburn_to_$def_verify$0$anon27_Else_correct)))))
(let ((anon0$1_correct@@22  (=> (forall (($inv_addr@@44 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44)) (let ((va@@365 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))))
(let ((l@@365 (|l#$ValueArray| va@@365)))
 (and (and (<= 0 l@@365) (<= l@@365 $MAX_U64)) (forall ((x@@365 Int) ) (!  (=> (or (< x@@365 0) (>= x@@365 l@@365)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@365) x@@365) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@365) x@@365))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@44))
)) (=> (and (and (and (forall (($inv_addr@@45 Int) ($inv_tv0@@39 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45)) (let ((va@@366 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))))
(let ((l@@366 (|l#$ValueArray| va@@366)))
 (and (and (<= 0 l@@366) (<= l@@366 $MAX_U64)) (forall ((x@@366 Int) ) (!  (=> (or (< x@@366 0) (>= x@@366 l@@366)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@366) x@@366) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@366) x@@366))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@39) 1) $inv_addr@@45))
)) (forall (($inv_addr@@46 Int) ($inv_tv0@@40 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46)) (let ((va@@367 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))))
(let ((l@@367 (|l#$ValueArray| va@@367)))
 (and (and (<= 0 l@@367) (<= l@@367 $MAX_U64)) (forall ((x@@367 Int) ) (!  (=> (or (< x@@367 0) (>= x@@367 l@@367)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@367) x@@367) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@367) x@@367))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@368 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@368 (|l#$ValueArray| va@@368)))
 (and (and (<= 0 l@@368) (<= l@@368 $MAX_U64)) (forall ((x@@368 Int) ) (!  (=> (or (< x@@368 0) (>= x@@368 l@@368)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@368) x@@368) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@368) x@@368))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code)) (let ((va@@369 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@369 (|l#$ValueArray| va@@369)))
 (and (and (<= 0 l@@369) (<= l@@369 $MAX_U64)) (forall ((x@@369 Int) ) (!  (=> (or (< x@@369 0) (>= x@@369 l@@369)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@369) x@@369) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@369) x@@369))
))))))) (forall (($$0@@122 Int) ) (!  (=> (and (>= $$0@@122 0) (< $$0@@122 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))) $$0@@122)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))) $$0@@122)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))) $$0@@122)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_currency_code))) $$0@@122))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events)) (let ((va@@370 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@370 (|l#$ValueArray| va@@370)))
 (and (and (<= 0 l@@370) (<= l@@370 $MAX_U64)) (forall ((x@@370 Int) ) (!  (=> (or (< x@@370 0) (>= x@@370 l@@370)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@370) x@@370) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@370) x@@370))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@371 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@371 (|l#$ValueArray| va@@371)))
 (and (and (<= 0 l@@371) (<= l@@371 $MAX_U64)) (forall ((x@@371 Int) ) (!  (=> (or (< x@@371 0) (>= x@@371 l@@371)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@371) x@@371) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@371) x@@371))
))))))) (forall (($$0@@123 Int) ) (!  (=> (and (>= $$0@@123 0) (< $$0@@123 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@123)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@123)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@123)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@123))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events)) (let ((va@@372 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@372 (|l#$ValueArray| va@@372)))
 (and (and (<= 0 l@@372) (<= l@@372 $MAX_U64)) (forall ((x@@372 Int) ) (!  (=> (or (< x@@372 0) (>= x@@372 l@@372)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@372) x@@372) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@372) x@@372))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@373 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@373 (|l#$ValueArray| va@@373)))
 (and (and (<= 0 l@@373) (<= l@@373 $MAX_U64)) (forall ((x@@373 Int) ) (!  (=> (or (< x@@373 0) (>= x@@373 l@@373)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@373) x@@373) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@373) x@@373))
))))))) (forall (($$0@@124 Int) ) (!  (=> (and (>= $$0@@124 0) (< $$0@@124 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@124)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@124)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@124)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@124))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@374 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@374 (|l#$ValueArray| va@@374)))
 (and (and (<= 0 l@@374) (<= l@@374 $MAX_U64)) (forall ((x@@374 Int) ) (!  (=> (or (< x@@374 0) (>= x@@374 l@@374)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@374) x@@374) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@374) x@@374))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@375 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@375 (|l#$ValueArray| va@@375)))
 (and (and (<= 0 l@@375) (<= l@@375 $MAX_U64)) (forall ((x@@375 Int) ) (!  (=> (or (< x@@375 0) (>= x@@375 l@@375)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@375) x@@375) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@375) x@@375))
))))))) (forall (($$0@@125 Int) ) (!  (=> (and (>= $$0@@125 0) (< $$0@@125 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@125)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@125)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@125)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@125))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@376 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@376 (|l#$ValueArray| va@@376)))
 (and (and (<= 0 l@@376) (<= l@@376 $MAX_U64)) (forall ((x@@376 Int) ) (!  (=> (or (< x@@376 0) (>= x@@376 l@@376)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@376) x@@376) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@376) x@@376))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@377 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@377 (|l#$ValueArray| va@@377)))
 (and (and (<= 0 l@@377) (<= l@@377 $MAX_U64)) (forall ((x@@377 Int) ) (!  (=> (or (< x@@377 0) (>= x@@377 l@@377)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@377) x@@377) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@377) x@@377))
))))))) (forall (($$0@@126 Int) ) (!  (=> (and (>= $$0@@126 0) (< $$0@@126 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@126)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@126)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@126)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@126))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@378 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@378 (|l#$ValueArray| va@@378)))
 (and (and (<= 0 l@@378) (<= l@@378 $MAX_U64)) (forall ((x@@378 Int) ) (!  (=> (or (< x@@378 0) (>= x@@378 l@@378)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@378) x@@378) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@378) x@@378))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@379 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@379 (|l#$ValueArray| va@@379)))
 (and (and (<= 0 l@@379) (<= l@@379 $MAX_U64)) (forall ((x@@379 Int) ) (!  (=> (or (< x@@379 0) (>= x@@379 l@@379)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@379) x@@379) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@379) x@@379))
))))))) (forall (($$0@@127 Int) ) (!  (=> (and (>= $$0@@127 0) (< $$0@@127 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@127)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@127)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@127)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@127))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@40) 1) $inv_addr@@46))
))) (and (forall (($inv_addr@@47 Int) ($inv_tv0@@41 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47)) (let ((va@@380 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))))
(let ((l@@380 (|l#$ValueArray| va@@380)))
 (and (and (<= 0 l@@380) (<= l@@380 $MAX_U64)) (forall ((x@@380 Int) ) (!  (=> (or (< x@@380 0) (>= x@@380 l@@380)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@380) x@@380) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@380) x@@380))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn)) (let ((va@@381 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn))))
(let ((l@@381 (|l#$ValueArray| va@@381)))
 (and (and (<= 0 l@@381) (<= l@@381 $MAX_U64)) (forall ((x@@381 Int) ) (!  (=> (or (< x@@381 0) (>= x@@381 l@@381)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@381) x@@381) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@381) x@@381))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@41) 1) $inv_addr@@47))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@33 T@$Value) )  (=> ((_ is $Type) coin_type@@33) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@2 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@33)) 1) (|a#$Address| mint_cap_owner@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@34 T@$Value) )  (=> ((_ is $Type) coin_type@@34) (|b#$Boolean| ($Boolean (forall ((addr3@@18 T@$Value) )  (=> ((_ is $Address) addr3@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@34)) 1) (|a#$Address| addr3@@18)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@34)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@34)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@35 T@$Value) )  (=> ((_ is $Type) coin_type@@35) (|b#$Boolean| ($Boolean (forall ((addr1@@11 T@$Value) )  (=> ((_ is $Address) addr1@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@35)) 1) (|a#$Address| addr1@@11)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@11)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@36 T@$Value) )  (=> ((_ is $Type) coin_type@@36) (|b#$Boolean| ($Boolean (forall ((addr1@@12 T@$Value) )  (=> ((_ is $Address) addr1@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@36)) 1) (|a#$Address| addr1@@12)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@12)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 286130) 277025)))) inline$$Diem_preburn_to_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@23  (=> ((_ is $Address) account@@2) (=> (and (and (and (and (and ((_ is $Vector) coin@@4) (let ((va@@382 (|v#$Vector| coin@@4)))
(let ((l@@382 (|l#$ValueArray| va@@382)))
 (and (and (<= 0 l@@382) (<= l@@382 $MAX_U64)) (forall ((x@@382 Int) ) (!  (=> (or (< x@@382 0) (>= x@@382 l@@382)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@382) x@@382) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@382) x@@382))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@4)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 275968) 286130)) anon0$1_correct@@22))))
(let ((PreconditionGeneratedEntry_correct@@15  (=> (= (ControlFlow 0 474859) 275968) anon0_correct@@23)))
PreconditionGeneratedEntry_correct@@15))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@19 () Bool)
(declare-fun $tv0@@31 () T@$TypeValue)
(declare-fun inline$$Diem_preburn_value_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@23 () Bool)
(declare-fun $abort_flag@1@@22 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@15 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@3 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@9 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@9 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@9 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@16 () T@$Value)
(declare-fun $abort_code@1@@20 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 484453) (let ((anon0$2_correct@@24  (and (=> (= (ControlFlow 0 288284) (- 0 487078)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487127)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@380 T@$Value) )  (=> ((_ is $Address) addr@@380) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@380))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@380)))))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@381 T@$Value) )  (=> ((_ is $Address) addr@@381) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@381))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@381))))))))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487207)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@382 T@$Value) )  (=> ((_ is $Address) addr@@382) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@382)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@382))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@383 T@$Value) )  (=> ((_ is $Address) addr@@383) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@383)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@383)))))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487275)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487324)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@384 T@$Value) )  (=> ((_ is $Address) addr@@384) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@384))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@384)))))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@385 T@$Value) )  (=> ((_ is $Address) addr@@385) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@385))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@385))))))))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487404)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@386 T@$Value) )  (=> ((_ is $Address) addr@@386) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@386)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@386))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@387 T@$Value) )  (=> ((_ is $Address) addr@@387) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@387)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@387)))))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487472)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487521)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487570)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@388 T@$Value) )  (=> ((_ is $Address) addr@@388) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@388))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@388)))))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@389 T@$Value) )  (=> ((_ is $Address) addr@@389) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@389))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@389))))))))))))))) (and (=> (= (ControlFlow 0 288284) (- 0 487650)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@390 T@$Value) )  (=> ((_ is $Address) addr@@390) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@390)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@390))))))))))))) (=> (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean (forall ((addr@@391 T@$Value) )  (=> ((_ is $Address) addr@@391) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@391)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@391)))))))))))) (=> (= (ControlFlow 0 288284) (- 0 487718)) (=> (not $abort_flag@2@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_preburn_value_$def_verify$0$Abort_correct  (=> (= inline$$Diem_preburn_value_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@19 true) (= (ControlFlow 0 288244) 288284)) anon0$2_correct@@24))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 288266) 288244)) inline$$Diem_preburn_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 288276) 288244) inline$$Diem_preburn_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@23 (and (=> (= (ControlFlow 0 288260) 288276) inline$$Diem_preburn_value_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 288260) 288266) inline$$Diem_preburn_value_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 288236) 288244)) inline$$Diem_preburn_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 288252) 288244) inline$$Diem_preburn_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@22 (and (=> (= (ControlFlow 0 288230) 288252) inline$$Diem_preburn_value_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 288230) 288236) inline$$Diem_preburn_value_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@0@@23 (= (ControlFlow 0 288256) 288244)) inline$$Diem_preburn_value_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@2@@19 $abort_flag@1@@22) (= (ControlFlow 0 288218) 288284)) anon0$2_correct@@24)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 288216) 288218)) inline$$Diem_preburn_value_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 288226) 288218) inline$$Diem_preburn_value_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@15  (=> (= inline$$GetFieldFromValue$0$dst@1@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@3)) $Diem_CurrencyInfo_preburn_value)) (and (=> (= (ControlFlow 0 288200) 288226) inline$$Diem_preburn_value_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 288200) 288216) inline$$Diem_preburn_value_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@22) (= (ControlFlow 0 288206) 288200)) inline$$GetFieldFromValue$0$anon0_correct@@15)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@9  (=> (= $abort_flag@1@@22 true) (and (=> (= (ControlFlow 0 288146) 288230) inline$$Diem_preburn_value_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 288146) 288206) inline$$Diem_preburn_value_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@9  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@9 inline$$GetGlobal$0$a@1@@9)) (= (ControlFlow 0 288144) 288146)) inline$$GetGlobal$0$anon3_Then$1_correct@@9)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@9  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@9 inline$$GetGlobal$0$a@1@@9) (=> (and (= inline$$GetGlobal$0$dst@1@@9 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@9 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@16))) (= $abort_flag@1@@22 $abort_flag@0@@23)) (and (=> (= (ControlFlow 0 288092) 288230) inline$$Diem_preburn_value_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 288092) 288206) inline$$Diem_preburn_value_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@9  (=> (= inline$$GetGlobal$0$a@1@@9 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@16)) (and (=> (= (ControlFlow 0 288074) 288144) inline$$GetGlobal$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 288074) 288092) inline$$GetGlobal$0$anon3_Else_correct@@9)))))
(let ((inline$$GetGlobal$0$Entry_correct@@9  (=> (= inline$$GetGlobal$0$ta@0@@9 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1)) (and (=> (= (ControlFlow 0 288068) (- 0 486929)) true) (=> (= (ControlFlow 0 288068) 288074) inline$$GetGlobal$0$anon0_correct@@9)))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@23) (= (ControlFlow 0 288152) 288068)) inline$$GetGlobal$0$Entry_correct@@9)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@16  (=> (not true) (and (=> (= (ControlFlow 0 287935) 288256) inline$$Diem_preburn_value_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 287935) 288152) inline$$Diem_preburn_value_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@16  (and (=> (= (ControlFlow 0 287945) 288256) inline$$Diem_preburn_value_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 287945) 288152) inline$$Diem_preburn_value_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@16  (=> (and (not $abort_flag@0@@23) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@16 ($Address 173345816))) (and (=> (= (ControlFlow 0 287929) 287945) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@16) (=> (= (ControlFlow 0 287929) 287935) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@16)))))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@23) (= (ControlFlow 0 287959) 287929)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@16)))
(let ((inline$$Diem_preburn_value_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@23) (=> $abort_flag@0@@23 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@23 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@20 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@392 T@$Value) )  (=> ((_ is $Address) addr@@392) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@392))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@392))))))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@393 T@$Value) )  (=> ((_ is $Address) addr@@393) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@393)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@393)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@394 T@$Value) )  (=> ((_ is $Address) addr@@394) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@394))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@394)))))))))))))))) (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@395 T@$Value) )  (=> ((_ is $Address) addr@@395) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@395)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@395)))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@396 T@$Value) )  (=> ((_ is $Address) addr@@396) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@396))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@396)))))))))))))))) (and (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean (forall ((addr@@397 T@$Value) )  (=> ((_ is $Address) addr@@397) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@397)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| addr@@397)))))))))))) (=> (not $abort_flag@0@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@31) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 287824) 288260) inline$$Diem_preburn_value_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 287824) 287959) inline$$Diem_preburn_value_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@23  (=> (forall (($inv_addr@@48 Int) ($inv_tv0@@42 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48)) (let ((va@@383 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))))
(let ((l@@383 (|l#$ValueArray| va@@383)))
 (and (and (<= 0 l@@383) (<= l@@383 $MAX_U64)) (forall ((x@@383 Int) ) (!  (=> (or (< x@@383 0) (>= x@@383 l@@383)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@383) x@@383) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@383) x@@383))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@384 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@384 (|l#$ValueArray| va@@384)))
 (and (and (<= 0 l@@384) (<= l@@384 $MAX_U64)) (forall ((x@@384 Int) ) (!  (=> (or (< x@@384 0) (>= x@@384 l@@384)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@384) x@@384) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@384) x@@384))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code)) (let ((va@@385 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@385 (|l#$ValueArray| va@@385)))
 (and (and (<= 0 l@@385) (<= l@@385 $MAX_U64)) (forall ((x@@385 Int) ) (!  (=> (or (< x@@385 0) (>= x@@385 l@@385)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@385) x@@385) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@385) x@@385))
))))))) (forall (($$0@@128 Int) ) (!  (=> (and (>= $$0@@128 0) (< $$0@@128 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))) $$0@@128)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))) $$0@@128)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))) $$0@@128)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_currency_code))) $$0@@128))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events)) (let ((va@@386 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@386 (|l#$ValueArray| va@@386)))
 (and (and (<= 0 l@@386) (<= l@@386 $MAX_U64)) (forall ((x@@386 Int) ) (!  (=> (or (< x@@386 0) (>= x@@386 l@@386)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@386) x@@386) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@386) x@@386))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@387 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@387 (|l#$ValueArray| va@@387)))
 (and (and (<= 0 l@@387) (<= l@@387 $MAX_U64)) (forall ((x@@387 Int) ) (!  (=> (or (< x@@387 0) (>= x@@387 l@@387)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@387) x@@387) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@387) x@@387))
))))))) (forall (($$0@@129 Int) ) (!  (=> (and (>= $$0@@129 0) (< $$0@@129 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@129)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@129)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@129)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@129))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events)) (let ((va@@388 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@388 (|l#$ValueArray| va@@388)))
 (and (and (<= 0 l@@388) (<= l@@388 $MAX_U64)) (forall ((x@@388 Int) ) (!  (=> (or (< x@@388 0) (>= x@@388 l@@388)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@388) x@@388) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@388) x@@388))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@389 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@389 (|l#$ValueArray| va@@389)))
 (and (and (<= 0 l@@389) (<= l@@389 $MAX_U64)) (forall ((x@@389 Int) ) (!  (=> (or (< x@@389 0) (>= x@@389 l@@389)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@389) x@@389) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@389) x@@389))
))))))) (forall (($$0@@130 Int) ) (!  (=> (and (>= $$0@@130 0) (< $$0@@130 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@130)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@130)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@130)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@130))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@390 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@390 (|l#$ValueArray| va@@390)))
 (and (and (<= 0 l@@390) (<= l@@390 $MAX_U64)) (forall ((x@@390 Int) ) (!  (=> (or (< x@@390 0) (>= x@@390 l@@390)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@390) x@@390) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@390) x@@390))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@391 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@391 (|l#$ValueArray| va@@391)))
 (and (and (<= 0 l@@391) (<= l@@391 $MAX_U64)) (forall ((x@@391 Int) ) (!  (=> (or (< x@@391 0) (>= x@@391 l@@391)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@391) x@@391) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@391) x@@391))
))))))) (forall (($$0@@131 Int) ) (!  (=> (and (>= $$0@@131 0) (< $$0@@131 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@131)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@131)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@131)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@131))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@392 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@392 (|l#$ValueArray| va@@392)))
 (and (and (<= 0 l@@392) (<= l@@392 $MAX_U64)) (forall ((x@@392 Int) ) (!  (=> (or (< x@@392 0) (>= x@@392 l@@392)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@392) x@@392) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@392) x@@392))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@393 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@393 (|l#$ValueArray| va@@393)))
 (and (and (<= 0 l@@393) (<= l@@393 $MAX_U64)) (forall ((x@@393 Int) ) (!  (=> (or (< x@@393 0) (>= x@@393 l@@393)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@393) x@@393) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@393) x@@393))
))))))) (forall (($$0@@132 Int) ) (!  (=> (and (>= $$0@@132 0) (< $$0@@132 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@132)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@132)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@132)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@132))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@394 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@394 (|l#$ValueArray| va@@394)))
 (and (and (<= 0 l@@394) (<= l@@394 $MAX_U64)) (forall ((x@@394 Int) ) (!  (=> (or (< x@@394 0) (>= x@@394 l@@394)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@394) x@@394) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@394) x@@394))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@395 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@395 (|l#$ValueArray| va@@395)))
 (and (and (<= 0 l@@395) (<= l@@395 $MAX_U64)) (forall ((x@@395 Int) ) (!  (=> (or (< x@@395 0) (>= x@@395 l@@395)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@395) x@@395) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@395) x@@395))
))))))) (forall (($$0@@133 Int) ) (!  (=> (and (>= $$0@@133 0) (< $$0@@133 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@133)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@133)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@133)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@133))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@42) 1) $inv_addr@@48))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@37 T@$Value) )  (=> ((_ is $Type) coin_type@@37) (|b#$Boolean| ($Boolean (forall ((addr3@@19 T@$Value) )  (=> ((_ is $Address) addr3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@37)) 1) (|a#$Address| addr3@@19)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@37)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@37)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 288282) 287824)) inline$$Diem_preburn_value_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@24  (=> (= (ControlFlow 0 484453) 288282) anon0$1_correct@@23)))
anon0_correct@@24))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun preburn@@1 () T@$Value)
(declare-fun $abort_flag@7@@7 () Bool)
(declare-fun $tv0@@32 () T@$TypeValue)
(declare-fun coin@@5 () T@$Value)
(declare-fun $abort_code@11@@7 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@8 () T@$Memory)
(declare-fun $abort_code@9@@8 () Int)
(declare-fun $abort_flag@6@@9 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0@@8 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@7| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@7 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@7 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@7 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@7 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@6| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@7| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@7| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@6| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@6 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@6 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@6| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1@@4 () T@$Mutation)
(declare-fun inline$$ReadRef$5$v@1@@4 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@7| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@7 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@7 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@7 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@7 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@7| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@9 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@10@@7 () Int)
(declare-fun $abort_code@1@@21 () Int)
(declare-fun $abort_flag@0@@24 () Bool)
(declare-fun $abort_code@3@@16 () Int)
(declare-fun $abort_flag@1@@23 () Bool)
(declare-fun $abort_code@4@@15 () Int)
(declare-fun $abort_flag@2@@20 () Bool)
(declare-fun $abort_code@5@@12 () Int)
(declare-fun $abort_flag@3@@14 () Bool)
(declare-fun $abort_code@6@@11 () Int)
(declare-fun $abort_flag@4@@12 () Bool)
(declare-fun $abort_code@7@@10 () Int)
(declare-fun $abort_flag@5@@9 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@7 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@16 () T@$Value)
(declare-fun call3formal@$ret0@0@@45 () T@$Value)
(declare-fun preburn_address@@5 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1@@4 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1@@4 () Int)
(declare-fun inline$$BorrowField$6$p@2@@4 () T@$Path)
(declare-fun inline$$ReadRef$4$v@1@@7 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@7 () Int)
(declare-fun inline$$BorrowField$5$p@2@@7 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@7 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@7| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@7 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@7 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@7| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@7 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2@@2 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@7 () Int)
(declare-fun inline$$BorrowField$4$p@2@@7 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$3$v@1@@7 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1@@2 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@7 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@7 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@7 () Int)
(declare-fun inline$$BorrowField$3$p@2@@7 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@8 () T@$Value)
(declare-fun $abort_code@8@@8 () Int)
(declare-fun call3formal@$ret0@0@@46 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$t27@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2@@8 () T@$Value)
(declare-fun inline$$Sub$0$dst@0@@8 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$t23@1 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@7 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@8 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@8 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@8 () Int)
(declare-fun inline$$BorrowField$2$p@2@@8 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@7 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@7 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@7 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@7 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@7 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@17 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@8| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@6| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@6 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@9| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@8 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@8 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@8| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@8 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@8 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@8 () Int)
(declare-fun inline$$BorrowField$1$p@2@@8 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$t17@1 () T@$Value)
(declare-fun $abort_code@2@@15 () Int)
(declare-fun call3formal@$ret0@0@@47 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def_verify$0$$t18@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@9 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@8 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@8 () Int)
(declare-fun inline$$BorrowField$0$p@2@@8 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 487771) (let ((anon0$2_correct@@25  (and (=> (= (ControlFlow 0 296769) (- 0 496818)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@7@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@7@@7) (and (=> (= (ControlFlow 0 296769) (- 0 496843)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@7@@7)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@7@@7) (and (=> (= (ControlFlow 0 296769) (- 0 496883)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@7) (and (=> (= (ControlFlow 0 296769) (- 0 496899)) (=> $abort_flag@7@@7 (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@7@@7 (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 496978)) (=> $abort_flag@7@@7 (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@7@@7 (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11@@7 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 296769) (- 0 497090)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497133)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497179)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@398 T@$Value) )  (=> ((_ is $Address) addr@@398) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@398))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@398)))))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@399 T@$Value) )  (=> ((_ is $Address) addr@@399) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@399))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@399))))))))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497259)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@400 T@$Value) )  (=> ((_ is $Address) addr@@400) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@400)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@400))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@401 T@$Value) )  (=> ((_ is $Address) addr@@401) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@401)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@401)))))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497327)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497373)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@402 T@$Value) )  (=> ((_ is $Address) addr@@402) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@402))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@402)))))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@403 T@$Value) )  (=> ((_ is $Address) addr@@403) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@403))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@403))))))))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497453)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@404 T@$Value) )  (=> ((_ is $Address) addr@@404) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@404)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@404))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@405 T@$Value) )  (=> ((_ is $Address) addr@@405) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@405)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@405)))))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497521)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497567)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@406 T@$Value) )  (=> ((_ is $Address) addr@@406) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@406))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@406)))))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@407 T@$Value) )  (=> ((_ is $Address) addr@@407) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@407))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@407))))))))))))))) (and (=> (= (ControlFlow 0 296769) (- 0 497647)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@408 T@$Value) )  (=> ((_ is $Address) addr@@408) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@408)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@408))))))))))))) (=> (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean (forall ((addr@@409 T@$Value) )  (=> ((_ is $Address) addr@@409) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@409)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@409)))))))))))) (=> (= (ControlFlow 0 296769) (- 0 497715)) (=> (not $abort_flag@7@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@8) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon62_correct  (=> (and (and (= $abort_code@11@@7 $abort_code@9@@8) (= $abort_flag@7@@7 $abort_flag@6@@9)) (and (= $Diem_CurrencyInfo_$memory@1@@8 $Diem_CurrencyInfo_$memory@0@@8) (= (ControlFlow 0 295022) 296769))) anon0$2_correct@@25)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 295020) 295022)) inline$$Diem_preburn_with_resource_$def_verify$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Then_correct  (=> (= (ControlFlow 0 295030) 295022) inline$$Diem_preburn_with_resource_$def_verify$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon60$3_correct  (and (=> (= (ControlFlow 0 296535) (- 0 496369)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 296535) (- 0 496493)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 296535) (- 0 496546)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@0))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@8 |inline$$WritebackToGlobal$1$m'@2@@7|) (and (=> (= (ControlFlow 0 296535) 295030) inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 296535) 295020) inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@7  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@7)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@7| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 296214) 296535)) inline$$Diem_preburn_with_resource_$def_verify$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@7  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@7) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@7 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@7)) (= inline$$WritebackToGlobal$1$a@1@@7 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@7))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@7 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@6|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@7 inline$$WritebackToGlobal$1$a@1@@7) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@6|))) (= |inline$$WritebackToGlobal$1$m'@1@@7| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@7 inline$$WritebackToGlobal$1$a@1@@7 inline$$WritebackToGlobal$1$v@1@@7)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@7| |inline$$WritebackToGlobal$1$m'@1@@7|) (= (ControlFlow 0 296268) 296535))) inline$$Diem_preburn_with_resource_$def_verify$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@7  (=> (= inline$$WritebackToGlobal$1$l@1@@7 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@6|)) (and (=> (= (ControlFlow 0 296204) 296268) inline$$WritebackToGlobal$1$anon3_Then_correct@@7) (=> (= (ControlFlow 0 296204) 296214) inline$$WritebackToGlobal$1$anon3_Else_correct@@7)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon60$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 296274) 296204)) inline$$WritebackToGlobal$1$anon0_correct@@7)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@7  (and (=> (= (ControlFlow 0 295957) (- 0 496087)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 295957) 296274) inline$$Diem_preburn_with_resource_$def_verify$0$anon60$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@7  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@7 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@6|)) (= (ControlFlow 0 295909) 295957)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@7)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@6  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@6 inline$$WritebackToReference$2$srcPath@1@@6))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@6| |inline$$WritebackToReference$1$dst'@2@@7|) (= (ControlFlow 0 295778) 295909)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@7))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@6  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@6|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@6) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@6))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@6 inline$$WritebackToReference$2$srcPath@1@@6)) (= |inline$$WritebackToReference$2$dst'@1@@6| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) inline$$WritebackToReference$2$dstPath@1@@6 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@6 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@6) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@6|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@6| |inline$$WritebackToReference$2$dst'@1@@6|) (= (ControlFlow 0 295834) 295909))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@7)))
(let ((inline$$WritebackToReference$2$anon0_correct@@6  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@6 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@6|)) (= inline$$WritebackToReference$2$dstPath@1@@6 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|))) (and (=> (= (ControlFlow 0 295742) 295834) inline$$WritebackToReference$2$anon3_Then_correct@@6) (=> (= (ControlFlow 0 295742) 295778) inline$$WritebackToReference$2$anon3_Else_correct@@6)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 295605) 295742)) inline$$WritebackToReference$2$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon92_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|)) (= (ControlFlow 0 296545) 295742)) inline$$WritebackToReference$2$anon0_correct@@6)))
(let ((inline$$WriteRef$2$anon0_correct@@6  (=> (= |inline$$WriteRef$2$to'@1@@6| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1@@4) (|p#$Mutation| inline$$BorrowField$6$dst@1@@4) inline$$ReadRef$5$v@1@@4)) (and (=> (= (ControlFlow 0 295591) 296545) inline$$Diem_preburn_with_resource_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 295591) 295605) inline$$Diem_preburn_with_resource_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon90_Else_correct  (=> (and (not $abort_flag@6@@9) (= (ControlFlow 0 295597) 295591)) inline$$WriteRef$2$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else$2_correct  (and (=> (= (ControlFlow 0 295010) (- 0 495433)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@2 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@3))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@3 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@3))))))))))))))))))))) (and (=> (= (ControlFlow 0 295010) (- 0 495557)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@8 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@8) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@8)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@9 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@9) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@9)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$addr3@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@9)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 295010) (- 0 495610)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@10 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@10) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@10)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@1)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@11 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@11) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@2)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@7|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@11)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$dr_addr@@2))))))))))))))) (=> (= $Diem_CurrencyInfo_$memory@0@@8 |inline$$WritebackToGlobal$0$m'@2@@7|) (and (=> (= (ControlFlow 0 295010) 295030) inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 295010) 295020) inline$$Diem_preburn_with_resource_$def_verify$0$anon93_Else_correct)))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@7  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@7)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@7| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 294689) 295010)) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@7  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@7) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@7 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@7)) (= inline$$WritebackToGlobal$0$a@1@@7 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@7))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@7 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@7 inline$$WritebackToGlobal$0$a@1@@7) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|))) (= |inline$$WritebackToGlobal$0$m'@1@@7| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@7 inline$$WritebackToGlobal$0$a@1@@7 inline$$WritebackToGlobal$0$v@1@@7)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@7| |inline$$WritebackToGlobal$0$m'@1@@7|) (= (ControlFlow 0 294743) 295010))) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@7  (=> (= inline$$WritebackToGlobal$0$l@1@@7 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|)) (and (=> (= (ControlFlow 0 294679) 294743) inline$$WritebackToGlobal$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 294679) 294689) inline$$WritebackToGlobal$0$anon3_Else_correct@@7)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12 T@$Value) )  (=> ((_ is $Type) inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@4 T@$Value) )  (=> ((_ is $Address) inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_preburn_with_resource_$def_verify$0$coin_type@@12)) 1) (|a#$Address| inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@4))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner1@@4 inline$$Diem_preburn_with_resource_$def_verify$0$mint_cap_owner2@@4))))))))))))))))))))) (= (ControlFlow 0 294749) 294679)) inline$$WritebackToGlobal$0$anon0_correct@@7)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@7  (and (=> (= (ControlFlow 0 294432) (- 0 495151)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 294432) 294749) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@7  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@7 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|)) (= (ControlFlow 0 294384) 294432)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@9)) (= (ControlFlow 0 294436) 294384)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct  (=> (= inline$$Diem_preburn_with_resource_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $abort_code@11@@7 $abort_code@10@@7) (= $abort_flag@7@@7 true)) (and (= $Diem_CurrencyInfo_$memory@1@@8 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 291603) 296769))) anon0$2_correct@@25))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon13_correct  (=> (and (= $abort_code@10@@7 $abort_code@1@@21) (= (ControlFlow 0 296721) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 296719) 296721)) inline$$Diem_preburn_with_resource_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon69_Then_correct  (=> (= (ControlFlow 0 296729) 296721) inline$$Diem_preburn_with_resource_$def_verify$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon68_Then_correct  (=> $abort_flag@0@@24 (and (=> (= (ControlFlow 0 296713) 296729) inline$$Diem_preburn_with_resource_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 296713) 296719) inline$$Diem_preburn_with_resource_$def_verify$0$anon69_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon21_correct  (=> (and (= $abort_code@10@@7 $abort_code@3@@16) (= (ControlFlow 0 296701) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 296699) 296701)) inline$$Diem_preburn_with_resource_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon73_Then_correct  (=> (= (ControlFlow 0 296709) 296701) inline$$Diem_preburn_with_resource_$def_verify$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon72_Then_correct  (=> $abort_flag@1@@23 (and (=> (= (ControlFlow 0 296693) 296709) inline$$Diem_preburn_with_resource_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 296693) 296699) inline$$Diem_preburn_with_resource_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon27_correct  (=> (and (= $abort_code@10@@7 $abort_code@4@@15) (= (ControlFlow 0 296671) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 296669) 296671)) inline$$Diem_preburn_with_resource_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon76_Then_correct  (=> (= (ControlFlow 0 296679) 296671) inline$$Diem_preburn_with_resource_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon75_Then_correct  (=> $abort_flag@2@@20 (and (=> (= (ControlFlow 0 296663) 296679) inline$$Diem_preburn_with_resource_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 296663) 296669) inline$$Diem_preburn_with_resource_$def_verify$0$anon76_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon33_correct  (=> (and (= $abort_code@10@@7 $abort_code@5@@12) (= (ControlFlow 0 296647) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 296645) 296647)) inline$$Diem_preburn_with_resource_$def_verify$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon79_Then_correct  (=> (= (ControlFlow 0 296655) 296647) inline$$Diem_preburn_with_resource_$def_verify$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Then_correct  (=> $abort_flag@3@@14 (and (=> (= (ControlFlow 0 296639) 296655) inline$$Diem_preburn_with_resource_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 296639) 296645) inline$$Diem_preburn_with_resource_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon37_correct  (=> (and (= $abort_code@10@@7 $abort_code@6@@11) (= (ControlFlow 0 296627) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 296625) 296627)) inline$$Diem_preburn_with_resource_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon81_Then_correct  (=> (= (ControlFlow 0 296635) 296627) inline$$Diem_preburn_with_resource_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Then_correct  (=> $abort_flag@4@@12 (and (=> (= (ControlFlow 0 296619) 296635) inline$$Diem_preburn_with_resource_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 296619) 296625) inline$$Diem_preburn_with_resource_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon41_correct  (=> (and (= $abort_code@10@@7 $abort_code@7@@10) (= (ControlFlow 0 296607) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 296605) 296607)) inline$$Diem_preburn_with_resource_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 296615) 296607) inline$$Diem_preburn_with_resource_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon82_Then_correct  (=> $abort_flag@5@@9 (and (=> (= (ControlFlow 0 296599) 296615) inline$$Diem_preburn_with_resource_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 296599) 296605) inline$$Diem_preburn_with_resource_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon49_correct  (=> (and (= $abort_code@10@@7 $abort_code@9@@8) (= (ControlFlow 0 296587) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 296585) 296587)) inline$$Diem_preburn_with_resource_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon87_Then_correct  (=> (= (ControlFlow 0 296595) 296587) inline$$Diem_preburn_with_resource_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Then_correct  (=> $abort_flag@6@@9 (and (=> (= (ControlFlow 0 296579) 296595) inline$$Diem_preburn_with_resource_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 296579) 296585) inline$$Diem_preburn_with_resource_$def_verify$0$anon87_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon57_correct  (=> (and (= $abort_code@10@@7 $abort_code@9@@8) (= (ControlFlow 0 296557) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 296555) 296557)) inline$$Diem_preburn_with_resource_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon91_Then_correct  (=> (= (ControlFlow 0 296565) 296557) inline$$Diem_preburn_with_resource_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon90_Then_correct  (=> $abort_flag@6@@9 (and (=> (= (ControlFlow 0 296549) 296565) inline$$Diem_preburn_with_resource_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 296549) 296555) inline$$Diem_preburn_with_resource_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@7  (=> (= inline$$Event_emit_event$0$t@0@@7 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 295522) 296549) inline$$Diem_preburn_with_resource_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 295522) 295597) inline$$Diem_preburn_with_resource_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 295532) (- 0 495890)) true) (=> (= (ControlFlow 0 295532) 295522) inline$$Event_emit_event$0$Entry_correct@@7))))
(let ((inline$$ReadRef$5$anon0_correct@@4  (=> (and (= inline$$ReadRef$5$v@1@@4 (|v#$Mutation| inline$$BorrowField$6$dst@1@@4)) (= (ControlFlow 0 295474) 295532)) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Then$3_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 295430) 295474)) inline$$ReadRef$5$anon0_correct@@4)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct@@1  (=> (= (ControlFlow 0 295436) 295474) inline$$ReadRef$5$anon0_correct@@4)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 295424) 295436) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 295424) 295430) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct@@1  (=> (and (>= 0 0) (= (ControlFlow 0 295416) 295474)) inline$$ReadRef$5$anon0_correct@@4)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct@@1  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@16) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@45) (let ((va@@396 (|v#$Vector| call3formal@$ret0@0@@45)))
(let ((l@@396 (|l#$ValueArray| va@@396)))
 (and (and (<= 0 l@@396) (<= l@@396 $MAX_U64)) (forall ((x@@396 Int) ) (!  (=> (or (< x@@396 0) (>= x@@396 l@@396)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@396) x@@396) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@396) x@@396))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0@@1 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0@@1 0) (< inline$$Diem_PreburnEvent_pack$0$$$0@@1 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) inline$$Diem_PreburnEvent_pack$0$$$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) inline$$Diem_PreburnEvent_pack$0$$$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) inline$$Diem_PreburnEvent_pack$0$$$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) inline$$Diem_PreburnEvent_pack$0$$$0@@1))
))) (and ((_ is $Address) preburn_address@@5) (= inline$$Diem_PreburnEvent_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@16) 1 call3formal@$ret0@0@@45) 2 preburn_address@@5) 3))))) (and (=> (= (ControlFlow 0 295408) 295424) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 295408) 295416) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct@@1))))))
(let ((inline$$BorrowField$6$anon0_correct@@4  (=> (= inline$$BorrowField$6$p@1@@4 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|)) (=> (and (and (= inline$$BorrowField$6$size@1@@4 (|size#$Path| inline$$BorrowField$6$p@1@@4)) (= inline$$BorrowField$6$p@2@@4 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1@@4) inline$$BorrowField$6$size@1@@4 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$6$size@1@@4 1)))) (and (= inline$$BorrowField$6$dst@1@@4 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) inline$$BorrowField$6$p@2@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 295152) 295408))) inline$$Diem_PreburnEvent_pack$0$anon0_correct@@1))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@9) (= (ControlFlow 0 295158) 295152)) inline$$BorrowField$6$anon0_correct@@4)))
(let ((inline$$Not$0$anon0_correct@@9  (=> (= inline$$Not$0$dst@1@@9 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$4$v@1@@7)))) (and (=> (= (ControlFlow 0 294301) 295158) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 294301) 294436) inline$$Diem_preburn_with_resource_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@9  (and (=> (= (ControlFlow 0 294291) (- 0 495112)) true) (=> (= (ControlFlow 0 294291) 294301) inline$$Not$0$anon0_correct@@9))))
(let ((inline$$ReadRef$4$anon0_correct@@7  (=> (and (= inline$$ReadRef$4$v@1@@7 (|v#$Mutation| inline$$BorrowField$5$dst@1@@7)) (= (ControlFlow 0 294243) 294291)) inline$$Not$0$Entry_correct@@9)))
(let ((inline$$BorrowField$5$anon0_correct@@7  (=> (= inline$$BorrowField$5$p@1@@7 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|)) (=> (and (and (= inline$$BorrowField$5$size@1@@7 (|size#$Path| inline$$BorrowField$5$p@1@@7)) (= inline$$BorrowField$5$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@7) inline$$BorrowField$5$size@1@@7 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$5$size@1@@7 1)))) (and (= inline$$BorrowField$5$dst@1@@7 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|) inline$$BorrowField$5$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@7|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 294205) 294243))) inline$$ReadRef$4$anon0_correct@@7))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@7  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@7 inline$$WritebackToReference$1$srcPath@1@@7))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@7| inline$$BorrowGlobal$0$dst@2@@7) (= (ControlFlow 0 293989) 294205)) inline$$BorrowField$5$anon0_correct@@7))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@7  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@7|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@7) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@7))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@7 inline$$WritebackToReference$1$srcPath@1@@7)) (= |inline$$WritebackToReference$1$dst'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) inline$$WritebackToReference$1$dstPath@1@@7 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@7 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@7) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@7|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@7| |inline$$WritebackToReference$1$dst'@1@@7|) (= (ControlFlow 0 294045) 294205))) inline$$BorrowField$5$anon0_correct@@7)))
(let ((inline$$WritebackToReference$1$anon0_correct@@7  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@7 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@7|)) (= inline$$WritebackToReference$1$dstPath@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@7))) (and (=> (= (ControlFlow 0 293953) 294045) inline$$WritebackToReference$1$anon3_Then_correct@@7) (=> (= (ControlFlow 0 293953) 293989) inline$$WritebackToReference$1$anon3_Else_correct@@7)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 293816) 293953)) inline$$WritebackToReference$1$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon88_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (= (ControlFlow 0 296575) 293953)) inline$$WritebackToReference$1$anon0_correct@@7)))
(let ((inline$$WriteRef$1$anon0_correct@@7  (=> (= |inline$$WriteRef$1$to'@1@@7| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1@@7) (|p#$Mutation| inline$$BorrowField$4$dst@1@@7) inline$$AddU64$0$dst@2@@2)) (and (=> (= (ControlFlow 0 293802) 296575) inline$$Diem_preburn_with_resource_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 293802) 293816) inline$$Diem_preburn_with_resource_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct@@7  (=> (= inline$$BorrowField$4$p@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (=> (and (and (= inline$$BorrowField$4$size@1@@7 (|size#$Path| inline$$BorrowField$4$p@1@@7)) (= inline$$BorrowField$4$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@7) inline$$BorrowField$4$size@1@@7 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1@@7 1)))) (and (= inline$$BorrowField$4$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) inline$$BorrowField$4$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 293743) 293802))) inline$$WriteRef$1$anon0_correct@@7))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Else_correct  (=> (and (not $abort_flag@6@@9) (= (ControlFlow 0 293749) 293743)) inline$$BorrowField$4$anon0_correct@@7)))
(let ((inline$$AddU64$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@6@@9 true) (=> (and (= $abort_code@9@@8 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@0@@2)) (and (=> (= (ControlFlow 0 293613) 296579) inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 293613) 293749) inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct@@2  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$3$v@1@@7) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16)) $MAX_U64) (= (ControlFlow 0 293611) 293613)) inline$$AddU64$0$anon3_Then$1_correct@@2)))
(let ((inline$$AddU64$0$anon3_Else_correct@@2  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$3$v@1@@7) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16))) (=> (and (and (= inline$$AddU64$0$dst@1@@2 ($Integer (+ (|i#$Integer| inline$$ReadRef$3$v@1@@7) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16)))) (= $abort_flag@6@@9 $abort_flag@5@@9)) (and (= $abort_code@9@@8 $abort_code@7@@10) (= inline$$AddU64$0$dst@2@@2 inline$$AddU64$0$dst@1@@2))) (and (=> (= (ControlFlow 0 293555) 296579) inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 293555) 293749) inline$$Diem_preburn_with_resource_$def_verify$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 293525) (- 0 494686)) true) (and (=> (= (ControlFlow 0 293525) 293611) inline$$AddU64$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 293525) 293555) inline$$AddU64$0$anon3_Else_correct@@2)))))
(let ((inline$$ReadRef$3$anon0_correct@@7  (=> (and (= inline$$ReadRef$3$v@1@@7 (|v#$Mutation| inline$$BorrowField$3$dst@1@@7)) (= (ControlFlow 0 293418) 293525)) inline$$AddU64$0$Entry_correct@@2)))
(let ((inline$$BorrowField$3$anon0_correct@@7  (=> (= inline$$BorrowField$3$p@1@@7 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (=> (and (and (= inline$$BorrowField$3$size@1@@7 (|size#$Path| inline$$BorrowField$3$p@1@@7)) (= inline$$BorrowField$3$p@2@@7 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@7) inline$$BorrowField$3$size@1@@7 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@7 1)))) (and (= inline$$BorrowField$3$dst@1@@7 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) inline$$BorrowField$3$p@2@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 293380) 293418))) inline$$ReadRef$3$anon0_correct@@7))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@8) (= (ControlFlow 0 293432) 293380)) inline$$BorrowField$3$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon46_correct  (=> (and (= $abort_code@10@@7 $abort_code@8@@8) (= (ControlFlow 0 293214) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 293212) 293214)) inline$$Diem_preburn_with_resource_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon85_Then_correct  (=> (= (ControlFlow 0 293222) 293214) inline$$Diem_preburn_with_resource_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Else$1_correct  (=> (= $abort_code@8@@8 (|i#$Integer| call3formal@$ret0@0@@46)) (and (=> (= (ControlFlow 0 293206) 293222) inline$$Diem_preburn_with_resource_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 293206) 293212) inline$$Diem_preburn_with_resource_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@7  (and (=> (= (ControlFlow 0 293196) (- 0 494518)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 293196) 293206) inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@7  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@7 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (= (ControlFlow 0 293148) 293196)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@8)) (= (ControlFlow 0 293200) 293148)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon82_Else_correct  (=> (not $abort_flag@5@@9) (and (=> (= (ControlFlow 0 293073) 293432) inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 293073) 293200) inline$$Diem_preburn_with_resource_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Else$1_correct  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$t27@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@9)) (and (=> $abort_flag@5@@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@46 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@46) (>= (|i#$Integer| call3formal@$ret0@0@@46) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@46) $MAX_U64))) (and (=> (= (ControlFlow 0 293067) 296599) inline$$Diem_preburn_with_resource_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 293067) 293073) inline$$Diem_preburn_with_resource_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@8  (=> (and (= inline$$Ge$0$dst@1@@8 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2@@8) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@16)))) (= (ControlFlow 0 293055) 293067)) inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct@@8  (and (=> (= (ControlFlow 0 293041) (- 0 494408)) true) (=> (= (ControlFlow 0 293041) 293055) inline$$Ge$0$anon0_correct@@8))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Else_correct  (=> (and (not $abort_flag@4@@12) (= (ControlFlow 0 293061) 293041)) inline$$Ge$0$Entry_correct@@8)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@8  (=> (= $abort_code@6@@11 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@12 true) (= inline$$Sub$0$dst@2@@8 inline$$Sub$0$dst@0@@8)) (and (=> (= (ControlFlow 0 292985) 296619) inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 292985) 293061) inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@8  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def_verify$0$$t23@1) (|i#$Integer| inline$$ReadRef$2$v@1@@7)) (= (ControlFlow 0 292983) 292985)) inline$$Sub$0$anon3_Then$1_correct@@8)))
(let ((inline$$Sub$0$anon3_Else_correct@@8  (=> (<= (|i#$Integer| inline$$ReadRef$2$v@1@@7) (|i#$Integer| inline$$Diem_preburn_with_resource_$def_verify$0$$t23@1)) (=> (and (and (= inline$$Sub$0$dst@1@@8 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def_verify$0$$t23@1) (|i#$Integer| inline$$ReadRef$2$v@1@@7)))) (= $abort_code@6@@11 $abort_code@5@@12)) (and (= $abort_flag@4@@12 $abort_flag@3@@14) (= inline$$Sub$0$dst@2@@8 inline$$Sub$0$dst@1@@8))) (and (=> (= (ControlFlow 0 292931) 296619) inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 292931) 293061) inline$$Diem_preburn_with_resource_$def_verify$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@8  (and (=> (= (ControlFlow 0 292905) (- 0 494320)) true) (and (=> (= (ControlFlow 0 292905) 292983) inline$$Sub$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 292905) 292931) inline$$Sub$0$anon3_Else_correct@@8)))))
(let ((inline$$ReadRef$2$anon0_correct@@7  (=> (and (= inline$$ReadRef$2$v@1@@7 (|v#$Mutation| inline$$BorrowField$2$dst@1@@8)) (= (ControlFlow 0 292806) 292905)) inline$$Sub$0$Entry_correct@@8)))
(let ((inline$$BorrowField$2$anon0_correct@@8  (=> (= inline$$BorrowField$2$p@1@@8 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (=> (and (and (= inline$$BorrowField$2$size@1@@8 (|size#$Path| inline$$BorrowField$2$p@1@@8)) (= inline$$BorrowField$2$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@8) inline$$BorrowField$2$size@1@@8 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@8 1)))) (and (= inline$$BorrowField$2$dst@1@@8 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@7) inline$$BorrowField$2$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 292768) 292806))) inline$$ReadRef$2$anon0_correct@@7))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Else$1_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 292820) 292768)) inline$$BorrowField$2$anon0_correct@@8)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@7  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@7)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@7)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 292606) 292820)) inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Else$1_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@7  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@7 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@7)) (= (ControlFlow 0 292600) 292606)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Else_correct  (=> (and (not $abort_flag@3@@14) (= (ControlFlow 0 292610) 292600)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@7)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@7  (=> (= $abort_flag@3@@14 true) (=> (and (= $abort_code@5@@12 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@7 inline$$BorrowGlobal$0$dst@0@@7)) (and (=> (= (ControlFlow 0 292560) 296639) inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 292560) 292610) inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@7  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@7 inline$$BorrowGlobal$0$a@1@@7)) (= (ControlFlow 0 292558) 292560)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@7)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@7  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@7 inline$$BorrowGlobal$0$a@1@@7) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@7 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@7 inline$$BorrowGlobal$0$a@1@@7) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@7 inline$$BorrowGlobal$0$a@1@@7))) (= $abort_flag@3@@14 $abort_flag@2@@20)) (and (= $abort_code@5@@12 $abort_code@4@@15) (= inline$$BorrowGlobal$0$dst@2@@7 inline$$BorrowGlobal$0$dst@1@@7))) (and (=> (= (ControlFlow 0 292506) 296639) inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 292506) 292610) inline$$Diem_preburn_with_resource_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@7  (=> (= inline$$BorrowGlobal$0$a@1@@7 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@17)) (and (=> (= (ControlFlow 0 292476) 292558) inline$$BorrowGlobal$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 292476) 292506) inline$$BorrowGlobal$0$anon3_Else_correct@@7)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@7  (=> (= inline$$BorrowGlobal$0$ta@0@@7 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1)) (and (=> (= (ControlFlow 0 292470) (- 0 494095)) true) (=> (= (ControlFlow 0 292470) 292476) inline$$BorrowGlobal$0$anon0_correct@@7)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Else_correct  (=> (and (not $abort_flag@2@@20) (= (ControlFlow 0 292566) 292470)) inline$$BorrowGlobal$0$Entry_correct@@7)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Then_correct  (=> $abort_flag@2@@20 (=> (and (= $abort_code@10@@7 $abort_code@4@@15) (= (ControlFlow 0 296659) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@17  (=> (not true) (and (=> (= (ControlFlow 0 292327) 296659) inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 292327) 292566) inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@17  (and (=> (= (ControlFlow 0 292337) 296659) inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 292337) 292566) inline$$Diem_preburn_with_resource_$def_verify$0$anon77_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@17  (=> (and (not $abort_flag@2@@20) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@17 ($Address 173345816))) (and (=> (= (ControlFlow 0 292321) 292337) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@17) (=> (= (ControlFlow 0 292321) 292327) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@17)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@2@@20) (= (ControlFlow 0 292351) 292321)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@17)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon24$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@20) (=> (and (=> $abort_flag@2@@20 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2@@20 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@4@@15 (|i#$Integer| ($Integer 5)))))) (=> (and (and (and (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@45 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@410 T@$Value) )  (=> ((_ is $Address) addr@@410) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@410))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@410))))))))))))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@411 T@$Value) )  (=> ((_ is $Address) addr@@411) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@411)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@411)))))))))))))) (and (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@412 T@$Value) )  (=> ((_ is $Address) addr@@412) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@412))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@412)))))))))))))))) (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@413 T@$Value) )  (=> ((_ is $Address) addr@@413) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@413)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@413)))))))))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))))) (and (and (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@414 T@$Value) )  (=> ((_ is $Address) addr@@414) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@414))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@414)))))))))))))))) (and (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean (forall ((addr@@415 T@$Value) )  (=> ((_ is $Address) addr@@415) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@415)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@415)))))))))))) (=> (not $abort_flag@2@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@45) (let ((va@@397 (|v#$Vector| call3formal@$ret0@0@@45)))
(let ((l@@397 (|l#$ValueArray| va@@397)))
 (and (and (<= 0 l@@397) (<= l@@397 $MAX_U64)) (forall ((x@@397 Int) ) (!  (=> (or (< x@@397 0) (>= x@@397 l@@397)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@397) x@@397) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@397) x@@397))
)))))) (forall (($$0@@134 Int) ) (!  (=> (and (>= $$0@@134 0) (< $$0@@134 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) $$0@@134)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) $$0@@134)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) $$0@@134)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@45)) $$0@@134))
))))) (and (=> (= (ControlFlow 0 292216) 296663) inline$$Diem_preburn_with_resource_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 292216) 292351) inline$$Diem_preburn_with_resource_$def_verify$0$anon75_Else_correct)))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@6  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) ($Local 11))) (= (ControlFlow 0 292182) 292216)) inline$$Diem_preburn_with_resource_$def_verify$0$anon24$2_correct)))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@6  (=> (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) ($Local 11)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@6| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|) 0 preburn@@1 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@8|))) (= (ControlFlow 0 292208) 292216)) inline$$Diem_preburn_with_resource_$def_verify$0$anon24$2_correct))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@8  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@8 inline$$WritebackToReference$0$srcPath@1@@8))) (= |inline$$WritebackToReference$0$dst'@2@@8| inline$$BorrowLoc$0$dst@1@@6)) (and (=> (= (ControlFlow 0 292027) 292208) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 292027) 292182) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@8  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@9|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@8 inline$$WritebackToReference$0$srcPath@1@@8)) (and (= |inline$$WritebackToReference$0$dst'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$WritebackToReference$0$dstPath@1@@8 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@8 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@8) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@9|)))) (= |inline$$WritebackToReference$0$dst'@2@@8| |inline$$WritebackToReference$0$dst'@1@@8|))) (and (=> (= (ControlFlow 0 292083) 292208) inline$$WritebackToValue$0$anon3_Then_correct@@6) (=> (= (ControlFlow 0 292083) 292182) inline$$WritebackToValue$0$anon3_Else_correct@@6)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@8  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@8 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@9|)) (= inline$$WritebackToReference$0$dstPath@1@@8 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6))) (and (=> (= (ControlFlow 0 291991) 292083) inline$$WritebackToReference$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 291991) 292027) inline$$WritebackToReference$0$anon3_Else_correct@@8)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 291854) 291991)) inline$$WritebackToReference$0$anon0_correct@@8)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon74_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def_verify$0$info@0)) (= (ControlFlow 0 296689) 291991)) inline$$WritebackToReference$0$anon0_correct@@8)))
(let ((inline$$WriteRef$0$anon0_correct@@9  (=> (= |inline$$WriteRef$0$to'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@8) (|p#$Mutation| inline$$BorrowField$1$dst@1@@8) call5formal@$ret0@0@@2)) (and (=> (= (ControlFlow 0 291840) 296689) inline$$Diem_preburn_with_resource_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 291840) 291854) inline$$Diem_preburn_with_resource_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon72_Else_correct  (=> (and (not $abort_flag@1@@23) (= (ControlFlow 0 291846) 291840)) inline$$WriteRef$0$anon0_correct@@9)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Then$2_correct  (and (=> (= (ControlFlow 0 291783) (- 0 492177)) true) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@1@@23) (=> (and (=> $abort_flag@1@@23 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615)))))) (=> $abort_flag@1@@23 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@3@@16 (|i#$Integer| ($Integer 8)))))) (=> (and (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@2)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@8)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@416 T@$Value) )  (=> ((_ is $Address) addr@@416) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@416))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@416))))))))))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@417 T@$Value) )  (=> ((_ is $Address) addr@@417) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@417)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@417)))))))))))))) (=> (and (and (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@418 T@$Value) )  (=> ((_ is $Address) addr@@418) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@418))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@418)))))))))))))))) (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@419 T@$Value) )  (=> ((_ is $Address) addr@@419) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@419)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@419)))))))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@420 T@$Value) )  (=> ((_ is $Address) addr@@420) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@420))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@420)))))))))))))))) (and (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean (forall ((addr@@421 T@$Value) )  (=> ((_ is $Address) addr@@421) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@421)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| addr@@421)))))))))))) (=> (not $abort_flag@1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@32) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@2) (let ((va@@398 (|v#$Vector| call5formal@$ret0@0@@2)))
(let ((l@@398 (|l#$ValueArray| va@@398)))
 (and (and (<= 0 l@@398) (<= l@@398 $MAX_U64)) (forall ((x@@398 Int) ) (!  (=> (or (< x@@398 0) (>= x@@398 l@@398)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@398) x@@398) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@398) x@@398))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@2)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 291783) 296693) inline$$Diem_preburn_with_resource_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 291783) 291846) inline$$Diem_preburn_with_resource_$def_verify$0$anon72_Else_correct))))))))))
(let ((inline$$ReadRef$1$anon0_correct@@8  (=> (and (= inline$$ReadRef$1$v@1@@8 (|v#$Mutation| inline$$BorrowField$1$dst@1@@8)) (= (ControlFlow 0 291771) 291783)) inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Then$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct@@8  (=> (= inline$$BorrowField$1$p@1@@8 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (=> (and (and (= inline$$BorrowField$1$size@1@@8 (|size#$Path| inline$$BorrowField$1$p@1@@8)) (= inline$$BorrowField$1$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@8) inline$$BorrowField$1$size@1@@8 $Diem_Preburn_to_burn) (+ inline$$BorrowField$1$size@1@@8 1)))) (and (= inline$$BorrowField$1$dst@1@@8 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$BorrowField$1$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 291733) 291771))) inline$$ReadRef$1$anon0_correct@@8))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def_verify$0$$t17@1) (= (ControlFlow 0 291739) 291733)) inline$$BorrowField$1$anon0_correct@@8)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon18_correct  (=> (and (= $abort_code@10@@7 $abort_code@2@@15) (= (ControlFlow 0 291597) 291603)) inline$$Diem_preburn_with_resource_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 291595) 291597)) inline$$Diem_preburn_with_resource_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon71_Then_correct  (=> (= (ControlFlow 0 291611) 291597) inline$$Diem_preburn_with_resource_$def_verify$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def_verify$0$$t17@1)) (= $abort_code@2@@15 (|i#$Integer| call3formal@$ret0@0@@47))) (and (=> (= (ControlFlow 0 291589) 291611) inline$$Diem_preburn_with_resource_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 291589) 291595) inline$$Diem_preburn_with_resource_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon68_Else_correct  (=> (not $abort_flag@0@@24) (and (=> (= (ControlFlow 0 291577) 291739) inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 291577) 291589) inline$$Diem_preburn_with_resource_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Else_correct  (=> (not false) (=> (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$t16@1 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def_verify$0$$t17@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$1$dst@1@@1 inline$$Diem_preburn_with_resource_$def_verify$0$$t16@1)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def_verify$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@24)) (and (=> $abort_flag@0@@24 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@47 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@47) (>= (|i#$Integer| call3formal@$ret0@0@@47) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@47) $MAX_U64))) (and (=> (= (ControlFlow 0 291571) 296713) inline$$Diem_preburn_with_resource_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 291571) 291577) inline$$Diem_preburn_with_resource_$def_verify$0$anon68_Else_correct)))))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Then_correct true))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 291515) 296733) inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 291515) 291571) inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 291525) 296733) inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 291525) 291571) inline$$Diem_preburn_with_resource_$def_verify$0$anon67_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$1$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 291499) 291525) inline$$Diem_value_$def$1$anon6_Then_correct@@1) (=> (= (ControlFlow 0 291499) 291515) inline$$Diem_value_$def$1$anon6_Else_correct@@1)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 291423) 291499)) inline$$GetFieldFromValue$1$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct@@1  (=> (= (ControlFlow 0 291533) 291499) inline$$GetFieldFromValue$1$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$1$anon0_correct@@1  (=> (not false) (and (=> (= (ControlFlow 0 291417) 291533) inline$$Diem_value_$def$1$anon5_Then_correct@@1) (=> (= (ControlFlow 0 291417) 291423) inline$$Diem_value_$def$1$anon5_Else_correct@@1)))))
(let ((inline$$Diem_value_$direct_intra$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@9) (let ((va@@399 (|v#$Vector| inline$$ReadRef$0$v@1@@9)))
(let ((l@@399 (|l#$ValueArray| va@@399)))
 (and (and (<= 0 l@@399) (<= l@@399 $MAX_U64)) (forall ((x@@399 Int) ) (!  (=> (or (< x@@399 0) (>= x@@399 l@@399)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@399) x@@399) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@399) x@@399))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@9)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 291539) 291417)) inline$$Diem_value_$def$1$anon0_correct@@1)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Else$1_correct  (and (=> (= (ControlFlow 0 291547) (- 0 491874)) true) (=> (= (ControlFlow 0 291547) 291539) inline$$Diem_value_$direct_intra$1$anon0_correct))))
(let ((inline$$ReadRef$0$anon0_correct@@9  (=> (and (= inline$$ReadRef$0$v@1@@9 (|v#$Mutation| inline$$BorrowField$0$dst@1@@8)) (= (ControlFlow 0 291237) 291547)) inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Else$1_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@8  (=> (= inline$$BorrowField$0$p@1@@8 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@6)) (=> (and (and (= inline$$BorrowField$0$size@1@@8 (|size#$Path| inline$$BorrowField$0$p@1@@8)) (= inline$$BorrowField$0$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@8) inline$$BorrowField$0$size@1@@8 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@8 1)))) (and (= inline$$BorrowField$0$dst@1@@8 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@6) inline$$BorrowField$0$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@6))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 291199) 291237))) inline$$ReadRef$0$anon0_correct@@9))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Else_correct  (=> (and (not false) (= (ControlFlow 0 291251) 291199)) inline$$BorrowField$0$anon0_correct@@8)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Then_correct true))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@4  (=> (not true) (and (=> (= (ControlFlow 0 291007) 296737) inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 291007) 291251) inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@4  (and (=> (= (ControlFlow 0 291017) 296737) inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 291017) 291251) inline$$Diem_preburn_with_resource_$def_verify$0$anon66_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@16  (=> (= inline$$GetFieldFromValue$0$dst@1@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 290991) 291017) inline$$Diem_value_$def$0$anon6_Then_correct@@4) (=> (= (ControlFlow 0 290991) 291007) inline$$Diem_value_$def$0$anon6_Else_correct@@4)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@4  (=> (and (not true) (= (ControlFlow 0 290915) 290991)) inline$$GetFieldFromValue$0$anon0_correct@@16)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@4  (=> (= (ControlFlow 0 291025) 290991) inline$$GetFieldFromValue$0$anon0_correct@@16)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@4  (=> (not false) (and (=> (= (ControlFlow 0 290909) 291025) inline$$Diem_value_$def$0$anon5_Then_correct@@4) (=> (= (ControlFlow 0 290909) 290915) inline$$Diem_value_$def$0$anon5_Else_correct@@4)))))
(let ((inline$$Diem_value_$direct_intra$0$anon0_correct@@1  (=> (and (and (and (and (and ((_ is $Vector) coin@@5) (let ((va@@400 (|v#$Vector| coin@@5)))
(let ((l@@400 (|l#$ValueArray| va@@400)))
 (and (and (<= 0 l@@400) (<= l@@400 $MAX_U64)) (forall ((x@@400 Int) ) (!  (=> (or (< x@@400 0) (>= x@@400 l@@400)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@400) x@@400) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@400) x@@400))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@5)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 291031) 290909)) inline$$Diem_value_$def$0$anon0_correct@@4)))
(let ((inline$$BorrowLoc$0$anon0_correct@@6  (=> (and (= inline$$BorrowLoc$0$dst@1@@6 ($Mutation ($Local 11) $EmptyPath preburn@@1)) (= (ControlFlow 0 290741) 291031)) inline$$Diem_value_$direct_intra$0$anon0_correct@@1)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 290589) 290741)) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 296745) 290741) inline$$BorrowLoc$0$anon0_correct@@6)))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 290581) 296745) inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 290581) 290589) inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Then_correct  (and (=> (= (ControlFlow 0 296753) 296745) inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 296753) 290589) inline$$Diem_preburn_with_resource_$def_verify$0$anon65_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 290573) 296753) inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 290573) 290581) inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 296761) 296753) inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 296761) 290581) inline$$Diem_preburn_with_resource_$def_verify$0$anon64_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 290567) 296761) inline$$Diem_preburn_with_resource_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 290567) 290573) inline$$Diem_preburn_with_resource_$def_verify$0$anon63_Else_correct)))))
(let ((anon0$1_correct@@24  (=> (and (forall (($inv_addr@@49 Int) ($inv_tv0@@43 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49)) (let ((va@@401 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))))
(let ((l@@401 (|l#$ValueArray| va@@401)))
 (and (and (<= 0 l@@401) (<= l@@401 $MAX_U64)) (forall ((x@@401 Int) ) (!  (=> (or (< x@@401 0) (>= x@@401 l@@401)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@401) x@@401) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@401) x@@401))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@43) 1) $inv_addr@@49))
)) (forall (($inv_addr@@50 Int) ($inv_tv0@@44 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50)) (let ((va@@402 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))))
(let ((l@@402 (|l#$ValueArray| va@@402)))
 (and (and (<= 0 l@@402) (<= l@@402 $MAX_U64)) (forall ((x@@402 Int) ) (!  (=> (or (< x@@402 0) (>= x@@402 l@@402)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@402) x@@402) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@402) x@@402))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@403 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@403 (|l#$ValueArray| va@@403)))
 (and (and (<= 0 l@@403) (<= l@@403 $MAX_U64)) (forall ((x@@403 Int) ) (!  (=> (or (< x@@403 0) (>= x@@403 l@@403)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@403) x@@403) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@403) x@@403))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code)) (let ((va@@404 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@404 (|l#$ValueArray| va@@404)))
 (and (and (<= 0 l@@404) (<= l@@404 $MAX_U64)) (forall ((x@@404 Int) ) (!  (=> (or (< x@@404 0) (>= x@@404 l@@404)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@404) x@@404) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@404) x@@404))
))))))) (forall (($$0@@135 Int) ) (!  (=> (and (>= $$0@@135 0) (< $$0@@135 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))) $$0@@135)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))) $$0@@135)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))) $$0@@135)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_currency_code))) $$0@@135))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events)) (let ((va@@405 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@405 (|l#$ValueArray| va@@405)))
 (and (and (<= 0 l@@405) (<= l@@405 $MAX_U64)) (forall ((x@@405 Int) ) (!  (=> (or (< x@@405 0) (>= x@@405 l@@405)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@405) x@@405) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@405) x@@405))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@406 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@406 (|l#$ValueArray| va@@406)))
 (and (and (<= 0 l@@406) (<= l@@406 $MAX_U64)) (forall ((x@@406 Int) ) (!  (=> (or (< x@@406 0) (>= x@@406 l@@406)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@406) x@@406) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@406) x@@406))
))))))) (forall (($$0@@136 Int) ) (!  (=> (and (>= $$0@@136 0) (< $$0@@136 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@136)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@136)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@136)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@136))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events)) (let ((va@@407 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@407 (|l#$ValueArray| va@@407)))
 (and (and (<= 0 l@@407) (<= l@@407 $MAX_U64)) (forall ((x@@407 Int) ) (!  (=> (or (< x@@407 0) (>= x@@407 l@@407)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@407) x@@407) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@407) x@@407))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@408 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@408 (|l#$ValueArray| va@@408)))
 (and (and (<= 0 l@@408) (<= l@@408 $MAX_U64)) (forall ((x@@408 Int) ) (!  (=> (or (< x@@408 0) (>= x@@408 l@@408)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@408) x@@408) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@408) x@@408))
))))))) (forall (($$0@@137 Int) ) (!  (=> (and (>= $$0@@137 0) (< $$0@@137 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@137)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@137)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@137)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@137))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@409 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@409 (|l#$ValueArray| va@@409)))
 (and (and (<= 0 l@@409) (<= l@@409 $MAX_U64)) (forall ((x@@409 Int) ) (!  (=> (or (< x@@409 0) (>= x@@409 l@@409)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@409) x@@409) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@409) x@@409))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@410 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@410 (|l#$ValueArray| va@@410)))
 (and (and (<= 0 l@@410) (<= l@@410 $MAX_U64)) (forall ((x@@410 Int) ) (!  (=> (or (< x@@410 0) (>= x@@410 l@@410)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@410) x@@410) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@410) x@@410))
))))))) (forall (($$0@@138 Int) ) (!  (=> (and (>= $$0@@138 0) (< $$0@@138 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@138)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@138)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@138)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@138))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@411 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@411 (|l#$ValueArray| va@@411)))
 (and (and (<= 0 l@@411) (<= l@@411 $MAX_U64)) (forall ((x@@411 Int) ) (!  (=> (or (< x@@411 0) (>= x@@411 l@@411)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@411) x@@411) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@411) x@@411))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@412 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@412 (|l#$ValueArray| va@@412)))
 (and (and (<= 0 l@@412) (<= l@@412 $MAX_U64)) (forall ((x@@412 Int) ) (!  (=> (or (< x@@412 0) (>= x@@412 l@@412)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@412) x@@412) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@412) x@@412))
))))))) (forall (($$0@@139 Int) ) (!  (=> (and (>= $$0@@139 0) (< $$0@@139 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@139)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@139)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@139)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@139))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@413 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@413 (|l#$ValueArray| va@@413)))
 (and (and (<= 0 l@@413) (<= l@@413 $MAX_U64)) (forall ((x@@413 Int) ) (!  (=> (or (< x@@413 0) (>= x@@413 l@@413)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@413) x@@413) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@413) x@@413))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@414 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@414 (|l#$ValueArray| va@@414)))
 (and (and (<= 0 l@@414) (<= l@@414 $MAX_U64)) (forall ((x@@414 Int) ) (!  (=> (or (< x@@414 0) (>= x@@414 l@@414)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@414) x@@414) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@414) x@@414))
))))))) (forall (($$0@@140 Int) ) (!  (=> (and (>= $$0@@140 0) (< $$0@@140 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@140)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@140)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@140)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@140))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@44) 1) $inv_addr@@50))
))) (=> (and (and (forall (($inv_addr@@51 Int) ($inv_tv0@@45 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51)) (let ((va@@415 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))))
(let ((l@@415 (|l#$ValueArray| va@@415)))
 (and (and (<= 0 l@@415) (<= l@@415 $MAX_U64)) (forall ((x@@415 Int) ) (!  (=> (or (< x@@415 0) (>= x@@415 l@@415)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@415) x@@415) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@415) x@@415))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn)) (let ((va@@416 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn))))
(let ((l@@416 (|l#$ValueArray| va@@416)))
 (and (and (<= 0 l@@416) (<= l@@416 $MAX_U64)) (forall ((x@@416 Int) ) (!  (=> (or (< x@@416 0) (>= x@@416 l@@416)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@416) x@@416) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@416) x@@416))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@45) 1) $inv_addr@@51))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@38 T@$Value) )  (=> ((_ is $Type) coin_type@@38) (|b#$Boolean| ($Boolean (forall ((addr3@@20 T@$Value) )  (=> ((_ is $Address) addr3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@38)) 1) (|a#$Address| addr3@@20)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@38)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@38)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@39 T@$Value) )  (=> ((_ is $Type) coin_type@@39) (|b#$Boolean| ($Boolean (forall ((addr1@@13 T@$Value) )  (=> ((_ is $Address) addr1@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@39)) 1) (|a#$Address| addr1@@13)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@13)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 296767) 290567))) inline$$Diem_preburn_with_resource_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@25  (=> (and (and (and (and ((_ is $Vector) coin@@5) (let ((va@@417 (|v#$Vector| coin@@5)))
(let ((l@@417 (|l#$ValueArray| va@@417)))
 (and (and (<= 0 l@@417) (<= l@@417 $MAX_U64)) (forall ((x@@417 Int) ) (!  (=> (or (< x@@417 0) (>= x@@417 l@@417)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@417) x@@417) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@417) x@@417))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@5)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@5)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) preburn@@1) (let ((va@@418 (|v#$Vector| preburn@@1)))
(let ((l@@418 (|l#$ValueArray| va@@418)))
 (and (and (<= 0 l@@418) (<= l@@418 $MAX_U64)) (forall ((x@@418 Int) ) (!  (=> (or (< x@@418 0) (>= x@@418 l@@418)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@418) x@@418) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@418) x@@418))
)))))) (= (|l#$ValueArray| (|v#$Vector| preburn@@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn)) (let ((va@@419 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))))
(let ((l@@419 (|l#$ValueArray| va@@419)))
 (and (and (<= 0 l@@419) (<= l@@419 $MAX_U64)) (forall ((x@@419 Int) ) (!  (=> (or (< x@@419 0) (>= x@@419 l@@419)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@419) x@@419) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@419) x@@419))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| preburn@@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) preburn_address@@5) (= (ControlFlow 0 288423) 296767))) anon0$1_correct@@24))))
(let ((PreconditionGeneratedEntry_correct@@16  (=> (= (ControlFlow 0 487771) 288423) anon0_correct@@25)))
PreconditionGeneratedEntry_correct@@16)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@33 () T@$TypeValue)
(declare-fun $abort_flag@5@@10 () Bool)
(declare-fun tc_account@@0 () T@$Value)
(declare-fun $abort_code@8@@9 () Int)
(declare-fun $Diem_BurnCapability_$memory@1 () T@$Memory)
(declare-fun $abort_flag@4@@13 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@6@@12 () Int)
(declare-fun $abort_code@7@@11 () Int)
(declare-fun $Diem_BurnCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@1@@22 () Int)
(declare-fun $abort_flag@0@@25 () Bool)
(declare-fun $abort_code@2@@16 () Int)
(declare-fun $abort_flag@1@@24 () Bool)
(declare-fun $abort_code@3@@17 () Int)
(declare-fun $abort_flag@2@@21 () Bool)
(declare-fun $abort_code@4@@16 () Int)
(declare-fun $abort_flag@3@@15 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun cap () T@$Value)
(declare-fun inline$$Not$0$dst@1@@10 () T@$Value)
(declare-fun $abort_code@5@@13 () Int)
(declare-fun call3formal@$ret0@0@@48 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def_verify$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@49 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 497765) (let ((anon0$2_correct@@26  (and (=> (= (ControlFlow 0 299577) (- 0 502021)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@5@@10) (and (=> (= (ControlFlow 0 299577) (- 0 502038)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0)))) $abort_flag@5@@10)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0)))) $abort_flag@5@@10) (and (=> (= (ControlFlow 0 299577) (- 0 502064)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@5@@10)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@5@@10) (and (=> (= (ControlFlow 0 299577) (- 0 502085)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@5@@10) (and (=> (= (ControlFlow 0 299577) (- 0 502114)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@5@@10)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@5@@10) (and (=> (= (ControlFlow 0 299577) (- 0 502131)) (=> $abort_flag@5@@10 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453)))))))) (=> (=> $abort_flag@5@@10 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502237)) (=> $abort_flag@5@@10 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0)))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@5@@10 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| tc_account@@0)))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@8@@9 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 299577) (- 0 502387)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502436)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@422 T@$Value) )  (=> ((_ is $Address) addr@@422) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@422))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@422)))))))))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@423 T@$Value) )  (=> ((_ is $Address) addr@@423) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@423))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@423))))))))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502516)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@424 T@$Value) )  (=> ((_ is $Address) addr@@424) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@424)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@424))))))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@425 T@$Value) )  (=> ((_ is $Address) addr@@425) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@425)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@425)))))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502584)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502633)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@426 T@$Value) )  (=> ((_ is $Address) addr@@426) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@426)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@426))))))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@427 T@$Value) )  (=> ((_ is $Address) addr@@427) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@427)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@427)))))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502699)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502748)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502797)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@428 T@$Value) )  (=> ((_ is $Address) addr@@428) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@428))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@428)))))))))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@429 T@$Value) )  (=> ((_ is $Address) addr@@429) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@429))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@429))))))))))))))) (and (=> (= (ControlFlow 0 299577) (- 0 502877)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@430 T@$Value) )  (=> ((_ is $Address) addr@@430) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@430)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@430))))))))))))) (=> (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean (forall ((addr@@431 T@$Value) )  (=> ((_ is $Address) addr@@431) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@431)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@431)))))))))))) (=> (= (ControlFlow 0 299577) (- 0 502945)) (=> (not $abort_flag@5@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@4@@13) (and (=> (= (ControlFlow 0 299455) (- 0 501826)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_burn_capability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_burn_capability_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_burn_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_burn_capability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_burn_capability_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_burn_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (=> (and (and (= $abort_code@8@@9 $abort_code@6@@12) (= $abort_flag@5@@10 $abort_flag@4@@13)) (and (= $Diem_BurnCapability_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 299455) 299577))) anon0$2_correct@@26))))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@8@@9 $abort_code@7@@11) (= $abort_flag@5@@10 true)) (and (= $Diem_BurnCapability_$memory@1 $Diem_BurnCapability_$memory@0) (= (ControlFlow 0 299037) 299577))) anon0$2_correct@@26)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon7_correct  (=> (= $abort_code@7@@11 $abort_code@1@@22) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 299547) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 299545) 299547)) inline$$Diem_publish_burn_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 299555) 299547) inline$$Diem_publish_burn_capability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0@@25 (and (=> (= (ControlFlow 0 299539) 299555) inline$$Diem_publish_burn_capability_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 299539) 299545) inline$$Diem_publish_burn_capability_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon11_correct  (=> (= $abort_code@7@@11 $abort_code@2@@16) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 299527) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 299525) 299527)) inline$$Diem_publish_burn_capability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 299535) 299527) inline$$Diem_publish_burn_capability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon33_Then_correct  (=> $abort_flag@1@@24 (and (=> (= (ControlFlow 0 299519) 299535) inline$$Diem_publish_burn_capability_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 299519) 299525) inline$$Diem_publish_burn_capability_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon15_correct  (=> (= $abort_code@7@@11 $abort_code@3@@17) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 299507) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 299505) 299507)) inline$$Diem_publish_burn_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 299515) 299507) inline$$Diem_publish_burn_capability_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Then_correct  (=> $abort_flag@2@@21 (and (=> (= (ControlFlow 0 299499) 299515) inline$$Diem_publish_burn_capability_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 299499) 299505) inline$$Diem_publish_burn_capability_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon19_correct  (=> (= $abort_code@7@@11 $abort_code@4@@16) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 299487) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 299485) 299487)) inline$$Diem_publish_burn_capability_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 299495) 299487) inline$$Diem_publish_burn_capability_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon37_Then_correct  (=> $abort_flag@3@@15 (and (=> (= (ControlFlow 0 299479) 299495) inline$$Diem_publish_burn_capability_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 299479) 299485) inline$$Diem_publish_burn_capability_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon27_correct  (=> (= $abort_code@7@@11 $abort_code@6@@12) (=> (and (= $Diem_BurnCapability_$memory@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 299467) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 299465) 299467)) inline$$Diem_publish_burn_capability_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 299475) 299467) inline$$Diem_publish_burn_capability_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Then_correct  (=> $abort_flag@4@@13 (and (=> (= (ControlFlow 0 299459) 299475) inline$$Diem_publish_burn_capability_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 299459) 299465) inline$$Diem_publish_burn_capability_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_flag@4@@13 true) (=> (and (= $abort_code@6@@12 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 299369) 299459) inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 299369) 299455) inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1) (= (ControlFlow 0 299367) 299369)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$0$ta@0 inline$$MoveTo$0$a@1 cap))) (= $abort_flag@4@@13 $abort_flag@3@@15)) (and (= $abort_code@6@@12 $abort_code@4@@16) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 299317) 299459) inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 299317) 299455) inline$$Diem_publish_burn_capability_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| tc_account@@0)) (and (=> (= (ControlFlow 0 299375) 299367) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 299375) 299317) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 299163) (- 0 501711)) true) (=> (= (ControlFlow 0 299163) 299375) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$MoveTo$0$Entry_correct  (=> (and (= inline$$MoveTo$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1)) (= (ControlFlow 0 299135) 299163)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@10) (= (ControlFlow 0 299383) 299135)) inline$$MoveTo$0$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon24_correct  (=> (= $abort_code@7@@11 $abort_code@5@@13) (=> (and (= $Diem_BurnCapability_$memory@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 299033) 299037)) inline$$Diem_publish_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 299031) 299033)) inline$$Diem_publish_burn_capability_$def_verify$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 299045) 299033) inline$$Diem_publish_burn_capability_$def_verify$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@10)) (= $abort_code@5@@13 (|i#$Integer| call3formal@$ret0@0@@48))) (and (=> (= (ControlFlow 0 299025) 299045) inline$$Diem_publish_burn_capability_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 299025) 299031) inline$$Diem_publish_burn_capability_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon37_Else_correct  (=> (not $abort_flag@3@@15) (and (=> (= (ControlFlow 0 299013) 299383) inline$$Diem_publish_burn_capability_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 299013) 299025) inline$$Diem_publish_burn_capability_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def_verify$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@15)) (and (=> $abort_flag@3@@15 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@48 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@48) (>= (|i#$Integer| call3formal@$ret0@0@@48) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@48) $MAX_U64))) (and (=> (= (ControlFlow 0 299007) 299479) inline$$Diem_publish_burn_capability_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 299007) 299013) inline$$Diem_publish_burn_capability_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@10  (=> (and (= inline$$Not$0$dst@1@@10 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def_verify$0$$t7@1)))) (= (ControlFlow 0 298995) 299007)) inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@10  (and (=> (= (ControlFlow 0 298985) (- 0 501554)) true) (=> (= (ControlFlow 0 298985) 298995) inline$$Not$0$anon0_correct@@10))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@2@@21) (=> (and (= inline$$Diem_publish_burn_capability_$def_verify$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| call3formal@$ret0@0@@49)))) (= (ControlFlow 0 299001) 298985)) inline$$Not$0$Entry_correct@@10))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon33_Else_correct  (=> (not $abort_flag@1@@24) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@21) (=> $abort_flag@2@@21 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@49 tc_account@@0)))) ((_ is $Address) call3formal@$ret0@0@@49))) (and (=> (= (ControlFlow 0 298927) 299499) inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 298927) 299001) inline$$Diem_publish_burn_capability_$def_verify$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@0@@25) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@24) (=> $abort_flag@1@@24 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@1@@24 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@16 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@432 T@$Value) )  (=> ((_ is $Address) addr@@432) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@432))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@432))))))))))))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@433 T@$Value) )  (=> ((_ is $Address) addr@@433) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@433)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@433)))))))))))))) (=> (and (and (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@434 T@$Value) )  (=> ((_ is $Address) addr@@434) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@434))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@434)))))))))))))))) (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@435 T@$Value) )  (=> ((_ is $Address) addr@@435) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@435)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@435)))))))))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@436 T@$Value) )  (=> ((_ is $Address) addr@@436) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@436))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@436)))))))))))))))) (and (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean (forall ((addr@@437 T@$Value) )  (=> ((_ is $Address) addr@@437) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@437)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| addr@@437)))))))))))) (=> (not $abort_flag@1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@33) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 298921) 299519) inline$$Diem_publish_burn_capability_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 298921) 298927) inline$$Diem_publish_burn_capability_$def_verify$0$anon33_Else_correct))))))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) $abort_flag@0@@25) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@25) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) $abort_flag@0@@25)) (and (=> $abort_flag@0@@25 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))))) (=> $abort_flag@0@@25 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0))))))) (= $abort_code@1@@22 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@0)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@22 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@0 ($Address 186537453))))) (= $abort_code@1@@22 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 298915) 299539) inline$$Diem_publish_burn_capability_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 298915) 298921) inline$$Diem_publish_burn_capability_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 298845) 298915)) inline$$Diem_publish_burn_capability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 299563) 298915) inline$$Diem_publish_burn_capability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 298837) 299563) inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 298837) 298845) inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 299571) 299563) inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 299571) 298845) inline$$Diem_publish_burn_capability_$def_verify$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 298831) 299571) inline$$Diem_publish_burn_capability_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 298831) 298837) inline$$Diem_publish_burn_capability_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@25  (=> (and (and (and (forall (($inv_addr@@52 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52)) (let ((va@@420 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))))
(let ((l@@420 (|l#$ValueArray| va@@420)))
 (and (and (<= 0 l@@420) (<= l@@420 $MAX_U64)) (forall ((x@@420 Int) ) (!  (=> (or (< x@@420 0) (>= x@@420 l@@420)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@420) x@@420) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@420) x@@420))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@52))
)) (forall (($inv_addr@@53 Int) ($inv_tv0@@46 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@46) 1) $inv_addr@@53)) (let ((va@@421 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@46) 1) $inv_addr@@53))))
(let ((l@@421 (|l#$ValueArray| va@@421)))
 (and (and (<= 0 l@@421) (<= l@@421 $MAX_U64)) (forall ((x@@421 Int) ) (!  (=> (or (< x@@421 0) (>= x@@421 l@@421)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@421) x@@421) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@421) x@@421))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@46) 1) $inv_addr@@53))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@46) 1) $inv_addr@@53))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@46) 1) $inv_addr@@53))
))) (and (forall (($inv_addr@@54 Int) ($inv_tv0@@47 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54)) (let ((va@@422 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))))
(let ((l@@422 (|l#$ValueArray| va@@422)))
 (and (and (<= 0 l@@422) (<= l@@422 $MAX_U64)) (forall ((x@@422 Int) ) (!  (=> (or (< x@@422 0) (>= x@@422 l@@422)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@422) x@@422) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@422) x@@422))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@423 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@423 (|l#$ValueArray| va@@423)))
 (and (and (<= 0 l@@423) (<= l@@423 $MAX_U64)) (forall ((x@@423 Int) ) (!  (=> (or (< x@@423 0) (>= x@@423 l@@423)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@423) x@@423) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@423) x@@423))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code)) (let ((va@@424 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@424 (|l#$ValueArray| va@@424)))
 (and (and (<= 0 l@@424) (<= l@@424 $MAX_U64)) (forall ((x@@424 Int) ) (!  (=> (or (< x@@424 0) (>= x@@424 l@@424)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@424) x@@424) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@424) x@@424))
))))))) (forall (($$0@@141 Int) ) (!  (=> (and (>= $$0@@141 0) (< $$0@@141 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))) $$0@@141)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))) $$0@@141)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))) $$0@@141)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_currency_code))) $$0@@141))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events)) (let ((va@@425 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@425 (|l#$ValueArray| va@@425)))
 (and (and (<= 0 l@@425) (<= l@@425 $MAX_U64)) (forall ((x@@425 Int) ) (!  (=> (or (< x@@425 0) (>= x@@425 l@@425)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@425) x@@425) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@425) x@@425))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@426 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@426 (|l#$ValueArray| va@@426)))
 (and (and (<= 0 l@@426) (<= l@@426 $MAX_U64)) (forall ((x@@426 Int) ) (!  (=> (or (< x@@426 0) (>= x@@426 l@@426)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@426) x@@426) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@426) x@@426))
))))))) (forall (($$0@@142 Int) ) (!  (=> (and (>= $$0@@142 0) (< $$0@@142 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@142)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@142)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@142)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@142))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events)) (let ((va@@427 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@427 (|l#$ValueArray| va@@427)))
 (and (and (<= 0 l@@427) (<= l@@427 $MAX_U64)) (forall ((x@@427 Int) ) (!  (=> (or (< x@@427 0) (>= x@@427 l@@427)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@427) x@@427) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@427) x@@427))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@428 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@428 (|l#$ValueArray| va@@428)))
 (and (and (<= 0 l@@428) (<= l@@428 $MAX_U64)) (forall ((x@@428 Int) ) (!  (=> (or (< x@@428 0) (>= x@@428 l@@428)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@428) x@@428) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@428) x@@428))
))))))) (forall (($$0@@143 Int) ) (!  (=> (and (>= $$0@@143 0) (< $$0@@143 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@143)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@143)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@143)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@143))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@429 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@429 (|l#$ValueArray| va@@429)))
 (and (and (<= 0 l@@429) (<= l@@429 $MAX_U64)) (forall ((x@@429 Int) ) (!  (=> (or (< x@@429 0) (>= x@@429 l@@429)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@429) x@@429) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@429) x@@429))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@430 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@430 (|l#$ValueArray| va@@430)))
 (and (and (<= 0 l@@430) (<= l@@430 $MAX_U64)) (forall ((x@@430 Int) ) (!  (=> (or (< x@@430 0) (>= x@@430 l@@430)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@430) x@@430) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@430) x@@430))
))))))) (forall (($$0@@144 Int) ) (!  (=> (and (>= $$0@@144 0) (< $$0@@144 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@144)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@144)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@144)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@144))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@431 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@431 (|l#$ValueArray| va@@431)))
 (and (and (<= 0 l@@431) (<= l@@431 $MAX_U64)) (forall ((x@@431 Int) ) (!  (=> (or (< x@@431 0) (>= x@@431 l@@431)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@431) x@@431) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@431) x@@431))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@432 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@432 (|l#$ValueArray| va@@432)))
 (and (and (<= 0 l@@432) (<= l@@432 $MAX_U64)) (forall ((x@@432 Int) ) (!  (=> (or (< x@@432 0) (>= x@@432 l@@432)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@432) x@@432) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@432) x@@432))
))))))) (forall (($$0@@145 Int) ) (!  (=> (and (>= $$0@@145 0) (< $$0@@145 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@145)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@145)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@145)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@145))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@433 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@433 (|l#$ValueArray| va@@433)))
 (and (and (<= 0 l@@433) (<= l@@433 $MAX_U64)) (forall ((x@@433 Int) ) (!  (=> (or (< x@@433 0) (>= x@@433 l@@433)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@433) x@@433) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@433) x@@433))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@434 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@434 (|l#$ValueArray| va@@434)))
 (and (and (<= 0 l@@434) (<= l@@434 $MAX_U64)) (forall ((x@@434 Int) ) (!  (=> (or (< x@@434 0) (>= x@@434 l@@434)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@434) x@@434) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@434) x@@434))
))))))) (forall (($$0@@146 Int) ) (!  (=> (and (>= $$0@@146 0) (< $$0@@146 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@146)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@146)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@146)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@146))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@47) 1) $inv_addr@@54))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@40 T@$Value) )  (=> ((_ is $Type) coin_type@@40) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@3 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@40)) 1) (|a#$Address| mint_cap_owner@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@41 T@$Value) )  (=> ((_ is $Type) coin_type@@41) (|b#$Boolean| ($Boolean (forall ((addr3@@21 T@$Value) )  (=> ((_ is $Address) addr3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@41)) 1) (|a#$Address| addr3@@21)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@41)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@41)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@42 T@$Value) )  (=> ((_ is $Type) coin_type@@42) (|b#$Boolean| ($Boolean (forall ((addr1@@14 T@$Value) )  (=> ((_ is $Address) addr1@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@42)) 1) (|a#$Address| addr1@@14)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@14)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@43 T@$Value) )  (=> ((_ is $Type) coin_type@@43) (|b#$Boolean| ($Boolean (forall ((addr1@@15 T@$Value) )  (=> ((_ is $Address) addr1@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@43)) 1) (|a#$Address| addr1@@15)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@15)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 299575) 298831)))) inline$$Diem_publish_burn_capability_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@26  (=> ((_ is $Address) tc_account@@0) (=> (and (and (and (and (and ((_ is $Vector) cap) (let ((va@@435 (|v#$Vector| cap)))
(let ((l@@435 (|l#$ValueArray| va@@435)))
 (and (and (<= 0 l@@435) (<= l@@435 $MAX_U64)) (forall ((x@@435 Int) ) (!  (=> (or (< x@@435 0) (>= x@@435 l@@435)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@435) x@@435) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@435) x@@435))
)))))) (= (|l#$ValueArray| (|v#$Vector| cap)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 297920) 299575)) anon0$1_correct@@25))))
(let ((PreconditionGeneratedEntry_correct@@17  (=> (= (ControlFlow 0 497765) 297920) anon0_correct@@26)))
PreconditionGeneratedEntry_correct@@17)))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun account@@3 () T@$Value)
(declare-fun $abort_flag@14@@2 () Bool)
(declare-fun tc_account@@1 () T@$Value)
(declare-fun $tv0@@34 () T@$TypeValue)
(declare-fun $abort_code@19@@2 () Int)
(declare-fun $Diem_Preburn_$memory@1@@2 () T@$Memory)
(declare-fun $abort_flag@13@@2 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_code@17@@4 () Int)
(declare-fun $abort_code@18@@3 () Int)
(declare-fun $Diem_Preburn_$memory@0@@4 () T@$Memory)
(declare-fun $abort_code@1@@23 () Int)
(declare-fun $abort_flag@0@@26 () Bool)
(declare-fun $abort_code@2@@17 () Int)
(declare-fun $abort_flag@1@@25 () Bool)
(declare-fun $abort_code@7@@12 () Int)
(declare-fun $abort_flag@5@@11 () Bool)
(declare-fun $abort_code@8@@10 () Int)
(declare-fun $abort_flag@6@@10 () Bool)
(declare-fun $abort_code@10@@8 () Int)
(declare-fun $abort_flag@7@@8 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0@@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@0 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@12@@3 () Bool)
(declare-fun $abort_code@16@@5 () Int)
(declare-fun inline$$Diem_publish_preburn_to_account_$def_verify$0$$Diem_Preburn_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Diem_create_preburn_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@15@@5 () Int)
(declare-fun $abort_code@12@@6 () Int)
(declare-fun $abort_flag@8@@6 () Bool)
(declare-fun $abort_code@13@@6 () Int)
(declare-fun $abort_flag@9@@6 () Bool)
(declare-fun $abort_flag@11@@5 () Bool)
(declare-fun $abort_code@14@@5 () Int)
(declare-fun inline$$Diem_Preburn_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1@@0 () T@$Value)
(declare-fun $abort_flag@10@@5 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1@@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$Not$1$dst@1@@0 () T@$Value)
(declare-fun $abort_code@11@@8 () Int)
(declare-fun call3formal@$ret0@0@@50 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def_verify$0$$t15@1 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def_verify$0$$t13@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@51 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@11 () T@$Value)
(declare-fun $abort_code@9@@9 () Int)
(declare-fun call3formal@$ret0@0@@52 () T@$Value)
(declare-fun inline$$Diem_publish_preburn_to_account_$def_verify$0$$t10@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@4@@14 () Bool)
(declare-fun $abort_code@6@@13 () Int)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@14 () Int)
(declare-fun $abort_code@3@@18 () Int)
(declare-fun $abort_flag@2@@22 () Bool)
(declare-fun $abort_flag@3@@16 () Bool)
(declare-fun $abort_code@4@@17 () Int)
(declare-fun |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@17 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@10 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@10 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@10 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@18 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$Diem_is_synthetic_currency_$def$0$$t5@1 () T@$Value)
(declare-fun $Diem_Preburn_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 502997) (let ((anon0$2_correct@@27  (and (=> (= (ControlFlow 0 303999) (- 0 508824)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508845)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508874)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508895)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508924)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508941)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508958)) (=> (|b#$Boolean| (let ((addr@@438 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@438)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@438)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| (let ((addr@@438 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@438)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@438)))) $Diem_CurrencyInfo_is_synthetic)))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508969)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 508995)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 509016)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@14@@2)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@14@@2) (and (=> (= (ControlFlow 0 303999) (- 0 509045)) (=> $abort_flag@14@@2 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| (let ((addr@@439 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@439)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@439)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2)))))))) (=> (=> $abort_flag@14@@2 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| (let ((addr@@439 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@439)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@439)))) $Diem_CurrencyInfo_is_synthetic))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509257)) (=> $abort_flag@14@@2 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| (let ((addr@@440 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@440)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@440)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3))))))) (=> (=> $abort_flag@14@@2 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| (let ((addr@@440 ($Address 173345816)))
($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@440)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@440)))) $Diem_CurrencyInfo_is_synthetic)))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@19@@2 (|i#$Integer| ($Integer 3)))))) (and (=> (= (ControlFlow 0 303999) (- 0 509579)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3))))) (and (=> (= (ControlFlow 0 303999) (- 0 509607)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509656)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@441 T@$Value) )  (=> ((_ is $Address) addr@@441) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@441))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@441)))))))))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@442 T@$Value) )  (=> ((_ is $Address) addr@@442) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@442))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@442))))))))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509736)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@443 T@$Value) )  (=> ((_ is $Address) addr@@443) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@443)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@443))))))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@444 T@$Value) )  (=> ((_ is $Address) addr@@444) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@444)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@444)))))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509804)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509853)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@445 T@$Value) )  (=> ((_ is $Address) addr@@445) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@445))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@445)))))))))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@446 T@$Value) )  (=> ((_ is $Address) addr@@446) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@446))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@446))))))))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 509933)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@447 T@$Value) )  (=> ((_ is $Address) addr@@447) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@447)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@447))))))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@448 T@$Value) )  (=> ((_ is $Address) addr@@448) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@448)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@448)))))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 510001)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 510050)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 303999) (- 0 510099)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@449 T@$Value) )  (=> ((_ is $Address) addr@@449) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@449)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@449))))))))))))) (=> (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean (forall ((addr@@450 T@$Value) )  (=> ((_ is $Address) addr@@450) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@450)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory@1@@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| addr@@450)))))))))))) (=> (= (ControlFlow 0 303999) (- 0 510165)) (=> (not $abort_flag@14@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Else_correct  (=> (not $abort_flag@13@@2) (and (=> (= (ControlFlow 0 303849) (- 0 508512)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (=> (= (ControlFlow 0 303849) (- 0 508575)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@0|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_preburn_to_account_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_publish_preburn_to_account_$def_verify$0$tc_addr@@0))))))))))))))) (=> (and (and (= $abort_code@19@@2 $abort_code@17@@4) (= $abort_flag@14@@2 $abort_flag@13@@2)) (and (= $Diem_Preburn_$memory@1@@2 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 303849) 303999))) anon0$2_correct@@27))))))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct  (=> (and (and (= $abort_code@19@@2 $abort_code@18@@3) (= $abort_flag@14@@2 true)) (and (= $Diem_Preburn_$memory@1@@2 $Diem_Preburn_$memory@0@@4) (= (ControlFlow 0 302150) 303999))) anon0$2_correct@@27)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon7_correct  (=> (= $abort_code@18@@3 $abort_code@1@@23) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303969) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon44_Else_correct  (=> (and (not true) (= (ControlFlow 0 303967) 303969)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon44_Then_correct  (=> (= (ControlFlow 0 303977) 303969) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon43_Then_correct  (=> $abort_flag@0@@26 (and (=> (= (ControlFlow 0 303961) 303977) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 303961) 303967) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon11_correct  (=> (= $abort_code@18@@3 $abort_code@2@@17) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303949) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 303947) 303949)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 303957) 303949) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon45_Then_correct  (=> $abort_flag@1@@25 (and (=> (= (ControlFlow 0 303941) 303957) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 303941) 303947) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon17_correct  (=> (= $abort_code@18@@3 $abort_code@7@@12) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303925) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 303923) 303925)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon49_Then_correct  (=> (= (ControlFlow 0 303933) 303925) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon48_Then_correct  (=> $abort_flag@5@@11 (and (=> (= (ControlFlow 0 303917) 303933) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 303917) 303923) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon49_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon25_correct  (=> (= $abort_code@18@@3 $abort_code@8@@10) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303905) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 303903) 303905)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 303913) 303905) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Then_correct  (=> $abort_flag@6@@10 (and (=> (= (ControlFlow 0 303897) 303913) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 303897) 303903) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon29_correct  (=> (= $abort_code@18@@3 $abort_code@10@@8) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303885) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 303883) 303885)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 303893) 303885) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon54_Then_correct  (=> $abort_flag@7@@8 (and (=> (= (ControlFlow 0 303877) 303893) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 303877) 303883) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon39_correct  (=> (= $abort_code@18@@3 $abort_code@17@@4) (=> (and (= $Diem_Preburn_$memory@0@@4 |inline$$MoveToRaw$0$m'@2@@0|) (= (ControlFlow 0 303861) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 303859) 303861)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon39_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon60_Then_correct  (=> (= (ControlFlow 0 303869) 303861) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon39_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Then_correct  (=> $abort_flag@13@@2 (and (=> (= (ControlFlow 0 303853) 303869) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 303853) 303859) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@13@@2 true) (=> (and (= $abort_code@17@@4 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@0@@0|)) (and (=> (= (ControlFlow 0 303683) 303853) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 303683) 303849) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0) (= (ControlFlow 0 303681) 303683)) inline$$MoveToRaw$0$anon3_Then$1_correct@@0)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@0  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@0| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$MoveTo$0$ta@0@@0 inline$$MoveTo$0$a@1@@0 inline$$Diem_create_preburn_$def$0$$ret0@2))) (= $abort_flag@13@@2 $abort_flag@12@@3)) (and (= $abort_code@17@@4 $abort_code@16@@5) (= |inline$$MoveToRaw$0$m'@2@@0| |inline$$MoveToRaw$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 303631) 303853) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 303631) 303849) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon59_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@0  (=> (= inline$$MoveTo$0$a@1@@0 (|a#$Address| account@@3)) (and (=> (= (ControlFlow 0 303689) 303681) inline$$MoveToRaw$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 303689) 303631) inline$$MoveToRaw$0$anon3_Else_correct@@0)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 303477) (- 0 508397)) true) (=> (= (ControlFlow 0 303477) 303689) inline$$MoveTo$0$anon0$1_correct@@0))))
(let ((inline$$MoveTo$0$Entry_correct@@0  (=> (and (= inline$$MoveTo$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1)) (= (ControlFlow 0 303449) 303477)) inline$$Signer_borrow_address$0$Entry_correct@@0)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@12@@3) (and (=> (= (ControlFlow 0 303697) (- 0 508335)) (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_publish_preburn_to_account_$def_verify$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$Diem_publish_preburn_to_account_$def_verify$0$$Diem_Preburn_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)) (=> (= (ControlFlow 0 303697) 303449) inline$$MoveTo$0$Entry_correct@@0))))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Then_correct  (=> (and (and $abort_flag@12@@3 (= $abort_code@18@@3 $abort_code@16@@5)) (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303873) 302150))) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_create_preburn_$def$0$$ret0@1 $Error) (= $abort_code@16@@5 $abort_code@15@@5)) (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_create_preburn_$def$0$$ret0@1) (= $abort_flag@12@@3 true))) (and (=> (= (ControlFlow 0 303269) 303873) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 303269) 303697) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon5_correct  (=> (and (= $abort_code@15@@5 $abort_code@12@@6) (= (ControlFlow 0 303301) 303269)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 303299) 303301)) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon17_Then_correct  (=> (= (ControlFlow 0 303309) 303301) inline$$Diem_create_preburn_$def$0$anon5_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Then_correct  (=> $abort_flag@8@@6 (and (=> (= (ControlFlow 0 303293) 303309) inline$$Diem_create_preburn_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 303293) 303299) inline$$Diem_create_preburn_$def$0$anon17_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon9_correct  (=> (and (= $abort_code@15@@5 $abort_code@13@@6) (= (ControlFlow 0 303281) 303269)) inline$$Diem_create_preburn_$def$0$Abort_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 303279) 303281)) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 303289) 303281) inline$$Diem_create_preburn_$def$0$anon9_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Then_correct  (=> $abort_flag@9@@6 (and (=> (= (ControlFlow 0 303273) 303289) inline$$Diem_create_preburn_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 303273) 303279) inline$$Diem_create_preburn_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Then_correct  (=> $abort_flag@11@@5 (=> (and (= $abort_code@15@@5 $abort_code@14@@5) (= (ControlFlow 0 303263) 303269)) inline$$Diem_create_preburn_$def$0$Abort_correct))))
(let ((inline$$Diem_create_preburn_$def$0$anon14_correct  (=> (= $abort_code@16@@5 $abort_code@14@@5) (=> (and (= inline$$Diem_create_preburn_$def$0$$ret0@2 inline$$Diem_Preburn_pack$0$$struct@1@@0) (= $abort_flag@12@@3 $abort_flag@11@@5)) (and (=> (= (ControlFlow 0 303251) 303873) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 303251) 303697) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 303249) 303251)) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 303259) 303251) inline$$Diem_create_preburn_$def$0$anon14_correct)))
(let ((inline$$Diem_Preburn_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 303227) 303259) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 303227) 303249) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 303233) 303259) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 303233) 303249) inline$$Diem_create_preburn_$def$0$anon21_Else_correct))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 303221) 303233) inline$$Diem_Preburn_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 303221) 303227) inline$$Diem_Preburn_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_Preburn_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 303213) 303259) inline$$Diem_create_preburn_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 303213) 303249) inline$$Diem_create_preburn_$def$0$anon21_Else_correct)))))
(let ((inline$$Diem_Preburn_pack$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_zero_$def$0$$ret0@2@@0) (let ((va@@436 (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)))
(let ((l@@436 (|l#$ValueArray| va@@436)))
 (and (and (<= 0 l@@436) (<= l@@436 $MAX_U64)) (forall ((x@@436 Int) ) (!  (=> (or (< x@@436 0) (>= x@@436 l@@436)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@436) x@@436) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@436) x@@436))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_zero_$def$0$$ret0@2@@0)) $Diem_Diem_value)) $MAX_U64))) true) (= inline$$Diem_Preburn_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$ret0@2@@0) 1)))) (and (=> (= (ControlFlow 0 303205) 303221) inline$$Diem_Preburn_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 303205) 303213) inline$$Diem_Preburn_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon20_Else_correct  (=> (and (not $abort_flag@11@@5) (= (ControlFlow 0 303239) 303205)) inline$$Diem_Preburn_pack$0$anon0_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon3_correct@@0  (=> (= inline$$Diem_zero_$def$0$$ret0@1@@0 $Error) (=> (and (= $abort_flag@11@@5 true) (= inline$$Diem_zero_$def$0$$ret0@2@@0 inline$$Diem_zero_$def$0$$ret0@1@@0)) (and (=> (= (ControlFlow 0 303044) 303263) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 303044) 303239) inline$$Diem_create_preburn_$def$0$anon20_Else_correct))))))
(let ((inline$$Diem_zero_$def$0$anon8_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 303038) 303044)) inline$$Diem_zero_$def$0$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon8_Then_correct@@0  (=> (= (ControlFlow 0 303052) 303044) inline$$Diem_zero_$def$0$anon3_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon7_Then_correct@@0  (=> $abort_flag@10@@5 (and (=> (= (ControlFlow 0 303032) 303052) inline$$Diem_zero_$def$0$anon8_Then_correct@@0) (=> (= (ControlFlow 0 303032) 303038) inline$$Diem_zero_$def$0$anon8_Else_correct@@0)))))
(let ((inline$$Diem_zero_$def$0$anon6_correct@@0  (=> (and (= $abort_flag@11@@5 $abort_flag@10@@5) (= inline$$Diem_zero_$def$0$$ret0@2@@0 inline$$Diem_Diem_pack$0$$struct@1@@1)) (and (=> (= (ControlFlow 0 303020) 303263) inline$$Diem_create_preburn_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 303020) 303239) inline$$Diem_create_preburn_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_zero_$def$0$anon9_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 303018) 303020)) inline$$Diem_zero_$def$0$anon6_correct@@0)))
(let ((inline$$Diem_zero_$def$0$anon9_Then_correct@@0  (=> (= (ControlFlow 0 303028) 303020) inline$$Diem_zero_$def$0$anon6_correct@@0)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 302996) 303028) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 302996) 303018) inline$$Diem_zero_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct@@1  (and (=> (= (ControlFlow 0 303002) 303028) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 303002) 303018) inline$$Diem_zero_$def$0$anon9_Else_correct@@0))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct@@1  (=> (> 0 0) (and (=> (= (ControlFlow 0 302990) 303002) inline$$Diem_Diem_pack$0$anon4_Then_correct@@1) (=> (= (ControlFlow 0 302990) 302996) inline$$Diem_Diem_pack$0$anon4_Else_correct@@1)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct@@1  (=> (>= 0 0) (and (=> (= (ControlFlow 0 302982) 303028) inline$$Diem_zero_$def$0$anon9_Then_correct@@0) (=> (= (ControlFlow 0 302982) 303018) inline$$Diem_zero_$def$0$anon9_Else_correct@@0)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct@@1  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def$0$$t0@1@@0) (>= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1@@0) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def$0$$t0@1@@0) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1@@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def$0$$t0@1@@0) 1)))) (and (=> (= (ControlFlow 0 302974) 302990) inline$$Diem_Diem_pack$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 302974) 302982) inline$$Diem_Diem_pack$0$anon3_Else_correct@@1)))))
(let ((inline$$Diem_zero_$def$0$anon7_Else_correct@@0  (=> (not $abort_flag@10@@5) (=> (and (= inline$$Diem_zero_$def$0$$t0@1@@0 ($Integer 0)) (= (ControlFlow 0 303008) 302974)) inline$$Diem_Diem_pack$0$anon0_correct@@1))))
(let ((inline$$Diem_zero_$def$0$anon0_correct@@0  (=> (and (and (not $abort_flag@9@@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@10@@5)) (and (=> $abort_flag@10@@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@10@@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@14@@5 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 302833) 303032) inline$$Diem_zero_$def$0$anon7_Then_correct@@0) (=> (= (ControlFlow 0 302833) 303008) inline$$Diem_zero_$def$0$anon7_Else_correct@@0)))))
(let ((inline$$Diem_create_preburn_$def$0$anon18_Else_correct  (=> (and (not $abort_flag@9@@6) (= (ControlFlow 0 303066) 302833)) inline$$Diem_zero_$def$0$anon0_correct@@0)))
(let ((inline$$Diem_create_preburn_$def$0$anon16_Else_correct  (=> (and (and (not $abort_flag@8@@6) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@6)) (and (=> $abort_flag@9@@6 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@9@@6 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13@@6 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 302636) 303273) inline$$Diem_create_preburn_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 302636) 303066) inline$$Diem_create_preburn_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_create_preburn_$def$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@8@@6) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@8@@6) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@8@@6)) (and (=> $abort_flag@8@@6 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))))) (=> $abort_flag@8@@6 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@12@@6 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@12@@6 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@12@@6 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 302630) 303293) inline$$Diem_create_preburn_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 302630) 302636) inline$$Diem_create_preburn_$def$0$anon16_Else_correct))))))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 302594) 302630)) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon15_Then_correct  (=> (= (ControlFlow 0 303317) 302630) inline$$Diem_create_preburn_$def$0$anon2$1_correct)))
(let ((inline$$Diem_create_preburn_$def$0$anon0_correct  (=> (not $abort_flag@7@@8) (and (=> (= (ControlFlow 0 302588) 303317) inline$$Diem_create_preburn_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 302588) 302594) inline$$Diem_create_preburn_$def$0$anon15_Else_correct)))))
(let ((inline$$Diem_create_preburn_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) tc_account@@1) (= (ControlFlow 0 303323) 302588)) inline$$Diem_create_preburn_$def$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon56_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1@@0) (= (ControlFlow 0 303331) 303323)) inline$$Diem_create_preburn_$direct_intra$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon34_correct  (=> (= $abort_code@18@@3 $abort_code@11@@8) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 302270) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 302268) 302270)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon34_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 302278) 302270) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon34_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1@@0)) (= $abort_code@11@@8 (|i#$Integer| call3formal@$ret0@0@@50))) (and (=> (= (ControlFlow 0 302262) 302278) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 302262) 302268) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@7@@8) (and (=> (= (ControlFlow 0 302250) 303331) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 302250) 302262) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_preburn_to_account_$def_verify$0$$t15@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@8)) (and (=> $abort_flag@7@@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@50 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@50) (>= (|i#$Integer| call3formal@$ret0@0@@50) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@50) $MAX_U64))) (and (=> (= (ControlFlow 0 302244) 303877) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 302244) 302250) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Not$1$anon0_correct@@0  (=> (and (= inline$$Not$1$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_preburn_to_account_$def_verify$0$$t13@1)))) (= (ControlFlow 0 302232) 302244)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct@@0  (and (=> (= (ControlFlow 0 302222) (- 0 507447)) true) (=> (= (ControlFlow 0 302222) 302232) inline$$Not$1$anon0_correct@@0))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@6@@10) (=> (and (= inline$$Diem_publish_preburn_to_account_$def_verify$0$$t13@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| call3formal@$ret0@0@@51)))) (= (ControlFlow 0 302238) 302222)) inline$$Not$1$Entry_correct@@0))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon50_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@11) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@10) (=> $abort_flag@6@@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@6@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@51 account@@3)))) ((_ is $Address) call3formal@$ret0@0@@51))) (and (=> (= (ControlFlow 0 302164) 303897) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 302164) 302238) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon52_Else_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon22_correct  (=> (= $abort_code@18@@3 $abort_code@9@@9) (=> (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 302146) 302150)) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 302144) 302146)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon22_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 302158) 302146) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon22_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon50_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@11)) (= $abort_code@9@@9 (|i#$Integer| call3formal@$ret0@0@@52))) (and (=> (= (ControlFlow 0 302138) 302158) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 302138) 302144) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon48_Else_correct  (=> (not $abort_flag@5@@11) (and (=> (= (ControlFlow 0 302126) 302164) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 302126) 302138) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_preburn_to_account_$def_verify$0$$t10@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@11)) (and (=> $abort_flag@5@@11 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@52 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@52) (>= (|i#$Integer| call3formal@$ret0@0@@52) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@52) $MAX_U64))) (and (=> (= (ControlFlow 0 302120) 303917) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 302120) 302126) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@11  (=> (and (= inline$$Not$0$dst@1@@11 ($Boolean  (not (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$ret0@2)))) (= (ControlFlow 0 302108) 302120)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@11  (and (=> (= (ControlFlow 0 302098) (- 0 507248)) true) (=> (= (ControlFlow 0 302098) 302108) inline$$Not$0$anon0_correct@@11))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Else_correct  (=> (and (not $abort_flag@4@@14) (= (ControlFlow 0 302114) 302098)) inline$$Not$0$Entry_correct@@11)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Then_correct  (=> (and (and $abort_flag@4@@14 (= $abort_code@18@@3 $abort_code@6@@13)) (and (= $Diem_Preburn_$memory@0@@4 $Diem_Preburn_$memory) (= (ControlFlow 0 303937) 302150))) inline$$Diem_publish_preburn_to_account_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$Abort_correct  (=> (and (and (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@1 $Error) (= $abort_flag@4@@14 true)) (and (= $abort_code@6@@13 $abort_code@5@@14) (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 inline$$Diem_is_synthetic_currency_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 302032) 303937) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 302032) 302114) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon7_correct  (=> (and (= $abort_code@5@@14 $abort_code@3@@18) (= (ControlFlow 0 302026) 302032)) inline$$Diem_is_synthetic_currency_$def$0$Abort_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 302024) 302026)) inline$$Diem_is_synthetic_currency_$def$0$anon7_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon18_Then_correct  (=> (= (ControlFlow 0 302040) 302026) inline$$Diem_is_synthetic_currency_$def$0$anon7_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct  (=> $abort_flag@2@@22 (and (=> (= (ControlFlow 0 302018) 302040) inline$$Diem_is_synthetic_currency_$def$0$anon18_Then_correct) (=> (= (ControlFlow 0 302018) 302024) inline$$Diem_is_synthetic_currency_$def$0$anon18_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct  (=> $abort_flag@1@@25 (=> (and (= $abort_code@5@@14 $abort_code@2@@17) (= (ControlFlow 0 302044) 302032)) inline$$Diem_is_synthetic_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon14_correct  (=> (= $abort_flag@4@@14 $abort_flag@3@@16) (=> (and (= $abort_code@6@@13 $abort_code@4@@17) (= inline$$Diem_is_synthetic_currency_$def$0$$ret0@2 |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1|)) (and (=> (= (ControlFlow 0 301701) 303937) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 301701) 302114) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 301699) 301701)) inline$$Diem_is_synthetic_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct  (=> (= (ControlFlow 0 301709) 301701) inline$$Diem_is_synthetic_currency_$def$0$anon14_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon10_correct  (=> (= $abort_code@4@@17 $abort_code@3@@18) (=> (and (= |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| inline$$GetFieldFromValue$0$dst@1@@17) (= $abort_flag@3@@16 $abort_flag@2@@22)) (and (=> (= (ControlFlow 0 302006) 301709) inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 302006) 301699) inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon19_Else_correct  (=> (and (not true) (= (ControlFlow 0 302004) 302006)) inline$$Diem_is_synthetic_currency_$def$0$anon10_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon19_Then_correct  (=> (= (ControlFlow 0 302014) 302006) inline$$Diem_is_synthetic_currency_$def$0$anon10_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@17  (=> (= inline$$GetFieldFromValue$0$dst@1@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2@@4)) $Diem_CurrencyInfo_is_synthetic)) (and (=> (= (ControlFlow 0 301956) 302014) inline$$Diem_is_synthetic_currency_$def$0$anon19_Then_correct) (=> (= (ControlFlow 0 301956) 302004) inline$$Diem_is_synthetic_currency_$def$0$anon19_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct  (=> (and (not $abort_flag@2@@22) (= (ControlFlow 0 301962) 301956)) inline$$GetFieldFromValue$0$anon0_correct@@17)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@10  (=> (= $abort_flag@2@@22 true) (=> (and (= $abort_code@3@@18 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@0@@4)) (and (=> (= (ControlFlow 0 301902) 302018) inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 301902) 301962) inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@10  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@10 inline$$GetGlobal$0$a@1@@10)) (= (ControlFlow 0 301900) 301902)) inline$$GetGlobal$0$anon3_Then$1_correct@@10)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@10  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@10 inline$$GetGlobal$0$a@1@@10) (=> (and (and (= inline$$GetGlobal$0$dst@1@@10 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@10 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@18))) (= $abort_flag@2@@22 $abort_flag@1@@25)) (and (= $abort_code@3@@18 $abort_code@2@@17) (= inline$$GetGlobal$0$dst@2@@4 inline$$GetGlobal$0$dst@1@@10))) (and (=> (= (ControlFlow 0 301848) 302018) inline$$Diem_is_synthetic_currency_$def$0$anon17_Then_correct) (=> (= (ControlFlow 0 301848) 301962) inline$$Diem_is_synthetic_currency_$def$0$anon17_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@10  (=> (= inline$$GetGlobal$0$a@1@@10 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@18)) (and (=> (= (ControlFlow 0 301830) 301900) inline$$GetGlobal$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 301830) 301848) inline$$GetGlobal$0$anon3_Else_correct@@10)))))
(let ((inline$$GetGlobal$0$Entry_correct@@10  (=> (= inline$$GetGlobal$0$ta@0@@10 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1)) (and (=> (= (ControlFlow 0 301824) (- 0 507013)) true) (=> (= (ControlFlow 0 301824) 301830) inline$$GetGlobal$0$anon0_correct@@10)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon16_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$t2@1) (= (ControlFlow 0 301908) 301824)) inline$$GetGlobal$0$Entry_correct@@10)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon12_correct  (=> (= $abort_code@4@@17 $abort_code@2@@17) (=> (and (= |inline$$Diem_is_synthetic_currency_$def$0$tmp#$1@1| inline$$Diem_is_synthetic_currency_$def$0$$t5@1) (= $abort_flag@3@@16 $abort_flag@1@@25)) (and (=> (= (ControlFlow 0 301689) 301709) inline$$Diem_is_synthetic_currency_$def$0$anon21_Then_correct) (=> (= (ControlFlow 0 301689) 301699) inline$$Diem_is_synthetic_currency_$def$0$anon21_Else_correct))))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon20_Else_correct  (=> (and (not true) (= (ControlFlow 0 301687) 301689)) inline$$Diem_is_synthetic_currency_$def$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon20_Then_correct  (=> (= (ControlFlow 0 301717) 301689) inline$$Diem_is_synthetic_currency_$def$0$anon12_correct)))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon16_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_is_synthetic_currency_$def$0$$t2@1)) (= inline$$Diem_is_synthetic_currency_$def$0$$t5@1 ($Boolean false))) (and (=> (= (ControlFlow 0 301679) 301717) inline$$Diem_is_synthetic_currency_$def$0$anon20_Then_correct) (=> (= (ControlFlow 0 301679) 301687) inline$$Diem_is_synthetic_currency_$def$0$anon20_Else_correct)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct  (=> (and (not $abort_flag@1@@25) (= inline$$Diem_is_synthetic_currency_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@18))))) (and (=> (= (ControlFlow 0 301635) 301908) inline$$Diem_is_synthetic_currency_$def$0$anon16_Then_correct) (=> (= (ControlFlow 0 301635) 301679) inline$$Diem_is_synthetic_currency_$def$0$anon16_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@18  (=> (not true) (and (=> (= (ControlFlow 0 301583) 302044) inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 301583) 301635) inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@18  (and (=> (= (ControlFlow 0 301593) 302044) inline$$Diem_is_synthetic_currency_$def$0$anon15_Then_correct) (=> (= (ControlFlow 0 301593) 301635) inline$$Diem_is_synthetic_currency_$def$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@18  (=> (and (not $abort_flag@1@@25) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@18 ($Address 173345816))) (and (=> (= (ControlFlow 0 301577) 301593) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@18) (=> (= (ControlFlow 0 301577) 301583) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@18)))))
(let ((inline$$Diem_is_synthetic_currency_$def$0$anon0_correct  (=> (and (not $abort_flag@1@@25) (= (ControlFlow 0 301607) 301577)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@18)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon45_Else_correct  (=> (and (not $abort_flag@1@@25) (= (ControlFlow 0 302058) 301607)) inline$$Diem_is_synthetic_currency_$def$0$anon0_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon43_Else_correct  (=> (and (not $abort_flag@0@@26) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) $abort_flag@1@@25)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@1@@25) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) $abort_flag@1@@25)) (and (=> $abort_flag@1@@25 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))))) (=> $abort_flag@1@@25 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1))))))) (= $abort_code@2@@17 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@1)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@2@@17 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@1 ($Address 186537453))))) (= $abort_code@2@@17 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 301144) 303941) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 301144) 302058) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon45_Else_correct))))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) $abort_flag@0@@26) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@0@@26)) (and (=> $abort_flag@0@@26 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))))) (=> $abort_flag@0@@26 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3))))))) (= $abort_code@1@@23 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| account@@3)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@1@@23 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 301138) 303961) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 301138) 301144) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon4_correct  (=> (and (= inline$$Diem_publish_preburn_to_account_$def_verify$0$$Diem_Preburn_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3) true)) (= (ControlFlow 0 301102) 301138)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 301040) 301102)) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 303985) 301102) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon4_correct)))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 301032) 303985) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 301032) 301040) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 303993) 303985) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 303993) 301040) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon42_Else_correct))))
(let ((inline$$Diem_publish_preburn_to_account_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 301026) 303993) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 301026) 301032) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon41_Else_correct)))))
(let ((anon0$1_correct@@26  (=> (and (and (and (forall (($inv_addr@@55 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55)) (let ((va@@437 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))))
(let ((l@@437 (|l#$ValueArray| va@@437)))
 (and (and (<= 0 l@@437) (<= l@@437 $MAX_U64)) (forall ((x@@437 Int) ) (!  (=> (or (< x@@437 0) (>= x@@437 l@@437)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@437) x@@437) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@437) x@@437))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@55))
)) (forall (($inv_addr@@56 Int) ($inv_tv0@@48 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56)) (let ((va@@438 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))))
(let ((l@@438 (|l#$ValueArray| va@@438)))
 (and (and (<= 0 l@@438) (<= l@@438 $MAX_U64)) (forall ((x@@438 Int) ) (!  (=> (or (< x@@438 0) (>= x@@438 l@@438)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@438) x@@438) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@438) x@@438))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@439 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@439 (|l#$ValueArray| va@@439)))
 (and (and (<= 0 l@@439) (<= l@@439 $MAX_U64)) (forall ((x@@439 Int) ) (!  (=> (or (< x@@439 0) (>= x@@439 l@@439)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@439) x@@439) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@439) x@@439))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code)) (let ((va@@440 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@440 (|l#$ValueArray| va@@440)))
 (and (and (<= 0 l@@440) (<= l@@440 $MAX_U64)) (forall ((x@@440 Int) ) (!  (=> (or (< x@@440 0) (>= x@@440 l@@440)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@440) x@@440) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@440) x@@440))
))))))) (forall (($$0@@147 Int) ) (!  (=> (and (>= $$0@@147 0) (< $$0@@147 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))) $$0@@147)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))) $$0@@147)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))) $$0@@147)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_currency_code))) $$0@@147))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events)) (let ((va@@441 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@441 (|l#$ValueArray| va@@441)))
 (and (and (<= 0 l@@441) (<= l@@441 $MAX_U64)) (forall ((x@@441 Int) ) (!  (=> (or (< x@@441 0) (>= x@@441 l@@441)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@441) x@@441) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@441) x@@441))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@442 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@442 (|l#$ValueArray| va@@442)))
 (and (and (<= 0 l@@442) (<= l@@442 $MAX_U64)) (forall ((x@@442 Int) ) (!  (=> (or (< x@@442 0) (>= x@@442 l@@442)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@442) x@@442) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@442) x@@442))
))))))) (forall (($$0@@148 Int) ) (!  (=> (and (>= $$0@@148 0) (< $$0@@148 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@148)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@148)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@148)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@148))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events)) (let ((va@@443 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@443 (|l#$ValueArray| va@@443)))
 (and (and (<= 0 l@@443) (<= l@@443 $MAX_U64)) (forall ((x@@443 Int) ) (!  (=> (or (< x@@443 0) (>= x@@443 l@@443)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@443) x@@443) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@443) x@@443))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@444 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@444 (|l#$ValueArray| va@@444)))
 (and (and (<= 0 l@@444) (<= l@@444 $MAX_U64)) (forall ((x@@444 Int) ) (!  (=> (or (< x@@444 0) (>= x@@444 l@@444)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@444) x@@444) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@444) x@@444))
))))))) (forall (($$0@@149 Int) ) (!  (=> (and (>= $$0@@149 0) (< $$0@@149 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@149)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@149)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@149)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@149))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@445 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@445 (|l#$ValueArray| va@@445)))
 (and (and (<= 0 l@@445) (<= l@@445 $MAX_U64)) (forall ((x@@445 Int) ) (!  (=> (or (< x@@445 0) (>= x@@445 l@@445)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@445) x@@445) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@445) x@@445))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@446 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@446 (|l#$ValueArray| va@@446)))
 (and (and (<= 0 l@@446) (<= l@@446 $MAX_U64)) (forall ((x@@446 Int) ) (!  (=> (or (< x@@446 0) (>= x@@446 l@@446)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@446) x@@446) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@446) x@@446))
))))))) (forall (($$0@@150 Int) ) (!  (=> (and (>= $$0@@150 0) (< $$0@@150 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@150)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@150)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@150)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@150))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@447 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@447 (|l#$ValueArray| va@@447)))
 (and (and (<= 0 l@@447) (<= l@@447 $MAX_U64)) (forall ((x@@447 Int) ) (!  (=> (or (< x@@447 0) (>= x@@447 l@@447)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@447) x@@447) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@447) x@@447))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@448 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@448 (|l#$ValueArray| va@@448)))
 (and (and (<= 0 l@@448) (<= l@@448 $MAX_U64)) (forall ((x@@448 Int) ) (!  (=> (or (< x@@448 0) (>= x@@448 l@@448)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@448) x@@448) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@448) x@@448))
))))))) (forall (($$0@@151 Int) ) (!  (=> (and (>= $$0@@151 0) (< $$0@@151 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@151)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@151)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@151)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@151))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@449 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@449 (|l#$ValueArray| va@@449)))
 (and (and (<= 0 l@@449) (<= l@@449 $MAX_U64)) (forall ((x@@449 Int) ) (!  (=> (or (< x@@449 0) (>= x@@449 l@@449)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@449) x@@449) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@449) x@@449))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@450 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@450 (|l#$ValueArray| va@@450)))
 (and (and (<= 0 l@@450) (<= l@@450 $MAX_U64)) (forall ((x@@450 Int) ) (!  (=> (or (< x@@450 0) (>= x@@450 l@@450)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@450) x@@450) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@450) x@@450))
))))))) (forall (($$0@@152 Int) ) (!  (=> (and (>= $$0@@152 0) (< $$0@@152 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@152)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@152)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@152)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@152))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@48) 1) $inv_addr@@56))
))) (and (forall (($inv_addr@@57 Int) ($inv_tv0@@49 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57)) (let ((va@@451 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))))
(let ((l@@451 (|l#$ValueArray| va@@451)))
 (and (and (<= 0 l@@451) (<= l@@451 $MAX_U64)) (forall ((x@@451 Int) ) (!  (=> (or (< x@@451 0) (>= x@@451 l@@451)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@451) x@@451) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@451) x@@451))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn)) (let ((va@@452 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn))))
(let ((l@@452 (|l#$ValueArray| va@@452)))
 (and (and (<= 0 l@@452) (<= l@@452 $MAX_U64)) (forall ((x@@452 Int) ) (!  (=> (or (< x@@452 0) (>= x@@452 l@@452)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@452) x@@452) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@452) x@@452))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@49) 1) $inv_addr@@57))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@44 T@$Value) )  (=> ((_ is $Type) coin_type@@44) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@4 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@44)) 1) (|a#$Address| mint_cap_owner@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@45 T@$Value) )  (=> ((_ is $Type) coin_type@@45) (|b#$Boolean| ($Boolean (forall ((addr3@@22 T@$Value) )  (=> ((_ is $Address) addr3@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@45)) 1) (|a#$Address| addr3@@22)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@45)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@45)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@46 T@$Value) )  (=> ((_ is $Type) coin_type@@46) (|b#$Boolean| ($Boolean (forall ((addr1@@16 T@$Value) )  (=> ((_ is $Address) addr1@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@46)) 1) (|a#$Address| addr1@@16)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@16)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@47 T@$Value) )  (=> ((_ is $Type) coin_type@@47) (|b#$Boolean| ($Boolean (forall ((addr1@@17 T@$Value) )  (=> ((_ is $Address) addr1@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@47)) 1) (|a#$Address| addr1@@17)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@17)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 303997) 301026)))) inline$$Diem_publish_preburn_to_account_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@27  (=> ((_ is $Address) account@@3) (=> (and ((_ is $Address) tc_account@@1) (= (ControlFlow 0 299806) 303997)) anon0$1_correct@@26))))
(let ((PreconditionGeneratedEntry_correct@@18  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Diem_Preburn_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@34) 1) (|a#$Address| account@@3)) (= (ControlFlow 0 502997) 299806)) anon0_correct@@27)))
PreconditionGeneratedEntry_correct@@18))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@35 () T@$TypeValue)
(declare-fun tc_account@@2 () T@$Value)
(declare-fun $abort_flag@21@@0 () Bool)
(declare-fun scaling_factor () T@$Value)
(declare-fun dr_account@@0 () T@$Value)
(declare-fun currency_code () T@$Value)
(declare-fun $DiemConfig_DisableReconfiguration_$memory () T@$Memory)
(declare-fun $abort_code@31@@0 () Int)
(declare-fun $Diem_MintCapability_$memory@1 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@3@@4 () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory@3 () T@$Memory)
(declare-fun $abort_flag@20@@0 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@1@@9 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@6 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@4 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@6 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@4@@0 () T@$Memory)
(declare-fun |inline$$MoveToRaw$1$m'@2| () T@$Memory)
(declare-fun $abort_code@29@@0 () Int)
(declare-fun $Diem_BurnCapability_$memory@1@@0 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@2@@6 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@5 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@5 () T@$Memory)
(declare-fun $Diem_MintCapability_$memory@0 () T@$Memory)
(declare-fun $abort_code@30@@0 () Int)
(declare-fun $Diem_BurnCapability_$memory@2 () T@$Memory)
(declare-fun $abort_code@1@@24 () Int)
(declare-fun $abort_flag@0@@27 () Bool)
(declare-fun $abort_code@18@@4 () Int)
(declare-fun $abort_flag@12@@4 () Bool)
(declare-fun $abort_code@19@@3 () Int)
(declare-fun $abort_flag@13@@3 () Bool)
(declare-fun $abort_code@21@@2 () Int)
(declare-fun $abort_flag@14@@3 () Bool)
(declare-fun $abort_flag@19@@0 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@2| () T@$Memory)
(declare-fun $abort_code@27@@1 () Int)
(declare-fun $abort_code@28@@0 () Int)
(declare-fun $Diem_BurnCapability_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@22@@1 () Int)
(declare-fun $abort_flag@15@@1 () Bool)
(declare-fun $abort_code@23@@1 () Int)
(declare-fun $abort_flag@16@@1 () Bool)
(declare-fun $abort_code@24@@1 () Int)
(declare-fun $abort_flag@17@@1 () Bool)
(declare-fun $abort_code@25@@1 () Int)
(declare-fun $abort_flag@18@@1 () Bool)
(declare-fun |inline$$MoveToRaw$2$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$2$a@1 () Int)
(declare-fun |inline$$MoveToRaw$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@2 () T@$Value)
(declare-fun inline$$Not$3$dst@1 () T@$Value)
(declare-fun $abort_code@26@@1 () Int)
(declare-fun call3formal@$ret0@0@@53 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t9@1 () T@$Value)
(declare-fun inline$$Diem_publish_burn_capability_$def$0$$t7@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@54 () T@$Value)
(declare-fun |inline$$MoveToRaw$1$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$1$a@1 () Int)
(declare-fun |inline$$MoveToRaw$1$m'@1| () T@$Memory)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Not$2$dst@1 () T@$Value)
(declare-fun $abort_code@20@@2 () Int)
(declare-fun call3formal@$ret0@0@@55 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def_verify$0$$t20@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@56 () T@$Value)
(declare-fun $abort_flag@11@@6 () Bool)
(declare-fun $abort_code@17@@5 () Int)
(declare-fun inline$$Diem_MintCapability_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_BurnCapability_pack$0$$struct@1 () T@$Value)
(declare-fun |inline$$MoveToRaw$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_flag@10@@6 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@2 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@0 () T@$Memory)
(declare-fun $abort_code@15@@6 () Int)
(declare-fun inline$$Diem_register_currency_$def$0$$t39@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t37@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$ret1@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@0@@9 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@3 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@3@@0 () T@$Memory)
(declare-fun $abort_code@16@@6 () Int)
(declare-fun $abort_code@2@@18 () Int)
(declare-fun $abort_flag@1@@26 () Bool)
(declare-fun $abort_code@3@@19 () Int)
(declare-fun $abort_flag@2@@23 () Bool)
(declare-fun $abort_code@4@@18 () Int)
(declare-fun $abort_flag@3@@17 () Bool)
(declare-fun $abort_code@5@@15 () Int)
(declare-fun $abort_flag@4@@15 () Bool)
(declare-fun $abort_code@7@@13 () Int)
(declare-fun $abort_flag@5@@12 () Bool)
(declare-fun $abort_code@9@@10 () Int)
(declare-fun $abort_flag@6@@11 () Bool)
(declare-fun $abort_flag@9@@7 () Bool)
(declare-fun $abort_code@13@@7 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0 () T@$Memory)
(declare-fun $abort_code@14@@6 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1 () T@$Memory)
(declare-fun $abort_code@10@@9 () Int)
(declare-fun $abort_flag@7@@9 () Bool)
(declare-fun $abort_code@11@@9 () Int)
(declare-fun $abort_flag@8@@7 () Bool)
(declare-fun call0formal@$tv0@0@@0 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@5| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@9| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@57 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@7| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@7 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@10| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@9 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@9 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@9| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@9 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@10 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@9 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@9 () Int)
(declare-fun inline$$BorrowField$0$p@2@@9 () T@$Path)
(declare-fun inline$$Not$1$dst@1@@1 () T@$Value)
(declare-fun $abort_code@12@@7 () Int)
(declare-fun call3formal@$ret0@0@@58 () T@$Value)
(declare-fun inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@18 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@1 () T@$TypeValue)
(declare-fun |inline$$MoveToRaw$0$m'@0@@1| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t28@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t29@1 () T@$Value)
(declare-fun to_xdx_exchange_rate () T@$Value)
(declare-fun inline$$Diem_register_SCS_currency_$def_verify$0$$t16@1 () T@$Value)
(declare-fun fractional_part () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t30@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$2$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$3$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$3$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$2$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$1$t@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun |inline$$Diem_register_currency_$def$0$tmp#$10@1| () T@$Value)
(declare-fun $abort_code@8@@11 () Int)
(declare-fun call3formal@$ret0@0@@59 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t26@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t24@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t25@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t22@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@12 () T@$Value)
(declare-fun $abort_code@6@@14 () Int)
(declare-fun call3formal@$ret0@0@@60 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def$0$$t18@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@61 () T@$Value)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 510220) (let ((anon0$2_correct@@28  (and (=> (= (ControlFlow 0 315946) (- 0 523924)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 523950)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 523971)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524000)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524017)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524054)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0)))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0)))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524080)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524101)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524130)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524147)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524164)) (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@451 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@451)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@453 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@453 currency_code))))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@451 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@451)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((x@@453 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@453 currency_code))))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524186)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524219)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524249)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524348)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524374)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524395)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524424)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524441)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524462)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524491)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524508)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524529)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524558)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@21@@0) (and (=> (= (ControlFlow 0 315946) (- 0 524575)) (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@452 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@452)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@454 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@454 currency_code)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))))) (=> (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@452 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@452)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((x@@454 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@454 currency_code)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 315946) (- 0 525203)) (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@453 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@453)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@455 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@455 currency_code))))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@21@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| dr_account@@0)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@453 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@453)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((x@@455 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@455 currency_code))))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@0))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@31@@0 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 315946) (- 0 526095)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2)))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| tc_account@@2))))) (and (=> (= (ControlFlow 0 315946) (- 0 526111)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526157)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@454 T@$Value) )  (=> ((_ is $Address) addr@@454) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@454)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@454))))))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@455 T@$Value) )  (=> ((_ is $Address) addr@@455) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@455)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@455)))))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526223)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526269)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@456 T@$Value) )  (=> ((_ is $Address) addr@@456) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@456)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@456))))))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@457 T@$Value) )  (=> ((_ is $Address) addr@@457) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@457)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@457)))))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526335)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526381)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526427)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@458 T@$Value) )  (=> ((_ is $Address) addr@@458) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@458))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@458)))))))))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@459 T@$Value) )  (=> ((_ is $Address) addr@@459) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@459))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@459))))))))))))))) (and (=> (= (ControlFlow 0 315946) (- 0 526507)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@460 T@$Value) )  (=> ((_ is $Address) addr@@460) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@460)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@460))))))))))))) (=> (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean (forall ((addr@@461 T@$Value) )  (=> ((_ is $Address) addr@@461) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@461)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| addr@@461)))))))))))) (=> (= (ControlFlow 0 315946) (- 0 526575)) (=> (not $abort_flag@21@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@4) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Else_correct  (=> (not $abort_flag@20@@0) (=> (and (and (and (= $Diem_CurrencyInfo_$memory@3@@4 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@4@@0) (= $Diem_MintCapability_$memory@1 |inline$$MoveToRaw$1$m'@2|))) (and (and (= $abort_code@31@@0 $abort_code@29@@0) (= $Diem_BurnCapability_$memory@3 $Diem_BurnCapability_$memory@1@@0)) (and (= $abort_flag@21@@0 $abort_flag@20@@0) (= (ControlFlow 0 315788) 315946)))) anon0$2_correct@@28))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct  (=> (and (and (and (= $Diem_CurrencyInfo_$memory@3@@4 $Diem_CurrencyInfo_$memory@2@@6) (= $DiemConfig_Configuration_$memory@6 $DiemConfig_Configuration_$memory@5)) (and (= $DiemConfig_DiemConfig_$memory@6 $DiemConfig_DiemConfig_$memory@5) (= $Diem_MintCapability_$memory@1 $Diem_MintCapability_$memory@0))) (and (and (= $abort_code@31@@0 $abort_code@30@@0) (= $Diem_BurnCapability_$memory@3 $Diem_BurnCapability_$memory@2)) (and (= $abort_flag@21@@0 true) (= (ControlFlow 0 313619) 315946)))) anon0$2_correct@@28)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon15_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@30@@0 $abort_code@1@@24) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 315884) 313619))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon48_Else_correct  (=> (and (not true) (= (ControlFlow 0 315882) 315884)) inline$$Diem_register_SCS_currency_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon48_Then_correct  (=> (= (ControlFlow 0 315892) 315884) inline$$Diem_register_SCS_currency_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon47_Then_correct  (=> $abort_flag@0@@27 (and (=> (= (ControlFlow 0 315876) 315892) inline$$Diem_register_SCS_currency_$def_verify$0$anon48_Then_correct) (=> (= (ControlFlow 0 315876) 315882) inline$$Diem_register_SCS_currency_$def_verify$0$anon48_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon25_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@30@@0 $abort_code@18@@4) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 315844) 313619))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon53_Else_correct  (=> (and (not true) (= (ControlFlow 0 315842) 315844)) inline$$Diem_register_SCS_currency_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon53_Then_correct  (=> (= (ControlFlow 0 315852) 315844) inline$$Diem_register_SCS_currency_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Then_correct  (=> $abort_flag@12@@4 (and (=> (= (ControlFlow 0 315836) 315852) inline$$Diem_register_SCS_currency_$def_verify$0$anon53_Then_correct) (=> (= (ControlFlow 0 315836) 315842) inline$$Diem_register_SCS_currency_$def_verify$0$anon53_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon29_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@30@@0 $abort_code@19@@3) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 315824) 313619))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 315822) 315824)) inline$$Diem_register_SCS_currency_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon55_Then_correct  (=> (= (ControlFlow 0 315832) 315824) inline$$Diem_register_SCS_currency_$def_verify$0$anon29_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon54_Then_correct  (=> $abort_flag@13@@3 (and (=> (= (ControlFlow 0 315816) 315832) inline$$Diem_register_SCS_currency_$def_verify$0$anon55_Then_correct) (=> (= (ControlFlow 0 315816) 315822) inline$$Diem_register_SCS_currency_$def_verify$0$anon55_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon37_correct  (=> (= $Diem_MintCapability_$memory@0 |inline$$MoveToRaw$1$m'@2|) (=> (and (= $abort_code@30@@0 $abort_code@21@@2) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 315804) 313619))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 315802) 315804)) inline$$Diem_register_SCS_currency_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon59_Then_correct  (=> (= (ControlFlow 0 315812) 315804) inline$$Diem_register_SCS_currency_$def_verify$0$anon37_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Then_correct  (=> $abort_flag@14@@3 (and (=> (= (ControlFlow 0 315796) 315812) inline$$Diem_register_SCS_currency_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 315796) 315802) inline$$Diem_register_SCS_currency_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Then_correct  (=> (and (and (and $abort_flag@20@@0 (= $Diem_MintCapability_$memory@0 |inline$$MoveToRaw$1$m'@2|)) (and (= $abort_code@30@@0 $abort_code@29@@0) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory@1@@0))) (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 315792) 313619)))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct  (=> (not $abort_flag@19@@0) (and (=> (= (ControlFlow 0 315654) (- 0 523457)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_burn_capability_$def$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_burn_capability_$def$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_burn_capability_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_publish_burn_capability_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_publish_burn_capability_$def$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_publish_burn_capability_$def$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$2$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_publish_burn_capability_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_publish_burn_capability_$def$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (=> (= $abort_flag@20@@0 $abort_flag@19@@0) (=> (and (= $abort_code@29@@0 $abort_code@27@@1) (= $Diem_BurnCapability_$memory@1@@0 |inline$$MoveToRaw$2$m'@2|)) (and (=> (= (ControlFlow 0 315654) 315792) inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 315654) 315788) inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Else_correct)))))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$Abort_correct  (=> (= $abort_flag@20@@0 true) (=> (and (= $abort_code@29@@0 $abort_code@28@@0) (= $Diem_BurnCapability_$memory@1@@0 $Diem_BurnCapability_$memory@0@@0)) (and (=> (= (ControlFlow 0 315236) 315792) inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 315236) 315788) inline$$Diem_register_SCS_currency_$def_verify$0$anon60_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon7_correct  (=> (= $abort_code@28@@0 $abort_code@22@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 315746) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 315744) 315746)) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 315754) 315746) inline$$Diem_publish_burn_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct  (=> $abort_flag@15@@1 (and (=> (= (ControlFlow 0 315738) 315754) inline$$Diem_publish_burn_capability_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 315738) 315744) inline$$Diem_publish_burn_capability_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon11_correct  (=> (= $abort_code@28@@0 $abort_code@23@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 315726) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 315724) 315726)) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 315734) 315726) inline$$Diem_publish_burn_capability_$def$0$anon11_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct  (=> $abort_flag@16@@1 (and (=> (= (ControlFlow 0 315718) 315734) inline$$Diem_publish_burn_capability_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 315718) 315724) inline$$Diem_publish_burn_capability_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon15_correct  (=> (= $abort_code@28@@0 $abort_code@24@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 315706) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 315704) 315706)) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 315714) 315706) inline$$Diem_publish_burn_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct  (=> $abort_flag@17@@1 (and (=> (= (ControlFlow 0 315698) 315714) inline$$Diem_publish_burn_capability_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 315698) 315704) inline$$Diem_publish_burn_capability_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon19_correct  (=> (= $abort_code@28@@0 $abort_code@25@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 315686) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 315684) 315686)) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 315694) 315686) inline$$Diem_publish_burn_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct  (=> $abort_flag@18@@1 (and (=> (= (ControlFlow 0 315678) 315694) inline$$Diem_publish_burn_capability_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 315678) 315684) inline$$Diem_publish_burn_capability_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon27_correct  (=> (= $abort_code@28@@0 $abort_code@27@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 |inline$$MoveToRaw$2$m'@2|) (= (ControlFlow 0 315666) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 315664) 315666)) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 315674) 315666) inline$$Diem_publish_burn_capability_$def$0$anon27_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct  (=> $abort_flag@19@@0 (and (=> (= (ControlFlow 0 315658) 315674) inline$$Diem_publish_burn_capability_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 315658) 315664) inline$$Diem_publish_burn_capability_$def$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$2$anon3_Then$1_correct  (=> (= $abort_code@27@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@19@@0 true) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@0|)) (and (=> (= (ControlFlow 0 315568) 315658) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 315568) 315654) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$2$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1) (= (ControlFlow 0 315566) 315568)) inline$$MoveToRaw$2$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$2$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1)) (=> (and (and (= |inline$$MoveToRaw$2$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveTo$2$ta@0 inline$$MoveTo$2$a@1 inline$$Diem_register_currency_$def$0$$ret1@2))) (= $abort_code@27@@1 $abort_code@25@@1)) (and (= $abort_flag@19@@0 $abort_flag@18@@1) (= |inline$$MoveToRaw$2$m'@2| |inline$$MoveToRaw$2$m'@1|))) (and (=> (= (ControlFlow 0 315516) 315658) inline$$Diem_publish_burn_capability_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 315516) 315654) inline$$Diem_publish_burn_capability_$def$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$2$anon0$1_correct  (=> (= inline$$MoveTo$2$a@1 (|a#$Address| tc_account@@2)) (and (=> (= (ControlFlow 0 315574) 315566) inline$$MoveToRaw$2$anon3_Then_correct) (=> (= (ControlFlow 0 315574) 315516) inline$$MoveToRaw$2$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$2$Entry_correct  (and (=> (= (ControlFlow 0 315362) (- 0 523342)) true) (=> (= (ControlFlow 0 315362) 315574) inline$$MoveTo$2$anon0$1_correct))))
(let ((inline$$MoveTo$2$Entry_correct  (=> (and (= inline$$MoveTo$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1)) (= (ControlFlow 0 315334) 315362)) inline$$Signer_borrow_address$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct  (=> (and (|b#$Boolean| inline$$Not$3$dst@1) (= (ControlFlow 0 315582) 315334)) inline$$MoveTo$2$Entry_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon24_correct  (=> (= $abort_code@28@@0 $abort_code@26@@1) (=> (and (= $Diem_BurnCapability_$memory@0@@0 $Diem_BurnCapability_$memory) (= (ControlFlow 0 315232) 315236)) inline$$Diem_publish_burn_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 315230) 315232)) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 315244) 315232) inline$$Diem_publish_burn_capability_$def$0$anon24_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$3$dst@1)) (= $abort_code@26@@1 (|i#$Integer| call3formal@$ret0@0@@53))) (and (=> (= (ControlFlow 0 315224) 315244) inline$$Diem_publish_burn_capability_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 315224) 315230) inline$$Diem_publish_burn_capability_$def$0$anon40_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct  (=> (not $abort_flag@18@@1) (and (=> (= (ControlFlow 0 315212) 315582) inline$$Diem_publish_burn_capability_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 315212) 315224) inline$$Diem_publish_burn_capability_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct  (=> (and (and (and (= inline$$Diem_publish_burn_capability_$def$0$$t9@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@18@@1)) (and (=> $abort_flag@18@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@18@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@53 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@53) (>= (|i#$Integer| call3formal@$ret0@0@@53) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@53) $MAX_U64))) (and (=> (= (ControlFlow 0 315206) 315678) inline$$Diem_publish_burn_capability_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 315206) 315212) inline$$Diem_publish_burn_capability_$def$0$anon37_Else_correct)))))
(let ((inline$$Not$3$anon0_correct  (=> (and (= inline$$Not$3$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_publish_burn_capability_$def$0$$t7@1)))) (= (ControlFlow 0 315194) 315206)) inline$$Diem_publish_burn_capability_$def$0$anon35_Else$1_correct)))
(let ((inline$$Not$3$Entry_correct  (and (=> (= (ControlFlow 0 315184) (- 0 523185)) true) (=> (= (ControlFlow 0 315184) 315194) inline$$Not$3$anon0_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct  (=> (not $abort_flag@17@@1) (=> (and (= inline$$Diem_publish_burn_capability_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| call3formal@$ret0@0@@54)))) (= (ControlFlow 0 315200) 315184)) inline$$Not$3$Entry_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct  (=> (not $abort_flag@16@@1) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@17@@1) (=> $abort_flag@17@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@17@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@54 tc_account@@2)))) ((_ is $Address) call3formal@$ret0@0@@54))) (and (=> (= (ControlFlow 0 315126) 315698) inline$$Diem_publish_burn_capability_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 315126) 315200) inline$$Diem_publish_burn_capability_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct  (=> (and (and (not $abort_flag@15@@1) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@16@@1)) (and (=> $abort_flag@16@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@16@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@23@@1 (|i#$Integer| ($Integer 5))))))) (and (=> (= (ControlFlow 0 315120) 315718) inline$$Diem_publish_burn_capability_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 315120) 315126) inline$$Diem_publish_burn_capability_$def$0$anon33_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@15@@1) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@15@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@15@@1)) (and (=> $abort_flag@15@@1 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))))) (=> $abort_flag@15@@1 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@22@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@22@@1 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@22@@1 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 315114) 315738) inline$$Diem_publish_burn_capability_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 315114) 315120) inline$$Diem_publish_burn_capability_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 315044) 315114)) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 315762) 315114) inline$$Diem_publish_burn_capability_$def$0$anon4$2_correct)))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 315036) 315762) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 315036) 315044) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 315770) 315762) inline$$Diem_publish_burn_capability_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 315770) 315044) inline$$Diem_publish_burn_capability_$def$0$anon30_Else_correct))))
(let ((inline$$Diem_publish_burn_capability_$def$0$anon0_correct  (=> (not $abort_flag@14@@3) (and (=> (= (ControlFlow 0 315030) 315770) inline$$Diem_publish_burn_capability_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 315030) 315036) inline$$Diem_publish_burn_capability_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_publish_burn_capability_$direct_intra$0$anon0_correct  (=> ((_ is $Address) tc_account@@2) (=> (and (and (and (and (and ((_ is $Vector) inline$$Diem_register_currency_$def$0$$ret1@2) (let ((va@@453 (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)))
(let ((l@@453 (|l#$ValueArray| va@@453)))
 (and (and (<= 0 l@@453) (<= l@@453 $MAX_U64)) (forall ((x@@456 Int) ) (!  (=> (or (< x@@456 0) (>= x@@456 l@@453)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@453) x@@456) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@453) x@@456))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_register_currency_$def$0$$ret1@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 315774) 315030)) inline$$Diem_publish_burn_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Else_correct  (=> (not $abort_flag@14@@3) (and (=> (= (ControlFlow 0 315780) (- 0 522376)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (and (=> (= (ControlFlow 0 315780) (- 0 522439)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1 inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 315780) (- 0 522561)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@3)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@3)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 315780) (- 0 522613)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@6 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@6) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@6)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$tc_addr@@0))))))))))))))) (=> (= (ControlFlow 0 315780) 315774) inline$$Diem_publish_burn_capability_$direct_intra$0$anon0_correct))))))))))))
(let ((inline$$MoveToRaw$1$anon3_Then$1_correct  (=> (= $abort_flag@14@@3 true) (=> (and (= $abort_code@21@@2 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@0|)) (and (=> (= (ControlFlow 0 314078) 315796) inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 314078) 315780) inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$MoveToRaw$1$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1) (= (ControlFlow 0 314076) 314078)) inline$$MoveToRaw$1$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$1$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1)) (=> (and (and (= |inline$$MoveToRaw$1$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) inline$$MoveTo$1$ta@0 inline$$MoveTo$1$a@1 inline$$Diem_register_currency_$def$0$$ret0@2))) (= $abort_flag@14@@3 $abort_flag@13@@3)) (and (= $abort_code@21@@2 $abort_code@19@@3) (= |inline$$MoveToRaw$1$m'@2| |inline$$MoveToRaw$1$m'@1|))) (and (=> (= (ControlFlow 0 314026) 315796) inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 314026) 315780) inline$$Diem_register_SCS_currency_$def_verify$0$anon58_Else_correct))))))
(let ((inline$$MoveTo$1$anon0$1_correct  (=> (= inline$$MoveTo$1$a@1 (|a#$Address| tc_account@@2)) (and (=> (= (ControlFlow 0 314084) 314076) inline$$MoveToRaw$1$anon3_Then_correct) (=> (= (ControlFlow 0 314084) 314026) inline$$MoveToRaw$1$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$1$Entry_correct  (and (=> (= (ControlFlow 0 313872) (- 0 522261)) true) (=> (= (ControlFlow 0 313872) 314084) inline$$MoveTo$1$anon0$1_correct))))
(let ((inline$$MoveTo$1$Entry_correct  (=> (and (= inline$$MoveTo$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1)) (= (ControlFlow 0 313844) 313872)) inline$$Signer_borrow_address$1$Entry_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon56_Then_correct  (=> (|b#$Boolean| inline$$Not$2$dst@1) (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@9) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_SCS_currency_$def_verify$0$coin_type@@7)) 1) (|a#$Address| inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_register_SCS_currency_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 314092) 313844)) inline$$MoveTo$1$Entry_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon34_correct  (=> (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory) (=> (and (= $abort_code@30@@0 $abort_code@20@@2) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory)) (=> (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 313615) 313619))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon57_Else_correct  (=> (and (not true) (= (ControlFlow 0 313613) 313615)) inline$$Diem_register_SCS_currency_$def_verify$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon57_Then_correct  (=> (= (ControlFlow 0 313627) 313615) inline$$Diem_register_SCS_currency_$def_verify$0$anon34_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon56_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$2$dst@1)) (= $abort_code@20@@2 (|i#$Integer| call3formal@$ret0@0@@55))) (and (=> (= (ControlFlow 0 313607) 313627) inline$$Diem_register_SCS_currency_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 313607) 313613) inline$$Diem_register_SCS_currency_$def_verify$0$anon57_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon54_Else_correct  (=> (not $abort_flag@13@@3) (and (=> (= (ControlFlow 0 313595) 314092) inline$$Diem_register_SCS_currency_$def_verify$0$anon56_Then_correct) (=> (= (ControlFlow 0 313595) 313607) inline$$Diem_register_SCS_currency_$def_verify$0$anon56_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_SCS_currency_$def_verify$0$$t22@1 ($Integer 9)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@13@@3)) (and (=> $abort_flag@13@@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@13@@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@55 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@55) (>= (|i#$Integer| call3formal@$ret0@0@@55) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@55) $MAX_U64))) (and (=> (= (ControlFlow 0 313589) 315816) inline$$Diem_register_SCS_currency_$def_verify$0$anon54_Then_correct) (=> (= (ControlFlow 0 313589) 313595) inline$$Diem_register_SCS_currency_$def_verify$0$anon54_Else_correct)))))
(let ((inline$$Not$2$anon0_correct  (=> (and (= inline$$Not$2$dst@1 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_SCS_currency_$def_verify$0$$t20@1)))) (= (ControlFlow 0 313577) 313589)) inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Else$1_correct)))
(let ((inline$$Not$2$Entry_correct  (and (=> (= (ControlFlow 0 313567) (- 0 521977)) true) (=> (= (ControlFlow 0 313567) 313577) inline$$Not$2$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Else_correct  (=> (not $abort_flag@12@@4) (=> (and (= inline$$Diem_register_SCS_currency_$def_verify$0$$t20@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| call3formal@$ret0@0@@56)))) (= (ControlFlow 0 313583) 313567)) inline$$Not$2$Entry_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon22_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@12@@4) (=> $abort_flag@12@@4 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@12@@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@56 tc_account@@2)))) ((_ is $Address) call3formal@$ret0@0@@56))) (and (=> (= (ControlFlow 0 313509) 315836) inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Then_correct) (=> (= (ControlFlow 0 313509) 313583) inline$$Diem_register_SCS_currency_$def_verify$0$anon52_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 313507) 313509)) inline$$Diem_register_SCS_currency_$def_verify$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Then_correct  (=> (= (ControlFlow 0 315860) 313509) inline$$Diem_register_SCS_currency_$def_verify$0$anon22_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon50_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313465) 315860) inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 313465) 313507) inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon50_Then_correct  (and (=> (= (ControlFlow 0 315868) 315860) inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Then_correct) (=> (= (ControlFlow 0 315868) 313507) inline$$Diem_register_SCS_currency_$def_verify$0$anon51_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Else_correct  (=> (not $abort_flag@11@@6) (and (=> (= (ControlFlow 0 313457) 315868) inline$$Diem_register_SCS_currency_$def_verify$0$anon50_Then_correct) (=> (= (ControlFlow 0 313457) 313465) inline$$Diem_register_SCS_currency_$def_verify$0$anon50_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Then_correct  (=> (and (and (and $abort_flag@11@@6 (= $Diem_MintCapability_$memory@0 $Diem_MintCapability_$memory)) (and (= $abort_code@30@@0 $abort_code@17@@5) (= $Diem_BurnCapability_$memory@2 $Diem_BurnCapability_$memory))) (and (and (= $Diem_CurrencyInfo_$memory@2@@6 $Diem_CurrencyInfo_$memory@1@@9) (= $DiemConfig_Configuration_$memory@5 $DiemConfig_Configuration_$memory@4)) (and (= $DiemConfig_DiemConfig_$memory@5 $DiemConfig_DiemConfig_$memory@4@@0) (= (ControlFlow 0 315872) 313619)))) inline$$Diem_register_SCS_currency_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon76_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret0@2 inline$$Diem_MintCapability_pack$0$$struct@1) (=> (and (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_BurnCapability_pack$0$$struct@1) (= $Diem_CurrencyInfo_$memory@1@@9 |inline$$MoveToRaw$0$m'@2@@1|)) (=> (and (and (= $abort_flag@11@@6 $abort_flag@10@@6) (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@2)) (and (= $DiemConfig_DiemConfig_$memory@4@@0 $DiemConfig_DiemConfig_$memory@2@@0) (= $abort_code@17@@5 $abort_code@15@@6))) (and (=> (= (ControlFlow 0 313013) 315872) inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 313013) 313457) inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Else_correct)))))))
(let ((inline$$Diem_register_currency_$def$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 313011) 313013)) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon114_Then_correct  (=> (= (ControlFlow 0 313021) 313013) inline$$Diem_register_currency_$def$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon113_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 313001) 313021) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 313001) 313011) inline$$Diem_register_currency_$def$0$anon114_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon113_Then_correct  (and (=> (= (ControlFlow 0 313029) 313021) inline$$Diem_register_currency_$def$0$anon114_Then_correct) (=> (= (ControlFlow 0 313029) 313011) inline$$Diem_register_currency_$def$0$anon114_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 312979) 313029) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 312979) 313001) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Then_correct  (and (=> (= (ControlFlow 0 312985) 313029) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 312985) 313001) inline$$Diem_register_currency_$def$0$anon113_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 312973) 312985) inline$$Diem_BurnCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 312973) 312979) inline$$Diem_BurnCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Else_correct  (=> (>= 0 0) (and (=> (= (ControlFlow 0 312965) 313029) inline$$Diem_register_currency_$def$0$anon113_Then_correct) (=> (= (ControlFlow 0 312965) 313001) inline$$Diem_register_currency_$def$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t39@1) (= inline$$Diem_BurnCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t39@1) 1)))) (and (=> (= (ControlFlow 0 312957) 312973) inline$$Diem_BurnCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 312957) 312965) inline$$Diem_BurnCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else$1_correct  (=> (and (= inline$$Diem_register_currency_$def$0$$t39@1 ($Boolean false)) (= (ControlFlow 0 312991) 312957)) inline$$Diem_BurnCapability_pack$0$anon0_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 312808) 312991)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 312814) 312991) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 312802) 312814) inline$$Diem_MintCapability_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 312802) 312808) inline$$Diem_MintCapability_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 312794) 312991)) inline$$Diem_register_currency_$def$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon0_correct  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t37@1) (= inline$$Diem_MintCapability_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t37@1) 1)))) (and (=> (= (ControlFlow 0 312786) 312802) inline$$Diem_MintCapability_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 312786) 312794) inline$$Diem_MintCapability_pack$0$anon3_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Else_correct  (=> (not $abort_flag@10@@6) (=> (and (= inline$$Diem_register_currency_$def$0$$t37@1 ($Boolean false)) (= (ControlFlow 0 312820) 312786)) inline$$Diem_MintCapability_pack$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$Abort_correct  (=> (= inline$$Diem_register_currency_$def$0$$ret0@1 $Error) (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$ret1@1 $Error) (= inline$$Diem_register_currency_$def$0$$ret0@2 inline$$Diem_register_currency_$def$0$$ret0@1)) (and (= inline$$Diem_register_currency_$def$0$$ret1@2 inline$$Diem_register_currency_$def$0$$ret1@1) (= $Diem_CurrencyInfo_$memory@1@@9 $Diem_CurrencyInfo_$memory@0@@9))) (and (and (= $abort_flag@11@@6 true) (= $DiemConfig_Configuration_$memory@4 $DiemConfig_Configuration_$memory@3)) (and (= $DiemConfig_DiemConfig_$memory@4@@0 $DiemConfig_DiemConfig_$memory@3@@0) (= $abort_code@17@@5 $abort_code@16@@6)))) (and (=> (= (ControlFlow 0 309086) 315872) inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Then_correct) (=> (= (ControlFlow 0 309086) 313457) inline$$Diem_register_SCS_currency_$def_verify$0$anon49_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon15_correct  (=> (= $abort_code@16@@6 $abort_code@2@@18) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313343) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 313341) 313343)) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 313351) 313343) inline$$Diem_register_currency_$def$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon83_Then_correct  (=> $abort_flag@1@@26 (and (=> (= (ControlFlow 0 313335) 313351) inline$$Diem_register_currency_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 313335) 313341) inline$$Diem_register_currency_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon19_correct  (=> (= $abort_code@16@@6 $abort_code@3@@19) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313323) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 313321) 313323)) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon86_Then_correct  (=> (= (ControlFlow 0 313331) 313323) inline$$Diem_register_currency_$def$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon85_Then_correct  (=> $abort_flag@2@@23 (and (=> (= (ControlFlow 0 313315) 313331) inline$$Diem_register_currency_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 313315) 313321) inline$$Diem_register_currency_$def$0$anon86_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon23_correct  (=> (= $abort_code@16@@6 $abort_code@4@@18) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313303) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 313301) 313303)) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon88_Then_correct  (=> (= (ControlFlow 0 313311) 313303) inline$$Diem_register_currency_$def$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon87_Then_correct  (=> $abort_flag@3@@17 (and (=> (= (ControlFlow 0 313295) 313311) inline$$Diem_register_currency_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 313295) 313301) inline$$Diem_register_currency_$def$0$anon88_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon27_correct  (=> (= $abort_code@16@@6 $abort_code@5@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313283) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 313281) 313283)) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon90_Then_correct  (=> (= (ControlFlow 0 313291) 313283) inline$$Diem_register_currency_$def$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon89_Then_correct  (=> $abort_flag@4@@15 (and (=> (= (ControlFlow 0 313275) 313291) inline$$Diem_register_currency_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 313275) 313281) inline$$Diem_register_currency_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon41_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313165) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 313163) 313165)) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon97_Then_correct  (=> (= (ControlFlow 0 313173) 313165) inline$$Diem_register_currency_$def$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon96_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313157) 313173) inline$$Diem_register_currency_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 313157) 313163) inline$$Diem_register_currency_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon49_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313145) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 313143) 313145)) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon101_Then_correct  (=> (= (ControlFlow 0 313153) 313145) inline$$Diem_register_currency_$def$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon100_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313137) 313153) inline$$Diem_register_currency_$def$0$anon101_Then_correct) (=> (= (ControlFlow 0 313137) 313143) inline$$Diem_register_currency_$def$0$anon101_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon53_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313125) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 313123) 313125)) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon103_Then_correct  (=> (= (ControlFlow 0 313133) 313125) inline$$Diem_register_currency_$def$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon102_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313117) 313133) inline$$Diem_register_currency_$def$0$anon103_Then_correct) (=> (= (ControlFlow 0 313117) 313123) inline$$Diem_register_currency_$def$0$anon103_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon57_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313105) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 313103) 313105)) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon105_Then_correct  (=> (= (ControlFlow 0 313113) 313105) inline$$Diem_register_currency_$def$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon104_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313097) 313113) inline$$Diem_register_currency_$def$0$anon105_Then_correct) (=> (= (ControlFlow 0 313097) 313103) inline$$Diem_register_currency_$def$0$anon105_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon61_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313085) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 313083) 313085)) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon107_Then_correct  (=> (= (ControlFlow 0 313093) 313085) inline$$Diem_register_currency_$def$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon106_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313077) 313093) inline$$Diem_register_currency_$def$0$anon107_Then_correct) (=> (= (ControlFlow 0 313077) 313083) inline$$Diem_register_currency_$def$0$anon107_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon65_correct  (=> (= $abort_code@16@@6 $abort_code@7@@13) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313065) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 313063) 313065)) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon109_Then_correct  (=> (= (ControlFlow 0 313073) 313065) inline$$Diem_register_currency_$def$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon108_Then_correct  (=> $abort_flag@5@@12 (and (=> (= (ControlFlow 0 313057) 313073) inline$$Diem_register_currency_$def$0$anon109_Then_correct) (=> (= (ControlFlow 0 313057) 313063) inline$$Diem_register_currency_$def$0$anon109_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon69_correct  (=> (= $abort_code@16@@6 $abort_code@9@@10) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 |inline$$MoveToRaw$0$m'@2@@1|) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 313045) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 313043) 313045)) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon111_Then_correct  (=> (= (ControlFlow 0 313053) 313045) inline$$Diem_register_currency_$def$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon110_Then_correct  (=> $abort_flag@6@@11 (and (=> (= (ControlFlow 0 313037) 313053) inline$$Diem_register_currency_$def$0$anon111_Then_correct) (=> (= (ControlFlow 0 313037) 313043) inline$$Diem_register_currency_$def$0$anon111_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon112_Then_correct  (=> (and $abort_flag@10@@6 (= $abort_code@16@@6 $abort_code@15@@6)) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 |inline$$MoveToRaw$0$m'@2@@1|) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory@2)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory@2@@0) (= (ControlFlow 0 313033) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct  (=> (not $abort_flag@9@@7) (=> (and (and (= $abort_code@15@@6 $abort_code@13@@7) (= $abort_flag@10@@6 $abort_flag@9@@7)) (and (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@0@@0) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@0))) (and (=> (= (ControlFlow 0 312517) 313033) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 312517) 312820) inline$$Diem_register_currency_$def$0$anon112_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct  (=> (and (and (= $abort_code@15@@6 $abort_code@14@@6) (= $abort_flag@10@@6 true)) (and (= $DiemConfig_DiemConfig_$memory@2@@0 $DiemConfig_DiemConfig_$memory@1@@0) (= $DiemConfig_Configuration_$memory@2 $DiemConfig_Configuration_$memory@1))) (and (=> (= (ControlFlow 0 311789) 313033) inline$$Diem_register_currency_$def$0$anon112_Then_correct) (=> (= (ControlFlow 0 311789) 312820) inline$$Diem_register_currency_$def$0$anon112_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@10@@9) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 312609) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 312607) 312609)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 312617) 312609) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct  (=> $abort_flag@7@@9 (and (=> (= (ControlFlow 0 312601) 312617) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 312601) 312607) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@10@@9) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 312589) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 312587) 312589)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 312597) 312589) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct  (=> $abort_flag@7@@9 (and (=> (= (ControlFlow 0 312581) 312597) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 312581) 312587) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@11@@9) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 312569) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 312567) 312569)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 312577) 312569) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct  (=> $abort_flag@8@@7 (and (=> (= (ControlFlow 0 312561) 312577) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 312561) 312567) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@11@@9) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 312549) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 312547) 312549)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct  (=> (= (ControlFlow 0 312557) 312549) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct  (=> $abort_flag@8@@7 (and (=> (= (ControlFlow 0 312541) 312557) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct) (=> (= (ControlFlow 0 312541) 312547) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@13@@7) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory@0@@0)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory@0) (= (ControlFlow 0 312529) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 312527) 312529)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct  (=> (= (ControlFlow 0 312537) 312529) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct  (=> $abort_flag@9@@7 (and (=> (= (ControlFlow 0 312521) 312537) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct) (=> (= (ControlFlow 0 312521) 312527) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct  (=> (and (= call0formal@$tv0@0@@0 $RegisteredCurrencies_RegisteredCurrencies_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 312511) (- 0 520443)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) $abort_flag@9@@7) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@9@@7)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@9@@7) (=> $abort_flag@9@@7 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@9@@7 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| dr_account@@0))))))) (= $abort_code@13@@7 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@13@@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@13@@7 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@9@@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@9@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@462 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@0) 1) (|a#$Address| addr@@462)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2@@5|)))) (=> (not $abort_flag@9@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 312511) 312521) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct) (=> (= (ControlFlow 0 312511) 312517) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@7  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@5| call3formal@$ret0@0@@57) (= (ControlFlow 0 312477) 312511)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@7  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@7| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|) 0 call3formal@$ret0@0@@57 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@9|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@5| |inline$$WritebackToValue$0$vdst'@1@@7|) (= (ControlFlow 0 312503) 312511))) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@9  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@10|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@9))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@9 inline$$WritebackToReference$0$srcPath@1@@9))) (= |inline$$WritebackToReference$0$dst'@2@@9| inline$$BorrowLoc$0$dst@1@@7)) (and (=> (= (ControlFlow 0 312322) 312503) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 312322) 312477) inline$$WritebackToValue$0$anon3_Else_correct@@7)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@9  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@10|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@9))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@9 inline$$WritebackToReference$0$srcPath@1@@9)) (and (= |inline$$WritebackToReference$0$dst'@1@@9| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$WritebackToReference$0$dstPath@1@@9 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@9 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@9) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@10|)))) (= |inline$$WritebackToReference$0$dst'@2@@9| |inline$$WritebackToReference$0$dst'@1@@9|))) (and (=> (= (ControlFlow 0 312378) 312503) inline$$WritebackToValue$0$anon3_Then_correct@@7) (=> (= (ControlFlow 0 312378) 312477) inline$$WritebackToValue$0$anon3_Else_correct@@7)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@9  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@9 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@10|)) (= inline$$WritebackToReference$0$dstPath@1@@9 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7))) (and (=> (= (ControlFlow 0 312286) 312378) inline$$WritebackToReference$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 312286) 312322) inline$$WritebackToReference$0$anon3_Else_correct@@9)))))
(let ((inline$$WriteRef$0$anon0_correct@@10  (=> (and (= |inline$$WriteRef$0$to'@1@@10| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@9) (|p#$Mutation| inline$$BorrowField$0$dst@1@@9) |inline$$Vector_push_back$0$v'@1|)) (= (ControlFlow 0 312143) 312286)) inline$$WritebackToReference$0$anon0_correct@@9)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@8@@7) (= (ControlFlow 0 312149) 312143)) inline$$WriteRef$0$anon0_correct@@10)))
(let ((inline$$Vector_push_back$0$anon0_correct  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@10) (= |inline$$Vector_push_back$0$v'@1| ($Vector (let ((len@@1 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@10)) len@@1 currency_code) (+ len@@1 1)))))) (and (=> (= (ControlFlow 0 312078) 312541) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 312078) 312149) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct)))))
(let ((inline$$Vector_push_back$0$Entry_correct  (=> (and (= inline$$Vector_push_back$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 312066) 312078)) inline$$Vector_push_back$0$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct@@10  (=> (and (= inline$$ReadRef$0$v@1@@10 (|v#$Mutation| inline$$BorrowField$0$dst@1@@9)) (= (ControlFlow 0 312013) 312066)) inline$$Vector_push_back$0$Entry_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@9  (=> (= inline$$BorrowField$0$p@1@@9 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@7)) (=> (and (and (= inline$$BorrowField$0$size@1@@9 (|size#$Path| inline$$BorrowField$0$p@1@@9)) (= inline$$BorrowField$0$p@2@@9 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@9) inline$$BorrowField$0$size@1@@9 $RegisteredCurrencies_RegisteredCurrencies_currency_codes) (+ inline$$BorrowField$0$size@1@@9 1)))) (and (= inline$$BorrowField$0$dst@1@@9 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@7) inline$$BorrowField$0$p@2@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@7))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) (= (ControlFlow 0 311975) 312013))) inline$$ReadRef$0$anon0_correct@@10))))
(let ((inline$$BorrowLoc$0$anon0_correct@@7  (=> (and (= inline$$BorrowLoc$0$dst@1@@7 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@57)) (= (ControlFlow 0 311851) 311975)) inline$$BorrowField$0$anon0_correct@@9)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct  (=> (and (|b#$Boolean| inline$$Not$1$dst@1@@1) (= (ControlFlow 0 311857) 311851)) inline$$BorrowLoc$0$anon0_correct@@7)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct  (=> (and (and (= $abort_code@14@@6 $abort_code@12@@7) (= $DiemConfig_DiemConfig_$memory@1@@0 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 311785) 311789))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 311783) 311785)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 311797) 311785) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1@@1)) (= $abort_code@12@@7 (|i#$Integer| call3formal@$ret0@0@@58))) (and (=> (= (ControlFlow 0 311777) 311797) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 311777) 311783) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct  (=> (not $abort_flag@8@@7) (and (=> (= (ControlFlow 0 311765) 311857) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 311765) 311777) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct  (=> (and (and (and (= inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@7)) (and (=> $abort_flag@8@@7 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@58 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@58) (>= (|i#$Integer| call3formal@$ret0@0@@58) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@58) $MAX_U64))) (and (=> (= (ControlFlow 0 311759) 312561) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 311759) 311765) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct)))))
(let ((inline$$Not$1$anon0_correct@@1  (=> (and (= inline$$Not$1$dst@1@@1 ($Boolean  (not (|b#$Boolean| inline$$Vector_contains$0$res@1)))) (= (ControlFlow 0 311747) 311759)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct)))
(let ((inline$$Not$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 311737) (- 0 519959)) true) (=> (= (ControlFlow 0 311737) 311747) inline$$Not$1$anon0_correct@@1))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@7@@9) (= (ControlFlow 0 311753) 311737)) inline$$Not$1$Entry_correct@@1)))
(let ((inline$$Vector_contains$0$anon0_correct  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@18) (= inline$$Vector_contains$0$res@1 ($Boolean (exists ((i@@10 Int) )  (and (and (<= 0 i@@10) (< i@@10 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@18)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@18)) i@@10) currency_code)))))) (and (=> (= (ControlFlow 0 311691) 312581) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 311691) 311753) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct)))))
(let ((inline$$Vector_contains$0$Entry_correct  (=> (and (= inline$$Vector_contains$0$ta@0 ($VectorType $IntegerType)) (= (ControlFlow 0 311677) 311691)) inline$$Vector_contains$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@18  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@18 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@57)) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (= (ControlFlow 0 311622) 311677)) inline$$Vector_contains$0$Entry_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@7@@9) (= (ControlFlow 0 311628) 311622)) inline$$GetFieldFromValue$0$anon0_correct@@18)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct  (=> (= call0formal@$tv0@0@@1 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7@@9) (=> $abort_flag@7@@9 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@7@@9 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10@@9 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@7@@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@57 (let ((addr@@463 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@1) 1) (|a#$Address| addr@@463)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 311576) 312601) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 311576) 311628) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 311506) 311576)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 312625) 311576) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 311498) 312625) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 311498) 311506) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 312633) 312625) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 312633) 311506) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct  (=> (not $abort_flag@6@@11) (and (=> (= (ControlFlow 0 311492) 312633) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 311492) 311498) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct  (=> ((_ is $Address) dr_account@@0) (=> (and (and (and ((_ is $Vector) currency_code) (let ((va@@454 (|v#$Vector| currency_code)))
(let ((l@@454 (|l#$ValueArray| va@@454)))
 (and (and (<= 0 l@@454) (<= l@@454 $MAX_U64)) (forall ((x@@457 Int) ) (!  (=> (or (< x@@457 0) (>= x@@457 l@@454)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@454) x@@457) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@454) x@@457))
)))))) (forall ((inline$$RegisteredCurrencies_add_currency_code$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_add_currency_code$0$$$0 0) (< inline$$RegisteredCurrencies_add_currency_code$0$$$0 (|l#$ValueArray| (|v#$Vector| currency_code)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$RegisteredCurrencies_add_currency_code$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$RegisteredCurrencies_add_currency_code$0$$$0))
))) (= (ControlFlow 0 312637) 311492)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon110_Else_correct  (=> (not $abort_flag@6@@11) (and (=> (= (ControlFlow 0 312643) (- 0 519348)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def$0$mint_cap_owner1 inline$$Diem_register_currency_$def$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def$0$mint_cap_owner1@@0 inline$$Diem_register_currency_$def$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 312643) (- 0 519472)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 312643) (- 0 519525)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$dr_addr@@0))))))))))))))) (=> (= (ControlFlow 0 312643) 312637) inline$$RegisteredCurrencies_add_currency_code$0$anon0_correct))))))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@1  (=> (= $abort_flag@6@@11 true) (=> (and (= $abort_code@9@@10 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@0@@1|)) (and (=> (= (ControlFlow 0 310581) 313037) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 310581) 312643) inline$$Diem_register_currency_$def$0$anon110_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@1  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1) (= (ControlFlow 0 310579) 310581)) inline$$MoveToRaw$0$anon3_Then$1_correct@@1)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@1  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@1 inline$$MoveTo$0$a@1@@1 inline$$Diem_CurrencyInfo_pack$0$$struct@1))) (= $abort_flag@6@@11 $abort_flag@5@@12)) (and (= $abort_code@9@@10 $abort_code@7@@13) (= |inline$$MoveToRaw$0$m'@2@@1| |inline$$MoveToRaw$0$m'@1@@1|))) (and (=> (= (ControlFlow 0 310529) 313037) inline$$Diem_register_currency_$def$0$anon110_Then_correct) (=> (= (ControlFlow 0 310529) 312643) inline$$Diem_register_currency_$def$0$anon110_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@1  (=> (= inline$$MoveTo$0$a@1@@1 (|a#$Address| dr_account@@0)) (and (=> (= (ControlFlow 0 310587) 310579) inline$$MoveToRaw$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 310587) 310529) inline$$MoveToRaw$0$anon3_Else_correct@@1)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 310375) (- 0 519233)) true) (=> (= (ControlFlow 0 310375) 310587) inline$$MoveTo$0$anon0$1_correct@@1))))
(let ((inline$$MoveTo$0$Entry_correct@@1  (=> (and (= inline$$MoveTo$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1)) (= (ControlFlow 0 310347) 310375)) inline$$Signer_borrow_address$0$Entry_correct@@1)))
(let ((inline$$Diem_register_currency_$def$0$anon108_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_currency_$def$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def$0$mint_cap_owner1@@1 inline$$Diem_register_currency_$def$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 310595) 310347)) inline$$MoveTo$0$Entry_correct@@1)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon3_correct  (and (=> (= (ControlFlow 0 310108) (- 0 519018)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 310108) 310595) inline$$Diem_register_currency_$def$0$anon108_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 310122) 310108)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct  (=> (= (ControlFlow 0 310128) 310108) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 310116) 310128) inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct) (=> (= (ControlFlow 0 310116) 310122) inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 310060) 310108)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon0_correct  (=> (and (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t28@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t28@1) $MAX_U128)) (and (and ((_ is $Integer) inline$$Diem_register_currency_$def$0$$t29@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def$0$$t29@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Vector) to_xdx_exchange_rate) (let ((va@@455 (|v#$Vector| to_xdx_exchange_rate)))
(let ((l@@455 (|l#$ValueArray| va@@455)))
 (and (and (<= 0 l@@455) (<= l@@455 $MAX_U64)) (forall ((x@@458 Int) ) (!  (=> (or (< x@@458 0) (>= x@@458 l@@455)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@455) x@@458) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@455) x@@458))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def_verify$0$$t16@1)) (and (and (and (and ((_ is $Integer) scaling_factor) (>= (|i#$Integer| scaling_factor) 0)) (<= (|i#$Integer| scaling_factor) $MAX_U64)) (and (and ((_ is $Integer) fractional_part) (>= (|i#$Integer| fractional_part) 0)) (<= (|i#$Integer| fractional_part) $MAX_U64))) (and (and (and ((_ is $Vector) currency_code) (let ((va@@456 (|v#$Vector| currency_code)))
(let ((l@@456 (|l#$ValueArray| va@@456)))
 (and (and (<= 0 l@@456) (<= l@@456 $MAX_U64)) (forall ((x@@459 Int) ) (!  (=> (or (< x@@459 0) (>= x@@459 l@@456)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@456) x@@459) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@456) x@@459))
)))))) (forall ((inline$$Diem_CurrencyInfo_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CurrencyInfo_pack$0$$$0 0) (< inline$$Diem_CurrencyInfo_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| currency_code)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_CurrencyInfo_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_CurrencyInfo_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_CurrencyInfo_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_CurrencyInfo_pack$0$$$0))
))) ((_ is $Boolean) inline$$Diem_register_currency_$def$0$$t30@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@457 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@457 (|l#$ValueArray| va@@457)))
 (and (and (<= 0 l@@457) (<= l@@457 $MAX_U64)) (forall ((x@@460 Int) ) (!  (=> (or (< x@@460 0) (>= x@@460 l@@457)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@457) x@@460) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@457) x@@460))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@458 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@458 (|l#$ValueArray| va@@458)))
 (and (and (<= 0 l@@458) (<= l@@458 $MAX_U64)) (forall ((x@@461 Int) ) (!  (=> (or (< x@@461 0) (>= x@@461 l@@458)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@458) x@@461) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@458) x@@461))
))))))) (forall (($$0@@153 Int) ) (!  (=> (and (>= $$0@@153 0) (< $$0@@153 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@153)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@153)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@153)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@153))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0) (let ((va@@459 (|v#$Vector| inline$$Event_new_event_handle$1$res@0)))
(let ((l@@459 (|l#$ValueArray| va@@459)))
 (and (and (<= 0 l@@459) (<= l@@459 $MAX_U64)) (forall ((x@@462 Int) ) (!  (=> (or (< x@@462 0) (>= x@@462 l@@459)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@459) x@@462) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@459) x@@462))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid)) (let ((va@@460 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))
(let ((l@@460 (|l#$ValueArray| va@@460)))
 (and (and (<= 0 l@@460) (<= l@@460 $MAX_U64)) (forall ((x@@463 Int) ) (!  (=> (or (< x@@463 0) (>= x@@463 l@@460)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@460) x@@463) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@460) x@@463))
))))))) (forall (($$0@@154 Int) ) (!  (=> (and (>= $$0@@154 0) (< $$0@@154 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@154)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@154)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@154)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0)) $Event_EventHandle_guid))) $$0@@154))
))) true)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$2$res@0) (let ((va@@461 (|v#$Vector| inline$$Event_new_event_handle$2$res@0)))
(let ((l@@461 (|l#$ValueArray| va@@461)))
 (and (and (<= 0 l@@461) (<= l@@461 $MAX_U64)) (forall ((x@@464 Int) ) (!  (=> (or (< x@@464 0) (>= x@@464 l@@461)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@461) x@@464) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@461) x@@464))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid)) (let ((va@@462 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))
(let ((l@@462 (|l#$ValueArray| va@@462)))
 (and (and (<= 0 l@@462) (<= l@@462 $MAX_U64)) (forall ((x@@465 Int) ) (!  (=> (or (< x@@465 0) (>= x@@465 l@@462)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@462) x@@465) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@462) x@@465))
))))))) (forall (($$0@@155 Int) ) (!  (=> (and (>= $$0@@155 0) (< $$0@@155 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@155)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@155)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@155)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0)) $Event_EventHandle_guid))) $$0@@155))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$3$res@0) (let ((va@@463 (|v#$Vector| inline$$Event_new_event_handle$3$res@0)))
(let ((l@@463 (|l#$ValueArray| va@@463)))
 (and (and (<= 0 l@@463) (<= l@@463 $MAX_U64)) (forall ((x@@466 Int) ) (!  (=> (or (< x@@466 0) (>= x@@466 l@@463)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@463) x@@466) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@463) x@@466))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid)) (let ((va@@464 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))
(let ((l@@464 (|l#$ValueArray| va@@464)))
 (and (and (<= 0 l@@464) (<= l@@464 $MAX_U64)) (forall ((x@@467 Int) ) (!  (=> (or (< x@@467 0) (>= x@@467 l@@464)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@464) x@@467) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@464) x@@467))
))))))) (forall (($$0@@156 Int) ) (!  (=> (and (>= $$0@@156 0) (< $$0@@156 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@156)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@156)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@156)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0)) $Event_EventHandle_guid))) $$0@@156))
))) true)) (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$4$res@0) (let ((va@@465 (|v#$Vector| inline$$Event_new_event_handle$4$res@0)))
(let ((l@@465 (|l#$ValueArray| va@@465)))
 (and (and (<= 0 l@@465) (<= l@@465 $MAX_U64)) (forall ((x@@468 Int) ) (!  (=> (or (< x@@468 0) (>= x@@468 l@@465)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@465) x@@468) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@465) x@@468))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid)) (let ((va@@466 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))
(let ((l@@466 (|l#$ValueArray| va@@466)))
 (and (and (<= 0 l@@466) (<= l@@466 $MAX_U64)) (forall ((x@@469 Int) ) (!  (=> (or (< x@@469 0) (>= x@@469 l@@466)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@466) x@@469) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@466) x@@469))
))))))) (forall (($$0@@157 Int) ) (!  (=> (and (>= $$0@@157 0) (< $$0@@157 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@157)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@157)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@157)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0)) $Event_EventHandle_guid))) $$0@@157))
))) true) (= inline$$Diem_CurrencyInfo_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def$0$$t28@1) 1 inline$$Diem_register_currency_$def$0$$t29@1) 2 to_xdx_exchange_rate) 3 inline$$Diem_register_SCS_currency_$def_verify$0$$t16@1) 4 scaling_factor) 5 fractional_part) 6 currency_code) 7 inline$$Diem_register_currency_$def$0$$t30@1) 8 inline$$Event_new_event_handle$0$res@0) 9 inline$$Event_new_event_handle$1$res@0) 10 inline$$Event_new_event_handle$2$res@0) 11 inline$$Event_new_event_handle$3$res@0) 12 inline$$Event_new_event_handle$4$res@0) 13))))) (and (=> (= (ControlFlow 0 310052) 310116) inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 310052) 310060) inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct))))))))
(let ((inline$$Diem_register_currency_$def$0$anon108_Else_correct  (=> (and (not $abort_flag@5@@12) (= (ControlFlow 0 310134) 310052)) inline$$Diem_CurrencyInfo_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$4$Entry_correct  (=> (= inline$$Event_new_event_handle$4$t@0 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 309474) 313057) inline$$Diem_register_currency_$def$0$anon108_Then_correct) (=> (= (ControlFlow 0 309474) 310134) inline$$Diem_register_currency_$def$0$anon108_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon106_Else_correct  (=> (and (not $abort_flag@5@@12) (= (ControlFlow 0 309482) 309474)) inline$$Event_new_event_handle$4$Entry_correct)))
(let ((inline$$Event_new_event_handle$3$Entry_correct  (=> (= inline$$Event_new_event_handle$3$t@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 309432) 313077) inline$$Diem_register_currency_$def$0$anon106_Then_correct) (=> (= (ControlFlow 0 309432) 309482) inline$$Diem_register_currency_$def$0$anon106_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon104_Else_correct  (=> (and (not $abort_flag@5@@12) (= (ControlFlow 0 309440) 309432)) inline$$Event_new_event_handle$3$Entry_correct)))
(let ((inline$$Event_new_event_handle$2$Entry_correct  (=> (= inline$$Event_new_event_handle$2$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 309390) 313097) inline$$Diem_register_currency_$def$0$anon104_Then_correct) (=> (= (ControlFlow 0 309390) 309440) inline$$Diem_register_currency_$def$0$anon104_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon102_Else_correct  (=> (and (not $abort_flag@5@@12) (= (ControlFlow 0 309398) 309390)) inline$$Event_new_event_handle$2$Entry_correct)))
(let ((inline$$Event_new_event_handle$1$Entry_correct  (=> (= inline$$Event_new_event_handle$1$t@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 309348) 313117) inline$$Diem_register_currency_$def$0$anon102_Then_correct) (=> (= (ControlFlow 0 309348) 309398) inline$$Diem_register_currency_$def$0$anon102_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon100_Else_correct  (=> (and (not $abort_flag@5@@12) (= (ControlFlow 0 309356) 309348)) inline$$Event_new_event_handle$1$Entry_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 309306) 313137) inline$$Diem_register_currency_$def$0$anon100_Then_correct) (=> (= (ControlFlow 0 309306) 309356) inline$$Diem_register_currency_$def$0$anon100_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon98_Then_correct  (=> (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|) (=> (and (and (= inline$$Diem_register_currency_$def$0$$t28@1 ($Integer 0)) (= inline$$Diem_register_currency_$def$0$$t29@1 ($Integer 0))) (and (= inline$$Diem_register_currency_$def$0$$t30@1 ($Boolean true)) (= (ControlFlow 0 309314) 309306))) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon46_correct  (=> (= $abort_code@16@@6 $abort_code@8@@11) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 309254) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 309252) 309254)) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon99_Then_correct  (=> (= (ControlFlow 0 309262) 309254) inline$$Diem_register_currency_$def$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon98_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Diem_register_currency_$def$0$tmp#$10@1|)) (= $abort_code@8@@11 (|i#$Integer| call3formal@$ret0@0@@59))) (and (=> (= (ControlFlow 0 309246) 309262) inline$$Diem_register_currency_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 309246) 309252) inline$$Diem_register_currency_$def$0$anon99_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon96_Else_correct  (=> (not $abort_flag@5@@12) (and (=> (= (ControlFlow 0 309234) 309314) inline$$Diem_register_currency_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 309234) 309246) inline$$Diem_register_currency_$def$0$anon98_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$L5_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@12)) (and (=> $abort_flag@5@@12 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@5@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@59 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@59) (>= (|i#$Integer| call3formal@$ret0@0@@59) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@59) $MAX_U64))) (and (=> (= (ControlFlow 0 309228) 313157) inline$$Diem_register_currency_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 309228) 309234) inline$$Diem_register_currency_$def$0$anon96_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon36_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Le$0$dst@1) (= (ControlFlow 0 313263) 309228)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 313261) 313263)) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon94_Then_correct  (=> (= (ControlFlow 0 313271) 313263) inline$$Diem_register_currency_$def$0$anon36_correct)))
(let ((inline$$Le$0$anon0_correct  (=> (= inline$$Le$0$dst@1 ($Boolean (<= (|i#$Integer| scaling_factor) (|i#$Integer| inline$$Diem_register_currency_$def$0$$t24@1)))) (and (=> (= (ControlFlow 0 313247) 313271) inline$$Diem_register_currency_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 313247) 313261) inline$$Diem_register_currency_$def$0$anon94_Else_correct)))))
(let ((inline$$Le$0$Entry_correct  (and (=> (= (ControlFlow 0 313233) (- 0 518540)) true) (=> (= (ControlFlow 0 313233) 313247) inline$$Le$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon93_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1) (=> (and (= inline$$Diem_register_currency_$def$0$$t24@1 ($Integer 10000000000)) (= (ControlFlow 0 313253) 313233)) inline$$Le$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon38_correct  (=> (and (= |inline$$Diem_register_currency_$def$0$tmp#$10@1| inline$$Diem_register_currency_$def$0$$t25@1) (= (ControlFlow 0 309222) 309228)) inline$$Diem_register_currency_$def$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 309220) 309222)) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon95_Then_correct  (=> (= (ControlFlow 0 313181) 309222) inline$$Diem_register_currency_$def$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= inline$$Diem_register_currency_$def$0$$t25@1 ($Boolean false))) (and (=> (= (ControlFlow 0 309212) 313181) inline$$Diem_register_currency_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 309212) 309220) inline$$Diem_register_currency_$def$0$anon95_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$Diem_register_currency_$def$0$$t22@1) (|i#$Integer| scaling_factor)))) (and (=> (= (ControlFlow 0 309160) 313253) inline$$Diem_register_currency_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 309160) 309212) inline$$Diem_register_currency_$def$0$anon93_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 309146) (- 0 518465)) true) (=> (= (ControlFlow 0 309146) 309160) inline$$Lt$0$anon0_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon91_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@12) (=> (and (= inline$$Diem_register_currency_$def$0$$t22@1 ($Integer 0)) (= (ControlFlow 0 309166) 309146)) inline$$Lt$0$Entry_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon32_correct  (=> (= $abort_code@16@@6 $abort_code@6@@14) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@9 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@0 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 309078) 309086))) inline$$Diem_register_currency_$def$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 309076) 309078)) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon92_Then_correct  (=> (= (ControlFlow 0 309094) 309078) inline$$Diem_register_currency_$def$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon91_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@12)) (= $abort_code@6@@14 (|i#$Integer| call3formal@$ret0@0@@60))) (and (=> (= (ControlFlow 0 309070) 309094) inline$$Diem_register_currency_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 309070) 309076) inline$$Diem_register_currency_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon89_Else_correct  (=> (not $abort_flag@4@@15) (and (=> (= (ControlFlow 0 309058) 309166) inline$$Diem_register_currency_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 309058) 309070) inline$$Diem_register_currency_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def$0$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@15)) (and (=> $abort_flag@4@@15 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@15) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@60 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@60) (>= (|i#$Integer| call3formal@$ret0@0@@60) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@60) $MAX_U64))) (and (=> (= (ControlFlow 0 309052) 313275) inline$$Diem_register_currency_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 309052) 309058) inline$$Diem_register_currency_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@12  (=> (and (= inline$$Not$0$dst@1@@12 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_currency_$def$0$$t18@1)))) (= (ControlFlow 0 309040) 309052)) inline$$Diem_register_currency_$def$0$anon87_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@12  (and (=> (= (ControlFlow 0 309030) (- 0 518335)) true) (=> (= (ControlFlow 0 309030) 309040) inline$$Not$0$anon0_correct@@12))))
(let ((inline$$Diem_register_currency_$def$0$anon87_Else_correct  (=> (not $abort_flag@3@@17) (=> (and (= inline$$Diem_register_currency_$def$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@35) 1) (|a#$Address| call3formal@$ret0@0@@61)))) (= (ControlFlow 0 309046) 309030)) inline$$Not$0$Entry_correct@@12))))
(let ((inline$$Diem_register_currency_$def$0$anon85_Else_correct  (=> (not $abort_flag@2@@23) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@17) (=> $abort_flag@3@@17 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@3@@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@61 dr_account@@0)))) ((_ is $Address) call3formal@$ret0@0@@61))) (and (=> (= (ControlFlow 0 308972) 313295) inline$$Diem_register_currency_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 308972) 309046) inline$$Diem_register_currency_$def$0$anon87_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon83_Else_correct  (=> (and (and (not $abort_flag@1@@26) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@2@@23)) (and (=> $abort_flag@2@@23 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816)))))) (=> $abort_flag@2@@23 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@3@@19 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 308966) 313315) inline$$Diem_register_currency_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 308966) 308972) inline$$Diem_register_currency_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon12$6_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@1@@26) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) $abort_flag@1@@26)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@1@@26) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) $abort_flag@1@@26)) (and (=> $abort_flag@1@@26 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))))) (=> $abort_flag@1@@26 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@2@@18 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0))))))) (= $abort_code@2@@18 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@0)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@2@@18 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@0 ($Address 173345816))))) (= $abort_code@2@@18 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 308960) 313335) inline$$Diem_register_currency_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 308960) 308966) inline$$Diem_register_currency_$def$0$anon83_Else_correct))))))
(let ((inline$$Diem_register_currency_$def$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 308754) 308960)) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon82_Then_correct  (=> (= (ControlFlow 0 313359) 308960) inline$$Diem_register_currency_$def$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308746) 313359) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 308746) 308754) inline$$Diem_register_currency_$def$0$anon82_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 313367) 313359) inline$$Diem_register_currency_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 313367) 308754) inline$$Diem_register_currency_$def$0$anon82_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308738) 313367) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 308738) 308746) inline$$Diem_register_currency_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon80_Then_correct  (and (=> (= (ControlFlow 0 313375) 313367) inline$$Diem_register_currency_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 313375) 308746) inline$$Diem_register_currency_$def$0$anon81_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308730) 313375) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 308730) 308738) inline$$Diem_register_currency_$def$0$anon80_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon79_Then_correct  (and (=> (= (ControlFlow 0 313383) 313375) inline$$Diem_register_currency_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 313383) 308738) inline$$Diem_register_currency_$def$0$anon80_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308722) 313383) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 308722) 308730) inline$$Diem_register_currency_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon78_Then_correct  (and (=> (= (ControlFlow 0 313391) 313383) inline$$Diem_register_currency_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 313391) 308730) inline$$Diem_register_currency_$def$0$anon79_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 308714) 313391) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 308714) 308722) inline$$Diem_register_currency_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_register_currency_$def$0$anon77_Then_correct  (and (=> (= (ControlFlow 0 313399) 313391) inline$$Diem_register_currency_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 313399) 308722) inline$$Diem_register_currency_$def$0$anon78_Else_correct))))
(let ((inline$$Diem_register_currency_$def$0$anon0_correct  (=> (not $abort_flag@0@@27) (and (=> (= (ControlFlow 0 308708) 313399) inline$$Diem_register_currency_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 308708) 308714) inline$$Diem_register_currency_$def$0$anon77_Else_correct)))))
(let ((inline$$Diem_register_currency_$direct_intra$0$anon0_correct  (=> ((_ is $Address) dr_account@@0) (=> (and (and (and (and (and (and ((_ is $Vector) to_xdx_exchange_rate) (let ((va@@467 (|v#$Vector| to_xdx_exchange_rate)))
(let ((l@@467 (|l#$ValueArray| va@@467)))
 (and (and (<= 0 l@@467) (<= l@@467 $MAX_U64)) (forall ((x@@470 Int) ) (!  (=> (or (< x@@470 0) (>= x@@470 l@@467)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@467) x@@470) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@467) x@@470))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) inline$$Diem_register_SCS_currency_$def_verify$0$$t16@1)) (and (and (and (and ((_ is $Integer) scaling_factor) (>= (|i#$Integer| scaling_factor) 0)) (<= (|i#$Integer| scaling_factor) $MAX_U64)) (and (and ((_ is $Integer) fractional_part) (>= (|i#$Integer| fractional_part) 0)) (<= (|i#$Integer| fractional_part) $MAX_U64))) (and (and (and ((_ is $Vector) currency_code) (let ((va@@468 (|v#$Vector| currency_code)))
(let ((l@@468 (|l#$ValueArray| va@@468)))
 (and (and (<= 0 l@@468) (<= l@@468 $MAX_U64)) (forall ((x@@471 Int) ) (!  (=> (or (< x@@471 0) (>= x@@471 l@@468)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@468) x@@471) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@468) x@@471))
)))))) (forall ((inline$$Diem_register_currency_$direct_intra$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_register_currency_$direct_intra$0$$$0 0) (< inline$$Diem_register_currency_$direct_intra$0$$$0 (|l#$ValueArray| (|v#$Vector| currency_code)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_register_currency_$direct_intra$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_register_currency_$direct_intra$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_register_currency_$direct_intra$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) inline$$Diem_register_currency_$direct_intra$0$$$0))
))) (= (ControlFlow 0 313407) 308708)))) inline$$Diem_register_currency_$def$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon47_Else_correct  (=> (not $abort_flag@0@@27) (=> (and (= inline$$Diem_register_SCS_currency_$def_verify$0$$t16@1 ($Boolean false)) (= (ControlFlow 0 313417) 313407)) inline$$Diem_register_currency_$direct_intra$0$anon0_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon12$6_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) $abort_flag@0@@27) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@27) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) $abort_flag@0@@27)) (and (=> $abort_flag@0@@27 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))))) (=> $abort_flag@0@@27 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2))))))) (= $abort_code@1@@24 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@2)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@24 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@2 ($Address 186537453))))) (= $abort_code@1@@24 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 306765) 315876) inline$$Diem_register_SCS_currency_$def_verify$0$anon47_Then_correct) (=> (= (ControlFlow 0 306765) 313417) inline$$Diem_register_SCS_currency_$def_verify$0$anon47_Else_correct))))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Else_correct  (=> (and (not true) (= (ControlFlow 0 306559) 306765)) inline$$Diem_register_SCS_currency_$def_verify$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Then_correct  (=> (= (ControlFlow 0 315900) 306765) inline$$Diem_register_SCS_currency_$def_verify$0$anon12$6_correct)))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306551) 315900) inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 306551) 306559) inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 315908) 315900) inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Then_correct) (=> (= (ControlFlow 0 315908) 306559) inline$$Diem_register_SCS_currency_$def_verify$0$anon46_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306543) 315908) inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 306543) 306551) inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Then_correct  (and (=> (= (ControlFlow 0 315916) 315908) inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Then_correct) (=> (= (ControlFlow 0 315916) 306551) inline$$Diem_register_SCS_currency_$def_verify$0$anon45_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306535) 315916) inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 306535) 306543) inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Then_correct  (and (=> (= (ControlFlow 0 315924) 315916) inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Then_correct) (=> (= (ControlFlow 0 315924) 306543) inline$$Diem_register_SCS_currency_$def_verify$0$anon44_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306527) 315924) inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 306527) 306535) inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Then_correct  (and (=> (= (ControlFlow 0 315932) 315924) inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Then_correct) (=> (= (ControlFlow 0 315932) 306535) inline$$Diem_register_SCS_currency_$def_verify$0$anon43_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon41_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 306519) 315932) inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 306519) 306527) inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon41_Then_correct  (and (=> (= (ControlFlow 0 315940) 315932) inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 315940) 306527) inline$$Diem_register_SCS_currency_$def_verify$0$anon42_Else_correct))))
(let ((inline$$Diem_register_SCS_currency_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 306513) 315940) inline$$Diem_register_SCS_currency_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 306513) 306519) inline$$Diem_register_SCS_currency_$def_verify$0$anon41_Else_correct)))))
(let ((anon0$1_correct@@27  (=> (forall (($inv_addr@@58 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58)) (let ((va@@469 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))))
(let ((l@@469 (|l#$ValueArray| va@@469)))
 (and (and (<= 0 l@@469) (<= l@@469 $MAX_U64)) (forall ((x@@472 Int) ) (!  (=> (or (< x@@472 0) (>= x@@472 l@@469)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@469) x@@472) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@469) x@@472))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@58))
)) (=> (and (forall (($inv_addr@@59 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59)) (let ((va@@470 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))))
(let ((l@@470 (|l#$ValueArray| va@@470)))
 (and (and (<= 0 l@@470) (<= l@@470 $MAX_U64)) (forall ((x@@473 Int) ) (!  (=> (or (< x@@473 0) (>= x@@473 l@@470)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@470) x@@473) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@470) x@@473))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@59))
)) (forall (($inv_addr@@60 Int) ($inv_tv0@@50 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@50) 1) $inv_addr@@60)) (let ((va@@471 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@50) 1) $inv_addr@@60))))
(let ((l@@471 (|l#$ValueArray| va@@471)))
 (and (and (<= 0 l@@471) (<= l@@471 $MAX_U64)) (forall ((x@@474 Int) ) (!  (=> (or (< x@@474 0) (>= x@@474 l@@471)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@471) x@@474) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@471) x@@474))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@50) 1) $inv_addr@@60))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@50) 1) $inv_addr@@60))
))) (=> (and (and (and (and (forall (($inv_addr@@61 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61)) (let ((va@@472 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))))
(let ((l@@472 (|l#$ValueArray| va@@472)))
 (and (and (<= 0 l@@472) (<= l@@472 $MAX_U64)) (forall ((x@@475 Int) ) (!  (=> (or (< x@@475 0) (>= x@@475 l@@472)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@472) x@@475) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@472) x@@475))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events)) (let ((va@@473 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))))
(let ((l@@473 (|l#$ValueArray| va@@473)))
 (and (and (<= 0 l@@473) (<= l@@473 $MAX_U64)) (forall ((x@@476 Int) ) (!  (=> (or (< x@@476 0) (>= x@@476 l@@473)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@473) x@@476) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@473) x@@476))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@474 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@474 (|l#$ValueArray| va@@474)))
 (and (and (<= 0 l@@474) (<= l@@474 $MAX_U64)) (forall ((x@@477 Int) ) (!  (=> (or (< x@@477 0) (>= x@@477 l@@474)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@474) x@@477) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@474) x@@477))
))))))) (forall (($$0@@158 Int) ) (!  (=> (and (>= $$0@@158 0) (< $$0@@158 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@158)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@158)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@158)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@158))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@61))
)) (forall (($inv_addr@@62 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@62)) (let ((va@@475 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@62))))
(let ((l@@475 (|l#$ValueArray| va@@475)))
 (and (and (<= 0 l@@475) (<= l@@475 $MAX_U64)) (forall ((x@@478 Int) ) (!  (=> (or (< x@@478 0) (>= x@@478 l@@475)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@475) x@@478) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@475) x@@478))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@62))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@62))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@62))
))) (and (forall (($inv_addr@@63 Int) ($inv_tv0@@51 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@51) 1) $inv_addr@@63)) (let ((va@@476 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@51) 1) $inv_addr@@63))))
(let ((l@@476 (|l#$ValueArray| va@@476)))
 (and (and (<= 0 l@@476) (<= l@@476 $MAX_U64)) (forall ((x@@479 Int) ) (!  (=> (or (< x@@479 0) (>= x@@479 l@@476)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@476) x@@479) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@476) x@@479))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@51) 1) $inv_addr@@63))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@51) 1) $inv_addr@@63))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@51) 1) $inv_addr@@63))
)) (forall (($inv_addr@@64 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64)) (let ((va@@477 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))))
(let ((l@@477 (|l#$ValueArray| va@@477)))
 (and (and (<= 0 l@@477) (<= l@@477 $MAX_U64)) (forall ((x@@480 Int) ) (!  (=> (or (< x@@480 0) (>= x@@480 l@@477)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@477) x@@480) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@477) x@@480))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (let ((va@@478 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))
(let ((l@@478 (|l#$ValueArray| va@@478)))
 (and (and (<= 0 l@@478) (<= l@@478 $MAX_U64)) (forall ((x@@481 Int) ) (!  (=> (or (< x@@481 0) (>= x@@481 l@@478)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@478) x@@481) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@478) x@@481))
))))))) (forall (($$0@@159 Int) ) (!  (=> (and (>= $$0@@159 0) (< $$0@@159 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159)) (let ((va@@479 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))))
(let ((l@@479 (|l#$ValueArray| va@@479)))
 (and (and (<= 0 l@@479) (<= l@@479 $MAX_U64)) (forall ((x@@482 Int) ) (!  (=> (or (< x@@482 0) (>= x@@482 l@@479)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@479) x@@482) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@479) x@@482))
)))))) (forall (($$1 Int) ) (!  (=> (and (>= $$1 0) (< $$1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))) $$1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))) $$1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))) $$1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))) $$1))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@159))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@64))
)))) (and (and (forall (($inv_addr@@65 Int) ($inv_tv0@@52 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@52) 1) $inv_addr@@65)) (let ((va@@480 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@52) 1) $inv_addr@@65))))
(let ((l@@480 (|l#$ValueArray| va@@480)))
 (and (and (<= 0 l@@480) (<= l@@480 $MAX_U64)) (forall ((x@@483 Int) ) (!  (=> (or (< x@@483 0) (>= x@@483 l@@480)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@480) x@@483) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@480) x@@483))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@52) 1) $inv_addr@@65))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@52) 1) $inv_addr@@65))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@52) 1) $inv_addr@@65))
)) (forall (($inv_addr@@66 Int) ($inv_tv0@@53 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66)) (let ((va@@481 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))))
(let ((l@@481 (|l#$ValueArray| va@@481)))
 (and (and (<= 0 l@@481) (<= l@@481 $MAX_U64)) (forall ((x@@484 Int) ) (!  (=> (or (< x@@484 0) (>= x@@484 l@@481)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@481) x@@484) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@481) x@@484))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@482 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@482 (|l#$ValueArray| va@@482)))
 (and (and (<= 0 l@@482) (<= l@@482 $MAX_U64)) (forall ((x@@485 Int) ) (!  (=> (or (< x@@485 0) (>= x@@485 l@@482)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@482) x@@485) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@482) x@@485))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code)) (let ((va@@483 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@483 (|l#$ValueArray| va@@483)))
 (and (and (<= 0 l@@483) (<= l@@483 $MAX_U64)) (forall ((x@@486 Int) ) (!  (=> (or (< x@@486 0) (>= x@@486 l@@483)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@483) x@@486) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@483) x@@486))
))))))) (forall (($$0@@160 Int) ) (!  (=> (and (>= $$0@@160 0) (< $$0@@160 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))) $$0@@160)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))) $$0@@160)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))) $$0@@160)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_currency_code))) $$0@@160))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events)) (let ((va@@484 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@484 (|l#$ValueArray| va@@484)))
 (and (and (<= 0 l@@484) (<= l@@484 $MAX_U64)) (forall ((x@@487 Int) ) (!  (=> (or (< x@@487 0) (>= x@@487 l@@484)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@484) x@@487) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@484) x@@487))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@485 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@485 (|l#$ValueArray| va@@485)))
 (and (and (<= 0 l@@485) (<= l@@485 $MAX_U64)) (forall ((x@@488 Int) ) (!  (=> (or (< x@@488 0) (>= x@@488 l@@485)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@485) x@@488) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@485) x@@488))
))))))) (forall (($$0@@161 Int) ) (!  (=> (and (>= $$0@@161 0) (< $$0@@161 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@161)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@161)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@161)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@161))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events)) (let ((va@@486 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@486 (|l#$ValueArray| va@@486)))
 (and (and (<= 0 l@@486) (<= l@@486 $MAX_U64)) (forall ((x@@489 Int) ) (!  (=> (or (< x@@489 0) (>= x@@489 l@@486)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@486) x@@489) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@486) x@@489))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@487 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@487 (|l#$ValueArray| va@@487)))
 (and (and (<= 0 l@@487) (<= l@@487 $MAX_U64)) (forall ((x@@490 Int) ) (!  (=> (or (< x@@490 0) (>= x@@490 l@@487)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@487) x@@490) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@487) x@@490))
))))))) (forall (($$0@@162 Int) ) (!  (=> (and (>= $$0@@162 0) (< $$0@@162 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@162)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@162)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@162)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@162))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@488 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@488 (|l#$ValueArray| va@@488)))
 (and (and (<= 0 l@@488) (<= l@@488 $MAX_U64)) (forall ((x@@491 Int) ) (!  (=> (or (< x@@491 0) (>= x@@491 l@@488)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@488) x@@491) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@488) x@@491))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@489 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@489 (|l#$ValueArray| va@@489)))
 (and (and (<= 0 l@@489) (<= l@@489 $MAX_U64)) (forall ((x@@492 Int) ) (!  (=> (or (< x@@492 0) (>= x@@492 l@@489)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@489) x@@492) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@489) x@@492))
))))))) (forall (($$0@@163 Int) ) (!  (=> (and (>= $$0@@163 0) (< $$0@@163 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@163)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@163)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@163)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@163))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@490 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@490 (|l#$ValueArray| va@@490)))
 (and (and (<= 0 l@@490) (<= l@@490 $MAX_U64)) (forall ((x@@493 Int) ) (!  (=> (or (< x@@493 0) (>= x@@493 l@@490)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@490) x@@493) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@490) x@@493))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@491 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@491 (|l#$ValueArray| va@@491)))
 (and (and (<= 0 l@@491) (<= l@@491 $MAX_U64)) (forall ((x@@494 Int) ) (!  (=> (or (< x@@494 0) (>= x@@494 l@@491)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@491) x@@494) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@491) x@@494))
))))))) (forall (($$0@@164 Int) ) (!  (=> (and (>= $$0@@164 0) (< $$0@@164 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@164)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@164)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@164)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@164))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@492 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@492 (|l#$ValueArray| va@@492)))
 (and (and (<= 0 l@@492) (<= l@@492 $MAX_U64)) (forall ((x@@495 Int) ) (!  (=> (or (< x@@495 0) (>= x@@495 l@@492)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@492) x@@495) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@492) x@@495))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@493 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@493 (|l#$ValueArray| va@@493)))
 (and (and (<= 0 l@@493) (<= l@@493 $MAX_U64)) (forall ((x@@496 Int) ) (!  (=> (or (< x@@496 0) (>= x@@496 l@@493)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@493) x@@496) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@493) x@@496))
))))))) (forall (($$0@@165 Int) ) (!  (=> (and (>= $$0@@165 0) (< $$0@@165 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@165)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@165)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@165)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@165))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@53) 1) $inv_addr@@66))
))) (and (forall (($inv_addr@@67 Int) ($inv_tv0@@54 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@54) 1) $inv_addr@@67)) (let ((va@@494 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@54) 1) $inv_addr@@67))))
(let ((l@@494 (|l#$ValueArray| va@@494)))
 (and (and (<= 0 l@@494) (<= l@@494 $MAX_U64)) (forall ((x@@497 Int) ) (!  (=> (or (< x@@497 0) (>= x@@497 l@@494)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@494) x@@497) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@494) x@@497))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@54) 1) $inv_addr@@67))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@54) 1) $inv_addr@@67))) $Diem_MintCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@54) 1) $inv_addr@@67))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@0 T@$Value) )  (=> ((_ is $Address) config_address@@0) (|b#$Boolean| ($Boolean (forall ((config_type@@0 T@$Value) )  (=> ((_ is $Type) config_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@0)) 1) (|a#$Address| config_address@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@0 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@48 T@$Value) )  (=> ((_ is $Type) coin_type@@48) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@5 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@48)) 1) (|a#$Address| mint_cap_owner@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@5)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@49 T@$Value) )  (=> ((_ is $Type) coin_type@@49) (|b#$Boolean| ($Boolean (forall ((addr3@@23 T@$Value) )  (=> ((_ is $Address) addr3@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@49)) 1) (|a#$Address| addr3@@23)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@49)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@49)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@50 T@$Value) )  (=> ((_ is $Type) coin_type@@50) (|b#$Boolean| ($Boolean (forall ((addr1@@18 T@$Value) )  (=> ((_ is $Address) addr1@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@50)) 1) (|a#$Address| addr1@@18)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@18)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@51 T@$Value) )  (=> ((_ is $Type) coin_type@@51) (|b#$Boolean| ($Boolean (forall ((addr1@@19 T@$Value) )  (=> ((_ is $Address) addr1@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@51)) 1) (|a#$Address| addr1@@19)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@19)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 315944) 306513))))) inline$$Diem_register_SCS_currency_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@28  (=> (and ((_ is $Address) dr_account@@0) ((_ is $Address) tc_account@@2)) (=> (and (and (and (and (and ((_ is $Vector) to_xdx_exchange_rate) (let ((va@@495 (|v#$Vector| to_xdx_exchange_rate)))
(let ((l@@495 (|l#$ValueArray| va@@495)))
 (and (and (<= 0 l@@495) (<= l@@495 $MAX_U64)) (forall ((x@@498 Int) ) (!  (=> (or (< x@@498 0) (>= x@@498 l@@495)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@495) x@@498) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@495) x@@498))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Integer) scaling_factor) (>= (|i#$Integer| scaling_factor) 0)) (<= (|i#$Integer| scaling_factor) $MAX_U64)) (and (and ((_ is $Integer) fractional_part) (>= (|i#$Integer| fractional_part) 0)) (<= (|i#$Integer| fractional_part) $MAX_U64))) (and (and (and ((_ is $Vector) currency_code) (let ((va@@496 (|v#$Vector| currency_code)))
(let ((l@@496 (|l#$ValueArray| va@@496)))
 (and (and (<= 0 l@@496) (<= l@@496 $MAX_U64)) (forall ((x@@499 Int) ) (!  (=> (or (< x@@499 0) (>= x@@499 l@@496)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@496) x@@499) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@496) x@@499))
)))))) (forall (($$0@@166 Int) ) (!  (=> (and (>= $$0@@166 0) (< $$0@@166 (|l#$ValueArray| (|v#$Vector| currency_code)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) $$0@@166)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) $$0@@166)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) $$0@@166)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code)) $$0@@166))
))) (= (ControlFlow 0 304560) 315944)))) anon0$1_correct@@27))))
(let ((PreconditionGeneratedEntry_correct@@19  (=> (= (ControlFlow 0 510220) 304560) anon0_correct@@28)))
PreconditionGeneratedEntry_correct@@19)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@24 () Bool)
(declare-fun $tv0@@36 () T@$TypeValue)
(declare-fun inline$$Diem_scaling_factor_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@28 () Bool)
(declare-fun $abort_flag@1@@27 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@19 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@4 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@11 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@11 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@11 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@19 () T@$Value)
(declare-fun $abort_code@1@@25 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 526622) (let ((anon0$2_correct@@29  (and (=> (= (ControlFlow 0 318149) (- 0 529247)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529296)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@464 T@$Value) )  (=> ((_ is $Address) addr@@464) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@464))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@464)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@465 T@$Value) )  (=> ((_ is $Address) addr@@465) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@465))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@465))))))))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529376)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@466 T@$Value) )  (=> ((_ is $Address) addr@@466) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@466)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@466))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@467 T@$Value) )  (=> ((_ is $Address) addr@@467) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@467)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@467)))))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529444)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529493)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@468 T@$Value) )  (=> ((_ is $Address) addr@@468) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@468))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@468)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@469 T@$Value) )  (=> ((_ is $Address) addr@@469) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@469))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@469))))))))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529573)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@470 T@$Value) )  (=> ((_ is $Address) addr@@470) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@470)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@470))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@471 T@$Value) )  (=> ((_ is $Address) addr@@471) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@471)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@471)))))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529641)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529690)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529739)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@472 T@$Value) )  (=> ((_ is $Address) addr@@472) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@472))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@472)))))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@473 T@$Value) )  (=> ((_ is $Address) addr@@473) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@473))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@473))))))))))))))) (and (=> (= (ControlFlow 0 318149) (- 0 529819)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@474 T@$Value) )  (=> ((_ is $Address) addr@@474) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@474)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@474))))))))))))) (=> (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean (forall ((addr@@475 T@$Value) )  (=> ((_ is $Address) addr@@475) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@475)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@475)))))))))))) (=> (= (ControlFlow 0 318149) (- 0 529887)) (=> (not $abort_flag@2@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$Abort_correct  (=> (= inline$$Diem_scaling_factor_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@24 true) (= (ControlFlow 0 318109) 318149)) anon0$2_correct@@29))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 318131) 318109)) inline$$Diem_scaling_factor_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 318141) 318109) inline$$Diem_scaling_factor_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@28 (and (=> (= (ControlFlow 0 318125) 318141) inline$$Diem_scaling_factor_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 318125) 318131) inline$$Diem_scaling_factor_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 318101) 318109)) inline$$Diem_scaling_factor_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 318117) 318109) inline$$Diem_scaling_factor_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@27 (and (=> (= (ControlFlow 0 318095) 318117) inline$$Diem_scaling_factor_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 318095) 318101) inline$$Diem_scaling_factor_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@0@@28 (= (ControlFlow 0 318121) 318109)) inline$$Diem_scaling_factor_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@2@@24 $abort_flag@1@@27) (= (ControlFlow 0 318083) 318149)) anon0$2_correct@@29)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 318081) 318083)) inline$$Diem_scaling_factor_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 318091) 318083) inline$$Diem_scaling_factor_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@19  (=> (= inline$$GetFieldFromValue$0$dst@1@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@4)) $Diem_CurrencyInfo_scaling_factor)) (and (=> (= (ControlFlow 0 318065) 318091) inline$$Diem_scaling_factor_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 318065) 318081) inline$$Diem_scaling_factor_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@27) (= (ControlFlow 0 318071) 318065)) inline$$GetFieldFromValue$0$anon0_correct@@19)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@11  (=> (= $abort_flag@1@@27 true) (and (=> (= (ControlFlow 0 318011) 318095) inline$$Diem_scaling_factor_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 318011) 318071) inline$$Diem_scaling_factor_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@11  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@11 inline$$GetGlobal$0$a@1@@11)) (= (ControlFlow 0 318009) 318011)) inline$$GetGlobal$0$anon3_Then$1_correct@@11)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@11  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@11 inline$$GetGlobal$0$a@1@@11) (=> (and (= inline$$GetGlobal$0$dst@1@@11 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@11 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@19))) (= $abort_flag@1@@27 $abort_flag@0@@28)) (and (=> (= (ControlFlow 0 317957) 318095) inline$$Diem_scaling_factor_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 317957) 318071) inline$$Diem_scaling_factor_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@11  (=> (= inline$$GetGlobal$0$a@1@@11 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@19)) (and (=> (= (ControlFlow 0 317939) 318009) inline$$GetGlobal$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 317939) 317957) inline$$GetGlobal$0$anon3_Else_correct@@11)))))
(let ((inline$$GetGlobal$0$Entry_correct@@11  (=> (= inline$$GetGlobal$0$ta@0@@11 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1)) (and (=> (= (ControlFlow 0 317933) (- 0 529098)) true) (=> (= (ControlFlow 0 317933) 317939) inline$$GetGlobal$0$anon0_correct@@11)))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@28) (= (ControlFlow 0 318017) 317933)) inline$$GetGlobal$0$Entry_correct@@11)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@19  (=> (not true) (and (=> (= (ControlFlow 0 317800) 318121) inline$$Diem_scaling_factor_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 317800) 318017) inline$$Diem_scaling_factor_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@19  (and (=> (= (ControlFlow 0 317810) 318121) inline$$Diem_scaling_factor_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 317810) 318017) inline$$Diem_scaling_factor_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@19  (=> (and (not $abort_flag@0@@28) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@19 ($Address 173345816))) (and (=> (= (ControlFlow 0 317794) 317810) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@19) (=> (= (ControlFlow 0 317794) 317800) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@19)))))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@28) (= (ControlFlow 0 317824) 317794)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@19)))
(let ((inline$$Diem_scaling_factor_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@28) (=> $abort_flag@0@@28 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@28 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@25 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@476 T@$Value) )  (=> ((_ is $Address) addr@@476) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@476))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@476))))))))))))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@477 T@$Value) )  (=> ((_ is $Address) addr@@477) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@477)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@477)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@478 T@$Value) )  (=> ((_ is $Address) addr@@478) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@478))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@478)))))))))))))))) (and (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@479 T@$Value) )  (=> ((_ is $Address) addr@@479) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@479)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@479)))))))))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@480 T@$Value) )  (=> ((_ is $Address) addr@@480) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@480))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@480)))))))))))))))) (and (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean (forall ((addr@@481 T@$Value) )  (=> ((_ is $Address) addr@@481) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@481)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| addr@@481)))))))))))) (=> (not $abort_flag@0@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@36) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 317689) 318125) inline$$Diem_scaling_factor_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 317689) 317824) inline$$Diem_scaling_factor_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@28  (=> (forall (($inv_addr@@68 Int) ($inv_tv0@@55 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68)) (let ((va@@497 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))))
(let ((l@@497 (|l#$ValueArray| va@@497)))
 (and (and (<= 0 l@@497) (<= l@@497 $MAX_U64)) (forall ((x@@500 Int) ) (!  (=> (or (< x@@500 0) (>= x@@500 l@@497)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@497) x@@500) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@497) x@@500))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@498 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@498 (|l#$ValueArray| va@@498)))
 (and (and (<= 0 l@@498) (<= l@@498 $MAX_U64)) (forall ((x@@501 Int) ) (!  (=> (or (< x@@501 0) (>= x@@501 l@@498)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@498) x@@501) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@498) x@@501))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code)) (let ((va@@499 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@499 (|l#$ValueArray| va@@499)))
 (and (and (<= 0 l@@499) (<= l@@499 $MAX_U64)) (forall ((x@@502 Int) ) (!  (=> (or (< x@@502 0) (>= x@@502 l@@499)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@499) x@@502) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@499) x@@502))
))))))) (forall (($$0@@167 Int) ) (!  (=> (and (>= $$0@@167 0) (< $$0@@167 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))) $$0@@167)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))) $$0@@167)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))) $$0@@167)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_currency_code))) $$0@@167))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events)) (let ((va@@500 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@500 (|l#$ValueArray| va@@500)))
 (and (and (<= 0 l@@500) (<= l@@500 $MAX_U64)) (forall ((x@@503 Int) ) (!  (=> (or (< x@@503 0) (>= x@@503 l@@500)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@500) x@@503) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@500) x@@503))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@501 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@501 (|l#$ValueArray| va@@501)))
 (and (and (<= 0 l@@501) (<= l@@501 $MAX_U64)) (forall ((x@@504 Int) ) (!  (=> (or (< x@@504 0) (>= x@@504 l@@501)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@501) x@@504) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@501) x@@504))
))))))) (forall (($$0@@168 Int) ) (!  (=> (and (>= $$0@@168 0) (< $$0@@168 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@168)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@168)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@168)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@168))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events)) (let ((va@@502 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@502 (|l#$ValueArray| va@@502)))
 (and (and (<= 0 l@@502) (<= l@@502 $MAX_U64)) (forall ((x@@505 Int) ) (!  (=> (or (< x@@505 0) (>= x@@505 l@@502)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@502) x@@505) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@502) x@@505))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@503 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@503 (|l#$ValueArray| va@@503)))
 (and (and (<= 0 l@@503) (<= l@@503 $MAX_U64)) (forall ((x@@506 Int) ) (!  (=> (or (< x@@506 0) (>= x@@506 l@@503)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@503) x@@506) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@503) x@@506))
))))))) (forall (($$0@@169 Int) ) (!  (=> (and (>= $$0@@169 0) (< $$0@@169 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@169)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@169)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@169)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@169))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@504 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@504 (|l#$ValueArray| va@@504)))
 (and (and (<= 0 l@@504) (<= l@@504 $MAX_U64)) (forall ((x@@507 Int) ) (!  (=> (or (< x@@507 0) (>= x@@507 l@@504)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@504) x@@507) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@504) x@@507))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@505 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@505 (|l#$ValueArray| va@@505)))
 (and (and (<= 0 l@@505) (<= l@@505 $MAX_U64)) (forall ((x@@508 Int) ) (!  (=> (or (< x@@508 0) (>= x@@508 l@@505)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@505) x@@508) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@505) x@@508))
))))))) (forall (($$0@@170 Int) ) (!  (=> (and (>= $$0@@170 0) (< $$0@@170 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@170)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@170)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@170)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@170))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@506 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@506 (|l#$ValueArray| va@@506)))
 (and (and (<= 0 l@@506) (<= l@@506 $MAX_U64)) (forall ((x@@509 Int) ) (!  (=> (or (< x@@509 0) (>= x@@509 l@@506)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@506) x@@509) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@506) x@@509))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@507 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@507 (|l#$ValueArray| va@@507)))
 (and (and (<= 0 l@@507) (<= l@@507 $MAX_U64)) (forall ((x@@510 Int) ) (!  (=> (or (< x@@510 0) (>= x@@510 l@@507)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@507) x@@510) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@507) x@@510))
))))))) (forall (($$0@@171 Int) ) (!  (=> (and (>= $$0@@171 0) (< $$0@@171 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@171)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@171)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@171)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@171))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@508 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@508 (|l#$ValueArray| va@@508)))
 (and (and (<= 0 l@@508) (<= l@@508 $MAX_U64)) (forall ((x@@511 Int) ) (!  (=> (or (< x@@511 0) (>= x@@511 l@@508)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@508) x@@511) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@508) x@@511))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@509 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@509 (|l#$ValueArray| va@@509)))
 (and (and (<= 0 l@@509) (<= l@@509 $MAX_U64)) (forall ((x@@512 Int) ) (!  (=> (or (< x@@512 0) (>= x@@512 l@@509)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@509) x@@512) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@509) x@@512))
))))))) (forall (($$0@@172 Int) ) (!  (=> (and (>= $$0@@172 0) (< $$0@@172 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@172)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@172)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@172)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@172))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@55) 1) $inv_addr@@68))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@52 T@$Value) )  (=> ((_ is $Type) coin_type@@52) (|b#$Boolean| ($Boolean (forall ((addr3@@24 T@$Value) )  (=> ((_ is $Address) addr3@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@52)) 1) (|a#$Address| addr3@@24)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@52)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@52)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 318147) 317689)) inline$$Diem_scaling_factor_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@29  (=> (= (ControlFlow 0 526622) 318147) anon0$1_correct@@28)))
anon0_correct@@29))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun scaling_factor@@0 () T@$Value)
(declare-fun $abort_flag@10@@7 () Bool)
(declare-fun $tv0@@37 () T@$TypeValue)
(declare-fun dr_account@@1 () T@$Value)
(declare-fun currency_code@@0 () T@$Value)
(declare-fun $abort_code@16@@7 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@10 () T@$Memory)
(declare-fun |inline$$MoveToRaw$0$m'@2@@2| () T@$Memory)
(declare-fun $abort_flag@9@@8 () Bool)
(declare-fun $DiemConfig_Configuration_$memory@4@@0 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@2@@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@4@@1 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@2@@1 () T@$Memory)
(declare-fun $abort_code@14@@7 () Int)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t39@1 () T@$Value)
(declare-fun inline$$Diem_BurnCapability_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t37@1 () T@$Value)
(declare-fun inline$$Diem_MintCapability_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $Diem_CurrencyInfo_$memory@0@@10 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@3@@0 () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory@3@@1 () T@$Memory)
(declare-fun $abort_code@15@@7 () Int)
(declare-fun $abort_code@1@@26 () Int)
(declare-fun $abort_flag@0@@29 () Bool)
(declare-fun $abort_code@2@@19 () Int)
(declare-fun $abort_flag@1@@28 () Bool)
(declare-fun $abort_code@3@@20 () Int)
(declare-fun $abort_flag@2@@25 () Bool)
(declare-fun $abort_code@4@@19 () Int)
(declare-fun $abort_flag@3@@18 () Bool)
(declare-fun $abort_code@6@@15 () Int)
(declare-fun $abort_flag@4@@16 () Bool)
(declare-fun $abort_code@8@@12 () Int)
(declare-fun $abort_flag@5@@13 () Bool)
(declare-fun $abort_flag@8@@8 () Bool)
(declare-fun $abort_code@12@@8 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@0@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@13@@8 () Int)
(declare-fun $DiemConfig_DiemConfig_$memory@1@@1 () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory@1@@0 () T@$Memory)
(declare-fun $abort_code@9@@11 () Int)
(declare-fun $abort_flag@6@@12 () Bool)
(declare-fun $abort_code@10@@10 () Int)
(declare-fun $abort_flag@7@@10 () Bool)
(declare-fun call0formal@$tv0@0@@2 () T@$TypeValue)
(declare-fun call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@6| () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@10| () T@$Mutation)
(declare-fun call3formal@$ret0@0@@62 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@8| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@8 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@11| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@10 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@10 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@10| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$Vector_push_back$0$v'@1@@0| () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@11 () T@$Value)
(declare-fun inline$$Vector_push_back$0$ta@0@@0 () T@$TypeValue)
(declare-fun inline$$BorrowField$0$p@1@@10 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@10 () Int)
(declare-fun inline$$BorrowField$0$p@2@@10 () T@$Path)
(declare-fun inline$$Not$1$dst@1@@2 () T@$Value)
(declare-fun $abort_code@11@@10 () Int)
(declare-fun call3formal@$ret0@0@@63 () T@$Value)
(declare-fun inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1@@0 () T@$Value)
(declare-fun inline$$Vector_contains$0$res@1@@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@20 () T@$Value)
(declare-fun inline$$Vector_contains$0$ta@0@@0 () T@$TypeValue)
(declare-fun call0formal@$tv0@0@@3 () T@$TypeValue)
(declare-fun |inline$$MoveToRaw$0$m'@0@@2| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0@@2 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1@@2 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1@@2| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t28@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t29@1 () T@$Value)
(declare-fun to_xdx_exchange_rate@@0 () T@$Value)
(declare-fun is_synthetic () T@$Value)
(declare-fun fractional_part@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t30@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0@@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$1$res@0@@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$2$res@0@@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$3$res@0@@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$res@0@@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$4$t@0@@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$3$t@0@@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$2$t@0@@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$1$t@0@@0 () T@$TypeValue)
(declare-fun inline$$Event_new_event_handle$0$t@0@@0 () T@$TypeValue)
(declare-fun |inline$$Diem_register_currency_$def_verify$0$tmp#$10@1| () T@$Value)
(declare-fun $abort_code@7@@14 () Int)
(declare-fun call3formal@$ret0@0@@64 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t26@1 () T@$Value)
(declare-fun inline$$Le$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$Lt$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t25@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t22@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@13 () T@$Value)
(declare-fun $abort_code@5@@16 () Int)
(declare-fun call3formal@$ret0@0@@65 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t20@1 () T@$Value)
(declare-fun inline$$Diem_register_currency_$def_verify$0$$t18@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@66 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 529944) (let ((anon0$2_correct@@30  (and (=> (= (ControlFlow 0 325388) (- 0 538768)) (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538805)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1)))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1)))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538831)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538852)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538881)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538898)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538915)) (=> (|b#$Boolean| ($Boolean (let (($range_1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@482 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@482)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@5 Int) )  (and (and (>= $i_0@@5 0) (< $i_0@@5 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@513 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@513 currency_code@@0))))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean (let (($range_1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@482 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@482)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@6 Int) )  (and (and (>= $i_0@@6 0) (< $i_0@@6 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((x@@513 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@6)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@513 currency_code@@0))))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538937)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 538970)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 539000)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@10@@7)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@10@@7) (and (=> (= (ControlFlow 0 325388) (- 0 539099)) (=> $abort_flag@10@@7 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@483 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@483)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@7 Int) )  (and (and (>= $i_0@@7 0) (< $i_0@@7 (|l#$ValueArray| (|v#$Vector| $range_1@@3)))) (let ((x@@514 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@3)) $i_0@@7)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@514 currency_code@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (=> (=> $abort_flag@10@@7 (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (|b#$Boolean| ($Boolean (let (($range_1@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@483 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@483)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@8 Int) )  (and (and (>= $i_0@@8 0) (< $i_0@@8 (|l#$ValueArray| (|v#$Vector| $range_1@@3)))) (let ((x@@514 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@3)) $i_0@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@514 currency_code@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 539421)) (=> $abort_flag@10@@7 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1)))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@484 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@484)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@9 Int) )  (and (and (>= $i_0@@9 0) (< $i_0@@9 (|l#$ValueArray| (|v#$Vector| $range_1@@4)))) (let ((x@@515 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@4)) $i_0@@9)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@515 currency_code@@0))))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 1))))))) (=> (=> $abort_flag@10@@7 (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified scaling_factor@@0 ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| scaling_factor@@0) (|i#$Integer| ($Integer 10000000000)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| dr_account@@1)))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (let (($range_1@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@484 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| addr@@484)))) $DiemConfig_DiemConfig_payload)))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)))
(exists (($i_0@@10 Int) )  (and (and (>= $i_0@@10 0) (< $i_0@@10 (|l#$ValueArray| (|v#$Vector| $range_1@@4)))) (let ((x@@515 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@4)) $i_0@@10)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified x@@515 currency_code@@0))))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| dr_account@@1))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 4))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@16@@7 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 325388) (- 0 539853)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 325388) (- 0 539865)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer 0)))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 325388) (- 0 539889)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 539935)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@485 T@$Value) )  (=> ((_ is $Address) addr@@485) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@485))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@485)))))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@486 T@$Value) )  (=> ((_ is $Address) addr@@486) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@486))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@486))))))))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540015)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@487 T@$Value) )  (=> ((_ is $Address) addr@@487) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@487)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@487))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@488 T@$Value) )  (=> ((_ is $Address) addr@@488) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@488)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@488)))))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540083)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540129)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@489 T@$Value) )  (=> ((_ is $Address) addr@@489) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@489))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@489)))))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@490 T@$Value) )  (=> ((_ is $Address) addr@@490) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@490))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@490))))))))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540209)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@491 T@$Value) )  (=> ((_ is $Address) addr@@491) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@491)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@491))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@492 T@$Value) )  (=> ((_ is $Address) addr@@492) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@492)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@492)))))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540277)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540323)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540369)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@493 T@$Value) )  (=> ((_ is $Address) addr@@493) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@493))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@493)))))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@494 T@$Value) )  (=> ((_ is $Address) addr@@494) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@494))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@494))))))))))))))) (and (=> (= (ControlFlow 0 325388) (- 0 540449)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@495 T@$Value) )  (=> ((_ is $Address) addr@@495) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@495)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@495))))))))))))) (=> (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean (forall ((addr@@496 T@$Value) )  (=> ((_ is $Address) addr@@496) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@496)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| addr@@496)))))))))))) (=> (= (ControlFlow 0 325388) (- 0 540517)) (=> (not $abort_flag@10@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@1@@10) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon76_correct  (=> (and (= $Diem_CurrencyInfo_$memory@1@@10 |inline$$MoveToRaw$0$m'@2@@2|) (= $abort_flag@10@@7 $abort_flag@9@@8)) (=> (and (and (= $DiemConfig_Configuration_$memory@4@@0 $DiemConfig_Configuration_$memory@2@@0) (= $DiemConfig_DiemConfig_$memory@4@@1 $DiemConfig_DiemConfig_$memory@2@@1)) (and (= $abort_code@16@@7 $abort_code@14@@7) (= (ControlFlow 0 324992) 325388))) anon0$2_correct@@30))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon114_Else_correct  (=> (and (not true) (= (ControlFlow 0 324990) 324992)) inline$$Diem_register_currency_$def_verify$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon114_Then_correct  (=> (= (ControlFlow 0 325000) 324992) inline$$Diem_register_currency_$def_verify$0$anon76_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon113_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 324980) 325000) inline$$Diem_register_currency_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 324980) 324990) inline$$Diem_register_currency_$def_verify$0$anon114_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon113_Then_correct  (and (=> (= (ControlFlow 0 325008) 325000) inline$$Diem_register_currency_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 325008) 324990) inline$$Diem_register_currency_$def_verify$0$anon114_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 324958) 325008) inline$$Diem_register_currency_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 324958) 324980) inline$$Diem_register_currency_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon4_Then_correct@@0  (and (=> (= (ControlFlow 0 324964) 325008) inline$$Diem_register_currency_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 324964) 324980) inline$$Diem_register_currency_$def_verify$0$anon113_Else_correct))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 324952) 324964) inline$$Diem_BurnCapability_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 324952) 324958) inline$$Diem_BurnCapability_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon3_Else_correct@@0  (=> (>= 0 0) (and (=> (= (ControlFlow 0 324944) 325008) inline$$Diem_register_currency_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 324944) 324980) inline$$Diem_register_currency_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$Diem_BurnCapability_pack$0$anon0_correct@@0  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def_verify$0$$t39@1) (= inline$$Diem_BurnCapability_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def_verify$0$$t39@1) 1)))) (and (=> (= (ControlFlow 0 324936) 324952) inline$$Diem_BurnCapability_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 324936) 324944) inline$$Diem_BurnCapability_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon112_Else$1_correct  (=> (and (= inline$$Diem_register_currency_$def_verify$0$$t39@1 ($Boolean false)) (= (ControlFlow 0 324970) 324936)) inline$$Diem_BurnCapability_pack$0$anon0_correct@@0)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324787) 324970)) inline$$Diem_register_currency_$def_verify$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon4_Then_correct@@0  (=> (= (ControlFlow 0 324793) 324970) inline$$Diem_register_currency_$def_verify$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 324781) 324793) inline$$Diem_MintCapability_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 324781) 324787) inline$$Diem_MintCapability_pack$0$anon4_Else_correct@@0)))))
(let ((inline$$Diem_MintCapability_pack$0$anon3_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 324773) 324970)) inline$$Diem_register_currency_$def_verify$0$anon112_Else$1_correct)))
(let ((inline$$Diem_MintCapability_pack$0$anon0_correct@@0  (=> (and ((_ is $Boolean) inline$$Diem_register_currency_$def_verify$0$$t37@1) (= inline$$Diem_MintCapability_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def_verify$0$$t37@1) 1)))) (and (=> (= (ControlFlow 0 324765) 324781) inline$$Diem_MintCapability_pack$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 324765) 324773) inline$$Diem_MintCapability_pack$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon112_Else_correct  (=> (not $abort_flag@9@@8) (=> (and (= inline$$Diem_register_currency_$def_verify$0$$t37@1 ($Boolean false)) (= (ControlFlow 0 324799) 324765)) inline$$Diem_MintCapability_pack$0$anon0_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$Abort_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def_verify$0$$ret0@1 $Error) (= inline$$Diem_register_currency_$def_verify$0$$ret1@1 $Error)) (and (= $Diem_CurrencyInfo_$memory@1@@10 $Diem_CurrencyInfo_$memory@0@@10) (= $abort_flag@10@@7 true))) (and (and (= $DiemConfig_Configuration_$memory@4@@0 $DiemConfig_Configuration_$memory@3@@0) (= $DiemConfig_DiemConfig_$memory@4@@1 $DiemConfig_DiemConfig_$memory@3@@1)) (and (= $abort_code@16@@7 $abort_code@15@@7) (= (ControlFlow 0 321065) 325388)))) anon0$2_correct@@30)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon15_correct  (=> (= $abort_code@15@@7 $abort_code@1@@26) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325322) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 325320) 325322)) inline$$Diem_register_currency_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon84_Then_correct  (=> (= (ControlFlow 0 325330) 325322) inline$$Diem_register_currency_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon83_Then_correct  (=> $abort_flag@0@@29 (and (=> (= (ControlFlow 0 325314) 325330) inline$$Diem_register_currency_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 325314) 325320) inline$$Diem_register_currency_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon19_correct  (=> (= $abort_code@15@@7 $abort_code@2@@19) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325302) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 325300) 325302)) inline$$Diem_register_currency_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon86_Then_correct  (=> (= (ControlFlow 0 325310) 325302) inline$$Diem_register_currency_$def_verify$0$anon19_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon85_Then_correct  (=> $abort_flag@1@@28 (and (=> (= (ControlFlow 0 325294) 325310) inline$$Diem_register_currency_$def_verify$0$anon86_Then_correct) (=> (= (ControlFlow 0 325294) 325300) inline$$Diem_register_currency_$def_verify$0$anon86_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon23_correct  (=> (= $abort_code@15@@7 $abort_code@3@@20) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325282) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 325280) 325282)) inline$$Diem_register_currency_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon88_Then_correct  (=> (= (ControlFlow 0 325290) 325282) inline$$Diem_register_currency_$def_verify$0$anon23_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon87_Then_correct  (=> $abort_flag@2@@25 (and (=> (= (ControlFlow 0 325274) 325290) inline$$Diem_register_currency_$def_verify$0$anon88_Then_correct) (=> (= (ControlFlow 0 325274) 325280) inline$$Diem_register_currency_$def_verify$0$anon88_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon27_correct  (=> (= $abort_code@15@@7 $abort_code@4@@19) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325262) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon90_Else_correct  (=> (and (not true) (= (ControlFlow 0 325260) 325262)) inline$$Diem_register_currency_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon90_Then_correct  (=> (= (ControlFlow 0 325270) 325262) inline$$Diem_register_currency_$def_verify$0$anon27_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon89_Then_correct  (=> $abort_flag@3@@18 (and (=> (= (ControlFlow 0 325254) 325270) inline$$Diem_register_currency_$def_verify$0$anon90_Then_correct) (=> (= (ControlFlow 0 325254) 325260) inline$$Diem_register_currency_$def_verify$0$anon90_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon41_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325144) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon97_Else_correct  (=> (and (not true) (= (ControlFlow 0 325142) 325144)) inline$$Diem_register_currency_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon97_Then_correct  (=> (= (ControlFlow 0 325152) 325144) inline$$Diem_register_currency_$def_verify$0$anon41_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon96_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325136) 325152) inline$$Diem_register_currency_$def_verify$0$anon97_Then_correct) (=> (= (ControlFlow 0 325136) 325142) inline$$Diem_register_currency_$def_verify$0$anon97_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon49_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325124) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon101_Else_correct  (=> (and (not true) (= (ControlFlow 0 325122) 325124)) inline$$Diem_register_currency_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon101_Then_correct  (=> (= (ControlFlow 0 325132) 325124) inline$$Diem_register_currency_$def_verify$0$anon49_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon100_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325116) 325132) inline$$Diem_register_currency_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 325116) 325122) inline$$Diem_register_currency_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon53_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325104) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 325102) 325104)) inline$$Diem_register_currency_$def_verify$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon103_Then_correct  (=> (= (ControlFlow 0 325112) 325104) inline$$Diem_register_currency_$def_verify$0$anon53_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon102_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325096) 325112) inline$$Diem_register_currency_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 325096) 325102) inline$$Diem_register_currency_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon57_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325084) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 325082) 325084)) inline$$Diem_register_currency_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon105_Then_correct  (=> (= (ControlFlow 0 325092) 325084) inline$$Diem_register_currency_$def_verify$0$anon57_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon104_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325076) 325092) inline$$Diem_register_currency_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 325076) 325082) inline$$Diem_register_currency_$def_verify$0$anon105_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon61_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325064) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 325062) 325064)) inline$$Diem_register_currency_$def_verify$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon107_Then_correct  (=> (= (ControlFlow 0 325072) 325064) inline$$Diem_register_currency_$def_verify$0$anon61_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon106_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325056) 325072) inline$$Diem_register_currency_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 325056) 325062) inline$$Diem_register_currency_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon65_correct  (=> (= $abort_code@15@@7 $abort_code@6@@15) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325044) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon109_Else_correct  (=> (and (not true) (= (ControlFlow 0 325042) 325044)) inline$$Diem_register_currency_$def_verify$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon109_Then_correct  (=> (= (ControlFlow 0 325052) 325044) inline$$Diem_register_currency_$def_verify$0$anon65_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon108_Then_correct  (=> $abort_flag@4@@16 (and (=> (= (ControlFlow 0 325036) 325052) inline$$Diem_register_currency_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 325036) 325042) inline$$Diem_register_currency_$def_verify$0$anon109_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon69_correct  (=> (= $abort_code@15@@7 $abort_code@8@@12) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 |inline$$MoveToRaw$0$m'@2@@2|) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 325024) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon111_Else_correct  (=> (and (not true) (= (ControlFlow 0 325022) 325024)) inline$$Diem_register_currency_$def_verify$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon111_Then_correct  (=> (= (ControlFlow 0 325032) 325024) inline$$Diem_register_currency_$def_verify$0$anon69_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon110_Then_correct  (=> $abort_flag@5@@13 (and (=> (= (ControlFlow 0 325016) 325032) inline$$Diem_register_currency_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 325016) 325022) inline$$Diem_register_currency_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon112_Then_correct  (=> (and $abort_flag@9@@8 (= $abort_code@15@@7 $abort_code@14@@7)) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 |inline$$MoveToRaw$0$m'@2@@2|) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory@2@@0)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory@2@@1) (= (ControlFlow 0 325012) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct@@0  (=> (not $abort_flag@8@@8) (=> (and (and (= $abort_code@14@@7 $abort_code@12@@8) (= $abort_flag@9@@8 $abort_flag@8@@8)) (and (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@0@@1) (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@0@@0))) (and (=> (= (ControlFlow 0 324496) 325012) inline$$Diem_register_currency_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 324496) 324799) inline$$Diem_register_currency_$def_verify$0$anon112_Else_correct))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0  (=> (and (and (= $abort_code@14@@7 $abort_code@13@@8) (= $abort_flag@9@@8 true)) (and (= $DiemConfig_DiemConfig_$memory@2@@1 $DiemConfig_DiemConfig_$memory@1@@1) (= $DiemConfig_Configuration_$memory@2@@0 $DiemConfig_Configuration_$memory@1@@0))) (and (=> (= (ControlFlow 0 323768) 325012) inline$$Diem_register_currency_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 323768) 324799) inline$$Diem_register_currency_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@9@@11) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 324588) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324586) 324588)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct@@0  (=> (= (ControlFlow 0 324596) 324588) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon7_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct@@0  (=> $abort_flag@6@@12 (and (=> (= (ControlFlow 0 324580) 324596) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Then_correct@@0) (=> (= (ControlFlow 0 324580) 324586) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon32_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@9@@11) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 324568) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324566) 324568)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct@@0  (=> (= (ControlFlow 0 324576) 324568) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon11_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct@@0  (=> $abort_flag@6@@12 (and (=> (= (ControlFlow 0 324560) 324576) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Then_correct@@0) (=> (= (ControlFlow 0 324560) 324566) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon34_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@10@@10) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 324548) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324546) 324548)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct@@0  (=> (= (ControlFlow 0 324556) 324548) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon15_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct@@0  (=> $abort_flag@7@@10 (and (=> (= (ControlFlow 0 324540) 324556) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Then_correct@@0) (=> (= (ControlFlow 0 324540) 324546) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon36_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@10@@10) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 324528) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324526) 324528)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct@@0  (=> (= (ControlFlow 0 324536) 324528) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon23_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct@@0  (=> $abort_flag@7@@10 (and (=> (= (ControlFlow 0 324520) 324536) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Then_correct@@0) (=> (= (ControlFlow 0 324520) 324526) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon40_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@12@@8) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory@0@@1)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory@0@@0) (= (ControlFlow 0 324508) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 324506) 324508)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct@@0  (=> (= (ControlFlow 0 324516) 324508) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon27_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct@@0  (=> $abort_flag@8@@8 (and (=> (= (ControlFlow 0 324500) 324516) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Then_correct@@0) (=> (= (ControlFlow 0 324500) 324506) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon42_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct@@0  (=> (and (= call0formal@$tv0@0@@2 $RegisteredCurrencies_RegisteredCurrencies_type_value) (= call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 ($ConstMemoryDomain true))) (and (=> (= (ControlFlow 0 324490) (- 0 537381)) (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| call3formal@$DiemConfig_Configuration_$CallerDomain@0@@0 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account@@1))))))) $abort_flag@8@@8) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@8@@8)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) $abort_flag@8@@8) (=> $abort_flag@8@@8 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account@@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time))))))))))) (and (=> $abort_flag@8@@8 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| dr_account@@1))))))) (= $abort_code@12@@8 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@12@@8 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer 0)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_epoch)) (|i#$Integer| ($Integer 18446744073709551615)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemConfig_Configuration_last_reconfiguration_time)))))))) (= $abort_code@12@@8 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@8@@8) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@8@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified (let ((addr@@497 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@2) 1) (|a#$Address| addr@@497)))) $DiemConfig_DiemConfig_payload)) |inline$$WritebackToValue$0$vdst'@2@@6|)))) (=> (not $abort_flag@8@@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (= (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory@0@@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (=> (= (ControlFlow 0 324490) 324500) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Then_correct@@0) (=> (= (ControlFlow 0 324490) 324496) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon41_Else_correct@@0)))))))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@8  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@10|) ($Local 2))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@6| call3formal@$ret0@0@@62) (= (ControlFlow 0 324456) 324490)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct@@0))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@8  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@10|) ($Local 2)) (= |inline$$WritebackToValue$0$vdst'@1@@8| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@10|) 0 call3formal@$ret0@0@@62 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@10|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@6| |inline$$WritebackToValue$0$vdst'@1@@8|) (= (ControlFlow 0 324482) 324490))) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else$3_correct@@0)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@10  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@11|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@10) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@10))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@10 inline$$WritebackToReference$0$srcPath@1@@10))) (= |inline$$WritebackToReference$0$dst'@2@@10| inline$$BorrowLoc$0$dst@1@@8)) (and (=> (= (ControlFlow 0 324301) 324482) inline$$WritebackToValue$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 324301) 324456) inline$$WritebackToValue$0$anon3_Else_correct@@8)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@10  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@11|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@10) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@10))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@10 inline$$WritebackToReference$0$srcPath@1@@10)) (and (= |inline$$WritebackToReference$0$dst'@1@@10| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) inline$$WritebackToReference$0$dstPath@1@@10 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@10 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@10) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@11|)))) (= |inline$$WritebackToReference$0$dst'@2@@10| |inline$$WritebackToReference$0$dst'@1@@10|))) (and (=> (= (ControlFlow 0 324357) 324482) inline$$WritebackToValue$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 324357) 324456) inline$$WritebackToValue$0$anon3_Else_correct@@8)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@10  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@10 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@11|)) (= inline$$WritebackToReference$0$dstPath@1@@10 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) (and (=> (= (ControlFlow 0 324265) 324357) inline$$WritebackToReference$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 324265) 324301) inline$$WritebackToReference$0$anon3_Else_correct@@10)))))
(let ((inline$$WriteRef$0$anon0_correct@@11  (=> (and (= |inline$$WriteRef$0$to'@1@@11| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@10) (|p#$Mutation| inline$$BorrowField$0$dst@1@@10) |inline$$Vector_push_back$0$v'@1@@0|)) (= (ControlFlow 0 324122) 324265)) inline$$WritebackToReference$0$anon0_correct@@10)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct@@0  (=> (and (not $abort_flag@7@@10) (= (ControlFlow 0 324128) 324122)) inline$$WriteRef$0$anon0_correct@@11)))
(let ((inline$$Vector_push_back$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$ReadRef$0$v@1@@11) (= |inline$$Vector_push_back$0$v'@1@@0| ($Vector (let ((len@@2 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@11))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@11)) len@@2 currency_code@@0) (+ len@@2 1)))))) (and (=> (= (ControlFlow 0 324057) 324520) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Then_correct@@0) (=> (= (ControlFlow 0 324057) 324128) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon39_Else_correct@@0)))))
(let ((inline$$Vector_push_back$0$Entry_correct@@0  (=> (and (= inline$$Vector_push_back$0$ta@0@@0 ($VectorType $IntegerType)) (= (ControlFlow 0 324045) 324057)) inline$$Vector_push_back$0$anon0_correct@@0)))
(let ((inline$$ReadRef$0$anon0_correct@@11  (=> (and (= inline$$ReadRef$0$v@1@@11 (|v#$Mutation| inline$$BorrowField$0$dst@1@@10)) (= (ControlFlow 0 323992) 324045)) inline$$Vector_push_back$0$Entry_correct@@0)))
(let ((inline$$BorrowField$0$anon0_correct@@10  (=> (= inline$$BorrowField$0$p@1@@10 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@8)) (=> (and (and (= inline$$BorrowField$0$size@1@@10 (|size#$Path| inline$$BorrowField$0$p@1@@10)) (= inline$$BorrowField$0$p@2@@10 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@10) inline$$BorrowField$0$size@1@@10 $RegisteredCurrencies_RegisteredCurrencies_currency_codes) (+ inline$$BorrowField$0$size@1@@10 1)))) (and (= inline$$BorrowField$0$dst@1@@10 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@8) inline$$BorrowField$0$p@2@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@8))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) (= (ControlFlow 0 323954) 323992))) inline$$ReadRef$0$anon0_correct@@11))))
(let ((inline$$BorrowLoc$0$anon0_correct@@8  (=> (and (= inline$$BorrowLoc$0$dst@1@@8 ($Mutation ($Local 2) $EmptyPath call3formal@$ret0@0@@62)) (= (ControlFlow 0 323830) 323954)) inline$$BorrowField$0$anon0_correct@@10)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct@@0  (=> (and (|b#$Boolean| inline$$Not$1$dst@1@@2) (= (ControlFlow 0 323836) 323830)) inline$$BorrowLoc$0$anon0_correct@@8)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct@@0  (=> (and (and (= $abort_code@13@@8 $abort_code@11@@10) (= $DiemConfig_DiemConfig_$memory@1@@1 $DiemConfig_DiemConfig_$memory)) (and (= $DiemConfig_Configuration_$memory@1@@0 $DiemConfig_Configuration_$memory) (= (ControlFlow 0 323764) 323768))) inline$$RegisteredCurrencies_add_currency_code_$def$0$Abort_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 323762) 323764)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct@@0  (=> (= (ControlFlow 0 323776) 323764) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon20_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct@@0  (=> (and (not (|b#$Boolean| inline$$Not$1$dst@1@@2)) (= $abort_code@11@@10 (|i#$Integer| call3formal@$ret0@0@@63))) (and (=> (= (ControlFlow 0 323756) 323776) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Then_correct@@0) (=> (= (ControlFlow 0 323756) 323762) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon38_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct@@0  (=> (not $abort_flag@7@@10) (and (=> (= (ControlFlow 0 323744) 323836) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Then_correct@@0) (=> (= (ControlFlow 0 323744) 323756) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon37_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct@@0  (=> (and (and (and (= inline$$RegisteredCurrencies_add_currency_code_$def$0$$t10@1@@0 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@7@@10)) (and (=> $abort_flag@7@@10 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@7@@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@63 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@63) (>= (|i#$Integer| call3formal@$ret0@0@@63) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@63) $MAX_U64))) (and (=> (= (ControlFlow 0 323738) 324540) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Then_correct@@0) (=> (= (ControlFlow 0 323738) 323744) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon35_Else_correct@@0)))))
(let ((inline$$Not$1$anon0_correct@@2  (=> (and (= inline$$Not$1$dst@1@@2 ($Boolean  (not (|b#$Boolean| inline$$Vector_contains$0$res@1@@0)))) (= (ControlFlow 0 323726) 323738)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else$1_correct@@0)))
(let ((inline$$Not$1$Entry_correct@@2  (and (=> (= (ControlFlow 0 323716) (- 0 536897)) true) (=> (= (ControlFlow 0 323716) 323726) inline$$Not$1$anon0_correct@@2))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct@@0  (=> (and (not $abort_flag@6@@12) (= (ControlFlow 0 323732) 323716)) inline$$Not$1$Entry_correct@@2)))
(let ((inline$$Vector_contains$0$anon0_correct@@0  (=> (and ((_ is $Vector) inline$$GetFieldFromValue$0$dst@1@@20) (= inline$$Vector_contains$0$res@1@@0 ($Boolean (exists ((i@@11 Int) )  (and (and (<= 0 i@@11) (< i@@11 (|l#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@20)))) ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetFieldFromValue$0$dst@1@@20)) i@@11) currency_code@@0)))))) (and (=> (= (ControlFlow 0 323670) 324560) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Then_correct@@0) (=> (= (ControlFlow 0 323670) 323732) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon33_Else_correct@@0)))))
(let ((inline$$Vector_contains$0$Entry_correct@@0  (=> (and (= inline$$Vector_contains$0$ta@0@@0 ($VectorType $IntegerType)) (= (ControlFlow 0 323656) 323670)) inline$$Vector_contains$0$anon0_correct@@0)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@20  (=> (and (= inline$$GetFieldFromValue$0$dst@1@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@62)) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (= (ControlFlow 0 323601) 323656)) inline$$Vector_contains$0$Entry_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct@@0  (=> (and (not $abort_flag@6@@12) (= (ControlFlow 0 323607) 323601)) inline$$GetFieldFromValue$0$anon0_correct@@20)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct@@0  (=> (= call0formal@$tv0@0@@3 $RegisteredCurrencies_RegisteredCurrencies_type_value) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@12) (=> $abort_flag@6@@12 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@12 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@11 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@6@@12) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@62 (let ((addr@@498 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 call0formal@$tv0@0@@3) 1) (|a#$Address| addr@@498)))) $DiemConfig_DiemConfig_payload)))))))) (and (=> (= (ControlFlow 0 323555) 324580) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Then_correct@@0) (=> (= (ControlFlow 0 323555) 323607) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon31_Else_correct@@0))))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 323485) 323555)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct@@0  (=> (= (ControlFlow 0 324604) 323555) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon4$2_correct@@0)))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 323477) 324604) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 323477) 323485) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct@@0  (and (=> (= (ControlFlow 0 324612) 324604) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Then_correct@@0) (=> (= (ControlFlow 0 324612) 323485) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon30_Else_correct@@0))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct@@0  (=> (not $abort_flag@5@@13) (and (=> (= (ControlFlow 0 323471) 324612) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Then_correct@@0) (=> (= (ControlFlow 0 323471) 323477) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon29_Else_correct@@0)))))
(let ((inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dr_account@@1) (=> (and (and (and ((_ is $Vector) currency_code@@0) (let ((va@@510 (|v#$Vector| currency_code@@0)))
(let ((l@@510 (|l#$ValueArray| va@@510)))
 (and (and (<= 0 l@@510) (<= l@@510 $MAX_U64)) (forall ((x@@516 Int) ) (!  (=> (or (< x@@516 0) (>= x@@516 l@@510)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@510) x@@516) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@510) x@@516))
)))))) (forall ((inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0 Int) ) (!  (=> (and (>= inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0 0) (< inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0 (|l#$ValueArray| (|v#$Vector| currency_code@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$$$0))
))) (= (ControlFlow 0 324616) 323471)) inline$$RegisteredCurrencies_add_currency_code_$def$0$anon0_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon110_Else_correct  (=> (not $abort_flag@5@@13) (and (=> (= (ControlFlow 0 324622) (- 0 536286)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1 inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 324622) (- 0 536410)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 324622) (- 0 536463)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2@@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$dr_addr@@0))))))))))))))) (=> (= (ControlFlow 0 324622) 324616) inline$$RegisteredCurrencies_add_currency_code_$direct_inter$0$anon0_correct))))))))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct@@2  (=> (= $abort_flag@5@@13 true) (=> (and (= $abort_code@8@@12 $EXEC_FAILURE_CODE) (= |inline$$MoveToRaw$0$m'@2@@2| |inline$$MoveToRaw$0$m'@0@@2|)) (and (=> (= (ControlFlow 0 322560) 325016) inline$$Diem_register_currency_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 322560) 324622) inline$$Diem_register_currency_$def_verify$0$anon110_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct@@2  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@2 inline$$MoveTo$0$a@1@@2) (= (ControlFlow 0 322558) 322560)) inline$$MoveToRaw$0$anon3_Then$1_correct@@2)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct@@2  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@2 inline$$MoveTo$0$a@1@@2)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1@@2| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@2 inline$$MoveTo$0$a@1@@2 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$MoveTo$0$ta@0@@2 inline$$MoveTo$0$a@1@@2 inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0))) (= $abort_flag@5@@13 $abort_flag@4@@16)) (and (= $abort_code@8@@12 $abort_code@6@@15) (= |inline$$MoveToRaw$0$m'@2@@2| |inline$$MoveToRaw$0$m'@1@@2|))) (and (=> (= (ControlFlow 0 322508) 325016) inline$$Diem_register_currency_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 322508) 324622) inline$$Diem_register_currency_$def_verify$0$anon110_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct@@2  (=> (= inline$$MoveTo$0$a@1@@2 (|a#$Address| dr_account@@1)) (and (=> (= (ControlFlow 0 322566) 322558) inline$$MoveToRaw$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 322566) 322508) inline$$MoveToRaw$0$anon3_Else_correct@@2)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct@@2  (and (=> (= (ControlFlow 0 322354) (- 0 536171)) true) (=> (= (ControlFlow 0 322354) 322566) inline$$MoveTo$0$anon0$1_correct@@2))))
(let ((inline$$MoveTo$0$Entry_correct@@2  (=> (and (= inline$$MoveTo$0$ta@0@@2 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1)) (= (ControlFlow 0 322326) 322354)) inline$$Signer_borrow_address$0$Entry_correct@@2)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon108_Else$1_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_register_currency_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_register_currency_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_register_currency_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_register_currency_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 322574) 322326)) inline$$MoveTo$0$Entry_correct@@2)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon3_correct@@0  (and (=> (= (ControlFlow 0 322087) (- 0 535956)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 322087) 322574) inline$$Diem_register_currency_$def_verify$0$anon108_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 322101) 322087)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 322107) 322087) inline$$Diem_CurrencyInfo_pack$0$anon3_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct@@0  (=> (> 0 0) (and (=> (= (ControlFlow 0 322095) 322107) inline$$Diem_CurrencyInfo_pack$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 322095) 322101) inline$$Diem_CurrencyInfo_pack$0$anon5_Else_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct@@0  (=> (and (>= 0 0) (= (ControlFlow 0 322039) 322087)) inline$$Diem_CurrencyInfo_pack$0$anon3_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_pack$0$anon0_correct@@0  (=> (and (and (and ((_ is $Integer) inline$$Diem_register_currency_$def_verify$0$$t28@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t28@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t28@1) $MAX_U128)) (and (and ((_ is $Integer) inline$$Diem_register_currency_$def_verify$0$$t29@1) (>= (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t29@1) 0)) (<= (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t29@1) $MAX_U64))) (=> (and (and (and (and (and (and ((_ is $Vector) to_xdx_exchange_rate@@0) (let ((va@@511 (|v#$Vector| to_xdx_exchange_rate@@0)))
(let ((l@@511 (|l#$ValueArray| va@@511)))
 (and (and (<= 0 l@@511) (<= l@@511 $MAX_U64)) (forall ((x@@517 Int) ) (!  (=> (or (< x@@517 0) (>= x@@517 l@@511)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@511) x@@517) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@511) x@@517))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) is_synthetic)) (and (and (and (and ((_ is $Integer) scaling_factor@@0) (>= (|i#$Integer| scaling_factor@@0) 0)) (<= (|i#$Integer| scaling_factor@@0) $MAX_U64)) (and (and ((_ is $Integer) fractional_part@@0) (>= (|i#$Integer| fractional_part@@0) 0)) (<= (|i#$Integer| fractional_part@@0) $MAX_U64))) (and (and (and ((_ is $Vector) currency_code@@0) (let ((va@@512 (|v#$Vector| currency_code@@0)))
(let ((l@@512 (|l#$ValueArray| va@@512)))
 (and (and (<= 0 l@@512) (<= l@@512 $MAX_U64)) (forall ((x@@518 Int) ) (!  (=> (or (< x@@518 0) (>= x@@518 l@@512)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@512) x@@518) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@512) x@@518))
)))))) (forall ((inline$$Diem_CurrencyInfo_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$Diem_CurrencyInfo_pack$0$$$0@@0 0) (< inline$$Diem_CurrencyInfo_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| currency_code@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$Diem_CurrencyInfo_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$Diem_CurrencyInfo_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$Diem_CurrencyInfo_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) inline$$Diem_CurrencyInfo_pack$0$$$0@@0))
))) ((_ is $Boolean) inline$$Diem_register_currency_$def_verify$0$$t30@1)))) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0@@0) (let ((va@@513 (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)))
(let ((l@@513 (|l#$ValueArray| va@@513)))
 (and (and (<= 0 l@@513) (<= l@@513 $MAX_U64)) (forall ((x@@519 Int) ) (!  (=> (or (< x@@519 0) (>= x@@519 l@@513)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@513) x@@519) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@513) x@@519))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid)) (let ((va@@514 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))))
(let ((l@@514 (|l#$ValueArray| va@@514)))
 (and (and (<= 0 l@@514) (<= l@@514 $MAX_U64)) (forall ((x@@520 Int) ) (!  (=> (or (< x@@520 0) (>= x@@520 l@@514)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@514) x@@520) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@514) x@@520))
))))))) (forall (($$0@@173 Int) ) (!  (=> (and (>= $$0@@173 0) (< $$0@@173 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))) $$0@@173)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))) $$0@@173)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))) $$0@@173)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0@@0)) $Event_EventHandle_guid))) $$0@@173))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$1$res@0@@0) (let ((va@@515 (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)))
(let ((l@@515 (|l#$ValueArray| va@@515)))
 (and (and (<= 0 l@@515) (<= l@@515 $MAX_U64)) (forall ((x@@521 Int) ) (!  (=> (or (< x@@521 0) (>= x@@521 l@@515)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@515) x@@521) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@515) x@@521))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid)) (let ((va@@516 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))))
(let ((l@@516 (|l#$ValueArray| va@@516)))
 (and (and (<= 0 l@@516) (<= l@@516 $MAX_U64)) (forall ((x@@522 Int) ) (!  (=> (or (< x@@522 0) (>= x@@522 l@@516)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@516) x@@522) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@516) x@@522))
))))))) (forall (($$0@@174 Int) ) (!  (=> (and (>= $$0@@174 0) (< $$0@@174 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))) $$0@@174)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))) $$0@@174)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))) $$0@@174)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$1$res@0@@0)) $Event_EventHandle_guid))) $$0@@174))
))) true)) (=> (and (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$2$res@0@@0) (let ((va@@517 (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)))
(let ((l@@517 (|l#$ValueArray| va@@517)))
 (and (and (<= 0 l@@517) (<= l@@517 $MAX_U64)) (forall ((x@@523 Int) ) (!  (=> (or (< x@@523 0) (>= x@@523 l@@517)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@517) x@@523) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@517) x@@523))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid)) (let ((va@@518 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))))
(let ((l@@518 (|l#$ValueArray| va@@518)))
 (and (and (<= 0 l@@518) (<= l@@518 $MAX_U64)) (forall ((x@@524 Int) ) (!  (=> (or (< x@@524 0) (>= x@@524 l@@518)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@518) x@@524) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@518) x@@524))
))))))) (forall (($$0@@175 Int) ) (!  (=> (and (>= $$0@@175 0) (< $$0@@175 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))) $$0@@175)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))) $$0@@175)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))) $$0@@175)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$2$res@0@@0)) $Event_EventHandle_guid))) $$0@@175))
))) true) (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$3$res@0@@0) (let ((va@@519 (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)))
(let ((l@@519 (|l#$ValueArray| va@@519)))
 (and (and (<= 0 l@@519) (<= l@@519 $MAX_U64)) (forall ((x@@525 Int) ) (!  (=> (or (< x@@525 0) (>= x@@525 l@@519)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@519) x@@525) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@519) x@@525))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid)) (let ((va@@520 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))))
(let ((l@@520 (|l#$ValueArray| va@@520)))
 (and (and (<= 0 l@@520) (<= l@@520 $MAX_U64)) (forall ((x@@526 Int) ) (!  (=> (or (< x@@526 0) (>= x@@526 l@@520)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@520) x@@526) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@520) x@@526))
))))))) (forall (($$0@@176 Int) ) (!  (=> (and (>= $$0@@176 0) (< $$0@@176 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))) $$0@@176)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))) $$0@@176)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))) $$0@@176)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$3$res@0@@0)) $Event_EventHandle_guid))) $$0@@176))
))) true)) (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$4$res@0@@0) (let ((va@@521 (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)))
(let ((l@@521 (|l#$ValueArray| va@@521)))
 (and (and (<= 0 l@@521) (<= l@@521 $MAX_U64)) (forall ((x@@527 Int) ) (!  (=> (or (< x@@527 0) (>= x@@527 l@@521)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@521) x@@527) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@521) x@@527))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid)) (let ((va@@522 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))))
(let ((l@@522 (|l#$ValueArray| va@@522)))
 (and (and (<= 0 l@@522) (<= l@@522 $MAX_U64)) (forall ((x@@528 Int) ) (!  (=> (or (< x@@528 0) (>= x@@528 l@@522)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@522) x@@528) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@522) x@@528))
))))))) (forall (($$0@@177 Int) ) (!  (=> (and (>= $$0@@177 0) (< $$0@@177 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))) $$0@@177)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))) $$0@@177)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))) $$0@@177)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$4$res@0@@0)) $Event_EventHandle_guid))) $$0@@177))
))) true) (= inline$$Diem_CurrencyInfo_pack$0$$struct@1@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_register_currency_$def_verify$0$$t28@1) 1 inline$$Diem_register_currency_$def_verify$0$$t29@1) 2 to_xdx_exchange_rate@@0) 3 is_synthetic) 4 scaling_factor@@0) 5 fractional_part@@0) 6 currency_code@@0) 7 inline$$Diem_register_currency_$def_verify$0$$t30@1) 8 inline$$Event_new_event_handle$0$res@0@@0) 9 inline$$Event_new_event_handle$1$res@0@@0) 10 inline$$Event_new_event_handle$2$res@0@@0) 11 inline$$Event_new_event_handle$3$res@0@@0) 12 inline$$Event_new_event_handle$4$res@0@@0) 13))))) (and (=> (= (ControlFlow 0 322031) 322095) inline$$Diem_CurrencyInfo_pack$0$anon4_Then_correct@@0) (=> (= (ControlFlow 0 322031) 322039) inline$$Diem_CurrencyInfo_pack$0$anon4_Else_correct@@0))))))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon108_Else_correct  (=> (and (not $abort_flag@4@@16) (= (ControlFlow 0 322113) 322031)) inline$$Diem_CurrencyInfo_pack$0$anon0_correct@@0)))
(let ((inline$$Event_new_event_handle$4$Entry_correct@@0  (=> (= inline$$Event_new_event_handle$4$t@0@@0 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 321453) 325036) inline$$Diem_register_currency_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 321453) 322113) inline$$Diem_register_currency_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon106_Else_correct  (=> (and (not $abort_flag@4@@16) (= (ControlFlow 0 321461) 321453)) inline$$Event_new_event_handle$4$Entry_correct@@0)))
(let ((inline$$Event_new_event_handle$3$Entry_correct@@0  (=> (= inline$$Event_new_event_handle$3$t@0@@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 321411) 325056) inline$$Diem_register_currency_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 321411) 321461) inline$$Diem_register_currency_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon104_Else_correct  (=> (and (not $abort_flag@4@@16) (= (ControlFlow 0 321419) 321411)) inline$$Event_new_event_handle$3$Entry_correct@@0)))
(let ((inline$$Event_new_event_handle$2$Entry_correct@@0  (=> (= inline$$Event_new_event_handle$2$t@0@@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 321369) 325076) inline$$Diem_register_currency_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 321369) 321419) inline$$Diem_register_currency_$def_verify$0$anon104_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon102_Else_correct  (=> (and (not $abort_flag@4@@16) (= (ControlFlow 0 321377) 321369)) inline$$Event_new_event_handle$2$Entry_correct@@0)))
(let ((inline$$Event_new_event_handle$1$Entry_correct@@0  (=> (= inline$$Event_new_event_handle$1$t@0@@0 $Diem_BurnEvent_type_value) (and (=> (= (ControlFlow 0 321327) 325096) inline$$Diem_register_currency_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 321327) 321377) inline$$Diem_register_currency_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon100_Else_correct  (=> (and (not $abort_flag@4@@16) (= (ControlFlow 0 321335) 321327)) inline$$Event_new_event_handle$1$Entry_correct@@0)))
(let ((inline$$Event_new_event_handle$0$Entry_correct@@0  (=> (= inline$$Event_new_event_handle$0$t@0@@0 $Diem_MintEvent_type_value) (and (=> (= (ControlFlow 0 321285) 325116) inline$$Diem_register_currency_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 321285) 321335) inline$$Diem_register_currency_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon98_Then_correct  (=> (|b#$Boolean| |inline$$Diem_register_currency_$def_verify$0$tmp#$10@1|) (=> (and (and (= inline$$Diem_register_currency_$def_verify$0$$t28@1 ($Integer 0)) (= inline$$Diem_register_currency_$def_verify$0$$t29@1 ($Integer 0))) (and (= inline$$Diem_register_currency_$def_verify$0$$t30@1 ($Boolean true)) (= (ControlFlow 0 321293) 321285))) inline$$Event_new_event_handle$0$Entry_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon46_correct  (=> (= $abort_code@15@@7 $abort_code@7@@14) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 321233) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 321231) 321233)) inline$$Diem_register_currency_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon99_Then_correct  (=> (= (ControlFlow 0 321241) 321233) inline$$Diem_register_currency_$def_verify$0$anon46_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon98_Else_correct  (=> (and (not (|b#$Boolean| |inline$$Diem_register_currency_$def_verify$0$tmp#$10@1|)) (= $abort_code@7@@14 (|i#$Integer| call3formal@$ret0@0@@64))) (and (=> (= (ControlFlow 0 321225) 321241) inline$$Diem_register_currency_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 321225) 321231) inline$$Diem_register_currency_$def_verify$0$anon99_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon96_Else_correct  (=> (not $abort_flag@4@@16) (and (=> (= (ControlFlow 0 321213) 321293) inline$$Diem_register_currency_$def_verify$0$anon98_Then_correct) (=> (= (ControlFlow 0 321213) 321225) inline$$Diem_register_currency_$def_verify$0$anon98_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$L5_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def_verify$0$$t26@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@16)) (and (=> $abort_flag@4@@16 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@64 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@64) (>= (|i#$Integer| call3formal@$ret0@0@@64) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@64) $MAX_U64))) (and (=> (= (ControlFlow 0 321207) 325136) inline$$Diem_register_currency_$def_verify$0$anon96_Then_correct) (=> (= (ControlFlow 0 321207) 321213) inline$$Diem_register_currency_$def_verify$0$anon96_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon36_correct  (=> (and (= |inline$$Diem_register_currency_$def_verify$0$tmp#$10@1| inline$$Le$0$dst@1@@0) (= (ControlFlow 0 325242) 321207)) inline$$Diem_register_currency_$def_verify$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 325240) 325242)) inline$$Diem_register_currency_$def_verify$0$anon36_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon94_Then_correct  (=> (= (ControlFlow 0 325250) 325242) inline$$Diem_register_currency_$def_verify$0$anon36_correct)))
(let ((inline$$Le$0$anon0_correct@@0  (=> (= inline$$Le$0$dst@1@@0 ($Boolean (<= (|i#$Integer| scaling_factor@@0) (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t24@1)))) (and (=> (= (ControlFlow 0 325226) 325250) inline$$Diem_register_currency_$def_verify$0$anon94_Then_correct) (=> (= (ControlFlow 0 325226) 325240) inline$$Diem_register_currency_$def_verify$0$anon94_Else_correct)))))
(let ((inline$$Le$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 325212) (- 0 535478)) true) (=> (= (ControlFlow 0 325212) 325226) inline$$Le$0$anon0_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon93_Then_correct  (=> (|b#$Boolean| inline$$Lt$0$dst@1@@0) (=> (and (= inline$$Diem_register_currency_$def_verify$0$$t24@1 ($Integer 10000000000)) (= (ControlFlow 0 325232) 325212)) inline$$Le$0$Entry_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon38_correct  (=> (and (= |inline$$Diem_register_currency_$def_verify$0$tmp#$10@1| inline$$Diem_register_currency_$def_verify$0$$t25@1) (= (ControlFlow 0 321201) 321207)) inline$$Diem_register_currency_$def_verify$0$L5_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon95_Else_correct  (=> (and (not true) (= (ControlFlow 0 321199) 321201)) inline$$Diem_register_currency_$def_verify$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon95_Then_correct  (=> (= (ControlFlow 0 325160) 321201) inline$$Diem_register_currency_$def_verify$0$anon38_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon93_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1@@0)) (= inline$$Diem_register_currency_$def_verify$0$$t25@1 ($Boolean false))) (and (=> (= (ControlFlow 0 321191) 325160) inline$$Diem_register_currency_$def_verify$0$anon95_Then_correct) (=> (= (ControlFlow 0 321191) 321199) inline$$Diem_register_currency_$def_verify$0$anon95_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct@@0  (=> (= inline$$Lt$0$dst@1@@0 ($Boolean (< (|i#$Integer| inline$$Diem_register_currency_$def_verify$0$$t22@1) (|i#$Integer| scaling_factor@@0)))) (and (=> (= (ControlFlow 0 321139) 325232) inline$$Diem_register_currency_$def_verify$0$anon93_Then_correct) (=> (= (ControlFlow 0 321139) 321191) inline$$Diem_register_currency_$def_verify$0$anon93_Else_correct)))))
(let ((inline$$Lt$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 321125) (- 0 535403)) true) (=> (= (ControlFlow 0 321125) 321139) inline$$Lt$0$anon0_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon91_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1@@13) (=> (and (= inline$$Diem_register_currency_$def_verify$0$$t22@1 ($Integer 0)) (= (ControlFlow 0 321145) 321125)) inline$$Lt$0$Entry_correct@@0))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon32_correct  (=> (= $abort_code@15@@7 $abort_code@5@@16) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@10 $Diem_CurrencyInfo_$memory) (= $DiemConfig_Configuration_$memory@3@@0 $DiemConfig_Configuration_$memory)) (and (= $DiemConfig_DiemConfig_$memory@3@@1 $DiemConfig_DiemConfig_$memory) (= (ControlFlow 0 321057) 321065))) inline$$Diem_register_currency_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 321055) 321057)) inline$$Diem_register_currency_$def_verify$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon92_Then_correct  (=> (= (ControlFlow 0 321073) 321057) inline$$Diem_register_currency_$def_verify$0$anon32_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon91_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@13)) (= $abort_code@5@@16 (|i#$Integer| call3formal@$ret0@0@@65))) (and (=> (= (ControlFlow 0 321049) 321073) inline$$Diem_register_currency_$def_verify$0$anon92_Then_correct) (=> (= (ControlFlow 0 321049) 321055) inline$$Diem_register_currency_$def_verify$0$anon92_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon89_Else_correct  (=> (not $abort_flag@3@@18) (and (=> (= (ControlFlow 0 321037) 321145) inline$$Diem_register_currency_$def_verify$0$anon91_Then_correct) (=> (= (ControlFlow 0 321037) 321049) inline$$Diem_register_currency_$def_verify$0$anon91_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$Diem_register_currency_$def_verify$0$$t20@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@18)) (and (=> $abort_flag@3@@18 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@18) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@65 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@65) (>= (|i#$Integer| call3formal@$ret0@0@@65) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@65) $MAX_U64))) (and (=> (= (ControlFlow 0 321031) 325254) inline$$Diem_register_currency_$def_verify$0$anon89_Then_correct) (=> (= (ControlFlow 0 321031) 321037) inline$$Diem_register_currency_$def_verify$0$anon89_Else_correct)))))
(let ((inline$$Not$0$anon0_correct@@13  (=> (and (= inline$$Not$0$dst@1@@13 ($Boolean  (not (|b#$Boolean| inline$$Diem_register_currency_$def_verify$0$$t18@1)))) (= (ControlFlow 0 321019) 321031)) inline$$Diem_register_currency_$def_verify$0$anon87_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct@@13  (and (=> (= (ControlFlow 0 321009) (- 0 535273)) true) (=> (= (ControlFlow 0 321009) 321019) inline$$Not$0$anon0_correct@@13))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon87_Else_correct  (=> (not $abort_flag@2@@25) (=> (and (= inline$$Diem_register_currency_$def_verify$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@37) 1) (|a#$Address| call3formal@$ret0@0@@66)))) (= (ControlFlow 0 321025) 321009)) inline$$Not$0$Entry_correct@@13))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon85_Else_correct  (=> (not $abort_flag@1@@28) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@25) (=> $abort_flag@2@@25 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@2@@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@66 dr_account@@1)))) ((_ is $Address) call3formal@$ret0@0@@66))) (and (=> (= (ControlFlow 0 320951) 325274) inline$$Diem_register_currency_$def_verify$0$anon87_Then_correct) (=> (= (ControlFlow 0 320951) 321025) inline$$Diem_register_currency_$def_verify$0$anon87_Else_correct))))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon83_Else_correct  (=> (and (and (not $abort_flag@0@@29) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@1@@28)) (and (=> $abort_flag@1@@28 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816)))))) (=> $abort_flag@1@@28 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@2@@19 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 320945) 325294) inline$$Diem_register_currency_$def_verify$0$anon85_Then_correct) (=> (= (ControlFlow 0 320945) 320951) inline$$Diem_register_currency_$def_verify$0$anon85_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon12$6_correct  (=> (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@0@@29) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) $abort_flag@0@@29)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@0@@29) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) $abort_flag@0@@29)) (and (=> $abort_flag@0@@29 (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))))) (=> $abort_flag@0@@29 (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@1@@26 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1))))))) (= $abort_code@1@@26 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dr_account@@1)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@1@@26 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account@@1 ($Address 173345816))))) (= $abort_code@1@@26 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 320939) 325314) inline$$Diem_register_currency_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 320939) 320945) inline$$Diem_register_currency_$def_verify$0$anon83_Else_correct))))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 320733) 320939)) inline$$Diem_register_currency_$def_verify$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon82_Then_correct  (=> (= (ControlFlow 0 325338) 320939) inline$$Diem_register_currency_$def_verify$0$anon12$6_correct)))
(let ((inline$$Diem_register_currency_$def_verify$0$anon81_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320725) 325338) inline$$Diem_register_currency_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 320725) 320733) inline$$Diem_register_currency_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon81_Then_correct  (and (=> (= (ControlFlow 0 325346) 325338) inline$$Diem_register_currency_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 325346) 320733) inline$$Diem_register_currency_$def_verify$0$anon82_Else_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon80_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320717) 325346) inline$$Diem_register_currency_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 320717) 320725) inline$$Diem_register_currency_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon80_Then_correct  (and (=> (= (ControlFlow 0 325354) 325346) inline$$Diem_register_currency_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 325354) 320725) inline$$Diem_register_currency_$def_verify$0$anon81_Else_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon79_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320709) 325354) inline$$Diem_register_currency_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 320709) 320717) inline$$Diem_register_currency_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon79_Then_correct  (and (=> (= (ControlFlow 0 325362) 325354) inline$$Diem_register_currency_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 325362) 320717) inline$$Diem_register_currency_$def_verify$0$anon80_Else_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon78_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320701) 325362) inline$$Diem_register_currency_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 320701) 320709) inline$$Diem_register_currency_$def_verify$0$anon79_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon78_Then_correct  (and (=> (= (ControlFlow 0 325370) 325362) inline$$Diem_register_currency_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 325370) 320709) inline$$Diem_register_currency_$def_verify$0$anon79_Else_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 320693) 325370) inline$$Diem_register_currency_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 320693) 320701) inline$$Diem_register_currency_$def_verify$0$anon78_Else_correct)))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon77_Then_correct  (and (=> (= (ControlFlow 0 325378) 325370) inline$$Diem_register_currency_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 325378) 320701) inline$$Diem_register_currency_$def_verify$0$anon78_Else_correct))))
(let ((inline$$Diem_register_currency_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 320687) 325378) inline$$Diem_register_currency_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 320687) 320693) inline$$Diem_register_currency_$def_verify$0$anon77_Else_correct)))))
(let ((anon0$1_correct@@29  (=> (forall (($inv_addr@@69 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69)) (let ((va@@523 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))))
(let ((l@@523 (|l#$ValueArray| va@@523)))
 (and (and (<= 0 l@@523) (<= l@@523 $MAX_U64)) (forall ((x@@529 Int) ) (!  (=> (or (< x@@529 0) (>= x@@529 l@@523)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@523) x@@529) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@523) x@@529))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@69))
)) (=> (and (and (and (and (forall (($inv_addr@@70 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70)) (let ((va@@524 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))))
(let ((l@@524 (|l#$ValueArray| va@@524)))
 (and (and (<= 0 l@@524) (<= l@@524 $MAX_U64)) (forall ((x@@530 Int) ) (!  (=> (or (< x@@530 0) (>= x@@530 l@@524)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@524) x@@530) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@524) x@@530))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@70))
)) (forall (($inv_addr@@71 Int) ($inv_tv0@@56 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@56) 1) $inv_addr@@71)) (let ((va@@525 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@56) 1) $inv_addr@@71))))
(let ((l@@525 (|l#$ValueArray| va@@525)))
 (and (and (<= 0 l@@525) (<= l@@525 $MAX_U64)) (forall ((x@@531 Int) ) (!  (=> (or (< x@@531 0) (>= x@@531 l@@525)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@525) x@@531) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@525) x@@531))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@56) 1) $inv_addr@@71))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@56) 1) $inv_addr@@71))
))) (and (forall (($inv_addr@@72 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72)) (let ((va@@526 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))))
(let ((l@@526 (|l#$ValueArray| va@@526)))
 (and (and (<= 0 l@@526) (<= l@@526 $MAX_U64)) (forall ((x@@532 Int) ) (!  (=> (or (< x@@532 0) (>= x@@532 l@@526)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@526) x@@532) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@526) x@@532))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) 3)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_epoch)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_epoch)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_epoch)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_last_reconfiguration_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_last_reconfiguration_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_last_reconfiguration_time)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events)) (let ((va@@527 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))))
(let ((l@@527 (|l#$ValueArray| va@@527)))
 (and (and (<= 0 l@@527) (<= l@@527 $MAX_U64)) (forall ((x@@533 Int) ) (!  (=> (or (< x@@533 0) (>= x@@533 l@@527)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@527) x@@533) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@527) x@@533))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid)) (let ((va@@528 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))
(let ((l@@528 (|l#$ValueArray| va@@528)))
 (and (and (<= 0 l@@528) (<= l@@528 $MAX_U64)) (forall ((x@@534 Int) ) (!  (=> (or (< x@@534 0) (>= x@@534 l@@528)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@528) x@@534) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@528) x@@534))
))))))) (forall (($$0@@178 Int) ) (!  (=> (and (>= $$0@@178 0) (< $$0@@178 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@178)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@178)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@178)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))) $DiemConfig_Configuration_events))) $Event_EventHandle_guid))) $$0@@178))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray $inv_addr@@72))
)) (forall (($inv_addr@@73 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@73)) (let ((va@@529 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@73))))
(let ((l@@529 (|l#$ValueArray| va@@529)))
 (and (and (<= 0 l@@529) (<= l@@529 $MAX_U64)) (forall ((x@@535 Int) ) (!  (=> (or (< x@@535 0) (>= x@@535 l@@529)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@529) x@@535) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@529) x@@535))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@73))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@73))) $DiemConfig_DisableReconfiguration_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DisableReconfiguration_$memory) $EmptyTypeValueArray $inv_addr@@73))
)))) (and (and (forall (($inv_addr@@74 Int) ($inv_tv0@@57 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@57) 1) $inv_addr@@74)) (let ((va@@530 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@57) 1) $inv_addr@@74))))
(let ((l@@530 (|l#$ValueArray| va@@530)))
 (and (and (<= 0 l@@530) (<= l@@530 $MAX_U64)) (forall ((x@@536 Int) ) (!  (=> (or (< x@@536 0) (>= x@@536 l@@530)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@530) x@@536) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@530) x@@536))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@57) 1) $inv_addr@@74))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@57) 1) $inv_addr@@74))) $DiemConfig_ModifyConfigCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_ModifyConfigCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@57) 1) $inv_addr@@74))
)) (forall (($inv_addr@@75 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75)) (let ((va@@531 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))))
(let ((l@@531 (|l#$ValueArray| va@@531)))
 (and (and (<= 0 l@@531) (<= l@@531 $MAX_U64)) (forall ((x@@537 Int) ) (!  (=> (or (< x@@537 0) (>= x@@537 l@@531)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@531) x@@537) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@531) x@@537))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes)) (let ((va@@532 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))
(let ((l@@532 (|l#$ValueArray| va@@532)))
 (and (and (<= 0 l@@532) (<= l@@532 $MAX_U64)) (forall ((x@@538 Int) ) (!  (=> (or (< x@@538 0) (>= x@@538 l@@532)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@532) x@@538) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@532) x@@538))
))))))) (forall (($$0@@179 Int) ) (!  (=> (and (>= $$0@@179 0) (< $$0@@179 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))))) (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179)) (let ((va@@533 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))))
(let ((l@@533 (|l#$ValueArray| va@@533)))
 (and (and (<= 0 l@@533) (<= l@@533 $MAX_U64)) (forall ((x@@539 Int) ) (!  (=> (or (< x@@539 0) (>= x@@539 l@@533)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@533) x@@539) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@533) x@@539))
)))))) (forall (($$1@@0 Int) ) (!  (=> (and (>= $$1@@0 0) (< $$1@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))) $$1@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))) $$1@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))) $$1@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))) $$1@@0))
)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))) $RegisteredCurrencies_RegisteredCurrencies_currency_codes))) $$0@@179))
))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $RegisteredCurrencies_RegisteredCurrencies_$memory) $EmptyTypeValueArray $inv_addr@@75))
))) (and (forall (($inv_addr@@76 Int) ($inv_tv0@@58 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76)) (let ((va@@534 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))))
(let ((l@@534 (|l#$ValueArray| va@@534)))
 (and (and (<= 0 l@@534) (<= l@@534 $MAX_U64)) (forall ((x@@540 Int) ) (!  (=> (or (< x@@540 0) (>= x@@540 l@@534)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@534) x@@540) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@534) x@@540))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@535 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@535 (|l#$ValueArray| va@@535)))
 (and (and (<= 0 l@@535) (<= l@@535 $MAX_U64)) (forall ((x@@541 Int) ) (!  (=> (or (< x@@541 0) (>= x@@541 l@@535)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@535) x@@541) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@535) x@@541))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code)) (let ((va@@536 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@536 (|l#$ValueArray| va@@536)))
 (and (and (<= 0 l@@536) (<= l@@536 $MAX_U64)) (forall ((x@@542 Int) ) (!  (=> (or (< x@@542 0) (>= x@@542 l@@536)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@536) x@@542) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@536) x@@542))
))))))) (forall (($$0@@180 Int) ) (!  (=> (and (>= $$0@@180 0) (< $$0@@180 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))) $$0@@180)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))) $$0@@180)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))) $$0@@180)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_currency_code))) $$0@@180))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events)) (let ((va@@537 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@537 (|l#$ValueArray| va@@537)))
 (and (and (<= 0 l@@537) (<= l@@537 $MAX_U64)) (forall ((x@@543 Int) ) (!  (=> (or (< x@@543 0) (>= x@@543 l@@537)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@537) x@@543) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@537) x@@543))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@538 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@538 (|l#$ValueArray| va@@538)))
 (and (and (<= 0 l@@538) (<= l@@538 $MAX_U64)) (forall ((x@@544 Int) ) (!  (=> (or (< x@@544 0) (>= x@@544 l@@538)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@538) x@@544) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@538) x@@544))
))))))) (forall (($$0@@181 Int) ) (!  (=> (and (>= $$0@@181 0) (< $$0@@181 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@181)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@181)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@181)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@181))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events)) (let ((va@@539 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@539 (|l#$ValueArray| va@@539)))
 (and (and (<= 0 l@@539) (<= l@@539 $MAX_U64)) (forall ((x@@545 Int) ) (!  (=> (or (< x@@545 0) (>= x@@545 l@@539)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@539) x@@545) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@539) x@@545))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@540 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@540 (|l#$ValueArray| va@@540)))
 (and (and (<= 0 l@@540) (<= l@@540 $MAX_U64)) (forall ((x@@546 Int) ) (!  (=> (or (< x@@546 0) (>= x@@546 l@@540)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@540) x@@546) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@540) x@@546))
))))))) (forall (($$0@@182 Int) ) (!  (=> (and (>= $$0@@182 0) (< $$0@@182 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@182)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@182)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@182)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@182))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@541 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@541 (|l#$ValueArray| va@@541)))
 (and (and (<= 0 l@@541) (<= l@@541 $MAX_U64)) (forall ((x@@547 Int) ) (!  (=> (or (< x@@547 0) (>= x@@547 l@@541)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@541) x@@547) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@541) x@@547))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@542 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@542 (|l#$ValueArray| va@@542)))
 (and (and (<= 0 l@@542) (<= l@@542 $MAX_U64)) (forall ((x@@548 Int) ) (!  (=> (or (< x@@548 0) (>= x@@548 l@@542)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@542) x@@548) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@542) x@@548))
))))))) (forall (($$0@@183 Int) ) (!  (=> (and (>= $$0@@183 0) (< $$0@@183 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@183)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@183)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@183)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@183))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@543 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@543 (|l#$ValueArray| va@@543)))
 (and (and (<= 0 l@@543) (<= l@@543 $MAX_U64)) (forall ((x@@549 Int) ) (!  (=> (or (< x@@549 0) (>= x@@549 l@@543)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@543) x@@549) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@543) x@@549))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@544 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@544 (|l#$ValueArray| va@@544)))
 (and (and (<= 0 l@@544) (<= l@@544 $MAX_U64)) (forall ((x@@550 Int) ) (!  (=> (or (< x@@550 0) (>= x@@550 l@@544)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@544) x@@550) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@544) x@@550))
))))))) (forall (($$0@@184 Int) ) (!  (=> (and (>= $$0@@184 0) (< $$0@@184 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@184)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@184)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@184)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@184))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@545 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@545 (|l#$ValueArray| va@@545)))
 (and (and (<= 0 l@@545) (<= l@@545 $MAX_U64)) (forall ((x@@551 Int) ) (!  (=> (or (< x@@551 0) (>= x@@551 l@@545)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@545) x@@551) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@545) x@@551))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@546 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@546 (|l#$ValueArray| va@@546)))
 (and (and (<= 0 l@@546) (<= l@@546 $MAX_U64)) (forall ((x@@552 Int) ) (!  (=> (or (< x@@552 0) (>= x@@552 l@@546)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@546) x@@552) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@546) x@@552))
))))))) (forall (($$0@@185 Int) ) (!  (=> (and (>= $$0@@185 0) (< $$0@@185 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@185)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@185)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@185)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@185))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@58) 1) $inv_addr@@76))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((config_address@@1 T@$Value) )  (=> ((_ is $Address) config_address@@1) (|b#$Boolean| ($Boolean (forall ((config_type@@1 T@$Value) )  (=> ((_ is $Type) config_type@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type@@1)) 1) (|a#$Address| config_address@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address@@1 ($Address 173345816)))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@53 T@$Value) )  (=> ((_ is $Type) coin_type@@53) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@6 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@53)) 1) (|a#$Address| mint_cap_owner@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@6)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@54 T@$Value) )  (=> ((_ is $Type) coin_type@@54) (|b#$Boolean| ($Boolean (forall ((addr3@@25 T@$Value) )  (=> ((_ is $Address) addr3@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@54)) 1) (|a#$Address| addr3@@25)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@54)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@54)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@55 T@$Value) )  (=> ((_ is $Type) coin_type@@55) (|b#$Boolean| ($Boolean (forall ((addr1@@20 T@$Value) )  (=> ((_ is $Address) addr1@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@55)) 1) (|a#$Address| addr1@@20)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@20)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@20)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@56 T@$Value) )  (=> ((_ is $Type) coin_type@@56) (|b#$Boolean| ($Boolean (forall ((addr1@@21 T@$Value) )  (=> ((_ is $Address) addr1@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@56)) 1) (|a#$Address| addr1@@21)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@21)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 325386) 320687))))) inline$$Diem_register_currency_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@30  (=> ((_ is $Address) dr_account@@1) (=> (and (and (and (and (and (and ((_ is $Vector) to_xdx_exchange_rate@@0) (let ((va@@547 (|v#$Vector| to_xdx_exchange_rate@@0)))
(let ((l@@547 (|l#$ValueArray| va@@547)))
 (and (and (<= 0 l@@547) (<= l@@547 $MAX_U64)) (forall ((x@@553 Int) ) (!  (=> (or (< x@@553 0) (>= x@@553 l@@547)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@547) x@@553) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@547) x@@553))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_xdx_exchange_rate@@0)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) ((_ is $Boolean) is_synthetic)) (and (and (and (and ((_ is $Integer) scaling_factor@@0) (>= (|i#$Integer| scaling_factor@@0) 0)) (<= (|i#$Integer| scaling_factor@@0) $MAX_U64)) (and (and ((_ is $Integer) fractional_part@@0) (>= (|i#$Integer| fractional_part@@0) 0)) (<= (|i#$Integer| fractional_part@@0) $MAX_U64))) (and (and (and ((_ is $Vector) currency_code@@0) (let ((va@@548 (|v#$Vector| currency_code@@0)))
(let ((l@@548 (|l#$ValueArray| va@@548)))
 (and (and (<= 0 l@@548) (<= l@@548 $MAX_U64)) (forall ((x@@554 Int) ) (!  (=> (or (< x@@554 0) (>= x@@554 l@@548)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@548) x@@554) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@548) x@@554))
)))))) (forall (($$0@@186 Int) ) (!  (=> (and (>= $$0@@186 0) (< $$0@@186 (|l#$ValueArray| (|v#$Vector| currency_code@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) $$0@@186)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) $$0@@186)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) $$0@@186)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| currency_code@@0)) $$0@@186))
))) (= (ControlFlow 0 318338) 325386)))) anon0$1_correct@@29))))
(let ((PreconditionGeneratedEntry_correct@@20  (=> (= (ControlFlow 0 529944) 318338) anon0_correct@@30)))
PreconditionGeneratedEntry_correct@@20)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@38 () T@$TypeValue)
(declare-fun account@@4 () T@$Value)
(declare-fun $abort_flag@3@@19 () Bool)
(declare-fun $abort_code@6@@16 () Int)
(declare-fun $Diem_BurnCapability_$memory@1@@1 () T@$Memory)
(declare-fun |inline$$MoveFrom$0$m'@2| () T@$Memory)
(declare-fun $abort_code@4@@20 () Int)
(declare-fun $abort_flag@2@@26 () Bool)
(declare-fun inline$$Diem_remove_burn_capability_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $Diem_BurnCapability_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@5@@17 () Int)
(declare-fun $abort_code@1@@27 () Int)
(declare-fun $abort_flag@0@@30 () Bool)
(declare-fun $abort_code@2@@20 () Int)
(declare-fun $abort_flag@1@@29 () Bool)
(declare-fun |inline$$MoveFrom$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveFrom$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveFrom$0$a@1 () Int)
(declare-fun inline$$MoveFrom$0$dst@1 () T@$Value)
(declare-fun |inline$$MoveFrom$0$m'@1| () T@$Memory)
(declare-fun call3formal@$ret0@0@@67 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def_verify$0$$t5@1 () T@$Value)
(declare-fun $abort_code@3@@21 () Int)
(declare-fun call3formal@$ret0@0@@68 () T@$Value)
(declare-fun inline$$Diem_remove_burn_capability_$def_verify$0$$t6@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 540565) (let ((anon0$2_correct@@31  (and (=> (= (ControlFlow 0 327388) (- 0 542224)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4))))))) $abort_flag@3@@19)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4))))))) $abort_flag@3@@19) (and (=> (= (ControlFlow 0 327388) (- 0 542256)) (=> $abort_flag@3@@19 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4))))))))) (=> (=> $abort_flag@3@@19 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4)))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542288)) (=> $abort_flag@3@@19 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4))))))) (= $abort_code@6@@16 (|i#$Integer| ($Integer 4)))))) (=> (=> $abort_flag@3@@19 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| account@@4))))))) (= $abort_code@6@@16 (|i#$Integer| ($Integer 4))))) (and (=> (= (ControlFlow 0 327388) (- 0 542331)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542380)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@499 T@$Value) )  (=> ((_ is $Address) addr@@499) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@499))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@499)))))))))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@500 T@$Value) )  (=> ((_ is $Address) addr@@500) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@500))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@500))))))))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542460)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@501 T@$Value) )  (=> ((_ is $Address) addr@@501) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@501)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@501))))))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@502 T@$Value) )  (=> ((_ is $Address) addr@@502) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@502)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@502)))))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542528)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542577)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@503 T@$Value) )  (=> ((_ is $Address) addr@@503) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@503))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@503)))))))))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@504 T@$Value) )  (=> ((_ is $Address) addr@@504) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@504))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@504))))))))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542655)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542704)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542753)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@505 T@$Value) )  (=> ((_ is $Address) addr@@505) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@505))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@505)))))))))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@506 T@$Value) )  (=> ((_ is $Address) addr@@506) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@506))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@506))))))))))))))) (and (=> (= (ControlFlow 0 327388) (- 0 542833)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@507 T@$Value) )  (=> ((_ is $Address) addr@@507) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@507)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@507))))))))))))) (=> (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean (forall ((addr@@508 T@$Value) )  (=> ((_ is $Address) addr@@508) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@508)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| addr@@508)))))))))))) (=> (= (ControlFlow 0 327388) (- 0 542901)) (=> (not $abort_flag@3@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon20_correct  (=> (and (and (= $Diem_BurnCapability_$memory@1@@1 |inline$$MoveFrom$0$m'@2|) (= $abort_code@6@@16 $abort_code@4@@20)) (and (= $abort_flag@3@@19 $abort_flag@2@@26) (= (ControlFlow 0 327304) 327388))) anon0$2_correct@@31)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 327302) 327304)) inline$$Diem_remove_burn_capability_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 327312) 327304) inline$$Diem_remove_burn_capability_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Else_correct  (=> (not $abort_flag@2@@26) (and (=> (= (ControlFlow 0 327296) (- 0 542041)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_remove_burn_capability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_remove_burn_capability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_remove_burn_capability_$def_verify$0$addr1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_remove_burn_capability_$def_verify$0$addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_remove_burn_capability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_remove_burn_capability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_remove_burn_capability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_remove_burn_capability_$def_verify$0$addr1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_remove_burn_capability_$def_verify$0$addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveFrom$0$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_remove_burn_capability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$Diem_remove_burn_capability_$def_verify$0$addr1@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (and (=> (= (ControlFlow 0 327296) 327312) inline$$Diem_remove_burn_capability_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 327296) 327302) inline$$Diem_remove_burn_capability_$def_verify$0$anon30_Else_correct)))))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$Abort_correct  (=> (= inline$$Diem_remove_burn_capability_$def_verify$0$$ret0@1 $Error) (=> (and (and (= $Diem_BurnCapability_$memory@1@@1 $Diem_BurnCapability_$memory@0@@1) (= $abort_code@6@@16 $abort_code@5@@17)) (and (= $abort_flag@3@@19 true) (= (ControlFlow 0 326964) 327388))) anon0$2_correct@@31))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon5_correct  (=> (= $Diem_BurnCapability_$memory@0@@1 $Diem_BurnCapability_$memory) (=> (and (= $abort_code@5@@17 $abort_code@1@@27) (= (ControlFlow 0 327364) 326964)) inline$$Diem_remove_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 327362) 327364)) inline$$Diem_remove_burn_capability_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 327372) 327364) inline$$Diem_remove_burn_capability_$def_verify$0$anon5_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0@@30 (and (=> (= (ControlFlow 0 327356) 327372) inline$$Diem_remove_burn_capability_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 327356) 327362) inline$$Diem_remove_burn_capability_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon9_correct  (=> (= $Diem_BurnCapability_$memory@0@@1 $Diem_BurnCapability_$memory) (=> (and (= $abort_code@5@@17 $abort_code@2@@20) (= (ControlFlow 0 327344) 326964)) inline$$Diem_remove_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 327342) 327344)) inline$$Diem_remove_burn_capability_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 327352) 327344) inline$$Diem_remove_burn_capability_$def_verify$0$anon9_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1@@29 (and (=> (= (ControlFlow 0 327336) 327352) inline$$Diem_remove_burn_capability_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 327336) 327342) inline$$Diem_remove_burn_capability_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon17_correct  (=> (= $Diem_BurnCapability_$memory@0@@1 |inline$$MoveFrom$0$m'@2|) (=> (and (= $abort_code@5@@17 $abort_code@4@@20) (= (ControlFlow 0 327324) 326964)) inline$$Diem_remove_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 327322) 327324)) inline$$Diem_remove_burn_capability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 327332) 327324) inline$$Diem_remove_burn_capability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Then_correct  (=> $abort_flag@2@@26 (and (=> (= (ControlFlow 0 327316) 327332) inline$$Diem_remove_burn_capability_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 327316) 327322) inline$$Diem_remove_burn_capability_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$MoveFrom$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@26 true) (=> (and (= $abort_code@4@@20 $EXEC_FAILURE_CODE) (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@0|)) (and (=> (= (ControlFlow 0 327214) 327316) inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 327214) 327296) inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$MoveFrom$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1)) (= (ControlFlow 0 327212) 327214)) inline$$MoveFrom$0$anon3_Then$1_correct)))
(let ((inline$$MoveFrom$0$anon3_Else_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1) (= inline$$MoveFrom$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1))) (=> (and (and (= |inline$$MoveFrom$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 false) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$MoveFrom$0$ta@0 inline$$MoveFrom$0$a@1 $Error))) (= $abort_flag@2@@26 $abort_flag@1@@29)) (and (= $abort_code@4@@20 $abort_code@2@@20) (= |inline$$MoveFrom$0$m'@2| |inline$$MoveFrom$0$m'@1|))) (and (=> (= (ControlFlow 0 327160) 327316) inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 327160) 327296) inline$$Diem_remove_burn_capability_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$MoveFrom$0$anon0_correct  (=> (= inline$$MoveFrom$0$a@1 (|a#$Address| call3formal@$ret0@0@@67)) (and (=> (= (ControlFlow 0 327114) 327212) inline$$MoveFrom$0$anon3_Then_correct) (=> (= (ControlFlow 0 327114) 327160) inline$$MoveFrom$0$anon3_Else_correct)))))
(let ((inline$$MoveFrom$0$Entry_correct  (=> (= inline$$MoveFrom$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1)) (and (=> (= (ControlFlow 0 327108) (- 0 541920)) true) (=> (= (ControlFlow 0 327108) 327114) inline$$MoveFrom$0$anon0_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon26_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_remove_burn_capability_$def_verify$0$$t5@1) (= (ControlFlow 0 327222) 327108)) inline$$MoveFrom$0$Entry_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon14_correct  (=> (= $Diem_BurnCapability_$memory@0@@1 $Diem_BurnCapability_$memory) (=> (and (= $abort_code@5@@17 $abort_code@3@@21) (= (ControlFlow 0 326958) 326964)) inline$$Diem_remove_burn_capability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon27_Else_correct  (=> (and (not true) (= (ControlFlow 0 326956) 326958)) inline$$Diem_remove_burn_capability_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon27_Then_correct  (=> (= (ControlFlow 0 326972) 326958) inline$$Diem_remove_burn_capability_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon26_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_remove_burn_capability_$def_verify$0$$t5@1)) (= $abort_code@3@@21 (|i#$Integer| call3formal@$ret0@0@@68))) (and (=> (= (ControlFlow 0 326950) 326972) inline$$Diem_remove_burn_capability_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 326950) 326956) inline$$Diem_remove_burn_capability_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon24_Else_correct  (=> (not $abort_flag@1@@29) (and (=> (= (ControlFlow 0 326938) 327222) inline$$Diem_remove_burn_capability_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 326938) 326950) inline$$Diem_remove_burn_capability_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon22_Else_correct  (=> (and (not $abort_flag@0@@30) (= inline$$Diem_remove_burn_capability_$def_verify$0$$t5@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@38) 1) (|a#$Address| call3formal@$ret0@0@@67))))) (=> (and (and (and (= inline$$Diem_remove_burn_capability_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@29)) (and (=> $abort_flag@1@@29 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@29) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@68 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@68) (>= (|i#$Integer| call3formal@$ret0@0@@68) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@68) $MAX_U64))) (and (=> (= (ControlFlow 0 326932) 327336) inline$$Diem_remove_burn_capability_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 326932) 326938) inline$$Diem_remove_burn_capability_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon2$1_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@30) (=> $abort_flag@0@@30 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@67 account@@4)))) ((_ is $Address) call3formal@$ret0@0@@67))) (and (=> (= (ControlFlow 0 326902) 327356) inline$$Diem_remove_burn_capability_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 326902) 326932) inline$$Diem_remove_burn_capability_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 326866) 326902)) inline$$Diem_remove_burn_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 327380) 326902) inline$$Diem_remove_burn_capability_$def_verify$0$anon2$1_correct)))
(let ((inline$$Diem_remove_burn_capability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 326860) 327380) inline$$Diem_remove_burn_capability_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 326860) 326866) inline$$Diem_remove_burn_capability_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@30  (=> (forall (($inv_addr@@77 Int) ($inv_tv0@@59 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@59) 1) $inv_addr@@77)) (let ((va@@549 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@59) 1) $inv_addr@@77))))
(let ((l@@549 (|l#$ValueArray| va@@549)))
 (and (and (<= 0 l@@549) (<= l@@549 $MAX_U64)) (forall ((x@@555 Int) ) (!  (=> (or (< x@@555 0) (>= x@@555 l@@549)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@549) x@@555) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@549) x@@555))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@59) 1) $inv_addr@@77))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@59) 1) $inv_addr@@77))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@59) 1) $inv_addr@@77))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@57 T@$Value) )  (=> ((_ is $Type) coin_type@@57) (|b#$Boolean| ($Boolean (forall ((addr1@@22 T@$Value) )  (=> ((_ is $Address) addr1@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@57)) 1) (|a#$Address| addr1@@22)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@22)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@22)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (= (ControlFlow 0 327386) 326860)) inline$$Diem_remove_burn_capability_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@31  (=> (and ((_ is $Address) account@@4) (= (ControlFlow 0 326300) 327386)) anon0$1_correct@@30)))
(let ((PreconditionGeneratedEntry_correct@@21  (=> (= (ControlFlow 0 540565) 326300) anon0_correct@@31)))
PreconditionGeneratedEntry_correct@@21))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin@@6 () T@$Value)
(declare-fun amount () T@$Value)
(declare-fun $abort_flag@1@@30 () Bool)
(declare-fun $abort_code@1@@28 () Int)
(declare-fun inline$$Diem_split_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_split_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun $tv0@@39 () T@$TypeValue)
(declare-fun inline$$Diem_split_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_split_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@31 () Bool)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@7| () T@$Value)
(declare-fun call5formal@$ret0@0@@3 () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@12| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@9| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@9 () T@$Mutation)
(declare-fun call6formal@$ret1@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@12 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 542954) (let ((anon0$2_correct@@32  (and (=> (= (ControlFlow 0 328412) (- 0 545921)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@1@@30)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@1@@30) (and (=> (= (ControlFlow 0 328412) (- 0 545942)) (=> $abort_flag@1@@30 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))))) (=> (=> $abort_flag@1@@30 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount))))) (and (=> (= (ControlFlow 0 328412) (- 0 545963)) (=> $abort_flag@1@@30 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@1@@28 (|i#$Integer| ($Integer 8)))))) (=> (=> $abort_flag@1@@30 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@1@@28 (|i#$Integer| ($Integer 8))))) (and (=> (= (ControlFlow 0 328412) (- 0 545995)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_split_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount)))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_split_$def_verify$0$$ret0@2)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (|i#$Integer| amount))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546027)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_split_$def_verify$0$$ret1@2)) $Diem_Diem_value) amount))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_split_$def_verify$0$$ret1@2)) $Diem_Diem_value) amount)))) (and (=> (= (ControlFlow 0 328412) (- 0 546045)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546094)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@509 T@$Value) )  (=> ((_ is $Address) addr@@509) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@509))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@509)))))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@510 T@$Value) )  (=> ((_ is $Address) addr@@510) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@510))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@510))))))))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546174)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@511 T@$Value) )  (=> ((_ is $Address) addr@@511) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@511)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@511))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@512 T@$Value) )  (=> ((_ is $Address) addr@@512) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@512)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@512)))))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546242)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546291)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@513 T@$Value) )  (=> ((_ is $Address) addr@@513) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@513))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@513)))))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@514 T@$Value) )  (=> ((_ is $Address) addr@@514) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@514))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@514))))))))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546371)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@515 T@$Value) )  (=> ((_ is $Address) addr@@515) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@515)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@515))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@516 T@$Value) )  (=> ((_ is $Address) addr@@516) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@516)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@516)))))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546439)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546488)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546537)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@517 T@$Value) )  (=> ((_ is $Address) addr@@517) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@517))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@517)))))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@518 T@$Value) )  (=> ((_ is $Address) addr@@518) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@518))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@518))))))))))))))) (and (=> (= (ControlFlow 0 328412) (- 0 546617)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@519 T@$Value) )  (=> ((_ is $Address) addr@@519) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@519)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@519))))))))))))) (=> (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean (forall ((addr@@520 T@$Value) )  (=> ((_ is $Address) addr@@520) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@520)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@520)))))))))))) (=> (= (ControlFlow 0 328412) (- 0 546685)) (=> (not $abort_flag@1@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_split_$def_verify$0$anon7_correct  (=> (and (= inline$$Diem_split_$def_verify$0$$ret0@1 $Error) (= inline$$Diem_split_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@1@@30 true) (= inline$$Diem_split_$def_verify$0$$ret0@2 inline$$Diem_split_$def_verify$0$$ret0@1)) (and (= inline$$Diem_split_$def_verify$0$$ret1@2 inline$$Diem_split_$def_verify$0$$ret1@1) (= (ControlFlow 0 328378) 328412))) anon0$2_correct@@32))))
(let ((inline$$Diem_split_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 328370) 328378)) inline$$Diem_split_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_split_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 328386) 328378) inline$$Diem_split_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_split_$def_verify$0$anon17_Then_correct  (=> $abort_flag@0@@31 (and (=> (= (ControlFlow 0 328364) 328386) inline$$Diem_split_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 328364) 328370) inline$$Diem_split_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_split_$def_verify$0$anon14_correct  (=> (and (and (= $abort_flag@1@@30 $abort_flag@0@@31) (= inline$$Diem_split_$def_verify$0$$ret0@2 |inline$$WritebackToValue$0$vdst'@2@@7|)) (and (= inline$$Diem_split_$def_verify$0$$ret1@2 call5formal@$ret0@0@@3) (= (ControlFlow 0 328336) 328412))) anon0$2_correct@@32)))
(let ((inline$$Diem_split_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 328334) 328336)) inline$$Diem_split_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_split_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 328344) 328336) inline$$Diem_split_$def_verify$0$anon14_correct)))
(let ((inline$$Diem_split_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 328324) 328344) inline$$Diem_split_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 328324) 328334) inline$$Diem_split_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$Diem_split_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 328352) 328344) inline$$Diem_split_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 328352) 328334) inline$$Diem_split_$def_verify$0$anon21_Else_correct))))
(let ((inline$$Diem_split_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 328314) 328352) inline$$Diem_split_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 328314) 328324) inline$$Diem_split_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$Diem_split_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 328360) 328352) inline$$Diem_split_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 328360) 328324) inline$$Diem_split_$def_verify$0$anon20_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@9  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@12|) ($Local 3))) (= |inline$$WritebackToValue$0$vdst'@2@@7| coin@@6)) (and (=> (= (ControlFlow 0 328240) 328360) inline$$Diem_split_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 328240) 328314) inline$$Diem_split_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@9  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@12|) ($Local 3)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@9| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@12|) 0 coin@@6 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@12|))) (= |inline$$WritebackToValue$0$vdst'@2@@7| |inline$$WritebackToValue$0$vdst'@1@@9|)) (and (=> (= (ControlFlow 0 328266) 328360) inline$$Diem_split_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 328266) 328314) inline$$Diem_split_$def_verify$0$anon19_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@12  (=> (= |inline$$WriteRef$0$to'@1@@12| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@9) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@9) call6formal@$ret1@0)) (and (=> (= (ControlFlow 0 328141) 328266) inline$$WritebackToValue$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 328141) 328240) inline$$WritebackToValue$0$anon3_Else_correct@@9)))))
(let ((inline$$Diem_split_$def_verify$0$anon17_Else_correct  (=> (and (not $abort_flag@0@@31) (= (ControlFlow 0 328147) 328141)) inline$$WriteRef$0$anon0_correct@@12)))
(let ((inline$$Diem_split_$def_verify$0$anon4$4_correct  (and (=> (= (ControlFlow 0 328084) (- 0 544922)) true) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12)) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@0@@31) (=> $abort_flag@0@@31 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12)) $Diem_Diem_value)) (|i#$Integer| amount)))))) (and (=> $abort_flag@0@@31 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12)) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@1@@28 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@12)) $Diem_Diem_value)) (|i#$Integer| amount))))))))) (and (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@3)) $Diem_Diem_value) amount)))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@521 T@$Value) )  (=> ((_ is $Address) addr@@521) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@521))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@521))))))))))))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@522 T@$Value) )  (=> ((_ is $Address) addr@@522) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@522)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@522))))))))))))))) (and (and (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@523 T@$Value) )  (=> ((_ is $Address) addr@@523) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@523))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@523)))))))))))))))) (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@524 T@$Value) )  (=> ((_ is $Address) addr@@524) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@524)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@524)))))))))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@525 T@$Value) )  (=> ((_ is $Address) addr@@525) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@525))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@525)))))))))))))))) (and (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean (forall ((addr@@526 T@$Value) )  (=> ((_ is $Address) addr@@526) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@526)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| addr@@526)))))))))))) (=> (not $abort_flag@0@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@39) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@3) (let ((va@@550 (|v#$Vector| call5formal@$ret0@0@@3)))
(let ((l@@550 (|l#$ValueArray| va@@550)))
 (and (and (<= 0 l@@550) (<= l@@550 $MAX_U64)) (forall ((x@@556 Int) ) (!  (=> (or (< x@@556 0) (>= x@@556 l@@550)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@550) x@@556) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@550) x@@556))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@3)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@3)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@3)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@3)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call6formal@$ret1@0) (let ((va@@551 (|v#$Vector| call6formal@$ret1@0)))
(let ((l@@551 (|l#$ValueArray| va@@551)))
 (and (and (<= 0 l@@551) (<= l@@551 $MAX_U64)) (forall ((x@@557 Int) ) (!  (=> (or (< x@@557 0) (>= x@@557 l@@551)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@551) x@@557) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@551) x@@557))
)))))) (= (|l#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 328084) 328364) inline$$Diem_split_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 328084) 328147) inline$$Diem_split_$def_verify$0$anon17_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct@@12  (=> (and (= inline$$ReadRef$0$v@1@@12 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@9)) (= (ControlFlow 0 328072) 328084)) inline$$Diem_split_$def_verify$0$anon4$4_correct)))
(let ((inline$$BorrowLoc$0$anon0_correct@@9  (=> (and (= inline$$BorrowLoc$0$dst@1@@9 ($Mutation ($Local 3) $EmptyPath coin@@6)) (= (ControlFlow 0 328034) 328072)) inline$$ReadRef$0$anon0_correct@@12)))
(let ((inline$$Diem_split_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 327916) 328034)) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$Diem_split_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 328394) 328034) inline$$BorrowLoc$0$anon0_correct@@9)))
(let ((inline$$Diem_split_$def_verify$0$anon15_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 327908) 328394) inline$$Diem_split_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 327908) 327916) inline$$Diem_split_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_split_$def_verify$0$anon15_Then_correct  (and (=> (= (ControlFlow 0 328402) 328394) inline$$Diem_split_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 328402) 327916) inline$$Diem_split_$def_verify$0$anon16_Else_correct))))
(let ((inline$$Diem_split_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 327902) 328402) inline$$Diem_split_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 327902) 327908) inline$$Diem_split_$def_verify$0$anon15_Else_correct)))))
(let ((anon0$1_correct@@31  (=> (and (forall (($inv_addr@@78 Int) ($inv_tv0@@60 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78)) (let ((va@@552 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))))
(let ((l@@552 (|l#$ValueArray| va@@552)))
 (and (and (<= 0 l@@552) (<= l@@552 $MAX_U64)) (forall ((x@@558 Int) ) (!  (=> (or (< x@@558 0) (>= x@@558 l@@552)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@552) x@@558) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@552) x@@558))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@60) 1) $inv_addr@@78))
)) (= (ControlFlow 0 328410) 327902)) inline$$Diem_split_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@32  (=> (and (and (and (and (and ((_ is $Vector) coin@@6) (let ((va@@553 (|v#$Vector| coin@@6)))
(let ((l@@553 (|l#$ValueArray| va@@553)))
 (and (and (<= 0 l@@553) (<= l@@553 $MAX_U64)) (forall ((x@@559 Int) ) (!  (=> (or (< x@@559 0) (>= x@@559 l@@553)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@553) x@@559) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@553) x@@559))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@6)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@6)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= (ControlFlow 0 327543) 328410))) anon0$1_correct@@31)))
(let ((PreconditionGeneratedEntry_correct@@22  (=> (= (ControlFlow 0 542954) 327543) anon0_correct@@32)))
PreconditionGeneratedEntry_correct@@22))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@40 () T@$TypeValue)
(declare-fun $abort_flag@3@@20 () Bool)
(declare-fun tc_account@@3 () T@$Value)
(declare-fun $abort_code@5@@18 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@11 () T@$Memory)
(declare-fun can_mint () T@$Value)
(declare-fun $abort_code@4@@21 () Int)
(declare-fun $abort_code@1@@29 () Int)
(declare-fun $abort_flag@0@@32 () Bool)
(declare-fun $abort_code@2@@21 () Int)
(declare-fun $abort_flag@1@@31 () Bool)
(declare-fun $abort_code@3@@22 () Int)
(declare-fun $abort_flag@2@@27 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@8| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@8 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@8 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@8 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@8 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@11| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@8| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2@@8 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@13| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@11 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@11 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@11| () T@$Mutation)
(declare-fun inline$$Diem_update_minting_ability_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@11 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@11 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@11 () Int)
(declare-fun inline$$BorrowField$0$p@2@@11 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@8 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@8 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@8 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@8 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@8 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@20 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 546736) (let ((anon0$2_correct@@33  (and (=> (= (ControlFlow 0 331392) (- 0 551358)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@20)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@20) (and (=> (= (ControlFlow 0 331392) (- 0 551374)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@3@@20)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@3@@20) (and (=> (= (ControlFlow 0 331392) (- 0 551395)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@20)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@20) (and (=> (= (ControlFlow 0 331392) (- 0 551424)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@3@@20)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@3@@20) (and (=> (= (ControlFlow 0 331392) (- 0 551441)) (=> $abort_flag@3@@20 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453)))))))) (=> (=> $abort_flag@3@@20 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551521)) (=> $abort_flag@3@@20 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@3@@20 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@5@@18 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 331392) (- 0 551645)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint) can_mint))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_can_mint) can_mint)))) (and (=> (= (ControlFlow 0 331392) (- 0 551667)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551713)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@527 T@$Value) )  (=> ((_ is $Address) addr@@527) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@527))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@527)))))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@528 T@$Value) )  (=> ((_ is $Address) addr@@528) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@528))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@528))))))))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551793)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@529 T@$Value) )  (=> ((_ is $Address) addr@@529) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@529)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@529))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@530 T@$Value) )  (=> ((_ is $Address) addr@@530) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@530)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@530)))))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551861)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551907)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@531 T@$Value) )  (=> ((_ is $Address) addr@@531) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@531))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@531)))))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@532 T@$Value) )  (=> ((_ is $Address) addr@@532) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@532))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@532))))))))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 551987)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@533 T@$Value) )  (=> ((_ is $Address) addr@@533) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@533)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@533))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@534 T@$Value) )  (=> ((_ is $Address) addr@@534) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@534)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@534)))))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 552055)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 552101)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 552147)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@535 T@$Value) )  (=> ((_ is $Address) addr@@535) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@535))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@535)))))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@536 T@$Value) )  (=> ((_ is $Address) addr@@536) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@536))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@536))))))))))))))) (and (=> (= (ControlFlow 0 331392) (- 0 552227)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@537 T@$Value) )  (=> ((_ is $Address) addr@@537) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@537)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@537))))))))))))) (=> (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean (forall ((addr@@538 T@$Value) )  (=> ((_ is $Address) addr@@538) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@538)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@538)))))))))))) (=> (= (ControlFlow 0 331392) (- 0 552295)) (=> (not $abort_flag@3@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@11) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$Abort_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@11 $Diem_CurrencyInfo_$memory) (= $abort_code@5@@18 $abort_code@4@@21)) (and (= $abort_flag@3@@20 true) (= (ControlFlow 0 331318) 331392))) anon0$2_correct@@33)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon7_correct  (=> (and (= $abort_code@4@@21 $abort_code@1@@29) (= (ControlFlow 0 331362) 331318)) inline$$Diem_update_minting_ability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 331360) 331362)) inline$$Diem_update_minting_ability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 331370) 331362) inline$$Diem_update_minting_ability_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@32 (and (=> (= (ControlFlow 0 331354) 331370) inline$$Diem_update_minting_ability_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 331354) 331360) inline$$Diem_update_minting_ability_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4@@21 $abort_code@2@@21) (= (ControlFlow 0 331342) 331318)) inline$$Diem_update_minting_ability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 331340) 331342)) inline$$Diem_update_minting_ability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 331350) 331342) inline$$Diem_update_minting_ability_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1@@31 (and (=> (= (ControlFlow 0 331334) 331350) inline$$Diem_update_minting_ability_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 331334) 331340) inline$$Diem_update_minting_ability_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon17_correct  (=> (and (= $abort_code@4@@21 $abort_code@3@@22) (= (ControlFlow 0 331314) 331318)) inline$$Diem_update_minting_ability_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 331312) 331314)) inline$$Diem_update_minting_ability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 331326) 331314) inline$$Diem_update_minting_ability_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon28_Then_correct  (=> $abort_flag@2@@27 (and (=> (= (ControlFlow 0 331306) 331326) inline$$Diem_update_minting_ability_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 331306) 331312) inline$$Diem_update_minting_ability_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon27_Then_correct  (=> $abort_flag@1@@31 (=> (and (= $abort_code@4@@21 $abort_code@2@@21) (= (ControlFlow 0 331330) 331318)) inline$$Diem_update_minting_ability_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon20$3_correct  (and (=> (= (ControlFlow 0 331292) (- 0 551024)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1 inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 331292) (- 0 551148)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 331292) (- 0 551201)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@8|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$dr_addr@@0))))))))))))))) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@11 |inline$$WritebackToGlobal$0$m'@2@@8|) (= $abort_code@5@@18 $abort_code@3@@22)) (and (= $abort_flag@3@@20 $abort_flag@2@@27) (= (ControlFlow 0 331292) 331392))) anon0$2_correct@@33)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@8  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@8)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@8| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 330971) 331292)) inline$$Diem_update_minting_ability_$def_verify$0$anon20$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@8  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@8) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@8 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@8)) (= inline$$WritebackToGlobal$0$a@1@@8 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@8))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@8 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@11|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@8 inline$$WritebackToGlobal$0$a@1@@8) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@11|))) (= |inline$$WritebackToGlobal$0$m'@1@@8| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@8 inline$$WritebackToGlobal$0$a@1@@8 inline$$WritebackToGlobal$0$v@1@@8)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@8| |inline$$WritebackToGlobal$0$m'@1@@8|) (= (ControlFlow 0 331025) 331292))) inline$$Diem_update_minting_ability_$def_verify$0$anon20$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@8  (=> (= inline$$WritebackToGlobal$0$l@1@@8 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@11|)) (and (=> (= (ControlFlow 0 330961) 331025) inline$$WritebackToGlobal$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 330961) 330971) inline$$WritebackToGlobal$0$anon3_Else_correct@@8)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon20$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_minting_ability_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_update_minting_ability_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 331031) 330961)) inline$$WritebackToGlobal$0$anon0_correct@@8)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@8  (and (=> (= (ControlFlow 0 330714) (- 0 550742)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 330714) 331031) inline$$Diem_update_minting_ability_$def_verify$0$anon20$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@8  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@8 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@11|)) (= (ControlFlow 0 330666) 330714)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@8)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@11  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@13|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@11) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@11))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@11 inline$$WritebackToReference$0$srcPath@1@@11))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@11| inline$$BorrowGlobal$0$dst@2@@8) (= (ControlFlow 0 330535) 330666)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@8))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@11  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@8) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@13|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@11) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@11))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@11 inline$$WritebackToReference$0$srcPath@1@@11)) (= |inline$$WritebackToReference$0$dst'@1@@11| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@8) inline$$WritebackToReference$0$dstPath@1@@11 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@11 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@11) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@8) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@13|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@11| |inline$$WritebackToReference$0$dst'@1@@11|) (= (ControlFlow 0 330591) 330666))) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@8)))
(let ((inline$$WritebackToReference$0$anon0_correct@@11  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@11 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@13|)) (= inline$$WritebackToReference$0$dstPath@1@@11 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@8))) (and (=> (= (ControlFlow 0 330499) 330591) inline$$WritebackToReference$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 330499) 330535) inline$$WritebackToReference$0$anon3_Else_correct@@11)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 330362) 330499)) inline$$WritebackToReference$0$anon0_correct@@11)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon30_Then_correct  (=> (and (= inline$$Diem_update_minting_ability_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@8)) (= (ControlFlow 0 331302) 330499)) inline$$WritebackToReference$0$anon0_correct@@11)))
(let ((inline$$WriteRef$0$anon0_correct@@13  (=> (= |inline$$WriteRef$0$to'@1@@13| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@11) (|p#$Mutation| inline$$BorrowField$0$dst@1@@11) can_mint)) (and (=> (= (ControlFlow 0 330348) 331302) inline$$Diem_update_minting_ability_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 330348) 330362) inline$$Diem_update_minting_ability_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@11  (=> (= inline$$BorrowField$0$p@1@@11 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@8)) (=> (and (and (= inline$$BorrowField$0$size@1@@11 (|size#$Path| inline$$BorrowField$0$p@1@@11)) (= inline$$BorrowField$0$p@2@@11 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@11) inline$$BorrowField$0$size@1@@11 $Diem_CurrencyInfo_can_mint) (+ inline$$BorrowField$0$size@1@@11 1)))) (and (= inline$$BorrowField$0$dst@1@@11 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@8) inline$$BorrowField$0$p@2@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@8))) $Diem_CurrencyInfo_can_mint))) (= (ControlFlow 0 330289) 330348))) inline$$WriteRef$0$anon0_correct@@13))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@8  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@8)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@8)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 330167) 330289)) inline$$BorrowField$0$anon0_correct@@11)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@8  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@8 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@8)) (= (ControlFlow 0 330161) 330167)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@8)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon28_Else_correct  (=> (and (not $abort_flag@2@@27) (= (ControlFlow 0 330171) 330161)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@8)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@8  (=> (= $abort_flag@2@@27 true) (=> (and (= $abort_code@3@@22 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@8 inline$$BorrowGlobal$0$dst@0@@8)) (and (=> (= (ControlFlow 0 330121) 331306) inline$$Diem_update_minting_ability_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 330121) 330171) inline$$Diem_update_minting_ability_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@8  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@8 inline$$BorrowGlobal$0$a@1@@8)) (= (ControlFlow 0 330119) 330121)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@8)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@8  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@8 inline$$BorrowGlobal$0$a@1@@8) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@8 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@8 inline$$BorrowGlobal$0$a@1@@8) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@8 inline$$BorrowGlobal$0$a@1@@8))) (= $abort_flag@2@@27 $abort_flag@1@@31)) (and (= $abort_code@3@@22 $abort_code@2@@21) (= inline$$BorrowGlobal$0$dst@2@@8 inline$$BorrowGlobal$0$dst@1@@8))) (and (=> (= (ControlFlow 0 330067) 331306) inline$$Diem_update_minting_ability_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 330067) 330171) inline$$Diem_update_minting_ability_$def_verify$0$anon28_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@8  (=> (= inline$$BorrowGlobal$0$a@1@@8 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@20)) (and (=> (= (ControlFlow 0 330037) 330119) inline$$BorrowGlobal$0$anon3_Then_correct@@8) (=> (= (ControlFlow 0 330037) 330067) inline$$BorrowGlobal$0$anon3_Else_correct@@8)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@8  (=> (= inline$$BorrowGlobal$0$ta@0@@8 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1)) (and (=> (= (ControlFlow 0 330031) (- 0 550388)) true) (=> (= (ControlFlow 0 330031) 330037) inline$$BorrowGlobal$0$anon0_correct@@8)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@1@@31) (= (ControlFlow 0 330127) 330031)) inline$$BorrowGlobal$0$Entry_correct@@8)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@20  (=> (not true) (and (=> (= (ControlFlow 0 329888) 331330) inline$$Diem_update_minting_ability_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 329888) 330127) inline$$Diem_update_minting_ability_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@20  (and (=> (= (ControlFlow 0 329898) 331330) inline$$Diem_update_minting_ability_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 329898) 330127) inline$$Diem_update_minting_ability_$def_verify$0$anon27_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@20  (=> (and (not $abort_flag@1@@31) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@20 ($Address 173345816))) (and (=> (= (ControlFlow 0 329882) 329898) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@20) (=> (= (ControlFlow 0 329882) 329888) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@20)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@1@@31) (= (ControlFlow 0 329912) 329882)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@20)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@0@@32) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@31) (=> $abort_flag@1@@31 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@1@@31 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@21 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@539 T@$Value) )  (=> ((_ is $Address) addr@@539) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@539))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@539))))))))))))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@540 T@$Value) )  (=> ((_ is $Address) addr@@540) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@540)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@540)))))))))))))) (=> (and (and (and (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@541 T@$Value) )  (=> ((_ is $Address) addr@@541) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@541))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@541)))))))))))))))) (and (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@542 T@$Value) )  (=> ((_ is $Address) addr@@542) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@542)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@542)))))))))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@543 T@$Value) )  (=> ((_ is $Address) addr@@543) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@543))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@543)))))))))))))))) (and (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean (forall ((addr@@544 T@$Value) )  (=> ((_ is $Address) addr@@544) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@544)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| addr@@544)))))))))))) (=> (not $abort_flag@1@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@40) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 329777) 331334) inline$$Diem_update_minting_ability_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 329777) 329912) inline$$Diem_update_minting_ability_$def_verify$0$anon25_Else_correct))))))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) $abort_flag@0@@32) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@32) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) $abort_flag@0@@32)) (and (=> $abort_flag@0@@32 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))))) (=> $abort_flag@0@@32 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3))))))) (= $abort_code@1@@29 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@3)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@29 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@3 ($Address 186537453))))) (= $abort_code@1@@29 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 329771) 331354) inline$$Diem_update_minting_ability_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 329771) 329777) inline$$Diem_update_minting_ability_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 329701) 329771)) inline$$Diem_update_minting_ability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 331378) 329771) inline$$Diem_update_minting_ability_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 329693) 331378) inline$$Diem_update_minting_ability_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 329693) 329701) inline$$Diem_update_minting_ability_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 331386) 331378) inline$$Diem_update_minting_ability_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 331386) 329701) inline$$Diem_update_minting_ability_$def_verify$0$anon22_Else_correct))))
(let ((inline$$Diem_update_minting_ability_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 329687) 331386) inline$$Diem_update_minting_ability_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 329687) 329693) inline$$Diem_update_minting_ability_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@32  (=> (forall (($inv_addr@@79 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79)) (let ((va@@554 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))))
(let ((l@@554 (|l#$ValueArray| va@@554)))
 (and (and (<= 0 l@@554) (<= l@@554 $MAX_U64)) (forall ((x@@560 Int) ) (!  (=> (or (< x@@560 0) (>= x@@560 l@@554)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@554) x@@560) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@554) x@@560))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@79))
)) (=> (and (forall (($inv_addr@@80 Int) ($inv_tv0@@61 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80)) (let ((va@@555 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))))
(let ((l@@555 (|l#$ValueArray| va@@555)))
 (and (and (<= 0 l@@555) (<= l@@555 $MAX_U64)) (forall ((x@@561 Int) ) (!  (=> (or (< x@@561 0) (>= x@@561 l@@555)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@555) x@@561) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@555) x@@561))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@556 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@556 (|l#$ValueArray| va@@556)))
 (and (and (<= 0 l@@556) (<= l@@556 $MAX_U64)) (forall ((x@@562 Int) ) (!  (=> (or (< x@@562 0) (>= x@@562 l@@556)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@556) x@@562) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@556) x@@562))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code)) (let ((va@@557 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@557 (|l#$ValueArray| va@@557)))
 (and (and (<= 0 l@@557) (<= l@@557 $MAX_U64)) (forall ((x@@563 Int) ) (!  (=> (or (< x@@563 0) (>= x@@563 l@@557)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@557) x@@563) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@557) x@@563))
))))))) (forall (($$0@@187 Int) ) (!  (=> (and (>= $$0@@187 0) (< $$0@@187 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))) $$0@@187)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))) $$0@@187)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))) $$0@@187)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_currency_code))) $$0@@187))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events)) (let ((va@@558 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@558 (|l#$ValueArray| va@@558)))
 (and (and (<= 0 l@@558) (<= l@@558 $MAX_U64)) (forall ((x@@564 Int) ) (!  (=> (or (< x@@564 0) (>= x@@564 l@@558)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@558) x@@564) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@558) x@@564))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@559 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@559 (|l#$ValueArray| va@@559)))
 (and (and (<= 0 l@@559) (<= l@@559 $MAX_U64)) (forall ((x@@565 Int) ) (!  (=> (or (< x@@565 0) (>= x@@565 l@@559)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@559) x@@565) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@559) x@@565))
))))))) (forall (($$0@@188 Int) ) (!  (=> (and (>= $$0@@188 0) (< $$0@@188 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@188)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@188)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@188)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@188))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events)) (let ((va@@560 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@560 (|l#$ValueArray| va@@560)))
 (and (and (<= 0 l@@560) (<= l@@560 $MAX_U64)) (forall ((x@@566 Int) ) (!  (=> (or (< x@@566 0) (>= x@@566 l@@560)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@560) x@@566) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@560) x@@566))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@561 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@561 (|l#$ValueArray| va@@561)))
 (and (and (<= 0 l@@561) (<= l@@561 $MAX_U64)) (forall ((x@@567 Int) ) (!  (=> (or (< x@@567 0) (>= x@@567 l@@561)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@561) x@@567) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@561) x@@567))
))))))) (forall (($$0@@189 Int) ) (!  (=> (and (>= $$0@@189 0) (< $$0@@189 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@189)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@189)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@189)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@189))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@562 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@562 (|l#$ValueArray| va@@562)))
 (and (and (<= 0 l@@562) (<= l@@562 $MAX_U64)) (forall ((x@@568 Int) ) (!  (=> (or (< x@@568 0) (>= x@@568 l@@562)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@562) x@@568) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@562) x@@568))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@563 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@563 (|l#$ValueArray| va@@563)))
 (and (and (<= 0 l@@563) (<= l@@563 $MAX_U64)) (forall ((x@@569 Int) ) (!  (=> (or (< x@@569 0) (>= x@@569 l@@563)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@563) x@@569) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@563) x@@569))
))))))) (forall (($$0@@190 Int) ) (!  (=> (and (>= $$0@@190 0) (< $$0@@190 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@190)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@190)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@190)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@190))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@564 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@564 (|l#$ValueArray| va@@564)))
 (and (and (<= 0 l@@564) (<= l@@564 $MAX_U64)) (forall ((x@@570 Int) ) (!  (=> (or (< x@@570 0) (>= x@@570 l@@564)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@564) x@@570) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@564) x@@570))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@565 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@565 (|l#$ValueArray| va@@565)))
 (and (and (<= 0 l@@565) (<= l@@565 $MAX_U64)) (forall ((x@@571 Int) ) (!  (=> (or (< x@@571 0) (>= x@@571 l@@565)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@565) x@@571) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@565) x@@571))
))))))) (forall (($$0@@191 Int) ) (!  (=> (and (>= $$0@@191 0) (< $$0@@191 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@191)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@191)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@191)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@191))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@566 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@566 (|l#$ValueArray| va@@566)))
 (and (and (<= 0 l@@566) (<= l@@566 $MAX_U64)) (forall ((x@@572 Int) ) (!  (=> (or (< x@@572 0) (>= x@@572 l@@566)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@566) x@@572) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@566) x@@572))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@567 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@567 (|l#$ValueArray| va@@567)))
 (and (and (<= 0 l@@567) (<= l@@567 $MAX_U64)) (forall ((x@@573 Int) ) (!  (=> (or (< x@@573 0) (>= x@@573 l@@567)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@567) x@@573) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@567) x@@573))
))))))) (forall (($$0@@192 Int) ) (!  (=> (and (>= $$0@@192 0) (< $$0@@192 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@192)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@192)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@192)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@192))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@61) 1) $inv_addr@@80))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@58 T@$Value) )  (=> ((_ is $Type) coin_type@@58) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@7 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@58)) 1) (|a#$Address| mint_cap_owner@@7)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@7)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (=> (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@59 T@$Value) )  (=> ((_ is $Type) coin_type@@59) (|b#$Boolean| ($Boolean (forall ((addr3@@26 T@$Value) )  (=> ((_ is $Address) addr3@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@59)) 1) (|a#$Address| addr3@@26)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@59)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@59)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@60 T@$Value) )  (=> ((_ is $Type) coin_type@@60) (|b#$Boolean| ($Boolean (forall ((addr1@@23 T@$Value) )  (=> ((_ is $Address) addr1@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@60)) 1) (|a#$Address| addr1@@23)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@23)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@61 T@$Value) )  (=> ((_ is $Type) coin_type@@61) (|b#$Boolean| ($Boolean (forall ((addr1@@24 T@$Value) )  (=> ((_ is $Address) addr1@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@61)) 1) (|a#$Address| addr1@@24)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@24)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 331390) 329687))) inline$$Diem_update_minting_ability_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@33  (=> ((_ is $Address) tc_account@@3) (=> (and ((_ is $Boolean) can_mint) (= (ControlFlow 0 328600) 331390)) anon0$1_correct@@32))))
(let ((PreconditionGeneratedEntry_correct@@23  (=> (= (ControlFlow 0 546736) 328600) anon0_correct@@33)))
PreconditionGeneratedEntry_correct@@23)))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun tc_account@@4 () T@$Value)
(declare-fun $abort_flag@3@@21 () Bool)
(declare-fun $tv0@@41 () T@$TypeValue)
(declare-fun $abort_code@5@@19 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@12 () T@$Memory)
(declare-fun xdx_exchange_rate () T@$Value)
(declare-fun $abort_code@4@@22 () Int)
(declare-fun $abort_code@1@@30 () Int)
(declare-fun $abort_flag@0@@33 () Bool)
(declare-fun $abort_code@2@@22 () Int)
(declare-fun $abort_flag@1@@32 () Bool)
(declare-fun $abort_code@3@@23 () Int)
(declare-fun $abort_flag@2@@28 () Bool)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@9| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$0$l@1@@9 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@9 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@9 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@9 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@8| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@9| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@12| () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@8| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@8 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@8 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@8| () T@$Mutation)
(declare-fun inline$$Diem_update_xdx_exchange_rate_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@9 () T@$Mutation)
(declare-fun inline$$ReadRef$2$v@1@@8 () T@$Value)
(declare-fun inline$$Event_emit_event$0$t@0@@8 () T@$TypeValue)
(declare-fun inline$$ReadRef$0$v@1@@13 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@21 () T@$Value)
(declare-fun inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@9 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@8 () T@$Mutation)
(declare-fun inline$$BorrowField$3$p@1@@8 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@8 () Int)
(declare-fun inline$$BorrowField$3$p@2@@8 () T@$Path)
(declare-fun inline$$BorrowField$2$dst@1@@9 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@9 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@9 () Int)
(declare-fun inline$$BorrowField$2$p@2@@9 () T@$Path)
(declare-fun inline$$BorrowField$1$p@1@@9 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@9 () Int)
(declare-fun inline$$BorrowField$1$p@2@@9 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2@@9 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@14| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@12 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@12 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@12| () T@$Mutation)
(declare-fun inline$$Diem_update_xdx_exchange_rate_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@12 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@12 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@12 () Int)
(declare-fun inline$$BorrowField$0$p@2@@12 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@9 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0@@9 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@9 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@9 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@9 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@21 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 552343) (let ((anon0$2_correct@@34  (and (=> (= (ControlFlow 0 336243) (- 0 558042)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558063)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558092)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558109)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558125)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558146)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558175)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) $abort_flag@3@@21)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) $abort_flag@3@@21) (and (=> (= (ControlFlow 0 336243) (- 0 558192)) (=> $abort_flag@3@@21 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453)))))))) (=> (=> $abort_flag@3@@21 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558336)) (=> $abort_flag@3@@21 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 2))))))) (=> (=> $abort_flag@3@@21 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) (= $abort_code@5@@19 (|i#$Integer| ($Integer 2)))))) (and (=> (= (ControlFlow 0 336243) (- 0 558557)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) xdx_exchange_rate))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) xdx_exchange_rate)))) (and (=> (= (ControlFlow 0 336243) (- 0 558579)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558625)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@545 T@$Value) )  (=> ((_ is $Address) addr@@545) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@545))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@545)))))))))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@546 T@$Value) )  (=> ((_ is $Address) addr@@546) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@546))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@546))))))))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558705)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@547 T@$Value) )  (=> ((_ is $Address) addr@@547) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@547)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@547))))))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@548 T@$Value) )  (=> ((_ is $Address) addr@@548) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@548)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@548)))))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558773)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558819)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@549 T@$Value) )  (=> ((_ is $Address) addr@@549) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@549))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@549)))))))))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@550 T@$Value) )  (=> ((_ is $Address) addr@@550) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@550))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@550))))))))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558899)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@551 T@$Value) )  (=> ((_ is $Address) addr@@551) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@551)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@551))))))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@552 T@$Value) )  (=> ((_ is $Address) addr@@552) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@552)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@552)))))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 558967)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 559013)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@0@@12) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 336243) (- 0 559059)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@553 T@$Value) )  (=> ((_ is $Address) addr@@553) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@553))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@553)))))))))))))))) (=> (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@554 T@$Value) )  (=> ((_ is $Address) addr@@554) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@554))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@554))))))))))))))) (=> (= (ControlFlow 0 336243) (- 0 559139)) (=> (not $abort_flag@3@@21) (|b#$Boolean| ($Boolean (forall ((addr@@555 T@$Value) )  (=> ((_ is $Address) addr@@555) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@555)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@555)))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct  (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@12 $Diem_CurrencyInfo_$memory) (= $abort_code@5@@19 $abort_code@4@@22)) (and (= $abort_flag@3@@21 true) (= (ControlFlow 0 336135) 336243))) anon0$2_correct@@34)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon7_correct  (=> (and (= $abort_code@4@@22 $abort_code@1@@30) (= (ControlFlow 0 336213) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 336211) 336213)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon32_Then_correct  (=> (= (ControlFlow 0 336221) 336213) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon31_Then_correct  (=> $abort_flag@0@@33 (and (=> (= (ControlFlow 0 336205) 336221) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 336205) 336211) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon11_correct  (=> (and (= $abort_code@4@@22 $abort_code@2@@22) (= (ControlFlow 0 336193) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 336191) 336193)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon34_Then_correct  (=> (= (ControlFlow 0 336201) 336193) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon11_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon33_Then_correct  (=> $abort_flag@1@@32 (and (=> (= (ControlFlow 0 336185) 336201) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 336185) 336191) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon17_correct  (=> (and (= $abort_code@4@@22 $abort_code@3@@23) (= (ControlFlow 0 336169) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon37_Else_correct  (=> (and (not true) (= (ControlFlow 0 336167) 336169)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon37_Then_correct  (=> (= (ControlFlow 0 336177) 336169) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon17_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Then_correct  (=> $abort_flag@2@@28 (and (=> (= (ControlFlow 0 336161) 336177) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 336161) 336167) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon25_correct  (=> (and (= $abort_code@4@@22 $abort_code@3@@23) (= (ControlFlow 0 336131) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon41_Else_correct  (=> (and (not true) (= (ControlFlow 0 336129) 336131)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon41_Then_correct  (=> (= (ControlFlow 0 336143) 336131) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon25_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon40_Then_correct  (=> $abort_flag@2@@28 (and (=> (= (ControlFlow 0 336123) 336143) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 336123) 336129) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon41_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Then_correct  (=> $abort_flag@2@@28 (=> (and (= $abort_code@4@@22 $abort_code@3@@23) (= (ControlFlow 0 336147) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Then_correct  (=> $abort_flag@1@@32 (=> (and (= $abort_code@4@@22 $abort_code@2@@22) (= (ControlFlow 0 336181) 336135)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon28$3_correct  (and (=> (= (ControlFlow 0 336109) (- 0 557691)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1 inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@0) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@0 inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@0))))))))))))))))))))) (and (=> (= (ControlFlow 0 336109) (- 0 557815)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@1 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@1)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@1)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@2 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@2) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@2)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@2)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (and (=> (= (ControlFlow 0 336109) (- 0 557868)) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@3 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@3) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@3)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@4 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@4) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@9|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@4)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$dr_addr@@0))))))))))))))) (=> (and (and (= $Diem_CurrencyInfo_$memory@0@@12 |inline$$WritebackToGlobal$0$m'@2@@9|) (= $abort_code@5@@19 $abort_code@3@@23)) (and (= $abort_flag@3@@21 $abort_flag@2@@28) (= (ControlFlow 0 336109) 336243))) anon0$2_correct@@34)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@9  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@9)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@9| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 335788) 336109)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon28$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@9  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@9) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@9 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@9)) (= inline$$WritebackToGlobal$0$a@1@@9 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@9))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@9 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@8|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@9 inline$$WritebackToGlobal$0$a@1@@9) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@8|))) (= |inline$$WritebackToGlobal$0$m'@1@@9| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$0$ta@1@@9 inline$$WritebackToGlobal$0$a@1@@9 inline$$WritebackToGlobal$0$v@1@@9)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@9| |inline$$WritebackToGlobal$0$m'@1@@9|) (= (ControlFlow 0 335842) 336109))) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon28$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@9  (=> (= inline$$WritebackToGlobal$0$l@1@@9 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@8|)) (and (=> (= (ControlFlow 0 335778) 335842) inline$$WritebackToGlobal$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 335778) 335788) inline$$WritebackToGlobal$0$anon3_Else_correct@@9)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon28$2_correct  (=> (and (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5 T@$Value) )  (=> ((_ is $Type) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@1) (|b#$Boolean| ($Boolean (forall ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@1 T@$Value) )  (=> ((_ is $Address) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$coin_type@@5)) 1) (|a#$Address| inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@1))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner1@@1 inline$$Diem_update_xdx_exchange_rate_$def_verify$0$mint_cap_owner2@@1))))))))))))))))))))) (= (ControlFlow 0 335848) 335778)) inline$$WritebackToGlobal$0$anon0_correct@@9)))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@9  (and (=> (= (ControlFlow 0 335531) (- 0 557409)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 335531) 335848) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon28$2_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@9  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@9 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@8|)) (= (ControlFlow 0 335483) 335531)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@9)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@8  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@8|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@8 inline$$WritebackToReference$1$srcPath@1@@8))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@8| |inline$$WritebackToReference$0$dst'@2@@12|) (= (ControlFlow 0 335352) 335483)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@9))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@8  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@8|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@8) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@8))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@8 inline$$WritebackToReference$1$srcPath@1@@8)) (= |inline$$WritebackToReference$1$dst'@1@@8| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) inline$$WritebackToReference$1$dstPath@1@@8 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@8 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@8) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@8|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@8| |inline$$WritebackToReference$1$dst'@1@@8|) (= (ControlFlow 0 335408) 335483))) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@9)))
(let ((inline$$WritebackToReference$1$anon0_correct@@8  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@8 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@8|)) (= inline$$WritebackToReference$1$dstPath@1@@8 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|))) (and (=> (= (ControlFlow 0 335316) 335408) inline$$WritebackToReference$1$anon3_Then_correct@@8) (=> (= (ControlFlow 0 335316) 335352) inline$$WritebackToReference$1$anon3_Else_correct@@8)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 335179) 335316)) inline$$WritebackToReference$1$anon0_correct@@8)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon42_Then_correct  (=> (and (= inline$$Diem_update_xdx_exchange_rate_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|)) (= (ControlFlow 0 336119) 335316)) inline$$WritebackToReference$1$anon0_correct@@8)))
(let ((inline$$WriteRef$1$anon0_correct@@8  (=> (= |inline$$WriteRef$1$to'@1@@8| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@9) (|p#$Mutation| inline$$BorrowField$1$dst@1@@9) inline$$ReadRef$2$v@1@@8)) (and (=> (= (ControlFlow 0 335165) 336119) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 335165) 335179) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon40_Else_correct  (=> (and (not $abort_flag@2@@28) (= (ControlFlow 0 335171) 335165)) inline$$WriteRef$1$anon0_correct@@8)))
(let ((inline$$Event_emit_event$0$Entry_correct@@8  (=> (= inline$$Event_emit_event$0$t@0@@8 $Diem_ToXDXExchangeRateUpdateEvent_type_value) (and (=> (= (ControlFlow 0 335096) 336123) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 335096) 335171) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Else$2_correct  (and (=> (= (ControlFlow 0 335106) (- 0 557212)) true) (=> (= (ControlFlow 0 335106) 335096) inline$$Event_emit_event$0$Entry_correct@@8))))
(let ((inline$$ReadRef$2$anon0_correct@@8  (=> (and (= inline$$ReadRef$2$v@1@@8 (|v#$Mutation| inline$$BorrowField$1$dst@1@@9)) (= (ControlFlow 0 335048) 335106)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Else$2_correct)))
(let ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 335004) 335048)) inline$$ReadRef$2$anon0_correct@@8)))
(let ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 335010) 335048) inline$$ReadRef$2$anon0_correct@@8)))
(let ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 334998) 335010) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 334998) 335004) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 334990) 335048)) inline$$ReadRef$2$anon0_correct@@8)))
(let ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Vector) inline$$ReadRef$0$v@1@@13) (let ((va@@568 (|v#$Vector| inline$$ReadRef$0$v@1@@13)))
(let ((l@@568 (|l#$ValueArray| va@@568)))
 (and (and (<= 0 l@@568) (<= l@@568 $MAX_U64)) (forall ((x@@574 Int) ) (!  (=> (or (< x@@574 0) (>= x@@574 l@@568)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@568) x@@574) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@568) x@@574))
)))))) (forall ((inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0 0) (< inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13)) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13)) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13)) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@13)) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$$0))
))) (=> (and (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@21) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@21) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@21) $MAX_U64)) (= inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$ReadRef$0$v@1@@13) 1 inline$$GetFieldFromValue$0$dst@1@@21) 2)))) (and (=> (= (ControlFlow 0 334982) 334998) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 334982) 334990) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@2@@28) (= (ControlFlow 0 335016) 334982)) inline$$Diem_ToXDXExchangeRateUpdateEvent_pack$0$anon0_correct)))
(let ((inline$$FixedPoint32_get_raw_value_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 334720) 336147) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 334720) 335016) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$FixedPoint32_get_raw_value_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 334730) 336147) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 334730) 335016) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon39_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@21  (=> (= inline$$GetFieldFromValue$0$dst@1@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) $FixedPoint32_FixedPoint32_value)) (and (=> (= (ControlFlow 0 334704) 334730) inline$$FixedPoint32_get_raw_value_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 334704) 334720) inline$$FixedPoint32_get_raw_value_$def$0$anon6_Else_correct)))))
(let ((inline$$FixedPoint32_get_raw_value_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 334628) 334704)) inline$$GetFieldFromValue$0$anon0_correct@@21)))
(let ((inline$$FixedPoint32_get_raw_value_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 334738) 334704) inline$$GetFieldFromValue$0$anon0_correct@@21)))
(let ((inline$$FixedPoint32_get_raw_value_$def$0$anon0_correct  (=> (not $abort_flag@2@@28) (and (=> (= (ControlFlow 0 334622) 334738) inline$$FixedPoint32_get_raw_value_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 334622) 334628) inline$$FixedPoint32_get_raw_value_$def$0$anon5_Else_correct)))))
(let ((inline$$FixedPoint32_get_raw_value_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1@@9) (let ((va@@569 (|v#$Vector| inline$$ReadRef$1$v@1@@9)))
(let ((l@@569 (|l#$ValueArray| va@@569)))
 (and (and (<= 0 l@@569) (<= l@@569 $MAX_U64)) (forall ((x@@575 Int) ) (!  (=> (or (< x@@575 0) (>= x@@575 l@@569)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@569) x@@575) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@569) x@@575))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@9)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (= (ControlFlow 0 334744) 334622)) inline$$FixedPoint32_get_raw_value_$def$0$anon0_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon20$4_correct  (and (=> (= (ControlFlow 0 334752) (- 0 556999)) true) (=> (= (ControlFlow 0 334752) 334744) inline$$FixedPoint32_get_raw_value_$direct_inter$0$anon0_correct))))
(let ((inline$$ReadRef$1$anon0_correct@@9  (=> (and (= inline$$ReadRef$1$v@1@@9 (|v#$Mutation| inline$$BorrowField$3$dst@1@@8)) (= (ControlFlow 0 334457) 334752)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon20$4_correct)))
(let ((inline$$BorrowField$3$anon0_correct@@8  (=> (= inline$$BorrowField$3$p@1@@8 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|)) (=> (and (and (= inline$$BorrowField$3$size@1@@8 (|size#$Path| inline$$BorrowField$3$p@1@@8)) (= inline$$BorrowField$3$p@2@@8 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@8) inline$$BorrowField$3$size@1@@8 $Diem_CurrencyInfo_to_xdx_exchange_rate) (+ inline$$BorrowField$3$size@1@@8 1)))) (and (= inline$$BorrowField$3$dst@1@@8 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) inline$$BorrowField$3$p@2@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) (= (ControlFlow 0 334419) 334457))) inline$$ReadRef$1$anon0_correct@@9))))
(let ((inline$$ReadRef$0$anon0_correct@@13  (=> (and (= inline$$ReadRef$0$v@1@@13 (|v#$Mutation| inline$$BorrowField$2$dst@1@@9)) (= (ControlFlow 0 334251) 334419)) inline$$BorrowField$3$anon0_correct@@8)))
(let ((inline$$BorrowField$2$anon0_correct@@9  (=> (= inline$$BorrowField$2$p@1@@9 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|)) (=> (and (and (= inline$$BorrowField$2$size@1@@9 (|size#$Path| inline$$BorrowField$2$p@1@@9)) (= inline$$BorrowField$2$p@2@@9 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@9) inline$$BorrowField$2$size@1@@9 $Diem_CurrencyInfo_currency_code) (+ inline$$BorrowField$2$size@1@@9 1)))) (and (= inline$$BorrowField$2$dst@1@@9 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) inline$$BorrowField$2$p@2@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|))) $Diem_CurrencyInfo_currency_code))) (= (ControlFlow 0 334213) 334251))) inline$$ReadRef$0$anon0_correct@@13))))
(let ((inline$$BorrowField$1$anon0_correct@@9  (=> (= inline$$BorrowField$1$p@1@@9 (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|)) (=> (and (and (= inline$$BorrowField$1$size@1@@9 (|size#$Path| inline$$BorrowField$1$p@1@@9)) (= inline$$BorrowField$1$p@2@@9 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@9) inline$$BorrowField$1$size@1@@9 $Diem_CurrencyInfo_exchange_rate_update_events) (+ inline$$BorrowField$1$size@1@@9 1)))) (and (= inline$$BorrowField$1$dst@1@@9 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|) inline$$BorrowField$1$p@2@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@12|))) $Diem_CurrencyInfo_exchange_rate_update_events))) (= (ControlFlow 0 334053) 334213))) inline$$BorrowField$2$anon0_correct@@9))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@12  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@9) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@14|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@12) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@12))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@12 inline$$WritebackToReference$0$srcPath@1@@12))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@12| inline$$BorrowGlobal$0$dst@2@@9) (= (ControlFlow 0 333873) 334053)) inline$$BorrowField$1$anon0_correct@@9))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@12  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@9) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@14|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@12) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@12))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@12 inline$$WritebackToReference$0$srcPath@1@@12)) (= |inline$$WritebackToReference$0$dst'@1@@12| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@9) inline$$WritebackToReference$0$dstPath@1@@12 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@12 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@12) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@9) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@14|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@12| |inline$$WritebackToReference$0$dst'@1@@12|) (= (ControlFlow 0 333929) 334053))) inline$$BorrowField$1$anon0_correct@@9)))
(let ((inline$$WritebackToReference$0$anon0_correct@@12  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@12 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@14|)) (= inline$$WritebackToReference$0$dstPath@1@@12 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@9))) (and (=> (= (ControlFlow 0 333837) 333929) inline$$WritebackToReference$0$anon3_Then_correct@@12) (=> (= (ControlFlow 0 333837) 333873) inline$$WritebackToReference$0$anon3_Else_correct@@12)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 333700) 333837)) inline$$WritebackToReference$0$anon0_correct@@12)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon38_Then_correct  (=> (and (= inline$$Diem_update_xdx_exchange_rate_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@9)) (= (ControlFlow 0 336157) 333837)) inline$$WritebackToReference$0$anon0_correct@@12)))
(let ((inline$$WriteRef$0$anon0_correct@@14  (=> (= |inline$$WriteRef$0$to'@1@@14| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@12) (|p#$Mutation| inline$$BorrowField$0$dst@1@@12) xdx_exchange_rate)) (and (=> (= (ControlFlow 0 333686) 336157) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 333686) 333700) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@12  (=> (= inline$$BorrowField$0$p@1@@12 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@9)) (=> (and (and (= inline$$BorrowField$0$size@1@@12 (|size#$Path| inline$$BorrowField$0$p@1@@12)) (= inline$$BorrowField$0$p@2@@12 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@12) inline$$BorrowField$0$size@1@@12 $Diem_CurrencyInfo_to_xdx_exchange_rate) (+ inline$$BorrowField$0$size@1@@12 1)))) (and (= inline$$BorrowField$0$dst@1@@12 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@9) inline$$BorrowField$0$p@2@@12 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@9))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) (= (ControlFlow 0 333627) 333686))) inline$$WriteRef$0$anon0_correct@@14))))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@9  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@9)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@9)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 333505) 333627)) inline$$BorrowField$0$anon0_correct@@12)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@9  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@9 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@9)) (= (ControlFlow 0 333499) 333505)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@9)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Else_correct  (=> (and (not $abort_flag@2@@28) (= (ControlFlow 0 333509) 333499)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@9)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@9  (=> (= $abort_flag@2@@28 true) (=> (and (= $abort_code@3@@23 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2@@9 inline$$BorrowGlobal$0$dst@0@@9)) (and (=> (= (ControlFlow 0 333459) 336161) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 333459) 333509) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@9  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@9 inline$$BorrowGlobal$0$a@1@@9)) (= (ControlFlow 0 333457) 333459)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@9)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@9  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@9 inline$$BorrowGlobal$0$a@1@@9) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@9 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@9 inline$$BorrowGlobal$0$a@1@@9) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$0$ta@0@@9 inline$$BorrowGlobal$0$a@1@@9))) (= $abort_flag@2@@28 $abort_flag@1@@32)) (and (= $abort_code@3@@23 $abort_code@2@@22) (= inline$$BorrowGlobal$0$dst@2@@9 inline$$BorrowGlobal$0$dst@1@@9))) (and (=> (= (ControlFlow 0 333405) 336161) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 333405) 333509) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon36_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@9  (=> (= inline$$BorrowGlobal$0$a@1@@9 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@21)) (and (=> (= (ControlFlow 0 333375) 333457) inline$$BorrowGlobal$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 333375) 333405) inline$$BorrowGlobal$0$anon3_Else_correct@@9)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@9  (=> (= inline$$BorrowGlobal$0$ta@0@@9 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1)) (and (=> (= (ControlFlow 0 333369) (- 0 556384)) true) (=> (= (ControlFlow 0 333369) 333375) inline$$BorrowGlobal$0$anon0_correct@@9)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Else_correct  (=> (and (not $abort_flag@1@@32) (= (ControlFlow 0 333465) 333369)) inline$$BorrowGlobal$0$Entry_correct@@9)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@21  (=> (not true) (and (=> (= (ControlFlow 0 333226) 336181) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 333226) 333465) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@21  (and (=> (= (ControlFlow 0 333236) 336181) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 333236) 333465) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon35_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@21  (=> (and (not $abort_flag@1@@32) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@21 ($Address 173345816))) (and (=> (= (ControlFlow 0 333220) 333236) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@21) (=> (= (ControlFlow 0 333220) 333226) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@21)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon33_Else_correct  (=> (and (not $abort_flag@1@@32) (= (ControlFlow 0 333250) 333220)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@21)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon31_Else_correct  (=> (not $abort_flag@0@@33) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@1@@32) (=> $abort_flag@1@@32 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@1@@32 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@2@@22 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@556 T@$Value) )  (=> ((_ is $Address) addr@@556) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@556))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@556))))))))))))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@557 T@$Value) )  (=> ((_ is $Address) addr@@557) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@557)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@557)))))))))))))) (=> (and (and (and (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@558 T@$Value) )  (=> ((_ is $Address) addr@@558) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@558))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@558)))))))))))))))) (and (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@559 T@$Value) )  (=> ((_ is $Address) addr@@559) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@559)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@559)))))))))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@560 T@$Value) )  (=> ((_ is $Address) addr@@560) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@560))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@560)))))))))))))))) (and (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean (forall ((addr@@561 T@$Value) )  (=> ((_ is $Address) addr@@561) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@561)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| addr@@561)))))))))))) (=> (not $abort_flag@1@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@41) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 333115) 336185) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 333115) 333250) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon33_Else_correct))))))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) $abort_flag@0@@33) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) $abort_flag@0@@33) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) $abort_flag@0@@33)) (and (=> $abort_flag@0@@33 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))))) (=> $abort_flag@0@@33 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4))))))) (= $abort_code@1@@30 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| tc_account@@4)))) $Roles_RoleId_role_id) ($Integer 1))))) (= $abort_code@1@@30 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified tc_account@@4 ($Address 186537453))))) (= $abort_code@1@@30 (|i#$Integer| ($Integer 2)))))))) (and (=> (= (ControlFlow 0 333109) 336205) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 333109) 333115) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon31_Else_correct))))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 333039) 333109)) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 336229) 333109) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon4$2_correct)))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 333031) 336229) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 333031) 333039) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 336237) 336229) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 336237) 333039) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon30_Else_correct))))
(let ((inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 333025) 336237) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 333025) 333031) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@33  (=> (and (and (and (forall (($inv_addr@@81 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81)) (let ((va@@570 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))))
(let ((l@@570 (|l#$ValueArray| va@@570)))
 (and (and (<= 0 l@@570) (<= l@@570 $MAX_U64)) (forall ((x@@576 Int) ) (!  (=> (or (< x@@576 0) (>= x@@576 l@@570)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@570) x@@576) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@570) x@@576))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@81))
)) (forall (($inv_addr@@82 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82)) (let ((va@@571 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))))
(let ((l@@571 (|l#$ValueArray| va@@571)))
 (and (and (<= 0 l@@571) (<= l@@571 $MAX_U64)) (forall ((x@@577 Int) ) (!  (=> (or (< x@@577 0) (>= x@@577 l@@571)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@571) x@@577) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@571) x@@577))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@82))
))) (and (forall (($inv_addr@@83 Int) ($inv_tv0@@62 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83)) (let ((va@@572 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))))
(let ((l@@572 (|l#$ValueArray| va@@572)))
 (and (and (<= 0 l@@572) (<= l@@572 $MAX_U64)) (forall ((x@@578 Int) ) (!  (=> (or (< x@@578 0) (>= x@@578 l@@572)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@572) x@@578) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@572) x@@578))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@573 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@573 (|l#$ValueArray| va@@573)))
 (and (and (<= 0 l@@573) (<= l@@573 $MAX_U64)) (forall ((x@@579 Int) ) (!  (=> (or (< x@@579 0) (>= x@@579 l@@573)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@573) x@@579) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@573) x@@579))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code)) (let ((va@@574 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@574 (|l#$ValueArray| va@@574)))
 (and (and (<= 0 l@@574) (<= l@@574 $MAX_U64)) (forall ((x@@580 Int) ) (!  (=> (or (< x@@580 0) (>= x@@580 l@@574)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@574) x@@580) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@574) x@@580))
))))))) (forall (($$0@@193 Int) ) (!  (=> (and (>= $$0@@193 0) (< $$0@@193 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))) $$0@@193)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))) $$0@@193)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))) $$0@@193)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_currency_code))) $$0@@193))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events)) (let ((va@@575 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@575 (|l#$ValueArray| va@@575)))
 (and (and (<= 0 l@@575) (<= l@@575 $MAX_U64)) (forall ((x@@581 Int) ) (!  (=> (or (< x@@581 0) (>= x@@581 l@@575)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@575) x@@581) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@575) x@@581))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@576 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@576 (|l#$ValueArray| va@@576)))
 (and (and (<= 0 l@@576) (<= l@@576 $MAX_U64)) (forall ((x@@582 Int) ) (!  (=> (or (< x@@582 0) (>= x@@582 l@@576)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@576) x@@582) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@576) x@@582))
))))))) (forall (($$0@@194 Int) ) (!  (=> (and (>= $$0@@194 0) (< $$0@@194 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@194)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@194)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@194)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@194))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events)) (let ((va@@577 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@577 (|l#$ValueArray| va@@577)))
 (and (and (<= 0 l@@577) (<= l@@577 $MAX_U64)) (forall ((x@@583 Int) ) (!  (=> (or (< x@@583 0) (>= x@@583 l@@577)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@577) x@@583) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@577) x@@583))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@578 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@578 (|l#$ValueArray| va@@578)))
 (and (and (<= 0 l@@578) (<= l@@578 $MAX_U64)) (forall ((x@@584 Int) ) (!  (=> (or (< x@@584 0) (>= x@@584 l@@578)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@578) x@@584) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@578) x@@584))
))))))) (forall (($$0@@195 Int) ) (!  (=> (and (>= $$0@@195 0) (< $$0@@195 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@195)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@195)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@195)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@195))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@579 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@579 (|l#$ValueArray| va@@579)))
 (and (and (<= 0 l@@579) (<= l@@579 $MAX_U64)) (forall ((x@@585 Int) ) (!  (=> (or (< x@@585 0) (>= x@@585 l@@579)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@579) x@@585) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@579) x@@585))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@580 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@580 (|l#$ValueArray| va@@580)))
 (and (and (<= 0 l@@580) (<= l@@580 $MAX_U64)) (forall ((x@@586 Int) ) (!  (=> (or (< x@@586 0) (>= x@@586 l@@580)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@580) x@@586) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@580) x@@586))
))))))) (forall (($$0@@196 Int) ) (!  (=> (and (>= $$0@@196 0) (< $$0@@196 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@196)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@196)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@196)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@196))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@581 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@581 (|l#$ValueArray| va@@581)))
 (and (and (<= 0 l@@581) (<= l@@581 $MAX_U64)) (forall ((x@@587 Int) ) (!  (=> (or (< x@@587 0) (>= x@@587 l@@581)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@581) x@@587) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@581) x@@587))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@582 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@582 (|l#$ValueArray| va@@582)))
 (and (and (<= 0 l@@582) (<= l@@582 $MAX_U64)) (forall ((x@@588 Int) ) (!  (=> (or (< x@@588 0) (>= x@@588 l@@582)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@582) x@@588) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@582) x@@588))
))))))) (forall (($$0@@197 Int) ) (!  (=> (and (>= $$0@@197 0) (< $$0@@197 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@197)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@197)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@197)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@197))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@583 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@583 (|l#$ValueArray| va@@583)))
 (and (and (<= 0 l@@583) (<= l@@583 $MAX_U64)) (forall ((x@@589 Int) ) (!  (=> (or (< x@@589 0) (>= x@@589 l@@583)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@583) x@@589) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@583) x@@589))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@584 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@584 (|l#$ValueArray| va@@584)))
 (and (and (<= 0 l@@584) (<= l@@584 $MAX_U64)) (forall ((x@@590 Int) ) (!  (=> (or (< x@@590 0) (>= x@@590 l@@584)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@584) x@@590) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@584) x@@590))
))))))) (forall (($$0@@198 Int) ) (!  (=> (and (>= $$0@@198 0) (< $$0@@198 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@198)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@198)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@198)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@198))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@62) 1) $inv_addr@@83))
)) (|b#$Boolean| ($Boolean (forall ((coin_type@@62 T@$Value) )  (=> ((_ is $Type) coin_type@@62) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@8 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@62)) 1) (|a#$Address| mint_cap_owner@@8)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@8)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@63 T@$Value) )  (=> ((_ is $Type) coin_type@@63) (|b#$Boolean| ($Boolean (forall ((addr3@@27 T@$Value) )  (=> ((_ is $Address) addr3@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@63)) 1) (|a#$Address| addr3@@27)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@63)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@63)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@64 T@$Value) )  (=> ((_ is $Type) coin_type@@64) (|b#$Boolean| ($Boolean (forall ((addr1@@25 T@$Value) )  (=> ((_ is $Address) addr1@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@64)) 1) (|a#$Address| addr1@@25)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@25)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@65 T@$Value) )  (=> ((_ is $Type) coin_type@@65) (|b#$Boolean| ($Boolean (forall ((addr1@@26 T@$Value) )  (=> ((_ is $Address) addr1@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@65)) 1) (|a#$Address| addr1@@26)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@26)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@26)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (= (ControlFlow 0 336241) 333025)))) inline$$Diem_update_xdx_exchange_rate_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@34  (=> ((_ is $Address) tc_account@@4) (=> (and (and (and (and (and ((_ is $Vector) xdx_exchange_rate) (let ((va@@585 (|v#$Vector| xdx_exchange_rate)))
(let ((l@@585 (|l#$ValueArray| va@@585)))
 (and (and (<= 0 l@@585) (<= l@@585 $MAX_U64)) (forall ((x@@591 Int) ) (!  (=> (or (< x@@591 0) (>= x@@591 l@@585)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@585) x@@591) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@585) x@@591))
)))))) (= (|l#$ValueArray| (|v#$Vector| xdx_exchange_rate)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| xdx_exchange_rate)) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) (= (ControlFlow 0 331763) 336241)) anon0$1_correct@@33))))
(let ((PreconditionGeneratedEntry_correct@@24  (=> (= (ControlFlow 0 552343) 331763) anon0_correct@@34)))
PreconditionGeneratedEntry_correct@@24)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@2@@29 () Bool)
(declare-fun $tv0@@42 () T@$TypeValue)
(declare-fun inline$$Diem_xdx_exchange_rate_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@34 () Bool)
(declare-fun $abort_flag@1@@33 () Bool)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@22 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@5 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0@@12 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@12 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@12 () T@$Value)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@22 () T@$Value)
(declare-fun $abort_code@1@@31 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 559212) (let ((anon0$2_correct@@35  (and (=> (= (ControlFlow 0 337675) (- 0 561837)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 561886)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@562 T@$Value) )  (=> ((_ is $Address) addr@@562) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@562))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@562)))))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@563 T@$Value) )  (=> ((_ is $Address) addr@@563) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@563))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@563))))))))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 561966)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@564 T@$Value) )  (=> ((_ is $Address) addr@@564) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@564)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@564))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@565 T@$Value) )  (=> ((_ is $Address) addr@@565) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@565)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@565)))))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562034)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562083)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@566 T@$Value) )  (=> ((_ is $Address) addr@@566) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@566))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@566)))))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@567 T@$Value) )  (=> ((_ is $Address) addr@@567) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@567))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@567))))))))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562163)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@568 T@$Value) )  (=> ((_ is $Address) addr@@568) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@568)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@568))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@569 T@$Value) )  (=> ((_ is $Address) addr@@569) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@569)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@569)))))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562231)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562280)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562329)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@570 T@$Value) )  (=> ((_ is $Address) addr@@570) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@570))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@570)))))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@571 T@$Value) )  (=> ((_ is $Address) addr@@571) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@571))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@571))))))))))))))) (and (=> (= (ControlFlow 0 337675) (- 0 562409)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@572 T@$Value) )  (=> ((_ is $Address) addr@@572) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@572)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@572))))))))))))) (=> (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean (forall ((addr@@573 T@$Value) )  (=> ((_ is $Address) addr@@573) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@573)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@573)))))))))))) (=> (= (ControlFlow 0 337675) (- 0 562477)) (=> (not $abort_flag@2@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct  (=> (= inline$$Diem_xdx_exchange_rate_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@2@@29 true) (= (ControlFlow 0 337635) 337675)) anon0$2_correct@@35))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 337657) 337635)) inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 337667) 337635) inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon13_Then_correct  (=> $abort_flag@0@@34 (and (=> (= (ControlFlow 0 337651) 337667) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 337651) 337657) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon17_Else_correct  (=> (and (not true) (= (ControlFlow 0 337627) 337635)) inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon17_Then_correct  (=> (= (ControlFlow 0 337643) 337635) inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Then_correct  (=> $abort_flag@1@@33 (and (=> (= (ControlFlow 0 337621) 337643) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 337621) 337627) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Then_correct  (=> (and $abort_flag@0@@34 (= (ControlFlow 0 337647) 337635)) inline$$Diem_xdx_exchange_rate_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon12_correct  (=> (and (= $abort_flag@2@@29 $abort_flag@1@@33) (= (ControlFlow 0 337609) 337675)) anon0$2_correct@@35)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 337607) 337609)) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 337617) 337609) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon12_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@22  (=> (= inline$$GetFieldFromValue$0$dst@1@@22 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@5)) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (and (=> (= (ControlFlow 0 337591) 337617) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 337591) 337607) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Else_correct  (=> (and (not $abort_flag@1@@33) (= (ControlFlow 0 337597) 337591)) inline$$GetFieldFromValue$0$anon0_correct@@22)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@12  (=> (= $abort_flag@1@@33 true) (and (=> (= (ControlFlow 0 337537) 337621) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 337537) 337597) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@12  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@12 inline$$GetGlobal$0$a@1@@12)) (= (ControlFlow 0 337535) 337537)) inline$$GetGlobal$0$anon3_Then$1_correct@@12)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@12  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@12 inline$$GetGlobal$0$a@1@@12) (=> (and (= inline$$GetGlobal$0$dst@1@@12 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$GetGlobal$0$ta@0@@12 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@22))) (= $abort_flag@1@@33 $abort_flag@0@@34)) (and (=> (= (ControlFlow 0 337483) 337621) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 337483) 337597) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon16_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@12  (=> (= inline$$GetGlobal$0$a@1@@12 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@22)) (and (=> (= (ControlFlow 0 337465) 337535) inline$$GetGlobal$0$anon3_Then_correct@@12) (=> (= (ControlFlow 0 337465) 337483) inline$$GetGlobal$0$anon3_Else_correct@@12)))))
(let ((inline$$GetGlobal$0$Entry_correct@@12  (=> (= inline$$GetGlobal$0$ta@0@@12 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1)) (and (=> (= (ControlFlow 0 337459) (- 0 561688)) true) (=> (= (ControlFlow 0 337459) 337465) inline$$GetGlobal$0$anon0_correct@@12)))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@34) (= (ControlFlow 0 337543) 337459)) inline$$GetGlobal$0$Entry_correct@@12)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@22  (=> (not true) (and (=> (= (ControlFlow 0 337326) 337647) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 337326) 337543) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@22  (and (=> (= (ControlFlow 0 337336) 337647) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 337336) 337543) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon15_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@22  (=> (and (not $abort_flag@0@@34) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@22 ($Address 173345816))) (and (=> (= (ControlFlow 0 337320) 337336) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@22) (=> (= (ControlFlow 0 337320) 337326) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@22)))))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@0@@34) (= (ControlFlow 0 337350) 337320)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@22)))
(let ((inline$$Diem_xdx_exchange_rate_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@34) (=> $abort_flag@0@@34 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@34 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@31 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@574 T@$Value) )  (=> ((_ is $Address) addr@@574) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@574))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@574))))))))))))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@575 T@$Value) )  (=> ((_ is $Address) addr@@575) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@575)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@575)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@576 T@$Value) )  (=> ((_ is $Address) addr@@576) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@576))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@576)))))))))))))))) (and (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@577 T@$Value) )  (=> ((_ is $Address) addr@@577) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@577)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@577)))))))))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@578 T@$Value) )  (=> ((_ is $Address) addr@@578) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@578))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@578)))))))))))))))) (and (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean (forall ((addr@@579 T@$Value) )  (=> ((_ is $Address) addr@@579) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@579)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| addr@@579)))))))))))) (=> (not $abort_flag@0@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@42) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 337215) 337651) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 337215) 337350) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon13_Else_correct))))))))
(let ((anon0$1_correct@@34  (=> (forall (($inv_addr@@84 Int) ($inv_tv0@@63 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84)) (let ((va@@586 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))))
(let ((l@@586 (|l#$ValueArray| va@@586)))
 (and (and (<= 0 l@@586) (<= l@@586 $MAX_U64)) (forall ((x@@592 Int) ) (!  (=> (or (< x@@592 0) (>= x@@592 l@@586)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@586) x@@592) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@586) x@@592))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@587 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@587 (|l#$ValueArray| va@@587)))
 (and (and (<= 0 l@@587) (<= l@@587 $MAX_U64)) (forall ((x@@593 Int) ) (!  (=> (or (< x@@593 0) (>= x@@593 l@@587)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@587) x@@593) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@587) x@@593))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code)) (let ((va@@588 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@588 (|l#$ValueArray| va@@588)))
 (and (and (<= 0 l@@588) (<= l@@588 $MAX_U64)) (forall ((x@@594 Int) ) (!  (=> (or (< x@@594 0) (>= x@@594 l@@588)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@588) x@@594) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@588) x@@594))
))))))) (forall (($$0@@199 Int) ) (!  (=> (and (>= $$0@@199 0) (< $$0@@199 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))) $$0@@199)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))) $$0@@199)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))) $$0@@199)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_currency_code))) $$0@@199))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events)) (let ((va@@589 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@589 (|l#$ValueArray| va@@589)))
 (and (and (<= 0 l@@589) (<= l@@589 $MAX_U64)) (forall ((x@@595 Int) ) (!  (=> (or (< x@@595 0) (>= x@@595 l@@589)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@589) x@@595) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@589) x@@595))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@590 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@590 (|l#$ValueArray| va@@590)))
 (and (and (<= 0 l@@590) (<= l@@590 $MAX_U64)) (forall ((x@@596 Int) ) (!  (=> (or (< x@@596 0) (>= x@@596 l@@590)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@590) x@@596) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@590) x@@596))
))))))) (forall (($$0@@200 Int) ) (!  (=> (and (>= $$0@@200 0) (< $$0@@200 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@200)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@200)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@200)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@200))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events)) (let ((va@@591 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@591 (|l#$ValueArray| va@@591)))
 (and (and (<= 0 l@@591) (<= l@@591 $MAX_U64)) (forall ((x@@597 Int) ) (!  (=> (or (< x@@597 0) (>= x@@597 l@@591)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@591) x@@597) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@591) x@@597))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@592 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@592 (|l#$ValueArray| va@@592)))
 (and (and (<= 0 l@@592) (<= l@@592 $MAX_U64)) (forall ((x@@598 Int) ) (!  (=> (or (< x@@598 0) (>= x@@598 l@@592)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@592) x@@598) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@592) x@@598))
))))))) (forall (($$0@@201 Int) ) (!  (=> (and (>= $$0@@201 0) (< $$0@@201 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@201)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@201)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@201)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@201))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@593 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@593 (|l#$ValueArray| va@@593)))
 (and (and (<= 0 l@@593) (<= l@@593 $MAX_U64)) (forall ((x@@599 Int) ) (!  (=> (or (< x@@599 0) (>= x@@599 l@@593)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@593) x@@599) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@593) x@@599))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@594 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@594 (|l#$ValueArray| va@@594)))
 (and (and (<= 0 l@@594) (<= l@@594 $MAX_U64)) (forall ((x@@600 Int) ) (!  (=> (or (< x@@600 0) (>= x@@600 l@@594)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@594) x@@600) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@594) x@@600))
))))))) (forall (($$0@@202 Int) ) (!  (=> (and (>= $$0@@202 0) (< $$0@@202 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@202)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@202)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@202)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@202))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@595 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@595 (|l#$ValueArray| va@@595)))
 (and (and (<= 0 l@@595) (<= l@@595 $MAX_U64)) (forall ((x@@601 Int) ) (!  (=> (or (< x@@601 0) (>= x@@601 l@@595)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@595) x@@601) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@595) x@@601))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@596 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@596 (|l#$ValueArray| va@@596)))
 (and (and (<= 0 l@@596) (<= l@@596 $MAX_U64)) (forall ((x@@602 Int) ) (!  (=> (or (< x@@602 0) (>= x@@602 l@@596)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@596) x@@602) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@596) x@@602))
))))))) (forall (($$0@@203 Int) ) (!  (=> (and (>= $$0@@203 0) (< $$0@@203 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@203)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@203)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@203)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@203))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@597 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@597 (|l#$ValueArray| va@@597)))
 (and (and (<= 0 l@@597) (<= l@@597 $MAX_U64)) (forall ((x@@603 Int) ) (!  (=> (or (< x@@603 0) (>= x@@603 l@@597)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@597) x@@603) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@597) x@@603))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@598 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@598 (|l#$ValueArray| va@@598)))
 (and (and (<= 0 l@@598) (<= l@@598 $MAX_U64)) (forall ((x@@604 Int) ) (!  (=> (or (< x@@604 0) (>= x@@604 l@@598)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@598) x@@604) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@598) x@@604))
))))))) (forall (($$0@@204 Int) ) (!  (=> (and (>= $$0@@204 0) (< $$0@@204 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@204)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@204)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@204)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@204))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@63) 1) $inv_addr@@84))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@66 T@$Value) )  (=> ((_ is $Type) coin_type@@66) (|b#$Boolean| ($Boolean (forall ((addr3@@28 T@$Value) )  (=> ((_ is $Address) addr3@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@66)) 1) (|a#$Address| addr3@@28)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@66)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@66)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 337673) 337215)) inline$$Diem_xdx_exchange_rate_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@35  (=> (= (ControlFlow 0 559212) 337673) anon0$1_correct@@34)))
anon0_correct@@35))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun coin@@7 () T@$Value)
(declare-fun amount@@0 () T@$Value)
(declare-fun $abort_flag@2@@30 () Bool)
(declare-fun $abort_code@5@@20 () Int)
(declare-fun inline$$Diem_withdraw_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun inline$$Diem_withdraw_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun $tv0@@43 () T@$TypeValue)
(declare-fun $abort_code@3@@24 () Int)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1@@2 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@8| () T@$Value)
(declare-fun $abort_flag@1@@34 () Bool)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@13| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@10| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@10 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@15| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@13 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@13 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@13| () T@$Mutation)
(declare-fun inline$$BorrowField$2$dst@1@@10 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@9 () T@$Value)
(declare-fun inline$$BorrowField$2$p@1@@10 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@10 () Int)
(declare-fun inline$$BorrowField$2$p@2@@10 () T@$Path)
(declare-fun inline$$Diem_withdraw_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_withdraw_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_code@4@@23 () Int)
(declare-fun $abort_code@1@@32 () Int)
(declare-fun $abort_flag@0@@35 () Bool)
(declare-fun inline$$Sub$0$dst@0@@9 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@10 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@9 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@10 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@10 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@10 () Int)
(declare-fun inline$$BorrowField$1$p@2@@10 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@9 () T@$Value)
(declare-fun $abort_code@2@@23 () Int)
(declare-fun call3formal@$ret0@0@@69 () T@$Value)
(declare-fun inline$$Diem_withdraw_$def_verify$0$$t9@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@14 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1@@13 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@13 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@13 () Int)
(declare-fun inline$$BorrowField$0$p@2@@13 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 562530) (let ((anon0$2_correct@@36  (and (=> (= (ControlFlow 0 339937) (- 0 564695)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))) $abort_flag@2@@30)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))) $abort_flag@2@@30) (and (=> (= (ControlFlow 0 339937) (- 0 564716)) (=> $abort_flag@2@@30 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))))) (=> (=> $abort_flag@2@@30 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0))))) (and (=> (= (ControlFlow 0 339937) (- 0 564737)) (=> $abort_flag@2@@30 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))) (= $abort_code@5@@20 (|i#$Integer| ($Integer 8)))))) (=> (=> $abort_flag@2@@30 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))) (= $abort_code@5@@20 (|i#$Integer| ($Integer 8))))) (and (=> (= (ControlFlow 0 339937) (- 0 564769)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_$def_verify$0$$ret1@2)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0)))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_$def_verify$0$$ret1@2)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (|i#$Integer| amount@@0))))))) (and (=> (= (ControlFlow 0 339937) (- 0 564801)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_$def_verify$0$$ret0@2)) $Diem_Diem_value) amount@@0))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_$def_verify$0$$ret0@2)) $Diem_Diem_value) amount@@0)))) (and (=> (= (ControlFlow 0 339937) (- 0 564819)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 564868)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@580 T@$Value) )  (=> ((_ is $Address) addr@@580) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@580))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@580)))))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@581 T@$Value) )  (=> ((_ is $Address) addr@@581) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@581))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@581))))))))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 564948)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@582 T@$Value) )  (=> ((_ is $Address) addr@@582) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@582)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@582))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@583 T@$Value) )  (=> ((_ is $Address) addr@@583) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@583)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@583)))))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565016)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565065)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@584 T@$Value) )  (=> ((_ is $Address) addr@@584) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@584))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@584)))))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@585 T@$Value) )  (=> ((_ is $Address) addr@@585) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@585))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@585))))))))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565145)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@586 T@$Value) )  (=> ((_ is $Address) addr@@586) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@586)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@586))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@587 T@$Value) )  (=> ((_ is $Address) addr@@587) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@587)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@587)))))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565213)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565262)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565311)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@588 T@$Value) )  (=> ((_ is $Address) addr@@588) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@588))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@588)))))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@589 T@$Value) )  (=> ((_ is $Address) addr@@589) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@589))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@589))))))))))))))) (and (=> (= (ControlFlow 0 339937) (- 0 565391)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@590 T@$Value) )  (=> ((_ is $Address) addr@@590) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@590)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@590))))))))))))) (=> (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean (forall ((addr@@591 T@$Value) )  (=> ((_ is $Address) addr@@591) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@591)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| addr@@591)))))))))))) (=> (= (ControlFlow 0 339937) (- 0 565459)) (=> (not $abort_flag@2@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@43) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon20_correct  (=> (= $abort_code@5@@20 $abort_code@3@@24) (=> (and (and (= inline$$Diem_withdraw_$def_verify$0$$ret0@2 inline$$Diem_Diem_pack$0$$struct@1@@2) (= inline$$Diem_withdraw_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@8|)) (and (= $abort_flag@2@@30 $abort_flag@1@@34) (= (ControlFlow 0 339855) 339937))) anon0$2_correct@@36))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 339853) 339855)) inline$$Diem_withdraw_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 339863) 339855) inline$$Diem_withdraw_$def_verify$0$anon20_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon29_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 339843) 339863) inline$$Diem_withdraw_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 339843) 339853) inline$$Diem_withdraw_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon29_Then_correct  (and (=> (= (ControlFlow 0 339871) 339863) inline$$Diem_withdraw_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 339871) 339853) inline$$Diem_withdraw_$def_verify$0$anon30_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 339821) 339871) inline$$Diem_withdraw_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 339821) 339843) inline$$Diem_withdraw_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct@@2  (and (=> (= (ControlFlow 0 339827) 339871) inline$$Diem_withdraw_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 339827) 339843) inline$$Diem_withdraw_$def_verify$0$anon29_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct@@2  (=> (> 0 0) (and (=> (= (ControlFlow 0 339815) 339827) inline$$Diem_Diem_pack$0$anon4_Then_correct@@2) (=> (= (ControlFlow 0 339815) 339821) inline$$Diem_Diem_pack$0$anon4_Else_correct@@2)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct@@2  (=> (>= 0 0) (and (=> (= (ControlFlow 0 339807) 339871) inline$$Diem_withdraw_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 339807) 339843) inline$$Diem_withdraw_$def_verify$0$anon29_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct@@2  (=> (and (and (and ((_ is $Integer) amount@@0) (>= (|i#$Integer| amount@@0) 0)) (<= (|i#$Integer| amount@@0) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1@@2 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 amount@@0) 1)))) (and (=> (= (ControlFlow 0 339799) 339815) inline$$Diem_Diem_pack$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 339799) 339807) inline$$Diem_Diem_pack$0$anon3_Else_correct@@2)))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@10  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@13|) ($Local 4))) (=> (and (= |inline$$WritebackToValue$0$vdst'@2@@8| coin@@7) (= (ControlFlow 0 339634) 339799)) inline$$Diem_Diem_pack$0$anon0_correct@@2))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@10  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@13|) ($Local 4)) (= |inline$$WritebackToValue$0$vdst'@1@@10| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@13|) 0 coin@@7 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@13|)))) (and (= |inline$$WritebackToValue$0$vdst'@2@@8| |inline$$WritebackToValue$0$vdst'@1@@10|) (= (ControlFlow 0 339660) 339799))) inline$$Diem_Diem_pack$0$anon0_correct@@2)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@13  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@15|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@13) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@13))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@13 inline$$WritebackToReference$0$srcPath@1@@13))) (= |inline$$WritebackToReference$0$dst'@2@@13| inline$$BorrowLoc$0$dst@1@@10)) (and (=> (= (ControlFlow 0 339479) 339660) inline$$WritebackToValue$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 339479) 339634) inline$$WritebackToValue$0$anon3_Else_correct@@10)))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@13  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@15|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@13) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@13))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@13 inline$$WritebackToReference$0$srcPath@1@@13)) (and (= |inline$$WritebackToReference$0$dst'@1@@13| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$WritebackToReference$0$dstPath@1@@13 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@13 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@13) (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@15|)))) (= |inline$$WritebackToReference$0$dst'@2@@13| |inline$$WritebackToReference$0$dst'@1@@13|))) (and (=> (= (ControlFlow 0 339535) 339660) inline$$WritebackToValue$0$anon3_Then_correct@@10) (=> (= (ControlFlow 0 339535) 339634) inline$$WritebackToValue$0$anon3_Else_correct@@10)))))
(let ((inline$$WritebackToReference$0$anon0_correct@@13  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@13 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@15|)) (= inline$$WritebackToReference$0$dstPath@1@@13 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) (and (=> (= (ControlFlow 0 339443) 339535) inline$$WritebackToReference$0$anon3_Then_correct@@13) (=> (= (ControlFlow 0 339443) 339479) inline$$WritebackToReference$0$anon3_Else_correct@@13)))))
(let ((inline$$WriteRef$0$anon0_correct@@15  (=> (and (= |inline$$WriteRef$0$to'@1@@15| ($Mutation (|l#$Mutation| inline$$BorrowField$2$dst@1@@10) (|p#$Mutation| inline$$BorrowField$2$dst@1@@10) inline$$Sub$0$dst@2@@9)) (= (ControlFlow 0 339300) 339443)) inline$$WritebackToReference$0$anon0_correct@@13)))
(let ((inline$$BorrowField$2$anon0_correct@@10  (=> (= inline$$BorrowField$2$p@1@@10 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (=> (and (and (= inline$$BorrowField$2$size@1@@10 (|size#$Path| inline$$BorrowField$2$p@1@@10)) (= inline$$BorrowField$2$p@2@@10 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@10) inline$$BorrowField$2$size@1@@10 $Diem_Diem_value) (+ inline$$BorrowField$2$size@1@@10 1)))) (and (= inline$$BorrowField$2$dst@1@@10 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$BorrowField$2$p@2@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) $Diem_Diem_value))) (= (ControlFlow 0 339241) 339300))) inline$$WriteRef$0$anon0_correct@@15))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon27_Else_correct  (=> (and (not $abort_flag@1@@34) (= (ControlFlow 0 339247) 339241)) inline$$BorrowField$2$anon0_correct@@10)))
(let ((inline$$Diem_withdraw_$def_verify$0$Abort_correct  (=> (= inline$$Diem_withdraw_$def_verify$0$$ret0@1 $Error) (=> (and (= inline$$Diem_withdraw_$def_verify$0$$ret1@1 $Error) (= $abort_code@5@@20 $abort_code@4@@23)) (=> (and (and (= inline$$Diem_withdraw_$def_verify$0$$ret0@2 inline$$Diem_withdraw_$def_verify$0$$ret0@1) (= inline$$Diem_withdraw_$def_verify$0$$ret1@2 inline$$Diem_withdraw_$def_verify$0$$ret1@1)) (and (= $abort_flag@2@@30 true) (= (ControlFlow 0 338728) 339937))) anon0$2_correct@@36)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon7_correct  (=> (and (= $abort_code@4@@23 $abort_code@1@@32) (= (ControlFlow 0 339903) 338728)) inline$$Diem_withdraw_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 339901) 339903)) inline$$Diem_withdraw_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 339911) 339903) inline$$Diem_withdraw_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0@@35 (and (=> (= (ControlFlow 0 339895) 339911) inline$$Diem_withdraw_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 339895) 339901) inline$$Diem_withdraw_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon15_correct  (=> (and (= $abort_code@4@@23 $abort_code@3@@24) (= (ControlFlow 0 339883) 338728)) inline$$Diem_withdraw_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 339881) 339883)) inline$$Diem_withdraw_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 339891) 339883) inline$$Diem_withdraw_$def_verify$0$anon15_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon27_Then_correct  (=> $abort_flag@1@@34 (and (=> (= (ControlFlow 0 339875) 339891) inline$$Diem_withdraw_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 339875) 339881) inline$$Diem_withdraw_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$Sub$0$anon3_Then$1_correct@@9  (=> (= $abort_flag@1@@34 true) (=> (and (= $abort_code@3@@24 $EXEC_FAILURE_CODE) (= inline$$Sub$0$dst@2@@9 inline$$Sub$0$dst@0@@9)) (and (=> (= (ControlFlow 0 339111) 339875) inline$$Diem_withdraw_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 339111) 339247) inline$$Diem_withdraw_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@9  (=> (and (< (|i#$Integer| inline$$ReadRef$1$v@1@@10) (|i#$Integer| amount@@0)) (= (ControlFlow 0 339109) 339111)) inline$$Sub$0$anon3_Then$1_correct@@9)))
(let ((inline$$Sub$0$anon3_Else_correct@@9  (=> (<= (|i#$Integer| amount@@0) (|i#$Integer| inline$$ReadRef$1$v@1@@10)) (=> (and (and (= inline$$Sub$0$dst@1@@9 ($Integer (- (|i#$Integer| inline$$ReadRef$1$v@1@@10) (|i#$Integer| amount@@0)))) (= $abort_flag@1@@34 $abort_flag@0@@35)) (and (= $abort_code@3@@24 $abort_code@1@@32) (= inline$$Sub$0$dst@2@@9 inline$$Sub$0$dst@1@@9))) (and (=> (= (ControlFlow 0 339057) 339875) inline$$Diem_withdraw_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 339057) 339247) inline$$Diem_withdraw_$def_verify$0$anon27_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@9  (and (=> (= (ControlFlow 0 339031) (- 0 564161)) true) (and (=> (= (ControlFlow 0 339031) 339109) inline$$Sub$0$anon3_Then_correct@@9) (=> (= (ControlFlow 0 339031) 339057) inline$$Sub$0$anon3_Else_correct@@9)))))
(let ((inline$$ReadRef$1$anon0_correct@@10  (=> (and (= inline$$ReadRef$1$v@1@@10 (|v#$Mutation| inline$$BorrowField$1$dst@1@@10)) (= (ControlFlow 0 338932) 339031)) inline$$Sub$0$Entry_correct@@9)))
(let ((inline$$BorrowField$1$anon0_correct@@10  (=> (= inline$$BorrowField$1$p@1@@10 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (=> (and (and (= inline$$BorrowField$1$size@1@@10 (|size#$Path| inline$$BorrowField$1$p@1@@10)) (= inline$$BorrowField$1$p@2@@10 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@10) inline$$BorrowField$1$size@1@@10 $Diem_Diem_value) (+ inline$$BorrowField$1$size@1@@10 1)))) (and (= inline$$BorrowField$1$dst@1@@10 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$BorrowField$1$p@2@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) $Diem_Diem_value))) (= (ControlFlow 0 338894) 338932))) inline$$ReadRef$1$anon0_correct@@10))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon25_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@9) (= (ControlFlow 0 338946) 338894)) inline$$BorrowField$1$anon0_correct@@10)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon12_correct  (=> (and (= $abort_code@4@@23 $abort_code@2@@23) (= (ControlFlow 0 338720) 338728)) inline$$Diem_withdraw_$def_verify$0$Abort_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 338718) 338720)) inline$$Diem_withdraw_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 338736) 338720) inline$$Diem_withdraw_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon25_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@9)) (= $abort_code@2@@23 (|i#$Integer| call3formal@$ret0@0@@69))) (and (=> (= (ControlFlow 0 338712) 338736) inline$$Diem_withdraw_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 338712) 338718) inline$$Diem_withdraw_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon23_Else_correct  (=> (not $abort_flag@0@@35) (and (=> (= (ControlFlow 0 338700) 338946) inline$$Diem_withdraw_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 338700) 338712) inline$$Diem_withdraw_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon4$5_correct  (=> (and (and (and (= inline$$Diem_withdraw_$def_verify$0$$t9@1 ($Integer 10)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@35)) (and (=> $abort_flag@0@@35 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@0@@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@69 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@69) (>= (|i#$Integer| call3formal@$ret0@0@@69) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@69) $MAX_U64))) (and (=> (= (ControlFlow 0 338694) 339895) inline$$Diem_withdraw_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 338694) 338700) inline$$Diem_withdraw_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@9  (=> (and (= inline$$Ge$0$dst@1@@9 ($Boolean (>= (|i#$Integer| inline$$ReadRef$0$v@1@@14) (|i#$Integer| amount@@0)))) (= (ControlFlow 0 338682) 338694)) inline$$Diem_withdraw_$def_verify$0$anon4$5_correct)))
(let ((inline$$Ge$0$Entry_correct@@9  (and (=> (= (ControlFlow 0 338668) (- 0 563938)) true) (=> (= (ControlFlow 0 338668) 338682) inline$$Ge$0$anon0_correct@@9))))
(let ((inline$$ReadRef$0$anon0_correct@@14  (=> (and (= inline$$ReadRef$0$v@1@@14 (|v#$Mutation| inline$$BorrowField$0$dst@1@@13)) (= (ControlFlow 0 338610) 338668)) inline$$Ge$0$Entry_correct@@9)))
(let ((inline$$BorrowField$0$anon0_correct@@13  (=> (= inline$$BorrowField$0$p@1@@13 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@10)) (=> (and (and (= inline$$BorrowField$0$size@1@@13 (|size#$Path| inline$$BorrowField$0$p@1@@13)) (= inline$$BorrowField$0$p@2@@13 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@13) inline$$BorrowField$0$size@1@@13 $Diem_Diem_value) (+ inline$$BorrowField$0$size@1@@13 1)))) (and (= inline$$BorrowField$0$dst@1@@13 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@10) inline$$BorrowField$0$p@2@@13 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@10))) $Diem_Diem_value))) (= (ControlFlow 0 338572) 338610))) inline$$ReadRef$0$anon0_correct@@14))))
(let ((inline$$BorrowLoc$0$anon0_correct@@10  (=> (and (= inline$$BorrowLoc$0$dst@1@@10 ($Mutation ($Local 4) $EmptyPath coin@@7)) (= (ControlFlow 0 338412) 338572)) inline$$BorrowField$0$anon0_correct@@13)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 338294) 338412)) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 339919) 338412) inline$$BorrowLoc$0$anon0_correct@@10)))
(let ((inline$$Diem_withdraw_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 338286) 339919) inline$$Diem_withdraw_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 338286) 338294) inline$$Diem_withdraw_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 339927) 339919) inline$$Diem_withdraw_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 339927) 338294) inline$$Diem_withdraw_$def_verify$0$anon22_Else_correct))))
(let ((inline$$Diem_withdraw_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 338280) 339927) inline$$Diem_withdraw_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 338280) 338286) inline$$Diem_withdraw_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct@@35  (=> (and (forall (($inv_addr@@85 Int) ($inv_tv0@@64 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85)) (let ((va@@599 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))))
(let ((l@@599 (|l#$ValueArray| va@@599)))
 (and (and (<= 0 l@@599) (<= l@@599 $MAX_U64)) (forall ((x@@605 Int) ) (!  (=> (or (< x@@605 0) (>= x@@605 l@@599)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@599) x@@605) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@599) x@@605))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@64) 1) $inv_addr@@85))
)) (= (ControlFlow 0 339935) 338280)) inline$$Diem_withdraw_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@36  (=> (and (and (and (and (and ((_ is $Vector) coin@@7) (let ((va@@600 (|v#$Vector| coin@@7)))
(let ((l@@600 (|l#$ValueArray| va@@600)))
 (and (and (<= 0 l@@600) (<= l@@600 $MAX_U64)) (forall ((x@@606 Int) ) (!  (=> (or (< x@@606 0) (>= x@@606 l@@600)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@600) x@@606) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@600) x@@606))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@7)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@7)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and ((_ is $Integer) amount@@0) (>= (|i#$Integer| amount@@0) 0)) (<= (|i#$Integer| amount@@0) $MAX_U64)) (= (ControlFlow 0 337810) 339935))) anon0$1_correct@@35)))
(let ((PreconditionGeneratedEntry_correct@@25  (=> (= (ControlFlow 0 562530) 337810) anon0_correct@@36)))
PreconditionGeneratedEntry_correct@@25)))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@35 () Bool)
(declare-fun inline$$Diem_withdraw_all_$def_verify$0$$ret0@2 () T@$Value)
(declare-fun coin@@8 () T@$Value)
(declare-fun inline$$Diem_withdraw_all_$def_verify$0$$ret1@2 () T@$Value)
(declare-fun $tv0@@44 () T@$TypeValue)
(declare-fun inline$$Diem_withdraw_all_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun inline$$Diem_withdraw_all_$def_verify$0$$ret1@1 () T@$Value)
(declare-fun $abort_flag@0@@36 () Bool)
(declare-fun call5formal@$ret0@0@@4 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2@@9| () T@$Value)
(declare-fun |inline$$WriteRef$0$to'@1@@16| () T@$Mutation)
(declare-fun |inline$$WritebackToValue$0$vdst'@1@@11| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1@@11 () T@$Mutation)
(declare-fun call6formal@$ret1@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@11 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@15 () T@$Value)
(declare-fun $abort_code@1@@33 () Int)
(declare-fun inline$$BorrowField$0$dst@1@@14 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1@@14 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@14 () Int)
(declare-fun inline$$BorrowField$0$p@2@@14 () T@$Path)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 565511) (let ((anon0$2_correct@@37  (and (=> (= (ControlFlow 0 341301) (- 0 568508)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@35)) (=> (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@35) (and (=> (= (ControlFlow 0 341301) (- 0 568517)) (=> $abort_flag@1@@35 (|b#$Boolean| ($Boolean false)))) (=> (=> $abort_flag@1@@35 (|b#$Boolean| ($Boolean false))) (and (=> (= (ControlFlow 0 341301) (- 0 568526)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_all_$def_verify$0$$ret0@2)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@8)) $Diem_Diem_value)))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_all_$def_verify$0$$ret0@2)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@8)) $Diem_Diem_value))))) (and (=> (= (ControlFlow 0 341301) (- 0 568548)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_all_$def_verify$0$$ret1@2)) $Diem_Diem_value) ($Integer 0)))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_withdraw_all_$def_verify$0$$ret1@2)) $Diem_Diem_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 341301) (- 0 568568)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568617)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@592 T@$Value) )  (=> ((_ is $Address) addr@@592) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@592))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@592)))))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@593 T@$Value) )  (=> ((_ is $Address) addr@@593) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@593))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@593))))))))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568697)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@594 T@$Value) )  (=> ((_ is $Address) addr@@594) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@594)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@594))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@595 T@$Value) )  (=> ((_ is $Address) addr@@595) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@595)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@595)))))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568765)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568814)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@596 T@$Value) )  (=> ((_ is $Address) addr@@596) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@596))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@596)))))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@597 T@$Value) )  (=> ((_ is $Address) addr@@597) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@597))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@597))))))))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568894)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@598 T@$Value) )  (=> ((_ is $Address) addr@@598) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@598)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@598))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@599 T@$Value) )  (=> ((_ is $Address) addr@@599) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@599)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@599)))))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 568962)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 569011)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 569060)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@600 T@$Value) )  (=> ((_ is $Address) addr@@600) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@600))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@600)))))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@601 T@$Value) )  (=> ((_ is $Address) addr@@601) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@601))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@601))))))))))))))) (and (=> (= (ControlFlow 0 341301) (- 0 569140)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@602 T@$Value) )  (=> ((_ is $Address) addr@@602) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@602)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@602))))))))))))) (=> (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean (forall ((addr@@603 T@$Value) )  (=> ((_ is $Address) addr@@603) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@603)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@603)))))))))))) (=> (= (ControlFlow 0 341301) (- 0 569208)) (=> (not $abort_flag@1@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))))))))))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon7_correct  (=> (and (= inline$$Diem_withdraw_all_$def_verify$0$$ret0@1 $Error) (= inline$$Diem_withdraw_all_$def_verify$0$$ret1@1 $Error)) (=> (and (and (= $abort_flag@1@@35 true) (= inline$$Diem_withdraw_all_$def_verify$0$$ret0@2 inline$$Diem_withdraw_all_$def_verify$0$$ret0@1)) (and (= inline$$Diem_withdraw_all_$def_verify$0$$ret1@2 inline$$Diem_withdraw_all_$def_verify$0$$ret1@1) (= (ControlFlow 0 341267) 341301))) anon0$2_correct@@37))))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon16_Else_correct  (=> (and (not true) (= (ControlFlow 0 341259) 341267)) inline$$Diem_withdraw_all_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon16_Then_correct  (=> (= (ControlFlow 0 341275) 341267) inline$$Diem_withdraw_all_$def_verify$0$anon7_correct)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon15_Then_correct  (=> $abort_flag@0@@36 (and (=> (= (ControlFlow 0 341253) 341275) inline$$Diem_withdraw_all_$def_verify$0$anon16_Then_correct) (=> (= (ControlFlow 0 341253) 341259) inline$$Diem_withdraw_all_$def_verify$0$anon16_Else_correct)))))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon12_correct  (=> (and (and (= $abort_flag@1@@35 $abort_flag@0@@36) (= inline$$Diem_withdraw_all_$def_verify$0$$ret0@2 call5formal@$ret0@0@@4)) (and (= inline$$Diem_withdraw_all_$def_verify$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2@@9|) (= (ControlFlow 0 341233) 341301))) anon0$2_correct@@37)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon18_Else_correct  (=> (and (not true) (= (ControlFlow 0 341231) 341233)) inline$$Diem_withdraw_all_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon18_Then_correct  (=> (= (ControlFlow 0 341241) 341233) inline$$Diem_withdraw_all_$def_verify$0$anon12_correct)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon17_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 341221) 341241) inline$$Diem_withdraw_all_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 341221) 341231) inline$$Diem_withdraw_all_$def_verify$0$anon18_Else_correct)))))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon17_Then_correct  (and (=> (= (ControlFlow 0 341249) 341241) inline$$Diem_withdraw_all_$def_verify$0$anon18_Then_correct) (=> (= (ControlFlow 0 341249) 341231) inline$$Diem_withdraw_all_$def_verify$0$anon18_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct@@11  (=> (and (not (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@16|) ($Local 2))) (= |inline$$WritebackToValue$0$vdst'@2@@9| coin@@8)) (and (=> (= (ControlFlow 0 341179) 341249) inline$$Diem_withdraw_all_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 341179) 341221) inline$$Diem_withdraw_all_$def_verify$0$anon17_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct@@11  (=> (= (|l#$Mutation| |inline$$WriteRef$0$to'@1@@16|) ($Local 2)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1@@11| ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$0$to'@1@@16|) 0 coin@@8 (|v#$Mutation| |inline$$WriteRef$0$to'@1@@16|))) (= |inline$$WritebackToValue$0$vdst'@2@@9| |inline$$WritebackToValue$0$vdst'@1@@11|)) (and (=> (= (ControlFlow 0 341205) 341249) inline$$Diem_withdraw_all_$def_verify$0$anon17_Then_correct) (=> (= (ControlFlow 0 341205) 341221) inline$$Diem_withdraw_all_$def_verify$0$anon17_Else_correct))))))
(let ((inline$$WriteRef$0$anon0_correct@@16  (=> (= |inline$$WriteRef$0$to'@1@@16| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@11) (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@11) call6formal@$ret1@0@@0)) (and (=> (= (ControlFlow 0 341080) 341205) inline$$WritebackToValue$0$anon3_Then_correct@@11) (=> (= (ControlFlow 0 341080) 341179) inline$$WritebackToValue$0$anon3_Else_correct@@11)))))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon15_Else_correct  (=> (and (not $abort_flag@0@@36) (= (ControlFlow 0 341086) 341080)) inline$$WriteRef$0$anon0_correct@@16)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon4$1_correct  (and (=> (= (ControlFlow 0 341023) (- 0 567529)) true) (=> (and (and (and (and (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11)) $Diem_Diem_value)) (|i#$Integer| inline$$ReadRef$0$v@1@@15)))) $abort_flag@0@@36) (=> $abort_flag@0@@36 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11)) $Diem_Diem_value)) (|i#$Integer| inline$$ReadRef$0$v@1@@15)))))) (and (=> $abort_flag@0@@36 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11)) $Diem_Diem_value)) (|i#$Integer| inline$$ReadRef$0$v@1@@15)))) (= $abort_code@1@@33 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1@@11)) $Diem_Diem_value)) (|i#$Integer| inline$$ReadRef$0$v@1@@15))))))))) (and (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@4)) $Diem_Diem_value) inline$$ReadRef$0$v@1@@15)))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@604 T@$Value) )  (=> ((_ is $Address) addr@@604) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@604))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@604))))))))))))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@605 T@$Value) )  (=> ((_ is $Address) addr@@605) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@605)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@605))))))))))))))) (and (and (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@606 T@$Value) )  (=> ((_ is $Address) addr@@606) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@606))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@606)))))))))))))))) (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@607 T@$Value) )  (=> ((_ is $Address) addr@@607) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@607)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@607)))))))))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@608 T@$Value) )  (=> ((_ is $Address) addr@@608) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@608))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@608)))))))))))))))) (and (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean (forall ((addr@@609 T@$Value) )  (=> ((_ is $Address) addr@@609) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@609)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| addr@@609)))))))))))) (=> (not $abort_flag@0@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@44) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))) (=> (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@4) (let ((va@@601 (|v#$Vector| call5formal@$ret0@0@@4)))
(let ((l@@601 (|l#$ValueArray| va@@601)))
 (and (and (<= 0 l@@601) (<= l@@601 $MAX_U64)) (forall ((x@@607 Int) ) (!  (=> (or (< x@@607 0) (>= x@@607 l@@601)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@601) x@@607) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@601) x@@607))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@4)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@4)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@4)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@4)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call6formal@$ret1@0@@0) (let ((va@@602 (|v#$Vector| call6formal@$ret1@0@@0)))
(let ((l@@602 (|l#$ValueArray| va@@602)))
 (and (and (<= 0 l@@602) (<= l@@602 $MAX_U64)) (forall ((x@@608 Int) ) (!  (=> (or (< x@@608 0) (>= x@@608 l@@602)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@602) x@@608) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@602) x@@608))
)))))) (= (|l#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0@@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 341023) 341253) inline$$Diem_withdraw_all_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 341023) 341086) inline$$Diem_withdraw_all_$def_verify$0$anon15_Else_correct)))))))
(let ((inline$$ReadRef$1$anon0_correct@@11  (=> (and (= inline$$ReadRef$1$v@1@@11 (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (= (ControlFlow 0 341011) 341023)) inline$$Diem_withdraw_all_$def_verify$0$anon4$1_correct)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon14_Else_correct  (=> (and (not true) (= (ControlFlow 0 340979) 341011)) inline$$ReadRef$1$anon0_correct@@11)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon14_Then_correct  (=> (= (ControlFlow 0 341283) 341011) inline$$ReadRef$1$anon0_correct@@11)))
(let ((inline$$ReadRef$0$anon0_correct@@15  (=> (= inline$$ReadRef$0$v@1@@15 (|v#$Mutation| inline$$BorrowField$0$dst@1@@14)) (and (=> (= (ControlFlow 0 340923) 341283) inline$$Diem_withdraw_all_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 340923) 340979) inline$$Diem_withdraw_all_$def_verify$0$anon14_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct@@14  (=> (= inline$$BorrowField$0$p@1@@14 (|p#$Mutation| inline$$BorrowLoc$0$dst@1@@11)) (=> (and (and (= inline$$BorrowField$0$size@1@@14 (|size#$Path| inline$$BorrowField$0$p@1@@14)) (= inline$$BorrowField$0$p@2@@14 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@14) inline$$BorrowField$0$size@1@@14 $Diem_Diem_value) (+ inline$$BorrowField$0$size@1@@14 1)))) (and (= inline$$BorrowField$0$dst@1@@14 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1@@11) inline$$BorrowField$0$p@2@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1@@11))) $Diem_Diem_value))) (= (ControlFlow 0 340885) 340923))) inline$$ReadRef$0$anon0_correct@@15))))
(let ((inline$$BorrowLoc$0$anon0_correct@@11  (=> (and (= inline$$BorrowLoc$0$dst@1@@11 ($Mutation ($Local 2) $EmptyPath coin@@8)) (= (ControlFlow 0 340725) 340885)) inline$$BorrowField$0$anon0_correct@@14)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon13_Else_correct  (=> (and (not true) (= (ControlFlow 0 340641) 340725)) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon13_Then_correct  (=> (= (ControlFlow 0 341291) 340725) inline$$BorrowLoc$0$anon0_correct@@11)))
(let ((inline$$Diem_withdraw_all_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 340635) 341291) inline$$Diem_withdraw_all_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 340635) 340641) inline$$Diem_withdraw_all_$def_verify$0$anon13_Else_correct)))))
(let ((anon0$1_correct@@36  (=> (and (forall (($inv_addr@@86 Int) ($inv_tv0@@65 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86)) (let ((va@@603 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))))
(let ((l@@603 (|l#$ValueArray| va@@603)))
 (and (and (<= 0 l@@603) (<= l@@603 $MAX_U64)) (forall ((x@@609 Int) ) (!  (=> (or (< x@@609 0) (>= x@@609 l@@603)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@603) x@@609) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@603) x@@609))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@65) 1) $inv_addr@@86))
)) (= (ControlFlow 0 341299) 340635)) inline$$Diem_withdraw_all_$def_verify$0$anon0_correct)))
(let ((anon0_correct@@37  (=> (and (and (and (and (and ((_ is $Vector) coin@@8) (let ((va@@604 (|v#$Vector| coin@@8)))
(let ((l@@604 (|l#$ValueArray| va@@604)))
 (and (and (<= 0 l@@604) (<= l@@604 $MAX_U64)) (forall ((x@@610 Int) ) (!  (=> (or (< x@@610 0) (>= x@@610 l@@604)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@604) x@@610) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@604) x@@610))
)))))) (= (|l#$ValueArray| (|v#$Vector| coin@@8)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@8)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@8)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| coin@@8)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 340307) 341299)) anon0$1_correct@@36)))
(let ((PreconditionGeneratedEntry_correct@@26  (=> (= (ControlFlow 0 565511) 340307) anon0_correct@@37)))
PreconditionGeneratedEntry_correct@@26))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@1@@36 () Bool)
(declare-fun $tv0@@45 () T@$TypeValue)
(declare-fun inline$$Diem_zero_$def_verify$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@0@@37 () Bool)
(declare-fun inline$$Diem_zero_$def_verify$0$$t0@1 () T@$Value)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1@@3 () T@$Value)
(declare-fun $abort_code@1@@34 () Int)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 569258) (let ((anon0$2_correct@@38  (and (=> (= (ControlFlow 0 341995) (- 0 571743)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 571792)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@610 T@$Value) )  (=> ((_ is $Address) addr@@610) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@610))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@610)))))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@611 T@$Value) )  (=> ((_ is $Address) addr@@611) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@611))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@611))))))))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 571872)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@612 T@$Value) )  (=> ((_ is $Address) addr@@612) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@612)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@612))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@613 T@$Value) )  (=> ((_ is $Address) addr@@613) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@613)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@613)))))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 571940)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 571989)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@614 T@$Value) )  (=> ((_ is $Address) addr@@614) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@614))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@614)))))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@615 T@$Value) )  (=> ((_ is $Address) addr@@615) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@615))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@615))))))))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 572069)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@616 T@$Value) )  (=> ((_ is $Address) addr@@616) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@616)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@616))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@617 T@$Value) )  (=> ((_ is $Address) addr@@617) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@617)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@617)))))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 572137)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 572186)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 572235)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@618 T@$Value) )  (=> ((_ is $Address) addr@@618) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@618))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@618)))))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@619 T@$Value) )  (=> ((_ is $Address) addr@@619) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@619))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@619))))))))))))))) (and (=> (= (ControlFlow 0 341995) (- 0 572315)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@620 T@$Value) )  (=> ((_ is $Address) addr@@620) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@620)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@620))))))))))))) (=> (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean (forall ((addr@@621 T@$Value) )  (=> ((_ is $Address) addr@@621) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@621)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@621)))))))))))) (=> (= (ControlFlow 0 341995) (- 0 572383)) (=> (not $abort_flag@1@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate)))))))))))))))))))))))))))))))
(let ((inline$$Diem_zero_$def_verify$0$anon3_correct  (=> (= inline$$Diem_zero_$def_verify$0$$ret0@1 $Error) (=> (and (= $abort_flag@1@@36 true) (= (ControlFlow 0 341979) 341995)) anon0$2_correct@@38))))
(let ((inline$$Diem_zero_$def_verify$0$anon8_Else_correct  (=> (and (not true) (= (ControlFlow 0 341973) 341979)) inline$$Diem_zero_$def_verify$0$anon3_correct)))
(let ((inline$$Diem_zero_$def_verify$0$anon8_Then_correct  (=> (= (ControlFlow 0 341987) 341979) inline$$Diem_zero_$def_verify$0$anon3_correct)))
(let ((inline$$Diem_zero_$def_verify$0$anon7_Then_correct  (=> $abort_flag@0@@37 (and (=> (= (ControlFlow 0 341967) 341987) inline$$Diem_zero_$def_verify$0$anon8_Then_correct) (=> (= (ControlFlow 0 341967) 341973) inline$$Diem_zero_$def_verify$0$anon8_Else_correct)))))
(let ((inline$$Diem_zero_$def_verify$0$anon6_correct  (=> (and (= $abort_flag@1@@36 $abort_flag@0@@37) (= (ControlFlow 0 341955) 341995)) anon0$2_correct@@38)))
(let ((inline$$Diem_zero_$def_verify$0$anon9_Else_correct  (=> (and (not true) (= (ControlFlow 0 341953) 341955)) inline$$Diem_zero_$def_verify$0$anon6_correct)))
(let ((inline$$Diem_zero_$def_verify$0$anon9_Then_correct  (=> (= (ControlFlow 0 341963) 341955) inline$$Diem_zero_$def_verify$0$anon6_correct)))
(let ((inline$$Diem_Diem_pack$0$anon4_Else_correct@@3  (=> (not true) (and (=> (= (ControlFlow 0 341931) 341963) inline$$Diem_zero_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 341931) 341953) inline$$Diem_zero_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon4_Then_correct@@3  (and (=> (= (ControlFlow 0 341937) 341963) inline$$Diem_zero_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 341937) 341953) inline$$Diem_zero_$def_verify$0$anon9_Else_correct))))
(let ((inline$$Diem_Diem_pack$0$anon3_Then_correct@@3  (=> (> 0 0) (and (=> (= (ControlFlow 0 341925) 341937) inline$$Diem_Diem_pack$0$anon4_Then_correct@@3) (=> (= (ControlFlow 0 341925) 341931) inline$$Diem_Diem_pack$0$anon4_Else_correct@@3)))))
(let ((inline$$Diem_Diem_pack$0$anon3_Else_correct@@3  (=> (>= 0 0) (and (=> (= (ControlFlow 0 341917) 341963) inline$$Diem_zero_$def_verify$0$anon9_Then_correct) (=> (= (ControlFlow 0 341917) 341953) inline$$Diem_zero_$def_verify$0$anon9_Else_correct)))))
(let ((inline$$Diem_Diem_pack$0$anon0_correct@@3  (=> (and (and (and ((_ is $Integer) inline$$Diem_zero_$def_verify$0$$t0@1) (>= (|i#$Integer| inline$$Diem_zero_$def_verify$0$$t0@1) 0)) (<= (|i#$Integer| inline$$Diem_zero_$def_verify$0$$t0@1) $MAX_U64)) (= inline$$Diem_Diem_pack$0$$struct@1@@3 ($Vector ($ValueArray (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$Diem_zero_$def_verify$0$$t0@1) 1)))) (and (=> (= (ControlFlow 0 341909) 341925) inline$$Diem_Diem_pack$0$anon3_Then_correct@@3) (=> (= (ControlFlow 0 341909) 341917) inline$$Diem_Diem_pack$0$anon3_Else_correct@@3)))))
(let ((inline$$Diem_zero_$def_verify$0$anon7_Else_correct  (=> (not $abort_flag@0@@37) (=> (and (= inline$$Diem_zero_$def_verify$0$$t0@1 ($Integer 0)) (= (ControlFlow 0 341943) 341909)) inline$$Diem_Diem_pack$0$anon0_correct@@3))))
(let ((inline$$Diem_zero_$def_verify$0$anon0_correct  (=> (not false) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@37) (=> $abort_flag@0@@37 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816)))))))))) (=> (and (and (=> $abort_flag@0@@37 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@34 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)))))))))) (and (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@622 T@$Value) )  (=> ((_ is $Address) addr@@622) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@622))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@622))))))))))))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@623 T@$Value) )  (=> ((_ is $Address) addr@@623) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@623)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@623)))))))))))))) (=> (and (and (and (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_total_value))))))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@624 T@$Value) )  (=> ((_ is $Address) addr@@624) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@624))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@624)))))))))))))))) (and (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@625 T@$Value) )  (=> ((_ is $Address) addr@@625) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@625)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@625)))))))))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))))) (and (and (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value))))))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@626 T@$Value) )  (=> ((_ is $Address) addr@@626) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@626))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@626)))))))))))))))) (and (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean (forall ((addr@@627 T@$Value) )  (=> ((_ is $Address) addr@@627) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@627)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| addr@@627)))))))))))) (=> (not $abort_flag@0@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@45) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))))))))) (and (=> (= (ControlFlow 0 341768) 341967) inline$$Diem_zero_$def_verify$0$anon7_Then_correct) (=> (= (ControlFlow 0 341768) 341943) inline$$Diem_zero_$def_verify$0$anon7_Else_correct))))))))
(let ((anon0$1_correct@@37  (=> (forall (($inv_addr@@87 Int) ($inv_tv0@@66 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87)) (let ((va@@605 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))))
(let ((l@@605 (|l#$ValueArray| va@@605)))
 (and (and (<= 0 l@@605) (<= l@@605 $MAX_U64)) (forall ((x@@611 Int) ) (!  (=> (or (< x@@611 0) (>= x@@611 l@@605)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@605) x@@611) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@605) x@@611))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@606 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@606 (|l#$ValueArray| va@@606)))
 (and (and (<= 0 l@@606) (<= l@@606 $MAX_U64)) (forall ((x@@612 Int) ) (!  (=> (or (< x@@612 0) (>= x@@612 l@@606)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@606) x@@612) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@606) x@@612))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code)) (let ((va@@607 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@607 (|l#$ValueArray| va@@607)))
 (and (and (<= 0 l@@607) (<= l@@607 $MAX_U64)) (forall ((x@@613 Int) ) (!  (=> (or (< x@@613 0) (>= x@@613 l@@607)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@607) x@@613) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@607) x@@613))
))))))) (forall (($$0@@205 Int) ) (!  (=> (and (>= $$0@@205 0) (< $$0@@205 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))) $$0@@205)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))) $$0@@205)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))) $$0@@205)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_currency_code))) $$0@@205))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events)) (let ((va@@608 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@608 (|l#$ValueArray| va@@608)))
 (and (and (<= 0 l@@608) (<= l@@608 $MAX_U64)) (forall ((x@@614 Int) ) (!  (=> (or (< x@@614 0) (>= x@@614 l@@608)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@608) x@@614) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@608) x@@614))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@609 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@609 (|l#$ValueArray| va@@609)))
 (and (and (<= 0 l@@609) (<= l@@609 $MAX_U64)) (forall ((x@@615 Int) ) (!  (=> (or (< x@@615 0) (>= x@@615 l@@609)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@609) x@@615) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@609) x@@615))
))))))) (forall (($$0@@206 Int) ) (!  (=> (and (>= $$0@@206 0) (< $$0@@206 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@206)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@206)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@206)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@206))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events)) (let ((va@@610 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@610 (|l#$ValueArray| va@@610)))
 (and (and (<= 0 l@@610) (<= l@@610 $MAX_U64)) (forall ((x@@616 Int) ) (!  (=> (or (< x@@616 0) (>= x@@616 l@@610)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@610) x@@616) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@610) x@@616))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@611 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@611 (|l#$ValueArray| va@@611)))
 (and (and (<= 0 l@@611) (<= l@@611 $MAX_U64)) (forall ((x@@617 Int) ) (!  (=> (or (< x@@617 0) (>= x@@617 l@@611)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@611) x@@617) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@611) x@@617))
))))))) (forall (($$0@@207 Int) ) (!  (=> (and (>= $$0@@207 0) (< $$0@@207 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@207)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@207)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@207)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@207))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@612 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@612 (|l#$ValueArray| va@@612)))
 (and (and (<= 0 l@@612) (<= l@@612 $MAX_U64)) (forall ((x@@618 Int) ) (!  (=> (or (< x@@618 0) (>= x@@618 l@@612)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@612) x@@618) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@612) x@@618))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@613 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@613 (|l#$ValueArray| va@@613)))
 (and (and (<= 0 l@@613) (<= l@@613 $MAX_U64)) (forall ((x@@619 Int) ) (!  (=> (or (< x@@619 0) (>= x@@619 l@@613)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@613) x@@619) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@613) x@@619))
))))))) (forall (($$0@@208 Int) ) (!  (=> (and (>= $$0@@208 0) (< $$0@@208 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@208)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@208)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@208)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@208))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@614 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@614 (|l#$ValueArray| va@@614)))
 (and (and (<= 0 l@@614) (<= l@@614 $MAX_U64)) (forall ((x@@620 Int) ) (!  (=> (or (< x@@620 0) (>= x@@620 l@@614)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@614) x@@620) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@614) x@@620))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@615 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@615 (|l#$ValueArray| va@@615)))
 (and (and (<= 0 l@@615) (<= l@@615 $MAX_U64)) (forall ((x@@621 Int) ) (!  (=> (or (< x@@621 0) (>= x@@621 l@@615)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@615) x@@621) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@615) x@@621))
))))))) (forall (($$0@@209 Int) ) (!  (=> (and (>= $$0@@209 0) (< $$0@@209 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@209)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@209)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@209)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@209))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@616 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@616 (|l#$ValueArray| va@@616)))
 (and (and (<= 0 l@@616) (<= l@@616 $MAX_U64)) (forall ((x@@622 Int) ) (!  (=> (or (< x@@622 0) (>= x@@622 l@@616)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@616) x@@622) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@616) x@@622))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@617 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@617 (|l#$ValueArray| va@@617)))
 (and (and (<= 0 l@@617) (<= l@@617 $MAX_U64)) (forall ((x@@623 Int) ) (!  (=> (or (< x@@623 0) (>= x@@623 l@@617)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@617) x@@623) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@617) x@@623))
))))))) (forall (($$0@@210 Int) ) (!  (=> (and (>= $$0@@210 0) (< $$0@@210 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@210)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@210)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@210)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@210))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@66) 1) $inv_addr@@87))
)) (=> (and (|b#$Boolean| ($Boolean (forall ((coin_type@@67 T@$Value) )  (=> ((_ is $Type) coin_type@@67) (|b#$Boolean| ($Boolean (forall ((addr3@@29 T@$Value) )  (=> ((_ is $Address) addr3@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@67)) 1) (|a#$Address| addr3@@29)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@67)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@67)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (= (ControlFlow 0 341993) 341768)) inline$$Diem_zero_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@38  (=> (= (ControlFlow 0 569258) 341993) anon0$1_correct@@37)))
anon0_correct@@38))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
