(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $AccountFreezing_FreezeAccountEvent () T@$TypeName)
(declare-fun $AccountFreezing_FreezeEventsHolder () T@$TypeName)
(declare-fun $AccountFreezing_FreezingBit () T@$TypeName)
(declare-fun $AccountFreezing_UnfreezeAccountEvent () T@$TypeName)
(declare-fun $AccountLimits_AccountLimitMutationCapability () T@$TypeName)
(declare-fun $AccountLimits_LimitsDefinition () T@$TypeName)
(declare-fun $AccountLimits_Window () T@$TypeName)
(declare-fun $ChainId_ChainId () T@$TypeName)
(declare-fun $FixedPoint32_FixedPoint32 () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies () T@$TypeName)
(declare-fun $Diem_Diem () T@$TypeName)
(declare-fun $Diem_BurnCapability () T@$TypeName)
(declare-fun $Diem_BurnEvent () T@$TypeName)
(declare-fun $Diem_CancelBurnEvent () T@$TypeName)
(declare-fun $Diem_CurrencyInfo () T@$TypeName)
(declare-fun $Diem_MintCapability () T@$TypeName)
(declare-fun $Diem_MintEvent () T@$TypeName)
(declare-fun $Diem_Preburn () T@$TypeName)
(declare-fun $Diem_PreburnEvent () T@$TypeName)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent () T@$TypeName)
(declare-fun $XUS_XUS () T@$TypeName)
(declare-fun $DesignatedDealer_Dealer () T@$TypeName)
(declare-fun $DesignatedDealer_ReceivedMintEvent () T@$TypeName)
(declare-fun $DesignatedDealer_TierInfo () T@$TypeName)
(declare-fun $XDX_XDX () T@$TypeName)
(declare-fun $XDX_Reserve () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $VASP_ChildVASP () T@$TypeName)
(declare-fun $VASP_ParentVASP () T@$TypeName)
(declare-fun $TransactionFee_TransactionFee () T@$TypeName)
(declare-fun $SlidingNonce_SlidingNonce () T@$TypeName)
(declare-fun $DualAttestation_BaseUrlRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent () T@$TypeName)
(declare-fun $DualAttestation_Credential () T@$TypeName)
(declare-fun $DualAttestation_Limit () T@$TypeName)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption () T@$TypeName)
(declare-fun $DiemAccount_DiemAccount () T@$TypeName)
(declare-fun $DiemAccount_AccountOperationsCapability () T@$TypeName)
(declare-fun $DiemAccount_AdminTransactionEvent () T@$TypeName)
(declare-fun $DiemAccount_Balance () T@$TypeName)
(declare-fun $DiemAccount_CreateAccountEvent () T@$TypeName)
(declare-fun $DiemAccount_DiemWriteSetManager () T@$TypeName)
(declare-fun $DiemAccount_KeyRotationCapability () T@$TypeName)
(declare-fun $DiemAccount_ReceivedPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_SentPaymentEvent () T@$TypeName)
(declare-fun $DiemAccount_WithdrawCapability () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_frozen_address () Int)
(declare-fun $AccountFreezing_FreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezeEventsHolder_freeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle () Int)
(declare-fun $AccountFreezing_FreezeEventsHolder_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_FreezingBit_is_frozen () Int)
(declare-fun $AccountFreezing_FreezingBit_type_value () T@$TypeValue)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_initiator_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_unfrozen_address () Int)
(declare-fun $AccountFreezing_UnfreezeAccountEvent_type_value () T@$TypeValue)
(declare-fun $AccountLimits_AccountLimitMutationCapability_dummy_field () Int)
(declare-fun $AccountLimits_AccountLimitMutationCapability_type_value () T@$TypeValue)
(declare-fun $AccountLimits_LimitsDefinition_max_inflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_outflow () Int)
(declare-fun $AccountLimits_LimitsDefinition_time_period () Int)
(declare-fun $AccountLimits_LimitsDefinition_max_holding () Int)
(declare-fun $AccountLimits_LimitsDefinition_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $AccountLimits_Window_window_start () Int)
(declare-fun $AccountLimits_Window_window_inflow () Int)
(declare-fun $AccountLimits_Window_window_outflow () Int)
(declare-fun $AccountLimits_Window_tracked_balance () Int)
(declare-fun $AccountLimits_Window_limit_address () Int)
(declare-fun $AccountLimits_Window_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ChainId_ChainId_id () Int)
(declare-fun $ChainId_ChainId_type_value () T@$TypeValue)
(declare-fun $FixedPoint32_FixedPoint32_value () Int)
(declare-fun $FixedPoint32_FixedPoint32_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_currency_codes () Int)
(declare-fun $RegisteredCurrencies_RegisteredCurrencies_type_value () T@$TypeValue)
(declare-fun $Diem_Diem_value () Int)
(declare-fun $Diem_Diem_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnCapability_dummy_field () Int)
(declare-fun $Diem_BurnCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_BurnEvent_amount () Int)
(declare-fun $Diem_BurnEvent_currency_code () Int)
(declare-fun $Diem_BurnEvent_preburn_address () Int)
(declare-fun $Diem_BurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CancelBurnEvent_amount () Int)
(declare-fun $Diem_CancelBurnEvent_currency_code () Int)
(declare-fun $Diem_CancelBurnEvent_preburn_address () Int)
(declare-fun $Diem_CancelBurnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_CurrencyInfo_total_value () Int)
(declare-fun $Diem_CurrencyInfo_preburn_value () Int)
(declare-fun $Diem_CurrencyInfo_to_xdx_exchange_rate () Int)
(declare-fun $Diem_CurrencyInfo_is_synthetic () Int)
(declare-fun $Diem_CurrencyInfo_scaling_factor () Int)
(declare-fun $Diem_CurrencyInfo_fractional_part () Int)
(declare-fun $Diem_CurrencyInfo_currency_code () Int)
(declare-fun $Diem_CurrencyInfo_can_mint () Int)
(declare-fun $Diem_CurrencyInfo_mint_events () Int)
(declare-fun $Diem_CurrencyInfo_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_preburn_events () Int)
(declare-fun $Diem_CurrencyInfo_cancel_burn_events () Int)
(declare-fun $Diem_CurrencyInfo_exchange_rate_update_events () Int)
(declare-fun $Diem_CurrencyInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintCapability_dummy_field () Int)
(declare-fun $Diem_MintCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_MintEvent_amount () Int)
(declare-fun $Diem_MintEvent_currency_code () Int)
(declare-fun $Diem_MintEvent_type_value () T@$TypeValue)
(declare-fun $Diem_Preburn_to_burn () Int)
(declare-fun $Diem_Preburn_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $Diem_PreburnEvent_amount () Int)
(declare-fun $Diem_PreburnEvent_currency_code () Int)
(declare-fun $Diem_PreburnEvent_preburn_address () Int)
(declare-fun $Diem_PreburnEvent_type_value () T@$TypeValue)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_currency_code () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate () Int)
(declare-fun $Diem_ToXDXExchangeRateUpdateEvent_type_value () T@$TypeValue)
(declare-fun $XUS_XUS_dummy_field () Int)
(declare-fun $XUS_XUS_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_Dealer_mint_event_handle () Int)
(declare-fun $DesignatedDealer_Dealer_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_ReceivedMintEvent_currency_code () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_destination_address () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_amount () Int)
(declare-fun $DesignatedDealer_ReceivedMintEvent_type_value () T@$TypeValue)
(declare-fun $DesignatedDealer_TierInfo_window_start () Int)
(declare-fun $DesignatedDealer_TierInfo_window_inflow () Int)
(declare-fun $DesignatedDealer_TierInfo_tiers () Int)
(declare-fun $DesignatedDealer_TierInfo_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $XDX_XDX_dummy_field () Int)
(declare-fun $XDX_XDX_type_value () T@$TypeValue)
(declare-fun $XDX_Reserve_mint_cap () Int)
(declare-fun $XDX_Reserve_burn_cap () Int)
(declare-fun $XDX_Reserve_preburn_cap () Int)
(declare-fun $XDX_Reserve_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $VASP_ChildVASP_parent_vasp_addr () Int)
(declare-fun $VASP_ChildVASP_type_value () T@$TypeValue)
(declare-fun $VASP_ParentVASP_num_children () Int)
(declare-fun $VASP_ParentVASP_type_value () T@$TypeValue)
(declare-fun $TransactionFee_TransactionFee_balance () Int)
(declare-fun $TransactionFee_TransactionFee_preburn () Int)
(declare-fun $TransactionFee_TransactionFee_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $SlidingNonce_spec_try_record_nonce (T@$Value T@$Value) T@$Value)
(declare-fun $SlidingNonce_SlidingNonce_min_nonce () Int)
(declare-fun $SlidingNonce_SlidingNonce_nonce_mask () Int)
(declare-fun $SlidingNonce_SlidingNonce_type_value () T@$TypeValue)
(declare-fun $DualAttestation_spec_dual_attestation_message (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $DualAttestation_BaseUrlRotationEvent_new_base_url () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_BaseUrlRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds () Int)
(declare-fun $DualAttestation_ComplianceKeyRotationEvent_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Credential_human_name () Int)
(declare-fun $DualAttestation_Credential_base_url () Int)
(declare-fun $DualAttestation_Credential_compliance_public_key () Int)
(declare-fun $DualAttestation_Credential_expiration_date () Int)
(declare-fun $DualAttestation_Credential_compliance_key_rotation_events () Int)
(declare-fun $DualAttestation_Credential_base_url_rotation_events () Int)
(declare-fun $DualAttestation_Credential_type_value () T@$TypeValue)
(declare-fun $DualAttestation_Limit_micro_xdx_limit () Int)
(declare-fun $DualAttestation_Limit_type_value () T@$TypeValue)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed () Int)
(declare-fun $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value () T@$TypeValue)
(declare-fun $DiemAccount_spec_abstract_create_authentication_key (T@$Value) T@$Value)
(declare-fun $DiemAccount_DiemAccount_authentication_key () Int)
(declare-fun $DiemAccount_DiemAccount_withdraw_capability () Int)
(declare-fun $DiemAccount_DiemAccount_key_rotation_capability () Int)
(declare-fun $DiemAccount_DiemAccount_received_events () Int)
(declare-fun $DiemAccount_DiemAccount_sent_events () Int)
(declare-fun $DiemAccount_DiemAccount_sequence_number () Int)
(declare-fun $DiemAccount_DiemAccount_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AccountOperationsCapability_limits_cap () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_creation_events () Int)
(declare-fun $DiemAccount_AccountOperationsCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_AdminTransactionEvent_committed_timestamp_secs () Int)
(declare-fun $DiemAccount_AdminTransactionEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_Balance_coin () Int)
(declare-fun $DiemAccount_Balance_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemAccount_CreateAccountEvent_created () Int)
(declare-fun $DiemAccount_CreateAccountEvent_role_id () Int)
(declare-fun $DiemAccount_CreateAccountEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_DiemWriteSetManager_upgrade_events () Int)
(declare-fun $DiemAccount_DiemWriteSetManager_type_value () T@$TypeValue)
(declare-fun $DiemAccount_KeyRotationCapability_account_address () Int)
(declare-fun $DiemAccount_KeyRotationCapability_type_value () T@$TypeValue)
(declare-fun $DiemAccount_ReceivedPaymentEvent_amount () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_payer () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_ReceivedPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_SentPaymentEvent_amount () Int)
(declare-fun $DiemAccount_SentPaymentEvent_currency_code () Int)
(declare-fun $DiemAccount_SentPaymentEvent_payee () Int)
(declare-fun $DiemAccount_SentPaymentEvent_metadata () Int)
(declare-fun $DiemAccount_SentPaymentEvent_type_value () T@$TypeValue)
(declare-fun $DiemAccount_WithdrawCapability_account_address () Int)
(declare-fun $DiemAccount_WithdrawCapability_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $Event_EventHandle $Event_EventHandleGenerator $AccountFreezing_FreezeAccountEvent $AccountFreezing_FreezeEventsHolder $AccountFreezing_FreezingBit $AccountFreezing_UnfreezeAccountEvent $AccountLimits_AccountLimitMutationCapability $AccountLimits_LimitsDefinition $AccountLimits_Window $ChainId_ChainId $FixedPoint32_FixedPoint32 $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $RegisteredCurrencies_RegisteredCurrencies $Diem_Diem $Diem_BurnCapability $Diem_BurnEvent $Diem_CancelBurnEvent $Diem_CurrencyInfo $Diem_MintCapability $Diem_MintEvent $Diem_Preburn $Diem_PreburnEvent $Diem_ToXDXExchangeRateUpdateEvent $XUS_XUS $DesignatedDealer_Dealer $DesignatedDealer_ReceivedMintEvent $DesignatedDealer_TierInfo $XDX_XDX $XDX_Reserve $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_Config $ValidatorConfig_ValidatorConfig $VASP_ChildVASP $VASP_ParentVASP $TransactionFee_TransactionFee $SlidingNonce_SlidingNonce $DualAttestation_BaseUrlRotationEvent $DualAttestation_ComplianceKeyRotationEvent $DualAttestation_Credential $DualAttestation_Limit $DiemTransactionPublishingOption_DiemTransactionPublishingOption $DiemAccount_DiemAccount $DiemAccount_AccountOperationsCapability $DiemAccount_AdminTransactionEvent $DiemAccount_Balance $DiemAccount_CreateAccountEvent $DiemAccount_DiemWriteSetManager $DiemAccount_KeyRotationCapability $DiemAccount_ReceivedPaymentEvent $DiemAccount_SentPaymentEvent $DiemAccount_WithdrawCapability)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_FreezeAccountEvent_frozen_address 1))
(assert (= $AccountFreezing_FreezeAccountEvent_type_value ($StructType $AccountFreezing_FreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezeEventsHolder_freeze_event_handle 0))
(assert (= $AccountFreezing_FreezeEventsHolder_unfreeze_event_handle 1))
(assert (= $AccountFreezing_FreezeEventsHolder_type_value ($StructType $AccountFreezing_FreezeEventsHolder $EmptyTypeValueArray)))
(assert (= $AccountFreezing_FreezingBit_is_frozen 0))
(assert (= $AccountFreezing_FreezingBit_type_value ($StructType $AccountFreezing_FreezingBit $EmptyTypeValueArray)))
(assert (= $AccountFreezing_UnfreezeAccountEvent_initiator_address 0))
(assert (= $AccountFreezing_UnfreezeAccountEvent_unfrozen_address 1))
(assert (= $AccountFreezing_UnfreezeAccountEvent_type_value ($StructType $AccountFreezing_UnfreezeAccountEvent $EmptyTypeValueArray)))
(assert (= $AccountLimits_AccountLimitMutationCapability_dummy_field 0))
(assert (= $AccountLimits_AccountLimitMutationCapability_type_value ($StructType $AccountLimits_AccountLimitMutationCapability $EmptyTypeValueArray)))
(assert (= $AccountLimits_LimitsDefinition_max_inflow 0))
(assert (= $AccountLimits_LimitsDefinition_max_outflow 1))
(assert (= $AccountLimits_LimitsDefinition_time_period 2))
(assert (= $AccountLimits_LimitsDefinition_max_holding 3))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($AccountLimits_LimitsDefinition_type_value $tv0@@0) ($StructType $AccountLimits_LimitsDefinition ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($AccountLimits_LimitsDefinition_type_value $tv0@@0))
)))
(assert (= $AccountLimits_Window_window_start 0))
(assert (= $AccountLimits_Window_window_inflow 1))
(assert (= $AccountLimits_Window_window_outflow 2))
(assert (= $AccountLimits_Window_tracked_balance 3))
(assert (= $AccountLimits_Window_limit_address 4))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($AccountLimits_Window_type_value $tv0@@1) ($StructType $AccountLimits_Window ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($AccountLimits_Window_type_value $tv0@@1))
)))
(assert (= $ChainId_ChainId_id 0))
(assert (= $ChainId_ChainId_type_value ($StructType $ChainId_ChainId $EmptyTypeValueArray)))
(assert (= $FixedPoint32_FixedPoint32_value 0))
(assert (= $FixedPoint32_FixedPoint32_type_value ($StructType $FixedPoint32_FixedPoint32 $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@2) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@2))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@3 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@3) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@3))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_currency_codes 0))
(assert (= $RegisteredCurrencies_RegisteredCurrencies_type_value ($StructType $RegisteredCurrencies_RegisteredCurrencies $EmptyTypeValueArray)))
(assert (= $Diem_Diem_value 0))
(assert (forall (($tv0@@4 T@$TypeValue) ) (! (= ($Diem_Diem_type_value $tv0@@4) ($StructType $Diem_Diem ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@4) 1))) :pattern ( ($Diem_Diem_type_value $tv0@@4))
)))
(assert (= $Diem_BurnCapability_dummy_field 0))
(assert (forall (($tv0@@5 T@$TypeValue) ) (! (= ($Diem_BurnCapability_type_value $tv0@@5) ($StructType $Diem_BurnCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@5) 1))) :pattern ( ($Diem_BurnCapability_type_value $tv0@@5))
)))
(assert (= $Diem_BurnEvent_amount 0))
(assert (= $Diem_BurnEvent_currency_code 1))
(assert (= $Diem_BurnEvent_preburn_address 2))
(assert (= $Diem_BurnEvent_type_value ($StructType $Diem_BurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CancelBurnEvent_amount 0))
(assert (= $Diem_CancelBurnEvent_currency_code 1))
(assert (= $Diem_CancelBurnEvent_preburn_address 2))
(assert (= $Diem_CancelBurnEvent_type_value ($StructType $Diem_CancelBurnEvent $EmptyTypeValueArray)))
(assert (= $Diem_CurrencyInfo_total_value 0))
(assert (= $Diem_CurrencyInfo_preburn_value 1))
(assert (= $Diem_CurrencyInfo_to_xdx_exchange_rate 2))
(assert (= $Diem_CurrencyInfo_is_synthetic 3))
(assert (= $Diem_CurrencyInfo_scaling_factor 4))
(assert (= $Diem_CurrencyInfo_fractional_part 5))
(assert (= $Diem_CurrencyInfo_currency_code 6))
(assert (= $Diem_CurrencyInfo_can_mint 7))
(assert (= $Diem_CurrencyInfo_mint_events 8))
(assert (= $Diem_CurrencyInfo_burn_events 9))
(assert (= $Diem_CurrencyInfo_preburn_events 10))
(assert (= $Diem_CurrencyInfo_cancel_burn_events 11))
(assert (= $Diem_CurrencyInfo_exchange_rate_update_events 12))
(assert (forall (($tv0@@6 T@$TypeValue) ) (! (= ($Diem_CurrencyInfo_type_value $tv0@@6) ($StructType $Diem_CurrencyInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@6) 1))) :pattern ( ($Diem_CurrencyInfo_type_value $tv0@@6))
)))
(assert (= $Diem_MintCapability_dummy_field 0))
(assert (forall (($tv0@@7 T@$TypeValue) ) (! (= ($Diem_MintCapability_type_value $tv0@@7) ($StructType $Diem_MintCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@7) 1))) :pattern ( ($Diem_MintCapability_type_value $tv0@@7))
)))
(assert (= $Diem_MintEvent_amount 0))
(assert (= $Diem_MintEvent_currency_code 1))
(assert (= $Diem_MintEvent_type_value ($StructType $Diem_MintEvent $EmptyTypeValueArray)))
(assert (= $Diem_Preburn_to_burn 0))
(assert (forall (($tv0@@8 T@$TypeValue) ) (! (= ($Diem_Preburn_type_value $tv0@@8) ($StructType $Diem_Preburn ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@8) 1))) :pattern ( ($Diem_Preburn_type_value $tv0@@8))
)))
(assert (= $Diem_PreburnEvent_amount 0))
(assert (= $Diem_PreburnEvent_currency_code 1))
(assert (= $Diem_PreburnEvent_preburn_address 2))
(assert (= $Diem_PreburnEvent_type_value ($StructType $Diem_PreburnEvent $EmptyTypeValueArray)))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_currency_code 0))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_new_to_xdx_exchange_rate 1))
(assert (= $Diem_ToXDXExchangeRateUpdateEvent_type_value ($StructType $Diem_ToXDXExchangeRateUpdateEvent $EmptyTypeValueArray)))
(assert (= $XUS_XUS_dummy_field 0))
(assert (= $XUS_XUS_type_value ($StructType $XUS_XUS $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_Dealer_mint_event_handle 0))
(assert (= $DesignatedDealer_Dealer_type_value ($StructType $DesignatedDealer_Dealer $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_ReceivedMintEvent_currency_code 0))
(assert (= $DesignatedDealer_ReceivedMintEvent_destination_address 1))
(assert (= $DesignatedDealer_ReceivedMintEvent_amount 2))
(assert (= $DesignatedDealer_ReceivedMintEvent_type_value ($StructType $DesignatedDealer_ReceivedMintEvent $EmptyTypeValueArray)))
(assert (= $DesignatedDealer_TierInfo_window_start 0))
(assert (= $DesignatedDealer_TierInfo_window_inflow 1))
(assert (= $DesignatedDealer_TierInfo_tiers 2))
(assert (forall (($tv0@@9 T@$TypeValue) ) (! (= ($DesignatedDealer_TierInfo_type_value $tv0@@9) ($StructType $DesignatedDealer_TierInfo ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@9) 1))) :pattern ( ($DesignatedDealer_TierInfo_type_value $tv0@@9))
)))
(assert (= $XDX_XDX_dummy_field 0))
(assert (= $XDX_XDX_type_value ($StructType $XDX_XDX $EmptyTypeValueArray)))
(assert (= $XDX_Reserve_mint_cap 0))
(assert (= $XDX_Reserve_burn_cap 1))
(assert (= $XDX_Reserve_preburn_cap 2))
(assert (= $XDX_Reserve_type_value ($StructType $XDX_Reserve $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@10 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@10) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@10) 1))) :pattern ( ($Option_Option_type_value $tv0@@10))
)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $VASP_ChildVASP_parent_vasp_addr 0))
(assert (= $VASP_ChildVASP_type_value ($StructType $VASP_ChildVASP $EmptyTypeValueArray)))
(assert (= $VASP_ParentVASP_num_children 0))
(assert (= $VASP_ParentVASP_type_value ($StructType $VASP_ParentVASP $EmptyTypeValueArray)))
(assert (= $TransactionFee_TransactionFee_balance 0))
(assert (= $TransactionFee_TransactionFee_preburn 1))
(assert (forall (($tv0@@11 T@$TypeValue) ) (! (= ($TransactionFee_TransactionFee_type_value $tv0@@11) ($StructType $TransactionFee_TransactionFee ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@11) 1))) :pattern ( ($TransactionFee_TransactionFee_type_value $tv0@@11))
)))
(assert (forall ((account T@$Value) (seq_nonce T@$Value) )  (and (and ((_ is $Integer) ($SlidingNonce_spec_try_record_nonce account seq_nonce)) (>= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) 0)) (<= (|i#$Integer| ($SlidingNonce_spec_try_record_nonce account seq_nonce)) $MAX_U64))))
(assert (= $SlidingNonce_SlidingNonce_min_nonce 0))
(assert (= $SlidingNonce_SlidingNonce_nonce_mask 1))
(assert (= $SlidingNonce_SlidingNonce_type_value ($StructType $SlidingNonce_SlidingNonce $EmptyTypeValueArray)))
(assert (forall ((payer T@$Value) (metadata T@$Value) (deposit_value T@$Value) )  (and (and ((_ is $Vector) ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value)) (let ((va@@8 (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DualAttestation_spec_dual_attestation_message payer metadata deposit_value))) $$0))
)))))
(assert (= $DualAttestation_BaseUrlRotationEvent_new_base_url 0))
(assert (= $DualAttestation_BaseUrlRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_BaseUrlRotationEvent_type_value ($StructType $DualAttestation_BaseUrlRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_new_compliance_public_key 0))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_time_rotated_seconds 1))
(assert (= $DualAttestation_ComplianceKeyRotationEvent_type_value ($StructType $DualAttestation_ComplianceKeyRotationEvent $EmptyTypeValueArray)))
(assert (= $DualAttestation_Credential_human_name 0))
(assert (= $DualAttestation_Credential_base_url 1))
(assert (= $DualAttestation_Credential_compliance_public_key 2))
(assert (= $DualAttestation_Credential_expiration_date 3))
(assert (= $DualAttestation_Credential_compliance_key_rotation_events 4))
(assert (= $DualAttestation_Credential_base_url_rotation_events 5))
(assert (= $DualAttestation_Credential_type_value ($StructType $DualAttestation_Credential $EmptyTypeValueArray)))
(assert (= $DualAttestation_Limit_micro_xdx_limit 0))
(assert (= $DualAttestation_Limit_type_value ($StructType $DualAttestation_Limit $EmptyTypeValueArray)))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_script_allow_list 0))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_module_publishing_allowed 1))
(assert (= $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value ($StructType $DiemTransactionPublishingOption_DiemTransactionPublishingOption $EmptyTypeValueArray)))
(assert (forall ((auth_key_prefix T@$Value) )  (and (and ((_ is $Vector) ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix)) (let ((va@@9 (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($DiemAccount_spec_abstract_create_authentication_key auth_key_prefix))) $$0@@0))
)))))
(assert (= $DiemAccount_DiemAccount_authentication_key 0))
(assert (= $DiemAccount_DiemAccount_withdraw_capability 1))
(assert (= $DiemAccount_DiemAccount_key_rotation_capability 2))
(assert (= $DiemAccount_DiemAccount_received_events 3))
(assert (= $DiemAccount_DiemAccount_sent_events 4))
(assert (= $DiemAccount_DiemAccount_sequence_number 5))
(assert (= $DiemAccount_DiemAccount_type_value ($StructType $DiemAccount_DiemAccount $EmptyTypeValueArray)))
(assert (= $DiemAccount_AccountOperationsCapability_limits_cap 0))
(assert (= $DiemAccount_AccountOperationsCapability_creation_events 1))
(assert (= $DiemAccount_AccountOperationsCapability_type_value ($StructType $DiemAccount_AccountOperationsCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_AdminTransactionEvent_committed_timestamp_secs 0))
(assert (= $DiemAccount_AdminTransactionEvent_type_value ($StructType $DiemAccount_AdminTransactionEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_Balance_coin 0))
(assert (forall (($tv0@@12 T@$TypeValue) ) (! (= ($DiemAccount_Balance_type_value $tv0@@12) ($StructType $DiemAccount_Balance ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@12) 1))) :pattern ( ($DiemAccount_Balance_type_value $tv0@@12))
)))
(assert (= $DiemAccount_CreateAccountEvent_created 0))
(assert (= $DiemAccount_CreateAccountEvent_role_id 1))
(assert (= $DiemAccount_CreateAccountEvent_type_value ($StructType $DiemAccount_CreateAccountEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_DiemWriteSetManager_upgrade_events 0))
(assert (= $DiemAccount_DiemWriteSetManager_type_value ($StructType $DiemAccount_DiemWriteSetManager $EmptyTypeValueArray)))
(assert (= $DiemAccount_KeyRotationCapability_account_address 0))
(assert (= $DiemAccount_KeyRotationCapability_type_value ($StructType $DiemAccount_KeyRotationCapability $EmptyTypeValueArray)))
(assert (= $DiemAccount_ReceivedPaymentEvent_amount 0))
(assert (= $DiemAccount_ReceivedPaymentEvent_currency_code 1))
(assert (= $DiemAccount_ReceivedPaymentEvent_payer 2))
(assert (= $DiemAccount_ReceivedPaymentEvent_metadata 3))
(assert (= $DiemAccount_ReceivedPaymentEvent_type_value ($StructType $DiemAccount_ReceivedPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_SentPaymentEvent_amount 0))
(assert (= $DiemAccount_SentPaymentEvent_currency_code 1))
(assert (= $DiemAccount_SentPaymentEvent_payee 2))
(assert (= $DiemAccount_SentPaymentEvent_metadata 3))
(assert (= $DiemAccount_SentPaymentEvent_type_value ($StructType $DiemAccount_SentPaymentEvent $EmptyTypeValueArray)))
(assert (= $DiemAccount_WithdrawCapability_account_address 0))
(assert (= $DiemAccount_WithdrawCapability_type_value ($StructType $DiemAccount_WithdrawCapability $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun dr_account () T@$Value)
(declare-fun $abort_flag@4 () Bool)
(declare-fun $SlidingNonce_SlidingNonce_$memory () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(declare-fun dummy_auth_key_prefix () T@$Value)
(declare-fun $abort_code@6 () Int)
(declare-fun $Roles_RoleId_$memory@3 () T@$Memory)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory@2 () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@3 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@3 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@2 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@2 () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory@2 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@2 () T@$Memory)
(declare-fun $Roles_RoleId_$memory@2 () T@$Memory)
(declare-fun $abort_code@5 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $Roles_RoleId_$memory@0 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@0 () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@0 () T@$Memory)
(declare-fun $DiemAccount_DiemWriteSetManager_$memory@0 () T@$Memory)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $Roles_RoleId_$memory@1 () T@$Memory)
(declare-fun $AccountFreezing_FreezingBit_$memory@1 () T@$Memory)
(declare-fun $SlidingNonce_SlidingNonce_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_AccountOperationsCapability_$memory@1 () T@$Memory)
(declare-fun $abort_flag@3 () Bool)
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemWriteSetManager_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $AccountFreezing_FreezeEventsHolder_$memory () T@$Memory)
(declare-fun $ChainId_ChainId_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $Diem_MintCapability_$memory () T@$Memory)
(declare-fun $Diem_BurnCapability_$memory () T@$Memory)
(declare-fun $Diem_Preburn_$memory () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory () T@$Memory)
(declare-fun $AccountLimits_LimitsDefinition_$memory () T@$Memory)
(declare-fun $XDX_Reserve_$memory () T@$Memory)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory () T@$Memory)
(declare-fun $ValidatorConfig_ValidatorConfig_$memory () T@$Memory)
(declare-fun $TransactionFee_TransactionFee_$memory () T@$Memory)
(declare-fun $DualAttestation_Limit_$memory () T@$Memory)
(declare-fun $DualAttestation_Credential_$memory () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory () T@$Memory)
(declare-fun $DesignatedDealer_Dealer_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $AccountFreezing_FreezingBit_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $SlidingNonce_SlidingNonce_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemAccount_DiemAccount_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemAccount_AccountOperationsCapability_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemAccount_DiemWriteSetManager_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 758051) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 409442) (- 0 766752)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766769)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766781)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766793)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766805)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766817)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766832)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766844)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766875)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766887)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766902)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766914)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@4) (and (=> (= (ControlFlow 0 409442) (- 0 766926)) (=> $abort_flag@4 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (=> (=> $abort_flag@4 (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767089)) (=> $abort_flag@4 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) (= $abort_code@6 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@4 (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 2)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) (= $abort_code@6 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@6 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@6 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767384)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767398)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0))))) (and (=> (= (ControlFlow 0 409442) (- 0 767424)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767438)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1))))) (and (=> (= (ControlFlow 0 409442) (- 0 767464)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767478)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767492)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767506)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767518)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767530)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767542)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767554)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767566)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767580)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767592)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767604)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (=> (= (ControlFlow 0 409442) (- 0 767618)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767630)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (and (=> (= (ControlFlow 0 409442) (- 0 767642)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))) (=> (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (=> (= (ControlFlow 0 409442) (- 0 767654)) (=> (not $abort_flag@4) (|b#$Boolean| ($Boolean (forall ((addr T@$Value) )  (=> ((_ is $Address) addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr)))) $DiemAccount_DiemAccount_authentication_key)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$Abort_correct  (=> (= $abort_flag@4 true) (=> (and (and (and (= $DiemAccount_DiemWriteSetManager_$memory@2 $DiemAccount_DiemWriteSetManager_$memory@1) (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory@2)) (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@2) (= $SlidingNonce_SlidingNonce_$memory@3 $SlidingNonce_SlidingNonce_$memory@2))) (and (and (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory@2) (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@2)) (and (= $abort_code@6 $abort_code@5) (= (ControlFlow 0 409352) 409442)))) anon0$2_correct))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon7_correct  (=> (and (and (and (= $abort_code@5 $abort_code@1) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory)) (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory) (= $SlidingNonce_SlidingNonce_$memory@2 $SlidingNonce_SlidingNonce_$memory))) (and (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory)) (and (= $DiemAccount_DiemWriteSetManager_$memory@1 $DiemAccount_DiemWriteSetManager_$memory) (= (ControlFlow 0 409412) 409352)))) inline$$DiemAccount_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon24_Else_correct  (=> (and (not true) (= (ControlFlow 0 409410) 409412)) inline$$DiemAccount_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon24_Then_correct  (=> (= (ControlFlow 0 409420) 409412) inline$$DiemAccount_initialize_$def_verify$0$anon7_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon23_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 409404) 409420) inline$$DiemAccount_initialize_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 409404) 409410) inline$$DiemAccount_initialize_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon11_correct  (=> (and (and (and (= $abort_code@5 $abort_code@2) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory)) (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory) (= $SlidingNonce_SlidingNonce_$memory@2 $SlidingNonce_SlidingNonce_$memory))) (and (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory)) (and (= $DiemAccount_DiemWriteSetManager_$memory@1 $DiemAccount_DiemWriteSetManager_$memory) (= (ControlFlow 0 409392) 409352)))) inline$$DiemAccount_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 409390) 409392)) inline$$DiemAccount_initialize_$def_verify$0$anon11_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 409400) 409392) inline$$DiemAccount_initialize_$def_verify$0$anon11_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon25_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 409384) 409400) inline$$DiemAccount_initialize_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 409384) 409390) inline$$DiemAccount_initialize_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon15_correct  (=> (and (and (and (= $abort_code@5 $abort_code@3) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@0)) (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@0) (= $SlidingNonce_SlidingNonce_$memory@2 $SlidingNonce_SlidingNonce_$memory@0))) (and (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@0) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@0)) (and (= $DiemAccount_DiemWriteSetManager_$memory@1 $DiemAccount_DiemWriteSetManager_$memory@0) (= (ControlFlow 0 409372) 409352)))) inline$$DiemAccount_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 409370) 409372)) inline$$DiemAccount_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon28_Then_correct  (=> (= (ControlFlow 0 409380) 409372) inline$$DiemAccount_initialize_$def_verify$0$anon15_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon27_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 409364) 409380) inline$$DiemAccount_initialize_$def_verify$0$anon28_Then_correct) (=> (= (ControlFlow 0 409364) 409370) inline$$DiemAccount_initialize_$def_verify$0$anon28_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon19_correct  (=> (and (and (and (= $abort_code@5 $abort_code@4) (= $Roles_RoleId_$memory@2 $Roles_RoleId_$memory@1)) (and (= $AccountFreezing_FreezingBit_$memory@2 $AccountFreezing_FreezingBit_$memory@1) (= $SlidingNonce_SlidingNonce_$memory@2 $SlidingNonce_SlidingNonce_$memory@1))) (and (and (= $DiemAccount_DiemAccount_$memory@2 $DiemAccount_DiemAccount_$memory@1) (= $DiemAccount_AccountOperationsCapability_$memory@2 $DiemAccount_AccountOperationsCapability_$memory@1)) (and (= $DiemAccount_DiemWriteSetManager_$memory@1 $DiemAccount_DiemWriteSetManager_$memory@0) (= (ControlFlow 0 409348) 409352)))) inline$$DiemAccount_initialize_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 409346) 409348)) inline$$DiemAccount_initialize_$def_verify$0$anon19_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon30_Then_correct  (=> (= (ControlFlow 0 409360) 409348) inline$$DiemAccount_initialize_$def_verify$0$anon19_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon29_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 409340) 409360) inline$$DiemAccount_initialize_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 409340) 409346) inline$$DiemAccount_initialize_$def_verify$0$anon30_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon29_Else_correct  (=> (and (not $abort_flag@3) (= $abort_flag@4 $abort_flag@3)) (=> (and (and (and (= $DiemAccount_DiemWriteSetManager_$memory@2 $DiemAccount_DiemWriteSetManager_$memory@0) (= $DiemAccount_AccountOperationsCapability_$memory@3 $DiemAccount_AccountOperationsCapability_$memory@1)) (and (= $DiemAccount_DiemAccount_$memory@3 $DiemAccount_DiemAccount_$memory@1) (= $SlidingNonce_SlidingNonce_$memory@3 $SlidingNonce_SlidingNonce_$memory@1))) (and (and (= $AccountFreezing_FreezingBit_$memory@3 $AccountFreezing_FreezingBit_$memory@1) (= $Roles_RoleId_$memory@3 $Roles_RoleId_$memory@1)) (and (= $abort_code@6 $abort_code@4) (= (ControlFlow 0 409336) 409442)))) anon0$2_correct))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@2) (and (=> (= (ControlFlow 0 409330) (- 0 765202)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 409330) (- 0 765211)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 409330) (- 0 765220)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 409330) (- 0 765229)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 409330) (- 0 765238)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 186537453))) (and (=> (= (ControlFlow 0 409330) (- 0 765247)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3)) (=> (and (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) $abort_flag@3)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@3))) (and (and (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 0)))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 1)))) $abort_flag@3)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $abort_flag@3) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@3)))) (and (and (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) $abort_flag@3) (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 0))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 1))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32)))))))) (and (=> $abort_flag@3 (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@4 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@4 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account))))))) (= $abort_code@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| dr_account)))) $Roles_RoleId_role_id) ($Integer 0))))) (= $abort_code@4 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@4 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 0)))) (= $abort_code@4 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) ($Address 1)))) (= $abort_code@4 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= $abort_code@4 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@4 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) (= $abort_code@4 (|i#$Integer| ($Integer 7)))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $Roles_RoleId_role_id) ($Integer 1)))))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (and (and (and (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))) (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 186537453) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))) (and (and (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_AccountOperationsCapability_creation_events)) (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean (forall ((addr@@0 T@$Value) )  (=> ((_ is $Address) addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr@@0)))) $DiemAccount_DiemAccount_authentication_key))))))))))))) (and (= (|contents#$Memory| $Roles_RoleId_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $Roles_RoleId_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (and (and (and (= (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (= (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))))) (and (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))) (and (= (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 409330) 409340) inline$$DiemAccount_initialize_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 409330) 409336) inline$$DiemAccount_initialize_$def_verify$0$anon29_Else_correct)))))))))))))))))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon25_Else_correct  (=> (not $abort_flag@1) (and (=> (= (ControlFlow 0 409324) (- 0 764132)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764141)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764150)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764159)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764168)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764177)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (and (=> (= (ControlFlow 0 409324) (- 0 764186)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemWriteSetManager_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemWriteSetManager_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (=> (and (and (and (and (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2)) (and (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2))) (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@2) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@2)) (and (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) $abort_flag@2) (=> $abort_flag@2 (or (or (or (or (or (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32)))))))))) (and (and (and (=> $abort_flag@2 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6)))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@3 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@3 (|i#$Integer| ($Integer 6))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (+ (|i#$Integer| ($Integer 16)) (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))))) ($Integer 32))))) (= $abort_code@3 (|i#$Integer| ($Integer 7)))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $Roles_RoleId_role_id) ($Integer 0)))))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (and (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Address 173345816) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))) (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean (forall ((addr@@1 T@$Value) )  (=> ((_ is $Address) addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@1)))) $DiemAccount_DiemAccount_authentication_key)))))))))))))) (and (and (= (|contents#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $Roles_RoleId_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (and (and (and (= (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (and (= (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (and (= (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 409324) 409364) inline$$DiemAccount_initialize_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 409324) 409330) inline$$DiemAccount_initialize_$def_verify$0$anon27_Else_correct))))))))))))))))))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon23_Else_correct  (=> (and (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816)))))) (=> $abort_flag@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified dr_account ($Address 173345816))))) (= $abort_code@2 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 409318) 409384) inline$$DiemAccount_initialize_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 409318) 409324) inline$$DiemAccount_initialize_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon4$2_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 409312) 409404) inline$$DiemAccount_initialize_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 409312) 409318) inline$$DiemAccount_initialize_$def_verify$0$anon23_Else_correct))))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon4_correct  (=> (= inline$$DiemAccount_initialize_$def_verify$0$$Roles_RoleId_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) true) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) true)) (=> (and (= inline$$DiemAccount_initialize_$def_verify$0$$AccountFreezing_FreezingBit_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) true)) (= inline$$DiemAccount_initialize_$def_verify$0$$SlidingNonce_SlidingNonce_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) true))) (=> (and (and (= inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)) true)) (= inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_AccountOperationsCapability_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true))) (and (= inline$$DiemAccount_initialize_$def_verify$0$$DiemAccount_DiemWriteSetManager_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)) true)) (= (ControlFlow 0 409276) 409312))) inline$$DiemAccount_initialize_$def_verify$0$anon4$2_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon22_Else_correct  (=> (and (not true) (= (ControlFlow 0 409088) 409276)) inline$$DiemAccount_initialize_$def_verify$0$anon4_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon22_Then_correct  (=> (= (ControlFlow 0 409428) 409276) inline$$DiemAccount_initialize_$def_verify$0$anon4_correct)))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon21_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 409080) 409428) inline$$DiemAccount_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 409080) 409088) inline$$DiemAccount_initialize_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon21_Then_correct  (and (=> (= (ControlFlow 0 409436) 409428) inline$$DiemAccount_initialize_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 409436) 409088) inline$$DiemAccount_initialize_$def_verify$0$anon22_Else_correct))))
(let ((inline$$DiemAccount_initialize_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 409074) 409436) inline$$DiemAccount_initialize_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 409074) 409080) inline$$DiemAccount_initialize_$def_verify$0$anon21_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0)) (let ((va@@11 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@0))
))) (=> (and (and (and (forall (($inv_addr@@1 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_min_nonce)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_min_nonce)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_min_nonce)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_nonce_mask)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_nonce_mask)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))) $SlidingNonce_SlidingNonce_nonce_mask)) $MAX_U128))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@14 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_authentication_key))) $$0@@1))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events)) (let ((va@@20 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@2))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
))))))) (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@3))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@24 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@25 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@4))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@4))
)))) (and (and (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@28 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) 1)) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events)) (let ((va@@29 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemAccount_DiemWriteSetManager_upgrade_events))) $Event_EventHandle_guid))) $$0@@5))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((coin_type T@$Value) )  (=> ((_ is $Type) coin_type) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner T@$Value) )  (=> ((_ is $Address) mint_cap_owner) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type)) 1) (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@0 T@$Value) )  (=> ((_ is $Type) coin_type@@0) (|b#$Boolean| ($Boolean (forall ((addr1 T@$Value) )  (=> ((_ is $Address) addr1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@0)) 1) (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@1 T@$Value) )  (=> ((_ is $Type) coin_type@@1) (|b#$Boolean| ($Boolean (forall ((addr1@@0 T@$Value) )  (=> ((_ is $Address) addr1@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@1)) 1) (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@0)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@2 T@$Value) )  (=> ((_ is $Address) addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@2)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@3 T@$Value) )  (=> ((_ is $Address) addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@3)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@4 T@$Value) )  (=> ((_ is $Address) addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@4)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@5 T@$Value) )  (=> ((_ is $Address) addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@5)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr1@@1 T@$Value) )  (=> ((_ is $Address) addr1@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@1)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@6 T@$Value) )  (=> ((_ is $Address) addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@6)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@7 T@$Value) )  (=> ((_ is $Address) addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@7)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@8 T@$Value) )  (=> ((_ is $Address) addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@8))))))))))) (|b#$Boolean| ($Boolean (forall ((token T@$Value) )  (=> ((_ is $Type) token) (|b#$Boolean| ($Boolean (forall ((addr@@9 T@$Value) )  (=> ((_ is $Address) addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token)) 1) (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@9)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@10 T@$Value) )  (=> ((_ is $Address) addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@10)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@11 T@$Value) )  (=> ((_ is $Address) addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@11)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@12 T@$Value) )  (=> ((_ is $Address) addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@12))))))))))) (= (ControlFlow 0 409440) 409074)))))) inline$$DiemAccount_initialize_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) dr_account) (=> (and (and (and ((_ is $Vector) dummy_auth_key_prefix) (let ((va@@31 (|v#$Vector| dummy_auth_key_prefix)))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
)))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| dummy_auth_key_prefix)) $$0@@6))
))) (= (ControlFlow 0 407191) 409440)) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (=> (and (and (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $Roles_RoleId_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (and (|Select_[$TypeValueArray,$int]$bool| $AccountFreezing_FreezingBit_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $AccountFreezing_FreezingBit_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (=> (and (and (and (|Select_[$TypeValueArray,$int]$bool| $SlidingNonce_SlidingNonce_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $SlidingNonce_SlidingNonce_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))) (and (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_DiemAccount_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_DiemAccount_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (and (and (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_AccountOperationsCapability_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_AccountOperationsCapability_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))) (and (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_DiemWriteSetManager_$CallerDomain $EmptyTypeValueArray (|a#$Address| ($Address 173345816))) (= (ControlFlow 0 758051) 407191)))) anon0_correct)))))
PreconditionGeneratedEntry_correct)))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@33 () Bool)
(declare-fun cap () T@$Value)
(declare-fun $tv0@@13 () T@$TypeValue)
(declare-fun $VASP_ParentVASP_$memory () T@$Memory)
(declare-fun $VASP_ChildVASP_$memory () T@$Memory)
(declare-fun $AccountLimits_Window_$memory () T@$Memory)
(declare-fun dd () T@$Value)
(declare-fun amount () T@$Value)
(declare-fun $abort_code@46 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@3@@0 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@2 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@5 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@4 () T@$Memory)
(declare-fun $abort_code@45 () Int)
(declare-fun $Diem_Preburn_$memory@2 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@1 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@1 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@7 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@6 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@2@@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun $abort_flag@32 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@3 () T@$Memory)
(declare-fun $Diem_Preburn_$memory@0 () T@$Memory)
(declare-fun $abort_code@44 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@1@@0 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@5 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@0 () T@$Memory)
(declare-fun $abort_flag@19 () Bool)
(declare-fun $abort_code@26 () Int)
(declare-fun $abort_code@42 () Int)
(declare-fun $abort_flag@31 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$4$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$4$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$4$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$4$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$4$v@1 () T@$Value)
(declare-fun |inline$$WriteRef$6$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$4$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$2$dst@2 () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@43 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2 () T@$Memory)
(declare-fun $abort_code@27 () Int)
(declare-fun $abort_flag@20 () Bool)
(declare-fun $abort_code@28 () Int)
(declare-fun $abort_flag@21 () Bool)
(declare-fun $abort_code@29 () Int)
(declare-fun $abort_flag@22 () Bool)
(declare-fun $abort_code@31 () Int)
(declare-fun $abort_flag@23 () Bool)
(declare-fun |inline$$WritebackToValue$1$vdst'@2| () T@$Value)
(declare-fun $abort_code@40 () Int)
(declare-fun $abort_flag@30 () Bool)
(declare-fun $Diem_CurrencyInfo_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$3$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$3$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$3$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$3$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$3$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$4$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$3$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$3$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$5$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$4$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$4$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$4$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$8$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$10$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$2$m'@1| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@41 () Int)
(declare-fun $abort_code@32 () Int)
(declare-fun $abort_flag@24 () Bool)
(declare-fun $abort_code@34 () Int)
(declare-fun $abort_flag@25 () Bool)
(declare-fun $abort_code@35 () Int)
(declare-fun $abort_flag@26 () Bool)
(declare-fun $abort_code@36 () Int)
(declare-fun $abort_flag@27 () Bool)
(declare-fun $abort_code@37 () Int)
(declare-fun $abort_flag@28 () Bool)
(declare-fun $abort_code@38 () Int)
(declare-fun $abort_flag@29 () Bool)
(declare-fun inline$$Event_emit_event$1$t@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$3$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$Diem_PreburnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$8$p@1 () T@$Path)
(declare-fun inline$$BorrowField$8$size@1 () Int)
(declare-fun inline$$BorrowField$8$p@2 () T@$Path)
(declare-fun inline$$ReadRef$9$v@1 () T@$Value)
(declare-fun inline$$BorrowField$7$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$7$p@1 () T@$Path)
(declare-fun inline$$BorrowField$7$size@1 () Int)
(declare-fun inline$$BorrowField$7$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$3$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$4$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$3$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$3$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$3$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$6$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$6$p@1 () T@$Path)
(declare-fun inline$$BorrowField$6$size@1 () Int)
(declare-fun inline$$BorrowField$6$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$8$v@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$5$p@1 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1 () Int)
(declare-fun inline$$BorrowField$5$p@2 () T@$Path)
(declare-fun inline$$Ge$1$dst@1 () T@$Value)
(declare-fun $abort_code@39 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t27@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@2 () T@$Value)
(declare-fun inline$$Sub$0$dst@0 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t23@1 () T@$Value)
(declare-fun inline$$ReadRef$7$v@1 () T@$Value)
(declare-fun inline$$Sub$0$dst@1 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$3$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$3$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$3$a@1 () Int)
(declare-fun inline$$BorrowGlobal$3$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$1$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$1$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$3$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0 () T@$Value)
(declare-fun inline$$ReadRef$6$v@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@33 () Int)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$4$dst@1 () T@$Value)
(declare-fun inline$$Diem_preburn_with_resource_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$ReadRef$5$v@1 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$2$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$2$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$2$a@1 () Int)
(declare-fun inline$$BorrowGlobal$2$dst@1 () T@$Mutation)
(declare-fun inline$$Diem_preburn_to_$def$0$$t7@1 () T@$Value)
(declare-fun $abort_code@30 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun inline$$Diem_preburn_to_$def$0$$t8@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@2 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_flag@18 () Bool)
(declare-fun $AccountLimits_Window_$memory@3 () T@$Memory)
(declare-fun $abort_code@24 () Int)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@2 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$ret0@1 () T@$Value)
(declare-fun $DiemAccount_DiemAccount_$memory@0@@0 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@4 () T@$Memory)
(declare-fun $abort_code@25 () Int)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@21 () Int)
(declare-fun $AccountLimits_Window_$memory@1 () T@$Memory)
(declare-fun $abort_flag@17 () Bool)
(declare-fun call5formal@$ret0@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@2| () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToValue$0$vdst'@1| () T@$Value)
(declare-fun inline$$BorrowLoc$0$dst@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun call6formal@$ret1@0 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@1 () T@$Value)
(declare-fun $abort_code@23 () Int)
(declare-fun $AccountLimits_Window_$memory@2 () T@$Memory)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@12 () Int)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun $abort_code@16 () Int)
(declare-fun $AccountLimits_Window_$memory@0 () T@$Memory)
(declare-fun $abort_flag@13 () Bool)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@14 () Bool)
(declare-fun $abort_code@22 () Int)
(declare-fun call8formal@$ret0@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun $abort_code@19 () Int)
(declare-fun $abort_flag@16 () Bool)
(declare-fun inline$$ReadRef$3$v@1 () T@$Value)
(declare-fun inline$$Ge$0$dst@1 () T@$Value)
(declare-fun $abort_code@20 () Int)
(declare-fun call3formal@$ret0@0@@5 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$t26@1 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1 () T@$Value)
(declare-fun $abort_flag@15 () Bool)
(declare-fun $abort_code@18 () Int)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$t21@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$AccountLimits_Window_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$ret0@0@@6 () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun call6formal@$ret0@0 () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance_$def$0$$t15@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@7 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_balance$0$$AccountLimits_Window_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun call3formal@$ret0@0@@8 () T@$Value)
(declare-fun inline$$DiemAccount_preburn_$def_verify$0$$t7@1 () T@$Value)
(declare-fun inline$$DiemAccount_SentPaymentEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_DiemAccount_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$t18@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_Balance_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $abort_code@7 () Int)
(declare-fun call3formal@$ret0@0@@9 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$t19@1 () T@$Value)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun call3formal@$ret0@0@@10 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$def$0$$t16@1 () T@$Value)
(declare-fun inline$$DiemAccount_withdraw_from_$direct_intra$0$$DiemAccount_Balance_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_preburn_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $Diem_Diem_$memory () T@$Memory)
(declare-fun $DiemAccount_WithdrawCapability_$memory () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$CallerDomain@@0 () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 767729) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 428564) (- 0 788633)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788648)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788668)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788702)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788717)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788733)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@0 (|l#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@1 (|l#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@2 (|l#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@3 (|l#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@4 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@4 1)))) len@@3 ($Integer 0)) (+ len@@3 1)))) len@@2 ($Integer 0)) (+ len@@2 1)))) len@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@1 1)))) len@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@0 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788816)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788862)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788877)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788892)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 788963)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789056)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@5 (|l#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@6 (|l#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@7 (|l#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@8 (|l#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@9 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@9 1)))) len@@8 ($Integer 0)) (+ len@@8 1)))) len@@7 ($Integer 0)) (+ len@@7 1)))) len@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@6 1)))) len@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@5 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789204)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789381)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789476)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789497)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789526)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789560)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789590)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789626)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@33) (and (=> (= (ControlFlow 0 428564) (- 0 789642)) (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))))) (=> (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@10 (|l#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@11 (|l#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@12 (|l#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@13 (|l#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@14 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@14 1)))) len@@13 ($Integer 0)) (+ len@@13 1)))) len@@12 ($Integer 0)) (+ len@@12 1)))) len@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@11 1)))) len@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@10 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow)))))))))))))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@15 (|l#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@16 (|l#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@17 (|l#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@18 (|l#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@19 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@19 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@19 1)))) len@@18 ($Integer 0)) (+ len@@18 1)))) len@@17 ($Integer 0)) (+ len@@17 1)))) len@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@16 1)))) len@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@15 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> (= (ControlFlow 0 428564) (- 0 790632)) (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@46 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))))) (=> (=> $abort_flag@33 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@20 (|l#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@21 (|l#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@22 (|l#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@23 (|l#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@24 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@24 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@24 1)))) len@@23 ($Integer 0)) (+ len@@23 1)))) len@@22 ($Integer 0)) (+ len@@22 1)))) len@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@21 1)))) len@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@20 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@25 (|l#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@26 (|l#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@27 (|l#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@28 (|l#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@29 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@29 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@29 1)))) len@@28 ($Integer 0)) (+ len@@28 1)))) len@@27 ($Integer 0)) (+ len@@27 1)))) len@@26 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@26 1)))) len@@25 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@25 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean true)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) dd (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@46 (|i#$Integer| ($Integer 3))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| dd)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (= $abort_code@46 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@46 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@46 (|i#$Integer| ($Integer 5)))))) (and (=> (= (ControlFlow 0 428564) (- 0 791842)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3@@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@3@@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))))) (and (=> (= (ControlFlow 0 428564) (- 0 791860)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3@@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability)))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3@@0) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_DiemAccount_withdraw_capability))))) (and (=> (= (ControlFlow 0 428564) (- 0 791901)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount)))))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| amount))))))) (and (=> (= (ControlFlow 0 428564) (- 0 791944)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount)))))))) (=> (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@5) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| amount))))))) (=> (= (ControlFlow 0 428564) (- 0 791983)) (=> (not $abort_flag@33) (|b#$Boolean| ($Boolean (forall ((addr@@13 T@$Value) )  (=> ((_ is $Address) addr@@13) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@3@@0) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@13)))) $DiemAccount_DiemAccount_authentication_key)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$Abort_correct  (=> (and (and (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@4) (= $abort_code@46 $abort_code@45)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@1) (= $abort_flag@33 true))) (and (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@1) (= $AccountLimits_Window_$memory@7 $AccountLimits_Window_$memory@6)) (and (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory@2@@0) (= (ControlFlow 0 428490) 428564)))) anon0$2_correct@@0)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon9_correct  (=> (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory) (=> (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= $abort_code@45 $abort_code@1@@0)) (=> (and (and (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory) (= $AccountLimits_Window_$memory@6 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 428526) 428490))) inline$$DiemAccount_preburn_$def_verify$0$Abort_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 428524) 428526)) inline$$DiemAccount_preburn_$def_verify$0$anon9_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 428534) 428526) inline$$DiemAccount_preburn_$def_verify$0$anon9_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon22_Then_correct  (=> $abort_flag@0@@0 (and (=> (= (ControlFlow 0 428518) 428534) inline$$DiemAccount_preburn_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 428518) 428524) inline$$DiemAccount_preburn_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon13_correct  (=> (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory) (=> (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= $abort_code@45 $abort_code@2@@0)) (=> (and (and (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory) (= $AccountLimits_Window_$memory@6 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 428506) 428490))) inline$$DiemAccount_preburn_$def_verify$0$Abort_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon25_Else_correct  (=> (and (not true) (= (ControlFlow 0 428504) 428506)) inline$$DiemAccount_preburn_$def_verify$0$anon13_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon25_Then_correct  (=> (= (ControlFlow 0 428514) 428506) inline$$DiemAccount_preburn_$def_verify$0$anon13_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon24_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 428498) 428514) inline$$DiemAccount_preburn_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 428498) 428504) inline$$DiemAccount_preburn_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon27_Then_correct  (=> (and (and (and $abort_flag@32 (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory@3)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory@0) (= $abort_code@45 $abort_code@44))) (and (and (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory@1@@0) (= $AccountLimits_Window_$memory@6 $AccountLimits_Window_$memory@5)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0) (= (ControlFlow 0 428486) 428490)))) inline$$DiemAccount_preburn_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon26_Then_correct  (=> (and (and (and $abort_flag@19 (= $Diem_CurrencyInfo_$memory@4 $Diem_CurrencyInfo_$memory)) (and (= $Diem_Preburn_$memory@1 $Diem_Preburn_$memory) (= $abort_code@45 $abort_code@26))) (and (and (= $DiemAccount_DiemAccount_$memory@2@@0 $DiemAccount_DiemAccount_$memory@1@@0) (= $AccountLimits_Window_$memory@6 $AccountLimits_Window_$memory@5)) (and (= $DiemAccount_Balance_$memory@1 $DiemAccount_Balance_$memory@0) (= (ControlFlow 0 428494) 428490)))) inline$$DiemAccount_preburn_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon27_Else_correct  (=> (not $abort_flag@32) (=> (and (and (and (= $Diem_CurrencyInfo_$memory@5 $Diem_CurrencyInfo_$memory@3) (= $abort_code@46 $abort_code@44)) (and (= $Diem_Preburn_$memory@2 $Diem_Preburn_$memory@0) (= $abort_flag@33 $abort_flag@32))) (and (and (= $DiemAccount_Balance_$memory@2 $DiemAccount_Balance_$memory@0) (= $AccountLimits_Window_$memory@7 $AccountLimits_Window_$memory@5)) (and (= $DiemAccount_DiemAccount_$memory@3@@0 $DiemAccount_DiemAccount_$memory@1@@0) (= (ControlFlow 0 428482) 428564)))) anon0$2_correct@@0))))
(let ((inline$$Diem_preburn_to_$def$0$anon39_Else$2_correct  (=> (and (and (= $abort_code@44 $abort_code@42) (= $abort_flag@32 $abort_flag@31)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@1) (= $Diem_Preburn_$memory@0 |inline$$WritebackToGlobal$4$m'@2|))) (and (=> (= (ControlFlow 0 428364) 428486) inline$$DiemAccount_preburn_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 428364) 428482) inline$$DiemAccount_preburn_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$WritebackToGlobal$4$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$4$l@1)) (=> (and (= |inline$$WritebackToGlobal$4$m'@2| $Diem_Preburn_$memory) (= (ControlFlow 0 428302) 428364)) inline$$Diem_preburn_to_$def$0$anon39_Else$2_correct))))
(let ((inline$$WritebackToGlobal$4$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$4$l@1) (=> (and (= inline$$WritebackToGlobal$4$ta@1 (|ts#$Global| inline$$WritebackToGlobal$4$l@1)) (= inline$$WritebackToGlobal$4$a@1 (|a#$Global| inline$$WritebackToGlobal$4$l@1))) (=> (and (and (= inline$$WritebackToGlobal$4$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$6$to'@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1) (|v#$Mutation| |inline$$WriteRef$6$to'@1|))) (= |inline$$WritebackToGlobal$4$m'@1| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$4$ta@1 inline$$WritebackToGlobal$4$a@1 inline$$WritebackToGlobal$4$v@1)))) (and (= |inline$$WritebackToGlobal$4$m'@2| |inline$$WritebackToGlobal$4$m'@1|) (= (ControlFlow 0 428356) 428364))) inline$$Diem_preburn_to_$def$0$anon39_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$4$anon0_correct  (=> (= inline$$WritebackToGlobal$4$l@1 (|l#$Mutation| |inline$$WriteRef$6$to'@1|)) (and (=> (= (ControlFlow 0 428292) 428356) inline$$WritebackToGlobal$4$anon3_Then_correct) (=> (= (ControlFlow 0 428292) 428302) inline$$WritebackToGlobal$4$anon3_Else_correct)))))
(let ((inline$$WriteRef$6$anon0_correct  (=> (and (= |inline$$WriteRef$6$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$2$dst@2) (|p#$Mutation| inline$$BorrowGlobal$2$dst@2) inline$$Diem_preburn_with_resource_$def$0$$ret0@2)) (= (ControlFlow 0 428170) 428292)) inline$$WritebackToGlobal$4$anon0_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon39_Else_correct  (=> (and (not $abort_flag@31) (= (ControlFlow 0 428176) 428170)) inline$$WriteRef$6$anon0_correct)))
(let ((inline$$Diem_preburn_to_$def$0$Abort_correct  (=> (and (and (= $abort_code@44 $abort_code@43) (= $abort_flag@32 true)) (and (= $Diem_CurrencyInfo_$memory@3 $Diem_CurrencyInfo_$memory@2) (= $Diem_Preburn_$memory@0 $Diem_Preburn_$memory))) (and (=> (= (ControlFlow 0 421229) 428486) inline$$DiemAccount_preburn_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 421229) 428482) inline$$DiemAccount_preburn_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon7_correct  (=> (= $abort_code@43 $abort_code@27) (=> (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 428440) 421229)) inline$$Diem_preburn_to_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 428438) 428440)) inline$$Diem_preburn_to_$def$0$anon7_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 428448) 428440) inline$$Diem_preburn_to_$def$0$anon7_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon29_Then_correct  (=> $abort_flag@20 (and (=> (= (ControlFlow 0 428432) 428448) inline$$Diem_preburn_to_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 428432) 428438) inline$$Diem_preburn_to_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon11_correct  (=> (= $abort_code@43 $abort_code@28) (=> (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 428420) 421229)) inline$$Diem_preburn_to_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 428418) 428420)) inline$$Diem_preburn_to_$def$0$anon11_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 428428) 428420) inline$$Diem_preburn_to_$def$0$anon11_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon31_Then_correct  (=> $abort_flag@21 (and (=> (= (ControlFlow 0 428412) 428428) inline$$Diem_preburn_to_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 428412) 428418) inline$$Diem_preburn_to_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon15_correct  (=> (= $abort_code@43 $abort_code@29) (=> (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 428400) 421229)) inline$$Diem_preburn_to_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 428398) 428400)) inline$$Diem_preburn_to_$def$0$anon15_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 428408) 428400) inline$$Diem_preburn_to_$def$0$anon15_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon33_Then_correct  (=> $abort_flag@22 (and (=> (= (ControlFlow 0 428392) 428408) inline$$Diem_preburn_to_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 428392) 428398) inline$$Diem_preburn_to_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon23_correct  (=> (= $abort_code@43 $abort_code@31) (=> (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 428380) 421229)) inline$$Diem_preburn_to_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 428378) 428380)) inline$$Diem_preburn_to_$def$0$anon23_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon38_Then_correct  (=> (= (ControlFlow 0 428388) 428380) inline$$Diem_preburn_to_$def$0$anon23_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon37_Then_correct  (=> $abort_flag@23 (and (=> (= (ControlFlow 0 428372) 428388) inline$$Diem_preburn_to_$def$0$anon38_Then_correct) (=> (= (ControlFlow 0 428372) 428378) inline$$Diem_preburn_to_$def$0$anon38_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon39_Then_correct  (=> (and (and $abort_flag@31 (= $abort_code@43 $abort_code@42)) (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory@1) (= (ControlFlow 0 428368) 421229))) inline$$Diem_preburn_to_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon62_correct  (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 |inline$$WritebackToValue$1$vdst'@2|) (= $abort_code@42 $abort_code@40)) (and (= $abort_flag@31 $abort_flag@30) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory@0))) (and (=> (= (ControlFlow 0 426744) 428368) inline$$Diem_preburn_to_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 426744) 428176) inline$$Diem_preburn_to_$def$0$anon39_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 426742) 426744)) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 426752) 426744) inline$$Diem_preburn_with_resource_$def$0$anon62_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$3$m'@2|) (and (=> (= (ControlFlow 0 427871) 426752) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 427871) 426742) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$3$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$3$l@1)) (=> (and (= |inline$$WritebackToGlobal$3$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 427809) 427871)) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct))))
(let ((inline$$WritebackToGlobal$3$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$3$l@1) (=> (and (= inline$$WritebackToGlobal$3$ta@1 (|ts#$Global| inline$$WritebackToGlobal$3$l@1)) (= inline$$WritebackToGlobal$3$a@1 (|a#$Global| inline$$WritebackToGlobal$3$l@1))) (=> (and (and (= inline$$WritebackToGlobal$3$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$4$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1) (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|))) (= |inline$$WritebackToGlobal$3$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$3$ta@1 inline$$WritebackToGlobal$3$a@1 inline$$WritebackToGlobal$3$v@1)))) (and (= |inline$$WritebackToGlobal$3$m'@2| |inline$$WritebackToGlobal$3$m'@1|) (= (ControlFlow 0 427863) 427871))) inline$$Diem_preburn_with_resource_$def$0$anon60$3_correct)))))
(let ((inline$$WritebackToGlobal$3$anon0_correct  (=> (= inline$$WritebackToGlobal$3$l@1 (|l#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (and (=> (= (ControlFlow 0 427799) 427863) inline$$WritebackToGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 427799) 427809) inline$$WritebackToGlobal$3$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct  (and (=> (= (ControlFlow 0 427679) (- 0 787812)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 427679) 427799) inline$$WritebackToGlobal$3$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0 (|v#$Mutation| |inline$$WritebackToReference$4$dst'@2|)) (= (ControlFlow 0 427631) 427679)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct)))
(let ((inline$$WritebackToReference$4$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1))) (=> (and (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$3$dst'@2|) (= (ControlFlow 0 427500) 427631)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct))))
(let ((inline$$WritebackToReference$4$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) (|l#$Mutation| |inline$$WriteRef$5$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|size#$Path| inline$$WritebackToReference$4$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$4$dstPath@1 inline$$WritebackToReference$4$srcPath@1)) (= |inline$$WritebackToReference$4$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) inline$$WritebackToReference$4$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$4$srcPath@1 (|size#$Path| inline$$WritebackToReference$4$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|) (|v#$Mutation| |inline$$WriteRef$5$to'@1|))))) (and (= |inline$$WritebackToReference$4$dst'@2| |inline$$WritebackToReference$4$dst'@1|) (= (ControlFlow 0 427556) 427631))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct)))
(let ((inline$$WritebackToReference$4$anon0_correct  (=> (and (= inline$$WritebackToReference$4$srcPath@1 (|p#$Mutation| |inline$$WriteRef$5$to'@1|)) (= inline$$WritebackToReference$4$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (and (=> (= (ControlFlow 0 427464) 427556) inline$$WritebackToReference$4$anon3_Then_correct) (=> (= (ControlFlow 0 427464) 427500) inline$$WritebackToReference$4$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct  (=> (and (not true) (= (ControlFlow 0 427327) 427464)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@3 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 427881) 427464)) inline$$WritebackToReference$4$anon0_correct)))
(let ((inline$$WriteRef$5$anon0_correct  (=> (= |inline$$WriteRef$5$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$8$dst@1) (|p#$Mutation| inline$$BorrowField$8$dst@1) inline$$ReadRef$10$v@1)) (and (=> (= (ControlFlow 0 427313) 427881) inline$$Diem_preburn_with_resource_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 427313) 427327) inline$$Diem_preburn_with_resource_$def$0$anon92_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@30) (= (ControlFlow 0 427319) 427313)) inline$$WriteRef$5$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@0 |inline$$WritebackToGlobal$2$m'@2|) (and (=> (= (ControlFlow 0 426732) 426752) inline$$Diem_preburn_with_resource_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 426732) 426742) inline$$Diem_preburn_with_resource_$def$0$anon93_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 426670) 426732)) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1) (=> (and (= inline$$WritebackToGlobal$2$ta@1 (|ts#$Global| inline$$WritebackToGlobal$2$l@1)) (= inline$$WritebackToGlobal$2$a@1 (|a#$Global| inline$$WritebackToGlobal$2$l@1))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1) (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) (= |inline$$WritebackToGlobal$2$m'@1| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1 inline$$WritebackToGlobal$2$a@1 inline$$WritebackToGlobal$2$v@1)))) (and (= |inline$$WritebackToGlobal$2$m'@2| |inline$$WritebackToGlobal$2$m'@1|) (= (ControlFlow 0 426724) 426732))) inline$$Diem_preburn_with_resource_$def$0$anon89_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct  (=> (= inline$$WritebackToGlobal$2$l@1 (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (and (=> (= (ControlFlow 0 426660) 426724) inline$$WritebackToGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 426660) 426670) inline$$WritebackToGlobal$2$anon3_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct  (and (=> (= (ControlFlow 0 426540) (- 0 787259)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 426540) 426660) inline$$WritebackToGlobal$2$anon0_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0 (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (= (ControlFlow 0 426492) 426540)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= (ControlFlow 0 426544) 426492)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$Abort_correct  (=> (= inline$$Diem_preburn_with_resource_$def$0$$ret0@1 $Error) (=> (and (and (= inline$$Diem_preburn_with_resource_$def$0$$ret0@2 inline$$Diem_preburn_with_resource_$def$0$$ret0@1) (= $abort_code@42 $abort_code@41)) (and (= $abort_flag@31 true) (= $Diem_CurrencyInfo_$memory@1 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 423711) 428368) inline$$Diem_preburn_to_$def$0$anon39_Then_correct) (=> (= (ControlFlow 0 423711) 428176) inline$$Diem_preburn_to_$def$0$anon39_Else_correct))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon13_correct  (=> (and (= $abort_code@41 $abort_code@32) (= (ControlFlow 0 428057) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct  (=> (and (not true) (= (ControlFlow 0 428055) 428057)) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct  (=> (= (ControlFlow 0 428065) 428057) inline$$Diem_preburn_with_resource_$def$0$anon13_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct  (=> $abort_flag@24 (and (=> (= (ControlFlow 0 428049) 428065) inline$$Diem_preburn_with_resource_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 428049) 428055) inline$$Diem_preburn_with_resource_$def$0$anon69_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon21_correct  (=> (and (= $abort_code@41 $abort_code@34) (= (ControlFlow 0 428037) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct  (=> (and (not true) (= (ControlFlow 0 428035) 428037)) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct  (=> (= (ControlFlow 0 428045) 428037) inline$$Diem_preburn_with_resource_$def$0$anon21_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct  (=> $abort_flag@25 (and (=> (= (ControlFlow 0 428029) 428045) inline$$Diem_preburn_with_resource_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 428029) 428035) inline$$Diem_preburn_with_resource_$def$0$anon73_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon27_correct  (=> (and (= $abort_code@41 $abort_code@35) (= (ControlFlow 0 428007) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 428005) 428007)) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 428015) 428007) inline$$Diem_preburn_with_resource_$def$0$anon27_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct  (=> $abort_flag@26 (and (=> (= (ControlFlow 0 427999) 428015) inline$$Diem_preburn_with_resource_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 427999) 428005) inline$$Diem_preburn_with_resource_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon33_correct  (=> (and (= $abort_code@41 $abort_code@36) (= (ControlFlow 0 427983) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 427981) 427983)) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 427991) 427983) inline$$Diem_preburn_with_resource_$def$0$anon33_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct  (=> $abort_flag@27 (and (=> (= (ControlFlow 0 427975) 427991) inline$$Diem_preburn_with_resource_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 427975) 427981) inline$$Diem_preburn_with_resource_$def$0$anon79_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon37_correct  (=> (and (= $abort_code@41 $abort_code@37) (= (ControlFlow 0 427963) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 427961) 427963)) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 427971) 427963) inline$$Diem_preburn_with_resource_$def$0$anon37_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct  (=> $abort_flag@28 (and (=> (= (ControlFlow 0 427955) 427971) inline$$Diem_preburn_with_resource_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 427955) 427961) inline$$Diem_preburn_with_resource_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon41_correct  (=> (and (= $abort_code@41 $abort_code@38) (= (ControlFlow 0 427943) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 427941) 427943)) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct  (=> (= (ControlFlow 0 427951) 427943) inline$$Diem_preburn_with_resource_$def$0$anon41_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct  (=> $abort_flag@29 (and (=> (= (ControlFlow 0 427935) 427951) inline$$Diem_preburn_with_resource_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 427935) 427941) inline$$Diem_preburn_with_resource_$def$0$anon83_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon49_correct  (=> (and (= $abort_code@41 $abort_code@40) (= (ControlFlow 0 427923) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 427921) 427923)) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 427931) 427923) inline$$Diem_preburn_with_resource_$def$0$anon49_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 427915) 427931) inline$$Diem_preburn_with_resource_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 427915) 427921) inline$$Diem_preburn_with_resource_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon57_correct  (=> (and (= $abort_code@41 $abort_code@40) (= (ControlFlow 0 427893) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 427891) 427893)) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 427901) 427893) inline$$Diem_preburn_with_resource_$def$0$anon57_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct  (=> $abort_flag@30 (and (=> (= (ControlFlow 0 427885) 427901) inline$$Diem_preburn_with_resource_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 427885) 427891) inline$$Diem_preburn_with_resource_$def$0$anon91_Else_correct)))))
(let ((inline$$Event_emit_event$1$Entry_correct  (=> (= inline$$Event_emit_event$1$t@0 $Diem_PreburnEvent_type_value) (and (=> (= (ControlFlow 0 427244) 427885) inline$$Diem_preburn_with_resource_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 427244) 427319) inline$$Diem_preburn_with_resource_$def$0$anon90_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct  (and (=> (= (ControlFlow 0 427254) (- 0 787615)) true) (=> (= (ControlFlow 0 427254) 427244) inline$$Event_emit_event$1$Entry_correct))))
(let ((inline$$ReadRef$10$anon0_correct  (=> (and (= inline$$ReadRef$10$v@1 (|v#$Mutation| inline$$BorrowField$8$dst@1)) (= (ControlFlow 0 427196) 427254)) inline$$Diem_preburn_with_resource_$def$0$anon89_Then$3_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 427152) 427196)) inline$$ReadRef$10$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 427158) 427196) inline$$ReadRef$10$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 427146) 427158) inline$$Diem_PreburnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 427146) 427152) inline$$Diem_PreburnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 427138) 427196)) inline$$ReadRef$10$anon0_correct)))
(let ((inline$$Diem_PreburnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$3$dst@1) (>= (|i#$Integer| inline$$GetFieldFromValue$3$dst@1) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$3$dst@1) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0) (let ((va@@32 (|v#$Vector| call3formal@$ret0@0)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (forall ((inline$$Diem_PreburnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_PreburnEvent_pack$0$$$0 0) (< inline$$Diem_PreburnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) inline$$Diem_PreburnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) inline$$Diem_PreburnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) inline$$Diem_PreburnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) inline$$Diem_PreburnEvent_pack$0$$$0))
))) (and ((_ is $Address) call3formal@$ret0@0@@0) (= inline$$Diem_PreburnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$3$dst@1) 1 call3formal@$ret0@0) 2 call3formal@$ret0@0@@0) 3))))) (and (=> (= (ControlFlow 0 427130) 427146) inline$$Diem_PreburnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 427130) 427138) inline$$Diem_PreburnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$8$anon0_correct  (=> (= inline$$BorrowField$8$p@1 (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (=> (and (and (= inline$$BorrowField$8$size@1 (|size#$Path| inline$$BorrowField$8$p@1)) (= inline$$BorrowField$8$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$8$p@1) inline$$BorrowField$8$size@1 $Diem_CurrencyInfo_preburn_events) (+ inline$$BorrowField$8$size@1 1)))) (and (= inline$$BorrowField$8$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) inline$$BorrowField$8$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) $Diem_CurrencyInfo_preburn_events))) (= (ControlFlow 0 426874) 427130))) inline$$Diem_PreburnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1) (= (ControlFlow 0 426880) 426874)) inline$$BorrowField$8$anon0_correct)))
(let ((inline$$Not$0$anon0_correct  (=> (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$9$v@1)))) (and (=> (= (ControlFlow 0 426409) 426880) inline$$Diem_preburn_with_resource_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 426409) 426544) inline$$Diem_preburn_with_resource_$def$0$anon89_Else_correct)))))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 426399) (- 0 787220)) true) (=> (= (ControlFlow 0 426399) 426409) inline$$Not$0$anon0_correct))))
(let ((inline$$ReadRef$9$anon0_correct  (=> (and (= inline$$ReadRef$9$v@1 (|v#$Mutation| inline$$BorrowField$7$dst@1)) (= (ControlFlow 0 426351) 426399)) inline$$Not$0$Entry_correct)))
(let ((inline$$BorrowField$7$anon0_correct  (=> (= inline$$BorrowField$7$p@1 (|p#$Mutation| |inline$$WritebackToReference$3$dst'@2|)) (=> (and (and (= inline$$BorrowField$7$size@1 (|size#$Path| inline$$BorrowField$7$p@1)) (= inline$$BorrowField$7$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$7$p@1) inline$$BorrowField$7$size@1 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$7$size@1 1)))) (and (= inline$$BorrowField$7$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$3$dst'@2|) inline$$BorrowField$7$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$3$dst'@2|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 426313) 426351))) inline$$ReadRef$9$anon0_correct))))
(let ((inline$$WritebackToReference$3$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1))) (=> (and (= |inline$$WritebackToReference$3$dst'@2| inline$$BorrowGlobal$3$dst@2) (= (ControlFlow 0 426097) 426313)) inline$$BorrowField$7$anon0_correct))))
(let ((inline$$WritebackToReference$3$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) (|l#$Mutation| |inline$$WriteRef$4$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|size#$Path| inline$$WritebackToReference$3$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$3$dstPath@1 inline$$WritebackToReference$3$srcPath@1)) (= |inline$$WritebackToReference$3$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$WritebackToReference$3$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$3$srcPath@1 (|size#$Path| inline$$WritebackToReference$3$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$3$dst@2) (|v#$Mutation| |inline$$WriteRef$4$to'@1|))))) (and (= |inline$$WritebackToReference$3$dst'@2| |inline$$WritebackToReference$3$dst'@1|) (= (ControlFlow 0 426153) 426313))) inline$$BorrowField$7$anon0_correct)))
(let ((inline$$WritebackToReference$3$anon0_correct  (=> (and (= inline$$WritebackToReference$3$srcPath@1 (|p#$Mutation| |inline$$WriteRef$4$to'@1|)) (= inline$$WritebackToReference$3$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2))) (and (=> (= (ControlFlow 0 426061) 426153) inline$$WritebackToReference$3$anon3_Then_correct) (=> (= (ControlFlow 0 426061) 426097) inline$$WritebackToReference$3$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct  (=> (and (not true) (= (ControlFlow 0 425924) 426061)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$3$dst@2)) (= (ControlFlow 0 427911) 426061)) inline$$WritebackToReference$3$anon0_correct)))
(let ((inline$$WriteRef$4$anon0_correct  (=> (= |inline$$WriteRef$4$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$6$dst@1) (|p#$Mutation| inline$$BorrowField$6$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 425910) 427911) inline$$Diem_preburn_with_resource_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 425910) 425924) inline$$Diem_preburn_with_resource_$def$0$anon88_Else_correct)))))
(let ((inline$$BorrowField$6$anon0_correct  (=> (= inline$$BorrowField$6$p@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2)) (=> (and (and (= inline$$BorrowField$6$size@1 (|size#$Path| inline$$BorrowField$6$p@1)) (= inline$$BorrowField$6$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$6$p@1) inline$$BorrowField$6$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$6$size@1 1)))) (and (= inline$$BorrowField$6$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$BorrowField$6$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$3$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 425851) 425910))) inline$$WriteRef$4$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct  (=> (and (not $abort_flag@30) (= (ControlFlow 0 425857) 425851)) inline$$BorrowField$6$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@30 true) (=> (and (= $abort_code@40 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 425721) 427915) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 425721) 425857) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| inline$$GetFieldFromValue$3$dst@1)) $MAX_U64) (= (ControlFlow 0 425719) 425721)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| inline$$GetFieldFromValue$3$dst@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$8$v@1) (|i#$Integer| inline$$GetFieldFromValue$3$dst@1)))) (= $abort_flag@30 $abort_flag@29)) (and (= $abort_code@40 $abort_code@38) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 425663) 427915) inline$$Diem_preburn_with_resource_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 425663) 425857) inline$$Diem_preburn_with_resource_$def$0$anon86_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 425633) (- 0 786794)) true) (and (=> (= (ControlFlow 0 425633) 425719) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 425633) 425663) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$8$anon0_correct  (=> (and (= inline$$ReadRef$8$v@1 (|v#$Mutation| inline$$BorrowField$5$dst@1)) (= (ControlFlow 0 425526) 425633)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$BorrowField$5$anon0_correct  (=> (= inline$$BorrowField$5$p@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2)) (=> (and (and (= inline$$BorrowField$5$size@1 (|size#$Path| inline$$BorrowField$5$p@1)) (= inline$$BorrowField$5$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1) inline$$BorrowField$5$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$5$size@1 1)))) (and (= inline$$BorrowField$5$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$BorrowField$5$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$3$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 425488) 425526))) inline$$ReadRef$8$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$1$dst@1) (= (ControlFlow 0 425540) 425488)) inline$$BorrowField$5$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon46_correct  (=> (and (= $abort_code@41 $abort_code@39) (= (ControlFlow 0 425322) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct  (=> (and (not true) (= (ControlFlow 0 425320) 425322)) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct  (=> (= (ControlFlow 0 425330) 425322) inline$$Diem_preburn_with_resource_$def$0$anon46_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct  (=> (= $abort_code@39 (|i#$Integer| call3formal@$ret0@0@@1)) (and (=> (= (ControlFlow 0 425314) 425330) inline$$Diem_preburn_with_resource_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 425314) 425320) inline$$Diem_preburn_with_resource_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct  (and (=> (= (ControlFlow 0 425304) (- 0 786626)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 425304) 425314) inline$$Diem_preburn_with_resource_$def$0$anon84_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0 (|v#$Mutation| inline$$BorrowGlobal$3$dst@2)) (= (ControlFlow 0 425256) 425304)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$1$dst@1)) (= (ControlFlow 0 425308) 425256)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct  (=> (not $abort_flag@29) (and (=> (= (ControlFlow 0 425181) 425540) inline$$Diem_preburn_with_resource_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 425181) 425308) inline$$Diem_preburn_with_resource_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct  (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t27@1 ($Integer 7)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@29)) (and (=> $abort_flag@29 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@29) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 425175) 427935) inline$$Diem_preburn_with_resource_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 425175) 425181) inline$$Diem_preburn_with_resource_$def$0$anon82_Else_correct)))))
(let ((inline$$Ge$1$anon0_correct  (=> (and (= inline$$Ge$1$dst@1 ($Boolean (>= (|i#$Integer| inline$$Sub$0$dst@2) (|i#$Integer| inline$$GetFieldFromValue$3$dst@1)))) (= (ControlFlow 0 425163) 425175)) inline$$Diem_preburn_with_resource_$def$0$anon80_Else$1_correct)))
(let ((inline$$Ge$1$Entry_correct  (and (=> (= (ControlFlow 0 425149) (- 0 786516)) true) (=> (= (ControlFlow 0 425149) 425163) inline$$Ge$1$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@28) (= (ControlFlow 0 425169) 425149)) inline$$Ge$1$Entry_correct)))
(let ((inline$$Sub$0$anon3_Then$1_correct  (=> (= $abort_code@37 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@28 true) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@0)) (and (=> (= (ControlFlow 0 425093) 427955) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 425093) 425169) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct  (=> (and (< (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$7$v@1)) (= (ControlFlow 0 425091) 425093)) inline$$Sub$0$anon3_Then$1_correct)))
(let ((inline$$Sub$0$anon3_Else_correct  (=> (<= (|i#$Integer| inline$$ReadRef$7$v@1) (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1)) (=> (and (and (= inline$$Sub$0$dst@1 ($Integer (- (|i#$Integer| inline$$Diem_preburn_with_resource_$def$0$$t23@1) (|i#$Integer| inline$$ReadRef$7$v@1)))) (= $abort_code@37 $abort_code@36)) (and (= $abort_flag@28 $abort_flag@27) (= inline$$Sub$0$dst@2 inline$$Sub$0$dst@1))) (and (=> (= (ControlFlow 0 425039) 427955) inline$$Diem_preburn_with_resource_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 425039) 425169) inline$$Diem_preburn_with_resource_$def$0$anon80_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct  (and (=> (= (ControlFlow 0 425013) (- 0 786428)) true) (and (=> (= (ControlFlow 0 425013) 425091) inline$$Sub$0$anon3_Then_correct) (=> (= (ControlFlow 0 425013) 425039) inline$$Sub$0$anon3_Else_correct)))))
(let ((inline$$ReadRef$7$anon0_correct  (=> (and (= inline$$ReadRef$7$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 424914) 425013)) inline$$Sub$0$Entry_correct)))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| inline$$BorrowGlobal$3$dst@2)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$3$dst@2) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$3$dst@2))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 424876) 424914))) inline$$ReadRef$7$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t23@1 ($Integer 18446744073709551615)) (= (ControlFlow 0 424928) 424876)) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 424714) 424928)) inline$$Diem_preburn_with_resource_$def$0$anon78_Else$1_correct)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$3$dst@2)) (= (ControlFlow 0 424708) 424714)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@27) (= (ControlFlow 0 424718) 424708)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$3$anon3_Then$1_correct  (=> (= $abort_flag@27 true) (=> (and (= $abort_code@36 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$3$dst@2 inline$$BorrowGlobal$3$dst@0)) (and (=> (= (ControlFlow 0 424668) 427975) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 424668) 424718) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$3$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$3$ta@0 inline$$BorrowGlobal$3$a@1)) (= (ControlFlow 0 424666) 424668)) inline$$BorrowGlobal$3$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$3$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$3$ta@0 inline$$BorrowGlobal$3$a@1) (=> (and (and (= inline$$BorrowGlobal$3$dst@1 ($Mutation ($Global inline$$BorrowGlobal$3$ta@0 inline$$BorrowGlobal$3$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$3$ta@0 inline$$BorrowGlobal$3$a@1))) (= $abort_flag@27 $abort_flag@26)) (and (= $abort_code@36 $abort_code@35) (= inline$$BorrowGlobal$3$dst@2 inline$$BorrowGlobal$3$dst@1))) (and (=> (= (ControlFlow 0 424614) 427975) inline$$Diem_preburn_with_resource_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 424614) 424718) inline$$Diem_preburn_with_resource_$def$0$anon78_Else_correct))))))
(let ((inline$$BorrowGlobal$3$anon0_correct  (=> (= inline$$BorrowGlobal$3$a@1 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 424584) 424666) inline$$BorrowGlobal$3$anon3_Then_correct) (=> (= (ControlFlow 0 424584) 424614) inline$$BorrowGlobal$3$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$3$Entry_correct  (=> (= inline$$BorrowGlobal$3$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 424578) (- 0 786203)) true) (=> (= (ControlFlow 0 424578) 424584) inline$$BorrowGlobal$3$anon0_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@26) (= (ControlFlow 0 424674) 424578)) inline$$BorrowGlobal$3$Entry_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct  (=> $abort_flag@26 (=> (and (= $abort_code@41 $abort_code@35) (= (ControlFlow 0 427995) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 424435) 427995) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 424435) 424674) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 424445) 427995) inline$$Diem_preburn_with_resource_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 424445) 424674) inline$$Diem_preburn_with_resource_$def$0$anon77_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@26) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 424429) 424445) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 424429) 424435) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@26) (= (ControlFlow 0 424459) 424429)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@26) (=> $abort_flag@26 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@26 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@35 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@26) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0) (let ((va@@33 (|v#$Vector| call3formal@$ret0@0)))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
)))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0)) $$0@@7))
)))) (and (=> (= (ControlFlow 0 424324) 427999) inline$$Diem_preburn_with_resource_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 424324) 424459) inline$$Diem_preburn_with_resource_$def$0$anon75_Else_correct)))))
(let ((inline$$WritebackToValue$1$anon3_Else_correct  (=> (not (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 11))) (=> (and (= |inline$$WritebackToValue$1$vdst'@2| inline$$ReadRef$4$v@1) (= (ControlFlow 0 424290) 424324)) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct))))
(let ((inline$$WritebackToValue$1$anon3_Then_correct  (=> (and (and (= (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|) ($Local 11)) (= |inline$$WritebackToValue$1$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 inline$$ReadRef$4$v@1 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|)))) (and (= |inline$$WritebackToValue$1$vdst'@2| |inline$$WritebackToValue$1$vdst'@1|) (= (ControlFlow 0 424316) 424324))) inline$$Diem_preburn_with_resource_$def$0$anon24$2_correct)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (= |inline$$WritebackToReference$2$dst'@2| inline$$BorrowLoc$1$dst@1)) (and (=> (= (ControlFlow 0 424135) 424316) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 424135) 424290) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$1$dst@1) (|l#$Mutation| |inline$$WriteRef$3$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (and (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$1$dst@1) (|v#$Mutation| |inline$$WriteRef$3$to'@1|)))) (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|))) (and (=> (= (ControlFlow 0 424191) 424316) inline$$WritebackToValue$1$anon3_Then_correct) (=> (= (ControlFlow 0 424191) 424290) inline$$WritebackToValue$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$3$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1))) (and (=> (= (ControlFlow 0 424099) 424191) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 424099) 424135) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 423962) 424099)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct  (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_preburn_with_resource_$def$0$info@0)) (= (ControlFlow 0 428025) 424099)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$3$anon0_correct  (=> (= |inline$$WriteRef$3$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) call5formal@$ret0@0)) (and (=> (= (ControlFlow 0 423948) 428025) inline$$Diem_preburn_with_resource_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 423948) 423962) inline$$Diem_preburn_with_resource_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct  (=> (and (not $abort_flag@25) (= (ControlFlow 0 423954) 423948)) inline$$WriteRef$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct  (and (=> (= (ControlFlow 0 423891) (- 0 785593)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@25) (=> $abort_flag@25 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@25 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@34 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@25) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$6$v@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0) (let ((va@@34 (|v#$Vector| call5formal@$ret0@0)))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 423891) 428029) inline$$Diem_preburn_with_resource_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 423891) 423954) inline$$Diem_preburn_with_resource_$def$0$anon72_Else_correct)))))))
(let ((inline$$ReadRef$6$anon0_correct  (=> (and (= inline$$ReadRef$6$v@1 (|v#$Mutation| inline$$BorrowField$3$dst@1)) (= (ControlFlow 0 423879) 423891)) inline$$Diem_preburn_with_resource_$def$0$anon70_Then$2_correct)))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 423841) 423879))) inline$$ReadRef$6$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1) (= (ControlFlow 0 423847) 423841)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon18_correct  (=> (and (= $abort_code@41 $abort_code@33) (= (ControlFlow 0 423705) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct  (=> (and (not true) (= (ControlFlow 0 423703) 423705)) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct  (=> (= (ControlFlow 0 423719) 423705) inline$$Diem_preburn_with_resource_$def$0$anon18_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_with_resource_$def$0$$t17@1)) (= $abort_code@33 (|i#$Integer| call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 423697) 423719) inline$$Diem_preburn_with_resource_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 423697) 423703) inline$$Diem_preburn_with_resource_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct  (=> (not $abort_flag@24) (and (=> (= (ControlFlow 0 423685) 423847) inline$$Diem_preburn_with_resource_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 423685) 423697) inline$$Diem_preburn_with_resource_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct  (=> (not $abort_flag@23) (=> (and (= inline$$Diem_preburn_with_resource_$def$0$$t16@1 ($Integer 0)) (= inline$$Diem_preburn_with_resource_$def$0$$t17@1 ($Boolean ($IsEqual_stratified inline$$GetFieldFromValue$4$dst@1 inline$$Diem_preburn_with_resource_$def$0$$t16@1)))) (=> (and (and (and (= inline$$Diem_preburn_with_resource_$def$0$$t18@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@24)) (and (=> $abort_flag@24 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@24) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Integer 1))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@2) (>= (|i#$Integer| call3formal@$ret0@0@@2) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@2) $MAX_U64))) (and (=> (= (ControlFlow 0 423679) 428049) inline$$Diem_preburn_with_resource_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 423679) 423685) inline$$Diem_preburn_with_resource_$def$0$anon68_Else_correct)))))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct  (=> $abort_flag@23 (=> (and (= $abort_code@41 $abort_code@31) (= (ControlFlow 0 428069) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$2$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 423623) 428069) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 423623) 423679) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_value_$def$2$anon6_Then_correct  (and (=> (= (ControlFlow 0 423633) 428069) inline$$Diem_preburn_with_resource_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 423633) 423679) inline$$Diem_preburn_with_resource_$def$0$anon67_Else_correct))))
(let ((inline$$GetFieldFromValue$4$anon0_correct  (=> (= inline$$GetFieldFromValue$4$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 423607) 423633) inline$$Diem_value_$def$2$anon6_Then_correct) (=> (= (ControlFlow 0 423607) 423623) inline$$Diem_value_$def$2$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$2$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 423531) 423607)) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$Diem_value_$def$2$anon5_Then_correct  (=> (= (ControlFlow 0 423641) 423607) inline$$GetFieldFromValue$4$anon0_correct)))
(let ((inline$$Diem_value_$def$2$anon0_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 423525) 423641) inline$$Diem_value_$def$2$anon5_Then_correct) (=> (= (ControlFlow 0 423525) 423531) inline$$Diem_value_$def$2$anon5_Else_correct)))))
(let ((inline$$Diem_value$2$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$5$v@1) (let ((va@@35 (|v#$Vector| inline$$ReadRef$5$v@1)))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$5$v@1)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 423647) 423525)) inline$$Diem_value_$def$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct  (and (=> (= (ControlFlow 0 423655) (- 0 785290)) true) (=> (= (ControlFlow 0 423655) 423647) inline$$Diem_value$2$anon0_correct))))
(let ((inline$$ReadRef$5$anon0_correct  (=> (and (= inline$$ReadRef$5$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 423345) 423655)) inline$$Diem_preburn_with_resource_$def$0$anon66_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowLoc$1$dst@1)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $Diem_Preburn_to_burn) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$1$dst@1) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$1$dst@1))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 423307) 423345))) inline$$ReadRef$5$anon0_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 423359) 423307)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct  (=> $abort_flag@23 (=> (and (= $abort_code@41 $abort_code@31) (= (ControlFlow 0 428073) 423711)) inline$$Diem_preburn_with_resource_$def$0$Abort_correct))))
(let ((inline$$Diem_value_$def$1$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 423115) 428073) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 423115) 423359) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon6_Then_correct  (and (=> (= (ControlFlow 0 423125) 428073) inline$$Diem_preburn_with_resource_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 423125) 423359) inline$$Diem_preburn_with_resource_$def$0$anon66_Else_correct))))
(let ((inline$$GetFieldFromValue$3$anon0_correct  (=> (= inline$$GetFieldFromValue$3$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 423099) 423125) inline$$Diem_value_$def$1$anon6_Then_correct) (=> (= (ControlFlow 0 423099) 423115) inline$$Diem_value_$def$1$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$1$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 423023) 423099)) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon5_Then_correct  (=> (= (ControlFlow 0 423133) 423099) inline$$GetFieldFromValue$3$anon0_correct)))
(let ((inline$$Diem_value_$def$1$anon0_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 423017) 423133) inline$$Diem_value_$def$1$anon5_Then_correct) (=> (= (ControlFlow 0 423017) 423023) inline$$Diem_value_$def$1$anon5_Else_correct)))))
(let ((inline$$Diem_value$1$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_withdraw_from_$def$0$$ret0@2) (let ((va@@36 (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 423139) 423017)) inline$$Diem_value_$def$1$anon0_correct)))
(let ((inline$$BorrowLoc$1$anon0_correct  (=> (and (= inline$$BorrowLoc$1$dst@1 ($Mutation ($Local 11) $EmptyPath inline$$ReadRef$4$v@1)) (= (ControlFlow 0 422849) 423139)) inline$$Diem_value$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 422697) 422849)) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 428081) 422849) inline$$BorrowLoc$1$anon0_correct)))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 422689) 428081) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 422689) 422697) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct  (and (=> (= (ControlFlow 0 428089) 428081) inline$$Diem_preburn_with_resource_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 428089) 422697) inline$$Diem_preburn_with_resource_$def$0$anon65_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 422681) 428089) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 422681) 422689) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct  (and (=> (= (ControlFlow 0 428097) 428089) inline$$Diem_preburn_with_resource_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 428097) 422689) inline$$Diem_preburn_with_resource_$def$0$anon64_Else_correct))))
(let ((inline$$Diem_preburn_with_resource_$def$0$anon0_correct  (=> (not $abort_flag@23) (and (=> (= (ControlFlow 0 422675) 428097) inline$$Diem_preburn_with_resource_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 422675) 422681) inline$$Diem_preburn_with_resource_$def$0$anon63_Else_correct)))))
(let ((inline$$Diem_preburn_with_resource$0$anon0_correct  (=> (and (and (and (and ((_ is $Vector) inline$$DiemAccount_withdraw_from_$def$0$$ret0@2) (let ((va@@37 (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$4$v@1) (let ((va@@38 (|v#$Vector| inline$$ReadRef$4$v@1)))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$4$v@1)) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) (and ((_ is $Address) call3formal@$ret0@0@@0) (= (ControlFlow 0 428103) 422675))) inline$$Diem_preburn_with_resource_$def$0$anon0_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon37_Else$1_correct  (and (=> (= (ControlFlow 0 428111) (- 0 784865)) true) (=> (= (ControlFlow 0 428111) 428103) inline$$Diem_preburn_with_resource$0$anon0_correct))))
(let ((inline$$ReadRef$4$anon0_correct  (=> (and (= inline$$ReadRef$4$v@1 (|v#$Mutation| inline$$BorrowGlobal$2$dst@2)) (= (ControlFlow 0 421488) 428111)) inline$$Diem_preburn_to_$def$0$anon37_Else$1_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon37_Else_correct  (=> (and (not $abort_flag@23) (= (ControlFlow 0 421494) 421488)) inline$$ReadRef$4$anon0_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Then$1_correct  (=> (= $abort_code@31 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@23 true) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@0)) (and (=> (= (ControlFlow 0 421444) 428372) inline$$Diem_preburn_to_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 421444) 421494) inline$$Diem_preburn_to_$def$0$anon37_Else_correct))))))
(let ((inline$$BorrowGlobal$2$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1)) (= (ControlFlow 0 421442) 421444)) inline$$BorrowGlobal$2$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$2$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) (=> (and (and (= inline$$BorrowGlobal$2$dst@1 ($Mutation ($Global inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$2$ta@0 inline$$BorrowGlobal$2$a@1))) (= $abort_code@31 $abort_code@29)) (and (= $abort_flag@23 $abort_flag@22) (= inline$$BorrowGlobal$2$dst@2 inline$$BorrowGlobal$2$dst@1))) (and (=> (= (ControlFlow 0 421390) 428372) inline$$Diem_preburn_to_$def$0$anon37_Then_correct) (=> (= (ControlFlow 0 421390) 421494) inline$$Diem_preburn_to_$def$0$anon37_Else_correct))))))
(let ((inline$$BorrowGlobal$2$anon0_correct  (=> (= inline$$BorrowGlobal$2$a@1 (|a#$Address| call3formal@$ret0@0@@0)) (and (=> (= (ControlFlow 0 421360) 421442) inline$$BorrowGlobal$2$anon3_Then_correct) (=> (= (ControlFlow 0 421360) 421390) inline$$BorrowGlobal$2$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$2$Entry_correct  (=> (= inline$$BorrowGlobal$2$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 421354) (- 0 784752)) true) (=> (= (ControlFlow 0 421354) 421360) inline$$BorrowGlobal$2$anon0_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon35_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_preburn_to_$def$0$$t7@1) (= (ControlFlow 0 421450) 421354)) inline$$BorrowGlobal$2$Entry_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon20_correct  (=> (= $abort_code@43 $abort_code@30) (=> (and (= $Diem_CurrencyInfo_$memory@2 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 421225) 421229)) inline$$Diem_preburn_to_$def$0$Abort_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 421223) 421225)) inline$$Diem_preburn_to_$def$0$anon20_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 421237) 421225) inline$$Diem_preburn_to_$def$0$anon20_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon35_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_preburn_to_$def$0$$t7@1)) (= $abort_code@30 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 421217) 421237) inline$$Diem_preburn_to_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 421217) 421223) inline$$Diem_preburn_to_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon33_Else_correct  (=> (not $abort_flag@22) (and (=> (= (ControlFlow 0 421205) 421450) inline$$Diem_preburn_to_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 421205) 421217) inline$$Diem_preburn_to_$def$0$anon35_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon31_Else_correct  (=> (and (not $abort_flag@21) (= inline$$Diem_preburn_to_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@0))))) (=> (and (and (and (= inline$$Diem_preburn_to_$def$0$$t8@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@22)) (and (=> $abort_flag@22 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@22) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 421199) 428392) inline$$Diem_preburn_to_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 421199) 421205) inline$$Diem_preburn_to_$def$0$anon33_Else_correct))))))
(let ((inline$$Diem_preburn_to_$def$0$anon29_Else_correct  (=> (not $abort_flag@20) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@21) (=> $abort_flag@21 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@21) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 dd)))) ((_ is $Address) call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 421169) 428412) inline$$Diem_preburn_to_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 421169) 421199) inline$$Diem_preburn_to_$def$0$anon31_Else_correct))))))
(let ((inline$$Diem_preburn_to_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) $abort_flag@20) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) $abort_flag@20)) (and (=> $abort_flag@20 (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))))) (=> $abort_flag@20 (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd))))))) (= $abort_code@27 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| dd)))) $Roles_RoleId_role_id) ($Integer 2))))) (= $abort_code@27 (|i#$Integer| ($Integer 3)))))))) (and (=> (= (ControlFlow 0 421163) 428432) inline$$Diem_preburn_to_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 421163) 421169) inline$$Diem_preburn_to_$def$0$anon29_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 421093) 421163)) inline$$Diem_preburn_to_$def$0$anon4$2_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 428456) 421163) inline$$Diem_preburn_to_$def$0$anon4$2_correct)))
(let ((inline$$Diem_preburn_to_$def$0$anon27_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 421085) 428456) inline$$Diem_preburn_to_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 421085) 421093) inline$$Diem_preburn_to_$def$0$anon28_Else_correct)))))
(let ((inline$$Diem_preburn_to_$def$0$anon27_Then_correct  (and (=> (= (ControlFlow 0 428464) 428456) inline$$Diem_preburn_to_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 428464) 421093) inline$$Diem_preburn_to_$def$0$anon28_Else_correct))))
(let ((inline$$Diem_preburn_to_$def$0$anon0_correct  (=> (not $abort_flag@19) (and (=> (= (ControlFlow 0 421079) 428464) inline$$Diem_preburn_to_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 421079) 421085) inline$$Diem_preburn_to_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_preburn_to_$direct_inter$0$anon0_correct  (=> ((_ is $Address) dd) (=> (and (and (and (and (and ((_ is $Vector) inline$$DiemAccount_withdraw_from_$def$0$$ret0@2) (let ((va@@40 (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_withdraw_from_$def$0$$ret0@2)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 428468) 421079)) inline$$Diem_preburn_to_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon26_Else_correct  (=> (and (not $abort_flag@19) (= (ControlFlow 0 428474) 428468)) inline$$Diem_preburn_to_$direct_inter$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon56_correct  (=> (and (= inline$$DiemAccount_withdraw_from_$def$0$$ret0@2 inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@2) (= $DiemAccount_DiemAccount_$memory@1@@0 |inline$$WritebackToGlobal$0$m'@2|)) (=> (and (and (= $abort_flag@19 $abort_flag@18) (= $AccountLimits_Window_$memory@5 $AccountLimits_Window_$memory@3)) (and (= $abort_code@26 $abort_code@24) (= $DiemAccount_Balance_$memory@0 |inline$$WritebackToGlobal$1$m'@2|))) (and (=> (= (ControlFlow 0 420297) 428494) inline$$DiemAccount_preburn_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 420297) 428474) inline$$DiemAccount_preburn_$def_verify$0$anon26_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 420295) 420297)) inline$$DiemAccount_withdraw_from_$def$0$anon56_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 420305) 420297) inline$$DiemAccount_withdraw_from_$def$0$anon56_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon54$1_correct  (and (=> (= (ControlFlow 0 420289) (- 0 783827)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_withdraw_from_$def$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$coin_type)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$coin_type)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_withdraw_from_$def$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$coin_type@@0)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@0))))))))))))))) (and (=> (= (ControlFlow 0 420289) (- 0 783905)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$token T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_withdraw_from_$def$0$token) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$token)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@1)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$token@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_withdraw_from_$def$0$token@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_withdraw_from_$def$0$token@@0)) 1) (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@2)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (and (=> (= (ControlFlow 0 420289) 420305) inline$$DiemAccount_withdraw_from_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 420289) 420295) inline$$DiemAccount_withdraw_from_$def$0$anon84_Else_correct))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $DiemAccount_Balance_$memory) (= (ControlFlow 0 420081) 420289)) inline$$DiemAccount_withdraw_from_$def$0$anon54$1_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WriteRef$2$to'@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DiemAccount_Balance_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 420135) 420289))) inline$$DiemAccount_withdraw_from_$def$0$anon54$1_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (and (=> (= (ControlFlow 0 420071) 420135) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 420071) 420081) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 419953) 420071)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon83_Then_correct  (=> (and (= inline$$DiemAccount_withdraw_from_$def$0$$trace_temp@2 (|v#$Mutation| |inline$$WriteRef$2$to'@1|)) (= (ControlFlow 0 420315) 420071)) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|p#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@2)) (and (=> (= (ControlFlow 0 419939) 420315) inline$$DiemAccount_withdraw_from_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 419939) 419953) inline$$DiemAccount_withdraw_from_$def$0$anon83_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon82_Else_correct  (=> (and (not $abort_flag@18) (= (ControlFlow 0 419945) 419939)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$Abort_correct  (=> (= inline$$DiemAccount_withdraw_from_$def$0$$ret0@1 $Error) (=> (and (= inline$$DiemAccount_withdraw_from_$def$0$$ret0@2 inline$$DiemAccount_withdraw_from_$def$0$$ret0@1) (= $DiemAccount_DiemAccount_$memory@1@@0 $DiemAccount_DiemAccount_$memory@0@@0)) (=> (and (and (= $abort_flag@19 true) (= $AccountLimits_Window_$memory@5 $AccountLimits_Window_$memory@4)) (and (= $abort_code@26 $abort_code@25) (= $DiemAccount_Balance_$memory@0 $DiemAccount_Balance_$memory))) (and (=> (= (ControlFlow 0 414677) 428494) inline$$DiemAccount_preburn_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 414677) 428474) inline$$DiemAccount_preburn_$def_verify$0$anon26_Else_correct)))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon11_correct  (=> (and (and (= $abort_code@25 $abort_code@3@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420473) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon62_Else_correct  (=> (and (not true) (= (ControlFlow 0 420471) 420473)) inline$$DiemAccount_withdraw_from_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon62_Then_correct  (=> (= (ControlFlow 0 420481) 420473) inline$$DiemAccount_withdraw_from_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon61_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 420465) 420481) inline$$DiemAccount_withdraw_from_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 420465) 420471) inline$$DiemAccount_withdraw_from_$def$0$anon62_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon19_correct  (=> (and (and (= $abort_code@25 $abort_code@4@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420441) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 420439) 420441)) inline$$DiemAccount_withdraw_from_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon66_Then_correct  (=> (= (ControlFlow 0 420449) 420441) inline$$DiemAccount_withdraw_from_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon65_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 420433) 420449) inline$$DiemAccount_withdraw_from_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 420433) 420439) inline$$DiemAccount_withdraw_from_$def$0$anon66_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon27_correct  (=> (and (and (= $abort_code@25 $abort_code@5@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420421) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 420419) 420421)) inline$$DiemAccount_withdraw_from_$def$0$anon27_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 420429) 420421) inline$$DiemAccount_withdraw_from_$def$0$anon27_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon69_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 420413) 420429) inline$$DiemAccount_withdraw_from_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 420413) 420419) inline$$DiemAccount_withdraw_from_$def$0$anon70_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon35_correct  (=> (and (and (= $abort_code@25 $abort_code@8) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420401) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 420399) 420401)) inline$$DiemAccount_withdraw_from_$def$0$anon35_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 420409) 420401) inline$$DiemAccount_withdraw_from_$def$0$anon35_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon73_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 420393) 420409) inline$$DiemAccount_withdraw_from_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 420393) 420399) inline$$DiemAccount_withdraw_from_$def$0$anon74_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon39_correct  (=> (and (and (= $abort_code@25 $abort_code@9) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420381) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 420379) 420381)) inline$$DiemAccount_withdraw_from_$def$0$anon39_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 420389) 420381) inline$$DiemAccount_withdraw_from_$def$0$anon39_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon75_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 420373) 420389) inline$$DiemAccount_withdraw_from_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 420373) 420379) inline$$DiemAccount_withdraw_from_$def$0$anon76_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon43_correct  (=> (and (and (= $abort_code@25 $abort_code@10) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420361) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 420359) 420361)) inline$$DiemAccount_withdraw_from_$def$0$anon43_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon78_Then_correct  (=> (= (ControlFlow 0 420369) 420361) inline$$DiemAccount_withdraw_from_$def$0$anon43_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon77_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 420353) 420369) inline$$DiemAccount_withdraw_from_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 420353) 420359) inline$$DiemAccount_withdraw_from_$def$0$anon78_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon47_correct  (=> (and (and (= $abort_code@25 $abort_code@10) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420341) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 420339) 420341)) inline$$DiemAccount_withdraw_from_$def$0$anon47_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon80_Then_correct  (=> (= (ControlFlow 0 420349) 420341) inline$$DiemAccount_withdraw_from_$def$0$anon47_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon79_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 420333) 420349) inline$$DiemAccount_withdraw_from_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 420333) 420339) inline$$DiemAccount_withdraw_from_$def$0$anon80_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon82_Then_correct  (=> $abort_flag@18 (=> (and (and (= $abort_code@25 $abort_code@24) (= $DiemAccount_DiemAccount_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2|)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory@3) (= (ControlFlow 0 420319) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon64_correct  (=> (= $abort_code@24 $abort_code@21) (=> (and (and (= $AccountLimits_Window_$memory@3 $AccountLimits_Window_$memory@1) (= $abort_flag@18 $abort_flag@17)) (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@2 call5formal@$ret0@0@@0) (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@2 |inline$$WritebackToValue$0$vdst'@2|))) (and (=> (= (ControlFlow 0 419188) 420319) inline$$DiemAccount_withdraw_from_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 419188) 419945) inline$$DiemAccount_withdraw_from_$def$0$anon82_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 419186) 419188)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon64_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Then_correct  (=> (= (ControlFlow 0 419196) 419188) inline$$DiemAccount_withdraw_from_balance_$def$0$anon64_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 419176) 419196) inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 419176) 419186) inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Then_correct  (and (=> (= (ControlFlow 0 419204) 419196) inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 419204) 419186) inline$$DiemAccount_withdraw_from_balance_$def$0$anon96_Else_correct))))
(let ((inline$$WritebackToValue$0$anon3_Else_correct  (=> (and (not (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12))) (= |inline$$WritebackToValue$0$vdst'@2| inline$$ReadRef$1$v@1)) (and (=> (= (ControlFlow 0 419134) 419204) inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 419134) 419176) inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Else_correct)))))
(let ((inline$$WritebackToValue$0$anon3_Then_correct  (=> (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) ($Local 12)) (=> (and (= |inline$$WritebackToValue$0$vdst'@1| ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|) 0 inline$$ReadRef$1$v@1 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (= |inline$$WritebackToValue$0$vdst'@2| |inline$$WritebackToValue$0$vdst'@1|)) (and (=> (= (ControlFlow 0 419160) 419204) inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 419160) 419176) inline$$DiemAccount_withdraw_from_balance_$def$0$anon95_Else_correct))))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (and (not (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowLoc$0$dst@1)) (and (=> (= (ControlFlow 0 418979) 419160) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 418979) 419134) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (= (|l#$Mutation| inline$$BorrowLoc$0$dst@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (and (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowLoc$0$dst@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1|)))) (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|))) (and (=> (= (ControlFlow 0 419035) 419160) inline$$WritebackToValue$0$anon3_Then_correct) (=> (= (ControlFlow 0 419035) 419134) inline$$WritebackToValue$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1))) (and (=> (= (ControlFlow 0 418943) 419035) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 418943) 418979) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon94_Else_correct  (=> (and (not true) (= (ControlFlow 0 418806) 418943)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon94_Then_correct  (=> (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$trace_temp@1 (|v#$Mutation| |inline$$WriteRef$1$to'@1|)) (= (ControlFlow 0 419214) 418943)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) call6formal@$ret1@0)) (and (=> (= (ControlFlow 0 418792) 419214) inline$$DiemAccount_withdraw_from_balance_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 418792) 418806) inline$$DiemAccount_withdraw_from_balance_$def$0$anon94_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon92_Else_correct  (=> (and (not $abort_flag@17) (= (ControlFlow 0 418798) 418792)) inline$$WriteRef$1$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct  (=> (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@1 $Error) (=> (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@1 $Error) (= $abort_code@24 $abort_code@23)) (=> (and (and (= $AccountLimits_Window_$memory@3 $AccountLimits_Window_$memory@2) (= $abort_flag@18 true)) (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@2 inline$$DiemAccount_withdraw_from_balance_$def$0$$ret0@1) (= inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@2 inline$$DiemAccount_withdraw_from_balance_$def$0$$ret1@1))) (and (=> (= (ControlFlow 0 418679) 420319) inline$$DiemAccount_withdraw_from_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 418679) 419945) inline$$DiemAccount_withdraw_from_$def$0$anon82_Else_correct)))))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon11_correct  (=> (= $abort_code@23 $abort_code@11) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419822) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 419820) 419822)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 419830) 419822) inline$$DiemAccount_withdraw_from_balance_$def$0$anon11_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon69_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 419814) 419830) inline$$DiemAccount_withdraw_from_balance_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 419814) 419820) inline$$DiemAccount_withdraw_from_balance_$def$0$anon70_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon15_correct  (=> (= $abort_code@23 $abort_code@12) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419802) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 419800) 419802)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon72_Then_correct  (=> (= (ControlFlow 0 419810) 419802) inline$$DiemAccount_withdraw_from_balance_$def$0$anon15_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon71_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 419794) 419810) inline$$DiemAccount_withdraw_from_balance_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 419794) 419800) inline$$DiemAccount_withdraw_from_balance_$def$0$anon72_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon19_correct  (=> (= $abort_code@23 $abort_code@13) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419782) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 419780) 419782)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 419790) 419782) inline$$DiemAccount_withdraw_from_balance_$def$0$anon19_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon73_Then_correct  (=> $abort_flag@10 (and (=> (= (ControlFlow 0 419774) 419790) inline$$DiemAccount_withdraw_from_balance_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 419774) 419780) inline$$DiemAccount_withdraw_from_balance_$def$0$anon74_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon25_correct  (=> (= $abort_code@23 $abort_code@14) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419762) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 419760) 419762)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon77_Then_correct  (=> (= (ControlFlow 0 419770) 419762) inline$$DiemAccount_withdraw_from_balance_$def$0$anon25_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon76_Then_correct  (=> $abort_flag@11 (and (=> (= (ControlFlow 0 419754) 419770) inline$$DiemAccount_withdraw_from_balance_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 419754) 419760) inline$$DiemAccount_withdraw_from_balance_$def$0$anon77_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon31_correct  (=> (= $abort_code@23 $abort_code@15) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419738) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 419736) 419738)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon31_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon80_Then_correct  (=> (= (ControlFlow 0 419746) 419738) inline$$DiemAccount_withdraw_from_balance_$def$0$anon31_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 419730) 419746) inline$$DiemAccount_withdraw_from_balance_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 419730) 419736) inline$$DiemAccount_withdraw_from_balance_$def$0$anon80_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon35_correct  (=> (= $abort_code@23 $abort_code@16) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@0) (= (ControlFlow 0 419718) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon82_Else_correct  (=> (and (not true) (= (ControlFlow 0 419716) 419718)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon35_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon82_Then_correct  (=> (= (ControlFlow 0 419726) 419718) inline$$DiemAccount_withdraw_from_balance_$def$0$anon35_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon81_Then_correct  (=> $abort_flag@13 (and (=> (= (ControlFlow 0 419710) 419726) inline$$DiemAccount_withdraw_from_balance_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 419710) 419716) inline$$DiemAccount_withdraw_from_balance_$def$0$anon82_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon39_correct  (=> (= $abort_code@23 $abort_code@17) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@0) (= (ControlFlow 0 419698) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 419696) 419698)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon39_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 419706) 419698) inline$$DiemAccount_withdraw_from_balance_$def$0$anon39_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon83_Then_correct  (=> $abort_flag@14 (and (=> (= (ControlFlow 0 419690) 419706) inline$$DiemAccount_withdraw_from_balance_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 419690) 419696) inline$$DiemAccount_withdraw_from_balance_$def$0$anon84_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon44_correct  (=> (= $abort_code@23 $abort_code@22) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@0) (= (ControlFlow 0 419672) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon86_Else_correct  (=> (and (not true) (= (ControlFlow 0 419670) 419672)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon44_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon86_Then_correct  (=> (= (ControlFlow 0 419680) 419672) inline$$DiemAccount_withdraw_from_balance_$def$0$anon44_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon85_Else_correct  (=> (and (not (|b#$Boolean| call8formal@$ret0@0)) (= $abort_code@22 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 419664) 419680) inline$$DiemAccount_withdraw_from_balance_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 419664) 419670) inline$$DiemAccount_withdraw_from_balance_$def$0$anon86_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Then_correct  (=> (and (and $abort_flag@11 (= $abort_code@23 $abort_code@14)) (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory) (= (ControlFlow 0 419750) 418679))) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon49_correct  (=> (= $abort_code@23 $abort_code@19) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@1) (= (ControlFlow 0 419246) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 419244) 419246)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon49_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 419254) 419246) inline$$DiemAccount_withdraw_from_balance_$def$0$anon49_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon88_Then_correct  (=> $abort_flag@16 (and (=> (= (ControlFlow 0 419238) 419254) inline$$DiemAccount_withdraw_from_balance_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 419238) 419244) inline$$DiemAccount_withdraw_from_balance_$def$0$anon89_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon57_correct  (=> (= $abort_code@23 $abort_code@21) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@1) (= (ControlFlow 0 419226) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 419224) 419226)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon57_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon93_Then_correct  (=> (= (ControlFlow 0 419234) 419226) inline$$DiemAccount_withdraw_from_balance_$def$0$anon57_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon92_Then_correct  (=> $abort_flag@17 (and (=> (= (ControlFlow 0 419218) 419234) inline$$DiemAccount_withdraw_from_balance_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 419218) 419224) inline$$DiemAccount_withdraw_from_balance_$def$0$anon93_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Then$1_correct  (and (=> (= (ControlFlow 0 418735) (- 0 782986)) true) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (|i#$Integer| amount)))) $abort_flag@17) (=> (and (and (=> $abort_flag@17 (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (|i#$Integer| amount))))) (=> $abort_flag@17 (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (|i#$Integer| amount)))) (= $abort_code@21 (|i#$Integer| ($Integer 8)))))) (and (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$3$v@1)) $Diem_Diem_value)) (|i#$Integer| amount))))))) (=> (not $abort_flag@17) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value) amount)))))) (=> (and (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@0) (let ((va@@41 (|v#$Vector| call5formal@$ret0@0@@0)))
(let ((l@@41 (|l#$ValueArray| va@@41)))
 (and (and (<= 0 l@@41) (<= l@@41 $MAX_U64)) (forall ((x@@41 Int) ) (!  (=> (or (< x@@41 0) (>= x@@41 l@@41)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@41) x@@41))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call6formal@$ret1@0) (let ((va@@42 (|v#$Vector| call6formal@$ret1@0)))
(let ((l@@42 (|l#$ValueArray| va@@42)))
 (and (and (<= 0 l@@42) (<= l@@42 $MAX_U64)) (forall ((x@@42 Int) ) (!  (=> (or (< x@@42 0) (>= x@@42 l@@42)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@42) x@@42))
)))))) (= (|l#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call6formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 418735) 419218) inline$$DiemAccount_withdraw_from_balance_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 418735) 418798) inline$$DiemAccount_withdraw_from_balance_$def$0$anon92_Else_correct))))))))
(let ((inline$$ReadRef$3$anon0_correct  (=> (and (= inline$$ReadRef$3$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 418723) 418735)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Then$1_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1) (= (ControlFlow 0 418729) 418723)) inline$$ReadRef$3$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon54_correct  (=> (= $abort_code@23 $abort_code@20) (=> (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@1) (= (ControlFlow 0 418671) 418679)) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 418669) 418671)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon54_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 418687) 418671) inline$$DiemAccount_withdraw_from_balance_$def$0$anon54_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1)) (= $abort_code@20 (|i#$Integer| call3formal@$ret0@0@@5))) (and (=> (= (ControlFlow 0 418663) 418687) inline$$DiemAccount_withdraw_from_balance_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 418663) 418669) inline$$DiemAccount_withdraw_from_balance_$def$0$anon91_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon88_Else_correct  (=> (not $abort_flag@16) (and (=> (= (ControlFlow 0 418651) 418729) inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 418651) 418663) inline$$DiemAccount_withdraw_from_balance_$def$0$anon90_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$t26@1 ($Integer 5)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@16)) (and (=> $abort_flag@16 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@16) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@5 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@5) (>= (|i#$Integer| call3formal@$ret0@0@@5) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@5) $MAX_U64))) (and (=> (= (ControlFlow 0 418645) 419238) inline$$DiemAccount_withdraw_from_balance_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 418645) 418651) inline$$DiemAccount_withdraw_from_balance_$def$0$anon88_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct  (=> (and (= inline$$Ge$0$dst@1 ($Boolean (>= (|i#$Integer| inline$$GetFieldFromValue$1$dst@1) (|i#$Integer| amount)))) (= (ControlFlow 0 418633) 418645)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Else$1_correct)))
(let ((inline$$Ge$0$Entry_correct  (and (=> (= (ControlFlow 0 418619) (- 0 782851)) true) (=> (= (ControlFlow 0 418619) 418633) inline$$Ge$0$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Else_correct  (=> (and (not $abort_flag@15) (= (ControlFlow 0 418639) 418619)) inline$$Ge$0$Entry_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Then_correct  (=> (and (and $abort_flag@15 (= $abort_code@23 $abort_code@18)) (and (= $AccountLimits_Window_$memory@2 $AccountLimits_Window_$memory@1) (= (ControlFlow 0 419258) 418679))) inline$$DiemAccount_withdraw_from_balance_$def$0$Abort_correct)))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 418537) 419258) inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 418537) 418639) inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 418547) 419258) inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 418547) 418639) inline$$DiemAccount_withdraw_from_balance_$def$0$anon87_Else_correct))))
(let ((inline$$GetFieldFromValue$1$anon0_correct  (=> (= inline$$GetFieldFromValue$1$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 418521) 418547) inline$$Diem_value_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 418521) 418537) inline$$Diem_value_$def$0$anon6_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 418445) 418521)) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 418555) 418521) inline$$GetFieldFromValue$1$anon0_correct)))
(let ((inline$$Diem_value_$def$0$anon0_correct  (=> (not $abort_flag@15) (and (=> (= (ControlFlow 0 418439) 418555) inline$$Diem_value_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 418439) 418445) inline$$Diem_value_$def$0$anon5_Else_correct)))))
(let ((inline$$Diem_value$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) inline$$ReadRef$2$v@1) (let ((va@@43 (|v#$Vector| inline$$ReadRef$2$v@1)))
(let ((l@@43 (|l#$ValueArray| va@@43)))
 (and (and (<= 0 l@@43) (<= l@@43 $MAX_U64)) (forall ((x@@43 Int) ) (!  (=> (or (< x@@43 0) (>= x@@43 l@@43)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@43) x@@43))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$2$v@1)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 418561) 418439)) inline$$Diem_value_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$L2$2_correct  (and (=> (= (ControlFlow 0 418569) (- 0 782750)) true) (=> (= (ControlFlow 0 418569) 418561) inline$$Diem_value$0$anon0_correct))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$1$dst@1)) (= (ControlFlow 0 418267) 418569)) inline$$DiemAccount_withdraw_from_balance_$def$0$L2$2_correct)))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowLoc$0$dst@1)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DiemAccount_Balance_coin) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowLoc$0$dst@1) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowLoc$0$dst@1))) $DiemAccount_Balance_coin))) (= (ControlFlow 0 418229) 418267))) inline$$ReadRef$2$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon85_Then_correct  (=> (|b#$Boolean| call8formal@$ret0@0) (=> (and (and (= $abort_code@18 $abort_code@17) (= $abort_flag@15 $abort_flag@14)) (and (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory@0) (= (ControlFlow 0 419686) 418229))) inline$$BorrowField$1$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon83_Else_correct  (=> (not $abort_flag@14) (and (=> (= (ControlFlow 0 419652) 419686) inline$$DiemAccount_withdraw_from_balance_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 419652) 419664) inline$$DiemAccount_withdraw_from_balance_$def$0$anon85_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon81_Else_correct  (=> (not $abort_flag@13) (=> (and (and (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$t21@1 ($Integer 6)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@14)) (and (=> $abort_flag@14 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@14) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 419646) 419690) inline$$DiemAccount_withdraw_from_balance_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 419646) 419652) inline$$DiemAccount_withdraw_from_balance_$def$0$anon83_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Else$1_correct  (and (=> (= (ControlFlow 0 419636) (- 0 781172)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_balance_$def$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_balance_$def$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))) $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@13)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@30 (|l#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@31 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@31 (|l#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@32 (|l#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@33 (|l#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@34 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@34 1)))) len@@33 ($Integer 0)) (+ len@@33 1)))) len@@32 ($Integer 0)) (+ len@@32 1)))) len@@31 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@31 1)))) len@@30 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@30 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@13) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@13))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13) (=> $abort_flag@13 (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@35 (|l#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@36 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@36 (|l#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@37 (|l#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@38 (|l#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@39 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@39 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@39 1)))) len@@38 ($Integer 0)) (+ len@@38 1)))) len@@37 ($Integer 0)) (+ len@@37 1)))) len@@36 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@36 1)))) len@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@35 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (and (=> $abort_flag@13 (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@40 (|l#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@41 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@41 (|l#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@42 (|l#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@43 (|l#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@44 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@44 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@44 1)))) len@@43 ($Integer 0)) (+ len@@43 1)))) len@@42 ($Integer 0)) (+ len@@42 1)))) len@@41 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@41 1)))) len@@40 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@40 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@16 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@16 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified call8formal@$ret0@0 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@45 (|l#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@46 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@46 (|l#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@47 (|l#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@48 (|l#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@49 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@49 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@49 1)))) len@@48 ($Integer 0)) (+ len@@48 1)))) len@@47 ($Integer 0)) (+ len@@47 1)))) len@@46 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@46 1)))) len@@45 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@45 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow))))))))))))) (and (and (=> (not $abort_flag@13) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| call8formal@$ret0@0) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))))) $AccountLimits_Window_tracked_balance (ite (|b#$Boolean| ($Boolean (>= (|i#$Integer| amount) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_tracked_balance))))) ($Integer 0) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| amount))))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))) $AccountLimits_Window_window_outflow)) (|i#$Integer| amount)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@50 (|l#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@51 (|l#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@52 (|l#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@53 (|l#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@54 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@54 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@54 1)))) len@@53 ($Integer 0)) (+ len@@53 1)))) len@@52 ($Integer 0)) (+ len@@52 1)))) len@@51 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@51 1)))) len@@50 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@50 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)) (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@55 (|l#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@56 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@56 (|l#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@57 (|l#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@58 (|l#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@59 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@59 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@59 1)))) len@@58 ($Integer 0)) (+ len@@58 1)))) len@@57 ($Integer 0)) (+ len@@57 1)))) len@@56 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_tracked_balance)) (+ len@@56 1)))) len@@55 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) $AccountLimits_Window_limit_address)) (+ len@@55 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))))))))) ((_ is $Boolean) call8formal@$ret0@0)) (and (= (|contents#$Memory| $AccountLimits_Window_$memory@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6)))) (= (|domain#$Memory| $AccountLimits_Window_$memory@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@6))))))) (and (=> (= (ControlFlow 0 419636) 419710) inline$$DiemAccount_withdraw_from_balance_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 419636) 419646) inline$$DiemAccount_withdraw_from_balance_$def$0$anon81_Else_correct))))))))
(let ((inline$$GetFieldFromValue$2$anon0_correct  (=> (and (= inline$$GetFieldFromValue$2$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $DiemAccount_AccountOperationsCapability_limits_cap)) (= (ControlFlow 0 419628) 419636)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Else$1_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 419634) 419628)) inline$$GetFieldFromValue$2$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (and (= $abort_flag@12 true) (= $abort_code@15 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 419574) 419730) inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 419574) 419634) inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 419572) 419574)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)))) (and (= $abort_flag@12 $abort_flag@11) (= $abort_code@15 $abort_code@14))) (and (=> (= (ControlFlow 0 419520) 419730) inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 419520) 419634) inline$$DiemAccount_withdraw_from_balance_$def$0$anon79_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 419502) 419572) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 419502) 419520) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 419496) (- 0 781063)) true) (=> (= (ControlFlow 0 419496) 419502) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 419580) 419496)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 419375) 419750) inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 419375) 419580) inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 419385) 419750) inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 419385) 419580) inline$$DiemAccount_withdraw_from_balance_$def$0$anon78_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@11) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 419369) 419385) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 419369) 419375) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon76_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 419399) 419369)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon75_Then_correct  (=> (and (|b#$Boolean| call6formal@$ret0@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))))))))) $abort_flag@11)) (=> (and (and (=> $abort_flag@11 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))))))) (=> $abort_flag@11 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))))))))) (= $abort_code@14 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@11) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@6 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr)))))) ((_ is $Address) call3formal@$ret0@0@@6))) (and (=> (= (ControlFlow 0 419264) 419754) inline$$DiemAccount_withdraw_from_balance_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 419264) 419399) inline$$DiemAccount_withdraw_from_balance_$def$0$anon76_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon75_Else_correct  (=> (not (|b#$Boolean| call6formal@$ret0@0)) (=> (and (and (= $abort_code@18 $abort_code@13) (= $abort_flag@15 $abort_flag@10)) (and (= $AccountLimits_Window_$memory@1 $AccountLimits_Window_$memory) (= (ControlFlow 0 418111) 418229))) inline$$BorrowField$1$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon73_Else_correct  (=> (not $abort_flag@10) (and (=> (= (ControlFlow 0 418103) 419264) inline$$DiemAccount_withdraw_from_balance_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 418103) 418111) inline$$DiemAccount_withdraw_from_balance_$def$0$anon75_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon71_Else_correct  (=> (and (not $abort_flag@9) (= inline$$DiemAccount_withdraw_from_balance_$def$0$$t15@1 ($Boolean true))) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10) (=> $abort_flag@10 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@10) (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret0@0 (ite (|b#$Boolean| inline$$DiemAccount_withdraw_from_balance_$def$0$$t15@1) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) call3formal@$ret0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) call3formal@$ret0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| call3formal@$ret0@0@@7))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) call3formal@$ret0@0@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| call3formal@$ret0@0@@7)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))))))))) ((_ is $Boolean) call6formal@$ret0@0))) (and (=> (= (ControlFlow 0 418097) 419774) inline$$DiemAccount_withdraw_from_balance_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 418097) 418103) inline$$DiemAccount_withdraw_from_balance_$def$0$anon73_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon69_Else_correct  (=> (and (and (not $abort_flag@8) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $AccountFreezing_FreezingBit_is_frozen)))))) (=> $abort_flag@9 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@12 (|i#$Integer| ($Integer 1))))))) (and (=> (= (ControlFlow 0 418087) 419794) inline$$DiemAccount_withdraw_from_balance_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 418087) 418097) inline$$DiemAccount_withdraw_from_balance_$def$0$anon71_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon8$5_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@8) (=> (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@8 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@11 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 418081) 419814) inline$$DiemAccount_withdraw_from_balance_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 418081) 418087) inline$$DiemAccount_withdraw_from_balance_$def$0$anon69_Else_correct))))))
(let ((inline$$BorrowLoc$0$anon0_correct  (=> (and (= inline$$BorrowLoc$0$dst@1 ($Mutation ($Local 12) $EmptyPath inline$$ReadRef$1$v@1)) (= (ControlFlow 0 418073) 418081)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon8$5_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon8_correct  (=> (and (= inline$$DiemAccount_withdraw_from_balance_$def$0$$AccountLimits_Window_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr))) true)) (= (ControlFlow 0 417921) 418073)) inline$$BorrowLoc$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 417855) 417921)) inline$$DiemAccount_withdraw_from_balance_$def$0$anon8_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Then_correct  (=> (= (ControlFlow 0 419838) 417921) inline$$DiemAccount_withdraw_from_balance_$def$0$anon8_correct)))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 417847) 419838) inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 417847) 417855) inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 419846) 419838) inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 419846) 417855) inline$$DiemAccount_withdraw_from_balance_$def$0$anon68_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 417839) 419846) inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 417839) 417847) inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Then_correct  (and (=> (= (ControlFlow 0 419854) 419846) inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 419854) 417847) inline$$DiemAccount_withdraw_from_balance_$def$0$anon67_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon65_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 417831) 419854) inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 417831) 417839) inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon65_Then_correct  (and (=> (= (ControlFlow 0 419862) 419854) inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 419862) 417839) inline$$DiemAccount_withdraw_from_balance_$def$0$anon66_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance_$def$0$anon0_correct  (=> (not $abort_flag@7) (and (=> (= (ControlFlow 0 417825) 419862) inline$$DiemAccount_withdraw_from_balance_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 417825) 417831) inline$$DiemAccount_withdraw_from_balance_$def$0$anon65_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_balance$0$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$0$dst@1) ((_ is $Address) call3formal@$ret0@0@@7)) (=> (and (and (and (and ((_ is $Vector) inline$$ReadRef$1$v@1) (let ((va@@44 (|v#$Vector| inline$$ReadRef$1$v@1)))
(let ((l@@44 (|l#$ValueArray| va@@44)))
 (and (and (<= 0 l@@44) (<= l@@44 $MAX_U64)) (forall ((x@@44 Int) ) (!  (=> (or (< x@@44 0) (>= x@@44 l@@44)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@44) x@@44))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin)) (let ((va@@45 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin))))
(let ((l@@45 (|l#$ValueArray| va@@45)))
 (and (and (<= 0 l@@45) (<= l@@45 $MAX_U64)) (forall ((x@@45 Int) ) (!  (=> (or (< x@@45 0) (>= x@@45 l@@45)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@45) x@@45))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$1$v@1)) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= (ControlFlow 0 419870) 417825))) inline$$DiemAccount_withdraw_from_balance_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_balance$0$Entry_correct  (=> (= inline$$DiemAccount_withdraw_from_balance$0$$AccountLimits_Window_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 416765) (- 0 780336)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_balance$0$$AccountLimits_Window_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr))))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_balance$0$$AccountLimits_Window_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) $VASP_ChildVASP_parent_vasp_addr)))) (=> (= (ControlFlow 0 416765) 419870) inline$$DiemAccount_withdraw_from_balance$0$anon0_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon50$4_correct  (and (=> (= (ControlFlow 0 419880) (- 0 780313)) true) (=> (= (ControlFlow 0 419880) 416765) inline$$DiemAccount_withdraw_from_balance$0$Entry_correct))))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 416594) 419880)) inline$$DiemAccount_withdraw_from_$def$0$anon50$4_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon50$3_correct  (and (=> (= (ControlFlow 0 416600) (- 0 780100)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@3)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_withdraw_from_$def$0$addr@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@3)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@4)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@4)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@4)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_withdraw_from_$def$0$addr@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@4)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (and (=> (= (ControlFlow 0 416600) (- 0 780146)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@5)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@5)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@5)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_withdraw_from_$def$0$addr@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@5)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@6)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_withdraw_from_$def$0$addr@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@6)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (and (=> (= (ControlFlow 0 416600) (- 0 780192)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@7 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@7)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@8 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@8))))))))))) (and (=> (= (ControlFlow 0 416600) (- 0 780225)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@9 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@9)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@10 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@10))))))))))) (and (=> (= (ControlFlow 0 416600) (- 0 780261)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@11 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@11)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@11)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_withdraw_from_$def$0$addr@@12 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_withdraw_from_$def$0$addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@12)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_withdraw_from_$def$0$addr@@12))))))))))) (=> (= (ControlFlow 0 416600) 416594) inline$$ReadRef$1$anon0_correct)))))))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 416295) 416600)) inline$$DiemAccount_withdraw_from_$def$0$anon50$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 416349) 416600))) inline$$DiemAccount_withdraw_from_$def$0$anon50$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 416285) 416349) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 416285) 416295) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (= (ControlFlow 0 416161) 416285)) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 416082) 416161)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 416138) 416161))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 416046) 416138) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 416046) 416082) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 415909) 416046)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon81_Then_correct  (=> (and (= inline$$DiemAccount_withdraw_from_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 420329) 416046)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1) (|p#$Mutation| inline$$BorrowField$0$dst@1) inline$$ReadRef$0$v@1)) (and (=> (= (ControlFlow 0 415895) 420329) inline$$DiemAccount_withdraw_from_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 415895) 415909) inline$$DiemAccount_withdraw_from_$def$0$anon81_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon79_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 415901) 415895)) inline$$WriteRef$0$anon0_correct)))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $DiemAccount_SentPaymentEvent_type_value) (and (=> (= (ControlFlow 0 415826) 420333) inline$$DiemAccount_withdraw_from_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 415826) 415901) inline$$DiemAccount_withdraw_from_$def$0$anon79_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon77_Else$2_correct  (and (=> (= (ControlFlow 0 415836) (- 0 779792)) true) (=> (= (ControlFlow 0 415836) 415826) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$0$anon0_correct  (=> (and (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (= (ControlFlow 0 415778) 415836)) inline$$DiemAccount_withdraw_from_$def$0$anon77_Else$2_correct)))
(let ((inline$$DiemAccount_SentPaymentEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 415734) 415778)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemAccount_SentPaymentEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 415740) 415778) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemAccount_SentPaymentEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 415728) 415740) inline$$DiemAccount_SentPaymentEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 415728) 415734) inline$$DiemAccount_SentPaymentEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemAccount_SentPaymentEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 415720) 415778)) inline$$ReadRef$0$anon0_correct)))
(let ((inline$$DiemAccount_SentPaymentEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@8) (let ((va@@46 (|v#$Vector| call3formal@$ret0@0@@8)))
(let ((l@@46 (|l#$ValueArray| va@@46)))
 (and (and (<= 0 l@@46) (<= l@@46 $MAX_U64)) (forall ((x@@46 Int) ) (!  (=> (or (< x@@46 0) (>= x@@46 l@@46)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@46) x@@46))
)))))) (forall ((inline$$DiemAccount_SentPaymentEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_SentPaymentEvent_pack$0$$$0 0) (< inline$$DiemAccount_SentPaymentEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0))
))) ((_ is $Address) call3formal@$ret0@0@@7)) (and (and (and ((_ is $Vector) inline$$DiemAccount_preburn_$def_verify$0$$t7@1) (let ((va@@47 (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)))
(let ((l@@47 (|l#$ValueArray| va@@47)))
 (and (and (<= 0 l@@47) (<= l@@47 $MAX_U64)) (forall ((x@@47 Int) ) (!  (=> (or (< x@@47 0) (>= x@@47 l@@47)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@47) x@@47))
)))))) (forall ((inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0 0) (< inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_SentPaymentEvent_pack$0$$$0@@0))
))) (= inline$$DiemAccount_SentPaymentEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 amount) 1 call3formal@$ret0@0@@8) 2 call3formal@$ret0@0@@7) 3 inline$$DiemAccount_preburn_$def_verify$0$$t7@1) 4))))) (and (=> (= (ControlFlow 0 415712) 415728) inline$$DiemAccount_SentPaymentEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 415712) 415720) inline$$DiemAccount_SentPaymentEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon77_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 415746) 415712)) inline$$DiemAccount_SentPaymentEvent_pack$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon75_Else$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@7) (=> $abort_flag@7 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@7 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@10 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@7) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@8) (let ((va@@48 (|v#$Vector| call3formal@$ret0@0@@8)))
(let ((l@@48 (|l#$ValueArray| va@@48)))
 (and (and (<= 0 l@@48) (<= l@@48 $MAX_U64)) (forall ((x@@48 Int) ) (!  (=> (or (< x@@48 0) (>= x@@48 l@@48)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@48) x@@48))
)))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@8)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@8)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@8)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@8)) $$0@@8))
)))) (and (=> (= (ControlFlow 0 415360) 420353) inline$$DiemAccount_withdraw_from_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 415360) 415746) inline$$DiemAccount_withdraw_from_$def$0$anon77_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemAccount_DiemAccount_sent_events) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemAccount_DiemAccount_sent_events))) (= (ControlFlow 0 415352) 415360))) inline$$DiemAccount_withdraw_from_$def$0$anon75_Else$2_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 415230) 415352)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 415224) 415230)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 415234) 415224)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@9 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@6 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 415191) 420373) inline$$DiemAccount_withdraw_from_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 415191) 415234) inline$$DiemAccount_withdraw_from_$def$0$anon75_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 415189) 415191)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@9 $abort_code@8)) (and (= $abort_flag@6 $abort_flag@5) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 415137) 420373) inline$$DiemAccount_withdraw_from_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 415137) 415234) inline$$DiemAccount_withdraw_from_$def$0$anon75_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$GetFieldFromValue$0$dst@1)) (and (=> (= (ControlFlow 0 415107) 415189) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 415107) 415137) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 415101) (- 0 779297)) true) (=> (= (ControlFlow 0 415101) 415107) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon73_Else_correct  (=> (not $abort_flag@5) (and (=> (= (ControlFlow 0 415197) (- 0 779281)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)) (=> (= (ControlFlow 0 415197) 415101) inline$$BorrowGlobal$1$Entry_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@5 true) (=> (and (= $abort_code@8 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 414978) 420393) inline$$DiemAccount_withdraw_from_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 414978) 415197) inline$$DiemAccount_withdraw_from_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 414976) 414978)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0 inline$$BorrowGlobal$0$a@1))) (= $abort_flag@5 $abort_flag@4@@0)) (and (= $abort_code@8 $abort_code@5@@0) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 414924) 420393) inline$$DiemAccount_withdraw_from_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 414924) 415197) inline$$DiemAccount_withdraw_from_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$GetFieldFromValue$0$dst@1)) (and (=> (= (ControlFlow 0 414894) 414976) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 414894) 414924) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (=> (= inline$$BorrowGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1)) (and (=> (= (ControlFlow 0 414888) (- 0 779184)) true) (=> (= (ControlFlow 0 414888) 414894) inline$$BorrowGlobal$0$anon0_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon71_Then_correct  (=> (|b#$Boolean| inline$$DiemAccount_withdraw_from_$def$0$$t18@1) (and (=> (= (ControlFlow 0 414984) (- 0 779116)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_Balance_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| inline$$GetFieldFromValue$0$dst@1))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_Balance_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| inline$$GetFieldFromValue$0$dst@1)) (=> (= (ControlFlow 0 414984) 414888) inline$$BorrowGlobal$0$Entry_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon32_correct  (=> (and (and (= $abort_code@25 $abort_code@7) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 414741) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 414739) 414741)) inline$$DiemAccount_withdraw_from_$def$0$anon32_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon72_Then_correct  (=> (= (ControlFlow 0 414749) 414741) inline$$DiemAccount_withdraw_from_$def$0$anon32_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon71_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_withdraw_from_$def$0$$t18@1)) (= $abort_code@7 (|i#$Integer| call3formal@$ret0@0@@9))) (and (=> (= (ControlFlow 0 414733) 414749) inline$$DiemAccount_withdraw_from_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 414733) 414739) inline$$DiemAccount_withdraw_from_$def$0$anon72_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon69_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 414721) 414984) inline$$DiemAccount_withdraw_from_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 414721) 414733) inline$$DiemAccount_withdraw_from_$def$0$anon71_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon67_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1) (= inline$$DiemAccount_withdraw_from_$def$0$$t18@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| inline$$GetFieldFromValue$0$dst@1))))) (=> (and (and (and (= inline$$DiemAccount_withdraw_from_$def$0$$t19@1 ($Integer 19)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@0)) (and (=> $abort_flag@4@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@9 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@9) (>= (|i#$Integer| call3formal@$ret0@0@@9) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@9) $MAX_U64))) (and (=> (= (ControlFlow 0 414715) 420413) inline$$DiemAccount_withdraw_from_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 414715) 414721) inline$$DiemAccount_withdraw_from_$def$0$anon69_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon24_correct  (=> (and (and (= $abort_code@25 $abort_code@6@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 414671) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 414669) 414671)) inline$$DiemAccount_withdraw_from_$def$0$anon24_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon68_Then_correct  (=> (= (ControlFlow 0 414685) 414671) inline$$DiemAccount_withdraw_from_$def$0$anon24_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1)) (= $abort_code@6@@0 (|i#$Integer| call3formal@$ret0@0@@10))) (and (=> (= (ControlFlow 0 414663) 414685) inline$$DiemAccount_withdraw_from_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 414663) 414669) inline$$DiemAccount_withdraw_from_$def$0$anon68_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon65_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 414651) 414715) inline$$DiemAccount_withdraw_from_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 414651) 414663) inline$$DiemAccount_withdraw_from_$def$0$anon67_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon64_Else_correct  (=> (not $abort_flag@2@@0) (=> (and (and (and (= inline$$DiemAccount_withdraw_from_$def$0$$t16@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@10 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@10) (>= (|i#$Integer| call3formal@$ret0@0@@10) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@10) $MAX_U64))) (and (=> (= (ControlFlow 0 414645) 420433) inline$$DiemAccount_withdraw_from_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 414645) 414651) inline$$DiemAccount_withdraw_from_$def$0$anon65_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon64_Then_correct  (=> $abort_flag@2@@0 (=> (and (and (= $abort_code@25 $abort_code@3@@0) (= $DiemAccount_DiemAccount_$memory@0@@0 $DiemAccount_DiemAccount_$memory)) (and (= $AccountLimits_Window_$memory@4 $AccountLimits_Window_$memory) (= (ControlFlow 0 420453) 414677))) inline$$DiemAccount_withdraw_from_$def$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 414601) 420453) inline$$DiemAccount_withdraw_from_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 414601) 414645) inline$$DiemAccount_withdraw_from_$def$0$anon64_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct  (and (=> (= (ControlFlow 0 414611) 420453) inline$$DiemAccount_withdraw_from_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 414611) 414645) inline$$DiemAccount_withdraw_from_$def$0$anon64_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$GetFieldFromValue$0$dst@1)))) (and (=> (= (ControlFlow 0 414595) 414611) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 414595) 414601) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct  (=> (and (not true) (= (ControlFlow 0 414549) 414595)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct  (=> (= (ControlFlow 0 414619) 414595) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct  (=> (not $abort_flag@2@@0) (and (=> (= (ControlFlow 0 414543) 414619) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 414543) 414549) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct)))))
(let ((inline$$DiemAccount_exists_at$0$anon0_correct  (=> (and ((_ is $Address) inline$$GetFieldFromValue$0$dst@1) (= (ControlFlow 0 414625) 414543)) inline$$DiemAccount_exists_at_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 414391) 414625)) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 420461) 414625) inline$$DiemAccount_exists_at$0$anon0_correct)))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)) (and (=> (= (ControlFlow 0 414343) 420461) inline$$DiemAccount_withdraw_from_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 414343) 414391) inline$$DiemAccount_withdraw_from_$def$0$anon63_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon61_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 414349) 414343)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon8$4_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@2@@0) (=> (and (=> $abort_flag@2@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 414297) 420465) inline$$DiemAccount_withdraw_from_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 414297) 414349) inline$$DiemAccount_withdraw_from_$def$0$anon61_Else_correct))))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon8_correct  (=> (= inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_DiemAccount_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)) true)) (=> (and (= inline$$DiemAccount_withdraw_from_$def$0$$DiemAccount_Balance_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)) true)) (= (ControlFlow 0 414193) 414297)) inline$$DiemAccount_withdraw_from_$def$0$anon8$4_correct))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon60_Else_correct  (=> (and (not true) (= (ControlFlow 0 414111) 414193)) inline$$DiemAccount_withdraw_from_$def$0$anon8_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon60_Then_correct  (=> (= (ControlFlow 0 420489) 414193) inline$$DiemAccount_withdraw_from_$def$0$anon8_correct)))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 414103) 420489) inline$$DiemAccount_withdraw_from_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 414103) 414111) inline$$DiemAccount_withdraw_from_$def$0$anon60_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 420497) 420489) inline$$DiemAccount_withdraw_from_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 420497) 414111) inline$$DiemAccount_withdraw_from_$def$0$anon60_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon58_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 414095) 420497) inline$$DiemAccount_withdraw_from_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 414095) 414103) inline$$DiemAccount_withdraw_from_$def$0$anon59_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon58_Then_correct  (and (=> (= (ControlFlow 0 420505) 420497) inline$$DiemAccount_withdraw_from_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 420505) 414103) inline$$DiemAccount_withdraw_from_$def$0$anon59_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon57_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 414087) 420505) inline$$DiemAccount_withdraw_from_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 414087) 414095) inline$$DiemAccount_withdraw_from_$def$0$anon58_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon57_Then_correct  (and (=> (= (ControlFlow 0 420513) 420505) inline$$DiemAccount_withdraw_from_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 420513) 414095) inline$$DiemAccount_withdraw_from_$def$0$anon58_Else_correct))))
(let ((inline$$DiemAccount_withdraw_from_$def$0$anon0_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 414081) 420513) inline$$DiemAccount_withdraw_from_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 414081) 414087) inline$$DiemAccount_withdraw_from_$def$0$anon57_Else_correct)))))
(let ((inline$$DiemAccount_withdraw_from_$direct_intra$0$anon0_correct  (=> (and (and (and (and (and (and (and ((_ is $Vector) cap) (let ((va@@49 (|v#$Vector| cap)))
(let ((l@@49 (|l#$ValueArray| va@@49)))
 (and (and (<= 0 l@@49) (<= l@@49 $MAX_U64)) (forall ((x@@49 Int) ) (!  (=> (or (< x@@49 0) (>= x@@49 l@@49)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@49) x@@49))
)))))) (= (|l#$ValueArray| (|v#$Vector| cap)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))) true) ((_ is $Address) call3formal@$ret0@0@@7)) (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64))) (and (and (and ((_ is $Vector) inline$$DiemAccount_preburn_$def_verify$0$$t7@1) (let ((va@@50 (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)))
(let ((l@@50 (|l#$ValueArray| va@@50)))
 (and (and (<= 0 l@@50) (<= l@@50 $MAX_U64)) (forall ((x@@50 Int) ) (!  (=> (or (< x@@50 0) (>= x@@50 l@@50)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@50) x@@50))
)))))) (forall ((inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0 0) (< inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0 (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_preburn_$def_verify$0$$t7@1)) inline$$DiemAccount_withdraw_from_$direct_intra$0$$$0))
))) (= (ControlFlow 0 420519) 414081))) inline$$DiemAccount_withdraw_from_$def$0$anon0_correct)))
(let ((inline$$DiemAccount_withdraw_from_$direct_intra$0$Entry_correct  (=> (= inline$$DiemAccount_withdraw_from_$direct_intra$0$$DiemAccount_Balance_$CallerDomain@0 ($ConstMemoryDomain true)) (and (=> (= (ControlFlow 0 412581) (- 0 778384)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_preburn_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_preburn_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))) (and (=> (= (ControlFlow 0 412581) (- 0 778395)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$direct_intra$0$$DiemAccount_Balance_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_withdraw_from_$direct_intra$0$$DiemAccount_Balance_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@13) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))) (=> (= (ControlFlow 0 412581) 420519) inline$$DiemAccount_withdraw_from_$direct_intra$0$anon0_correct))))))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon24_Else_correct  (=> (not $abort_flag@1@@0) (=> (and (= inline$$DiemAccount_preburn_$def_verify$0$$t7@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (= (ControlFlow 0 420527) 412581)) inline$$DiemAccount_withdraw_from_$direct_intra$0$Entry_correct))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon22_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0) (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@7 dd)))) ((_ is $Address) call3formal@$ret0@0@@7))) (and (=> (= (ControlFlow 0 412320) 428498) inline$$DiemAccount_preburn_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 412320) 420527) inline$$DiemAccount_preburn_$def_verify$0$anon24_Else_correct))))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@0) (=> (and (=> $abort_flag@0@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 412314) 428518) inline$$DiemAccount_preburn_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 412314) 412320) inline$$DiemAccount_preburn_$def_verify$0$anon22_Else_correct))))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon6_correct  (=> (and (= inline$$DiemAccount_preburn_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address)) true)) (= (ControlFlow 0 412244) 412314)) inline$$DiemAccount_preburn_$def_verify$0$anon6$3_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 412192) 412244)) inline$$DiemAccount_preburn_$def_verify$0$anon6_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 428542) 412244) inline$$DiemAccount_preburn_$def_verify$0$anon6_correct)))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon20_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 412184) 428542) inline$$DiemAccount_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 412184) 412192) inline$$DiemAccount_preburn_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon20_Then_correct  (and (=> (= (ControlFlow 0 428550) 428542) inline$$DiemAccount_preburn_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 428550) 412192) inline$$DiemAccount_preburn_$def_verify$0$anon21_Else_correct))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon19_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 412176) 428550) inline$$DiemAccount_preburn_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 412176) 412184) inline$$DiemAccount_preburn_$def_verify$0$anon20_Else_correct)))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon19_Then_correct  (and (=> (= (ControlFlow 0 428558) 428550) inline$$DiemAccount_preburn_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 428558) 412184) inline$$DiemAccount_preburn_$def_verify$0$anon20_Else_correct))))
(let ((inline$$DiemAccount_preburn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 412170) 428558) inline$$DiemAccount_preburn_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 412170) 412176) inline$$DiemAccount_preburn_$def_verify$0$anon19_Else_correct)))))
(let ((anon0$1_correct@@0  (=> (and (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@51 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@51 (|l#$ValueArray| va@@51)))
 (and (and (<= 0 l@@51) (<= l@@51 $MAX_U64)) (forall ((x@@51 Int) ) (!  (=> (or (< x@@51 0) (>= x@@51 l@@51)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@51) x@@51))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@52 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@52 (|l#$ValueArray| va@@52)))
 (and (and (<= 0 l@@52) (<= l@@52 $MAX_U64)) (forall ((x@@52 Int) ) (!  (=> (or (< x@@52 0) (>= x@@52 l@@52)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@52) x@@52))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))) $Roles_RoleId_role_id)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray $inv_addr@@7))
))) (=> (and (and (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@53 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@53 (|l#$ValueArray| va@@53)))
 (and (and (<= 0 l@@53) (<= l@@53 $MAX_U64)) (forall ((x@@53 Int) ) (!  (=> (or (< x@@53 0) (>= x@@53 l@@53)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@53) x@@53))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@8))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@8))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (forall (($inv_addr@@9 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9)) (let ((va@@54 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))))
(let ((l@@54 (|l#$ValueArray| va@@54)))
 (and (and (<= 0 l@@54) (<= l@@54 $MAX_U64)) (forall ((x@@54 Int) ) (!  (=> (or (< x@@54 0) (>= x@@54 l@@54)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@54) x@@54))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@9))
))) (and (forall (($inv_addr@@10 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10)) (let ((va@@55 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))))
(let ((l@@55 (|l#$ValueArray| va@@55)))
 (and (and (<= 0 l@@55) (<= l@@55 $MAX_U64)) (forall ((x@@55 Int) ) (!  (=> (or (< x@@55 0) (>= x@@55 l@@55)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@55) x@@55))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@10))
)) (forall (($inv_addr@@11 Int) ($inv_tv0@@1 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11)) (let ((va@@56 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))))
(let ((l@@56 (|l#$ValueArray| va@@56)))
 (and (and (<= 0 l@@56) (<= l@@56 $MAX_U64)) (forall ((x@@56 Int) ) (!  (=> (or (< x@@56 0) (>= x@@56 l@@56)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@56) x@@56))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@1) 1) $inv_addr@@11))
)))) (=> (and (and (and (and (forall (($inv_addr@@12 Int) ($inv_tv0@@2 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12)) (let ((va@@57 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))))
(let ((l@@57 (|l#$ValueArray| va@@57)))
 (and (and (<= 0 l@@57) (<= l@@57 $MAX_U64)) (forall ((x@@57 Int) ) (!  (=> (or (< x@@57 0) (>= x@@57 l@@57)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@57) x@@57))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@58 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@58 (|l#$ValueArray| va@@58)))
 (and (and (<= 0 l@@58) (<= l@@58 $MAX_U64)) (forall ((x@@58 Int) ) (!  (=> (or (< x@@58 0) (>= x@@58 l@@58)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@58) x@@58))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code)) (let ((va@@59 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@59 (|l#$ValueArray| va@@59)))
 (and (and (<= 0 l@@59) (<= l@@59 $MAX_U64)) (forall ((x@@59 Int) ) (!  (=> (or (< x@@59 0) (>= x@@59 l@@59)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@59) x@@59))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_currency_code))) $$0@@9))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events)) (let ((va@@60 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@60 (|l#$ValueArray| va@@60)))
 (and (and (<= 0 l@@60) (<= l@@60 $MAX_U64)) (forall ((x@@60 Int) ) (!  (=> (or (< x@@60 0) (>= x@@60 l@@60)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@60) x@@60))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@61 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@61 (|l#$ValueArray| va@@61)))
 (and (and (<= 0 l@@61) (<= l@@61 $MAX_U64)) (forall ((x@@61 Int) ) (!  (=> (or (< x@@61 0) (>= x@@61 l@@61)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@61) x@@61))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@10))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events)) (let ((va@@62 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@62 (|l#$ValueArray| va@@62)))
 (and (and (<= 0 l@@62) (<= l@@62 $MAX_U64)) (forall ((x@@62 Int) ) (!  (=> (or (< x@@62 0) (>= x@@62 l@@62)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@62) x@@62))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@63 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@63 (|l#$ValueArray| va@@63)))
 (and (and (<= 0 l@@63) (<= l@@63 $MAX_U64)) (forall ((x@@63 Int) ) (!  (=> (or (< x@@63 0) (>= x@@63 l@@63)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@63) x@@63))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@11))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@64 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@64 (|l#$ValueArray| va@@64)))
 (and (and (<= 0 l@@64) (<= l@@64 $MAX_U64)) (forall ((x@@64 Int) ) (!  (=> (or (< x@@64 0) (>= x@@64 l@@64)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@64) x@@64))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@65 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@65 (|l#$ValueArray| va@@65)))
 (and (and (<= 0 l@@65) (<= l@@65 $MAX_U64)) (forall ((x@@65 Int) ) (!  (=> (or (< x@@65 0) (>= x@@65 l@@65)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@65) x@@65))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@12))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@66 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@66 (|l#$ValueArray| va@@66)))
 (and (and (<= 0 l@@66) (<= l@@66 $MAX_U64)) (forall ((x@@66 Int) ) (!  (=> (or (< x@@66 0) (>= x@@66 l@@66)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@66) x@@66))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@67 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@67 (|l#$ValueArray| va@@67)))
 (and (and (<= 0 l@@67) (<= l@@67 $MAX_U64)) (forall ((x@@67 Int) ) (!  (=> (or (< x@@67 0) (>= x@@67 l@@67)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@67) x@@67))
))))))) (forall (($$0@@13 Int) ) (!  (=> (and (>= $$0@@13 0) (< $$0@@13 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@13)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@13)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@13)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@13))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@68 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@68 (|l#$ValueArray| va@@68)))
 (and (and (<= 0 l@@68) (<= l@@68 $MAX_U64)) (forall ((x@@68 Int) ) (!  (=> (or (< x@@68 0) (>= x@@68 l@@68)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@68) x@@68))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@69 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@69 (|l#$ValueArray| va@@69)))
 (and (and (<= 0 l@@69) (<= l@@69 $MAX_U64)) (forall ((x@@69 Int) ) (!  (=> (or (< x@@69 0) (>= x@@69 l@@69)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@69) x@@69))
))))))) (forall (($$0@@14 Int) ) (!  (=> (and (>= $$0@@14 0) (< $$0@@14 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@14)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@14)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@14)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@14))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@2) 1) $inv_addr@@12))
)) (forall (($inv_addr@@13 Int) ($inv_tv0@@3 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13)) (let ((va@@70 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))))
(let ((l@@70 (|l#$ValueArray| va@@70)))
 (and (and (<= 0 l@@70) (<= l@@70 $MAX_U64)) (forall ((x@@70 Int) ) (!  (=> (or (< x@@70 0) (>= x@@70 l@@70)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@70) x@@70))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn)) (let ((va@@71 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))))
(let ((l@@71 (|l#$ValueArray| va@@71)))
 (and (and (<= 0 l@@71) (<= l@@71 $MAX_U64)) (forall ((x@@71 Int) ) (!  (=> (or (< x@@71 0) (>= x@@71 l@@71)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@71) x@@71))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@3) 1) $inv_addr@@13))
))) (and (forall (($inv_addr@@14 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@14)) (let ((va@@72 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))))
(let ((l@@72 (|l#$ValueArray| va@@72)))
 (and (and (<= 0 l@@72) (<= l@@72 $MAX_U64)) (forall ((x@@72 Int) ) (!  (=> (or (< x@@72 0) (>= x@@72 l@@72)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@72) x@@72))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@14))
)) (forall (($inv_addr@@15 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15)) (let ((va@@73 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))))
(let ((l@@73 (|l#$ValueArray| va@@73)))
 (and (and (<= 0 l@@73) (<= l@@73 $MAX_U64)) (forall ((x@@73 Int) ) (!  (=> (or (< x@@73 0) (>= x@@73 l@@73)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@73) x@@73))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@15))
)))) (and (and (forall (($inv_addr@@16 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16)) (let ((va@@74 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))))
(let ((l@@74 (|l#$ValueArray| va@@74)))
 (and (and (<= 0 l@@74) (<= l@@74 $MAX_U64)) (forall ((x@@74 Int) ) (!  (=> (or (< x@@74 0) (>= x@@74 l@@74)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@74) x@@74))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@75 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@75 (|l#$ValueArray| va@@75)))
 (and (and (<= 0 l@@75) (<= l@@75 $MAX_U64)) (forall ((x@@75 Int) ) (!  (=> (or (< x@@75 0) (>= x@@75 l@@75)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@75) x@@75))
))))))) (forall (($$0@@15 Int) ) (!  (=> (and (>= $$0@@15 0) (< $$0@@15 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))) $$0@@15)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))) $$0@@15)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))) $$0@@15)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_authentication_key))) $$0@@15))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@76 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@76 (|l#$ValueArray| va@@76)))
 (and (and (<= 0 l@@76) (<= l@@76 $MAX_U64)) (forall ((x@@76 Int) ) (!  (=> (or (< x@@76 0) (>= x@@76 l@@76)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@76) x@@76))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@77 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@77 (|l#$ValueArray| va@@77)))
 (and (and (<= 0 l@@77) (<= l@@77 $MAX_U64)) (forall ((x@@77 Int) ) (!  (=> (or (< x@@77 0) (>= x@@77 l@@77)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@77) x@@77))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@78 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@78 (|l#$ValueArray| va@@78)))
 (and (and (<= 0 l@@78) (<= l@@78 $MAX_U64)) (forall ((x@@78 Int) ) (!  (=> (or (< x@@78 0) (>= x@@78 l@@78)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@78) x@@78))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@79 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@79 (|l#$ValueArray| va@@79)))
 (and (and (<= 0 l@@79) (<= l@@79 $MAX_U64)) (forall ((x@@79 Int) ) (!  (=> (or (< x@@79 0) (>= x@@79 l@@79)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@79) x@@79))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events)) (let ((va@@80 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@80 (|l#$ValueArray| va@@80)))
 (and (and (<= 0 l@@80) (<= l@@80 $MAX_U64)) (forall ((x@@80 Int) ) (!  (=> (or (< x@@80 0) (>= x@@80 l@@80)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@80) x@@80))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@81 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@81 (|l#$ValueArray| va@@81)))
 (and (and (<= 0 l@@81) (<= l@@81 $MAX_U64)) (forall ((x@@81 Int) ) (!  (=> (or (< x@@81 0) (>= x@@81 l@@81)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@81) x@@81))
))))))) (forall (($$0@@16 Int) ) (!  (=> (and (>= $$0@@16 0) (< $$0@@16 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@16)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@16)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@16)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@16))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@82 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@82 (|l#$ValueArray| va@@82)))
 (and (and (<= 0 l@@82) (<= l@@82 $MAX_U64)) (forall ((x@@82 Int) ) (!  (=> (or (< x@@82 0) (>= x@@82 l@@82)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@82) x@@82))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@83 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@83 (|l#$ValueArray| va@@83)))
 (and (and (<= 0 l@@83) (<= l@@83 $MAX_U64)) (forall ((x@@83 Int) ) (!  (=> (or (< x@@83 0) (>= x@@83 l@@83)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@83) x@@83))
))))))) (forall (($$0@@17 Int) ) (!  (=> (and (>= $$0@@17 0) (< $$0@@17 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@17)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@17)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@17)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@17))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@16))
)) (forall (($inv_addr@@17 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17)) (let ((va@@84 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))))
(let ((l@@84 (|l#$ValueArray| va@@84)))
 (and (and (<= 0 l@@84) (<= l@@84 $MAX_U64)) (forall ((x@@84 Int) ) (!  (=> (or (< x@@84 0) (>= x@@84 l@@84)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@84) x@@84))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@85 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@85 (|l#$ValueArray| va@@85)))
 (and (and (<= 0 l@@85) (<= l@@85 $MAX_U64)) (forall ((x@@85 Int) ) (!  (=> (or (< x@@85 0) (>= x@@85 l@@85)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@85) x@@85))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@86 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@86 (|l#$ValueArray| va@@86)))
 (and (and (<= 0 l@@86) (<= l@@86 $MAX_U64)) (forall ((x@@86 Int) ) (!  (=> (or (< x@@86 0) (>= x@@86 l@@86)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@86) x@@86))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@87 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@87 (|l#$ValueArray| va@@87)))
 (and (and (<= 0 l@@87) (<= l@@87 $MAX_U64)) (forall ((x@@87 Int) ) (!  (=> (or (< x@@87 0) (>= x@@87 l@@87)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@87) x@@87))
))))))) (forall (($$0@@18 Int) ) (!  (=> (and (>= $$0@@18 0) (< $$0@@18 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@18)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@18)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@18)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@18))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@17))
))) (and (forall (($inv_addr@@18 Int) ($inv_tv0@@4 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18)) (let ((va@@88 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))))
(let ((l@@88 (|l#$ValueArray| va@@88)))
 (and (and (<= 0 l@@88) (<= l@@88 $MAX_U64)) (forall ((x@@88 Int) ) (!  (=> (or (< x@@88 0) (>= x@@88 l@@88)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@88) x@@88))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin)) (let ((va@@89 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin))))
(let ((l@@89 (|l#$ValueArray| va@@89)))
 (and (and (<= 0 l@@89) (<= l@@89 $MAX_U64)) (forall ((x@@89 Int) ) (!  (=> (or (< x@@89 0) (>= x@@89 l@@89)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@89) x@@89))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@4) 1) $inv_addr@@18))
)) (forall (($inv_addr@@19 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@19)) (let ((va@@90 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))))
(let ((l@@90 (|l#$ValueArray| va@@90)))
 (and (and (<= 0 l@@90) (<= l@@90 $MAX_U64)) (forall ((x@@90 Int) ) (!  (=> (or (< x@@90 0) (>= x@@90 l@@90)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@90) x@@90))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))) $DiemAccount_WithdrawCapability_account_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_WithdrawCapability_$memory) $EmptyTypeValueArray $inv_addr@@19))
))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((window_addr T@$Value) )  (=> ((_ is $Address) window_addr) (|b#$Boolean| ($Boolean (forall ((coin_type@@2 T@$Value) )  (=> ((_ is $Type) coin_type@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| window_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@2)) 1) (|a#$Address| window_addr)))) $AccountLimits_Window_limit_address)))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816)))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@3 T@$Value) )  (=> ((_ is $Type) coin_type@@3) (|b#$Boolean| ($Boolean (forall ((mint_cap_owner@@0 T@$Value) )  (=> ((_ is $Address) mint_cap_owner@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@3)) 1) (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| mint_cap_owner@@0)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@4 T@$Value) )  (=> ((_ is $Type) coin_type@@4) (|b#$Boolean| ($Boolean (forall ((addr3 T@$Value) )  (=> ((_ is $Address) addr3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| addr3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@4)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic)))))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@5 T@$Value) )  (=> ((_ is $Type) coin_type@@5) (|b#$Boolean| ($Boolean (forall ((addr1@@2 T@$Value) )  (=> ((_ is $Address) addr1@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@5)) 1) (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@2)))) $Roles_RoleId_role_id) ($Integer 1)))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@6 T@$Value) )  (=> ((_ is $Type) coin_type@@6) (|b#$Boolean| ($Boolean (forall ((addr1@@3 T@$Value) )  (=> ((_ is $Address) addr1@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@6)) 1) (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@3)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@14 T@$Value) )  (=> ((_ is $Address) addr@@14) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@14)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@14 ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@15 T@$Value) )  (=> ((_ is $Address) addr@@15) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr@@15)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@15 ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@16 T@$Value) )  (=> ((_ is $Address) addr@@16) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorOperatorConfig_ValidatorOperatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@16)))) $Roles_RoleId_role_id) ($Integer 4)))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@17 T@$Value) )  (=> ((_ is $Address) addr@@17) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@17)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@18 T@$Value) )  (=> ((_ is $Address) addr@@18) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@18)))) $Roles_RoleId_role_id) ($Integer 3))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@19 T@$Value) )  (=> ((_ is $Address) addr@@19) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $ValidatorConfig_Config_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $ValidatorConfig_ValidatorConfig_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $ValidatorConfig_ValidatorConfig_config))) $Option_Option_vec)) ($Integer 0)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@19)))) $Roles_RoleId_role_id) ($Integer 3)))))))))))))) (|b#$Boolean| ($Boolean (forall ((child_addr T@$Value) )  (=> ((_ is $Address) child_addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr1@@4 T@$Value) )  (=> ((_ is $Address) addr1@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@4)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@20 T@$Value) )  (=> ((_ is $Address) addr@@20) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@20 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@20)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@21 T@$Value) )  (=> ((_ is $Address) addr@@21) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@21 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@21)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@22 T@$Value) )  (=> ((_ is $Address) addr@@22) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@22))))))))))) (|b#$Boolean| ($Boolean (forall ((token@@0 T@$Value) )  (=> ((_ is $Type) token@@0) (|b#$Boolean| ($Boolean (forall ((addr@@23 T@$Value) )  (=> ((_ is $Address) addr@@23) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token@@0)) 1) (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@23)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((addr@@24 T@$Value) )  (=> ((_ is $Address) addr@@24) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DesignatedDealer_Dealer_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@24)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@25 T@$Value) )  (=> ((_ is $Address) addr@@25) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@25)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@26 T@$Value) )  (=> ((_ is $Address) addr@@26) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@26))))))))))) (= (ControlFlow 0 428562) 412170)))))) inline$$DiemAccount_preburn_$def_verify$0$anon0_correct))))))
(let ((anon0_correct@@0  (=> ((_ is $Address) dd) (=> (and (and (and (and (and ((_ is $Vector) cap) (let ((va@@91 (|v#$Vector| cap)))
(let ((l@@91 (|l#$ValueArray| va@@91)))
 (and (and (<= 0 l@@91) (<= l@@91 $MAX_U64)) (forall ((x@@91 Int) ) (!  (=> (or (< x@@91 0) (>= x@@91 l@@91)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@91) x@@91))
)))))) (= (|l#$ValueArray| (|v#$Vector| cap)) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))) true) (and (and (and ((_ is $Integer) amount) (>= (|i#$Integer| amount) 0)) (<= (|i#$Integer| amount) $MAX_U64)) (= (ControlFlow 0 409836) 428562))) anon0$1_correct@@0))))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (and (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_DiemAccount_$CallerDomain@@0 $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| cap)) $DiemAccount_WithdrawCapability_account_address))) (= (ControlFlow 0 767729) 409836)) anon0_correct@@0)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@14 () T@$TypeValue)
(declare-fun account@@0 () T@$Value)
(declare-fun $abort_flag@13@@0 () Bool)
(declare-fun preburn_address () T@$Value)
(declare-fun $abort_code@20@@0 () Int)
(declare-fun $Diem_Preburn_$memory@3 () T@$Memory)
(declare-fun $Diem_CurrencyInfo_$memory@3@@0 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@2@@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@2@@1 () T@$Memory)
(declare-fun $abort_code@19@@0 () Int)
(declare-fun $DiemAccount_Balance_$memory@1@@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@1@@1 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@2@@0 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@1@@0 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@0@@0 () T@$Memory)
(declare-fun $DiemAccount_DiemAccount_$memory@0@@1 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@18@@0 () Int)
(declare-fun $abort_flag@12@@0 () Bool)
(declare-fun $abort_flag@11@@0 () Bool)
(declare-fun $abort_code@17@@0 () Int)
(declare-fun inline$$DiemAccount_cancel_burn_$def_verify$0$$t5@1 () T@$Value)
(declare-fun inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1 () T@$Value)
(declare-fun call6formal@$AccountLimits_Window_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call7formal@$DiemAccount_DiemAccount_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call8formal@$DiemAccount_Balance_$CallerDomain@0 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$Diem_cancel_burn_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@2 () T@$Value)
(declare-fun $Diem_Preburn_$memory@1@@0 () T@$Memory)
(declare-fun $abort_flag@10@@0 () Bool)
(declare-fun $abort_code@15@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@1@@0 () T@$Memory)
(declare-fun inline$$Diem_cancel_burn_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_Preburn_$memory@2@@0 () T@$Memory)
(declare-fun $abort_code@16@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@2@@0 () T@$Memory)
(declare-fun $abort_code@1@@1 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@4@@1 () Int)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun call4formal@$ret0@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@0| () T@$Memory)
(declare-fun $abort_flag@9@@0 () Bool)
(declare-fun $abort_code@13@@0 () Int)
(declare-fun $Diem_CurrencyInfo_$memory@0@@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$2$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$2$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$2$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$2$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$2$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$2$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@0| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@6 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@0| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@5 () T@$Value)
(declare-fun inline$$BorrowField$5$dst@1@@0 () T@$Mutation)
(declare-fun inline$$ReadRef$4$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@0| () T@$Memory)
(declare-fun inline$$WritebackToGlobal$1$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@0| () T@$Memory)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@0 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@1 () T@$Value)
(declare-fun $Diem_Preburn_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@14@@0 () Int)
(declare-fun $abort_code@5@@1 () Int)
(declare-fun $abort_flag@3@@1 () Bool)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $abort_flag@4@@1 () Bool)
(declare-fun $abort_code@8@@0 () Int)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun $abort_code@9@@0 () Int)
(declare-fun $abort_flag@6@@0 () Bool)
(declare-fun $abort_code@10@@0 () Int)
(declare-fun $abort_flag@7@@0 () Bool)
(declare-fun $abort_code@11@@0 () Int)
(declare-fun $abort_flag@8@@0 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@0 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@11 () T@$Value)
(declare-fun inline$$Diem_CancelBurnEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$5$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$5$size@1@@0 () Int)
(declare-fun inline$$BorrowField$5$p@2@@0 () T@$Path)
(declare-fun inline$$ReadRef$3$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$4$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1@@0 () Int)
(declare-fun inline$$BorrowField$4$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@4 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@3 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Sub$0$dst@2@@0 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1@@0 () Int)
(declare-fun inline$$BorrowField$3$p@2@@0 () T@$Path)
(declare-fun inline$$Sub$0$dst@0@@0 () T@$Value)
(declare-fun inline$$ReadRef$2$v@1@@0 () T@$Value)
(declare-fun inline$$Sub$0$dst@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$2$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1@@0 () Int)
(declare-fun inline$$BorrowField$2$p@2@@0 () T@$Path)
(declare-fun inline$$Ge$0$dst@1@@0 () T@$Value)
(declare-fun $abort_code@12@@0 () Int)
(declare-fun call3formal@$ret0@0@@12 () T@$Value)
(declare-fun inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t21@1 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@0 () Int)
(declare-fun inline$$BorrowField$1$p@2@@0 () T@$Path)
(declare-fun inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$ta@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$1$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@0 () T@$Mutation)
(declare-fun inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun inline$$WritebackToGlobal$0$l@1@@0 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@0 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@0 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@0 () T@$Value)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@0| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@0 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@0| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@0 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@0 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@0| () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$info@0 () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@0 () T@$Mutation)
(declare-fun call5formal@$ret1@0 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@0 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@0 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@0 () Int)
(declare-fun inline$$BorrowField$0$p@2@@0 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@0 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@0 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@0 () T@$Mutation)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1 () T@$Value)
(declare-fun $abort_code@6@@1 () Int)
(declare-fun call3formal@$ret0@0@@13 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_with_capability_$def$0$$t13@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$GetGlobal$0$a@1@@0 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@14 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_$def$0$$t7@1 () T@$Value)
(declare-fun $abort_code@3@@1 () Int)
(declare-fun call3formal@$ret0@0@@15 () T@$Value)
(declare-fun inline$$Diem_cancel_burn_$def$0$$t8@1 () T@$Value)
(declare-fun $FixedPoint32_FixedPoint32_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 792048) (let ((anon0$2_correct@@1  (and (=> (= (ControlFlow 0 440628) (- 0 812913)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 812946)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 812976)) (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813005)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813021)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813051)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813067)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813087)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@60 (|l#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@61 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@61 1)))) len@@60 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@60 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@65 (|l#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@66 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@66 1)))) len@@65 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@65 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@60 (|l#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@61 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@61 (|l#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@62 (|l#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@63 (|l#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@64 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@64 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@64 1)))) len@@63 ($Integer 0)) (+ len@@63 1)))) len@@62 ($Integer 0)) (+ len@@62 1)))) len@@61 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@61 1)))) len@@60 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@60 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@65 (|l#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@66 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@66 (|l#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@67 (|l#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@68 (|l#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@69 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@69 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@69 1)))) len@@68 ($Integer 0)) (+ len@@68 1)))) len@@67 ($Integer 0)) (+ len@@67 1)))) len@@66 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@66 1)))) len@@65 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@65 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813147)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813162)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813205)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813249)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813308)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813389)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813470)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813580)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813663)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813724)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813807)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@70 (|l#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@71 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@71 1)))) len@@70 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@70 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@70 (|l#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@71 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@71 (|l#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@72 (|l#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@73 (|l#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@74 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@74 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@74 1)))) len@@73 ($Integer 0)) (+ len@@73 1)))) len@@72 ($Integer 0)) (+ len@@72 1)))) len@@71 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@71 1)))) len@@70 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@70 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 813946)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@75 (|l#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@76 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@76 (|l#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@77 (|l#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@78 (|l#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@79 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@79 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@79 1)))) len@@78 ($Integer 0)) (+ len@@78 1)))) len@@77 ($Integer 0)) (+ len@@77 1)))) len@@76 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@76 1)))) len@@75 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@75 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814085)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814244)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814329)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814345)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814356)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@13@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@13@@0) (and (=> (= (ControlFlow 0 440628) (- 0 814395)) (=> $abort_flag@13@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@80 (|l#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@81 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@81 1)))) len@@80 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@80 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@85 (|l#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@86 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@86 1)))) len@@85 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@85 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@0) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key@@0 ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@90 (|l#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@91 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@91 1)))) len@@90 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@90 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@95 (|l#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1)))) len@@95 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@95 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (=> (=> $abort_flag@13@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@80 (|l#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@81 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@81 (|l#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@82 (|l#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@83 (|l#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@84 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@84 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@84 1)))) len@@83 ($Integer 0)) (+ len@@83 1)))) len@@82 ($Integer 0)) (+ len@@82 1)))) len@@81 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@81 1)))) len@@80 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@80 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@85 (|l#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@86 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@86 (|l#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@87 (|l#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@88 (|l#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@89 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@89 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@89 1)))) len@@88 ($Integer 0)) (+ len@@88 1)))) len@@87 ($Integer 0)) (+ len@@87 1)))) len@@86 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@86 1)))) len@@85 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@85 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@0) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key@@0 ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@90 (|l#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@91 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@91 (|l#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@92 (|l#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@93 (|l#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@94 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@94 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@94 1)))) len@@93 ($Integer 0)) (+ len@@93 1)))) len@@92 ($Integer 0)) (+ len@@92 1)))) len@@91 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@91 1)))) len@@90 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@90 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@95 (|l#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@96 (|l#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@97 (|l#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@98 (|l#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@99 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@99 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@99 1)))) len@@98 ($Integer 0)) (+ len@@98 1)))) len@@97 ($Integer 0)) (+ len@@97 1)))) len@@96 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@96 1)))) len@@95 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@95 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))) (and (=> (= (ControlFlow 0 440628) (- 0 815853)) (=> $abort_flag@13@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@100 (|l#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1)))) len@@100 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@100 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@105 (|l#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1)))) len@@105 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@105 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@1) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key@@1 ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@110 (|l#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1)))) len@@110 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@110 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@115 (|l#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1)))) len@@115 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@115 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@13@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| account@@0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 4)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean (< (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@100 (|l#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@101 (|l#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@102 (|l#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@103 (|l#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@104 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@104 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@104 1)))) len@@103 ($Integer 0)) (+ len@@103 1)))) len@@102 ($Integer 0)) (+ len@@102 1)))) len@@101 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@101 1)))) len@@100 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@100 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@105 (|l#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@106 (|l#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@107 (|l#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@108 (|l#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@109 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@109 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@109 1)))) len@@108 ($Integer 0)) (+ len@@108 1)))) len@@107 ($Integer 0)) (+ len@@107 1)))) len@@106 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@106 1)))) len@@105 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@105 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@1) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify ($Vector ($ValueArray ($MapConstValue $Error) 0)) payee_compliance_key@@1 ($DualAttestation_spec_dual_attestation_message preburn_address ($Vector ($ValueArray ($MapConstValue $Error) 0)) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray ($MapConstValue $Error) 0))))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@110 (|l#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@111 (|l#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@112 (|l#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@113 (|l#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@114 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@114 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@114 1)))) len@@113 ($Integer 0)) (+ len@@113 1)))) len@@112 ($Integer 0)) (+ len@@112 1)))) len@@111 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@111 1)))) len@@110 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@110 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@115 (|l#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@116 (|l#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@117 (|l#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@118 (|l#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@119 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@119 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@119 1)))) len@@118 ($Integer 0)) (+ len@@118 1)))) len@@117 ($Integer 0)) (+ len@@117 1)))) len@@116 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@116 1)))) len@@115 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@115 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@20@@0 (|i#$Integer| ($Integer 8)))))) (and (=> (= (ControlFlow 0 440628) (- 0 817586)) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0)))))) (=> (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory@3) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value) ($Integer 0))))) (and (=> (= (ControlFlow 0 440628) (- 0 817608)) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value) ($Integer (- (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_preburn_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 440628) (- 0 817644)) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $Diem_Preburn_to_burn))) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 440628) (- 0 817684)) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean (forall ((addr@@27 T@$Value) )  (=> ((_ is $Address) addr@@27) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@27)))) $DiemAccount_DiemAccount_authentication_key))))))))))))) (=> (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean (forall ((addr@@28 T@$Value) )  (=> ((_ is $Address) addr@@28) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@2@@1) $EmptyTypeValueArray (|a#$Address| addr@@28)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@28)))) $DiemAccount_DiemAccount_authentication_key)))))))))))) (=> (= (ControlFlow 0 440628) (- 0 817743)) (=> (not $abort_flag@13@@0) (|b#$Boolean| ($Boolean (forall ((addr@@29 T@$Value) )  (=> ((_ is $Address) addr@@29) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@29)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@2@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@29)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@29)))) $DiemAccount_Balance_coin))) $Diem_Diem_value))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$Abort_correct  (=> (and (= $abort_code@20@@0 $abort_code@19@@0) (= $DiemAccount_Balance_$memory@2@@0 $DiemAccount_Balance_$memory@1@@0)) (=> (and (and (= $DiemAccount_DiemAccount_$memory@2@@1 $DiemAccount_DiemAccount_$memory@1@@1) (= $AccountLimits_Window_$memory@2@@0 $AccountLimits_Window_$memory@1@@0)) (and (= $abort_flag@13@@0 true) (= (ControlFlow 0 440594) 440628))) anon0$2_correct@@1))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon9_correct  (=> (= $AccountLimits_Window_$memory@1@@0 $AccountLimits_Window_$memory@0@@0) (=> (and (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory@0@@1) (= $DiemAccount_Balance_$memory@1@@0 $DiemAccount_Balance_$memory@0@@0)) (and (= $abort_code@19@@0 $abort_code@18@@0) (= (ControlFlow 0 440590) 440594))) inline$$DiemAccount_cancel_burn_$def_verify$0$Abort_correct))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon15_Else_correct  (=> (and (not true) (= (ControlFlow 0 440588) 440590)) inline$$DiemAccount_cancel_burn_$def_verify$0$anon9_correct)))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon15_Then_correct  (=> (= (ControlFlow 0 440602) 440590) inline$$DiemAccount_cancel_burn_$def_verify$0$anon9_correct)))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon14_Then_correct  (=> $abort_flag@12@@0 (and (=> (= (ControlFlow 0 440582) 440602) inline$$DiemAccount_cancel_burn_$def_verify$0$anon15_Then_correct) (=> (= (ControlFlow 0 440582) 440588) inline$$DiemAccount_cancel_burn_$def_verify$0$anon15_Else_correct)))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Then_correct  (=> (and $abort_flag@11@@0 (= $AccountLimits_Window_$memory@1@@0 $AccountLimits_Window_$memory)) (=> (and (and (= $DiemAccount_DiemAccount_$memory@1@@1 $DiemAccount_DiemAccount_$memory) (= $DiemAccount_Balance_$memory@1@@0 $DiemAccount_Balance_$memory)) (and (= $abort_code@19@@0 $abort_code@17@@0) (= (ControlFlow 0 440606) 440594))) inline$$DiemAccount_cancel_burn_$def_verify$0$Abort_correct))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon14_Else_correct  (=> (not $abort_flag@12@@0) (=> (and (= $abort_code@20@@0 $abort_code@18@@0) (= $DiemAccount_Balance_$memory@2@@0 $DiemAccount_Balance_$memory@0@@0)) (=> (and (and (= $DiemAccount_DiemAccount_$memory@2@@1 $DiemAccount_DiemAccount_$memory@0@@1) (= $AccountLimits_Window_$memory@2@@0 $AccountLimits_Window_$memory@0@@0)) (and (= $abort_flag@13@@0 $abort_flag@12@@0) (= (ControlFlow 0 440578) 440628))) anon0$2_correct@@1)))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Else_correct  (=> (and (not $abort_flag@11@@0) (= inline$$DiemAccount_cancel_burn_$def_verify$0$$t5@1 ($Vector ($ValueArray ($MapConstValue $Error) 0)))) (=> (and (and (= inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1 ($Vector ($ValueArray ($MapConstValue $Error) 0))) (= call6formal@$AccountLimits_Window_$CallerDomain@0 ($ConstMemoryDomain true))) (and (= call7formal@$DiemAccount_DiemAccount_$CallerDomain@0 ($ConstMemoryDomain true)) (= call8formal@$DiemAccount_Balance_$CallerDomain@0 ($ConstMemoryDomain true)))) (and (=> (= (ControlFlow 0 440572) (- 0 808429)) (|Select_[$TypeValueArray,$int]$bool| call6formal@$AccountLimits_Window_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) (=> (|Select_[$TypeValueArray,$int]$bool| call6formal@$AccountLimits_Window_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))) (and (=> (= (ControlFlow 0 440572) (- 0 808454)) (|Select_[$TypeValueArray,$int]$bool| call7formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| preburn_address))) (=> (|Select_[$TypeValueArray,$int]$bool| call7formal@$DiemAccount_DiemAccount_$CallerDomain@0 $EmptyTypeValueArray (|a#$Address| preburn_address)) (and (=> (= (ControlFlow 0 440572) (- 0 808462)) (|Select_[$TypeValueArray,$int]$bool| call8formal@$DiemAccount_Balance_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))) (=> (|Select_[$TypeValueArray,$int]$bool| call8formal@$DiemAccount_Balance_$CallerDomain@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) $abort_flag@12@@0) (=> (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) ($Integer 0)))) $abort_flag@12@@0)) (=> (and (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@120 (|l#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@121 (|l#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@122 (|l#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@123 (|l#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@124 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@124 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@124 1)))) len@@123 ($Integer 0)) (+ len@@123 1)))) len@@122 ($Integer 0)) (+ len@@122 1)))) len@@121 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@121 1)))) len@@120 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@120 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@125 (|l#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@126 (|l#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@127 (|l#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@128 (|l#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@129 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@129 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@129 1)))) len@@128 ($Integer 0)) (+ len@@128 1)))) len@@127 ($Integer 0)) (+ len@@127 1)))) len@@126 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@126 1)))) len@@125 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@125 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@12@@0)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@12@@0))) (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@12@@0)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@2) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1 payee_compliance_key@@2 ($DualAttestation_spec_dual_attestation_message preburn_address inline$$DiemAccount_cancel_burn_$def_verify$0$$t5@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)))))))))))))) $abort_flag@12@@0)))) (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@12@@0)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@130 (|l#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@131 (|l#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@132 (|l#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@133 (|l#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@134 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@134 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@134 1)))) len@@133 ($Integer 0)) (+ len@@133 1)))) len@@132 ($Integer 0)) (+ len@@132 1)))) len@@131 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@131 1)))) len@@130 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@130 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@12@@0))) (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@135 (|l#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@136 (|l#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@137 (|l#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@138 (|l#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@139 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@139 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@139 1)))) len@@138 ($Integer 0)) (+ len@@138 1)))) len@@137 ($Integer 0)) (+ len@@137 1)))) len@@136 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@136 1)))) len@@135 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@135 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@12@@0)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@12@@0))))) (and (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@12@@0) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@12@@0)) (and (=> $abort_flag@12@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@140 (|l#$ValueArray| (let ((len@@141 (|l#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1)))) len@@141 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@141 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@141 (|l#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@142 (|l#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@143 (|l#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@144 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@144 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@144 1)))) len@@143 ($Integer 0)) (+ len@@143 1)))) len@@142 ($Integer 0)) (+ len@@142 1)))) len@@141 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@141 1)))) len@@140 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@140 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@145 (|l#$ValueArray| (let ((len@@146 (|l#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1)))) len@@146 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@146 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@146 (|l#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@147 (|l#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@148 (|l#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@149 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@149 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@149 1)))) len@@148 ($Integer 0)) (+ len@@148 1)))) len@@147 ($Integer 0)) (+ len@@147 1)))) len@@146 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@146 1)))) len@@145 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@145 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@3 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@3) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1 payee_compliance_key@@3 ($DualAttestation_spec_dual_attestation_message preburn_address inline$$DiemAccount_cancel_burn_$def_verify$0$$t5@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@150 (|l#$ValueArray| (let ((len@@151 (|l#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1)))) len@@151 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@151 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@151 (|l#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@152 (|l#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@153 (|l#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@154 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@154 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@154 1)))) len@@153 ($Integer 0)) (+ len@@153 1)))) len@@152 ($Integer 0)) (+ len@@152 1)))) len@@151 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@151 1)))) len@@150 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@150 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@155 (|l#$ValueArray| (let ((len@@156 (|l#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1)))) len@@156 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@156 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@156 (|l#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@157 (|l#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@158 (|l#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@159 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@159 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@159 1)))) len@@158 ($Integer 0)) (+ len@@158 1)))) len@@157 ($Integer 0)) (+ len@@157 1)))) len@@156 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@156 1)))) len@@155 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@155 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))) (=> $abort_flag@12@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@160 (|l#$ValueArray| (let ((len@@161 (|l#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1)))) len@@161 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@161 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@161 (|l#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@162 (|l#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@163 (|l#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@164 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@164 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@164 1)))) len@@163 ($Integer 0)) (+ len@@163 1)))) len@@162 ($Integer 0)) (+ len@@162 1)))) len@@161 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@161 1)))) len@@160 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@160 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@165 (|l#$ValueArray| (let ((len@@166 (|l#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1)))) len@@166 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@166 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@166 (|l#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@167 (|l#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@168 (|l#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@169 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@169 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@169 1)))) len@@168 ($Integer 0)) (+ len@@168 1)))) len@@167 ($Integer 0)) (+ len@@167 1)))) len@@166 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@166 1)))) len@@165 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@165 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@4 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@4) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1 payee_compliance_key@@4 ($DualAttestation_spec_dual_attestation_message preburn_address inline$$DiemAccount_cancel_burn_$def_verify$0$$t5@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)))))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| inline$$DiemAccount_cancel_burn_$def_verify$0$$t6@1))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified preburn_address preburn_address))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) preburn_address))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@170 (|l#$ValueArray| (let ((len@@171 (|l#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1)))) len@@171 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@171 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@171 (|l#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@172 (|l#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@173 (|l#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@174 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@174 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@174 1)))) len@@173 ($Integer 0)) (+ len@@173 1)))) len@@172 ($Integer 0)) (+ len@@172 1)))) len@@171 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@171 1)))) len@@170 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@170 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@175 (|l#$ValueArray| (let ((len@@176 (|l#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1)))) len@@176 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@176 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@176 (|l#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@177 (|l#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@178 (|l#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@179 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@179 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@179 1)))) len@@178 ($Integer 0)) (+ len@@178 1)))) len@@177 ($Integer 0)) (+ len@@177 1)))) len@@176 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@176 1)))) len@@175 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@175 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory@3@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@18@@0 (|i#$Integer| ($Integer 8)))))))) (and (and (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| preburn_address))))) (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))))) (and (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $DiemAccount_DiemAccount_withdraw_capability))))) (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_cancel_burn_$def$0$$ret0@2)) $Diem_Diem_value))))))))))) (and (and (and (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean (forall ((addr@@30 T@$Value) )  (=> ((_ is $Address) addr@@30) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@30)))) $DiemAccount_DiemAccount_authentication_key)))))))))))) (=> (not $abort_flag@12@@0) (|b#$Boolean| ($Boolean (forall ((addr@@31 T@$Value) )  (=> ((_ is $Address) addr@@31) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@31)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@31)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| addr@@31)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)))))))))))))) (and (= (|contents#$Memory| $AccountLimits_Window_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))) (= (|domain#$Memory| $AccountLimits_Window_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr))) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) preburn_address (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address)))) $VASP_ChildVASP_parent_vasp_addr)))))))) (and (and (= (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| preburn_address)))) (= (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| preburn_address) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0@@1) $EmptyTypeValueArray (|a#$Address| preburn_address))))) (and (= (|contents#$Memory| $DiemAccount_Balance_$memory@0@@0) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) (= (|domain#$Memory| $DiemAccount_Balance_$memory@0@@0) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@0@@0) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address))))))))) (and (=> (= (ControlFlow 0 440572) 440582) inline$$DiemAccount_cancel_burn_$def_verify$0$anon14_Then_correct) (=> (= (ControlFlow 0 440572) 440578) inline$$DiemAccount_cancel_burn_$def_verify$0$anon14_Else_correct)))))))))))))))
(let ((inline$$Diem_cancel_burn_$def$0$anon24_correct  (=> (= inline$$Diem_cancel_burn_$def$0$$ret0@2 inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@2) (=> (and (and (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@1@@0) (= $abort_flag@11@@0 $abort_flag@10@@0)) (and (= $abort_code@17@@0 $abort_code@15@@0) (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@1@@0))) (and (=> (= (ControlFlow 0 440442) 440606) inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 440442) 440572) inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Diem_cancel_burn_$def$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 440440) 440442)) inline$$Diem_cancel_burn_$def$0$anon24_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon36_Then_correct  (=> (= (ControlFlow 0 440450) 440442) inline$$Diem_cancel_burn_$def$0$anon24_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon35_Else_correct  (=> (not $abort_flag@10@@0) (and (=> (= (ControlFlow 0 440434) 440450) inline$$Diem_cancel_burn_$def$0$anon36_Then_correct) (=> (= (ControlFlow 0 440434) 440440) inline$$Diem_cancel_burn_$def$0$anon36_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$Abort_correct  (=> (and (= inline$$Diem_cancel_burn_$def$0$$ret0@1 $Error) (= inline$$Diem_cancel_burn_$def$0$$ret0@2 inline$$Diem_cancel_burn_$def$0$$ret0@1)) (=> (and (and (= $Diem_Preburn_$memory@3 $Diem_Preburn_$memory@2@@0) (= $abort_flag@11@@0 true)) (and (= $abort_code@17@@0 $abort_code@16@@0) (= $Diem_CurrencyInfo_$memory@3@@0 $Diem_CurrencyInfo_$memory@2@@0))) (and (=> (= (ControlFlow 0 434027) 440606) inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Then_correct) (=> (= (ControlFlow 0 434027) 440572) inline$$DiemAccount_cancel_burn_$def_verify$0$anon13_Else_correct))))))
(let ((inline$$Diem_cancel_burn_$def$0$anon7_correct  (=> (and (and (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory) (= $abort_code@16@@0 $abort_code@1@@1)) (and (= $Diem_CurrencyInfo_$memory@2@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 440506) 434027))) inline$$Diem_cancel_burn_$def$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon28_Else_correct  (=> (and (not true) (= (ControlFlow 0 440504) 440506)) inline$$Diem_cancel_burn_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon28_Then_correct  (=> (= (ControlFlow 0 440514) 440506) inline$$Diem_cancel_burn_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon27_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 440498) 440514) inline$$Diem_cancel_burn_$def$0$anon28_Then_correct) (=> (= (ControlFlow 0 440498) 440504) inline$$Diem_cancel_burn_$def$0$anon28_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon11_correct  (=> (and (and (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory) (= $abort_code@16@@0 $abort_code@2@@1)) (and (= $Diem_CurrencyInfo_$memory@2@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 440486) 434027))) inline$$Diem_cancel_burn_$def$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon30_Else_correct  (=> (and (not true) (= (ControlFlow 0 440484) 440486)) inline$$Diem_cancel_burn_$def$0$anon11_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon30_Then_correct  (=> (= (ControlFlow 0 440494) 440486) inline$$Diem_cancel_burn_$def$0$anon11_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon29_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 440478) 440494) inline$$Diem_cancel_burn_$def$0$anon30_Then_correct) (=> (= (ControlFlow 0 440478) 440484) inline$$Diem_cancel_burn_$def$0$anon30_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon19_correct  (=> (and (and (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory) (= $abort_code@16@@0 $abort_code@4@@1)) (and (= $Diem_CurrencyInfo_$memory@2@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 440466) 434027))) inline$$Diem_cancel_burn_$def$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon34_Else_correct  (=> (and (not true) (= (ControlFlow 0 440464) 440466)) inline$$Diem_cancel_burn_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon34_Then_correct  (=> (= (ControlFlow 0 440474) 440466) inline$$Diem_cancel_burn_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon33_Then_correct  (=> $abort_flag@2@@1 (and (=> (= (ControlFlow 0 440458) 440474) inline$$Diem_cancel_burn_$def$0$anon34_Then_correct) (=> (= (ControlFlow 0 440458) 440464) inline$$Diem_cancel_burn_$def$0$anon34_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon35_Then_correct  (=> $abort_flag@10@@0 (=> (and (and (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory@1@@0) (= $abort_code@16@@0 $abort_code@15@@0)) (and (= $Diem_CurrencyInfo_$memory@2@@0 $Diem_CurrencyInfo_$memory@1@@0) (= (ControlFlow 0 440454) 434027))) inline$$Diem_cancel_burn_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@2 call4formal@$ret0@0) (=> (and (and (= $Diem_Preburn_$memory@1@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= $abort_flag@10@@0 $abort_flag@9@@0)) (and (= $abort_code@15@@0 $abort_code@13@@0) (= $Diem_CurrencyInfo_$memory@1@@0 $Diem_CurrencyInfo_$memory@0@@0))) (and (=> (= (ControlFlow 0 439023) 440454) inline$$Diem_cancel_burn_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 439023) 440434) inline$$Diem_cancel_burn_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct  (=> (and (not true) (= (ControlFlow 0 439021) 439023)) inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct  (=> (= (ControlFlow 0 439031) 439023) inline$$Diem_cancel_burn_with_capability_$def$0$anon66_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct  (=> (= $Diem_CurrencyInfo_$memory@0@@0 |inline$$WritebackToGlobal$2$m'@2@@0|) (and (=> (= (ControlFlow 0 440158) 439031) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 440158) 439021) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct)))))
(let ((inline$$WritebackToGlobal$2$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$2$m'@2@@0| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 440096) 440158)) inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct))))
(let ((inline$$WritebackToGlobal$2$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$2$l@1@@0) (=> (and (= inline$$WritebackToGlobal$2$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$2$l@1@@0)) (= inline$$WritebackToGlobal$2$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$2$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$2$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|))) (= |inline$$WritebackToGlobal$2$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$2$ta@1@@0 inline$$WritebackToGlobal$2$a@1@@0 inline$$WritebackToGlobal$2$v@1@@0)))) (and (= |inline$$WritebackToGlobal$2$m'@2@@0| |inline$$WritebackToGlobal$2$m'@1@@0|) (= (ControlFlow 0 440150) 440158))) inline$$Diem_cancel_burn_with_capability_$def$0$anon64$3_correct)))))
(let ((inline$$WritebackToGlobal$2$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$2$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (and (=> (= (ControlFlow 0 440086) 440150) inline$$WritebackToGlobal$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 440086) 440096) inline$$WritebackToGlobal$2$anon3_Else_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@0  (and (=> (= (ControlFlow 0 439966) (- 0 807772)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 439966) 440086) inline$$WritebackToGlobal$2$anon0_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$2$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2@@0|)) (= (ControlFlow 0 439918) 439966)) inline$$Diem_CurrencyInfo_$pack_ref$2$anon0_correct@@0)))
(let ((inline$$WritebackToReference$2$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$1$dst'@2@@0|) (= (ControlFlow 0 439787) 439918)) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|l#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$2$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1@@0 inline$$WritebackToReference$2$srcPath@1@@0)) (= |inline$$WritebackToReference$2$dst'@1@@0| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$WritebackToReference$2$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$2$dstPath@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) (|v#$Mutation| |inline$$WriteRef$2$to'@1@@0|))))) (and (= |inline$$WritebackToReference$2$dst'@2@@0| |inline$$WritebackToReference$2$dst'@1@@0|) (= (ControlFlow 0 439843) 439918))) inline$$Diem_CurrencyInfo_$pack_ref$2$Entry_correct@@0)))
(let ((inline$$WritebackToReference$2$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$2$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$2$to'@1@@0|)) (= inline$$WritebackToReference$2$dstPath@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (and (=> (= (ControlFlow 0 439751) 439843) inline$$WritebackToReference$2$anon3_Then_correct@@0) (=> (= (ControlFlow 0 439751) 439787) inline$$WritebackToReference$2$anon3_Else_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct  (=> (and (not true) (= (ControlFlow 0 439614) 439751)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@6 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 440168) 439751)) inline$$WritebackToReference$2$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 439606) 440168) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 439606) 439614) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@5 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 440178) 440168) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Then_correct) (=> (= (ControlFlow 0 440178) 439614) inline$$Diem_cancel_burn_with_capability_$def$0$anon98_Else_correct)))))
(let ((inline$$WriteRef$2$anon0_correct@@0  (=> (= |inline$$WriteRef$2$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$5$dst@1@@0) (|p#$Mutation| inline$$BorrowField$5$dst@1@@0) inline$$ReadRef$4$v@1@@0)) (and (=> (= (ControlFlow 0 439592) 440178) inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Then_correct) (=> (= (ControlFlow 0 439592) 439606) inline$$Diem_cancel_burn_with_capability_$def$0$anon97_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Else_correct  (=> (and (not $abort_flag@9@@0) (= (ControlFlow 0 439598) 439592)) inline$$WriteRef$2$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct  (=> (= $Diem_CurrencyInfo_$memory@0@@0 |inline$$WritebackToGlobal$1$m'@2@@0|) (and (=> (= (ControlFlow 0 439011) 439031) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Then_correct) (=> (= (ControlFlow 0 439011) 439021) inline$$Diem_cancel_burn_with_capability_$def$0$anon99_Else_correct)))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@0  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@0| $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 438949) 439011)) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@0  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@0) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@0)) (= inline$$WritebackToGlobal$1$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) (= |inline$$WritebackToGlobal$1$m'@1@@0| ($Memory (|domain#$Memory| $Diem_CurrencyInfo_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$WritebackToGlobal$1$ta@1@@0 inline$$WritebackToGlobal$1$a@1@@0 inline$$WritebackToGlobal$1$v@1@@0)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@0| |inline$$WritebackToGlobal$1$m'@1@@0|) (= (ControlFlow 0 439003) 439011))) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$1$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (and (=> (= (ControlFlow 0 438939) 439003) inline$$WritebackToGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 438939) 438949) inline$$WritebackToGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@0  (and (=> (= (ControlFlow 0 438819) (- 0 807201)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 438819) 438939) inline$$WritebackToGlobal$1$anon0_correct@@0)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$1$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (= (ControlFlow 0 438771) 438819)) inline$$Diem_CurrencyInfo_$pack_ref$1$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1@@0)) (= (ControlFlow 0 438823) 438771)) inline$$Diem_CurrencyInfo_$pack_ref$1$Entry_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@1 $Error) (= inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@2 inline$$Diem_cancel_burn_with_capability_$def$0$$ret0@1)) (=> (and (and (= $Diem_Preburn_$memory@1@@0 $Diem_Preburn_$memory@0@@0) (= $abort_flag@10@@0 true)) (and (= $abort_code@15@@0 $abort_code@14@@0) (= $Diem_CurrencyInfo_$memory@1@@0 $Diem_CurrencyInfo_$memory))) (and (=> (= (ControlFlow 0 435555) 440454) inline$$Diem_cancel_burn_$def$0$anon35_Then_correct) (=> (= (ControlFlow 0 435555) 440434) inline$$Diem_cancel_burn_$def$0$anon35_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct  (=> (= $abort_code@14@@0 $abort_code@5@@1) (=> (and (= $Diem_Preburn_$memory@0@@0 $Diem_Preburn_$memory) (= (ControlFlow 0 440386) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 440384) 440386)) inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Then_correct  (=> (= (ControlFlow 0 440394) 440386) inline$$Diem_cancel_burn_with_capability_$def$0$anon7_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Then_correct  (=> $abort_flag@3@@1 (and (=> (= (ControlFlow 0 440378) 440394) inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Then_correct) (=> (= (ControlFlow 0 440378) 440384) inline$$Diem_cancel_burn_with_capability_$def$0$anon70_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct  (=> (= $abort_code@14@@0 $abort_code@7@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 $Diem_Preburn_$memory) (= (ControlFlow 0 440366) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 440364) 440366)) inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Then_correct  (=> (= (ControlFlow 0 440374) 440366) inline$$Diem_cancel_burn_with_capability_$def$0$anon15_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct  (=> $abort_flag@4@@1 (and (=> (= (ControlFlow 0 440358) 440374) inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Then_correct) (=> (= (ControlFlow 0 440358) 440364) inline$$Diem_cancel_burn_with_capability_$def$0$anon74_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct  (=> (= $abort_code@14@@0 $abort_code@8@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 $Diem_Preburn_$memory) (= (ControlFlow 0 440346) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Else_correct  (=> (and (not true) (= (ControlFlow 0 440344) 440346)) inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Then_correct  (=> (= (ControlFlow 0 440354) 440346) inline$$Diem_cancel_burn_with_capability_$def$0$anon19_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Then_correct  (=> $abort_flag@5@@0 (and (=> (= (ControlFlow 0 440338) 440354) inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Then_correct) (=> (= (ControlFlow 0 440338) 440344) inline$$Diem_cancel_burn_with_capability_$def$0$anon76_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct  (=> (= $abort_code@14@@0 $abort_code@9@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440298) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 440296) 440298)) inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Then_correct  (=> (= (ControlFlow 0 440306) 440298) inline$$Diem_cancel_burn_with_capability_$def$0$anon29_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Then_correct  (=> $abort_flag@6@@0 (and (=> (= (ControlFlow 0 440290) 440306) inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Then_correct) (=> (= (ControlFlow 0 440290) 440296) inline$$Diem_cancel_burn_with_capability_$def$0$anon81_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct  (=> (= $abort_code@14@@0 $abort_code@10@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440274) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 440272) 440274)) inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Then_correct  (=> (= (ControlFlow 0 440282) 440274) inline$$Diem_cancel_burn_with_capability_$def$0$anon35_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct  (=> $abort_flag@7@@0 (and (=> (= (ControlFlow 0 440266) 440282) inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Then_correct) (=> (= (ControlFlow 0 440266) 440272) inline$$Diem_cancel_burn_with_capability_$def$0$anon84_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct  (=> (= $abort_code@14@@0 $abort_code@11@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440250) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Else_correct  (=> (and (not true) (= (ControlFlow 0 440248) 440250)) inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Then_correct  (=> (= (ControlFlow 0 440258) 440250) inline$$Diem_cancel_burn_with_capability_$def$0$anon41_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Then_correct  (=> $abort_flag@8@@0 (and (=> (= (ControlFlow 0 440242) 440258) inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Then_correct) (=> (= (ControlFlow 0 440242) 440248) inline$$Diem_cancel_burn_with_capability_$def$0$anon87_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct  (=> (= $abort_code@14@@0 $abort_code@13@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440230) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Else_correct  (=> (and (not true) (= (ControlFlow 0 440228) 440230)) inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Then_correct  (=> (= (ControlFlow 0 440238) 440230) inline$$Diem_cancel_burn_with_capability_$def$0$anon49_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct  (=> $abort_flag@9@@0 (and (=> (= (ControlFlow 0 440222) 440238) inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Then_correct) (=> (= (ControlFlow 0 440222) 440228) inline$$Diem_cancel_burn_with_capability_$def$0$anon91_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct  (=> (= $abort_code@14@@0 $abort_code@13@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440190) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Else_correct  (=> (and (not true) (= (ControlFlow 0 440188) 440190)) inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Then_correct  (=> (= (ControlFlow 0 440198) 440190) inline$$Diem_cancel_burn_with_capability_$def$0$anon59_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Then_correct  (=> $abort_flag@9@@0 (and (=> (= (ControlFlow 0 440182) 440198) inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Then_correct) (=> (= (ControlFlow 0 440182) 440188) inline$$Diem_cancel_burn_with_capability_$def$0$anon96_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@0  (=> (= inline$$Event_emit_event$0$t@0@@0 $Diem_CancelBurnEvent_type_value) (and (=> (= (ControlFlow 0 439523) 440182) inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Then_correct) (=> (= (ControlFlow 0 439523) 439598) inline$$Diem_cancel_burn_with_capability_$def$0$anon95_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then$3_correct  (and (=> (= (ControlFlow 0 439533) (- 0 807557)) true) (=> (= (ControlFlow 0 439533) 439523) inline$$Event_emit_event$0$Entry_correct@@0))))
(let ((inline$$ReadRef$4$anon0_correct@@0  (=> (and (= inline$$ReadRef$4$v@1@@0 (|v#$Mutation| inline$$BorrowField$5$dst@1@@0)) (= (ControlFlow 0 439475) 439533)) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then$3_correct)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 439431) 439475)) inline$$ReadRef$4$anon0_correct@@0)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 439437) 439475) inline$$ReadRef$4$anon0_correct@@0)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 439425) 439437) inline$$Diem_CancelBurnEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 439425) 439431) inline$$Diem_CancelBurnEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 439417) 439475)) inline$$ReadRef$4$anon0_correct@@0)))
(let ((inline$$Diem_CancelBurnEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@0) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) $MAX_U64)) (=> (and (and (and ((_ is $Vector) call3formal@$ret0@0@@11) (let ((va@@92 (|v#$Vector| call3formal@$ret0@0@@11)))
(let ((l@@92 (|l#$ValueArray| va@@92)))
 (and (and (<= 0 l@@92) (<= l@@92 $MAX_U64)) (forall ((x@@92 Int) ) (!  (=> (or (< x@@92 0) (>= x@@92 l@@92)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@92) x@@92))
)))))) (forall ((inline$$Diem_CancelBurnEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$Diem_CancelBurnEvent_pack$0$$$0 0) (< inline$$Diem_CancelBurnEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) inline$$Diem_CancelBurnEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) inline$$Diem_CancelBurnEvent_pack$0$$$0))
))) (and ((_ is $Address) preburn_address) (= inline$$Diem_CancelBurnEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@0) 1 call3formal@$ret0@0@@11) 2 preburn_address) 3))))) (and (=> (= (ControlFlow 0 439409) 439425) inline$$Diem_CancelBurnEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 439409) 439417) inline$$Diem_CancelBurnEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$BorrowField$5$anon0_correct@@0  (=> (= inline$$BorrowField$5$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$5$size@1@@0 (|size#$Path| inline$$BorrowField$5$p@1@@0)) (= inline$$BorrowField$5$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$5$p@1@@0) inline$$BorrowField$5$size@1@@0 $Diem_CurrencyInfo_cancel_burn_events) (+ inline$$BorrowField$5$size@1@@0 1)))) (and (= inline$$BorrowField$5$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$5$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $Diem_CurrencyInfo_cancel_burn_events))) (= (ControlFlow 0 439153) 439409))) inline$$Diem_CancelBurnEvent_pack$0$anon0_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then_correct  (=> (and (|b#$Boolean| inline$$Not$0$dst@1@@0) (= (ControlFlow 0 439159) 439153)) inline$$BorrowField$5$anon0_correct@@0)))
(let ((inline$$Not$0$anon0_correct@@0  (=> (= inline$$Not$0$dst@1@@0 ($Boolean  (not (|b#$Boolean| inline$$ReadRef$3$v@1@@0)))) (and (=> (= (ControlFlow 0 438688) 439159) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Then_correct) (=> (= (ControlFlow 0 438688) 438823) inline$$Diem_cancel_burn_with_capability_$def$0$anon94_Else_correct)))))
(let ((inline$$Not$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 438678) (- 0 807162)) true) (=> (= (ControlFlow 0 438678) 438688) inline$$Not$0$anon0_correct@@0))))
(let ((inline$$ReadRef$3$anon0_correct@@0  (=> (and (= inline$$ReadRef$3$v@1@@0 (|v#$Mutation| inline$$BorrowField$4$dst@1@@0)) (= (ControlFlow 0 438630) 438678)) inline$$Not$0$Entry_correct@@0)))
(let ((inline$$BorrowField$4$anon0_correct@@0  (=> (= inline$$BorrowField$4$p@1@@0 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|)) (=> (and (and (= inline$$BorrowField$4$size@1@@0 (|size#$Path| inline$$BorrowField$4$p@1@@0)) (= inline$$BorrowField$4$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1@@0) inline$$BorrowField$4$size@1@@0 $Diem_CurrencyInfo_is_synthetic) (+ inline$$BorrowField$4$size@1@@0 1)))) (and (= inline$$BorrowField$4$dst@1@@0 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|) inline$$BorrowField$4$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@0|))) $Diem_CurrencyInfo_is_synthetic))) (= (ControlFlow 0 438592) 438630))) inline$$ReadRef$3$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@0| inline$$BorrowGlobal$1$dst@2@@0) (= (ControlFlow 0 438376) 438592)) inline$$BorrowField$4$anon0_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@0 inline$$WritebackToReference$1$srcPath@1@@0)) (= |inline$$WritebackToReference$1$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$WritebackToReference$1$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@0|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@0| |inline$$WritebackToReference$1$dst'@1@@0|) (= (ControlFlow 0 438432) 438592))) inline$$BorrowField$4$anon0_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@0|)) (= inline$$WritebackToReference$1$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) (and (=> (= (ControlFlow 0 438340) 438432) inline$$WritebackToReference$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 438340) 438376) inline$$WritebackToReference$1$anon3_Else_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct  (=> (and (not true) (= (ControlFlow 0 438203) 438340)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@4 (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (= (ControlFlow 0 440208) 438340)) inline$$WritebackToReference$1$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 438195) 440208) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 438195) 438203) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@3 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (and (=> (= (ControlFlow 0 440218) 440208) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Then_correct) (=> (= (ControlFlow 0 440218) 438203) inline$$Diem_cancel_burn_with_capability_$def$0$anon93_Else_correct)))))
(let ((inline$$WriteRef$1$anon0_correct@@0  (=> (= |inline$$WriteRef$1$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1@@0) (|p#$Mutation| inline$$BorrowField$3$dst@1@@0) inline$$Sub$0$dst@2@@0)) (and (=> (= (ControlFlow 0 438181) 440218) inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Then_correct) (=> (= (ControlFlow 0 438181) 438195) inline$$Diem_cancel_burn_with_capability_$def$0$anon92_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct@@0  (=> (= inline$$BorrowField$3$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$3$size@1@@0 (|size#$Path| inline$$BorrowField$3$p@1@@0)) (= inline$$BorrowField$3$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1@@0) inline$$BorrowField$3$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$3$size@1@@0 1)))) (and (= inline$$BorrowField$3$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$3$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 438122) 438181))) inline$$WriteRef$1$anon0_correct@@0))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct  (=> (and (not $abort_flag@9@@0) (= (ControlFlow 0 438128) 438122)) inline$$BorrowField$3$anon0_correct@@0)))
(let ((inline$$Sub$0$anon3_Then$1_correct@@0  (=> (= $abort_code@13@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@9@@0 true) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@0@@0)) (and (=> (= (ControlFlow 0 437992) 440222) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 437992) 438128) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$anon3_Then_correct@@0  (=> (and (< (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0)) (= (ControlFlow 0 437990) 437992)) inline$$Sub$0$anon3_Then$1_correct@@0)))
(let ((inline$$Sub$0$anon3_Else_correct@@0  (=> (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0) (|i#$Integer| inline$$ReadRef$2$v@1@@0)) (=> (and (and (= inline$$Sub$0$dst@1@@0 ($Integer (- (|i#$Integer| inline$$ReadRef$2$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0)))) (= $abort_code@13@@0 $abort_code@11@@0)) (and (= $abort_flag@9@@0 $abort_flag@8@@0) (= inline$$Sub$0$dst@2@@0 inline$$Sub$0$dst@1@@0))) (and (=> (= (ControlFlow 0 437938) 440222) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Then_correct) (=> (= (ControlFlow 0 437938) 438128) inline$$Diem_cancel_burn_with_capability_$def$0$anon90_Else_correct))))))
(let ((inline$$Sub$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 437912) (- 0 806726)) true) (and (=> (= (ControlFlow 0 437912) 437990) inline$$Sub$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 437912) 437938) inline$$Sub$0$anon3_Else_correct@@0)))))
(let ((inline$$ReadRef$2$anon0_correct@@0  (=> (and (= inline$$ReadRef$2$v@1@@0 (|v#$Mutation| inline$$BorrowField$2$dst@1@@0)) (= (ControlFlow 0 437813) 437912)) inline$$Sub$0$Entry_correct@@0)))
(let ((inline$$BorrowField$2$anon0_correct@@0  (=> (= inline$$BorrowField$2$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$2$size@1@@0 (|size#$Path| inline$$BorrowField$2$p@1@@0)) (= inline$$BorrowField$2$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1@@0) inline$$BorrowField$2$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$2$size@1@@0 1)))) (and (= inline$$BorrowField$2$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$2$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 437775) 437813))) inline$$ReadRef$2$anon0_correct@@0))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Then_correct  (=> (and (|b#$Boolean| inline$$Ge$0$dst@1@@0) (= (ControlFlow 0 437827) 437775)) inline$$BorrowField$2$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct  (=> (= $abort_code@14@@0 $abort_code@12@@0) (=> (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 437609) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Else_correct  (=> (and (not true) (= (ControlFlow 0 437607) 437609)) inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Then_correct  (=> (= (ControlFlow 0 437617) 437609) inline$$Diem_cancel_burn_with_capability_$def$0$anon46_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else$1_correct  (=> (= $abort_code@12@@0 (|i#$Integer| call3formal@$ret0@0@@12)) (and (=> (= (ControlFlow 0 437601) 437617) inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Then_correct) (=> (= (ControlFlow 0 437601) 437607) inline$$Diem_cancel_burn_with_capability_$def$0$anon89_Else_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@0  (and (=> (= (ControlFlow 0 437591) (- 0 806558)) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))) (=> (= (ControlFlow 0 437591) 437601) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else$1_correct)))))
(let ((inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$pack_ref$0$$after@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 437543) 437591)) inline$$Diem_CurrencyInfo_$pack_ref$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else_correct  (=> (and (not (|b#$Boolean| inline$$Ge$0$dst@1@@0)) (= (ControlFlow 0 437595) 437543)) inline$$Diem_CurrencyInfo_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Else_correct  (=> (not $abort_flag@8@@0) (and (=> (= (ControlFlow 0 437468) 437827) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Then_correct) (=> (= (ControlFlow 0 437468) 437595) inline$$Diem_cancel_burn_with_capability_$def$0$anon88_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else$2_correct  (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8@@0)) (and (=> $abort_flag@8@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@12 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@12) (>= (|i#$Integer| call3formal@$ret0@0@@12) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@12) $MAX_U64))) (and (=> (= (ControlFlow 0 437462) 440242) inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Then_correct) (=> (= (ControlFlow 0 437462) 437468) inline$$Diem_cancel_burn_with_capability_$def$0$anon86_Else_correct)))))
(let ((inline$$Ge$0$anon0_correct@@0  (=> (and (= inline$$Ge$0$dst@1@@0 ($Boolean (>= (|i#$Integer| inline$$ReadRef$1$v@1@@0) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@0)))) (= (ControlFlow 0 437450) 437462)) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else$2_correct)))
(let ((inline$$Ge$0$Entry_correct@@0  (and (=> (= (ControlFlow 0 437436) (- 0 806448)) true) (=> (= (ControlFlow 0 437436) 437450) inline$$Ge$0$anon0_correct@@0))))
(let ((inline$$ReadRef$1$anon0_correct@@0  (=> (and (= inline$$ReadRef$1$v@1@@0 (|v#$Mutation| inline$$BorrowField$1$dst@1@@0)) (= (ControlFlow 0 437378) 437436)) inline$$Ge$0$Entry_correct@@0)))
(let ((inline$$BorrowField$1$anon0_correct@@0  (=> (= inline$$BorrowField$1$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (=> (and (and (= inline$$BorrowField$1$size@1@@0 (|size#$Path| inline$$BorrowField$1$p@1@@0)) (= inline$$BorrowField$1$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@0) inline$$BorrowField$1$size@1@@0 $Diem_CurrencyInfo_preburn_value) (+ inline$$BorrowField$1$size@1@@0 1)))) (and (= inline$$BorrowField$1$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@0) inline$$BorrowField$1$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0))) $Diem_CurrencyInfo_preburn_value))) (= (ControlFlow 0 437340) 437378))) inline$$ReadRef$1$anon0_correct@@0))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 437392) 437340)) inline$$BorrowField$1$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct  (=> (and (and $abort_flag@7@@0 (= $abort_code@14@@0 $abort_code@10@@0)) (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440262) 435555))) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct)))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 437148) 440262) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 437148) 437392) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 437158) 440262) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Then_correct) (=> (= (ControlFlow 0 437158) 437392) inline$$Diem_cancel_burn_with_capability_$def$0$anon85_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@0  (=> (= inline$$GetFieldFromValue$0$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 437132) 437158) inline$$Diem_value_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 437132) 437148) inline$$Diem_value_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 437056) 437132)) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 437166) 437132) inline$$GetFieldFromValue$0$anon0_correct@@0)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@0  (=> (not $abort_flag@7@@0) (and (=> (= (ControlFlow 0 437050) 437166) inline$$Diem_value_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 437050) 437056) inline$$Diem_value_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$Diem_value$0$anon0_correct@@0  (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@93 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@93 (|l#$ValueArray| va@@93)))
 (and (and (<= 0 l@@93) (<= l@@93 $MAX_U64)) (forall ((x@@93 Int) ) (!  (=> (or (< x@@93 0) (>= x@@93 l@@93)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@93) x@@93))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 437172) 437050)) inline$$Diem_value_$def$0$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@0  (=> (and (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0)) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0)) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000))))))))) (= (ControlFlow 0 436884) 437172)) inline$$Diem_value$0$anon0_correct@@0)))
(let ((inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$Diem_CurrencyInfo_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@0)) (= (ControlFlow 0 436878) 436884)) inline$$Diem_CurrencyInfo_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct  (=> (and (not $abort_flag@7@@0) (= (ControlFlow 0 436888) 436878)) inline$$Diem_CurrencyInfo_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@0  (=> (= $abort_flag@7@@0 true) (=> (and (= $abort_code@10@@0 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@0@@0)) (and (=> (= (ControlFlow 0 436838) 440266) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 436838) 436888) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1@@0)) (= (ControlFlow 0 436836) 436838)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) inline$$BorrowGlobal$1$ta@0 inline$$BorrowGlobal$1$a@1@@0))) (= $abort_flag@7@@0 $abort_flag@6@@0)) (and (= $abort_code@10@@0 $abort_code@9@@0) (= inline$$BorrowGlobal$1$dst@2@@0 inline$$BorrowGlobal$1$dst@1@@0))) (and (=> (= (ControlFlow 0 436784) 440266) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Then_correct) (=> (= (ControlFlow 0 436784) 436888) inline$$Diem_cancel_burn_with_capability_$def$0$anon83_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@0  (=> (= inline$$BorrowGlobal$1$a@1@@0 (|a#$Address| inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0)) (and (=> (= (ControlFlow 0 436754) 436836) inline$$BorrowGlobal$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 436754) 436784) inline$$BorrowGlobal$1$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@0  (=> (= inline$$BorrowGlobal$1$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 436748) (- 0 806139)) true) (=> (= (ControlFlow 0 436748) 436754) inline$$BorrowGlobal$1$anon0_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 436844) 436748)) inline$$BorrowGlobal$1$Entry_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct  (=> (and (and $abort_flag@6@@0 (= $abort_code@14@@0 $abort_code@9@@0)) (and (= $Diem_Preburn_$memory@0@@0 |inline$$WritebackToGlobal$0$m'@2@@0|) (= (ControlFlow 0 440286) 435555))) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct)))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 436605) 440286) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 436605) 436844) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct)))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 436615) 440286) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Then_correct) (=> (= (ControlFlow 0 436615) 436844) inline$$Diem_cancel_burn_with_capability_$def$0$anon82_Else_correct))))
(let ((inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@6@@0) (= inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 436599) 436615) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 436599) 436605) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Else_correct  (=> (and (not $abort_flag@6@@0) (= (ControlFlow 0 436629) 436599)) inline$$CoreAddresses_CURRENCY_INFO_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@6@@0) (=> $abort_flag@6@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@6@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@9@@0 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@6@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@11 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@11) (let ((va@@94 (|v#$Vector| call3formal@$ret0@0@@11)))
(let ((l@@94 (|l#$ValueArray| va@@94)))
 (and (and (<= 0 l@@94) (<= l@@94 $MAX_U64)) (forall ((x@@94 Int) ) (!  (=> (or (< x@@94 0) (>= x@@94 l@@94)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@94) x@@94))
)))))) (forall (($$0@@19 Int) ) (!  (=> (and (>= $$0@@19 0) (< $$0@@19 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) $$0@@19)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) $$0@@19)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) $$0@@19)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@11)) $$0@@19))
)))) (and (=> (= (ControlFlow 0 436494) 440290) inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Then_correct) (=> (= (ControlFlow 0 436494) 436629) inline$$Diem_cancel_burn_with_capability_$def$0$anon80_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Else_correct  (=> (and (not true) (= (ControlFlow 0 436492) 436494)) inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Then_correct  (=> (= (ControlFlow 0 440314) 436494) inline$$Diem_cancel_burn_with_capability_$def$0$anon26_correct)))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@0  (=> (and (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0)) (= |inline$$WritebackToGlobal$0$m'@2@@0| $Diem_Preburn_$memory)) (and (=> (= (ControlFlow 0 436390) 440314) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 436390) 436492) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Else_correct)))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@0  (=> (and ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@0) (= inline$$WritebackToGlobal$0$ta@1@@0 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@0))) (=> (and (and (= inline$$WritebackToGlobal$0$a@1@@0 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@0)) (= inline$$WritebackToGlobal$0$v@1@@0 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)))) (and (= |inline$$WritebackToGlobal$0$m'@1@@0| ($Memory (|domain#$Memory| $Diem_Preburn_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$WritebackToGlobal$0$ta@1@@0 inline$$WritebackToGlobal$0$a@1@@0 inline$$WritebackToGlobal$0$v@1@@0))) (= |inline$$WritebackToGlobal$0$m'@2@@0| |inline$$WritebackToGlobal$0$m'@1@@0|))) (and (=> (= (ControlFlow 0 436444) 440314) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Then_correct) (=> (= (ControlFlow 0 436444) 436492) inline$$Diem_cancel_burn_with_capability_$def$0$anon79_Else_correct))))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@0  (=> (= inline$$WritebackToGlobal$0$l@1@@0 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@0|)) (and (=> (= (ControlFlow 0 436380) 436444) inline$$WritebackToGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 436380) 436390) inline$$WritebackToGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@0  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@0| inline$$BorrowGlobal$0$dst@2@@0) (= (ControlFlow 0 436202) 436380)) inline$$WritebackToGlobal$0$anon0_correct@@0))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@0  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@0))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@0 inline$$WritebackToReference$0$srcPath@1@@0)) (= |inline$$WritebackToReference$0$dst'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$WritebackToReference$0$dstPath@1@@0 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@0 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@0) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@0|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@0| |inline$$WritebackToReference$0$dst'@1@@0|) (= (ControlFlow 0 436258) 436380))) inline$$WritebackToGlobal$0$anon0_correct@@0)))
(let ((inline$$WritebackToReference$0$anon0_correct@@0  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@0 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@0|)) (= inline$$WritebackToReference$0$dstPath@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) (and (=> (= (ControlFlow 0 436166) 436258) inline$$WritebackToReference$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 436166) 436202) inline$$WritebackToReference$0$anon3_Else_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct  (=> (and (not true) (= (ControlFlow 0 436029) 436166)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct  (=> (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@2 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (= (ControlFlow 0 440324) 436166)) inline$$WritebackToReference$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 436021) 440324) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 436021) 436029) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Then_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$trace_temp@1 (|v#$Mutation| inline$$Diem_cancel_burn_with_capability_$def$0$info@0)) (and (=> (= (ControlFlow 0 440334) 440324) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Then_correct) (=> (= (ControlFlow 0 440334) 436029) inline$$Diem_cancel_burn_with_capability_$def$0$anon78_Else_correct)))))
(let ((inline$$WriteRef$0$anon0_correct@@0  (=> (= |inline$$WriteRef$0$to'@1@@0| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@0) (|p#$Mutation| inline$$BorrowField$0$dst@1@@0) call5formal@$ret1@0)) (and (=> (= (ControlFlow 0 436007) 440334) inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Then_correct) (=> (= (ControlFlow 0 436007) 436021) inline$$Diem_cancel_burn_with_capability_$def$0$anon77_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Else_correct  (=> (and (not $abort_flag@5@@0) (= (ControlFlow 0 436013) 436007)) inline$$WriteRef$0$anon0_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else$2_correct  (and (=> (= (ControlFlow 0 435950) (- 0 805522)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@5@@0) (=> $abort_flag@5@@0 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@0)) $Diem_Diem_value))))) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value) ($Integer 0))))))) (=> (and (and (and (and (and ((_ is $Vector) call4formal@$ret0@0) (let ((va@@95 (|v#$Vector| call4formal@$ret0@0)))
(let ((l@@95 (|l#$ValueArray| va@@95)))
 (and (and (<= 0 l@@95) (<= l@@95 $MAX_U64)) (forall ((x@@95 Int) ) (!  (=> (or (< x@@95 0) (>= x@@95 l@@95)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@95) x@@95))
)))))) (= (|l#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call4formal@$ret0@0)) $Diem_Diem_value)) $MAX_U64))) true) (and (and (and (and ((_ is $Vector) call5formal@$ret1@0) (let ((va@@96 (|v#$Vector| call5formal@$ret1@0)))
(let ((l@@96 (|l#$ValueArray| va@@96)))
 (and (and (<= 0 l@@96) (<= l@@96 $MAX_U64)) (forall ((x@@96 Int) ) (!  (=> (or (< x@@96 0) (>= x@@96 l@@96)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@96) x@@96))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret1@0)) $Diem_Diem_value)) $MAX_U64))) true)) (and (=> (= (ControlFlow 0 435950) 440338) inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Then_correct) (=> (= (ControlFlow 0 435950) 436013) inline$$Diem_cancel_burn_with_capability_$def$0$anon75_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct@@0  (=> (and (= inline$$ReadRef$0$v@1@@0 (|v#$Mutation| inline$$BorrowField$0$dst@1@@0)) (= (ControlFlow 0 435938) 435950)) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@0  (=> (= inline$$BorrowField$0$p@1@@0 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@0)) (=> (and (and (= inline$$BorrowField$0$size@1@@0 (|size#$Path| inline$$BorrowField$0$p@1@@0)) (= inline$$BorrowField$0$p@2@@0 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@0) inline$$BorrowField$0$size@1@@0 $Diem_Preburn_to_burn) (+ inline$$BorrowField$0$size@1@@0 1)))) (and (= inline$$BorrowField$0$dst@1@@0 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@0) inline$$BorrowField$0$p@2@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@0))) $Diem_Preburn_to_burn))) (= (ControlFlow 0 435900) 435938))) inline$$ReadRef$0$anon0_correct@@0))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct  (=> (and (not $abort_flag@4@@1) (= (ControlFlow 0 435906) 435900)) inline$$BorrowField$0$anon0_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_code@7@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@1 true) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@0@@0)) (and (=> (= (ControlFlow 0 435770) 440358) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 435770) 435906) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0)) (= (ControlFlow 0 435768) 435770)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@0 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) inline$$BorrowGlobal$0$ta@0@@0 inline$$BorrowGlobal$0$a@1@@0))) (= $abort_code@7@@0 $abort_code@5@@1)) (and (= $abort_flag@4@@1 $abort_flag@3@@1) (= inline$$BorrowGlobal$0$dst@2@@0 inline$$BorrowGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 435716) 440358) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Then_correct) (=> (= (ControlFlow 0 435716) 435906) inline$$Diem_cancel_burn_with_capability_$def$0$anon73_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@0  (=> (= inline$$BorrowGlobal$0$a@1@@0 (|a#$Address| preburn_address)) (and (=> (= (ControlFlow 0 435686) 435768) inline$$BorrowGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 435686) 435716) inline$$BorrowGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@0  (=> (= inline$$BorrowGlobal$0$ta@0@@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 435680) (- 0 805337)) true) (=> (= (ControlFlow 0 435680) 435686) inline$$BorrowGlobal$0$anon0_correct@@0)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1) (= (ControlFlow 0 435776) 435680)) inline$$BorrowGlobal$0$Entry_correct@@0)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct  (=> (= $abort_code@14@@0 $abort_code@6@@1) (=> (and (= $Diem_Preburn_$memory@0@@0 $Diem_Preburn_$memory) (= (ControlFlow 0 435549) 435555)) inline$$Diem_cancel_burn_with_capability_$def$0$Abort_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 435547) 435549)) inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Then_correct  (=> (= (ControlFlow 0 435563) 435549) inline$$Diem_cancel_burn_with_capability_$def$0$anon12_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1)) (= $abort_code@6@@1 (|i#$Integer| call3formal@$ret0@0@@13))) (and (=> (= (ControlFlow 0 435541) 435563) inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Then_correct) (=> (= (ControlFlow 0 435541) 435547) inline$$Diem_cancel_burn_with_capability_$def$0$anon72_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Else_correct  (=> (not $abort_flag@3@@1) (and (=> (= (ControlFlow 0 435529) 435776) inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Then_correct) (=> (= (ControlFlow 0 435529) 435541) inline$$Diem_cancel_burn_with_capability_$def$0$anon71_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct  (=> (= inline$$Diem_cancel_burn_with_capability_$def$0$$t12@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| preburn_address)))) (=> (and (and (and (= inline$$Diem_cancel_burn_with_capability_$def$0$$t13@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@1)) (and (=> $abort_flag@3@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@13 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@13) (>= (|i#$Integer| call3formal@$ret0@0@@13) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@13) $MAX_U64))) (and (=> (= (ControlFlow 0 435523) 440378) inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Then_correct) (=> (= (ControlFlow 0 435523) 435529) inline$$Diem_cancel_burn_with_capability_$def$0$anon69_Else_correct))))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 435463) 435523)) inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct  (=> (= (ControlFlow 0 440402) 435523) inline$$Diem_cancel_burn_with_capability_$def$0$anon4$1_correct)))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 435455) 440402) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 435455) 435463) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Then_correct  (and (=> (= (ControlFlow 0 440410) 440402) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Then_correct) (=> (= (ControlFlow 0 440410) 435463) inline$$Diem_cancel_burn_with_capability_$def$0$anon68_Else_correct))))
(let ((inline$$Diem_cancel_burn_with_capability_$def$0$anon0_correct  (=> (not $abort_flag@2@@1) (and (=> (= (ControlFlow 0 435449) 440410) inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Then_correct) (=> (= (ControlFlow 0 435449) 435455) inline$$Diem_cancel_burn_with_capability_$def$0$anon67_Else_correct)))))
(let ((inline$$Diem_cancel_burn_with_capability$0$anon0_correct  (=> ((_ is $Address) preburn_address) (=> (and (and (and (and (and ((_ is $Vector) inline$$GetGlobal$0$dst@2) (let ((va@@97 (|v#$Vector| inline$$GetGlobal$0$dst@2)))
(let ((l@@97 (|l#$ValueArray| va@@97)))
 (and (and (<= 0 l@@97) (<= l@@97 $MAX_U64)) (forall ((x@@97 Int) ) (!  (=> (or (< x@@97 0) (>= x@@97 l@@97)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@97) x@@97))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@2)) $Diem_BurnCapability_dummy_field))) true) (= (ControlFlow 0 440416) 435449)) inline$$Diem_cancel_burn_with_capability_$def$0$anon0_correct))))
(let ((inline$$Diem_cancel_burn_$def$0$anon33_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 440424) 440416)) inline$$Diem_cancel_burn_with_capability$0$anon0_correct)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@0  (=> (= $abort_flag@2@@1 true) (=> (and (= $abort_code@4@@1 $EXEC_FAILURE_CODE) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 434220) 440458) inline$$Diem_cancel_burn_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 434220) 440424) inline$$Diem_cancel_burn_$def$0$anon33_Else_correct))))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@0  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1@@0)) (= (ControlFlow 0 434218) 434220)) inline$$GetGlobal$0$anon3_Then$1_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@0  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0 inline$$GetGlobal$0$a@1@@0) (=> (and (and (= inline$$GetGlobal$0$dst@1@@0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) inline$$GetGlobal$0$ta@0 (|a#$Address| call3formal@$ret0@0@@14))) (= $abort_flag@2@@1 $abort_flag@1@@1)) (and (= $abort_code@4@@1 $abort_code@2@@1) (= inline$$GetGlobal$0$dst@2 inline$$GetGlobal$0$dst@1@@0))) (and (=> (= (ControlFlow 0 434166) 440458) inline$$Diem_cancel_burn_$def$0$anon33_Then_correct) (=> (= (ControlFlow 0 434166) 440424) inline$$Diem_cancel_burn_$def$0$anon33_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct@@0  (=> (= inline$$GetGlobal$0$a@1@@0 (|a#$Address| call3formal@$ret0@0@@14)) (and (=> (= (ControlFlow 0 434148) 434218) inline$$GetGlobal$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 434148) 434166) inline$$GetGlobal$0$anon3_Else_correct@@0)))))
(let ((inline$$GetGlobal$0$Entry_correct@@0  (=> (= inline$$GetGlobal$0$ta@0 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1)) (and (=> (= (ControlFlow 0 434142) (- 0 804947)) true) (=> (= (ControlFlow 0 434142) 434148) inline$$GetGlobal$0$anon0_correct@@0)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon31_Then_correct  (=> (and (|b#$Boolean| inline$$Diem_cancel_burn_$def$0$$t7@1) (= (ControlFlow 0 434226) 434142)) inline$$GetGlobal$0$Entry_correct@@0)))
(let ((inline$$Diem_cancel_burn_$def$0$anon16_correct  (=> (and (and (= $Diem_Preburn_$memory@2@@0 $Diem_Preburn_$memory) (= $abort_code@16@@0 $abort_code@3@@1)) (and (= $Diem_CurrencyInfo_$memory@2@@0 $Diem_CurrencyInfo_$memory) (= (ControlFlow 0 434021) 434027))) inline$$Diem_cancel_burn_$def$0$Abort_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon32_Else_correct  (=> (and (not true) (= (ControlFlow 0 434019) 434021)) inline$$Diem_cancel_burn_$def$0$anon16_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon32_Then_correct  (=> (= (ControlFlow 0 434035) 434021) inline$$Diem_cancel_burn_$def$0$anon16_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon31_Else_correct  (=> (and (not (|b#$Boolean| inline$$Diem_cancel_burn_$def$0$$t7@1)) (= $abort_code@3@@1 (|i#$Integer| call3formal@$ret0@0@@15))) (and (=> (= (ControlFlow 0 434013) 434035) inline$$Diem_cancel_burn_$def$0$anon32_Then_correct) (=> (= (ControlFlow 0 434013) 434019) inline$$Diem_cancel_burn_$def$0$anon32_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon29_Else_correct  (=> (not $abort_flag@1@@1) (and (=> (= (ControlFlow 0 434001) 434226) inline$$Diem_cancel_burn_$def$0$anon31_Then_correct) (=> (= (ControlFlow 0 434001) 434013) inline$$Diem_cancel_burn_$def$0$anon31_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon27_Else_correct  (=> (and (not $abort_flag@0@@1) (= inline$$Diem_cancel_burn_$def$0$$t7@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@14) 1) (|a#$Address| call3formal@$ret0@0@@14))))) (=> (and (and (and (= inline$$Diem_cancel_burn_$def$0$$t8@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@15 ($Integer 4))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@15) (>= (|i#$Integer| call3formal@$ret0@0@@15) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@15) $MAX_U64))) (and (=> (= (ControlFlow 0 433995) 440478) inline$$Diem_cancel_burn_$def$0$anon29_Then_correct) (=> (= (ControlFlow 0 433995) 434001) inline$$Diem_cancel_burn_$def$0$anon29_Else_correct))))))
(let ((inline$$Diem_cancel_burn_$def$0$anon4$2_correct  (=> (and (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@0@@1) (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean false)))) (and (=> (not $abort_flag@0@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@14 account@@0)))) ((_ is $Address) call3formal@$ret0@0@@14))) (and (=> (= (ControlFlow 0 433965) 440498) inline$$Diem_cancel_burn_$def$0$anon27_Then_correct) (=> (= (ControlFlow 0 433965) 433995) inline$$Diem_cancel_burn_$def$0$anon27_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 433895) 433965)) inline$$Diem_cancel_burn_$def$0$anon4$2_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon26_Then_correct  (=> (= (ControlFlow 0 440522) 433965) inline$$Diem_cancel_burn_$def$0$anon4$2_correct)))
(let ((inline$$Diem_cancel_burn_$def$0$anon25_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 433887) 440522) inline$$Diem_cancel_burn_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 433887) 433895) inline$$Diem_cancel_burn_$def$0$anon26_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$def$0$anon25_Then_correct  (and (=> (= (ControlFlow 0 440530) 440522) inline$$Diem_cancel_burn_$def$0$anon26_Then_correct) (=> (= (ControlFlow 0 440530) 433895) inline$$Diem_cancel_burn_$def$0$anon26_Else_correct))))
(let ((inline$$Diem_cancel_burn_$def$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 433881) 440530) inline$$Diem_cancel_burn_$def$0$anon25_Then_correct) (=> (= (ControlFlow 0 433881) 433887) inline$$Diem_cancel_burn_$def$0$anon25_Else_correct)))))
(let ((inline$$Diem_cancel_burn_$direct_inter$0$anon0_correct  (=> ((_ is $Address) account@@0) (=> (and ((_ is $Address) preburn_address) (= (ControlFlow 0 440536) 433881)) inline$$Diem_cancel_burn_$def$0$anon0_correct))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Else_correct  (=> (and (not true) (= (ControlFlow 0 433283) 440536)) inline$$Diem_cancel_burn_$direct_inter$0$anon0_correct)))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Then_correct  (=> (= (ControlFlow 0 440614) 440536) inline$$Diem_cancel_burn_$direct_inter$0$anon0_correct)))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon11_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 433275) 440614) inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 433275) 433283) inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Else_correct)))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon11_Then_correct  (and (=> (= (ControlFlow 0 440622) 440614) inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Then_correct) (=> (= (ControlFlow 0 440622) 433283) inline$$DiemAccount_cancel_burn_$def_verify$0$anon12_Else_correct))))
(let ((inline$$DiemAccount_cancel_burn_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 433269) 440622) inline$$DiemAccount_cancel_burn_$def_verify$0$anon11_Then_correct) (=> (= (ControlFlow 0 433269) 433275) inline$$DiemAccount_cancel_burn_$def_verify$0$anon11_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (and (forall (($inv_addr@@20 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20)) (let ((va@@98 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))))
(let ((l@@98 (|l#$ValueArray| va@@98)))
 (and (and (<= 0 l@@98) (<= l@@98 $MAX_U64)) (forall ((x@@98 Int) ) (!  (=> (or (< x@@98 0) (>= x@@98 l@@98)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@98) x@@98))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@20))
)) (forall (($inv_addr@@21 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@21)) (let ((va@@99 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@21))))
(let ((l@@99 (|l#$ValueArray| va@@99)))
 (and (and (<= 0 l@@99) (<= l@@99 $MAX_U64)) (forall ((x@@99 Int) ) (!  (=> (or (< x@@99 0) (>= x@@99 l@@99)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@99) x@@99))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@21))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@21))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@21))
))) (=> (and (and (and (and (forall (($inv_addr@@22 Int) ($inv_tv0@@5 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22)) (let ((va@@100 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))))
(let ((l@@100 (|l#$ValueArray| va@@100)))
 (and (and (<= 0 l@@100) (<= l@@100 $MAX_U64)) (forall ((x@@100 Int) ) (!  (=> (or (< x@@100 0) (>= x@@100 l@@100)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@100) x@@100))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@5) 1) $inv_addr@@22))
)) (forall (($inv_addr@@23 Int) ($inv_tv0@@6 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23)) (let ((va@@101 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))))
(let ((l@@101 (|l#$ValueArray| va@@101)))
 (and (and (<= 0 l@@101) (<= l@@101 $MAX_U64)) (forall ((x@@101 Int) ) (!  (=> (or (< x@@101 0) (>= x@@101 l@@101)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@101) x@@101))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@6) 1) $inv_addr@@23))
))) (and (forall (($inv_addr@@24 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24)) (let ((va@@102 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))))
(let ((l@@102 (|l#$ValueArray| va@@102)))
 (and (and (<= 0 l@@102) (<= l@@102 $MAX_U64)) (forall ((x@@102 Int) ) (!  (=> (or (< x@@102 0) (>= x@@102 l@@102)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@102) x@@102))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@24))
)) (forall (($inv_addr@@25 Int) ($inv_tv0@@7 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25)) (let ((va@@103 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))))
(let ((l@@103 (|l#$ValueArray| va@@103)))
 (and (and (<= 0 l@@103) (<= l@@103 $MAX_U64)) (forall ((x@@103 Int) ) (!  (=> (or (< x@@103 0) (>= x@@103 l@@103)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@103) x@@103))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@7) 1) $inv_addr@@25))
)))) (and (and (forall (($inv_addr@@26 Int) ($inv_tv0@@8 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26)) (let ((va@@104 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))))
(let ((l@@104 (|l#$ValueArray| va@@104)))
 (and (and (<= 0 l@@104) (<= l@@104 $MAX_U64)) (forall ((x@@104 Int) ) (!  (=> (or (< x@@104 0) (>= x@@104 l@@104)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@104) x@@104))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))) $Diem_BurnCapability_dummy_field))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@8) 1) $inv_addr@@26))
)) (forall (($inv_addr@@27 Int) ($inv_tv0@@9 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27)) (let ((va@@105 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))))
(let ((l@@105 (|l#$ValueArray| va@@105)))
 (and (and (<= 0 l@@105) (<= l@@105 $MAX_U64)) (forall ((x@@105 Int) ) (!  (=> (or (< x@@105 0) (>= x@@105 l@@105)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@105) x@@105))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@106 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@106 (|l#$ValueArray| va@@106)))
 (and (and (<= 0 l@@106) (<= l@@106 $MAX_U64)) (forall ((x@@106 Int) ) (!  (=> (or (< x@@106 0) (>= x@@106 l@@106)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@106) x@@106))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code)) (let ((va@@107 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@107 (|l#$ValueArray| va@@107)))
 (and (and (<= 0 l@@107) (<= l@@107 $MAX_U64)) (forall ((x@@107 Int) ) (!  (=> (or (< x@@107 0) (>= x@@107 l@@107)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@107) x@@107))
))))))) (forall (($$0@@20 Int) ) (!  (=> (and (>= $$0@@20 0) (< $$0@@20 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@20)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@20)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@20)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_currency_code))) $$0@@20))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events)) (let ((va@@108 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@108 (|l#$ValueArray| va@@108)))
 (and (and (<= 0 l@@108) (<= l@@108 $MAX_U64)) (forall ((x@@108 Int) ) (!  (=> (or (< x@@108 0) (>= x@@108 l@@108)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@108) x@@108))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@109 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@109 (|l#$ValueArray| va@@109)))
 (and (and (<= 0 l@@109) (<= l@@109 $MAX_U64)) (forall ((x@@109 Int) ) (!  (=> (or (< x@@109 0) (>= x@@109 l@@109)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@109) x@@109))
))))))) (forall (($$0@@21 Int) ) (!  (=> (and (>= $$0@@21 0) (< $$0@@21 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@21)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@21)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@21)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@21))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events)) (let ((va@@110 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@110 (|l#$ValueArray| va@@110)))
 (and (and (<= 0 l@@110) (<= l@@110 $MAX_U64)) (forall ((x@@110 Int) ) (!  (=> (or (< x@@110 0) (>= x@@110 l@@110)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@110) x@@110))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@111 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@111 (|l#$ValueArray| va@@111)))
 (and (and (<= 0 l@@111) (<= l@@111 $MAX_U64)) (forall ((x@@111 Int) ) (!  (=> (or (< x@@111 0) (>= x@@111 l@@111)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@111) x@@111))
))))))) (forall (($$0@@22 Int) ) (!  (=> (and (>= $$0@@22 0) (< $$0@@22 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@22)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@22)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@22)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@22))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@112 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@112 (|l#$ValueArray| va@@112)))
 (and (and (<= 0 l@@112) (<= l@@112 $MAX_U64)) (forall ((x@@112 Int) ) (!  (=> (or (< x@@112 0) (>= x@@112 l@@112)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@112) x@@112))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@113 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@113 (|l#$ValueArray| va@@113)))
 (and (and (<= 0 l@@113) (<= l@@113 $MAX_U64)) (forall ((x@@113 Int) ) (!  (=> (or (< x@@113 0) (>= x@@113 l@@113)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@113) x@@113))
))))))) (forall (($$0@@23 Int) ) (!  (=> (and (>= $$0@@23 0) (< $$0@@23 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@23)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@23)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@23)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@23))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@114 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@114 (|l#$ValueArray| va@@114)))
 (and (and (<= 0 l@@114) (<= l@@114 $MAX_U64)) (forall ((x@@114 Int) ) (!  (=> (or (< x@@114 0) (>= x@@114 l@@114)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@114) x@@114))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@115 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@115 (|l#$ValueArray| va@@115)))
 (and (and (<= 0 l@@115) (<= l@@115 $MAX_U64)) (forall ((x@@115 Int) ) (!  (=> (or (< x@@115 0) (>= x@@115 l@@115)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@115) x@@115))
))))))) (forall (($$0@@24 Int) ) (!  (=> (and (>= $$0@@24 0) (< $$0@@24 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@24)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@24)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@24)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@24))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@116 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@116 (|l#$ValueArray| va@@116)))
 (and (and (<= 0 l@@116) (<= l@@116 $MAX_U64)) (forall ((x@@116 Int) ) (!  (=> (or (< x@@116 0) (>= x@@116 l@@116)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@116) x@@116))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@117 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@117 (|l#$ValueArray| va@@117)))
 (and (and (<= 0 l@@117) (<= l@@117 $MAX_U64)) (forall ((x@@117 Int) ) (!  (=> (or (< x@@117 0) (>= x@@117 l@@117)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@117) x@@117))
))))))) (forall (($$0@@25 Int) ) (!  (=> (and (>= $$0@@25 0) (< $$0@@25 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@25)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@25)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@25)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@25))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@9) 1) $inv_addr@@27))
))) (and (forall (($inv_addr@@28 Int) ($inv_tv0@@10 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28)) (let ((va@@118 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))))
(let ((l@@118 (|l#$ValueArray| va@@118)))
 (and (and (<= 0 l@@118) (<= l@@118 $MAX_U64)) (forall ((x@@118 Int) ) (!  (=> (or (< x@@118 0) (>= x@@118 l@@118)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@118) x@@118))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn)) (let ((va@@119 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))))
(let ((l@@119 (|l#$ValueArray| va@@119)))
 (and (and (<= 0 l@@119) (<= l@@119 $MAX_U64)) (forall ((x@@119 Int) ) (!  (=> (or (< x@@119 0) (>= x@@119 l@@119)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@119) x@@119))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))) $Diem_Preburn_to_burn))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@10) 1) $inv_addr@@28))
)) (forall (($inv_addr@@29 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@29)) (let ((va@@120 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@29))))
(let ((l@@120 (|l#$ValueArray| va@@120)))
 (and (and (<= 0 l@@120) (<= l@@120 $MAX_U64)) (forall ((x@@120 Int) ) (!  (=> (or (< x@@120 0) (>= x@@120 l@@120)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@120) x@@120))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@29))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@29))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@29))
))))) (and (and (and (forall (($inv_addr@@30 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30)) (let ((va@@121 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))))
(let ((l@@121 (|l#$ValueArray| va@@121)))
 (and (and (<= 0 l@@121) (<= l@@121 $MAX_U64)) (forall ((x@@121 Int) ) (!  (=> (or (< x@@121 0) (>= x@@121 l@@121)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@121) x@@121))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@30))
)) (forall (($inv_addr@@31 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31)) (let ((va@@122 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))))
(let ((l@@122 (|l#$ValueArray| va@@122)))
 (and (and (<= 0 l@@122) (<= l@@122 $MAX_U64)) (forall ((x@@122 Int) ) (!  (=> (or (< x@@122 0) (>= x@@122 l@@122)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@122) x@@122))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name)) (let ((va@@123 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))))
(let ((l@@123 (|l#$ValueArray| va@@123)))
 (and (and (<= 0 l@@123) (<= l@@123 $MAX_U64)) (forall ((x@@123 Int) ) (!  (=> (or (< x@@123 0) (>= x@@123 l@@123)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@123) x@@123))
))))))) (forall (($$0@@26 Int) ) (!  (=> (and (>= $$0@@26 0) (< $$0@@26 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))) $$0@@26)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))) $$0@@26)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))) $$0@@26)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_human_name))) $$0@@26))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url)) (let ((va@@124 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))))
(let ((l@@124 (|l#$ValueArray| va@@124)))
 (and (and (<= 0 l@@124) (<= l@@124 $MAX_U64)) (forall ((x@@124 Int) ) (!  (=> (or (< x@@124 0) (>= x@@124 l@@124)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@124) x@@124))
))))))) (forall (($$0@@27 Int) ) (!  (=> (and (>= $$0@@27 0) (< $$0@@27 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))) $$0@@27)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))) $$0@@27)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))) $$0@@27)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url))) $$0@@27))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@125 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@125 (|l#$ValueArray| va@@125)))
 (and (and (<= 0 l@@125) (<= l@@125 $MAX_U64)) (forall ((x@@125 Int) ) (!  (=> (or (< x@@125 0) (>= x@@125 l@@125)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@125) x@@125))
))))))) (forall (($$0@@28 Int) ) (!  (=> (and (>= $$0@@28 0) (< $$0@@28 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))) $$0@@28)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))) $$0@@28)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))) $$0@@28)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_public_key))) $$0@@28))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@126 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@126 (|l#$ValueArray| va@@126)))
 (and (and (<= 0 l@@126) (<= l@@126 $MAX_U64)) (forall ((x@@126 Int) ) (!  (=> (or (< x@@126 0) (>= x@@126 l@@126)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@126) x@@126))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@127 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@127 (|l#$ValueArray| va@@127)))
 (and (and (<= 0 l@@127) (<= l@@127 $MAX_U64)) (forall ((x@@127 Int) ) (!  (=> (or (< x@@127 0) (>= x@@127 l@@127)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@127) x@@127))
))))))) (forall (($$0@@29 Int) ) (!  (=> (and (>= $$0@@29 0) (< $$0@@29 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@29)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@29)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@29)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@29))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@128 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@128 (|l#$ValueArray| va@@128)))
 (and (and (<= 0 l@@128) (<= l@@128 $MAX_U64)) (forall ((x@@128 Int) ) (!  (=> (or (< x@@128 0) (>= x@@128 l@@128)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@128) x@@128))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@129 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@129 (|l#$ValueArray| va@@129)))
 (and (and (<= 0 l@@129) (<= l@@129 $MAX_U64)) (forall ((x@@129 Int) ) (!  (=> (or (< x@@129 0) (>= x@@129 l@@129)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@129) x@@129))
))))))) (forall (($$0@@30 Int) ) (!  (=> (and (>= $$0@@30 0) (< $$0@@30 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@30)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@30)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@30)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@30))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@31))
))) (and (forall (($inv_addr@@32 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32)) (let ((va@@130 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))))
(let ((l@@130 (|l#$ValueArray| va@@130)))
 (and (and (<= 0 l@@130) (<= l@@130 $MAX_U64)) (forall ((x@@130 Int) ) (!  (=> (or (< x@@130 0) (>= x@@130 l@@130)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@130) x@@130))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@32))
)) (forall (($inv_addr@@33 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33)) (let ((va@@131 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))))
(let ((l@@131 (|l#$ValueArray| va@@131)))
 (and (and (<= 0 l@@131) (<= l@@131 $MAX_U64)) (forall ((x@@131 Int) ) (!  (=> (or (< x@@131 0) (>= x@@131 l@@131)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@131) x@@131))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@132 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@132 (|l#$ValueArray| va@@132)))
 (and (and (<= 0 l@@132) (<= l@@132 $MAX_U64)) (forall ((x@@132 Int) ) (!  (=> (or (< x@@132 0) (>= x@@132 l@@132)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@132) x@@132))
))))))) (forall (($$0@@31 Int) ) (!  (=> (and (>= $$0@@31 0) (< $$0@@31 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))) $$0@@31)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))) $$0@@31)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))) $$0@@31)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_authentication_key))) $$0@@31))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@133 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@133 (|l#$ValueArray| va@@133)))
 (and (and (<= 0 l@@133) (<= l@@133 $MAX_U64)) (forall ((x@@133 Int) ) (!  (=> (or (< x@@133 0) (>= x@@133 l@@133)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@133) x@@133))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@134 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@134 (|l#$ValueArray| va@@134)))
 (and (and (<= 0 l@@134) (<= l@@134 $MAX_U64)) (forall ((x@@134 Int) ) (!  (=> (or (< x@@134 0) (>= x@@134 l@@134)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@134) x@@134))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@135 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@135 (|l#$ValueArray| va@@135)))
 (and (and (<= 0 l@@135) (<= l@@135 $MAX_U64)) (forall ((x@@135 Int) ) (!  (=> (or (< x@@135 0) (>= x@@135 l@@135)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@135) x@@135))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@136 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@136 (|l#$ValueArray| va@@136)))
 (and (and (<= 0 l@@136) (<= l@@136 $MAX_U64)) (forall ((x@@136 Int) ) (!  (=> (or (< x@@136 0) (>= x@@136 l@@136)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@136) x@@136))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events)) (let ((va@@137 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@137 (|l#$ValueArray| va@@137)))
 (and (and (<= 0 l@@137) (<= l@@137 $MAX_U64)) (forall ((x@@137 Int) ) (!  (=> (or (< x@@137 0) (>= x@@137 l@@137)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@137) x@@137))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@138 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@138 (|l#$ValueArray| va@@138)))
 (and (and (<= 0 l@@138) (<= l@@138 $MAX_U64)) (forall ((x@@138 Int) ) (!  (=> (or (< x@@138 0) (>= x@@138 l@@138)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@138) x@@138))
))))))) (forall (($$0@@32 Int) ) (!  (=> (and (>= $$0@@32 0) (< $$0@@32 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@32)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@32)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@32)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@32))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@139 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@139 (|l#$ValueArray| va@@139)))
 (and (and (<= 0 l@@139) (<= l@@139 $MAX_U64)) (forall ((x@@139 Int) ) (!  (=> (or (< x@@139 0) (>= x@@139 l@@139)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@139) x@@139))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@140 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@140 (|l#$ValueArray| va@@140)))
 (and (and (<= 0 l@@140) (<= l@@140 $MAX_U64)) (forall ((x@@140 Int) ) (!  (=> (or (< x@@140 0) (>= x@@140 l@@140)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@140) x@@140))
))))))) (forall (($$0@@33 Int) ) (!  (=> (and (>= $$0@@33 0) (< $$0@@33 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@33)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@33)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@33)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@33))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@33))
)))) (and (and (forall (($inv_addr@@34 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34)) (let ((va@@141 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))))
(let ((l@@141 (|l#$ValueArray| va@@141)))
 (and (and (<= 0 l@@141) (<= l@@141 $MAX_U64)) (forall ((x@@141 Int) ) (!  (=> (or (< x@@141 0) (>= x@@141 l@@141)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@141) x@@141))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@142 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@142 (|l#$ValueArray| va@@142)))
 (and (and (<= 0 l@@142) (<= l@@142 $MAX_U64)) (forall ((x@@142 Int) ) (!  (=> (or (< x@@142 0) (>= x@@142 l@@142)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@142) x@@142))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@143 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@143 (|l#$ValueArray| va@@143)))
 (and (and (<= 0 l@@143) (<= l@@143 $MAX_U64)) (forall ((x@@143 Int) ) (!  (=> (or (< x@@143 0) (>= x@@143 l@@143)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@143) x@@143))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@144 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@144 (|l#$ValueArray| va@@144)))
 (and (and (<= 0 l@@144) (<= l@@144 $MAX_U64)) (forall ((x@@144 Int) ) (!  (=> (or (< x@@144 0) (>= x@@144 l@@144)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@144) x@@144))
))))))) (forall (($$0@@34 Int) ) (!  (=> (and (>= $$0@@34 0) (< $$0@@34 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@34)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@34)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@34)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@34))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@34))
)) (forall (($inv_addr@@35 Int) ($inv_tv0@@11 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35)) (let ((va@@145 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))))
(let ((l@@145 (|l#$ValueArray| va@@145)))
 (and (and (<= 0 l@@145) (<= l@@145 $MAX_U64)) (forall ((x@@145 Int) ) (!  (=> (or (< x@@145 0) (>= x@@145 l@@145)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@145) x@@145))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin)) (let ((va@@146 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin))))
(let ((l@@146 (|l#$ValueArray| va@@146)))
 (and (and (<= 0 l@@146) (<= l@@146 $MAX_U64)) (forall ((x@@146 Int) ) (!  (=> (or (< x@@146 0) (>= x@@146 l@@146)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@146) x@@146))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@11) 1) $inv_addr@@35))
))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen)))))))))))) (and (|b#$Boolean| ($Boolean (forall ((window_addr@@0 T@$Value) )  (=> ((_ is $Address) window_addr@@0) (|b#$Boolean| ($Boolean (forall ((coin_type@@7 T@$Value) )  (=> ((_ is $Type) coin_type@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| window_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@7)) 1) (|a#$Address| window_addr@@0)))) $AccountLimits_Window_limit_address)))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((coin_type@@8 T@$Value) )  (=> ((_ is $Type) coin_type@@8) (|b#$Boolean| ($Boolean (forall ((addr3@@0 T@$Value) )  (=> ((_ is $Address) addr3@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| addr3@@0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@8)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((coin_type@@9 T@$Value) )  (=> ((_ is $Type) coin_type@@9) (|b#$Boolean| ($Boolean (forall ((addr1@@5 T@$Value) )  (=> ((_ is $Address) addr1@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_BurnCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@9)) 1) (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@5)))) $Roles_RoleId_role_id) ($Integer 1))))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@10 T@$Value) )  (=> ((_ is $Type) coin_type@@10) (|b#$Boolean| ($Boolean (forall ((addr1@@6 T@$Value) )  (=> ((_ is $Address) addr1@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_Preburn_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@10)) 1) (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@6)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@32 T@$Value) )  (=> ((_ is $Address) addr@@32) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@32)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@32 ($Address 173345816))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@33 T@$Value) )  (=> ((_ is $Address) addr@@33) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr@@33)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@33 ($Address 173345816))))))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean (forall ((child_addr@@0 T@$Value) )  (=> ((_ is $Address) child_addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@7 T@$Value) )  (=> ((_ is $Address) addr1@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@7)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@34 T@$Value) )  (=> ((_ is $Address) addr@@34) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@34 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@34)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@35 T@$Value) )  (=> ((_ is $Address) addr@@35) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@35 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@35)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@36 T@$Value) )  (=> ((_ is $Address) addr@@36) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@36))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((token@@1 T@$Value) )  (=> ((_ is $Type) token@@1) (|b#$Boolean| ($Boolean (forall ((addr@@37 T@$Value) )  (=> ((_ is $Address) addr@@37) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token@@1)) 1) (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@37)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@38 T@$Value) )  (=> ((_ is $Address) addr@@38) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@38)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@39 T@$Value) )  (=> ((_ is $Address) addr@@39) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@39))))))))))) (= (ControlFlow 0 440626) 433269)))))) inline$$DiemAccount_cancel_burn_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@1  (=> ((_ is $Address) account@@0) (=> (and ((_ is $Address) preburn_address) (= (ControlFlow 0 431222) 440626)) anon0$1_correct@@1))))
(let ((PreconditionGeneratedEntry_correct@@1  (=> (= (ControlFlow 0 792048) 431222) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@1))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@15 () T@$TypeValue)
(declare-fun payee () T@$Value)
(declare-fun $abort_flag@16@@0 () Bool)
(declare-fun to_deposit () T@$Value)
(declare-fun payer@@0 () T@$Value)
(declare-fun metadata_signature () T@$Value)
(declare-fun metadata@@0 () T@$Value)
(declare-fun $abort_code@22@@0 () Int)
(declare-fun $DiemAccount_DiemAccount_$memory@0@@2 () T@$Memory)
(declare-fun $DiemAccount_Balance_$memory@1@@1 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2@@1| () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@3@@0 () T@$Memory)
(declare-fun $AccountLimits_Window_$memory@1@@1 () T@$Memory)
(declare-fun $abort_code@19@@1 () Int)
(declare-fun |inline$$WritebackToGlobal$0$m'@2@@1| () T@$Memory)
(declare-fun $abort_flag@15@@0 () Bool)
(declare-fun inline$$WritebackToGlobal$1$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$1$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1@@1| () T@$Memory)
(declare-fun inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$ReadRef$1$v@1@@1 () T@$Value)
(declare-fun $AccountLimits_Window_$memory@2@@1 () T@$Memory)
(declare-fun $abort_code@21@@0 () Int)
(declare-fun $DiemAccount_Balance_$memory@0@@1 () T@$Memory)
(declare-fun $abort_code@1@@2 () Int)
(declare-fun $abort_flag@0@@2 () Bool)
(declare-fun $abort_code@2@@2 () Int)
(declare-fun $abort_flag@1@@2 () Bool)
(declare-fun $abort_code@3@@2 () Int)
(declare-fun $abort_flag@2@@2 () Bool)
(declare-fun $abort_code@5@@2 () Int)
(declare-fun $abort_flag@3@@2 () Bool)
(declare-fun $abort_code@6@@2 () Int)
(declare-fun $abort_flag@4@@2 () Bool)
(declare-fun $abort_code@8@@1 () Int)
(declare-fun $abort_flag@5@@1 () Bool)
(declare-fun $abort_code@10@@1 () Int)
(declare-fun $abort_flag@6@@1 () Bool)
(declare-fun $abort_code@11@@1 () Int)
(declare-fun $abort_flag@7@@1 () Bool)
(declare-fun $abort_code@12@@1 () Int)
(declare-fun $abort_flag@8@@1 () Bool)
(declare-fun $abort_code@13@@1 () Int)
(declare-fun $AccountLimits_Window_$memory@0@@1 () T@$Memory)
(declare-fun $abort_flag@9@@1 () Bool)
(declare-fun $abort_code@14@@1 () Int)
(declare-fun $abort_flag@10@@1 () Bool)
(declare-fun $abort_code@20@@1 () Int)
(declare-fun call8formal@$ret0@0@@0 () T@$Value)
(declare-fun call3formal@$ret0@0@@16 () T@$Value)
(declare-fun $abort_code@16@@1 () Int)
(declare-fun $abort_flag@12@@1 () Bool)
(declare-fun $abort_code@17@@1 () Int)
(declare-fun $abort_flag@13@@1 () Bool)
(declare-fun $abort_code@18@@1 () Int)
(declare-fun $abort_flag@14@@0 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0@@1 () T@$TypeValue)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@17 () T@$Value)
(declare-fun inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$1$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1@@1 () Int)
(declare-fun inline$$BorrowField$1$p@2@@1 () T@$Path)
(declare-fun inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0 () T@$Value)
(declare-fun inline$$BorrowGlobal$1$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1@@1 () T@$Mutation)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$WritebackToGlobal$0$l@1@@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1@@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1@@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1@@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2@@1| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1@@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$0$dst@2@@1 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1@@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1@@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1@@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1@@1| () T@$Mutation)
(declare-fun inline$$BorrowField$0$dst@1@@1 () T@$Mutation)
(declare-fun call5formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1@@1 () T@$Value)
(declare-fun inline$$BorrowField$0$p@1@@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1@@1 () Int)
(declare-fun inline$$BorrowField$0$p@2@@1 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@0@@1 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$ta@0@@1 () T@$TypeValueArray)
(declare-fun inline$$BorrowGlobal$0$a@1@@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1@@1 () T@$Mutation)
(declare-fun $abort_code@15@@1 () Int)
(declare-fun $abort_flag@11@@1 () Bool)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_Balance_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t36@1 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun call3formal@$ret0@0@@18 () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(declare-fun call6formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t29@1 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t26@1 () T@$Value)
(declare-fun $abort_code@9@@1 () Int)
(declare-fun call3formal@$ret0@0@@19 () T@$Value)
(declare-fun inline$$DiemAccount_exists_at_$def$0$$t2@1@@0 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t27@1 () T@$Value)
(declare-fun $abort_code@7@@1 () Int)
(declare-fun call3formal@$ret0@0@@20 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t24@1 () T@$Value)
(declare-fun inline$$Gt$0$dst@1 () T@$Value)
(declare-fun $abort_code@4@@2 () Int)
(declare-fun call3formal@$ret0@0@@21 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$DiemAccount_deposit_$def_verify$0$$t19@1 () T@$Value)
(declare-fun $AccountLimits_Window_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemAccount_DiemAccount_$CallerDomain@@1 () |T@[$TypeValueArray,Int]Bool|)
(declare-fun $DiemAccount_Balance_$CallerDomain () |T@[$TypeValueArray,Int]Bool|)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 817864) (let ((anon0$2_correct@@2  (and (=> (= (ControlFlow 0 450111) (- 0 835485)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835515)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835531)) (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0)))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0)))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835550)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@180 (|l#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@181 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@181 1)))) len@@180 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@180 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@180 (|l#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@181 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@181 (|l#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@182 (|l#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@183 (|l#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@184 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@184 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@184 1)))) len@@183 ($Integer 0)) (+ len@@183 1)))) len@@182 ($Integer 0)) (+ len@@182 1)))) len@@181 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@181 1)))) len@@180 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@180 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@185 (|l#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@186 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@186 (|l#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@187 (|l#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@188 (|l#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@189 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@189 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@189 1)))) len@@188 ($Integer 0)) (+ len@@188 1)))) len@@187 ($Integer 0)) (+ len@@187 1)))) len@@186 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@186 1)))) len@@185 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@185 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835609)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835624)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835659)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835696)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835747)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835820)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835893)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@5) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@5 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@5 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@5) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@5 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 835978)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836053)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836114)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836197)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@190 (|l#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@191 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@191 1)))) len@@190 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@190 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@190 (|l#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@191 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@191 (|l#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@192 (|l#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@193 (|l#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@194 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@194 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@194 1)))) len@@193 ($Integer 0)) (+ len@@193 1)))) len@@192 ($Integer 0)) (+ len@@192 1)))) len@@191 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@191 1)))) len@@190 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@190 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836335)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@195 (|l#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1)))) len@@195 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@195 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@195 (|l#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@196 (|l#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@197 (|l#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@198 (|l#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@199 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@199 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@199 1)))) len@@198 ($Integer 0)) (+ len@@198 1)))) len@@197 ($Integer 0)) (+ len@@197 1)))) len@@196 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@196 1)))) len@@195 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@195 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836473)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836632)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836717)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836734)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836745)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@16@@0)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) $abort_flag@16@@0) (and (=> (= (ControlFlow 0 450111) (- 0 836783)) (=> $abort_flag@16@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@200 (|l#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1)))) len@@200 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@200 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@205 (|l#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1)))) len@@205 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@205 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@6) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@6 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@210 (|l#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1)))) len@@210 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@210 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (=> (=> $abort_flag@16@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@200 (|l#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@201 (|l#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@202 (|l#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@203 (|l#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@204 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@204 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@204 1)))) len@@203 ($Integer 0)) (+ len@@203 1)))) len@@202 ($Integer 0)) (+ len@@202 1)))) len@@201 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@201 1)))) len@@200 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@200 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@205 (|l#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@206 (|l#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@207 (|l#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@208 (|l#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@209 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@209 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@209 1)))) len@@208 ($Integer 0)) (+ len@@208 1)))) len@@207 ($Integer 0)) (+ len@@207 1)))) len@@206 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@206 1)))) len@@205 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@205 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@6 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@6) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@6 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@210 (|l#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@211 (|l#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@212 (|l#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@213 (|l#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@214 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@214 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@214 1)))) len@@213 ($Integer 0)) (+ len@@213 1)))) len@@212 ($Integer 0)) (+ len@@212 1)))) len@@211 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@211 1)))) len@@210 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@210 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@215 (|l#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@216 (|l#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@217 (|l#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@218 (|l#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@219 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@219 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@219 1)))) len@@218 ($Integer 0)) (+ len@@218 1)))) len@@217 ($Integer 0)) (+ len@@217 1)))) len@@216 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@216 1)))) len@@215 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@215 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))) (and (=> (= (ControlFlow 0 450111) (- 0 838061)) (=> $abort_flag@16@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@220 (|l#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1)))) len@@220 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@220 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@225 (|l#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@226 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@226 1)))) len@@225 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@225 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@7) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@7 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@230 (|l#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@231 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@231 1)))) len@@230 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@230 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@235 (|l#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@236 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@236 1)))) len@@235 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@235 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))))) (=> (=> $abort_flag@16@@0 (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) ($Integer 0)))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@220 (|l#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@221 (|l#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@222 (|l#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@223 (|l#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@224 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@224 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@224 1)))) len@@223 ($Integer 0)) (+ len@@223 1)))) len@@222 ($Integer 0)) (+ len@@222 1)))) len@@221 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@221 1)))) len@@220 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@220 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@225 (|l#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@226 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@226 (|l#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@227 (|l#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@228 (|l#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@229 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@229 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@229 1)))) len@@228 ($Integer 0)) (+ len@@228 1)))) len@@227 ($Integer 0)) (+ len@@227 1)))) len@@226 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@226 1)))) len@@225 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@225 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding))))))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@7 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@7) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@7 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@230 (|l#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@231 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@231 (|l#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@232 (|l#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@233 (|l#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@234 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@234 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@234 1)))) len@@233 ($Integer 0)) (+ len@@233 1)))) len@@232 ($Integer 0)) (+ len@@232 1)))) len@@231 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@231 1)))) len@@230 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@230 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@235 (|l#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@236 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@236 (|l#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@237 (|l#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@238 (|l#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@239 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@239 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@239 1)))) len@@238 ($Integer 0)) (+ len@@238 1)))) len@@237 ($Integer 0)) (+ len@@237 1)))) len@@236 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_tracked_balance)) (+ len@@236 1)))) len@@235 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address)) (+ len@@235 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean false)) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer $MAX_U64))))) (= $abort_code@22@@0 (|i#$Integer| ($Integer 8)))))) (and (=> (= (ControlFlow 0 450111) (- 0 839570)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| payee)))))) (=> (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| payee))))) (and (=> (= (ControlFlow 0 450111) (- 0 839584)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))))) (=> (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (and (=> (= (ControlFlow 0 450111) (- 0 839610)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| payee)))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $DiemAccount_DiemAccount_withdraw_capability)))))) (=> (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| payee)))) $DiemAccount_DiemAccount_withdraw_capability) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $DiemAccount_DiemAccount_withdraw_capability))))) (and (=> (= (ControlFlow 0 450111) (- 0 839643)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))))))) (=> (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))) (and (=> (= (ControlFlow 0 450111) (- 0 839682)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (forall ((addr@@40 T@$Value) )  (=> ((_ is $Address) addr@@40) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| addr@@40)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@40)))) $DiemAccount_DiemAccount_authentication_key))))))))))))) (=> (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (forall ((addr@@41 T@$Value) )  (=> ((_ is $Address) addr@@41) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory@0@@2) $EmptyTypeValueArray (|a#$Address| addr@@41)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@41)))) $DiemAccount_DiemAccount_authentication_key)))))))))))) (=> (= (ControlFlow 0 450111) (- 0 839741)) (=> (not $abort_flag@16@@0) (|b#$Boolean| ($Boolean (forall ((addr@@42 T@$Value) )  (=> ((_ is $Address) addr@@42) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@42)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory@1@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@42)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@42)))) $DiemAccount_Balance_coin))) $Diem_Diem_value))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon146_Else$4_correct  (and (=> (= (ControlFlow 0 449305) (- 0 834787)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_deposit_$def_verify$0$addr (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@0 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@0) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@0)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_deposit_$def_verify$0$addr@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@0)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address))))))))))))))))) (and (=> (= (ControlFlow 0 449305) (- 0 834833)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@1 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@1)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_deposit_$def_verify$0$addr@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@1)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address)))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@2 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@2) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@2)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@2)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@2)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified inline$$DiemAccount_deposit_$def_verify$0$addr@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@2)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (and (=> (= (ControlFlow 0 449305) (- 0 834879)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@3 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@3) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@3)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@3)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@4 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@4) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@4)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@4))))))))))) (and (=> (= (ControlFlow 0 449305) (- 0 834912)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@5 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@5) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@5)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@5)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@6 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@6) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@6)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@6))))))))))) (and (=> (= (ControlFlow 0 449305) (- 0 834948)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@7 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@7) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@7)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@7)))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@8 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2@@1|) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@8)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@8))))))))))) (=> (and (= $AccountLimits_Window_$memory@3@@0 $AccountLimits_Window_$memory@1@@1) (= $abort_code@22@@0 $abort_code@19@@1)) (=> (and (and (= $DiemAccount_Balance_$memory@1@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= $abort_flag@16@@0 $abort_flag@15@@0)) (and (= $DiemAccount_DiemAccount_$memory@0@@2 |inline$$WritebackToGlobal$1$m'@2@@1|) (= (ControlFlow 0 449305) 450111))) anon0$2_correct@@2))))))))))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2@@1| $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 449036) 449305)) inline$$DiemAccount_deposit_$def_verify$0$anon146_Else$4_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1@@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1@@1)) (= inline$$WritebackToGlobal$1$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$1$ta@1@@1 inline$$WritebackToGlobal$1$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|))) (= |inline$$WritebackToGlobal$1$m'@1@@1| ($Memory (|domain#$Memory| $DiemAccount_DiemAccount_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) inline$$WritebackToGlobal$1$ta@1@@1 inline$$WritebackToGlobal$1$a@1@@1 inline$$WritebackToGlobal$1$v@1@@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2@@1| |inline$$WritebackToGlobal$1$m'@1@@1|) (= (ControlFlow 0 449090) 449305))) inline$$DiemAccount_deposit_$def_verify$0$anon146_Else$4_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$1$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (and (=> (= (ControlFlow 0 449026) 449090) inline$$WritebackToGlobal$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 449026) 449036) inline$$WritebackToGlobal$1$anon3_Else_correct@@1)))))
(let ((inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemAccount_DiemAccount_$pack_ref$0$$after@0@@0 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2@@1|)) (= (ControlFlow 0 448902) 449026)) inline$$WritebackToGlobal$1$anon0_correct@@1)))
(let ((inline$$WritebackToReference$1$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2@@1| inline$$BorrowGlobal$1$dst@2@@1) (= (ControlFlow 0 448823) 448902)) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@0))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1@@1 inline$$WritebackToReference$1$srcPath@1@@1)) (= |inline$$WritebackToReference$1$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$WritebackToReference$1$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$1$to'@1@@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2@@1| |inline$$WritebackToReference$1$dst'@1@@1|) (= (ControlFlow 0 448879) 448902))) inline$$DiemAccount_DiemAccount_$pack_ref$0$Entry_correct@@0)))
(let ((inline$$WritebackToReference$1$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$1$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1@@1|)) (= inline$$WritebackToReference$1$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) (and (=> (= (ControlFlow 0 448787) 448879) inline$$WritebackToReference$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 448787) 448823) inline$$WritebackToReference$1$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$1$anon0_correct@@1  (=> (and (= |inline$$WriteRef$1$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1@@1) (|p#$Mutation| inline$$BorrowField$1$dst@1@@1) inline$$ReadRef$1$v@1@@1)) (= (ControlFlow 0 448644) 448787)) inline$$WritebackToReference$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon146_Else_correct  (=> (and (not $abort_flag@15@@0) (= (ControlFlow 0 448650) 448644)) inline$$WriteRef$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$Abort_correct  (=> (and (= $AccountLimits_Window_$memory@3@@0 $AccountLimits_Window_$memory@2@@1) (= $abort_code@22@@0 $abort_code@21@@0)) (=> (and (and (= $DiemAccount_Balance_$memory@1@@1 $DiemAccount_Balance_$memory@0@@1) (= $abort_flag@16@@0 true)) (and (= $DiemAccount_DiemAccount_$memory@0@@2 $DiemAccount_DiemAccount_$memory) (= (ControlFlow 0 446310) 450111))) anon0$2_correct@@2))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon13_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@1@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 450057) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon105_Else_correct  (=> (and (not true) (= (ControlFlow 0 450055) 450057)) inline$$DiemAccount_deposit_$def_verify$0$anon13_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon105_Then_correct  (=> (= (ControlFlow 0 450065) 450057) inline$$DiemAccount_deposit_$def_verify$0$anon13_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon104_Then_correct  (=> $abort_flag@0@@2 (and (=> (= (ControlFlow 0 450049) 450065) inline$$DiemAccount_deposit_$def_verify$0$anon105_Then_correct) (=> (= (ControlFlow 0 450049) 450055) inline$$DiemAccount_deposit_$def_verify$0$anon105_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon17_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@2@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 450037) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon107_Else_correct  (=> (and (not true) (= (ControlFlow 0 450035) 450037)) inline$$DiemAccount_deposit_$def_verify$0$anon17_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon107_Then_correct  (=> (= (ControlFlow 0 450045) 450037) inline$$DiemAccount_deposit_$def_verify$0$anon17_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon106_Then_correct  (=> $abort_flag@1@@2 (and (=> (= (ControlFlow 0 450029) 450045) inline$$DiemAccount_deposit_$def_verify$0$anon107_Then_correct) (=> (= (ControlFlow 0 450029) 450035) inline$$DiemAccount_deposit_$def_verify$0$anon107_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon23_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@3@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 450013) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon110_Else_correct  (=> (and (not true) (= (ControlFlow 0 450011) 450013)) inline$$DiemAccount_deposit_$def_verify$0$anon23_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon110_Then_correct  (=> (= (ControlFlow 0 450021) 450013) inline$$DiemAccount_deposit_$def_verify$0$anon23_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon109_Then_correct  (=> $abort_flag@2@@2 (and (=> (= (ControlFlow 0 450005) 450021) inline$$DiemAccount_deposit_$def_verify$0$anon110_Then_correct) (=> (= (ControlFlow 0 450005) 450011) inline$$DiemAccount_deposit_$def_verify$0$anon110_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon33_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@5@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449989) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon115_Else_correct  (=> (and (not true) (= (ControlFlow 0 449987) 449989)) inline$$DiemAccount_deposit_$def_verify$0$anon33_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon115_Then_correct  (=> (= (ControlFlow 0 449997) 449989) inline$$DiemAccount_deposit_$def_verify$0$anon33_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon114_Then_correct  (=> $abort_flag@3@@2 (and (=> (= (ControlFlow 0 449981) 449997) inline$$DiemAccount_deposit_$def_verify$0$anon115_Then_correct) (=> (= (ControlFlow 0 449981) 449987) inline$$DiemAccount_deposit_$def_verify$0$anon115_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon41_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@6@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449969) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon119_Else_correct  (=> (and (not true) (= (ControlFlow 0 449967) 449969)) inline$$DiemAccount_deposit_$def_verify$0$anon41_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon119_Then_correct  (=> (= (ControlFlow 0 449977) 449969) inline$$DiemAccount_deposit_$def_verify$0$anon41_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon118_Then_correct  (=> $abort_flag@4@@2 (and (=> (= (ControlFlow 0 449961) 449977) inline$$DiemAccount_deposit_$def_verify$0$anon119_Then_correct) (=> (= (ControlFlow 0 449961) 449967) inline$$DiemAccount_deposit_$def_verify$0$anon119_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon49_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@8@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449949) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon123_Else_correct  (=> (and (not true) (= (ControlFlow 0 449947) 449949)) inline$$DiemAccount_deposit_$def_verify$0$anon49_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon123_Then_correct  (=> (= (ControlFlow 0 449957) 449949) inline$$DiemAccount_deposit_$def_verify$0$anon49_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon122_Then_correct  (=> $abort_flag@5@@1 (and (=> (= (ControlFlow 0 449941) 449957) inline$$DiemAccount_deposit_$def_verify$0$anon123_Then_correct) (=> (= (ControlFlow 0 449941) 449947) inline$$DiemAccount_deposit_$def_verify$0$anon123_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon53_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@10@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449929) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon125_Else_correct  (=> (and (not true) (= (ControlFlow 0 449927) 449929)) inline$$DiemAccount_deposit_$def_verify$0$anon53_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon125_Then_correct  (=> (= (ControlFlow 0 449937) 449929) inline$$DiemAccount_deposit_$def_verify$0$anon53_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon124_Then_correct  (=> $abort_flag@6@@1 (and (=> (= (ControlFlow 0 449921) 449937) inline$$DiemAccount_deposit_$def_verify$0$anon125_Then_correct) (=> (= (ControlFlow 0 449921) 449927) inline$$DiemAccount_deposit_$def_verify$0$anon125_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon59_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@11@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449909) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon128_Else_correct  (=> (and (not true) (= (ControlFlow 0 449907) 449909)) inline$$DiemAccount_deposit_$def_verify$0$anon59_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon128_Then_correct  (=> (= (ControlFlow 0 449917) 449909) inline$$DiemAccount_deposit_$def_verify$0$anon59_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon127_Then_correct  (=> $abort_flag@7@@1 (and (=> (= (ControlFlow 0 449901) 449917) inline$$DiemAccount_deposit_$def_verify$0$anon128_Then_correct) (=> (= (ControlFlow 0 449901) 449907) inline$$DiemAccount_deposit_$def_verify$0$anon128_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon65_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@12@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449885) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon131_Else_correct  (=> (and (not true) (= (ControlFlow 0 449883) 449885)) inline$$DiemAccount_deposit_$def_verify$0$anon65_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon131_Then_correct  (=> (= (ControlFlow 0 449893) 449885) inline$$DiemAccount_deposit_$def_verify$0$anon65_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon130_Then_correct  (=> $abort_flag@8@@1 (and (=> (= (ControlFlow 0 449877) 449893) inline$$DiemAccount_deposit_$def_verify$0$anon131_Then_correct) (=> (= (ControlFlow 0 449877) 449883) inline$$DiemAccount_deposit_$def_verify$0$anon131_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon69_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@13@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@0@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449865) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon133_Else_correct  (=> (and (not true) (= (ControlFlow 0 449863) 449865)) inline$$DiemAccount_deposit_$def_verify$0$anon69_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon133_Then_correct  (=> (= (ControlFlow 0 449873) 449865) inline$$DiemAccount_deposit_$def_verify$0$anon69_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon132_Then_correct  (=> $abort_flag@9@@1 (and (=> (= (ControlFlow 0 449857) 449873) inline$$DiemAccount_deposit_$def_verify$0$anon133_Then_correct) (=> (= (ControlFlow 0 449857) 449863) inline$$DiemAccount_deposit_$def_verify$0$anon133_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon73_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@14@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@0@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449845) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon135_Else_correct  (=> (and (not true) (= (ControlFlow 0 449843) 449845)) inline$$DiemAccount_deposit_$def_verify$0$anon73_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon135_Then_correct  (=> (= (ControlFlow 0 449853) 449845) inline$$DiemAccount_deposit_$def_verify$0$anon73_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon134_Then_correct  (=> $abort_flag@10@@1 (and (=> (= (ControlFlow 0 449837) 449853) inline$$DiemAccount_deposit_$def_verify$0$anon135_Then_correct) (=> (= (ControlFlow 0 449837) 449843) inline$$DiemAccount_deposit_$def_verify$0$anon135_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon78_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@20@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@0@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449819) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon137_Else_correct  (=> (and (not true) (= (ControlFlow 0 449817) 449819)) inline$$DiemAccount_deposit_$def_verify$0$anon78_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon137_Then_correct  (=> (= (ControlFlow 0 449827) 449819) inline$$DiemAccount_deposit_$def_verify$0$anon78_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon136_Else_correct  (=> (and (not (|b#$Boolean| call8formal@$ret0@0@@0)) (= $abort_code@20@@1 (|i#$Integer| call3formal@$ret0@0@@16))) (and (=> (= (ControlFlow 0 449811) 449827) inline$$DiemAccount_deposit_$def_verify$0$anon137_Then_correct) (=> (= (ControlFlow 0 449811) 449817) inline$$DiemAccount_deposit_$def_verify$0$anon137_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon129_Then_correct  (=> $abort_flag@7@@1 (=> (and (and (= $abort_code@21@@0 $abort_code@11@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449897) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon81_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@16@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@1@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449397) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon139_Else_correct  (=> (and (not true) (= (ControlFlow 0 449395) 449397)) inline$$DiemAccount_deposit_$def_verify$0$anon81_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon139_Then_correct  (=> (= (ControlFlow 0 449405) 449397) inline$$DiemAccount_deposit_$def_verify$0$anon81_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon138_Then_correct  (=> $abort_flag@12@@1 (and (=> (= (ControlFlow 0 449389) 449405) inline$$DiemAccount_deposit_$def_verify$0$anon139_Then_correct) (=> (= (ControlFlow 0 449389) 449395) inline$$DiemAccount_deposit_$def_verify$0$anon139_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon85_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@17@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@1@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 449377) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon141_Else_correct  (=> (and (not true) (= (ControlFlow 0 449375) 449377)) inline$$DiemAccount_deposit_$def_verify$0$anon85_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon141_Then_correct  (=> (= (ControlFlow 0 449385) 449377) inline$$DiemAccount_deposit_$def_verify$0$anon85_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon140_Then_correct  (=> $abort_flag@13@@1 (and (=> (= (ControlFlow 0 449369) 449385) inline$$DiemAccount_deposit_$def_verify$0$anon141_Then_correct) (=> (= (ControlFlow 0 449369) 449375) inline$$DiemAccount_deposit_$def_verify$0$anon141_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon89_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@18@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@1@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 449357) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon143_Else_correct  (=> (and (not true) (= (ControlFlow 0 449355) 449357)) inline$$DiemAccount_deposit_$def_verify$0$anon89_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon143_Then_correct  (=> (= (ControlFlow 0 449365) 449357) inline$$DiemAccount_deposit_$def_verify$0$anon89_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon142_Then_correct  (=> $abort_flag@14@@0 (and (=> (= (ControlFlow 0 449349) 449365) inline$$DiemAccount_deposit_$def_verify$0$anon143_Then_correct) (=> (= (ControlFlow 0 449349) 449355) inline$$DiemAccount_deposit_$def_verify$0$anon143_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon93_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@19@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@1@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 449337) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon145_Else_correct  (=> (and (not true) (= (ControlFlow 0 449335) 449337)) inline$$DiemAccount_deposit_$def_verify$0$anon93_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon145_Then_correct  (=> (= (ControlFlow 0 449345) 449337) inline$$DiemAccount_deposit_$def_verify$0$anon93_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon144_Then_correct  (=> $abort_flag@15@@0 (and (=> (= (ControlFlow 0 449329) 449345) inline$$DiemAccount_deposit_$def_verify$0$anon145_Then_correct) (=> (= (ControlFlow 0 449329) 449335) inline$$DiemAccount_deposit_$def_verify$0$anon145_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon97_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@19@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory@1@@1)) (and (= $DiemAccount_Balance_$memory@0@@1 |inline$$WritebackToGlobal$0$m'@2@@1|) (= (ControlFlow 0 449317) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon147_Else_correct  (=> (and (not true) (= (ControlFlow 0 449315) 449317)) inline$$DiemAccount_deposit_$def_verify$0$anon97_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon147_Then_correct  (=> (= (ControlFlow 0 449325) 449317) inline$$DiemAccount_deposit_$def_verify$0$anon97_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon146_Then_correct  (=> $abort_flag@15@@0 (and (=> (= (ControlFlow 0 449309) 449325) inline$$DiemAccount_deposit_$def_verify$0$anon147_Then_correct) (=> (= (ControlFlow 0 449309) 449315) inline$$DiemAccount_deposit_$def_verify$0$anon147_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct@@1  (=> (= inline$$Event_emit_event$0$t@0@@1 $DiemAccount_ReceivedPaymentEvent_type_value) (and (=> (= (ControlFlow 0 448575) 449309) inline$$DiemAccount_deposit_$def_verify$0$anon146_Then_correct) (=> (= (ControlFlow 0 448575) 448650) inline$$DiemAccount_deposit_$def_verify$0$anon146_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon144_Else$2_correct  (and (=> (= (ControlFlow 0 448585) (- 0 834497)) true) (=> (= (ControlFlow 0 448585) 448575) inline$$Event_emit_event$0$Entry_correct@@1))))
(let ((inline$$ReadRef$1$anon0_correct@@1  (=> (and (= inline$$ReadRef$1$v@1@@1 (|v#$Mutation| inline$$BorrowField$1$dst@1@@1)) (= (ControlFlow 0 448527) 448585)) inline$$DiemAccount_deposit_$def_verify$0$anon144_Else$2_correct)))
(let ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 448483) 448527)) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 448489) 448527) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 448477) 448489) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 448477) 448483) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 448469) 448527)) inline$$ReadRef$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$GetFieldFromValue$0$dst@1@@1) (>= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) 0)) (<= (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) $MAX_U64)) (=> (and (and (and (and ((_ is $Vector) call3formal@$ret0@0@@17) (let ((va@@147 (|v#$Vector| call3formal@$ret0@0@@17)))
(let ((l@@147 (|l#$ValueArray| va@@147)))
 (and (and (<= 0 l@@147) (<= l@@147 $MAX_U64)) (forall ((x@@147 Int) ) (!  (=> (or (< x@@147 0) (>= x@@147 l@@147)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@147) x@@147))
)))))) (forall ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0 0) (< inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0))
))) ((_ is $Address) payer@@0)) (and (and (and ((_ is $Vector) metadata@@0) (let ((va@@148 (|v#$Vector| metadata@@0)))
(let ((l@@148 (|l#$ValueArray| va@@148)))
 (and (and (<= 0 l@@148) (<= l@@148 $MAX_U64)) (forall ((x@@148 Int) ) (!  (=> (or (< x@@148 0) (>= x@@148 l@@148)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@148) x@@148))
)))))) (forall ((inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0 Int) ) (!  (=> (and (>= inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0 0) (< inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0 (|l#$ValueArray| (|v#$Vector| metadata@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$$0@@0))
))) (= inline$$DiemAccount_ReceivedPaymentEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$GetFieldFromValue$0$dst@1@@1) 1 call3formal@$ret0@0@@17) 2 payer@@0) 3 metadata@@0) 4))))) (and (=> (= (ControlFlow 0 448461) 448477) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 448461) 448469) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon144_Else_correct  (=> (and (not $abort_flag@15@@0) (= (ControlFlow 0 448495) 448461)) inline$$DiemAccount_ReceivedPaymentEvent_pack$0$anon0_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon142_Else$2_correct  (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@15@@0) (=> $abort_flag@15@@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))) (and (=> $abort_flag@15@@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19@@1 (|i#$Integer| ($Integer 5))))) (=> (not $abort_flag@15@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_currency_code))))))) (and (and ((_ is $Vector) call3formal@$ret0@0@@17) (let ((va@@149 (|v#$Vector| call3formal@$ret0@0@@17)))
(let ((l@@149 (|l#$ValueArray| va@@149)))
 (and (and (<= 0 l@@149) (<= l@@149 $MAX_U64)) (forall ((x@@149 Int) ) (!  (=> (or (< x@@149 0) (>= x@@149 l@@149)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@149) x@@149))
)))))) (forall (($$0@@35 Int) ) (!  (=> (and (>= $$0@@35 0) (< $$0@@35 (|l#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) $$0@@35)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) $$0@@35)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) $$0@@35)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call3formal@$ret0@0@@17)) $$0@@35))
)))) (and (=> (= (ControlFlow 0 448109) 449329) inline$$DiemAccount_deposit_$def_verify$0$anon144_Then_correct) (=> (= (ControlFlow 0 448109) 448495) inline$$DiemAccount_deposit_$def_verify$0$anon144_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct@@1  (=> (= inline$$BorrowField$1$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (=> (and (and (= inline$$BorrowField$1$size@1@@1 (|size#$Path| inline$$BorrowField$1$p@1@@1)) (= inline$$BorrowField$1$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1@@1) inline$$BorrowField$1$size@1@@1 $DiemAccount_DiemAccount_received_events) (+ inline$$BorrowField$1$size@1@@1 1)))) (and (= inline$$BorrowField$1$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2@@1) inline$$BorrowField$1$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1))) $DiemAccount_DiemAccount_received_events))) (= (ControlFlow 0 448101) 448109))) inline$$DiemAccount_deposit_$def_verify$0$anon142_Else$2_correct))))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@0  (=> (and (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0)) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0)) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true) (= (ControlFlow 0 447979) 448101)) inline$$BorrowField$1$anon0_correct@@1)))
(let ((inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@0  (=> (and (= inline$$DiemAccount_DiemAccount_$unpack_ref$0$$before@0@@0 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2@@1)) (= (ControlFlow 0 447973) 447979)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon142_Else_correct  (=> (and (not $abort_flag@14@@0) (= (ControlFlow 0 447983) 447973)) inline$$DiemAccount_DiemAccount_$unpack_ref$0$Entry_correct@@0)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct@@1  (=> (= $abort_flag@14@@0 true) (=> (and (= $abort_code@18@@1 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$1$dst@2@@1 inline$$BorrowGlobal$1$dst@0@@1)) (and (=> (= (ControlFlow 0 447940) 449349) inline$$DiemAccount_deposit_$def_verify$0$anon142_Then_correct) (=> (= (ControlFlow 0 447940) 447983) inline$$DiemAccount_deposit_$def_verify$0$anon142_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@1)) (= (ControlFlow 0 447938) 447940)) inline$$BorrowGlobal$1$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1@@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1@@1))) (= $abort_flag@14@@0 $abort_flag@13@@1)) (and (= $abort_code@18@@1 $abort_code@17@@1) (= inline$$BorrowGlobal$1$dst@2@@1 inline$$BorrowGlobal$1$dst@1@@1))) (and (=> (= (ControlFlow 0 447886) 449349) inline$$DiemAccount_deposit_$def_verify$0$anon142_Then_correct) (=> (= (ControlFlow 0 447886) 447983) inline$$DiemAccount_deposit_$def_verify$0$anon142_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct@@1  (=> (= inline$$BorrowGlobal$1$a@1@@1 (|a#$Address| payee)) (and (=> (= (ControlFlow 0 447856) 447938) inline$$BorrowGlobal$1$anon3_Then_correct@@1) (=> (= (ControlFlow 0 447856) 447886) inline$$BorrowGlobal$1$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$1$Entry_correct@@1  (and (=> (= (ControlFlow 0 447850) (- 0 834002)) true) (=> (= (ControlFlow 0 447850) 447856) inline$$BorrowGlobal$1$anon0_correct@@1))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon140_Else$3_correct  (and (=> (= (ControlFlow 0 447946) (- 0 833845)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$coin_type T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_deposit_$def_verify$0$coin_type) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@9 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@9) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@9)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$coin_type)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@9)))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$coin_type@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_deposit_$def_verify$0$coin_type@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@10 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@10) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@10)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$coin_type@@0)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@10))))))))))))))) (and (=> (= (ControlFlow 0 447946) (- 0 833923)) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$token T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_deposit_$def_verify$0$token) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@11 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$token)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@11)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))))))) (=> (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$token@@0 T@$Value) )  (=> ((_ is $Type) inline$$DiemAccount_deposit_$def_verify$0$token@@0) (|b#$Boolean| ($Boolean (forall ((inline$$DiemAccount_deposit_$def_verify$0$addr@@12 T@$Value) )  (=> ((_ is $Address) inline$$DiemAccount_deposit_$def_verify$0$addr@@12) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2@@1|) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| inline$$DiemAccount_deposit_$def_verify$0$token@@0)) 1) (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| inline$$DiemAccount_deposit_$def_verify$0$addr@@12)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (and (=> (= (ControlFlow 0 447946) (- 0 833986)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| payee))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 $EmptyTypeValueArray (|a#$Address| payee)) (=> (= (ControlFlow 0 447946) 447850) inline$$BorrowGlobal$1$Entry_correct@@1)))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct@@1  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2@@1| $DiemAccount_Balance_$memory) (= (ControlFlow 0 447535) 447946)) inline$$DiemAccount_deposit_$def_verify$0$anon140_Else$3_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct@@1  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1@@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1@@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1@@1)) (= inline$$WritebackToGlobal$0$a@1@@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1@@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1@@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|))) (= |inline$$WritebackToGlobal$0$m'@1@@1| ($Memory (|domain#$Memory| $DiemAccount_Balance_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$WritebackToGlobal$0$ta@1@@1 inline$$WritebackToGlobal$0$a@1@@1 inline$$WritebackToGlobal$0$v@1@@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2@@1| |inline$$WritebackToGlobal$0$m'@1@@1|) (= (ControlFlow 0 447589) 447946))) inline$$DiemAccount_deposit_$def_verify$0$anon140_Else$3_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct@@1  (=> (= inline$$WritebackToGlobal$0$l@1@@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2@@1|)) (and (=> (= (ControlFlow 0 447525) 447589) inline$$WritebackToGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 447525) 447535) inline$$WritebackToGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct@@1  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2@@1| inline$$BorrowGlobal$0$dst@2@@1) (= (ControlFlow 0 447345) 447525)) inline$$WritebackToGlobal$0$anon0_correct@@1))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct@@1  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|l#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1@@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1@@1 inline$$WritebackToReference$0$srcPath@1@@1)) (= |inline$$WritebackToReference$0$dst'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$WritebackToReference$0$dstPath@1@@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1@@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1@@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) (|v#$Mutation| |inline$$WriteRef$0$to'@1@@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2@@1| |inline$$WritebackToReference$0$dst'@1@@1|) (= (ControlFlow 0 447401) 447525))) inline$$WritebackToGlobal$0$anon0_correct@@1)))
(let ((inline$$WritebackToReference$0$anon0_correct@@1  (=> (and (= inline$$WritebackToReference$0$srcPath@1@@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1@@1|)) (= inline$$WritebackToReference$0$dstPath@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) (and (=> (= (ControlFlow 0 447309) 447401) inline$$WritebackToReference$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 447309) 447345) inline$$WritebackToReference$0$anon3_Else_correct@@1)))))
(let ((inline$$WriteRef$0$anon0_correct@@1  (=> (and (= |inline$$WriteRef$0$to'@1@@1| ($Mutation (|l#$Mutation| inline$$BorrowField$0$dst@1@@1) (|p#$Mutation| inline$$BorrowField$0$dst@1@@1) call5formal@$ret0@0@@1)) (= (ControlFlow 0 447166) 447309)) inline$$WritebackToReference$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon140_Else_correct  (=> (and (not $abort_flag@13@@1) (= (ControlFlow 0 447172) 447166)) inline$$WriteRef$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon138_Else$2_correct  (and (=> (= (ControlFlow 0 447109) (- 0 833409)) true) (=> (and (and (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@13@@1) (=> $abort_flag@13@@1 (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> $abort_flag@13@@1 (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@17@@1 (|i#$Integer| ($Integer 8))))) (=> (not $abort_flag@13@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$ReadRef$0$v@1@@1)) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)))))))))) (=> (and (and (and (and ((_ is $Vector) call5formal@$ret0@0@@1) (let ((va@@150 (|v#$Vector| call5formal@$ret0@0@@1)))
(let ((l@@150 (|l#$ValueArray| va@@150)))
 (and (and (<= 0 l@@150) (<= l@@150 $MAX_U64)) (forall ((x@@150 Int) ) (!  (=> (or (< x@@150 0) (>= x@@150 l@@150)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@150) x@@150))
)))))) (= (|l#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| call5formal@$ret0@0@@1)) $Diem_Diem_value)) $MAX_U64))) true) (and (=> (= (ControlFlow 0 447109) 449369) inline$$DiemAccount_deposit_$def_verify$0$anon140_Then_correct) (=> (= (ControlFlow 0 447109) 447172) inline$$DiemAccount_deposit_$def_verify$0$anon140_Else_correct)))))))
(let ((inline$$ReadRef$0$anon0_correct@@1  (=> (and (= inline$$ReadRef$0$v@1@@1 (|v#$Mutation| inline$$BorrowField$0$dst@1@@1)) (= (ControlFlow 0 447097) 447109)) inline$$DiemAccount_deposit_$def_verify$0$anon138_Else$2_correct)))
(let ((inline$$BorrowField$0$anon0_correct@@1  (=> (= inline$$BorrowField$0$p@1@@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2@@1)) (=> (and (and (= inline$$BorrowField$0$size@1@@1 (|size#$Path| inline$$BorrowField$0$p@1@@1)) (= inline$$BorrowField$0$p@2@@1 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1@@1) inline$$BorrowField$0$size@1@@1 $DiemAccount_Balance_coin) (+ inline$$BorrowField$0$size@1@@1 1)))) (and (= inline$$BorrowField$0$dst@1@@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2@@1) inline$$BorrowField$0$p@2@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2@@1))) $DiemAccount_Balance_coin))) (= (ControlFlow 0 447059) 447097))) inline$$ReadRef$0$anon0_correct@@1))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon138_Else_correct  (=> (and (not $abort_flag@12@@1) (= (ControlFlow 0 447065) 447059)) inline$$BorrowField$0$anon0_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct@@1  (=> (= $abort_code@16@@1 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@12@@1 true) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@0@@1)) (and (=> (= (ControlFlow 0 446929) 449389) inline$$DiemAccount_deposit_$def_verify$0$anon138_Then_correct) (=> (= (ControlFlow 0 446929) 447065) inline$$DiemAccount_deposit_$def_verify$0$anon138_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1)) (= (ControlFlow 0 446927) 446929)) inline$$BorrowGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct@@1  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1@@1 ($Mutation ($Global inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) inline$$BorrowGlobal$0$ta@0@@1 inline$$BorrowGlobal$0$a@1@@1))) (= $abort_code@16@@1 $abort_code@15@@1)) (and (= $abort_flag@12@@1 $abort_flag@11@@1) (= inline$$BorrowGlobal$0$dst@2@@1 inline$$BorrowGlobal$0$dst@1@@1))) (and (=> (= (ControlFlow 0 446875) 449389) inline$$DiemAccount_deposit_$def_verify$0$anon138_Then_correct) (=> (= (ControlFlow 0 446875) 447065) inline$$DiemAccount_deposit_$def_verify$0$anon138_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct@@1  (=> (= inline$$BorrowGlobal$0$a@1@@1 (|a#$Address| payee)) (and (=> (= (ControlFlow 0 446845) 446927) inline$$BorrowGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 446845) 446875) inline$$BorrowGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$BorrowGlobal$0$Entry_correct@@1  (=> (= inline$$BorrowGlobal$0$ta@0@@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1)) (and (=> (= (ControlFlow 0 446839) (- 0 833224)) true) (=> (= (ControlFlow 0 446839) 446845) inline$$BorrowGlobal$0$anon0_correct@@1)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$L8_correct  (and (=> (= (ControlFlow 0 446935) (- 0 833181)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_Balance_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_Balance_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)) (=> (= (ControlFlow 0 446935) 446839) inline$$BorrowGlobal$0$Entry_correct@@1)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon136_Then_correct  (=> (|b#$Boolean| call8formal@$ret0@0@@0) (=> (and (and (= $abort_code@15@@1 $abort_code@14@@1) (= $abort_flag@11@@1 $abort_flag@10@@1)) (and (= $AccountLimits_Window_$memory@1@@1 $AccountLimits_Window_$memory@0@@1) (= (ControlFlow 0 449833) 446935))) inline$$DiemAccount_deposit_$def_verify$0$L8_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon134_Else_correct  (=> (not $abort_flag@10@@1) (and (=> (= (ControlFlow 0 449799) 449833) inline$$DiemAccount_deposit_$def_verify$0$anon136_Then_correct) (=> (= (ControlFlow 0 449799) 449811) inline$$DiemAccount_deposit_$def_verify$0$anon136_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon132_Else_correct  (=> (not $abort_flag@9@@1) (=> (and (and (and (= inline$$DiemAccount_deposit_$def_verify$0$$t36@1 ($Integer 3)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@10@@1)) (and (=> $abort_flag@10@@1 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@10@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@16 ($Integer 8))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@16) (>= (|i#$Integer| call3formal@$ret0@0@@16) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@16) $MAX_U64))) (and (=> (= (ControlFlow 0 449793) 449837) inline$$DiemAccount_deposit_$def_verify$0$anon134_Then_correct) (=> (= (ControlFlow 0 449793) 449799) inline$$DiemAccount_deposit_$def_verify$0$anon134_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon130_Else$1_correct  (and (=> (= (ControlFlow 0 449783) (- 0 831412)) (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))) (=> (|Select_[$TypeValueArray,$int]$bool| inline$$DiemAccount_deposit_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))) $abort_flag@9@@1) (=> (and (and (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)))))))) $abort_flag@9@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@240 (|l#$ValueArray| (let ((len@@241 (|l#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1)))) len@@241 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@241 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@241 (|l#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@242 (|l#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@243 (|l#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@244 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@244 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@244 1)))) len@@243 ($Integer 0)) (+ len@@243 1)))) len@@242 ($Integer 0)) (+ len@@242 1)))) len@@241 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@241 1)))) len@@240 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@240 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@9@@1)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@245 (|l#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@246 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@246 (|l#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@247 (|l#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@248 (|l#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@249 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@249 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@249 1)))) len@@248 ($Integer 0)) (+ len@@248 1)))) len@@247 ($Integer 0)) (+ len@@247 1)))) len@@246 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@246 1)))) len@@245 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@245 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@9@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) $abort_flag@9@@1))) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@9@@1) (=> $abort_flag@9@@1 (or (or (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@250 (|l#$ValueArray| (let ((len@@251 (|l#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1)))) len@@251 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@251 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@251 (|l#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@252 (|l#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@253 (|l#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@254 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@254 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@254 1)))) len@@253 ($Integer 0)) (+ len@@253 1)))) len@@252 ($Integer 0)) (+ len@@252 1)))) len@@251 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@251 1)))) len@@250 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@250 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@255 (|l#$ValueArray| (let ((len@@256 (|l#$ValueArray| (let ((len@@257 (|l#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1)))) len@@257 ($Integer 0)) (+ len@@257 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@257 (|l#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1)))) len@@257 ($Integer 0)) (+ len@@257 1)))) len@@256 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@256 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@256 (|l#$ValueArray| (let ((len@@257 (|l#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1)))) len@@257 ($Integer 0)) (+ len@@257 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@257 (|l#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@258 (|l#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@259 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@259 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@259 1)))) len@@258 ($Integer 0)) (+ len@@258 1)))) len@@257 ($Integer 0)) (+ len@@257 1)))) len@@256 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@256 1)))) len@@255 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@255 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))))) (and (=> $abort_flag@9@@1 (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@260 (|l#$ValueArray| (let ((len@@261 (|l#$ValueArray| (let ((len@@262 (|l#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1)))) len@@262 ($Integer 0)) (+ len@@262 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@262 (|l#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1)))) len@@262 ($Integer 0)) (+ len@@262 1)))) len@@261 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@261 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@261 (|l#$ValueArray| (let ((len@@262 (|l#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1)))) len@@262 ($Integer 0)) (+ len@@262 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@262 (|l#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@263 (|l#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@264 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@264 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@264 1)))) len@@263 ($Integer 0)) (+ len@@263 1)))) len@@262 ($Integer 0)) (+ len@@262 1)))) len@@261 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@261 1)))) len@@260 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@260 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@265 (|l#$ValueArray| (let ((len@@266 (|l#$ValueArray| (let ((len@@267 (|l#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1)))) len@@267 ($Integer 0)) (+ len@@267 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@267 (|l#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1)))) len@@267 ($Integer 0)) (+ len@@267 1)))) len@@266 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@266 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@266 (|l#$ValueArray| (let ((len@@267 (|l#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1)))) len@@267 ($Integer 0)) (+ len@@267 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@267 (|l#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@268 (|l#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@269 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@269 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@269 1)))) len@@268 ($Integer 0)) (+ len@@268 1)))) len@@267 ($Integer 0)) (+ len@@267 1)))) len@@266 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@266 1)))) len@@265 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@265 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period))))) (|i#$Integer| ($Integer $MAX_U64)))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@13@@1 (|i#$Integer| ($Integer 1)))))) (=> (not $abort_flag@9@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call8formal@$ret0@0@@0 ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@270 (|l#$ValueArray| (let ((len@@271 (|l#$ValueArray| (let ((len@@272 (|l#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1)))) len@@272 ($Integer 0)) (+ len@@272 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@272 (|l#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1)))) len@@272 ($Integer 0)) (+ len@@272 1)))) len@@271 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@271 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@271 (|l#$ValueArray| (let ((len@@272 (|l#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1)))) len@@272 ($Integer 0)) (+ len@@272 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@272 (|l#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@273 (|l#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@274 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@274 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@274 1)))) len@@273 ($Integer 0)) (+ len@@273 1)))) len@@272 ($Integer 0)) (+ len@@272 1)))) len@@271 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@271 1)))) len@@270 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@270 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@275 (|l#$ValueArray| (let ((len@@276 (|l#$ValueArray| (let ((len@@277 (|l#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1)))) len@@277 ($Integer 0)) (+ len@@277 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@277 (|l#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1)))) len@@277 ($Integer 0)) (+ len@@277 1)))) len@@276 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@276 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@276 (|l#$ValueArray| (let ((len@@277 (|l#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1)))) len@@277 ($Integer 0)) (+ len@@277 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@277 (|l#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@278 (|l#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@279 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@279 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@279 1)))) len@@278 ($Integer 0)) (+ len@@278 1)))) len@@277 ($Integer 0)) (+ len@@277 1)))) len@@276 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@276 1)))) len@@275 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@275 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding)))))))))))))))) (and (and (=> (not $abort_flag@9@@1) (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (and (|b#$Boolean| call8formal@$ret0@0@@0) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_inflow) ($Integer $MAX_U64)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_outflow) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_max_holding) ($Integer $MAX_U64))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period) ($Integer 86400000000))))))))))))) ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)) ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))))) $AccountLimits_Window_tracked_balance ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_tracked_balance)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|l#$ValueArray| (|v#$Vector| ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))) $AccountLimits_Window_window_inflow)) (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1)))) (|l#$ValueArray| (|v#$Vector| (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@280 (|l#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@281 (|l#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@282 (|l#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@283 (|l#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@284 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@284 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@284 1)))) len@@283 ($Integer 0)) (+ len@@283 1)))) len@@282 ($Integer 0)) (+ len@@282 1)))) len@@281 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@281 1)))) len@@280 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@280 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))))))))) ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)) (ite (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_window_start)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address))))) $AccountLimits_LimitsDefinition_time_period)))))))) ($Vector (let ((len@@285 (|l#$ValueArray| (let ((len@@286 (|l#$ValueArray| (let ((len@@287 (|l#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1)))) len@@287 ($Integer 0)) (+ len@@287 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@287 (|l#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1)))) len@@287 ($Integer 0)) (+ len@@287 1)))) len@@286 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@286 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@286 (|l#$ValueArray| (let ((len@@287 (|l#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1)))) len@@287 ($Integer 0)) (+ len@@287 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@287 (|l#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@288 (|l#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1))))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (let ((len@@289 (|l#$ValueArray| $EmptyValueArray)))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| $EmptyValueArray) len@@289 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (+ len@@289 1)))) len@@288 ($Integer 0)) (+ len@@288 1)))) len@@287 ($Integer 0)) (+ len@@287 1)))) len@@286 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_tracked_balance)) (+ len@@286 1)))) len@@285 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) $AccountLimits_Window_limit_address)) (+ len@@285 1)))) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))))))))) ((_ is $Boolean) call8formal@$ret0@0@@0)) (and (= (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18)))) (= (|domain#$Memory| $AccountLimits_Window_$memory@0@@1) (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18) (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory@0@@1) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| call3formal@$ret0@0@@18))))))) (and (=> (= (ControlFlow 0 449783) 449857) inline$$DiemAccount_deposit_$def_verify$0$anon132_Then_correct) (=> (= (ControlFlow 0 449783) 449793) inline$$DiemAccount_deposit_$def_verify$0$anon132_Else_correct)))))))))
(let ((inline$$GetFieldFromValue$1$anon0_correct@@0  (=> (and (= inline$$GetFieldFromValue$1$dst@1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst@@0)) $DiemAccount_AccountOperationsCapability_limits_cap)) (= (ControlFlow 0 449775) 449783)) inline$$DiemAccount_deposit_$def_verify$0$anon130_Else$1_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon130_Else_correct  (=> (and (not $abort_flag@8@@1) (= (ControlFlow 0 449781) 449775)) inline$$GetFieldFromValue$1$anon0_correct@@0)))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct@@1  (=> (and (= $abort_flag@8@@1 true) (= $abort_code@12@@1 $EXEC_FAILURE_CODE)) (and (=> (= (ControlFlow 0 449721) 449877) inline$$DiemAccount_deposit_$def_verify$0$anon130_Then_correct) (=> (= (ControlFlow 0 449721) 449781) inline$$DiemAccount_deposit_$def_verify$0$anon130_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct@@1  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1)) (= (ControlFlow 0 449719) 449721)) inline$$GetGlobal$0$anon3_Then$1_correct@@1)))
(let ((inline$$GetGlobal$0$anon3_Else_correct@@1  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1@@1) (= inline$$GetGlobal$0$dst@1@@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0)))) (and (= $abort_flag@8@@1 $abort_flag@7@@1) (= $abort_code@12@@1 $abort_code@11@@1))) (and (=> (= (ControlFlow 0 449667) 449877) inline$$DiemAccount_deposit_$def_verify$0$anon130_Then_correct) (=> (= (ControlFlow 0 449667) 449781) inline$$DiemAccount_deposit_$def_verify$0$anon130_Else_correct)))))
(let ((inline$$GetGlobal$0$anon0_correct@@1  (=> (= inline$$GetGlobal$0$a@1@@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0)) (and (=> (= (ControlFlow 0 449649) 449719) inline$$GetGlobal$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 449649) 449667) inline$$GetGlobal$0$anon3_Else_correct@@1)))))
(let ((inline$$GetGlobal$0$Entry_correct@@1  (and (=> (= (ControlFlow 0 449643) (- 0 831303)) true) (=> (= (ControlFlow 0 449643) 449649) inline$$GetGlobal$0$anon0_correct@@1))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon129_Else_correct  (=> (and (not $abort_flag@7@@1) (= (ControlFlow 0 449727) 449643)) inline$$GetGlobal$0$Entry_correct@@1)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 449522) 449897) inline$$DiemAccount_deposit_$def_verify$0$anon129_Then_correct) (=> (= (ControlFlow 0 449522) 449727) inline$$DiemAccount_deposit_$def_verify$0$anon129_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 449532) 449897) inline$$DiemAccount_deposit_$def_verify$0$anon129_Then_correct) (=> (= (ControlFlow 0 449532) 449727) inline$$DiemAccount_deposit_$def_verify$0$anon129_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@7@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 449516) 449532) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 449516) 449522) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon127_Else_correct  (=> (and (not $abort_flag@7@@1) (= (ControlFlow 0 449546) 449516)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon126_Then_correct  (=> (and (|b#$Boolean| call6formal@$ret0@0@@0) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) $abort_flag@7@@1)) (=> (and (and (=> $abort_flag@7@@1 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))))))) (=> $abort_flag@7@@1 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (= $abort_code@11@@1 (|i#$Integer| ($Integer 7)))))) (and (=> (not $abort_flag@7@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@18 (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))))) ((_ is $Address) call3formal@$ret0@0@@18))) (and (=> (= (ControlFlow 0 449411) 449901) inline$$DiemAccount_deposit_$def_verify$0$anon127_Then_correct) (=> (= (ControlFlow 0 449411) 449546) inline$$DiemAccount_deposit_$def_verify$0$anon127_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon126_Else_correct  (=> (not (|b#$Boolean| call6formal@$ret0@0@@0)) (=> (and (and (= $abort_code@15@@1 $abort_code@10@@1) (= $abort_flag@11@@1 $abort_flag@6@@1)) (and (= $AccountLimits_Window_$memory@1@@1 $AccountLimits_Window_$memory) (= (ControlFlow 0 446704) 446935))) inline$$DiemAccount_deposit_$def_verify$0$L8_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon124_Else_correct  (=> (not $abort_flag@6@@1) (and (=> (= (ControlFlow 0 446696) 449411) inline$$DiemAccount_deposit_$def_verify$0$anon126_Then_correct) (=> (= (ControlFlow 0 446696) 446704) inline$$DiemAccount_deposit_$def_verify$0$anon126_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon122_Else_correct  (=> (and (and (and (not $abort_flag@5@@1) (= inline$$DiemAccount_deposit_$def_verify$0$$t29@1 ($Boolean false))) (and (=> (|b#$Boolean| ($Boolean false)) $abort_flag@6@@1) (=> $abort_flag@6@@1 (|b#$Boolean| ($Boolean false))))) (and (and (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean ($IsEqual_stratified call6formal@$ret0@0@@0 (ite (|b#$Boolean| inline$$DiemAccount_deposit_$def_verify$0$$t29@1) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payer@@0))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))) ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| (ite (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))) ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))))))))) (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean (forall ((addr@@43 T@$Value) )  (=> ((_ is $Address) addr@@43) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) $DiemAccount_DiemAccount_authentication_key) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@43)))) $DiemAccount_DiemAccount_authentication_key))))))))))))) (and (=> (not $abort_flag@6@@1) (|b#$Boolean| ($Boolean (forall ((addr@@44 T@$Value) )  (=> ((_ is $Address) addr@@44) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@44)))) (|b#$Boolean| ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@44)))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| addr@@44)))) $DiemAccount_Balance_coin))) $Diem_Diem_value))))))))))))) ((_ is $Boolean) call6formal@$ret0@0@@0)))) (and (=> (= (ControlFlow 0 446690) 449921) inline$$DiemAccount_deposit_$def_verify$0$anon124_Then_correct) (=> (= (ControlFlow 0 446690) 446696) inline$$DiemAccount_deposit_$def_verify$0$anon124_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon120_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_deposit_$def_verify$0$$t26@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@1)) (=> (and (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) $abort_flag@5@@1)) (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) $abort_flag@5@@1))) (and (and (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@8 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@8) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@8 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 inline$$GetFieldFromValue$0$dst@1@@1))))))))))))) $abort_flag@5@@1) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) $abort_flag@5@@1)) (and (=> $abort_flag@5@@1 (or (or (or (or (or (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816)))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0)))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@9 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@9) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@9 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 inline$$GetFieldFromValue$0$dst@1@@1)))))))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))))) (=> $abort_flag@5@@1 (or (or (or (or (or (or (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5)))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0)))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 8))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)) ($Integer 0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_base_url)) ($Integer 0))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 1))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (let ((payee_compliance_key@@10 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))) $DualAttestation_Credential_compliance_public_key)))
($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 64)))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $IntegerType payee_compliance_key@@10) ($Integer 0)))))))))) (|b#$Boolean| ($Signature_$ed25519_verify metadata_signature payee_compliance_key@@10 ($DualAttestation_spec_dual_attestation_message payer@@0 metadata@@0 inline$$GetFieldFromValue$0$dst@1@@1))))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 7))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified ($Integer (|l#$ValueArray| (|v#$Vector| metadata_signature))) ($Integer 0))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (>= (|i#$Integer| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 0)))) ($Integer 0) (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 1)))) inline$$GetFieldFromValue$0$dst@1@@1 (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value) ($Integer 2)))) ($Integer (div (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| ($Integer 2)))) ($Integer (+ (|i#$Integer| ($Integer 18446744073709551615)) (|i#$Integer| ($Integer 1)))))))) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DualAttestation_Limit_micro_xdx_limit))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified payer@@0 payee))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0))))))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) payer@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payer@@0)))) $VASP_ChildVASP_parent_vasp_addr)) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))))))))))))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)) payee))))))))))) (= $abort_code@8@@1 (|i#$Integer| ($Integer 5))))))))) (and (=> (= (ControlFlow 0 446680) 449941) inline$$DiemAccount_deposit_$def_verify$0$anon122_Then_correct) (=> (= (ControlFlow 0 446680) 446690) inline$$DiemAccount_deposit_$def_verify$0$anon122_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon46_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@9@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 446666) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon121_Else_correct  (=> (and (not true) (= (ControlFlow 0 446664) 446666)) inline$$DiemAccount_deposit_$def_verify$0$anon46_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon121_Then_correct  (=> (= (ControlFlow 0 446674) 446666) inline$$DiemAccount_deposit_$def_verify$0$anon46_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon120_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_deposit_$def_verify$0$$t26@1)) (= $abort_code@9@@1 (|i#$Integer| call3formal@$ret0@0@@19))) (and (=> (= (ControlFlow 0 446658) 446674) inline$$DiemAccount_deposit_$def_verify$0$anon121_Then_correct) (=> (= (ControlFlow 0 446658) 446664) inline$$DiemAccount_deposit_$def_verify$0$anon121_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon118_Else_correct  (=> (not $abort_flag@4@@2) (and (=> (= (ControlFlow 0 446646) 446680) inline$$DiemAccount_deposit_$def_verify$0$anon120_Then_correct) (=> (= (ControlFlow 0 446646) 446658) inline$$DiemAccount_deposit_$def_verify$0$anon120_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon116_Then_correct  (=> (and (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@0) (= inline$$DiemAccount_deposit_$def_verify$0$$t26@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee))))) (=> (and (and (and (= inline$$DiemAccount_deposit_$def_verify$0$$t27@1 ($Integer 18)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@4@@2)) (and (=> $abort_flag@4@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@4@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@19 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@19) (>= (|i#$Integer| call3formal@$ret0@0@@19) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@19) $MAX_U64))) (and (=> (= (ControlFlow 0 446640) 449961) inline$$DiemAccount_deposit_$def_verify$0$anon118_Then_correct) (=> (= (ControlFlow 0 446640) 446646) inline$$DiemAccount_deposit_$def_verify$0$anon118_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon38_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@7@@1) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 446602) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon117_Else_correct  (=> (and (not true) (= (ControlFlow 0 446600) 446602)) inline$$DiemAccount_deposit_$def_verify$0$anon38_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon117_Then_correct  (=> (= (ControlFlow 0 446610) 446602) inline$$DiemAccount_deposit_$def_verify$0$anon38_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon116_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemAccount_exists_at_$def$0$$t2@1@@0)) (= $abort_code@7@@1 (|i#$Integer| call3formal@$ret0@0@@20))) (and (=> (= (ControlFlow 0 446594) 446610) inline$$DiemAccount_deposit_$def_verify$0$anon117_Then_correct) (=> (= (ControlFlow 0 446594) 446600) inline$$DiemAccount_deposit_$def_verify$0$anon117_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon114_Else_correct  (=> (not $abort_flag@3@@2) (and (=> (= (ControlFlow 0 446582) 446640) inline$$DiemAccount_deposit_$def_verify$0$anon116_Then_correct) (=> (= (ControlFlow 0 446582) 446594) inline$$DiemAccount_deposit_$def_verify$0$anon116_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon113_Else_correct  (=> (not $abort_flag@2@@2) (=> (and (and (and (= inline$$DiemAccount_deposit_$def_verify$0$$t24@1 ($Integer 17)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@2)) (and (=> $abort_flag@3@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@20 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@20) (>= (|i#$Integer| call3formal@$ret0@0@@20) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@20) $MAX_U64))) (and (=> (= (ControlFlow 0 446576) 449981) inline$$DiemAccount_deposit_$def_verify$0$anon114_Then_correct) (=> (= (ControlFlow 0 446576) 446582) inline$$DiemAccount_deposit_$def_verify$0$anon114_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon113_Then_correct  (=> $abort_flag@2@@2 (=> (and (and (= $abort_code@21@@0 $abort_code@3@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 450001) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 446532) 450001) inline$$DiemAccount_deposit_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 446532) 446576) inline$$DiemAccount_deposit_$def_verify$0$anon113_Else_correct)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@0  (and (=> (= (ControlFlow 0 446542) 450001) inline$$DiemAccount_deposit_$def_verify$0$anon113_Then_correct) (=> (= (ControlFlow 0 446542) 446576) inline$$DiemAccount_deposit_$def_verify$0$anon113_Else_correct))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0  (=> (= inline$$DiemAccount_exists_at_$def$0$$t2@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (and (=> (= (ControlFlow 0 446526) 446542) inline$$DiemAccount_exists_at_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 446526) 446532) inline$$DiemAccount_exists_at_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 446480) 446526)) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@0  (=> (= (ControlFlow 0 446550) 446526) inline$$DiemAccount_exists_at_$def$0$anon2$1_correct@@0)))
(let ((inline$$DiemAccount_exists_at_$def$0$anon0_correct@@0  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 446474) 446550) inline$$DiemAccount_exists_at_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 446474) 446480) inline$$DiemAccount_exists_at_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$DiemAccount_exists_at_$direct_intra$0$anon0_correct  (=> (and ((_ is $Address) payee) (= (ControlFlow 0 446556) 446474)) inline$$DiemAccount_exists_at_$def$0$anon0_correct@@0)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon111_Then_correct  (=> (and (|b#$Boolean| inline$$Gt$0$dst@1) (= (ControlFlow 0 446564) 446556)) inline$$DiemAccount_exists_at_$direct_intra$0$anon0_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon28_correct  (=> (and (and (= $abort_code@21@@0 $abort_code@4@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 446306) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon112_Else_correct  (=> (and (not true) (= (ControlFlow 0 446304) 446306)) inline$$DiemAccount_deposit_$def_verify$0$anon28_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon112_Then_correct  (=> (= (ControlFlow 0 446318) 446306) inline$$DiemAccount_deposit_$def_verify$0$anon28_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon111_Else_correct  (=> (and (not (|b#$Boolean| inline$$Gt$0$dst@1)) (= $abort_code@4@@2 (|i#$Integer| call3formal@$ret0@0@@21))) (and (=> (= (ControlFlow 0 446298) 446318) inline$$DiemAccount_deposit_$def_verify$0$anon112_Then_correct) (=> (= (ControlFlow 0 446298) 446304) inline$$DiemAccount_deposit_$def_verify$0$anon112_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon109_Else_correct  (=> (not $abort_flag@2@@2) (and (=> (= (ControlFlow 0 446286) 446564) inline$$DiemAccount_deposit_$def_verify$0$anon111_Then_correct) (=> (= (ControlFlow 0 446286) 446298) inline$$DiemAccount_deposit_$def_verify$0$anon111_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon108_Else$1_correct  (=> (and (and (and (= inline$$DiemAccount_deposit_$def_verify$0$$t21@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@2@@2)) (and (=> $abort_flag@2@@2 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@2@@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@21 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@21) (>= (|i#$Integer| call3formal@$ret0@0@@21) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@21) $MAX_U64))) (and (=> (= (ControlFlow 0 446280) 450005) inline$$DiemAccount_deposit_$def_verify$0$anon109_Then_correct) (=> (= (ControlFlow 0 446280) 446286) inline$$DiemAccount_deposit_$def_verify$0$anon109_Else_correct)))))
(let ((inline$$Gt$0$anon0_correct  (=> (and (= inline$$Gt$0$dst@1 ($Boolean (> (|i#$Integer| inline$$GetFieldFromValue$0$dst@1@@1) (|i#$Integer| inline$$DiemAccount_deposit_$def_verify$0$$t19@1)))) (= (ControlFlow 0 446268) 446280)) inline$$DiemAccount_deposit_$def_verify$0$anon108_Else$1_correct)))
(let ((inline$$Gt$0$Entry_correct  (and (=> (= (ControlFlow 0 446254) (- 0 829203)) true) (=> (= (ControlFlow 0 446254) 446268) inline$$Gt$0$anon0_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon108_Else_correct  (=> (not $abort_flag@1@@2) (=> (and (= inline$$DiemAccount_deposit_$def_verify$0$$t19@1 ($Integer 0)) (= (ControlFlow 0 446274) 446254)) inline$$Gt$0$Entry_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon108_Then_correct  (=> $abort_flag@1@@2 (=> (and (and (= $abort_code@21@@0 $abort_code@2@@2) (= $AccountLimits_Window_$memory@2@@1 $AccountLimits_Window_$memory)) (and (= $DiemAccount_Balance_$memory@0@@1 $DiemAccount_Balance_$memory) (= (ControlFlow 0 450025) 446310))) inline$$DiemAccount_deposit_$def_verify$0$Abort_correct))))
(let ((inline$$Diem_value_$def$0$anon6_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 446168) 450025) inline$$DiemAccount_deposit_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 446168) 446274) inline$$DiemAccount_deposit_$def_verify$0$anon108_Else_correct)))))
(let ((inline$$Diem_value_$def$0$anon6_Then_correct@@1  (and (=> (= (ControlFlow 0 446178) 450025) inline$$DiemAccount_deposit_$def_verify$0$anon108_Then_correct) (=> (= (ControlFlow 0 446178) 446274) inline$$DiemAccount_deposit_$def_verify$0$anon108_Else_correct))))
(let ((inline$$GetFieldFromValue$0$anon0_correct@@1  (=> (= inline$$GetFieldFromValue$0$dst@1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (and (=> (= (ControlFlow 0 446152) 446178) inline$$Diem_value_$def$0$anon6_Then_correct@@1) (=> (= (ControlFlow 0 446152) 446168) inline$$Diem_value_$def$0$anon6_Else_correct@@1)))))
(let ((inline$$Diem_value_$def$0$anon5_Else_correct@@1  (=> (and (not true) (= (ControlFlow 0 446076) 446152)) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$0$anon5_Then_correct@@1  (=> (= (ControlFlow 0 446186) 446152) inline$$GetFieldFromValue$0$anon0_correct@@1)))
(let ((inline$$Diem_value_$def$0$anon0_correct@@1  (=> (not $abort_flag@1@@2) (and (=> (= (ControlFlow 0 446070) 446186) inline$$Diem_value_$def$0$anon5_Then_correct@@1) (=> (= (ControlFlow 0 446070) 446076) inline$$Diem_value_$def$0$anon5_Else_correct@@1)))))
(let ((inline$$Diem_value_$direct_inter$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Vector) to_deposit) (let ((va@@151 (|v#$Vector| to_deposit)))
(let ((l@@151 (|l#$ValueArray| va@@151)))
 (and (and (<= 0 l@@151) (<= l@@151 $MAX_U64)) (forall ((x@@151 Int) ) (!  (=> (or (< x@@151 0) (>= x@@151 l@@151)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@151) x@@151))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_deposit)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) $MAX_U64))) true) (= (ControlFlow 0 446192) 446070)) inline$$Diem_value_$def$0$anon0_correct@@1)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon106_Else_correct  (=> (and (not $abort_flag@1@@2) (= (ControlFlow 0 446200) 446192)) inline$$Diem_value_$direct_inter$0$anon0_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon104_Else_correct  (=> (and (and (not $abort_flag@0@@2) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) $abort_flag@1@@2)) (and (=> $abort_flag@1@@2 (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen)))))) (=> $abort_flag@1@@2 (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $AccountFreezing_FreezingBit_is_frozen))))) (= $abort_code@2@@2 (|i#$Integer| ($Integer 1))))))) (and (=> (= (ControlFlow 0 445904) 450029) inline$$DiemAccount_deposit_$def_verify$0$anon106_Then_correct) (=> (= (ControlFlow 0 445904) 446200) inline$$DiemAccount_deposit_$def_verify$0$anon106_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon10$5_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0@@2) (=> (and (=> $abort_flag@0@@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0@@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1@@2 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 445898) 450049) inline$$DiemAccount_deposit_$def_verify$0$anon104_Then_correct) (=> (= (ControlFlow 0 445898) 445904) inline$$DiemAccount_deposit_$def_verify$0$anon104_Else_correct))))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon10_correct  (=> (and (and (= inline$$DiemAccount_deposit_$def_verify$0$$AccountLimits_Window_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr))) true)) (= inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_DiemAccount_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) $EmptyTypeValueArray (|a#$Address| payee) true))) (and (= inline$$DiemAccount_deposit_$def_verify$0$$DiemAccount_Balance_$SelfDomain@1 (|Store_[$TypeValueArray,$int]$bool| ($ConstMemoryDomain false) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee) true)) (= (ControlFlow 0 445760) 445898))) inline$$DiemAccount_deposit_$def_verify$0$anon10$5_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon103_Else_correct  (=> (and (not true) (= (ControlFlow 0 445654) 445760)) inline$$DiemAccount_deposit_$def_verify$0$anon10_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon103_Then_correct  (=> (= (ControlFlow 0 450073) 445760) inline$$DiemAccount_deposit_$def_verify$0$anon10_correct)))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon102_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 445646) 450073) inline$$DiemAccount_deposit_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 445646) 445654) inline$$DiemAccount_deposit_$def_verify$0$anon103_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon102_Then_correct  (and (=> (= (ControlFlow 0 450081) 450073) inline$$DiemAccount_deposit_$def_verify$0$anon103_Then_correct) (=> (= (ControlFlow 0 450081) 445654) inline$$DiemAccount_deposit_$def_verify$0$anon103_Else_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon101_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 445638) 450081) inline$$DiemAccount_deposit_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 445638) 445646) inline$$DiemAccount_deposit_$def_verify$0$anon102_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon101_Then_correct  (and (=> (= (ControlFlow 0 450089) 450081) inline$$DiemAccount_deposit_$def_verify$0$anon102_Then_correct) (=> (= (ControlFlow 0 450089) 445646) inline$$DiemAccount_deposit_$def_verify$0$anon102_Else_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon100_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 445630) 450089) inline$$DiemAccount_deposit_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 445630) 445638) inline$$DiemAccount_deposit_$def_verify$0$anon101_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon100_Then_correct  (and (=> (= (ControlFlow 0 450097) 450089) inline$$DiemAccount_deposit_$def_verify$0$anon101_Then_correct) (=> (= (ControlFlow 0 450097) 445638) inline$$DiemAccount_deposit_$def_verify$0$anon101_Else_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon99_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 445622) 450097) inline$$DiemAccount_deposit_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 445622) 445630) inline$$DiemAccount_deposit_$def_verify$0$anon100_Else_correct)))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon99_Then_correct  (and (=> (= (ControlFlow 0 450105) 450097) inline$$DiemAccount_deposit_$def_verify$0$anon100_Then_correct) (=> (= (ControlFlow 0 450105) 445630) inline$$DiemAccount_deposit_$def_verify$0$anon100_Else_correct))))
(let ((inline$$DiemAccount_deposit_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 445616) 450105) inline$$DiemAccount_deposit_$def_verify$0$anon99_Then_correct) (=> (= (ControlFlow 0 445616) 445622) inline$$DiemAccount_deposit_$def_verify$0$anon99_Else_correct)))))
(let ((anon0$1_correct@@2  (=> (and (forall (($inv_addr@@36 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36)) (let ((va@@152 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))))
(let ((l@@152 (|l#$ValueArray| va@@152)))
 (and (and (<= 0 l@@152) (<= l@@152 $MAX_U64)) (forall ((x@@152 Int) ) (!  (=> (or (< x@@152 0) (>= x@@152 l@@152)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@152) x@@152))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@36))
)) (forall (($inv_addr@@37 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@37)) (let ((va@@153 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@37))))
(let ((l@@153 (|l#$ValueArray| va@@153)))
 (and (and (<= 0 l@@153) (<= l@@153 $MAX_U64)) (forall ((x@@153 Int) ) (!  (=> (or (< x@@153 0) (>= x@@153 l@@153)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@153) x@@153))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@37))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@37))) $AccountFreezing_FreezingBit_is_frozen))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray $inv_addr@@37))
))) (=> (and (and (forall (($inv_addr@@38 Int) ($inv_tv0@@12 T@$TypeValue) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38)) (let ((va@@154 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))))
(let ((l@@154 (|l#$ValueArray| va@@154)))
 (and (and (<= 0 l@@154) (<= l@@154 $MAX_U64)) (forall ((x@@154 Int) ) (!  (=> (or (< x@@154 0) (>= x@@154 l@@154)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@154) x@@154))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) 4)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_time_period)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_time_period)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_time_period)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_holding)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_holding)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_holding)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_inflow)) (|i#$Integer| ($Integer 0))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_outflow)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_time_period)) (|i#$Integer| ($Integer 0)))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))) $AccountLimits_LimitsDefinition_max_holding)) (|i#$Integer| ($Integer 0))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@12) 1) $inv_addr@@38))
)) (forall (($inv_addr@@39 Int) ($inv_tv0@@13 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39)) (let ((va@@155 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))))
(let ((l@@155 (|l#$ValueArray| va@@155)))
 (and (and (<= 0 l@@155) (<= l@@155 $MAX_U64)) (forall ((x@@155 Int) ) (!  (=> (or (< x@@155 0) (>= x@@155 l@@155)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@155) x@@155))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) 5)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_start)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_start)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_start)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_inflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_inflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_inflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_outflow)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_outflow)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_window_outflow)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_tracked_balance)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_tracked_balance)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_tracked_balance)) $MAX_U64))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))) $AccountLimits_Window_limit_address))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@13) 1) $inv_addr@@39))
))) (and (forall (($inv_addr@@40 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40)) (let ((va@@156 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))))
(let ((l@@156 (|l#$ValueArray| va@@156)))
 (and (and (<= 0 l@@156) (<= l@@156 $MAX_U64)) (forall ((x@@156 Int) ) (!  (=> (or (< x@@156 0) (>= x@@156 l@@156)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@156) x@@156))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))) $FixedPoint32_FixedPoint32_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $FixedPoint32_FixedPoint32_$memory) $EmptyTypeValueArray $inv_addr@@40))
)) (forall (($inv_addr@@41 Int) ($inv_tv0@@14 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41)) (let ((va@@157 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))))
(let ((l@@157 (|l#$ValueArray| va@@157)))
 (and (and (<= 0 l@@157) (<= l@@157 $MAX_U64)) (forall ((x@@157 Int) ) (!  (=> (or (< x@@157 0) (>= x@@157 l@@157)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@157) x@@157))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))) $Diem_Diem_value)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_Diem_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@14) 1) $inv_addr@@41))
)))) (=> (and (and (and (forall (($inv_addr@@42 Int) ($inv_tv0@@15 T@$TypeValue) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42)) (let ((va@@158 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))))
(let ((l@@158 (|l#$ValueArray| va@@158)))
 (and (and (<= 0 l@@158) (<= l@@158 $MAX_U64)) (forall ((x@@158 Int) ) (!  (=> (or (< x@@158 0) (>= x@@158 l@@158)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@158) x@@158))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) 13)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_total_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_total_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_total_value)) $MAX_U128))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_value)) $MAX_U64))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate)) (let ((va@@159 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate))))
(let ((l@@159 (|l#$ValueArray| va@@159)))
 (and (and (<= 0 l@@159) (<= l@@159 $MAX_U64)) (forall ((x@@159 Int) ) (!  (=> (or (< x@@159 0) (>= x@@159 l@@159)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@159) x@@159))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_to_xdx_exchange_rate))) $FixedPoint32_FixedPoint32_value)) $MAX_U64)))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_is_synthetic))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_scaling_factor)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_scaling_factor)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_scaling_factor)) $MAX_U64))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_fractional_part)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_fractional_part)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_fractional_part)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code)) (let ((va@@160 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))))
(let ((l@@160 (|l#$ValueArray| va@@160)))
 (and (and (<= 0 l@@160) (<= l@@160 $MAX_U64)) (forall ((x@@160 Int) ) (!  (=> (or (< x@@160 0) (>= x@@160 l@@160)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@160) x@@160))
))))))) (forall (($$0@@36 Int) ) (!  (=> (and (>= $$0@@36 0) (< $$0@@36 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))) $$0@@36)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))) $$0@@36)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))) $$0@@36)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_currency_code))) $$0@@36))
))) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_can_mint))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events)) (let ((va@@161 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))))
(let ((l@@161 (|l#$ValueArray| va@@161)))
 (and (and (<= 0 l@@161) (<= l@@161 $MAX_U64)) (forall ((x@@161 Int) ) (!  (=> (or (< x@@161 0) (>= x@@161 l@@161)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@161) x@@161))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid)) (let ((va@@162 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))
(let ((l@@162 (|l#$ValueArray| va@@162)))
 (and (and (<= 0 l@@162) (<= l@@162 $MAX_U64)) (forall ((x@@162 Int) ) (!  (=> (or (< x@@162 0) (>= x@@162 l@@162)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@162) x@@162))
))))))) (forall (($$0@@37 Int) ) (!  (=> (and (>= $$0@@37 0) (< $$0@@37 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@37)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@37)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@37)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_mint_events))) $Event_EventHandle_guid))) $$0@@37))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events)) (let ((va@@163 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))))
(let ((l@@163 (|l#$ValueArray| va@@163)))
 (and (and (<= 0 l@@163) (<= l@@163 $MAX_U64)) (forall ((x@@163 Int) ) (!  (=> (or (< x@@163 0) (>= x@@163 l@@163)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@163) x@@163))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid)) (let ((va@@164 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))
(let ((l@@164 (|l#$ValueArray| va@@164)))
 (and (and (<= 0 l@@164) (<= l@@164 $MAX_U64)) (forall ((x@@164 Int) ) (!  (=> (or (< x@@164 0) (>= x@@164 l@@164)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@164) x@@164))
))))))) (forall (($$0@@38 Int) ) (!  (=> (and (>= $$0@@38 0) (< $$0@@38 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@38)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@38)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@38)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_burn_events))) $Event_EventHandle_guid))) $$0@@38))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events)) (let ((va@@165 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))))
(let ((l@@165 (|l#$ValueArray| va@@165)))
 (and (and (<= 0 l@@165) (<= l@@165 $MAX_U64)) (forall ((x@@165 Int) ) (!  (=> (or (< x@@165 0) (>= x@@165 l@@165)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@165) x@@165))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid)) (let ((va@@166 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))
(let ((l@@166 (|l#$ValueArray| va@@166)))
 (and (and (<= 0 l@@166) (<= l@@166 $MAX_U64)) (forall ((x@@166 Int) ) (!  (=> (or (< x@@166 0) (>= x@@166 l@@166)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@166) x@@166))
))))))) (forall (($$0@@39 Int) ) (!  (=> (and (>= $$0@@39 0) (< $$0@@39 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@39)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@39)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@39)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_preburn_events))) $Event_EventHandle_guid))) $$0@@39))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events)) (let ((va@@167 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))))
(let ((l@@167 (|l#$ValueArray| va@@167)))
 (and (and (<= 0 l@@167) (<= l@@167 $MAX_U64)) (forall ((x@@167 Int) ) (!  (=> (or (< x@@167 0) (>= x@@167 l@@167)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@167) x@@167))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid)) (let ((va@@168 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))
(let ((l@@168 (|l#$ValueArray| va@@168)))
 (and (and (<= 0 l@@168) (<= l@@168 $MAX_U64)) (forall ((x@@168 Int) ) (!  (=> (or (< x@@168 0) (>= x@@168 l@@168)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@168) x@@168))
))))))) (forall (($$0@@40 Int) ) (!  (=> (and (>= $$0@@40 0) (< $$0@@40 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@40)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@40)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@40)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_cancel_burn_events))) $Event_EventHandle_guid))) $$0@@40))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events)) (let ((va@@169 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))))
(let ((l@@169 (|l#$ValueArray| va@@169)))
 (and (and (<= 0 l@@169) (<= l@@169 $MAX_U64)) (forall ((x@@169 Int) ) (!  (=> (or (< x@@169 0) (>= x@@169 l@@169)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@169) x@@169))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid)) (let ((va@@170 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))
(let ((l@@170 (|l#$ValueArray| va@@170)))
 (and (and (<= 0 l@@170) (<= l@@170 $MAX_U64)) (forall ((x@@170 Int) ) (!  (=> (or (< x@@170 0) (>= x@@170 l@@170)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@170) x@@170))
))))))) (forall (($$0@@41 Int) ) (!  (=> (and (>= $$0@@41 0) (< $$0@@41 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@41)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@41)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@41)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_exchange_rate_update_events))) $Event_EventHandle_guid))) $$0@@41))
)))) (and (and (and (and (and (and true true) true) true) true) true) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (< (|i#$Integer| ($Integer 0)) (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_scaling_factor))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))) $Diem_CurrencyInfo_scaling_factor)) (|i#$Integer| ($Integer 10000000000)))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@15) 1) $inv_addr@@42))
)) (forall (($inv_addr@@43 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@43)) (let ((va@@171 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@43))))
(let ((l@@171 (|l#$ValueArray| va@@171)))
 (and (and (<= 0 l@@171) (<= l@@171 $MAX_U64)) (forall ((x@@171 Int) ) (!  (=> (or (< x@@171 0) (>= x@@171 l@@171)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@171) x@@171))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@43))) 1)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@43))) $VASP_ChildVASP_parent_vasp_addr))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray $inv_addr@@43))
))) (and (forall (($inv_addr@@44 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44)) (let ((va@@172 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))))
(let ((l@@172 (|l#$ValueArray| va@@172)))
 (and (and (<= 0 l@@172) (<= l@@172 $MAX_U64)) (forall ((x@@172 Int) ) (!  (=> (or (< x@@172 0) (>= x@@172 l@@172)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@172) x@@172))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))) $VASP_ParentVASP_num_children)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))) $VASP_ParentVASP_num_children)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))) $VASP_ParentVASP_num_children)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray $inv_addr@@44))
)) (forall (($inv_addr@@45 Int) ) (!  (and (and (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45)) (let ((va@@173 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))))
(let ((l@@173 (|l#$ValueArray| va@@173)))
 (and (and (<= 0 l@@173) (<= l@@173 $MAX_U64)) (forall ((x@@173 Int) ) (!  (=> (or (< x@@173 0) (>= x@@173 l@@173)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@173) x@@173))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name)) (let ((va@@174 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))))
(let ((l@@174 (|l#$ValueArray| va@@174)))
 (and (and (<= 0 l@@174) (<= l@@174 $MAX_U64)) (forall ((x@@174 Int) ) (!  (=> (or (< x@@174 0) (>= x@@174 l@@174)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@174) x@@174))
))))))) (forall (($$0@@42 Int) ) (!  (=> (and (>= $$0@@42 0) (< $$0@@42 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))) $$0@@42)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))) $$0@@42)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))) $$0@@42)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_human_name))) $$0@@42))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url)) (let ((va@@175 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))))
(let ((l@@175 (|l#$ValueArray| va@@175)))
 (and (and (<= 0 l@@175) (<= l@@175 $MAX_U64)) (forall ((x@@175 Int) ) (!  (=> (or (< x@@175 0) (>= x@@175 l@@175)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@175) x@@175))
))))))) (forall (($$0@@43 Int) ) (!  (=> (and (>= $$0@@43 0) (< $$0@@43 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))) $$0@@43)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))) $$0@@43)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))) $$0@@43)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url))) $$0@@43))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key)) (let ((va@@176 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))))
(let ((l@@176 (|l#$ValueArray| va@@176)))
 (and (and (<= 0 l@@176) (<= l@@176 $MAX_U64)) (forall ((x@@176 Int) ) (!  (=> (or (< x@@176 0) (>= x@@176 l@@176)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@176) x@@176))
))))))) (forall (($$0@@44 Int) ) (!  (=> (and (>= $$0@@44 0) (< $$0@@44 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))) $$0@@44)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))) $$0@@44)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))) $$0@@44)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_public_key))) $$0@@44))
))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_expiration_date)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_expiration_date)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_expiration_date)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events)) (let ((va@@177 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))))
(let ((l@@177 (|l#$ValueArray| va@@177)))
 (and (and (<= 0 l@@177) (<= l@@177 $MAX_U64)) (forall ((x@@177 Int) ) (!  (=> (or (< x@@177 0) (>= x@@177 l@@177)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@177) x@@177))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid)) (let ((va@@178 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@178 (|l#$ValueArray| va@@178)))
 (and (and (<= 0 l@@178) (<= l@@178 $MAX_U64)) (forall ((x@@178 Int) ) (!  (=> (or (< x@@178 0) (>= x@@178 l@@178)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@178) x@@178))
))))))) (forall (($$0@@45 Int) ) (!  (=> (and (>= $$0@@45 0) (< $$0@@45 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@45)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@45)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@45)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_compliance_key_rotation_events))) $Event_EventHandle_guid))) $$0@@45))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events)) (let ((va@@179 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))))
(let ((l@@179 (|l#$ValueArray| va@@179)))
 (and (and (<= 0 l@@179) (<= l@@179 $MAX_U64)) (forall ((x@@179 Int) ) (!  (=> (or (< x@@179 0) (>= x@@179 l@@179)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@179) x@@179))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid)) (let ((va@@180 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))
(let ((l@@180 (|l#$ValueArray| va@@180)))
 (and (and (<= 0 l@@180) (<= l@@180 $MAX_U64)) (forall ((x@@180 Int) ) (!  (=> (or (< x@@180 0) (>= x@@180 l@@180)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@180) x@@180))
))))))) (forall (($$0@@46 Int) ) (!  (=> (and (>= $$0@@46 0) (< $$0@@46 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@46)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@46)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@46)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))) $DualAttestation_Credential_base_url_rotation_events))) $Event_EventHandle_guid))) $$0@@46))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray $inv_addr@@45))
)))) (and (and (forall (($inv_addr@@46 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46)) (let ((va@@181 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))))
(let ((l@@181 (|l#$ValueArray| va@@181)))
 (and (and (<= 0 l@@181) (<= l@@181 $MAX_U64)) (forall ((x@@181 Int) ) (!  (=> (or (< x@@181 0) (>= x@@181 l@@181)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@181) x@@181))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DualAttestation_Limit_micro_xdx_limit)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DualAttestation_Limit_micro_xdx_limit)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))) $DualAttestation_Limit_micro_xdx_limit)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray $inv_addr@@46))
)) (forall (($inv_addr@@47 Int) ) (!  (and (and (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47)) (let ((va@@182 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))))
(let ((l@@182 (|l#$ValueArray| va@@182)))
 (and (and (<= 0 l@@182) (<= l@@182 $MAX_U64)) (forall ((x@@182 Int) ) (!  (=> (or (< x@@182 0) (>= x@@182 l@@182)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@182) x@@182))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) 6)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key)) (let ((va@@183 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))))
(let ((l@@183 (|l#$ValueArray| va@@183)))
 (and (and (<= 0 l@@183) (<= l@@183 $MAX_U64)) (forall ((x@@183 Int) ) (!  (=> (or (< x@@183 0) (>= x@@183 l@@183)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@183) x@@183))
))))))) (forall (($$0@@47 Int) ) (!  (=> (and (>= $$0@@47 0) (< $$0@@47 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))) $$0@@47)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))) $$0@@47)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))) $$0@@47)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_authentication_key))) $$0@@47))
))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability)) (let ((va@@184 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability))))
(let ((l@@184 (|l#$ValueArray| va@@184)))
 (and (and (<= 0 l@@184) (<= l@@184 $MAX_U64)) (forall ((x@@184 Int) ) (!  (=> (or (< x@@184 0) (>= x@@184 l@@184)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@184) x@@184))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) (let ((va@@185 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))
(let ((l@@185 (|l#$ValueArray| va@@185)))
 (and (and (<= 0 l@@185) (<= l@@185 $MAX_U64)) (forall ((x@@185 Int) ) (!  (=> (or (< x@@185 0) (>= x@@185 l@@185)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@185) x@@185))
)))))))) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability)) (let ((va@@186 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability))))
(let ((l@@186 (|l#$ValueArray| va@@186)))
 (and (and (<= 0 l@@186) (<= l@@186 $MAX_U64)) (forall ((x@@186 Int) ) (!  (=> (or (< x@@186 0) (>= x@@186 l@@186)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@186) x@@186))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) (let ((va@@187 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))
(let ((l@@187 (|l#$ValueArray| va@@187)))
 (and (and (<= 0 l@@187) (<= l@@187 $MAX_U64)) (forall ((x@@187 Int) ) (!  (=> (or (< x@@187 0) (>= x@@187 l@@187)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@187) x@@187))
)))))))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events)) (let ((va@@188 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))))
(let ((l@@188 (|l#$ValueArray| va@@188)))
 (and (and (<= 0 l@@188) (<= l@@188 $MAX_U64)) (forall ((x@@188 Int) ) (!  (=> (or (< x@@188 0) (>= x@@188 l@@188)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@188) x@@188))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid)) (let ((va@@189 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))
(let ((l@@189 (|l#$ValueArray| va@@189)))
 (and (and (<= 0 l@@189) (<= l@@189 $MAX_U64)) (forall ((x@@189 Int) ) (!  (=> (or (< x@@189 0) (>= x@@189 l@@189)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@189) x@@189))
))))))) (forall (($$0@@48 Int) ) (!  (=> (and (>= $$0@@48 0) (< $$0@@48 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@48)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@48)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@48)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_received_events))) $Event_EventHandle_guid))) $$0@@48))
)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events)) (let ((va@@190 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))))
(let ((l@@190 (|l#$ValueArray| va@@190)))
 (and (and (<= 0 l@@190) (<= l@@190 $MAX_U64)) (forall ((x@@190 Int) ) (!  (=> (or (< x@@190 0) (>= x@@190 l@@190)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@190) x@@190))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid)) (let ((va@@191 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))
(let ((l@@191 (|l#$ValueArray| va@@191)))
 (and (and (<= 0 l@@191) (<= l@@191 $MAX_U64)) (forall ((x@@191 Int) ) (!  (=> (or (< x@@191 0) (>= x@@191 l@@191)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@191) x@@191))
))))))) (forall (($$0@@49 Int) ) (!  (=> (and (>= $$0@@49 0) (< $$0@@49 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@49)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@49)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@49)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sent_events))) $Event_EventHandle_guid))) $$0@@49))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sequence_number)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sequence_number)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_sequence_number)) $MAX_U64))) (and (and (and (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) true) true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray $inv_addr@@47))
))) (and (forall (($inv_addr@@48 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48)) (let ((va@@192 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))))
(let ((l@@192 (|l#$ValueArray| va@@192)))
 (and (and (<= 0 l@@192) (<= l@@192 $MAX_U64)) (forall ((x@@192 Int) ) (!  (=> (or (< x@@192 0) (>= x@@192 l@@192)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@192) x@@192))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) 2)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_limits_cap)) (let ((va@@193 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_limits_cap))))
(let ((l@@193 (|l#$ValueArray| va@@193)))
 (and (and (<= 0 l@@193) (<= l@@193 $MAX_U64)) (forall ((x@@193 Int) ) (!  (=> (or (< x@@193 0) (>= x@@193 l@@193)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@193) x@@193))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_limits_cap))) 1)) ((_ is $Boolean) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_limits_cap))) $AccountLimits_AccountLimitMutationCapability_dummy_field)))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events)) (let ((va@@194 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))))
(let ((l@@194 (|l#$ValueArray| va@@194)))
 (and (and (<= 0 l@@194) (<= l@@194 $MAX_U64)) (forall ((x@@194 Int) ) (!  (=> (or (< x@@194 0) (>= x@@194 l@@194)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@194) x@@194))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid)) (let ((va@@195 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))
(let ((l@@195 (|l#$ValueArray| va@@195)))
 (and (and (<= 0 l@@195) (<= l@@195 $MAX_U64)) (forall ((x@@195 Int) ) (!  (=> (or (< x@@195 0) (>= x@@195 l@@195)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@195) x@@195))
))))))) (forall (($$0@@50 Int) ) (!  (=> (and (>= $$0@@50 0) (< $$0@@50 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@50)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@50)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@50)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))) $DiemAccount_AccountOperationsCapability_creation_events))) $Event_EventHandle_guid))) $$0@@50))
)))) (and true true)) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray $inv_addr@@48))
)) (forall (($inv_addr@@49 Int) ($inv_tv0@@16 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49)) (let ((va@@196 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))))
(let ((l@@196 (|l#$ValueArray| va@@196)))
 (and (and (<= 0 l@@196) (<= l@@196 $MAX_U64)) (forall ((x@@196 Int) ) (!  (=> (or (< x@@196 0) (>= x@@196 l@@196)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@196) x@@196))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) 1)) (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin)) (let ((va@@197 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin))))
(let ((l@@197 (|l#$ValueArray| va@@197)))
 (and (and (<= 0 l@@197) (<= l@@197 $MAX_U64)) (forall ((x@@197 Int) ) (!  (=> (or (< x@@197 0) (>= x@@197 l@@197)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@197) x@@197))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))) $DiemAccount_Balance_coin))) $Diem_Diem_value)) $MAX_U64)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@16) 1) $inv_addr@@49))
))))) (=> (and (and (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezeEventsHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $AccountFreezing_FreezingBit_is_frozen))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453))))) $AccountFreezing_FreezingBit_is_frozen))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((window_addr@@1 T@$Value) )  (=> ((_ is $Address) window_addr@@1) (|b#$Boolean| ($Boolean (forall ((coin_type@@11 T@$Value) )  (=> ((_ is $Type) coin_type@@11) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| window_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $AccountLimits_Window_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@11)) 1) (|a#$Address| window_addr@@1)))) $AccountLimits_Window_limit_address)))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $ChainId_ChainId_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $RegisteredCurrencies_RegisteredCurrencies_type_value) 1) (|a#$Address| ($Address 173345816))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((coin_type@@12 T@$Value) )  (=> ((_ is $Type) coin_type@@12) (|b#$Boolean| ($Boolean (forall ((addr3@@1 T@$Value) )  (=> ((_ is $Address) addr3@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_MintCapability_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| addr3@@1)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| coin_type@@12)) 1) (|a#$Address| ($Address 173345816))))) $Diem_CurrencyInfo_is_synthetic))))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@45 T@$Value) )  (=> ((_ is $Address) addr@@45) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| addr@@45)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@45 ($Address 173345816))))))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $XDX_Reserve_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Diem_CurrencyInfo_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@46 T@$Value) )  (=> ((_ is $Address) addr@@46) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountLimits_LimitsDefinition_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XDX_XDX_type_value) 1) (|a#$Address| addr@@46)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@46 ($Address 173345816))))))))))))))) (and (and (and (and (|b#$Boolean| ($Boolean (forall ((child_addr@@1 T@$Value) )  (=> ((_ is $Address) child_addr@@1) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| child_addr@@1)))) $VASP_ChildVASP_parent_vasp_addr)))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $TransactionFee_TransactionFee_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $XUS_XUS_type_value) 1) (|a#$Address| ($Address 186537453))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $SlidingNonce_SlidingNonce_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 186537453)))))))))) (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Limit_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr1@@8 T@$Value) )  (=> ((_ is $Address) addr1@@8) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr1@@8)))) $Roles_RoleId_role_id) ($Integer 2)))))))))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemTransactionPublishingOption_DiemTransactionPublishingOption_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@47 T@$Value) )  (=> ((_ is $Address) addr@@47) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0)))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@47 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_KeyRotationCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@47)))) $DiemAccount_DiemAccount_key_rotation_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_KeyRotationCapability_account_address)))))))))))))))))))) (and (and (and (|b#$Boolean| ($Boolean (forall ((addr@@48 T@$Value) )  (=> ((_ is $Address) addr@@48) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean ($IsEqual_stratified ($Vector_$length $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec)) ($Integer 0))))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified addr@@48 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| ($Vector_$borrow $DiemAccount_WithdrawCapability_type_value (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@48)))) $DiemAccount_DiemAccount_withdraw_capability))) $Option_Option_vec) ($Integer 0)))) $DiemAccount_WithdrawCapability_account_address))))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_AccountOperationsCapability_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemWriteSetManager_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean (forall ((addr@@49 T@$Value) )  (=> ((_ is $Address) addr@@49) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@49))))))))))))) (and (and (|b#$Boolean| ($Boolean (forall ((token@@2 T@$Value) )  (=> ((_ is $Type) token@@2) (|b#$Boolean| ($Boolean (forall ((addr@@50 T@$Value) )  (=> ((_ is $Address) addr@@50) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_Balance_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| token@@2)) 1) (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) $Roles_RoleId_role_id) ($Integer 5))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) $Roles_RoleId_role_id) ($Integer 6)))))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@50)))) $Roles_RoleId_role_id) ($Integer 2))))))))))))))))))))) (|b#$Boolean| ($Boolean (forall ((addr@@51 T@$Value) )  (=> ((_ is $Address) addr@@51) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DualAttestation_Credential_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) (|b#$Boolean| ($Boolean  (or (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) $Roles_RoleId_role_id) ($Integer 2))))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| addr@@51)))) $Roles_RoleId_role_id) ($Integer 5)))))))))))))))))) (and (|b#$Boolean| ($Boolean (forall ((addr@@52 T@$Value) )  (=> ((_ is $Address) addr@@52) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemAccount_DiemAccount_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52)))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $AccountFreezing_FreezingBit_$memory) $EmptyTypeValueArray (|a#$Address| addr@@52))))))))))) (= (ControlFlow 0 450109) 445616)))))) inline$$DiemAccount_deposit_$def_verify$0$anon0_correct))))))
(let ((anon0_correct@@2  (=> (and ((_ is $Address) payer@@0) ((_ is $Address) payee)) (=> (and (and (and (and (and (and ((_ is $Vector) to_deposit) (let ((va@@198 (|v#$Vector| to_deposit)))
(let ((l@@198 (|l#$ValueArray| va@@198)))
 (and (and (<= 0 l@@198) (<= l@@198 $MAX_U64)) (forall ((x@@198 Int) ) (!  (=> (or (< x@@198 0) (>= x@@198 l@@198)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@198) x@@198))
)))))) (= (|l#$ValueArray| (|v#$Vector| to_deposit)) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| to_deposit)) $Diem_Diem_value)) $MAX_U64))) true) (and (and ((_ is $Vector) metadata@@0) (let ((va@@199 (|v#$Vector| metadata@@0)))
(let ((l@@199 (|l#$ValueArray| va@@199)))
 (and (and (<= 0 l@@199) (<= l@@199 $MAX_U64)) (forall ((x@@199 Int) ) (!  (=> (or (< x@@199 0) (>= x@@199 l@@199)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@199) x@@199))
)))))) (forall (($$0@@51 Int) ) (!  (=> (and (>= $$0@@51 0) (< $$0@@51 (|l#$ValueArray| (|v#$Vector| metadata@@0)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@51)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@51)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@51)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata@@0)) $$0@@51))
)))) (and (and (and ((_ is $Vector) metadata_signature) (let ((va@@200 (|v#$Vector| metadata_signature)))
(let ((l@@200 (|l#$ValueArray| va@@200)))
 (and (and (<= 0 l@@200) (<= l@@200 $MAX_U64)) (forall ((x@@200 Int) ) (!  (=> (or (< x@@200 0) (>= x@@200 l@@200)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@200) x@@200))
)))))) (forall (($$0@@52 Int) ) (!  (=> (and (>= $$0@@52 0) (< $$0@@52 (|l#$ValueArray| (|v#$Vector| metadata_signature)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@52)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@52)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@52)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| metadata_signature)) $$0@@52))
))) (= (ControlFlow 0 442054) 450109))) anon0$1_correct@@2))))
(let ((PreconditionGeneratedEntry_correct@@2  (=> (and (and (|Select_[$TypeValueArray,$int]$bool| $AccountLimits_Window_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| (ite (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $VASP_ParentVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) payee (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $VASP_ChildVASP_$memory) $EmptyTypeValueArray (|a#$Address| payee)))) $VASP_ChildVASP_parent_vasp_addr)))) (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_DiemAccount_$CallerDomain@@1 $EmptyTypeValueArray (|a#$Address| payee))) (and (|Select_[$TypeValueArray,$int]$bool| $DiemAccount_Balance_$CallerDomain ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@15) 1) (|a#$Address| payee)) (= (ControlFlow 0 817864) 442054))) anon0_correct@@2)))
PreconditionGeneratedEntry_correct@@2)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $tv0@@16 () T@$TypeValue)
(declare-fun account@@1 () T@$Value)
(declare-fun $abort_flag@25@@0 () Bool)
(declare-fun $abort_code@29@@0 () Int)
(declare-fun $DiemAccount_Balance_$memory@1@@2 () T@$Memory)
(declare-fun $abort_flag@24@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@27@@0 () Int)
(declare-fun $abort_code@28@@0 () Int)
(declare-fun $DiemAccount_Balance_$memory@0@@2 () T@$Memory)
(declare-fun $abort_code@1@@3 () Int)
(declare-fun $abort_flag@0@@3 () Bool)
(declare-fun $abort_code@21@@1 () Int)
(declare-fun $abort_flag@19@@0 () Bool)
(declare-fun $abort_code@22@@1 () Int)
(declare-fun $abort_flag@20@@0 () Bool)
(declare-fun $abort_code@24@@0 () Int)
(declare-fun $abort_flag@21@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$ta@0 () T@$TypeValueArray)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun inline$$DiemAccount_Balance_pack$0$$struct@1 () T@$Value)
(declare-fun $abort_code@26@@0 () Int)
(declare-fun $abort_flag@23@@0 () Bool)
(declare-fun inline$$Diem_zero_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_flag@22@@0 () Bool)
(declare-fun inline$$Diem_Diem_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$Diem_zero_$def$0$$t0@1 () T@$Value)
(declare-fun inline$$Not$0$dst@1@@1 () T@$Value)
(declare-fun $abort_code@25@@0 () Int)
(declare-fun call3formal@$ret0@0@@22 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def_verify$0$$t12@1 () T@$Value)
(declare-fun inline$$DiemAccount_add_currency_$def_verify$0$$t10@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@23 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@23@@0 () Int)
(declare-fun call3formal@$ret0@0@@24 () T@$Value)
(declare-fun $abort_flag@18@@0 () Bool)
(declare-fun inline$$DiemAccount_add_currency_$def_verify$0$$t8@1 () T@$Value)
(declare-fun $abort_code@20@@2 () Int)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@18@@2 () Int)
(declare-fun $abort_flag@16@@1 () Bool)
(declare-fun $abort_code@17@@2 () Int)
(declare-fun $abort_flag@10@@2 () Bool)
(declare-fun $abort_code@11@@2 () Int)
(declare-fun $abort_flag@5@@2 () Bool)
(declare-fun $abort_code@6@@3 () Int)
(declare-fun $abort_code@19@@2 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$2@1| () T@$Value)
(declare-fun $abort_flag@17@@0 () Bool)
(declare-fun $abort_flag@11@@2 () Bool)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t6@1 () T@$Value)
(declare-fun $abort_code@12@@2 () Int)
(declare-fun |inline$$Roles_can_hold_balance_$def$0$tmp#$1@1| () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@2 () T@$Value)
(declare-fun $abort_flag@15@@1 () Bool)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$ret0@1 () T@$Value)
(declare-fun $abort_code@16@@2 () Int)
(declare-fun $abort_code@13@@2 () Int)
(declare-fun $abort_flag@12@@2 () Bool)
(declare-fun $abort_code@14@@2 () Int)
(declare-fun $abort_flag@13@@2 () Bool)
(declare-fun $abort_flag@14@@1 () Bool)
(declare-fun $abort_code@15@@2 () Int)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$2$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$2$dst@1@@0 () T@$Value)
(declare-fun inline$$Roles_has_designated_dealer_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$2$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$2$a@1 () Int)
(declare-fun inline$$GetGlobal$2$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@25 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$2$$t9@1 () T@$Value)
(declare-fun inline$$Roles_can_hold_balance_$def$0$$t5@1 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@2 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@2 () T@$Value)
(declare-fun $abort_flag@9@@2 () Bool)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$ret0@1 () T@$Value)
(declare-fun $abort_code@10@@2 () Int)
(declare-fun $abort_code@7@@2 () Int)
(declare-fun $abort_flag@6@@2 () Bool)
(declare-fun $abort_code@8@@2 () Int)
(declare-fun $abort_flag@7@@2 () Bool)
(declare-fun $abort_flag@8@@2 () Bool)
(declare-fun $abort_code@9@@2 () Int)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$1$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$1$dst@1@@1 () T@$Value)
(declare-fun inline$$Roles_has_child_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@2 () T@$Value)
(declare-fun inline$$GetGlobal$1$dst@0 () T@$Value)
(declare-fun inline$$GetGlobal$1$a@1 () Int)
(declare-fun inline$$GetGlobal$1$dst@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@26 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$1$$t9@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_flag@4@@3 () Bool)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$ret0@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$ret0@1 () T@$Value)
(declare-fun $abort_code@5@@3 () Int)
(declare-fun $abort_code@2@@3 () Int)
(declare-fun $abort_flag@1@@3 () Bool)
(declare-fun $abort_code@3@@3 () Int)
(declare-fun $abort_flag@2@@3 () Bool)
(declare-fun $abort_flag@3@@3 () Bool)
(declare-fun $abort_code@4@@3 () Int)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@2| () T@$Value)
(declare-fun |inline$$Roles_has_role_$def$0$tmp#$3@1| () T@$Value)
(declare-fun inline$$GetFieldFromValue$0$dst@1@@2 () T@$Value)
(declare-fun inline$$Roles_has_parent_VASP_role_$def$0$$t2@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@2@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst@0@@0 () T@$Value)
(declare-fun inline$$GetGlobal$0$a@1@@2 () Int)
(declare-fun inline$$GetGlobal$0$dst@1@@2 () T@$Value)
(declare-fun call3formal@$ret0@0@@27 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t6@1 () T@$Value)
(declare-fun inline$$Roles_has_role_$def$0$$t9@1 () T@$Value)
(push 1)
(exit)
