(set-info :smt-lib-version 2.6)
(set-logic UFDTNIA)
(set-info :source |

From the test suite for the Move Prover, a verifier for smart contracts in the
Move programming language.  A paper about the tool is here:
https://doi.org/10.1007/978-3-030-53288-8_7

The Move Prover code and tests are available at:
https://github.com/diem/diem/tree/main/language/move-prover

The benchmarks were generated using the master branch and standard test suite
as of Dec 17, 2020.  Submitted by Clark Barrett <barrett@cs.stanford.edu>.

|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")

(declare-sort T@$TypeName 0)
(declare-sort |T@[Int]$TypeValue| 0)
(declare-datatypes ((T@$TypeValue 0)(T@$TypeValueArray 0)) ((($BooleanType ) ($IntegerType ) ($AddressType ) ($StrType ) ($VectorType (|t#$VectorType| T@$TypeValue) ) ($StructType (|name#$StructType| T@$TypeName) (|ts#$StructType| T@$TypeValueArray) ) ($TypeType ) ($ErrorType ) ) (($TypeValueArray (|v#$TypeValueArray| |T@[Int]$TypeValue|) (|l#$TypeValueArray| Int) ) ) ))
(declare-sort |T@[Int]$Value| 0)
(declare-datatypes ((T@$Value 0)(T@$ValueArray 0)) ((($Boolean (|b#$Boolean| Bool) ) ($Integer (|i#$Integer| Int) ) ($Address (|a#$Address| Int) ) ($Vector (|v#$Vector| T@$ValueArray) ) ($Range (|lb#$Range| T@$Value) (|ub#$Range| T@$Value) ) ($Type (|t#$Type| T@$TypeValue) ) ($Error ) ) (($ValueArray (|v#$ValueArray| |T@[Int]$Value|) (|l#$ValueArray| Int) ) ) ))
(declare-sort |T@[$TypeValueArray,Int]Bool| 0)
(declare-sort |T@[$TypeValueArray,Int]$Value| 0)
(declare-datatypes ((T@$Memory 0)) ((($Memory (|domain#$Memory| |T@[$TypeValueArray,Int]Bool|) (|contents#$Memory| |T@[$TypeValueArray,Int]$Value|) ) ) ))
(declare-datatypes ((T@$Location 0)) ((($Global (|ts#$Global| T@$TypeValueArray) (|a#$Global| Int) ) ($Local (|i#$Local| Int) ) ($Param (|i#$Param| Int) ) ) ))
(declare-sort |T@[Int]Int| 0)
(declare-datatypes ((T@$Path 0)) ((($Path (|p#$Path| |T@[Int]Int|) (|size#$Path| Int) ) ) ))
(declare-datatypes ((T@$Mutation 0)) ((($Mutation (|l#$Mutation| T@$Location) (|p#$Mutation| T@$Path) (|v#$Mutation| T@$Value) ) ) ))
(declare-fun $Event_EventHandle () T@$TypeName)
(declare-fun $Event_EventHandleGenerator () T@$TypeName)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds () T@$TypeName)
(declare-fun $Roles_RoleId () T@$TypeName)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig () T@$TypeName)
(declare-fun $Option_Option () T@$TypeName)
(declare-fun $ValidatorConfig_ValidatorConfig () T@$TypeName)
(declare-fun $ValidatorConfig_Config () T@$TypeName)
(declare-fun $DiemConfig_DiemConfig () T@$TypeName)
(declare-fun $DiemConfig_Configuration () T@$TypeName)
(declare-fun $DiemConfig_DisableReconfiguration () T@$TypeName)
(declare-fun $DiemConfig_ModifyConfigCapability () T@$TypeName)
(declare-fun $DiemConfig_NewEpochEvent () T@$TypeName)
(declare-fun $DiemSystem_DiemSystem () T@$TypeName)
(declare-fun $DiemSystem_CapabilityHolder () T@$TypeName)
(declare-fun $DiemSystem_ValidatorInfo () T@$TypeName)
(declare-fun $DiemBlock_BlockMetadata () T@$TypeName)
(declare-fun $DiemBlock_NewBlockEvent () T@$TypeName)
(declare-fun $DebugTrackLocal (Int Int Int T@$Value) Bool)
(declare-fun $DebugTrackAbort (Int Int Int) Bool)
(declare-fun $DebugTrackExp (Int Int T@$Value) T@$Value)
(declare-fun $EmptyPath () T@$Path)
(declare-fun $EmptyTypeValueArray () T@$TypeValueArray)
(declare-fun $MapConstTypeValue (T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun $MAX_U8 () Int)
(declare-fun $MAX_U64 () Int)
(declare-fun $MAX_U128 () Int)
(declare-fun $EmptyValueArray () T@$ValueArray)
(declare-fun $MapConstValue (T@$Value) |T@[Int]$Value|)
(declare-fun $StratificationDepth () Int)
(declare-fun $IsEqual_stratified (T@$Value T@$Value) Bool)
(declare-fun $IsEqual_level1 (T@$Value T@$Value) Bool)
(declare-fun |Select_[$int]$Value| (|T@[Int]$Value| Int) T@$Value)
(declare-fun $IsEqual_level2 (T@$Value T@$Value) Bool)
(declare-fun $ReadValue_stratified (T@$Path T@$Value) T@$Value)
(declare-fun $ReadValue_level1 (T@$Path T@$Value) T@$Value)
(declare-fun |Select_[$int]$int| (|T@[Int]Int| Int) Int)
(declare-fun $ReadValue_level2 (T@$Path T@$Value) T@$Value)
(declare-fun $UpdateValue_stratified (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun |Store_[$int]$Value| (|T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?x2 T@$Value)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$Value|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$Value)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$Value| (|Store_[$int]$Value| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$Value| ?x0 ?y1)))))
(declare-fun $UpdateValue_level1 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $UpdateValue_level2 (T@$Path Int T@$Value T@$Value) T@$Value)
(declare-fun $IsPathPrefix_stratified (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level1 (T@$Path T@$Path) Bool)
(declare-fun $IsPathPrefix_level2 (T@$Path T@$Path) Bool)
(declare-fun $ConcatPath_stratified (T@$Path T@$Path) T@$Path)
(declare-fun $ConcatPath_level1 (T@$Path T@$Path) T@$Path)
(declare-fun |Store_[$int]$int| (|T@[Int]Int| Int Int) |T@[Int]Int|)
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?x2 Int)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]Int|) ( ?x1 Int) ( ?y1 Int) ( ?x2 Int)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$int| (|Store_[$int]$int| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$int| ?x0 ?y1)))))
(declare-fun $ConcatPath_level2 (T@$Path T@$Path) T@$Path)
(declare-fun $ConstMemoryDomain (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun |lambda#5| (Bool) |T@[$TypeValueArray,Int]Bool|)
(declare-fun $EmptyMemory () T@$Memory)
(declare-fun $ConstMemoryContent (T@$Value) |T@[$TypeValueArray,Int]$Value|)
(declare-fun $EXEC_FAILURE_CODE () Int)
(declare-fun $power_of_2 (T@$Value) Int)
(declare-fun $shl (T@$Value T@$Value) T@$Value)
(declare-fun $shr (T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$empty (T@$TypeValue) T@$Value)
(declare-fun $Vector_$push_back (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$pop_back (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$length (T@$TypeValue T@$Value) T@$Value)
(declare-fun $Vector_$borrow (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$borrow_mut (T@$TypeValue T@$Value T@$Value) T@$Value)
(declare-fun $Vector_$swap (T@$TypeValue T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $Hash_sha2_core (T@$Value) T@$Value)
(declare-fun $Hash_sha3_core (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_validate_pubkey (T@$Value) T@$Value)
(declare-fun $Signature_$ed25519_verify (T@$Value T@$Value T@$Value) T@$Value)
(declare-fun $BCS_serialize_core (T@$Value) T@$Value)
(declare-fun $BCS_serialize_core_inv (T@$Value) T@$Value)
(declare-fun $serialized_address_len () Int)
(declare-fun $Event_EventHandle_counter () Int)
(declare-fun $Event_EventHandle_guid () Int)
(declare-fun $Event_EventHandle_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun |Store_[$int]$TypeValue| (|T@[Int]$TypeValue| Int T@$TypeValue) |T@[Int]$TypeValue|)
(declare-fun |Select_[$int]$TypeValue| (|T@[Int]$TypeValue| Int) T@$TypeValue)
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?x2 T@$TypeValue)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?x1)  ?x2)))
(assert (forall ( ( ?x0 |T@[Int]$TypeValue|) ( ?x1 Int) ( ?y1 Int) ( ?x2 T@$TypeValue)) (=>  (not (= ?x1 ?y1)) (= (|Select_[$int]$TypeValue| (|Store_[$int]$TypeValue| ?x0 ?x1 ?x2) ?y1) (|Select_[$int]$TypeValue| ?x0 ?y1)))))
(declare-fun $Event_EventHandleGenerator_counter () Int)
(declare-fun $Event_EventHandleGenerator_addr () Int)
(declare-fun $Event_EventHandleGenerator_type_value () T@$TypeValue)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_microseconds () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_type_value () T@$TypeValue)
(declare-fun $Roles_RoleId_role_id () Int)
(declare-fun $Roles_RoleId_type_value () T@$TypeValue)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name () Int)
(declare-fun $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value () T@$TypeValue)
(declare-fun $Option_Option_vec () Int)
(declare-fun $Option_Option_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $ValidatorConfig_ValidatorConfig_config () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_operator_account () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_human_name () Int)
(declare-fun $ValidatorConfig_ValidatorConfig_type_value () T@$TypeValue)
(declare-fun $ValidatorConfig_Config_consensus_pubkey () Int)
(declare-fun $ValidatorConfig_Config_validator_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_fullnode_network_addresses () Int)
(declare-fun $ValidatorConfig_Config_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DiemConfig_payload () Int)
(declare-fun $DiemConfig_DiemConfig_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_Configuration_epoch () Int)
(declare-fun $DiemConfig_Configuration_last_reconfiguration_time () Int)
(declare-fun $DiemConfig_Configuration_events () Int)
(declare-fun $DiemConfig_Configuration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_DisableReconfiguration_dummy_field () Int)
(declare-fun $DiemConfig_DisableReconfiguration_type_value () T@$TypeValue)
(declare-fun $DiemConfig_ModifyConfigCapability_dummy_field () Int)
(declare-fun $DiemConfig_ModifyConfigCapability_type_value (T@$TypeValue) T@$TypeValue)
(declare-fun $DiemConfig_NewEpochEvent_epoch () Int)
(declare-fun $DiemConfig_NewEpochEvent_type_value () T@$TypeValue)
(declare-fun $DiemSystem_DiemSystem_scheme () Int)
(declare-fun $DiemSystem_DiemSystem_validators () Int)
(declare-fun $DiemSystem_DiemSystem_type_value () T@$TypeValue)
(declare-fun $DiemSystem_CapabilityHolder_cap () Int)
(declare-fun $DiemSystem_CapabilityHolder_type_value () T@$TypeValue)
(declare-fun $DiemSystem_ValidatorInfo_addr () Int)
(declare-fun $DiemSystem_ValidatorInfo_consensus_voting_power () Int)
(declare-fun $DiemSystem_ValidatorInfo_config () Int)
(declare-fun $DiemSystem_ValidatorInfo_last_config_update_time () Int)
(declare-fun $DiemSystem_ValidatorInfo_type_value () T@$TypeValue)
(declare-fun $DiemBlock_BlockMetadata_height () Int)
(declare-fun $DiemBlock_BlockMetadata_new_block_events () Int)
(declare-fun $DiemBlock_BlockMetadata_type_value () T@$TypeValue)
(declare-fun $DiemBlock_NewBlockEvent_round () Int)
(declare-fun $DiemBlock_NewBlockEvent_proposer () Int)
(declare-fun $DiemBlock_NewBlockEvent_previous_block_votes () Int)
(declare-fun $DiemBlock_NewBlockEvent_time_microseconds () Int)
(declare-fun $DiemBlock_NewBlockEvent_type_value () T@$TypeValue)
(declare-fun |lambda#0| (Int Int |T@[Int]$Value| T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#1| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#2| (Int Int Int |T@[Int]$Value| |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#3| (Int Int |T@[Int]$Value| Int Int T@$Value) |T@[Int]$Value|)
(declare-fun |lambda#4| (Int Int |T@[Int]$Value| Int T@$Value) |T@[Int]$Value|)
(declare-fun |Select_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int) Bool)
(assert (distinct $Event_EventHandle $Event_EventHandleGenerator $DiemTimestamp_CurrentTimeMicroseconds $Roles_RoleId $ValidatorOperatorConfig_ValidatorOperatorConfig $Option_Option $ValidatorConfig_ValidatorConfig $ValidatorConfig_Config $DiemConfig_DiemConfig $DiemConfig_Configuration $DiemConfig_DisableReconfiguration $DiemConfig_ModifyConfigCapability $DiemConfig_NewEpochEvent $DiemSystem_DiemSystem $DiemSystem_CapabilityHolder $DiemSystem_ValidatorInfo $DiemBlock_BlockMetadata $DiemBlock_NewBlockEvent)
)
(assert (forall ((file_id Int) (byte_index Int) (var_idx Int) ($Value T@$Value) ) (! (= ($DebugTrackLocal file_id byte_index var_idx $Value) true) :pattern ( ($DebugTrackLocal file_id byte_index var_idx $Value))
)))
(assert (forall ((file_id@@0 Int) (byte_index@@0 Int) (code Int) ) (! (= ($DebugTrackAbort file_id@@0 byte_index@@0 code) true) :pattern ( ($DebugTrackAbort file_id@@0 byte_index@@0 code))
)))
(assert (forall ((module_id Int) (node_id Int) ($Value@@0 T@$Value) ) (! (= ($DebugTrackExp module_id node_id $Value@@0) $Value@@0) :pattern ( ($DebugTrackExp module_id node_id $Value@@0))
)))
(assert (= (|size#$Path| $EmptyPath) 0))
(assert (= (|l#$TypeValueArray| $EmptyTypeValueArray) 0))
(assert (= (|v#$TypeValueArray| $EmptyTypeValueArray) ($MapConstTypeValue $ErrorType)))
(assert (= $MAX_U8 255))
(assert (= $MAX_U64 18446744073709551615))
(assert (= $MAX_U128 340282366920938463463374607431768211455))
(assert (= (|l#$ValueArray| $EmptyValueArray) 0))
(assert (= (|v#$ValueArray| $EmptyValueArray) ($MapConstValue $Error)))
(assert (= $StratificationDepth 4))
(assert (forall ((v1 T@$Value) (v2 T@$Value) ) (! (= ($IsEqual_stratified v1 v2)  (or (= v1 v2) (and (and (and ((_ is $Vector) v1) ((_ is $Vector) v2)) (= (|l#$ValueArray| (|v#$Vector| v1)) (|l#$ValueArray| (|v#$Vector| v2)))) (forall ((i Int) )  (=> (and (<= 0 i) (< i (|l#$ValueArray| (|v#$Vector| v1)))) ($IsEqual_level1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1)) i) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2)) i))))))) :pattern ( ($IsEqual_stratified v1 v2))
)))
(assert (forall ((v1@@0 T@$Value) (v2@@0 T@$Value) ) (! (= ($IsEqual_level1 v1@@0 v2@@0)  (or (= v1@@0 v2@@0) (and (and (and ((_ is $Vector) v1@@0) ((_ is $Vector) v2@@0)) (= (|l#$ValueArray| (|v#$Vector| v1@@0)) (|l#$ValueArray| (|v#$Vector| v2@@0)))) (forall ((i@@0 Int) )  (=> (and (<= 0 i@@0) (< i@@0 (|l#$ValueArray| (|v#$Vector| v1@@0)))) ($IsEqual_level2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@0)) i@@0) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@0)) i@@0))))))) :pattern ( ($IsEqual_level1 v1@@0 v2@@0))
)))
(assert (forall ((v1@@1 T@$Value) (v2@@1 T@$Value) ) (! (= ($IsEqual_level2 v1@@1 v2@@1)  (or (= v1@@1 v2@@1) (and (and (and ((_ is $Vector) v1@@1) ((_ is $Vector) v2@@1)) (= (|l#$ValueArray| (|v#$Vector| v1@@1)) (|l#$ValueArray| (|v#$Vector| v2@@1)))) (forall ((i@@1 Int) )  (=> (and (<= 0 i@@1) (< i@@1 (|l#$ValueArray| (|v#$Vector| v1@@1)))) (= (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v1@@1)) i@@1) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v2@@1)) i@@1))))))) :pattern ( ($IsEqual_level2 v1@@1 v2@@1))
)))
(assert (forall ((p T@$Path) (v T@$Value) ) (! (= ($ReadValue_stratified p v) (ite (= 0 (|size#$Path| p)) v ($ReadValue_level1 p (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v)) (|Select_[$int]$int| (|p#$Path| p) 0))))) :pattern ( ($ReadValue_stratified p v))
)))
(assert (forall ((p@@0 T@$Path) (v@@0 T@$Value) ) (! (= ($ReadValue_level1 p@@0 v@@0) (ite (= 1 (|size#$Path| p@@0)) v@@0 ($ReadValue_level2 p@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@0)) (|Select_[$int]$int| (|p#$Path| p@@0) 1))))) :pattern ( ($ReadValue_level1 p@@0 v@@0))
)))
(assert (forall ((p@@1 T@$Path) (v@@1 T@$Value) ) (! (= ($ReadValue_level2 p@@1 v@@1) (ite (= 2 (|size#$Path| p@@1)) v@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@1)) (|Select_[$int]$int| (|p#$Path| p@@1) 2)))) :pattern ( ($ReadValue_level2 p@@1 v@@1))
)))
(assert (forall ((p@@2 T@$Path) (offset Int) (v@@2 T@$Value) (new_v T@$Value) ) (! (= ($UpdateValue_stratified p@@2 offset v@@2 new_v) (let ((poffset (+ offset 0)))
(ite (= poffset (|size#$Path| p@@2)) new_v ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset) ($UpdateValue_level1 p@@2 offset (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@2)) (|Select_[$int]$int| (|p#$Path| p@@2) poffset)) new_v)) (|l#$ValueArray| (|v#$Vector| v@@2))))))) :pattern ( ($UpdateValue_stratified p@@2 offset v@@2 new_v))
)))
(assert (forall ((p@@3 T@$Path) (offset@@0 Int) (v@@3 T@$Value) (new_v@@0 T@$Value) ) (! (= ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0) (let ((poffset@@0 (+ offset@@0 1)))
(ite (= poffset@@0 (|size#$Path| p@@3)) new_v@@0 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0) ($UpdateValue_level2 p@@3 offset@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@3)) (|Select_[$int]$int| (|p#$Path| p@@3) poffset@@0)) new_v@@0)) (|l#$ValueArray| (|v#$Vector| v@@3))))))) :pattern ( ($UpdateValue_level1 p@@3 offset@@0 v@@3 new_v@@0))
)))
(assert (forall ((p@@4 T@$Path) (offset@@1 Int) (v@@4 T@$Value) (new_v@@1 T@$Value) ) (! (= ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1) (let ((poffset@@1 (+ offset@@1 2)))
(ite (= poffset@@1 (|size#$Path| p@@4)) new_v@@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@4)) (|Select_[$int]$int| (|p#$Path| p@@4) poffset@@1) new_v@@1) (|l#$ValueArray| (|v#$Vector| v@@4))))))) :pattern ( ($UpdateValue_level2 p@@4 offset@@1 v@@4 new_v@@1))
)))
(assert (forall ((p1 T@$Path) (p2 T@$Path) ) (! (= ($IsPathPrefix_stratified p1 p2) (ite (= 0 (|size#$Path| p1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1) 0) (|Select_[$int]$int| (|p#$Path| p2) 0)) ($IsPathPrefix_level1 p1 p2) false))) :pattern ( ($IsPathPrefix_stratified p1 p2))
)))
(assert (forall ((p1@@0 T@$Path) (p2@@0 T@$Path) ) (! (= ($IsPathPrefix_level1 p1@@0 p2@@0) (ite (= 1 (|size#$Path| p1@@0)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@0) 1) (|Select_[$int]$int| (|p#$Path| p2@@0) 1)) ($IsPathPrefix_level2 p1@@0 p2@@0) false))) :pattern ( ($IsPathPrefix_level1 p1@@0 p2@@0))
)))
(assert (forall ((p1@@1 T@$Path) (p2@@1 T@$Path) ) (! (= ($IsPathPrefix_level2 p1@@1 p2@@1) (ite (= 2 (|size#$Path| p1@@1)) true (ite (= (|Select_[$int]$int| (|p#$Path| p1@@1) 2) (|Select_[$int]$int| (|p#$Path| p2@@1) 2)) true false))) :pattern ( ($IsPathPrefix_level2 p1@@1 p2@@1))
)))
(assert (forall ((p1@@2 T@$Path) (p2@@2 T@$Path) ) (! (= ($ConcatPath_stratified p1@@2 p2@@2) (ite (= 0 (|size#$Path| p2@@2)) p1@@2 ($ConcatPath_level1 ($Path (|Store_[$int]$int| (|p#$Path| p1@@2) (|size#$Path| p1@@2) (|Select_[$int]$int| (|p#$Path| p2@@2) 0)) (+ (|size#$Path| p1@@2) 1)) p2@@2))) :pattern ( ($ConcatPath_stratified p1@@2 p2@@2))
)))
(assert (forall ((p1@@3 T@$Path) (p2@@3 T@$Path) ) (! (= ($ConcatPath_level1 p1@@3 p2@@3) (ite (= 1 (|size#$Path| p2@@3)) p1@@3 ($ConcatPath_level2 ($Path (|Store_[$int]$int| (|p#$Path| p1@@3) (|size#$Path| p1@@3) (|Select_[$int]$int| (|p#$Path| p2@@3) 1)) (+ (|size#$Path| p1@@3) 1)) p2@@3))) :pattern ( ($ConcatPath_level1 p1@@3 p2@@3))
)))
(assert (forall ((p1@@4 T@$Path) (p2@@4 T@$Path) ) (! (= ($ConcatPath_level2 p1@@4 p2@@4) (ite (= 2 (|size#$Path| p2@@4)) p1@@4 ($Path (|Store_[$int]$int| (|p#$Path| p1@@4) (|size#$Path| p1@@4) (|Select_[$int]$int| (|p#$Path| p2@@4) 2)) (+ (|size#$Path| p1@@4) 1)))) :pattern ( ($ConcatPath_level2 p1@@4 p2@@4))
)))
(assert (= ($ConstMemoryDomain false) (|lambda#5| false)))
(assert (= ($ConstMemoryDomain true) (|lambda#5| true)))
(assert (= (|domain#$Memory| $EmptyMemory) ($ConstMemoryDomain false)))
(assert (= (|contents#$Memory| $EmptyMemory) ($ConstMemoryContent $Error)))
(assert (= $EXEC_FAILURE_CODE (- 0 1)))
(assert (forall ((power T@$Value) ) (! (= ($power_of_2 power) (let ((p@@5 (|i#$Integer| power)))
(ite (= p@@5 8) 256 (ite (= p@@5 16) 65536 (ite (= p@@5 32) 4294967296 (ite (= p@@5 64) 18446744073709551616 (- 0 1))))))) :pattern ( ($power_of_2 power))
)))
(assert (forall ((src1 T@$Value) (src2 T@$Value) ) (! (= ($shl src1 src2) (let ((po2 ($power_of_2 src2)))
($Integer (* (|i#$Integer| src1) po2)))) :pattern ( ($shl src1 src2))
)))
(assert (forall ((src1@@0 T@$Value) (src2@@0 T@$Value) ) (! (= ($shr src1@@0 src2@@0) (let ((po2@@0 ($power_of_2 src2@@0)))
($Integer (div (|i#$Integer| src1@@0) po2@@0)))) :pattern ( ($shr src1@@0 src2@@0))
)))
(assert (forall ((ta T@$TypeValue) ) (! (= ($Vector_$empty ta) ($Vector $EmptyValueArray)) :pattern ( ($Vector_$empty ta))
)))
(assert (forall ((ta@@0 T@$TypeValue) (v@@5 T@$Value) (val T@$Value) ) (! (= ($Vector_$push_back ta@@0 v@@5 val) ($Vector (let ((len (|l#$ValueArray| (|v#$Vector| v@@5))))
($ValueArray (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@5)) len val) (+ len 1))))) :pattern ( ($Vector_$push_back ta@@0 v@@5 val))
)))
(assert (forall ((ta@@1 T@$TypeValue) (v@@6 T@$Value) ) (! (= ($Vector_$pop_back ta@@1 v@@6) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@6)) (- (|l#$ValueArray| (|v#$Vector| v@@6)) 1))) :pattern ( ($Vector_$pop_back ta@@1 v@@6))
)))
(assert (forall ((ta@@2 T@$TypeValue) (v@@7 T@$Value) ) (! (= ($Vector_$length ta@@2 v@@7) ($Integer (|l#$ValueArray| (|v#$Vector| v@@7)))) :pattern ( ($Vector_$length ta@@2 v@@7))
)))
(assert (forall ((ta@@3 T@$TypeValue) (v@@8 T@$Value) (i@@2 T@$Value) ) (! (= ($Vector_$borrow ta@@3 v@@8 i@@2) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@8)) (|i#$Integer| i@@2))) :pattern ( ($Vector_$borrow ta@@3 v@@8 i@@2))
)))
(assert (forall ((ta@@4 T@$TypeValue) (v@@9 T@$Value) (i@@3 T@$Value) ) (! (= ($Vector_$borrow_mut ta@@4 v@@9 i@@3) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@9)) (|i#$Integer| i@@3))) :pattern ( ($Vector_$borrow_mut ta@@4 v@@9 i@@3))
)))
(assert (forall ((ta@@5 T@$TypeValue) (v@@10 T@$Value) (i@@4 T@$Value) (j T@$Value) ) (! (= ($Vector_$swap ta@@5 v@@10 i@@4 j) ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| j))) (|i#$Integer| j) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@10)) (|i#$Integer| i@@4))) (|l#$ValueArray| (|v#$Vector| v@@10))))) :pattern ( ($Vector_$swap ta@@5 v@@10 i@@4 j))
)))
(assert (forall ((v1@@2 T@$Value) (v2@@2 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@2) (let ((va (|v#$Vector| v1@@2)))
(let ((l (|l#$ValueArray| va)))
 (and (and (<= 0 l) (<= l $MAX_U64)) (forall ((x Int) ) (!  (=> (or (< x 0) (>= x l)) (= (|Select_[$int]$Value| (|v#$ValueArray| va) x) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va) x))
)))))) (and ((_ is $Vector) v2@@2) (let ((va@@0 (|v#$Vector| v2@@2)))
(let ((l@@0 (|l#$ValueArray| va@@0)))
 (and (and (<= 0 l@@0) (<= l@@0 $MAX_U64)) (forall ((x@@0 Int) ) (!  (=> (or (< x@@0 0) (>= x@@0 l@@0)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@0) x@@0))
))))))) ($IsEqual_stratified v1@@2 v2@@2)) ($IsEqual_stratified ($Hash_sha2_core v1@@2) ($Hash_sha2_core v2@@2)))))
(assert (forall ((v1@@3 T@$Value) (v2@@3 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@3) (let ((va@@1 (|v#$Vector| v1@@3)))
(let ((l@@1 (|l#$ValueArray| va@@1)))
 (and (and (<= 0 l@@1) (<= l@@1 $MAX_U64)) (forall ((x@@1 Int) ) (!  (=> (or (< x@@1 0) (>= x@@1 l@@1)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@1) x@@1))
)))))) (and ((_ is $Vector) v2@@3) (let ((va@@2 (|v#$Vector| v2@@3)))
(let ((l@@2 (|l#$ValueArray| va@@2)))
 (and (and (<= 0 l@@2) (<= l@@2 $MAX_U64)) (forall ((x@@2 Int) ) (!  (=> (or (< x@@2 0) (>= x@@2 l@@2)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@2) x@@2))
))))))) ($IsEqual_stratified ($Hash_sha2_core v1@@3) ($Hash_sha2_core v2@@3))) ($IsEqual_stratified v1@@3 v2@@3))))
(assert (forall ((v1@@4 T@$Value) (v2@@4 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@4) (let ((va@@3 (|v#$Vector| v1@@4)))
(let ((l@@3 (|l#$ValueArray| va@@3)))
 (and (and (<= 0 l@@3) (<= l@@3 $MAX_U64)) (forall ((x@@3 Int) ) (!  (=> (or (< x@@3 0) (>= x@@3 l@@3)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@3) x@@3))
)))))) (and ((_ is $Vector) v2@@4) (let ((va@@4 (|v#$Vector| v2@@4)))
(let ((l@@4 (|l#$ValueArray| va@@4)))
 (and (and (<= 0 l@@4) (<= l@@4 $MAX_U64)) (forall ((x@@4 Int) ) (!  (=> (or (< x@@4 0) (>= x@@4 l@@4)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@4) x@@4))
))))))) ($IsEqual_stratified v1@@4 v2@@4)) ($IsEqual_stratified ($Hash_sha3_core v1@@4) ($Hash_sha3_core v2@@4)))))
(assert (forall ((v1@@5 T@$Value) (v2@@5 T@$Value) )  (=> (and (and (and ((_ is $Vector) v1@@5) (let ((va@@5 (|v#$Vector| v1@@5)))
(let ((l@@5 (|l#$ValueArray| va@@5)))
 (and (and (<= 0 l@@5) (<= l@@5 $MAX_U64)) (forall ((x@@5 Int) ) (!  (=> (or (< x@@5 0) (>= x@@5 l@@5)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@5) x@@5))
)))))) (and ((_ is $Vector) v2@@5) (let ((va@@6 (|v#$Vector| v2@@5)))
(let ((l@@6 (|l#$ValueArray| va@@6)))
 (and (and (<= 0 l@@6) (<= l@@6 $MAX_U64)) (forall ((x@@6 Int) ) (!  (=> (or (< x@@6 0) (>= x@@6 l@@6)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@6) x@@6))
))))))) ($IsEqual_stratified ($Hash_sha3_core v1@@5) ($Hash_sha3_core v2@@5))) ($IsEqual_stratified v1@@5 v2@@5))))
(assert (forall ((public_key T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_validate_pubkey public_key))))
(assert (forall ((signature T@$Value) (public_key@@0 T@$Value) (message T@$Value) ) ((_ is $Boolean) ($Signature_$ed25519_verify signature public_key@@0 message))))
(assert (forall ((v1@@6 T@$Value) (v2@@6 T@$Value) )  (=> ($IsEqual_stratified v1@@6 v2@@6) (= ($BCS_serialize_core v1@@6) ($BCS_serialize_core v2@@6)))))
(assert (forall ((v@@11 T@$Value) ) (= ($BCS_serialize_core_inv ($BCS_serialize_core v@@11)) v@@11)))
(assert (forall ((v@@12 T@$Value) ) (let ((r ($BCS_serialize_core v@@12)))
 (and (and (and ((_ is $Vector) r) (let ((va@@7 (|v#$Vector| r)))
(let ((l@@7 (|l#$ValueArray| va@@7)))
 (and (and (<= 0 l@@7) (<= l@@7 $MAX_U64)) (forall ((x@@7 Int) ) (!  (=> (or (< x@@7 0) (>= x@@7 l@@7)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@7) x@@7))
)))))) (forall ((i@@5 Int) ) (!  (=> (and (<= 0 i@@5) (< i@@5 (|l#$ValueArray| (|v#$Vector| r)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| r)) i@@5))
))) (> (|l#$ValueArray| (|v#$Vector| r)) 0)))))
(assert (forall ((v@@13 T@$Value) ) (let ((r@@0 ($BCS_serialize_core v@@13)))
 (=> ((_ is $Address) v@@13) (= (|l#$ValueArray| (|v#$Vector| r@@0)) $serialized_address_len)))))
(assert (= $Event_EventHandle_counter 0))
(assert (= $Event_EventHandle_guid 1))
(assert (forall (($tv0 T@$TypeValue) ) (! (= ($Event_EventHandle_type_value $tv0) ($StructType $Event_EventHandle ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0) 1))) :pattern ( ($Event_EventHandle_type_value $tv0))
)))
(assert (= $Event_EventHandleGenerator_counter 0))
(assert (= $Event_EventHandleGenerator_addr 1))
(assert (= $Event_EventHandleGenerator_type_value ($StructType $Event_EventHandleGenerator $EmptyTypeValueArray)))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_microseconds 0))
(assert (= $DiemTimestamp_CurrentTimeMicroseconds_type_value ($StructType $DiemTimestamp_CurrentTimeMicroseconds $EmptyTypeValueArray)))
(assert (= $Roles_RoleId_role_id 0))
(assert (= $Roles_RoleId_type_value ($StructType $Roles_RoleId $EmptyTypeValueArray)))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_human_name 0))
(assert (= $ValidatorOperatorConfig_ValidatorOperatorConfig_type_value ($StructType $ValidatorOperatorConfig_ValidatorOperatorConfig $EmptyTypeValueArray)))
(assert (= $Option_Option_vec 0))
(assert (forall (($tv0@@0 T@$TypeValue) ) (! (= ($Option_Option_type_value $tv0@@0) ($StructType $Option_Option ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@0) 1))) :pattern ( ($Option_Option_type_value $tv0@@0))
)))
(assert (= $ValidatorConfig_ValidatorConfig_config 0))
(assert (= $ValidatorConfig_ValidatorConfig_operator_account 1))
(assert (= $ValidatorConfig_ValidatorConfig_human_name 2))
(assert (= $ValidatorConfig_ValidatorConfig_type_value ($StructType $ValidatorConfig_ValidatorConfig $EmptyTypeValueArray)))
(assert (= $ValidatorConfig_Config_consensus_pubkey 0))
(assert (= $ValidatorConfig_Config_validator_network_addresses 1))
(assert (= $ValidatorConfig_Config_fullnode_network_addresses 2))
(assert (= $ValidatorConfig_Config_type_value ($StructType $ValidatorConfig_Config $EmptyTypeValueArray)))
(assert (= $DiemConfig_DiemConfig_payload 0))
(assert (forall (($tv0@@1 T@$TypeValue) ) (! (= ($DiemConfig_DiemConfig_type_value $tv0@@1) ($StructType $DiemConfig_DiemConfig ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@1) 1))) :pattern ( ($DiemConfig_DiemConfig_type_value $tv0@@1))
)))
(assert (= $DiemConfig_Configuration_epoch 0))
(assert (= $DiemConfig_Configuration_last_reconfiguration_time 1))
(assert (= $DiemConfig_Configuration_events 2))
(assert (= $DiemConfig_Configuration_type_value ($StructType $DiemConfig_Configuration $EmptyTypeValueArray)))
(assert (= $DiemConfig_DisableReconfiguration_dummy_field 0))
(assert (= $DiemConfig_DisableReconfiguration_type_value ($StructType $DiemConfig_DisableReconfiguration $EmptyTypeValueArray)))
(assert (= $DiemConfig_ModifyConfigCapability_dummy_field 0))
(assert (forall (($tv0@@2 T@$TypeValue) ) (! (= ($DiemConfig_ModifyConfigCapability_type_value $tv0@@2) ($StructType $DiemConfig_ModifyConfigCapability ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $tv0@@2) 1))) :pattern ( ($DiemConfig_ModifyConfigCapability_type_value $tv0@@2))
)))
(assert (= $DiemConfig_NewEpochEvent_epoch 0))
(assert (= $DiemConfig_NewEpochEvent_type_value ($StructType $DiemConfig_NewEpochEvent $EmptyTypeValueArray)))
(assert (= $DiemSystem_DiemSystem_scheme 0))
(assert (= $DiemSystem_DiemSystem_validators 1))
(assert (= $DiemSystem_DiemSystem_type_value ($StructType $DiemSystem_DiemSystem $EmptyTypeValueArray)))
(assert (= $DiemSystem_CapabilityHolder_cap 0))
(assert (= $DiemSystem_CapabilityHolder_type_value ($StructType $DiemSystem_CapabilityHolder $EmptyTypeValueArray)))
(assert (= $DiemSystem_ValidatorInfo_addr 0))
(assert (= $DiemSystem_ValidatorInfo_consensus_voting_power 1))
(assert (= $DiemSystem_ValidatorInfo_config 2))
(assert (= $DiemSystem_ValidatorInfo_last_config_update_time 3))
(assert (= $DiemSystem_ValidatorInfo_type_value ($StructType $DiemSystem_ValidatorInfo $EmptyTypeValueArray)))
(assert (= $DiemBlock_BlockMetadata_height 0))
(assert (= $DiemBlock_BlockMetadata_new_block_events 1))
(assert (= $DiemBlock_BlockMetadata_type_value ($StructType $DiemBlock_BlockMetadata $EmptyTypeValueArray)))
(assert (= $DiemBlock_NewBlockEvent_round 0))
(assert (= $DiemBlock_NewBlockEvent_proposer 1))
(assert (= $DiemBlock_NewBlockEvent_previous_block_votes 2))
(assert (= $DiemBlock_NewBlockEvent_time_microseconds 3))
(assert (= $DiemBlock_NewBlockEvent_type_value ($StructType $DiemBlock_NewBlockEvent $EmptyTypeValueArray)))
(assert (forall ((i@@6 Int) (|l#0| Int) (|l#1| Int) (|l#2| |T@[Int]$Value|) (|l#3| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6) (ite  (and (>= i@@6 |l#0|) (< i@@6 |l#1|)) (|Select_[$int]$Value| |l#2| i@@6) |l#3|)) :pattern ( (|Select_[$int]$Value| (|lambda#0| |l#0| |l#1| |l#2| |l#3|) i@@6))
)))
(assert (forall ((j@@0 Int) (|l#0@@0| Int) (|l#1@@0| Int) (|l#2@@0| Int) (|l#3@@0| |T@[Int]$Value|) (|l#4| |T@[Int]$Value|) (|l#5| Int) (|l#6| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0) (ite  (and (>= j@@0 |l#0@@0|) (< j@@0 |l#1@@0|)) (ite (< j@@0 |l#2@@0|) (|Select_[$int]$Value| |l#3@@0| j@@0) (|Select_[$int]$Value| |l#4| (+ j@@0 |l#5|))) |l#6|)) :pattern ( (|Select_[$int]$Value| (|lambda#1| |l#0@@0| |l#1@@0| |l#2@@0| |l#3@@0| |l#4| |l#5| |l#6|) j@@0))
)))
(assert (forall ((i@@7 Int) (|l#0@@1| Int) (|l#1@@1| Int) (|l#2@@1| Int) (|l#3@@1| |T@[Int]$Value|) (|l#4@@0| |T@[Int]$Value|) (|l#5@@0| Int) (|l#6@@0| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7) (ite  (and (>= i@@7 |l#0@@1|) (< i@@7 |l#1@@1|)) (ite (< i@@7 |l#2@@1|) (|Select_[$int]$Value| |l#3@@1| i@@7) (|Select_[$int]$Value| |l#4@@0| (- i@@7 |l#5@@0|))) |l#6@@0|)) :pattern ( (|Select_[$int]$Value| (|lambda#2| |l#0@@1| |l#1@@1| |l#2@@1| |l#3@@1| |l#4@@0| |l#5@@0| |l#6@@0|) i@@7))
)))
(assert (forall ((i@@8 Int) (|l#0@@2| Int) (|l#1@@2| Int) (|l#2@@2| |T@[Int]$Value|) (|l#3@@2| Int) (|l#4@@1| Int) (|l#5@@1| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8) (ite  (and (<= |l#0@@2| i@@8) (< i@@8 |l#1@@2|)) (|Select_[$int]$Value| |l#2@@2| (- (- |l#3@@2| i@@8) |l#4@@1|)) |l#5@@1|)) :pattern ( (|Select_[$int]$Value| (|lambda#3| |l#0@@2| |l#1@@2| |l#2@@2| |l#3@@2| |l#4@@1| |l#5@@1|) i@@8))
)))
(assert (forall ((k Int) (|l#0@@3| Int) (|l#1@@3| Int) (|l#2@@3| |T@[Int]$Value|) (|l#3@@3| Int) (|l#4@@2| T@$Value) ) (! (= (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k) (ite  (and (<= |l#0@@3| k) (< k |l#1@@3|)) (|Select_[$int]$Value| |l#2@@3| (+ |l#3@@3| k)) |l#4@@2|)) :pattern ( (|Select_[$int]$Value| (|lambda#4| |l#0@@3| |l#1@@3| |l#2@@3| |l#3@@3| |l#4@@2|) k))
)))
(assert (forall ((ta@@6 T@$TypeValueArray) (i@@9 Int) (|l#0@@4| Bool) ) (! (= (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9) |l#0@@4|) :pattern ( (|Select_[$TypeValueArray,$int]$bool| (|lambda#5| |l#0@@4|) ta@@6 i@@9))
)))
(declare-fun ControlFlow (Int Int) Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory () T@$Memory)
(declare-fun $abort_flag@13 () Bool)
(declare-fun vm () T@$Value)
(declare-fun proposer () T@$Value)
(declare-fun |Select_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int) T@$Value)
(declare-fun $DiemConfig_DiemConfig_$memory () T@$Memory)
(declare-fun $DiemBlock_BlockMetadata_$memory () T@$Memory)
(declare-fun $abort_code@19 () Int)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory@2 () T@$Memory)
(declare-fun timestamp () T@$Value)
(declare-fun $DiemBlock_BlockMetadata_$memory@0 () T@$Memory)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 () T@$Memory)
(declare-fun |inline$$WritebackToGlobal$1$m'@2| () T@$Memory)
(declare-fun $abort_code@17 () Int)
(declare-fun $abort_flag@12 () Bool)
(declare-fun inline$$WritebackToGlobal$1$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$1$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$1$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$1$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$2$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$1$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$Value| (|T@[$TypeValueArray,Int]$Value| T@$TypeValueArray Int T@$Value) |T@[$TypeValueArray,Int]$Value|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 T@$Value)) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]$Value|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 T@$Value)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$Value| (|Store_[$TypeValueArray,$int]$Value| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$Value| ?x0 ?y1 ?y2)))))
(declare-fun |inline$$WritebackToReference$1$dst'@2| () T@$Mutation)
(declare-fun |inline$$WriteRef$2$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$2$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$2$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$2$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$trace_temp@2 () T@$Value)
(declare-fun inline$$BorrowField$4$dst@1 () T@$Mutation)
(declare-fun inline$$ReadRef$2$v@1 () T@$Value)
(declare-fun $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 () T@$Memory)
(declare-fun $abort_code@18 () Int)
(declare-fun $abort_code@1 () Int)
(declare-fun $abort_flag@0 () Bool)
(declare-fun $abort_code@2 () Int)
(declare-fun $abort_flag@1 () Bool)
(declare-fun $abort_code@3 () Int)
(declare-fun $abort_flag@2 () Bool)
(declare-fun $abort_code@4 () Int)
(declare-fun $abort_flag@3 () Bool)
(declare-fun $abort_code@6 () Int)
(declare-fun $abort_flag@4 () Bool)
(declare-fun inline$$Event_emit_event$0$t@0 () T@$TypeValue)
(declare-fun round () T@$Value)
(declare-fun previous_block_votes () T@$Value)
(declare-fun inline$$DiemBlock_NewBlockEvent_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$BorrowField$4$p@1 () T@$Path)
(declare-fun inline$$BorrowField$4$size@1 () Int)
(declare-fun inline$$BorrowField$4$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$0$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$1$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$1$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$1$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$1$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$3$dst@1 () T@$Mutation)
(declare-fun inline$$AddU64$0$dst@2 () T@$Value)
(declare-fun inline$$BorrowField$3$p@1 () T@$Path)
(declare-fun inline$$BorrowField$3$size@1 () Int)
(declare-fun inline$$BorrowField$3$p@2 () T@$Path)
(declare-fun inline$$AddU64$0$dst@0 () T@$Value)
(declare-fun inline$$ReadRef$1$v@1 () T@$Value)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$t21@1 () T@$Value)
(declare-fun inline$$AddU64$0$dst@1 () T@$Value)
(declare-fun $abort_flag@11 () Bool)
(declare-fun $abort_code@16 () Int)
(declare-fun inline$$BorrowField$2$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$2$p@1 () T@$Path)
(declare-fun inline$$BorrowField$2$size@1 () Int)
(declare-fun inline$$BorrowField$2$p@2 () T@$Path)
(declare-fun |inline$$WritebackToGlobal$0$m'@2| () T@$Memory)
(declare-fun $abort_code@13 () Int)
(declare-fun $abort_flag@10 () Bool)
(declare-fun inline$$WritebackToGlobal$0$l@1 () T@$Location)
(declare-fun inline$$WritebackToGlobal$0$ta@1 () T@$TypeValueArray)
(declare-fun inline$$WritebackToGlobal$0$a@1 () Int)
(declare-fun inline$$WritebackToGlobal$0$v@1 () T@$Value)
(declare-fun |inline$$WritebackToReference$0$dst'@2| () T@$Mutation)
(declare-fun |inline$$WritebackToGlobal$0$m'@1| () T@$Memory)
(declare-fun inline$$BorrowGlobal$1$dst@2 () T@$Mutation)
(declare-fun |inline$$WriteRef$0$to'@1| () T@$Mutation)
(declare-fun inline$$WritebackToReference$0$dstPath@1 () T@$Path)
(declare-fun inline$$WritebackToReference$0$srcPath@1 () T@$Path)
(declare-fun |inline$$WritebackToReference$0$dst'@1| () T@$Mutation)
(declare-fun inline$$DiemTimestamp_update_global_time_$def$0$$trace_temp@1 () T@$Value)
(declare-fun inline$$BorrowField$1$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$1$p@1 () T@$Path)
(declare-fun inline$$BorrowField$1$size@1 () Int)
(declare-fun inline$$BorrowField$1$p@2 () T@$Path)
(declare-fun inline$$DiemTimestamp_update_global_time_$def$0$$t16@1 () T@$Value)
(declare-fun $abort_flag@8 () Bool)
(declare-fun $abort_code@10 () Int)
(declare-fun inline$$Lt$0$dst@1 () T@$Value)
(declare-fun $abort_flag@9 () Bool)
(declare-fun $abort_code@11 () Int)
(declare-fun $abort_code@15 () Int)
(declare-fun $abort_code@7 () Int)
(declare-fun $abort_flag@5 () Bool)
(declare-fun $abort_code@8 () Int)
(declare-fun $abort_flag@6 () Bool)
(declare-fun $abort_code@9 () Int)
(declare-fun $abort_flag@7 () Bool)
(declare-fun $abort_code@14 () Int)
(declare-fun call3formal@$ret0@0 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def$0$$t15@1 () T@$Value)
(declare-fun inline$$ReadRef$0$v@1 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def$0$$t17@1 () T@$Value)
(declare-fun $abort_code@12 () Int)
(declare-fun call3formal@$ret0@0@@0 () T@$Value)
(declare-fun inline$$DiemTimestamp_update_global_time_$def$0$$t20@1 () T@$Value)
(declare-fun inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$BorrowField$0$dst@1 () T@$Mutation)
(declare-fun inline$$BorrowField$0$p@1 () T@$Path)
(declare-fun inline$$BorrowField$0$size@1 () Int)
(declare-fun inline$$BorrowField$0$p@2 () T@$Path)
(declare-fun inline$$BorrowGlobal$1$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$1$a@1 () Int)
(declare-fun inline$$BorrowGlobal$1$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 () T@$Value)
(declare-fun inline$$BorrowGlobal$0$dst@0 () T@$Mutation)
(declare-fun inline$$BorrowGlobal$0$a@1 () Int)
(declare-fun inline$$BorrowGlobal$0$dst@1 () T@$Mutation)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun |inline$$DiemBlock_block_prologue_$def_verify$0$tmp#$8@1| () T@$Value)
(declare-fun $abort_code@5 () Int)
(declare-fun call3formal@$ret0@0@@1 () T@$Value)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$t17@1 () T@$Value)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$t16@1 () T@$Value)
(declare-fun inline$$DiemBlock_block_prologue_$def_verify$0$$t15@1 () T@$Value)
(declare-fun call3formal@$ret0@0@@2 () T@$Value)
(declare-fun inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 () T@$Value)
(declare-fun $Option_Option_$memory () T@$Memory)
(declare-fun $DiemSystem_DiemSystem_$memory () T@$Memory)
(declare-fun $DiemSystem_ValidatorInfo_$memory () T@$Memory)
(declare-fun $DiemConfig_Configuration_$memory () T@$Memory)
(declare-fun $DiemSystem_CapabilityHolder_$memory () T@$Memory)
(declare-fun $Roles_RoleId_$memory () T@$Memory)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 110918) (let ((anon0$2_correct  (and (=> (= (ControlFlow 0 105401) (- 0 116543)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 105401) (- 0 116557)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) $abort_flag@13) (and (=> (= (ControlFlow 0 105401) (- 0 116574)) (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0 Int) )  (and (and (>= $i_0 0) (< $i_0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((v@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $DiemSystem_ValidatorInfo_addr) proposer))))))))))))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@0 Int) )  (and (and (>= $i_0@@0 0) (< $i_0@@0 (|l#$ValueArray| (|v#$Vector| $range_1)))) (let ((v@@14 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1)) $i_0@@0)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@14)) $DiemSystem_ValidatorInfo_addr) proposer))))))))))))))) $abort_flag@13) (and (=> (= (ControlFlow 0 105401) (- 0 116609)) (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@13)) (=> (=> (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615))))) $abort_flag@13) (and (=> (= (ControlFlow 0 105401) (- 0 116641)) (=> $abort_flag@13 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@1 Int) )  (and (and (>= $i_0@@1 0) (< $i_0@@1 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((v@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@1)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $DiemSystem_ValidatorInfo_addr) proposer)))))))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615)))))))) (=> (=> $abort_flag@13 (or (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0)))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@0 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@0 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@0)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@2 Int) )  (and (and (>= $i_0@@2 0) (< $i_0@@2 (|l#$ValueArray| (|v#$Vector| $range_1@@0)))) (let ((v@@15 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@0)) $i_0@@2)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@15)) $DiemSystem_ValidatorInfo_addr) proposer)))))))))))))))) (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615))))))) (and (=> (= (ControlFlow 0 105401) (- 0 116736)) (=> $abort_flag@13 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) (= $abort_code@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@3 Int) )  (and (and (>= $i_0@@3 0) (< $i_0@@3 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((v@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@3)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $DiemSystem_ValidatorInfo_addr) proposer))))))))))))))) (= $abort_code@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@19 (|i#$Integer| ($Integer (- 0 1)))))))) (=> (=> $abort_flag@13 (or (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@19 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) (= $abort_code@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified proposer ($Address 0))))) (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (let (($range_1@@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@1 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@1)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@4 Int) )  (and (and (>= $i_0@@4 0) (< $i_0@@4 (|l#$ValueArray| (|v#$Vector| $range_1@@1)))) (let ((v@@16 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@1)) $i_0@@4)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@16)) $DiemSystem_ValidatorInfo_addr) proposer))))))))))))))) (= $abort_code@19 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (> (|i#$Integer| ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1))))) (|i#$Integer| ($Integer 18446744073709551615))))) (= $abort_code@19 (|i#$Integer| ($Integer (- 0 1))))))) (and (=> (= (ControlFlow 0 105401) (- 0 116877)) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))))) (=> (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory@2) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp)))) (=> (= (ControlFlow 0 105401) (- 0 116893)) (=> (not $abort_flag@13) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height) ($Integer (+ (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height)) (|i#$Integer| ($Integer 1)))))))))))))))))))))))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon56$2_correct  (and (=> (= (ControlFlow 0 105123) (- 0 116341)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$1$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@2 $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) (=> (and (and (= $abort_code@19 $abort_code@17) (= $abort_flag@13 $abort_flag@12)) (and (= $DiemBlock_BlockMetadata_$memory@0 |inline$$WritebackToGlobal$1$m'@2|) (= (ControlFlow 0 105123) 105401))) anon0$2_correct))))))
(let ((inline$$WritebackToGlobal$1$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$1$l@1)) (=> (and (= |inline$$WritebackToGlobal$1$m'@2| $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 105043) 105123)) inline$$DiemBlock_block_prologue_$def_verify$0$anon56$2_correct))))
(let ((inline$$WritebackToGlobal$1$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$1$l@1) (=> (and (= inline$$WritebackToGlobal$1$ta@1 (|ts#$Global| inline$$WritebackToGlobal$1$l@1)) (= inline$$WritebackToGlobal$1$a@1 (|a#$Global| inline$$WritebackToGlobal$1$l@1))) (=> (and (and (= inline$$WritebackToGlobal$1$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$2$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1) (|v#$Mutation| |inline$$WritebackToReference$2$dst'@2|))) (= |inline$$WritebackToGlobal$1$m'@1| ($Memory (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) inline$$WritebackToGlobal$1$ta@1 inline$$WritebackToGlobal$1$a@1 inline$$WritebackToGlobal$1$v@1)))) (and (= |inline$$WritebackToGlobal$1$m'@2| |inline$$WritebackToGlobal$1$m'@1|) (= (ControlFlow 0 105097) 105123))) inline$$DiemBlock_block_prologue_$def_verify$0$anon56$2_correct)))))
(let ((inline$$WritebackToGlobal$1$anon0_correct  (=> (= inline$$WritebackToGlobal$1$l@1 (|l#$Mutation| |inline$$WritebackToReference$2$dst'@2|)) (and (=> (= (ControlFlow 0 105033) 105097) inline$$WritebackToGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 105033) 105043) inline$$WritebackToGlobal$1$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$2$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1))) (=> (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$1$dst'@2|) (= (ControlFlow 0 104855) 105033)) inline$$WritebackToGlobal$1$anon0_correct))))
(let ((inline$$WritebackToReference$2$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|l#$Mutation| |inline$$WriteRef$2$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|size#$Path| inline$$WritebackToReference$2$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$2$dstPath@1 inline$$WritebackToReference$2$srcPath@1)) (= |inline$$WritebackToReference$2$dst'@1| ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$WritebackToReference$2$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$2$srcPath@1 (|size#$Path| inline$$WritebackToReference$2$dstPath@1) (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|) (|v#$Mutation| |inline$$WriteRef$2$to'@1|))))) (and (= |inline$$WritebackToReference$2$dst'@2| |inline$$WritebackToReference$2$dst'@1|) (= (ControlFlow 0 104911) 105033))) inline$$WritebackToGlobal$1$anon0_correct)))
(let ((inline$$WritebackToReference$2$anon0_correct  (=> (and (= inline$$WritebackToReference$2$srcPath@1 (|p#$Mutation| |inline$$WriteRef$2$to'@1|)) (= inline$$WritebackToReference$2$dstPath@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) (and (=> (= (ControlFlow 0 104819) 104911) inline$$WritebackToReference$2$anon3_Then_correct) (=> (= (ControlFlow 0 104819) 104855) inline$$WritebackToReference$2$anon3_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon84_Else_correct  (=> (and (not true) (= (ControlFlow 0 104682) 104819)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon84_Then_correct  (=> (and (= inline$$DiemBlock_block_prologue_$def_verify$0$$trace_temp@2 (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (= (ControlFlow 0 105133) 104819)) inline$$WritebackToReference$2$anon0_correct)))
(let ((inline$$WriteRef$2$anon0_correct  (=> (= |inline$$WriteRef$2$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$4$dst@1) (|p#$Mutation| inline$$BorrowField$4$dst@1) inline$$ReadRef$2$v@1)) (and (=> (= (ControlFlow 0 104668) 105133) inline$$DiemBlock_block_prologue_$def_verify$0$anon84_Then_correct) (=> (= (ControlFlow 0 104668) 104682) inline$$DiemBlock_block_prologue_$def_verify$0$anon84_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon82_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 104674) 104668)) inline$$WriteRef$2$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@2 $DiemTimestamp_CurrentTimeMicroseconds_$memory@1) (=> (and (and (= $abort_code@19 $abort_code@18) (= $abort_flag@13 true)) (and (= $DiemBlock_BlockMetadata_$memory@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 100181) 105401))) anon0$2_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon13_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@1) (= (ControlFlow 0 105347) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 105345) 105347)) inline$$DiemBlock_block_prologue_$def_verify$0$anon13_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon63_Then_correct  (=> (= (ControlFlow 0 105355) 105347) inline$$DiemBlock_block_prologue_$def_verify$0$anon13_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon62_Then_correct  (=> $abort_flag@0 (and (=> (= (ControlFlow 0 105339) 105355) inline$$DiemBlock_block_prologue_$def_verify$0$anon63_Then_correct) (=> (= (ControlFlow 0 105339) 105345) inline$$DiemBlock_block_prologue_$def_verify$0$anon63_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon17_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@2) (= (ControlFlow 0 105327) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 105325) 105327)) inline$$DiemBlock_block_prologue_$def_verify$0$anon17_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon65_Then_correct  (=> (= (ControlFlow 0 105335) 105327) inline$$DiemBlock_block_prologue_$def_verify$0$anon17_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon64_Then_correct  (=> $abort_flag@1 (and (=> (= (ControlFlow 0 105319) 105335) inline$$DiemBlock_block_prologue_$def_verify$0$anon65_Then_correct) (=> (= (ControlFlow 0 105319) 105325) inline$$DiemBlock_block_prologue_$def_verify$0$anon65_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon27_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@3) (= (ControlFlow 0 105243) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon70_Else_correct  (=> (and (not true) (= (ControlFlow 0 105241) 105243)) inline$$DiemBlock_block_prologue_$def_verify$0$anon27_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon70_Then_correct  (=> (= (ControlFlow 0 105251) 105243) inline$$DiemBlock_block_prologue_$def_verify$0$anon27_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon69_Then_correct  (=> $abort_flag@2 (and (=> (= (ControlFlow 0 105235) 105251) inline$$DiemBlock_block_prologue_$def_verify$0$anon70_Then_correct) (=> (= (ControlFlow 0 105235) 105241) inline$$DiemBlock_block_prologue_$def_verify$0$anon70_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon31_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@4) (= (ControlFlow 0 105223) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon72_Else_correct  (=> (and (not true) (= (ControlFlow 0 105221) 105223)) inline$$DiemBlock_block_prologue_$def_verify$0$anon31_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon72_Then_correct  (=> (= (ControlFlow 0 105231) 105223) inline$$DiemBlock_block_prologue_$def_verify$0$anon31_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon71_Then_correct  (=> $abort_flag@3 (and (=> (= (ControlFlow 0 105215) 105231) inline$$DiemBlock_block_prologue_$def_verify$0$anon72_Then_correct) (=> (= (ControlFlow 0 105215) 105221) inline$$DiemBlock_block_prologue_$def_verify$0$anon72_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon41_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@6) (= (ControlFlow 0 105199) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon77_Else_correct  (=> (and (not true) (= (ControlFlow 0 105197) 105199)) inline$$DiemBlock_block_prologue_$def_verify$0$anon41_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon77_Then_correct  (=> (= (ControlFlow 0 105207) 105199) inline$$DiemBlock_block_prologue_$def_verify$0$anon41_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Then_correct  (=> $abort_flag@4 (and (=> (= (ControlFlow 0 105191) 105207) inline$$DiemBlock_block_prologue_$def_verify$0$anon77_Then_correct) (=> (= (ControlFlow 0 105191) 105197) inline$$DiemBlock_block_prologue_$def_verify$0$anon77_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon47_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) (=> (and (= $abort_code@18 $abort_code@17) (= (ControlFlow 0 105175) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon80_Else_correct  (=> (and (not true) (= (ControlFlow 0 105173) 105175)) inline$$DiemBlock_block_prologue_$def_verify$0$anon47_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon80_Then_correct  (=> (= (ControlFlow 0 105183) 105175) inline$$DiemBlock_block_prologue_$def_verify$0$anon47_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 105167) 105183) inline$$DiemBlock_block_prologue_$def_verify$0$anon80_Then_correct) (=> (= (ControlFlow 0 105167) 105173) inline$$DiemBlock_block_prologue_$def_verify$0$anon80_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon53_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory@0) (=> (and (= $abort_code@18 $abort_code@17) (= (ControlFlow 0 105145) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon83_Else_correct  (=> (and (not true) (= (ControlFlow 0 105143) 105145)) inline$$DiemBlock_block_prologue_$def_verify$0$anon53_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon83_Then_correct  (=> (= (ControlFlow 0 105153) 105145) inline$$DiemBlock_block_prologue_$def_verify$0$anon53_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon82_Then_correct  (=> $abort_flag@12 (and (=> (= (ControlFlow 0 105137) 105153) inline$$DiemBlock_block_prologue_$def_verify$0$anon83_Then_correct) (=> (= (ControlFlow 0 105137) 105143) inline$$DiemBlock_block_prologue_$def_verify$0$anon83_Else_correct)))))
(let ((inline$$Event_emit_event$0$Entry_correct  (=> (= inline$$Event_emit_event$0$t@0 $DiemBlock_NewBlockEvent_type_value) (and (=> (= (ControlFlow 0 104599) 105137) inline$$DiemBlock_block_prologue_$def_verify$0$anon82_Then_correct) (=> (= (ControlFlow 0 104599) 104674) inline$$DiemBlock_block_prologue_$def_verify$0$anon82_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon50$4_correct  (and (=> (= (ControlFlow 0 104609) (- 0 116045)) true) (=> (= (ControlFlow 0 104609) 104599) inline$$Event_emit_event$0$Entry_correct))))
(let ((inline$$ReadRef$2$anon0_correct  (=> (and (= inline$$ReadRef$2$v@1 (|v#$Mutation| inline$$BorrowField$4$dst@1)) (= (ControlFlow 0 104551) 104609)) inline$$DiemBlock_block_prologue_$def_verify$0$anon50$4_correct)))
(let ((inline$$DiemBlock_NewBlockEvent_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 104507) 104551)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemBlock_NewBlockEvent_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 104513) 104551) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemBlock_NewBlockEvent_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 104501) 104513) inline$$DiemBlock_NewBlockEvent_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 104501) 104507) inline$$DiemBlock_NewBlockEvent_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemBlock_NewBlockEvent_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 104493) 104551)) inline$$ReadRef$2$anon0_correct)))
(let ((inline$$DiemBlock_NewBlockEvent_pack$0$anon0_correct  (=> (and (and (and (and (and ((_ is $Integer) round) (>= (|i#$Integer| round) 0)) (<= (|i#$Integer| round) $MAX_U64)) ((_ is $Address) proposer)) (and (and ((_ is $Vector) previous_block_votes) (let ((va@@8 (|v#$Vector| previous_block_votes)))
(let ((l@@8 (|l#$ValueArray| va@@8)))
 (and (and (<= 0 l@@8) (<= l@@8 $MAX_U64)) (forall ((x@@8 Int) ) (!  (=> (or (< x@@8 0) (>= x@@8 l@@8)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@8) x@@8))
)))))) (forall ((inline$$DiemBlock_NewBlockEvent_pack$0$$$0 Int) ) (!  (=> (and (>= inline$$DiemBlock_NewBlockEvent_pack$0$$$0 0) (< inline$$DiemBlock_NewBlockEvent_pack$0$$$0 (|l#$ValueArray| (|v#$Vector| previous_block_votes)))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| previous_block_votes)) inline$$DiemBlock_NewBlockEvent_pack$0$$$0))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| previous_block_votes)) inline$$DiemBlock_NewBlockEvent_pack$0$$$0))
)))) (and (and (and ((_ is $Integer) timestamp) (>= (|i#$Integer| timestamp) 0)) (<= (|i#$Integer| timestamp) $MAX_U64)) (= inline$$DiemBlock_NewBlockEvent_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 round) 1 proposer) 2 previous_block_votes) 3 timestamp) 4))))) (and (=> (= (ControlFlow 0 104485) 104501) inline$$DiemBlock_NewBlockEvent_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 104485) 104493) inline$$DiemBlock_NewBlockEvent_pack$0$anon3_Else_correct)))))
(let ((inline$$BorrowField$4$anon0_correct  (=> (= inline$$BorrowField$4$p@1 (|p#$Mutation| |inline$$WritebackToReference$1$dst'@2|)) (=> (and (and (= inline$$BorrowField$4$size@1 (|size#$Path| inline$$BorrowField$4$p@1)) (= inline$$BorrowField$4$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$4$p@1) inline$$BorrowField$4$size@1 $DiemBlock_BlockMetadata_new_block_events) (+ inline$$BorrowField$4$size@1 1)))) (and (= inline$$BorrowField$4$dst@1 ($Mutation (|l#$Mutation| |inline$$WritebackToReference$1$dst'@2|) inline$$BorrowField$4$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| |inline$$WritebackToReference$1$dst'@2|))) $DiemBlock_BlockMetadata_new_block_events))) (= (ControlFlow 0 104203) 104485))) inline$$DiemBlock_NewBlockEvent_pack$0$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1))) (=> (and (= |inline$$WritebackToReference$1$dst'@2| inline$$BorrowGlobal$0$dst@2) (= (ControlFlow 0 104023) 104203)) inline$$BorrowField$4$anon0_correct))))
(let ((inline$$WritebackToReference$1$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) (|l#$Mutation| |inline$$WriteRef$1$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|size#$Path| inline$$WritebackToReference$1$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$1$dstPath@1 inline$$WritebackToReference$1$srcPath@1)) (= |inline$$WritebackToReference$1$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$WritebackToReference$1$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$1$srcPath@1 (|size#$Path| inline$$WritebackToReference$1$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$0$dst@2) (|v#$Mutation| |inline$$WriteRef$1$to'@1|))))) (and (= |inline$$WritebackToReference$1$dst'@2| |inline$$WritebackToReference$1$dst'@1|) (= (ControlFlow 0 104079) 104203))) inline$$BorrowField$4$anon0_correct)))
(let ((inline$$WritebackToReference$1$anon0_correct  (=> (and (= inline$$WritebackToReference$1$srcPath@1 (|p#$Mutation| |inline$$WriteRef$1$to'@1|)) (= inline$$WritebackToReference$1$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2))) (and (=> (= (ControlFlow 0 103987) 104079) inline$$WritebackToReference$1$anon3_Then_correct) (=> (= (ControlFlow 0 103987) 104023) inline$$WritebackToReference$1$anon3_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon81_Else_correct  (=> (and (not true) (= (ControlFlow 0 103850) 103987)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon81_Then_correct  (=> (and (= inline$$DiemBlock_block_prologue_$def_verify$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$0$dst@2)) (= (ControlFlow 0 105163) 103987)) inline$$WritebackToReference$1$anon0_correct)))
(let ((inline$$WriteRef$1$anon0_correct  (=> (= |inline$$WriteRef$1$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$3$dst@1) (|p#$Mutation| inline$$BorrowField$3$dst@1) inline$$AddU64$0$dst@2)) (and (=> (= (ControlFlow 0 103836) 105163) inline$$DiemBlock_block_prologue_$def_verify$0$anon81_Then_correct) (=> (= (ControlFlow 0 103836) 103850) inline$$DiemBlock_block_prologue_$def_verify$0$anon81_Else_correct)))))
(let ((inline$$BorrowField$3$anon0_correct  (=> (= inline$$BorrowField$3$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$3$size@1 (|size#$Path| inline$$BorrowField$3$p@1)) (= inline$$BorrowField$3$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$3$p@1) inline$$BorrowField$3$size@1 $DiemBlock_BlockMetadata_height) (+ inline$$BorrowField$3$size@1 1)))) (and (= inline$$BorrowField$3$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$3$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemBlock_BlockMetadata_height))) (= (ControlFlow 0 103777) 103836))) inline$$WriteRef$1$anon0_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Else_correct  (=> (and (not $abort_flag@12) (= (ControlFlow 0 103783) 103777)) inline$$BorrowField$3$anon0_correct)))
(let ((inline$$AddU64$0$anon3_Then$1_correct  (=> (= $abort_flag@12 true) (=> (and (= $abort_code@17 $EXEC_FAILURE_CODE) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@0)) (and (=> (= (ControlFlow 0 103647) 105167) inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 103647) 103783) inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$AddU64$0$anon3_Then_correct  (=> (and (> (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$DiemBlock_block_prologue_$def_verify$0$$t21@1)) $MAX_U64) (= (ControlFlow 0 103645) 103647)) inline$$AddU64$0$anon3_Then$1_correct)))
(let ((inline$$AddU64$0$anon3_Else_correct  (=> (>= $MAX_U64 (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$DiemBlock_block_prologue_$def_verify$0$$t21@1))) (=> (and (and (= inline$$AddU64$0$dst@1 ($Integer (+ (|i#$Integer| inline$$ReadRef$1$v@1) (|i#$Integer| inline$$DiemBlock_block_prologue_$def_verify$0$$t21@1)))) (= $abort_flag@12 $abort_flag@11)) (and (= $abort_code@17 $abort_code@16) (= inline$$AddU64$0$dst@2 inline$$AddU64$0$dst@1))) (and (=> (= (ControlFlow 0 103589) 105167) inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Then_correct) (=> (= (ControlFlow 0 103589) 103783) inline$$DiemBlock_block_prologue_$def_verify$0$anon79_Else_correct))))))
(let ((inline$$AddU64$0$Entry_correct  (and (=> (= (ControlFlow 0 103559) (- 0 115509)) true) (and (=> (= (ControlFlow 0 103559) 103645) inline$$AddU64$0$anon3_Then_correct) (=> (= (ControlFlow 0 103559) 103589) inline$$AddU64$0$anon3_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Else$1_correct  (=> (and (= inline$$DiemBlock_block_prologue_$def_verify$0$$t21@1 ($Integer 1)) (= (ControlFlow 0 103653) 103559)) inline$$AddU64$0$Entry_correct)))
(let ((inline$$ReadRef$1$anon0_correct  (=> (and (= inline$$ReadRef$1$v@1 (|v#$Mutation| inline$$BorrowField$2$dst@1)) (= (ControlFlow 0 103448) 103653)) inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Else$1_correct)))
(let ((inline$$BorrowField$2$anon0_correct  (=> (= inline$$BorrowField$2$p@1 (|p#$Mutation| inline$$BorrowGlobal$0$dst@2)) (=> (and (and (= inline$$BorrowField$2$size@1 (|size#$Path| inline$$BorrowField$2$p@1)) (= inline$$BorrowField$2$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$2$p@1) inline$$BorrowField$2$size@1 $DiemBlock_BlockMetadata_height) (+ inline$$BorrowField$2$size@1 1)))) (and (= inline$$BorrowField$2$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$0$dst@2) inline$$BorrowField$2$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$0$dst@2))) $DiemBlock_BlockMetadata_height))) (= (ControlFlow 0 103410) 103448))) inline$$ReadRef$1$anon0_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Else_correct  (=> (and (not $abort_flag@11) (= (ControlFlow 0 103462) 103410)) inline$$BorrowField$2$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Then_correct  (=> (and (and $abort_flag@11 (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory@0)) (and (= $abort_code@18 $abort_code@16) (= (ControlFlow 0 105187) 100181))) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon44$2_correct  (and (=> (= (ControlFlow 0 103032) (- 0 115244)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$WritebackToGlobal$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (= $abort_code@16 $abort_code@13) (=> (and (= $abort_flag@11 $abort_flag@10) (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 |inline$$WritebackToGlobal$0$m'@2|)) (and (=> (= (ControlFlow 0 103032) 105187) inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 103032) 103462) inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Else_correct))))))))
(let ((inline$$WritebackToGlobal$0$anon3_Else_correct  (=> (not ((_ is $Global) inline$$WritebackToGlobal$0$l@1)) (=> (and (= |inline$$WritebackToGlobal$0$m'@2| $DiemTimestamp_CurrentTimeMicroseconds_$memory) (= (ControlFlow 0 102952) 103032)) inline$$DiemTimestamp_update_global_time_$def$0$anon44$2_correct))))
(let ((inline$$WritebackToGlobal$0$anon3_Then_correct  (=> ((_ is $Global) inline$$WritebackToGlobal$0$l@1) (=> (and (= inline$$WritebackToGlobal$0$ta@1 (|ts#$Global| inline$$WritebackToGlobal$0$l@1)) (= inline$$WritebackToGlobal$0$a@1 (|a#$Global| inline$$WritebackToGlobal$0$l@1))) (=> (and (and (= inline$$WritebackToGlobal$0$v@1 ($UpdateValue_stratified (|p#$Mutation| |inline$$WritebackToReference$0$dst'@2|) 0 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1) (|v#$Mutation| |inline$$WritebackToReference$0$dst'@2|))) (= |inline$$WritebackToGlobal$0$m'@1| ($Memory (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) inline$$WritebackToGlobal$0$ta@1 inline$$WritebackToGlobal$0$a@1 inline$$WritebackToGlobal$0$v@1)))) (and (= |inline$$WritebackToGlobal$0$m'@2| |inline$$WritebackToGlobal$0$m'@1|) (= (ControlFlow 0 103006) 103032))) inline$$DiemTimestamp_update_global_time_$def$0$anon44$2_correct)))))
(let ((inline$$WritebackToGlobal$0$anon0_correct  (=> (= inline$$WritebackToGlobal$0$l@1 (|l#$Mutation| |inline$$WritebackToReference$0$dst'@2|)) (and (=> (= (ControlFlow 0 102942) 103006) inline$$WritebackToGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 102942) 102952) inline$$WritebackToGlobal$0$anon3_Else_correct)))))
(let ((inline$$WritebackToReference$0$anon3_Else_correct  (=> (not (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1))) (=> (and (= |inline$$WritebackToReference$0$dst'@2| inline$$BorrowGlobal$1$dst@2) (= (ControlFlow 0 102764) 102942)) inline$$WritebackToGlobal$0$anon0_correct))))
(let ((inline$$WritebackToReference$0$anon3_Then_correct  (=> (and (and (and (and (= (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) (|l#$Mutation| |inline$$WriteRef$0$to'@1|)) (<= (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|size#$Path| inline$$WritebackToReference$0$srcPath@1))) ($IsPathPrefix_stratified inline$$WritebackToReference$0$dstPath@1 inline$$WritebackToReference$0$srcPath@1)) (= |inline$$WritebackToReference$0$dst'@1| ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$WritebackToReference$0$dstPath@1 ($UpdateValue_stratified inline$$WritebackToReference$0$srcPath@1 (|size#$Path| inline$$WritebackToReference$0$dstPath@1) (|v#$Mutation| inline$$BorrowGlobal$1$dst@2) (|v#$Mutation| |inline$$WriteRef$0$to'@1|))))) (and (= |inline$$WritebackToReference$0$dst'@2| |inline$$WritebackToReference$0$dst'@1|) (= (ControlFlow 0 102820) 102942))) inline$$WritebackToGlobal$0$anon0_correct)))
(let ((inline$$WritebackToReference$0$anon0_correct  (=> (and (= inline$$WritebackToReference$0$srcPath@1 (|p#$Mutation| |inline$$WriteRef$0$to'@1|)) (= inline$$WritebackToReference$0$dstPath@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2))) (and (=> (= (ControlFlow 0 102728) 102820) inline$$WritebackToReference$0$anon3_Then_correct) (=> (= (ControlFlow 0 102728) 102764) inline$$WritebackToReference$0$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon66_Else_correct  (=> (and (not true) (= (ControlFlow 0 102591) 102728)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon66_Then_correct  (=> (and (= inline$$DiemTimestamp_update_global_time_$def$0$$trace_temp@1 (|v#$Mutation| inline$$BorrowGlobal$1$dst@2)) (= (ControlFlow 0 103042) 102728)) inline$$WritebackToReference$0$anon0_correct)))
(let ((inline$$WriteRef$0$anon0_correct  (=> (= |inline$$WriteRef$0$to'@1| ($Mutation (|l#$Mutation| inline$$BorrowField$1$dst@1) (|p#$Mutation| inline$$BorrowField$1$dst@1) timestamp)) (and (=> (= (ControlFlow 0 102577) 103042) inline$$DiemTimestamp_update_global_time_$def$0$anon66_Then_correct) (=> (= (ControlFlow 0 102577) 102591) inline$$DiemTimestamp_update_global_time_$def$0$anon66_Else_correct)))))
(let ((inline$$BorrowField$1$anon0_correct  (=> (= inline$$BorrowField$1$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$1$size@1 (|size#$Path| inline$$BorrowField$1$p@1)) (= inline$$BorrowField$1$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$1$p@1) inline$$BorrowField$1$size@1 $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (+ inline$$BorrowField$1$size@1 1)))) (and (= inline$$BorrowField$1$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$1$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))) (= (ControlFlow 0 102518) 102577))) inline$$WriteRef$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon60_Then_correct  (=> (and (and (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def$0$$t16@1) (= $abort_flag@10 $abort_flag@8)) (and (= $abort_code@13 $abort_code@10) (= (ControlFlow 0 103120) 102518))) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon64_Then_correct  (=> (and (and (|b#$Boolean| inline$$Lt$0$dst@1) (= $abort_flag@10 $abort_flag@9)) (and (= $abort_code@13 $abort_code@11) (= (ControlFlow 0 102400) 102518))) inline$$BorrowField$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct  (=> (= $abort_code@16 $abort_code@15) (=> (and (= $abort_flag@11 true) (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@0 $DiemTimestamp_CurrentTimeMicroseconds_$memory)) (and (=> (= (ControlFlow 0 102386) 105187) inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Then_correct) (=> (= (ControlFlow 0 102386) 103462) inline$$DiemBlock_block_prologue_$def_verify$0$anon78_Else_correct))))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon9_correct  (=> (and (= $abort_code@15 $abort_code@7) (= (ControlFlow 0 103208) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon49_Else_correct  (=> (and (not true) (= (ControlFlow 0 103206) 103208)) inline$$DiemTimestamp_update_global_time_$def$0$anon9_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon49_Then_correct  (=> (= (ControlFlow 0 103216) 103208) inline$$DiemTimestamp_update_global_time_$def$0$anon9_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon48_Then_correct  (=> $abort_flag@5 (and (=> (= (ControlFlow 0 103200) 103216) inline$$DiemTimestamp_update_global_time_$def$0$anon49_Then_correct) (=> (= (ControlFlow 0 103200) 103206) inline$$DiemTimestamp_update_global_time_$def$0$anon49_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon13_correct  (=> (and (= $abort_code@15 $abort_code@8) (= (ControlFlow 0 103188) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon51_Else_correct  (=> (and (not true) (= (ControlFlow 0 103186) 103188)) inline$$DiemTimestamp_update_global_time_$def$0$anon13_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon51_Then_correct  (=> (= (ControlFlow 0 103196) 103188) inline$$DiemTimestamp_update_global_time_$def$0$anon13_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon50_Then_correct  (=> $abort_flag@6 (and (=> (= (ControlFlow 0 103180) 103196) inline$$DiemTimestamp_update_global_time_$def$0$anon51_Then_correct) (=> (= (ControlFlow 0 103180) 103186) inline$$DiemTimestamp_update_global_time_$def$0$anon51_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon19_correct  (=> (and (= $abort_code@15 $abort_code@9) (= (ControlFlow 0 103164) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon54_Else_correct  (=> (and (not true) (= (ControlFlow 0 103162) 103164)) inline$$DiemTimestamp_update_global_time_$def$0$anon19_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon54_Then_correct  (=> (= (ControlFlow 0 103172) 103164) inline$$DiemTimestamp_update_global_time_$def$0$anon19_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon53_Then_correct  (=> $abort_flag@7 (and (=> (= (ControlFlow 0 103156) 103172) inline$$DiemTimestamp_update_global_time_$def$0$anon54_Then_correct) (=> (= (ControlFlow 0 103156) 103162) inline$$DiemTimestamp_update_global_time_$def$0$anon54_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon29_correct  (=> (and (= $abort_code@15 $abort_code@10) (= (ControlFlow 0 103132) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon59_Else_correct  (=> (and (not true) (= (ControlFlow 0 103130) 103132)) inline$$DiemTimestamp_update_global_time_$def$0$anon29_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon59_Then_correct  (=> (= (ControlFlow 0 103140) 103132) inline$$DiemTimestamp_update_global_time_$def$0$anon29_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon58_Then_correct  (=> $abort_flag@8 (and (=> (= (ControlFlow 0 103124) 103140) inline$$DiemTimestamp_update_global_time_$def$0$anon59_Then_correct) (=> (= (ControlFlow 0 103124) 103130) inline$$DiemTimestamp_update_global_time_$def$0$anon59_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon34_correct  (=> (and (= $abort_code@15 $abort_code@14) (= (ControlFlow 0 103106) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 103104) 103106)) inline$$DiemTimestamp_update_global_time_$def$0$anon34_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon61_Then_correct  (=> (= (ControlFlow 0 103114) 103106) inline$$DiemTimestamp_update_global_time_$def$0$anon34_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon60_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def$0$$t16@1)) (= $abort_code@14 (|i#$Integer| call3formal@$ret0@0))) (and (=> (= (ControlFlow 0 103098) 103114) inline$$DiemTimestamp_update_global_time_$def$0$anon61_Then_correct) (=> (= (ControlFlow 0 103098) 103104) inline$$DiemTimestamp_update_global_time_$def$0$anon61_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon58_Else_correct  (=> (not $abort_flag@8) (and (=> (= (ControlFlow 0 103086) 103120) inline$$DiemTimestamp_update_global_time_$def$0$anon60_Then_correct) (=> (= (ControlFlow 0 103086) 103098) inline$$DiemTimestamp_update_global_time_$def$0$anon60_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon57_Then_correct  (=> (and (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def$0$$t15@1) (= inline$$DiemTimestamp_update_global_time_$def$0$$t16@1 ($Boolean ($IsEqual_stratified inline$$ReadRef$0$v@1 timestamp)))) (=> (and (and (and (= inline$$DiemTimestamp_update_global_time_$def$0$$t17@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@8)) (and (=> $abort_flag@8 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@8) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0) (>= (|i#$Integer| call3formal@$ret0@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0) $MAX_U64))) (and (=> (= (ControlFlow 0 103080) 103124) inline$$DiemTimestamp_update_global_time_$def$0$anon58_Then_correct) (=> (= (ControlFlow 0 103080) 103086) inline$$DiemTimestamp_update_global_time_$def$0$anon58_Else_correct))))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon37_correct  (=> (and (= $abort_code@15 $abort_code@11) (= (ControlFlow 0 103054) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon63_Else_correct  (=> (and (not true) (= (ControlFlow 0 103052) 103054)) inline$$DiemTimestamp_update_global_time_$def$0$anon37_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon63_Then_correct  (=> (= (ControlFlow 0 103062) 103054) inline$$DiemTimestamp_update_global_time_$def$0$anon37_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon62_Then_correct  (=> $abort_flag@9 (and (=> (= (ControlFlow 0 103046) 103062) inline$$DiemTimestamp_update_global_time_$def$0$anon63_Then_correct) (=> (= (ControlFlow 0 103046) 103052) inline$$DiemTimestamp_update_global_time_$def$0$anon63_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon42_correct  (=> (and (= $abort_code@15 $abort_code@12) (= (ControlFlow 0 102382) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon65_Else_correct  (=> (and (not true) (= (ControlFlow 0 102380) 102382)) inline$$DiemTimestamp_update_global_time_$def$0$anon42_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon65_Then_correct  (=> (= (ControlFlow 0 102394) 102382) inline$$DiemTimestamp_update_global_time_$def$0$anon42_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon64_Else_correct  (=> (and (not (|b#$Boolean| inline$$Lt$0$dst@1)) (= $abort_code@12 (|i#$Integer| call3formal@$ret0@0@@0))) (and (=> (= (ControlFlow 0 102374) 102394) inline$$DiemTimestamp_update_global_time_$def$0$anon65_Then_correct) (=> (= (ControlFlow 0 102374) 102380) inline$$DiemTimestamp_update_global_time_$def$0$anon65_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon62_Else_correct  (=> (not $abort_flag@9) (and (=> (= (ControlFlow 0 102362) 102400) inline$$DiemTimestamp_update_global_time_$def$0$anon64_Then_correct) (=> (= (ControlFlow 0 102362) 102374) inline$$DiemTimestamp_update_global_time_$def$0$anon64_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon57_Else$1_correct  (=> (and (and (and (= inline$$DiemTimestamp_update_global_time_$def$0$$t20@1 ($Integer 2)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@9)) (and (=> $abort_flag@9 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@9) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@0 ($Integer 7))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@0) (>= (|i#$Integer| call3formal@$ret0@0@@0) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@0) $MAX_U64))) (and (=> (= (ControlFlow 0 102356) 103046) inline$$DiemTimestamp_update_global_time_$def$0$anon62_Then_correct) (=> (= (ControlFlow 0 102356) 102362) inline$$DiemTimestamp_update_global_time_$def$0$anon62_Else_correct)))))
(let ((inline$$Lt$0$anon0_correct  (=> (and (= inline$$Lt$0$dst@1 ($Boolean (< (|i#$Integer| inline$$ReadRef$0$v@1) (|i#$Integer| timestamp)))) (= (ControlFlow 0 102344) 102356)) inline$$DiemTimestamp_update_global_time_$def$0$anon57_Else$1_correct)))
(let ((inline$$Lt$0$Entry_correct  (and (=> (= (ControlFlow 0 102330) (- 0 114747)) true) (=> (= (ControlFlow 0 102330) 102344) inline$$Lt$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon57_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemTimestamp_update_global_time_$def$0$$t15@1)) (= (ControlFlow 0 102350) 102330)) inline$$Lt$0$Entry_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon56_Else_correct  (=> (and (not $abort_flag@7) (= inline$$DiemTimestamp_update_global_time_$def$0$$t15@1 ($Boolean ($IsEqual_stratified proposer inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$$t0@1)))) (and (=> (= (ControlFlow 0 102280) 103080) inline$$DiemTimestamp_update_global_time_$def$0$anon57_Then_correct) (=> (= (ControlFlow 0 102280) 102350) inline$$DiemTimestamp_update_global_time_$def$0$anon57_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon56_Then_correct  (=> $abort_flag@7 (=> (and (= $abort_code@15 $abort_code@9) (= (ControlFlow 0 103144) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 102240) 103144) inline$$DiemTimestamp_update_global_time_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 102240) 102280) inline$$DiemTimestamp_update_global_time_$def$0$anon56_Else_correct)))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 102250) 103144) inline$$DiemTimestamp_update_global_time_$def$0$anon56_Then_correct) (=> (= (ControlFlow 0 102250) 102280) inline$$DiemTimestamp_update_global_time_$def$0$anon56_Else_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@7) (= inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$$t0@1 ($Address 0))) (and (=> (= (ControlFlow 0 102234) 102250) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 102234) 102240) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon55_Else_correct  (=> (and (not true) (= (ControlFlow 0 102133) 102234)) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon55_Then_correct  (=> (= (ControlFlow 0 103152) 102234) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$ReadRef$0$anon0_correct  (=> (= inline$$ReadRef$0$v@1 (|v#$Mutation| inline$$BorrowField$0$dst@1)) (and (=> (= (ControlFlow 0 102077) 103152) inline$$DiemTimestamp_update_global_time_$def$0$anon55_Then_correct) (=> (= (ControlFlow 0 102077) 102133) inline$$DiemTimestamp_update_global_time_$def$0$anon55_Else_correct)))))
(let ((inline$$BorrowField$0$anon0_correct  (=> (= inline$$BorrowField$0$p@1 (|p#$Mutation| inline$$BorrowGlobal$1$dst@2)) (=> (and (and (= inline$$BorrowField$0$size@1 (|size#$Path| inline$$BorrowField$0$p@1)) (= inline$$BorrowField$0$p@2 ($Path (|Store_[$int]$int| (|p#$Path| inline$$BorrowField$0$p@1) inline$$BorrowField$0$size@1 $DiemTimestamp_CurrentTimeMicroseconds_microseconds) (+ inline$$BorrowField$0$size@1 1)))) (and (= inline$$BorrowField$0$dst@1 ($Mutation (|l#$Mutation| inline$$BorrowGlobal$1$dst@2) inline$$BorrowField$0$p@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|v#$Mutation| inline$$BorrowGlobal$1$dst@2))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds))) (= (ControlFlow 0 102039) 102077))) inline$$ReadRef$0$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon53_Else_correct  (=> (and (not $abort_flag@7) (= (ControlFlow 0 102091) 102039)) inline$$BorrowField$0$anon0_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Then$1_correct  (=> (= $abort_code@9 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@7 true) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@0)) (and (=> (= (ControlFlow 0 101873) 103156) inline$$DiemTimestamp_update_global_time_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 101873) 102091) inline$$DiemTimestamp_update_global_time_$def$0$anon53_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1)) (= (ControlFlow 0 101871) 101873)) inline$$BorrowGlobal$1$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$1$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) (=> (and (and (= inline$$BorrowGlobal$1$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$1$a@1))) (= $abort_code@9 $abort_code@8)) (and (= $abort_flag@7 $abort_flag@6) (= inline$$BorrowGlobal$1$dst@2 inline$$BorrowGlobal$1$dst@1))) (and (=> (= (ControlFlow 0 101819) 103156) inline$$DiemTimestamp_update_global_time_$def$0$anon53_Then_correct) (=> (= (ControlFlow 0 101819) 102091) inline$$DiemTimestamp_update_global_time_$def$0$anon53_Else_correct))))))
(let ((inline$$BorrowGlobal$1$anon0_correct  (=> (= inline$$BorrowGlobal$1$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1)) (and (=> (= (ControlFlow 0 101789) 101871) inline$$BorrowGlobal$1$anon3_Then_correct) (=> (= (ControlFlow 0 101789) 101819) inline$$BorrowGlobal$1$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$1$Entry_correct  (and (=> (= (ControlFlow 0 101783) (- 0 114380)) true) (=> (= (ControlFlow 0 101783) 101789) inline$$BorrowGlobal$1$anon0_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon52_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 101879) 101783)) inline$$BorrowGlobal$1$Entry_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon52_Then_correct  (=> $abort_flag@6 (=> (and (= $abort_code@15 $abort_code@8) (= (ControlFlow 0 103176) 102386)) inline$$DiemTimestamp_update_global_time_$def$0$Abort_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101652) 103176) inline$$DiemTimestamp_update_global_time_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 101652) 101879) inline$$DiemTimestamp_update_global_time_$def$0$anon52_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct  (and (=> (= (ControlFlow 0 101662) 103176) inline$$DiemTimestamp_update_global_time_$def$0$anon52_Then_correct) (=> (= (ControlFlow 0 101662) 101879) inline$$DiemTimestamp_update_global_time_$def$0$anon52_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct  (=> (and (not $abort_flag@6) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 101646) 101662) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct) (=> (= (ControlFlow 0 101646) 101652) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon50_Else_correct  (=> (and (not $abort_flag@6) (= (ControlFlow 0 101676) 101646)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon48_Else_correct  (=> (and (and (not $abort_flag@5) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) $abort_flag@6)) (and (=> $abort_flag@6 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0)))))) (=> $abort_flag@6 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) (= $abort_code@8 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 101541) 103180) inline$$DiemTimestamp_update_global_time_$def$0$anon50_Then_correct) (=> (= (ControlFlow 0 101541) 101676) inline$$DiemTimestamp_update_global_time_$def$0$anon50_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon6$3_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@5) (=> (and (=> $abort_flag@5 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@5 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@7 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 101535) 103200) inline$$DiemTimestamp_update_global_time_$def$0$anon48_Then_correct) (=> (= (ControlFlow 0 101535) 101541) inline$$DiemTimestamp_update_global_time_$def$0$anon48_Else_correct))))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon47_Else_correct  (=> (and (not true) (= (ControlFlow 0 101431) 101535)) inline$$DiemTimestamp_update_global_time_$def$0$anon6$3_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon47_Then_correct  (=> (= (ControlFlow 0 103224) 101535) inline$$DiemTimestamp_update_global_time_$def$0$anon6$3_correct)))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon46_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101423) 103224) inline$$DiemTimestamp_update_global_time_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 101423) 101431) inline$$DiemTimestamp_update_global_time_$def$0$anon47_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon46_Then_correct  (and (=> (= (ControlFlow 0 103232) 103224) inline$$DiemTimestamp_update_global_time_$def$0$anon47_Then_correct) (=> (= (ControlFlow 0 103232) 101431) inline$$DiemTimestamp_update_global_time_$def$0$anon47_Else_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon45_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 101415) 103232) inline$$DiemTimestamp_update_global_time_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 101415) 101423) inline$$DiemTimestamp_update_global_time_$def$0$anon46_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon45_Then_correct  (and (=> (= (ControlFlow 0 103240) 103232) inline$$DiemTimestamp_update_global_time_$def$0$anon46_Then_correct) (=> (= (ControlFlow 0 103240) 101423) inline$$DiemTimestamp_update_global_time_$def$0$anon46_Else_correct))))
(let ((inline$$DiemTimestamp_update_global_time_$def$0$anon0_correct  (=> (not $abort_flag@4) (and (=> (= (ControlFlow 0 101409) 103240) inline$$DiemTimestamp_update_global_time_$def$0$anon45_Then_correct) (=> (= (ControlFlow 0 101409) 101415) inline$$DiemTimestamp_update_global_time_$def$0$anon45_Else_correct)))))
(let ((inline$$DiemTimestamp_update_global_time_$direct_inter$0$anon0_correct  (=> (and ((_ is $Address) vm) ((_ is $Address) proposer)) (=> (and (and (and ((_ is $Integer) timestamp) (>= (|i#$Integer| timestamp) 0)) (<= (|i#$Integer| timestamp) $MAX_U64)) (and (not (|b#$Boolean| (ite (|b#$Boolean| ($Boolean ($IsEqual_stratified proposer ($Address 0)))) ($Boolean  (not ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds) timestamp))) ($Boolean (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (|i#$Integer| timestamp)))))) (= (ControlFlow 0 103244) 101409))) inline$$DiemTimestamp_update_global_time_$def$0$anon0_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Else_correct  (=> (and (not $abort_flag@4) (= (ControlFlow 0 103250) 103244)) inline$$DiemTimestamp_update_global_time_$direct_inter$0$anon0_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@4 true) (=> (and (= $abort_code@6 $EXEC_FAILURE_CODE) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@0)) (and (=> (= (ControlFlow 0 100521) 105191) inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 100521) 103250) inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1)) (= (ControlFlow 0 100519) 100521)) inline$$BorrowGlobal$0$anon3_Then$1_correct)))
(let ((inline$$BorrowGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) (=> (and (and (= inline$$BorrowGlobal$0$dst@1 ($Mutation ($Global $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1) $EmptyPath (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$BorrowGlobal$0$a@1))) (= $abort_flag@4 $abort_flag@3)) (and (= $abort_code@6 $abort_code@4) (= inline$$BorrowGlobal$0$dst@2 inline$$BorrowGlobal$0$dst@1))) (and (=> (= (ControlFlow 0 100467) 105191) inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Then_correct) (=> (= (ControlFlow 0 100467) 103250) inline$$DiemBlock_block_prologue_$def_verify$0$anon76_Else_correct))))))
(let ((inline$$BorrowGlobal$0$anon0_correct  (=> (= inline$$BorrowGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1)) (and (=> (= (ControlFlow 0 100437) 100519) inline$$BorrowGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 100437) 100467) inline$$BorrowGlobal$0$anon3_Else_correct)))))
(let ((inline$$BorrowGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 100431) (- 0 113889)) true) (=> (= (ControlFlow 0 100431) 100437) inline$$BorrowGlobal$0$anon0_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Else_correct  (=> (and (not $abort_flag@3) (= (ControlFlow 0 100527) 100431)) inline$$BorrowGlobal$0$Entry_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Then_correct  (=> (and (and $abort_flag@3 (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory)) (and (= $abort_code@18 $abort_code@4) (= (ControlFlow 0 105211) 100181))) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 100300) 105211) inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 100300) 100527) inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 100310) 105211) inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Then_correct) (=> (= (ControlFlow 0 100310) 100527) inline$$DiemBlock_block_prologue_$def_verify$0$anon75_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@3) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 100294) 100310) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 100294) 100300) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon73_Then_correct  (=> (and (|b#$Boolean| |inline$$DiemBlock_block_prologue_$def_verify$0$tmp#$8@1|) (= (ControlFlow 0 100324) 100294)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon36_correct  (=> (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory) (=> (and (= $abort_code@18 $abort_code@5) (= (ControlFlow 0 100177) 100181)) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon74_Else_correct  (=> (and (not true) (= (ControlFlow 0 100175) 100177)) inline$$DiemBlock_block_prologue_$def_verify$0$anon36_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon74_Then_correct  (=> (= (ControlFlow 0 100189) 100177) inline$$DiemBlock_block_prologue_$def_verify$0$anon36_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon73_Else_correct  (=> (and (not (|b#$Boolean| |inline$$DiemBlock_block_prologue_$def_verify$0$tmp#$8@1|)) (= $abort_code@5 (|i#$Integer| call3formal@$ret0@0@@1))) (and (=> (= (ControlFlow 0 100169) 100189) inline$$DiemBlock_block_prologue_$def_verify$0$anon74_Then_correct) (=> (= (ControlFlow 0 100169) 100175) inline$$DiemBlock_block_prologue_$def_verify$0$anon74_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon71_Else_correct  (=> (not $abort_flag@3) (and (=> (= (ControlFlow 0 100157) 100324) inline$$DiemBlock_block_prologue_$def_verify$0$anon73_Then_correct) (=> (= (ControlFlow 0 100157) 100169) inline$$DiemBlock_block_prologue_$def_verify$0$anon73_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$L3_correct  (=> (and (and (and (= inline$$DiemBlock_block_prologue_$def_verify$0$$t17@1 ($Integer 1)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3)) (and (=> $abort_flag@3 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@1 ($Integer 2))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@1) (>= (|i#$Integer| call3formal@$ret0@0@@1) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@1) $MAX_U64))) (and (=> (= (ControlFlow 0 100151) 105215) inline$$DiemBlock_block_prologue_$def_verify$0$anon71_Then_correct) (=> (= (ControlFlow 0 100151) 100157) inline$$DiemBlock_block_prologue_$def_verify$0$anon71_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon24_correct  (=> (and (= |inline$$DiemBlock_block_prologue_$def_verify$0$tmp#$8@1| inline$$DiemBlock_block_prologue_$def_verify$0$$t16@1) (= (ControlFlow 0 105303) 100151)) inline$$DiemBlock_block_prologue_$def_verify$0$L3_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon68_Else_correct  (=> (and (not true) (= (ControlFlow 0 105301) 105303)) inline$$DiemBlock_block_prologue_$def_verify$0$anon24_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon68_Then_correct  (=> (= (ControlFlow 0 105311) 105303) inline$$DiemBlock_block_prologue_$def_verify$0$anon24_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon67_Then_correct  (=> (and (|b#$Boolean| inline$$DiemBlock_block_prologue_$def_verify$0$$t15@1) (= inline$$DiemBlock_block_prologue_$def_verify$0$$t16@1 ($Boolean true))) (and (=> (= (ControlFlow 0 105293) 105311) inline$$DiemBlock_block_prologue_$def_verify$0$anon68_Then_correct) (=> (= (ControlFlow 0 105293) 105301) inline$$DiemBlock_block_prologue_$def_verify$0$anon68_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon69_Else_correct  (=> (not $abort_flag@2) (=> (and (= |inline$$DiemBlock_block_prologue_$def_verify$0$tmp#$8@1| call3formal@$ret0@0@@2) (= (ControlFlow 0 100145) 100151)) inline$$DiemBlock_block_prologue_$def_verify$0$L3_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon67_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemBlock_block_prologue_$def_verify$0$$t15@1)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) $abort_flag@2)) (=> (and (and (=> $abort_flag@2 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@2 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816)))))))) (= $abort_code@3 (|i#$Integer| ($Integer 5)))))) (and (=> (not $abort_flag@2) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@2 ($Boolean (let (($range_1@@2 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@2 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@2)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))
(exists (($i_0@@5 Int) )  (and (and (>= $i_0@@5 0) (< $i_0@@5 (|l#$ValueArray| (|v#$Vector| $range_1@@2)))) (let ((v@@17 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| $range_1@@2)) $i_0@@5)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| v@@17)) $DiemSystem_ValidatorInfo_addr) proposer)))))))))))) ((_ is $Boolean) call3formal@$ret0@0@@2))) (and (=> (= (ControlFlow 0 100139) 105235) inline$$DiemBlock_block_prologue_$def_verify$0$anon69_Then_correct) (=> (= (ControlFlow 0 100139) 100145) inline$$DiemBlock_block_prologue_$def_verify$0$anon69_Else_correct))))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Else_correct  (=> (and (not $abort_flag@1) (= inline$$DiemBlock_block_prologue_$def_verify$0$$t15@1 ($Boolean ($IsEqual_stratified proposer inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1)))) (and (=> (= (ControlFlow 0 100131) 105293) inline$$DiemBlock_block_prologue_$def_verify$0$anon67_Then_correct) (=> (= (ControlFlow 0 100131) 100139) inline$$DiemBlock_block_prologue_$def_verify$0$anon67_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Then_correct  (=> (and (and $abort_flag@1 (= $DiemTimestamp_CurrentTimeMicroseconds_$memory@1 $DiemTimestamp_CurrentTimeMicroseconds_$memory)) (and (= $abort_code@18 $abort_code@2) (= (ControlFlow 0 105315) 100181))) inline$$DiemBlock_block_prologue_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 100091) 105315) inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 100091) 100131) inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Else_correct)))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct  (and (=> (= (ControlFlow 0 100101) 105315) inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Then_correct) (=> (= (ControlFlow 0 100101) 100131) inline$$DiemBlock_block_prologue_$def_verify$0$anon66_Else_correct))))
(let ((inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct  (=> (and (not $abort_flag@1) (= inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$$t0@1 ($Address 0))) (and (=> (= (ControlFlow 0 100085) 100101) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Then_correct) (=> (= (ControlFlow 0 100085) 100091) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon3_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon64_Else_correct  (=> (and (not $abort_flag@1) (= (ControlFlow 0 100115) 100085)) inline$$CoreAddresses_VM_RESERVED_ADDRESS_$def$0$anon0_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon62_Else_correct  (=> (and (and (not $abort_flag@0) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) $abort_flag@1)) (and (=> $abort_flag@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0)))))) (=> $abort_flag@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified vm ($Address 0))))) (= $abort_code@2 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 99980) 105319) inline$$DiemBlock_block_prologue_$def_verify$0$anon64_Then_correct) (=> (= (ControlFlow 0 99980) 100115) inline$$DiemBlock_block_prologue_$def_verify$0$anon64_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon10$5_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) $abort_flag@0) (=> (and (=> $abort_flag@0 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> $abort_flag@0 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= $abort_code@1 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 99974) 105339) inline$$DiemBlock_block_prologue_$def_verify$0$anon62_Then_correct) (=> (= (ControlFlow 0 99974) 99980) inline$$DiemBlock_block_prologue_$def_verify$0$anon62_Else_correct))))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Else_correct  (=> (and (not true) (= (ControlFlow 0 99802) 99974)) inline$$DiemBlock_block_prologue_$def_verify$0$anon10$5_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Then_correct  (=> (= (ControlFlow 0 105363) 99974) inline$$DiemBlock_block_prologue_$def_verify$0$anon10$5_correct)))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 99794) 105363) inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 99794) 99802) inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Then_correct  (and (=> (= (ControlFlow 0 105371) 105363) inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Then_correct) (=> (= (ControlFlow 0 105371) 99802) inline$$DiemBlock_block_prologue_$def_verify$0$anon61_Else_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 99786) 105371) inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 99786) 99794) inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Then_correct  (and (=> (= (ControlFlow 0 105379) 105371) inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Then_correct) (=> (= (ControlFlow 0 105379) 99794) inline$$DiemBlock_block_prologue_$def_verify$0$anon60_Else_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 99778) 105379) inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 99778) 99786) inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Then_correct  (and (=> (= (ControlFlow 0 105387) 105379) inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Then_correct) (=> (= (ControlFlow 0 105387) 99786) inline$$DiemBlock_block_prologue_$def_verify$0$anon59_Else_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon57_Else_correct  (=> (not true) (and (=> (= (ControlFlow 0 99770) 105387) inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 99770) 99778) inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Else_correct)))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon57_Then_correct  (and (=> (= (ControlFlow 0 105395) 105387) inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Then_correct) (=> (= (ControlFlow 0 105395) 99778) inline$$DiemBlock_block_prologue_$def_verify$0$anon58_Else_correct))))
(let ((inline$$DiemBlock_block_prologue_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 99764) 105395) inline$$DiemBlock_block_prologue_$def_verify$0$anon57_Then_correct) (=> (= (ControlFlow 0 99764) 99770) inline$$DiemBlock_block_prologue_$def_verify$0$anon57_Else_correct)))))
(let ((anon0$1_correct  (=> (and (forall (($inv_addr Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr)) (let ((va@@9 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))))
(let ((l@@9 (|l#$ValueArray| va@@9)))
 (and (and (<= 0 l@@9) (<= l@@9 $MAX_U64)) (forall ((x@@9 Int) ) (!  (=> (or (< x@@9 0) (>= x@@9 l@@9)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@9) x@@9))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr))
)) (forall (($inv_addr@@0 Int) ($inv_tv0 T@$TypeValue) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0)) (let ((va@@10 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))))
(let ((l@@10 (|l#$ValueArray| va@@10)))
 (and (and (<= 0 l@@10) (<= l@@10 $MAX_U64)) (forall ((x@@10 Int) ) (!  (=> (or (< x@@10 0) (>= x@@10 l@@10)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@10) x@@10))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) 1)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec)) (let ((va@@11 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec))))
(let ((l@@11 (|l#$ValueArray| va@@11)))
 (and (and (<= 0 l@@11) (<= l@@11 $MAX_U64)) (forall ((x@@11 Int) ) (!  (=> (or (< x@@11 0) (>= x@@11 l@@11)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@11) x@@11))
))))))) (|b#$Boolean| ($Boolean (<= (|i#$Integer| ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))) $Option_Option_vec))))) (|i#$Integer| ($Integer 1)))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Option_Option_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0) 1) $inv_addr@@0))
))) (=> (and (and (forall (($inv_addr@@1 Int) ($inv_tv0@@0 T@$TypeValue) ) (!  (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1)) (let ((va@@12 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))))
(let ((l@@12 (|l#$ValueArray| va@@12)))
 (and (and (<= 0 l@@12) (<= l@@12 $MAX_U64)) (forall ((x@@12 Int) ) (!  (=> (or (< x@@12 0) (>= x@@12 l@@12)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@12) x@@12))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))) 1)) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $inv_tv0@@0) 1) $inv_addr@@1))
)) (forall (($inv_addr@@2 Int) ) (!  (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2)) (let ((va@@13 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))))
(let ((l@@13 (|l#$ValueArray| va@@13)))
 (and (and (<= 0 l@@13) (<= l@@13 $MAX_U64)) (forall ((x@@13 Int) ) (!  (=> (or (< x@@13 0) (>= x@@13 l@@13)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@13) x@@13))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_scheme)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_scheme)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_scheme)) $MAX_U8))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators)) (let ((va@@14 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))))
(let ((l@@14 (|l#$ValueArray| va@@14)))
 (and (and (<= 0 l@@14) (<= l@@14 $MAX_U64)) (forall ((x@@14 Int) ) (!  (=> (or (< x@@14 0) (>= x@@14 l@@14)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@14) x@@14))
))))))) (forall (($$0 Int) ) (!  (=> (and (>= $$0 0) (< $$0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))))) (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0)) (let ((va@@15 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))))
(let ((l@@15 (|l#$ValueArray| va@@15)))
 (and (and (<= 0 l@@15) (<= l@@15 $MAX_U64)) (forall ((x@@15 Int) ) (!  (=> (or (< x@@15 0) (>= x@@15 l@@15)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@15) x@@15))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config)) (let ((va@@16 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@16 (|l#$ValueArray| va@@16)))
 (and (and (<= 0 l@@16) (<= l@@16 $MAX_U64)) (forall ((x@@16 Int) ) (!  (=> (or (< x@@16 0) (>= x@@16 l@@16)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@16) x@@16))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@17 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@17 (|l#$ValueArray| va@@17)))
 (and (and (<= 0 l@@17) (<= l@@17 $MAX_U64)) (forall ((x@@17 Int) ) (!  (=> (or (< x@@17 0) (>= x@@17 l@@17)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@17) x@@17))
))))))) (forall (($$0@@0 Int) ) (!  (=> (and (>= $$0@@0 0) (< $$0@@0 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@0)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@0)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@0)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@0))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@18 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@18 (|l#$ValueArray| va@@18)))
 (and (and (<= 0 l@@18) (<= l@@18 $MAX_U64)) (forall ((x@@18 Int) ) (!  (=> (or (< x@@18 0) (>= x@@18 l@@18)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@18) x@@18))
))))))) (forall (($$0@@1 Int) ) (!  (=> (and (>= $$0@@1 0) (< $$0@@1 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@1)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@1)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@1)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@1))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@19 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@19 (|l#$ValueArray| va@@19)))
 (and (and (<= 0 l@@19) (<= l@@19 $MAX_U64)) (forall ((x@@19 Int) ) (!  (=> (or (< x@@19 0) (>= x@@19 l@@19)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@19) x@@19))
))))))) (forall (($$0@@2 Int) ) (!  (=> (and (>= $$0@@2 0) (< $$0@@2 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@2)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@2)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@2)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@2))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64)))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0))
))) (and (forall (($$0@@3 Int) ) (!  (=> (and (>= $$0@@3 0) (< $$0@@3 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))))) true) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) $$0@@3))
)) (|b#$Boolean| ($Boolean (let (($range_1@@3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@6 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@3)) $i_0@@6) (< $i_0@@6 (|i#$Integer| (|ub#$Range| $range_1@@3)))) (let ((i@@10 ($Integer $i_0@@6)))
(|b#$Boolean| ($Boolean (let (($range_3 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_2 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_3)) $i_2) (< $i_2 (|i#$Integer| (|ub#$Range| $range_3)))) (let ((j@@1 ($Integer $i_2)))
(|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i@@10)))) $DiemSystem_ValidatorInfo_addr) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| j@@1)))) $DiemSystem_ValidatorInfo_addr)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified i@@10 j@@1)))))))))))))))))))) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_DiemSystem_$memory) $EmptyTypeValueArray $inv_addr@@2))
))) (and (forall (($inv_addr@@3 Int) ) (!  (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3)) (let ((va@@20 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))))
(let ((l@@20 (|l#$ValueArray| va@@20)))
 (and (and (<= 0 l@@20) (<= l@@20 $MAX_U64)) (forall ((x@@20 Int) ) (!  (=> (or (< x@@20 0) (>= x@@20 l@@20)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@20) x@@20))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) 4)) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_addr))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_consensus_voting_power)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_consensus_voting_power)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_consensus_voting_power)) $MAX_U64))) (and (and (and (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config)) (let ((va@@21 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))))
(let ((l@@21 (|l#$ValueArray| va@@21)))
 (and (and (<= 0 l@@21) (<= l@@21 $MAX_U64)) (forall ((x@@21 Int) ) (!  (=> (or (< x@@21 0) (>= x@@21 l@@21)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@21) x@@21))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) 3)) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey)) (let ((va@@22 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))
(let ((l@@22 (|l#$ValueArray| va@@22)))
 (and (and (<= 0 l@@22) (<= l@@22 $MAX_U64)) (forall ((x@@22 Int) ) (!  (=> (or (< x@@22 0) (>= x@@22 l@@22)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@22) x@@22))
))))))) (forall (($$0@@4 Int) ) (!  (=> (and (>= $$0@@4 0) (< $$0@@4 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_consensus_pubkey))) $$0@@4))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses)) (let ((va@@23 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))
(let ((l@@23 (|l#$ValueArray| va@@23)))
 (and (and (<= 0 l@@23) (<= l@@23 $MAX_U64)) (forall ((x@@23 Int) ) (!  (=> (or (< x@@23 0) (>= x@@23 l@@23)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@23) x@@23))
))))))) (forall (($$0@@5 Int) ) (!  (=> (and (>= $$0@@5 0) (< $$0@@5 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_validator_network_addresses))) $$0@@5))
))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses)) (let ((va@@24 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))
(let ((l@@24 (|l#$ValueArray| va@@24)))
 (and (and (<= 0 l@@24) (<= l@@24 $MAX_U64)) (forall ((x@@24 Int) ) (!  (=> (or (< x@@24 0) (>= x@@24 l@@24)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@24) x@@24))
))))))) (forall (($$0@@6 Int) ) (!  (=> (and (>= $$0@@6 0) (< $$0@@6 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_config))) $ValidatorConfig_Config_fullnode_network_addresses))) $$0@@6))
)))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_last_config_update_time)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_last_config_update_time)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))) $DiemSystem_ValidatorInfo_last_config_update_time)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemSystem_ValidatorInfo_$memory) $EmptyTypeValueArray $inv_addr@@3))
)) (forall (($inv_addr@@4 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4)) (let ((va@@25 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))))
(let ((l@@25 (|l#$ValueArray| va@@25)))
 (and (and (<= 0 l@@25) (<= l@@25 $MAX_U64)) (forall ((x@@25 Int) ) (!  (=> (or (< x@@25 0) (>= x@@25 l@@25)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@25) x@@25))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_height)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_height)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_height)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events)) (let ((va@@26 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))))
(let ((l@@26 (|l#$ValueArray| va@@26)))
 (and (and (<= 0 l@@26) (<= l@@26 $MAX_U64)) (forall ((x@@26 Int) ) (!  (=> (or (< x@@26 0) (>= x@@26 l@@26)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@26) x@@26))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid)) (let ((va@@27 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))
(let ((l@@27 (|l#$ValueArray| va@@27)))
 (and (and (<= 0 l@@27) (<= l@@27 $MAX_U64)) (forall ((x@@27 Int) ) (!  (=> (or (< x@@27 0) (>= x@@27 l@@27)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@27) x@@27))
))))))) (forall (($$0@@7 Int) ) (!  (=> (and (>= $$0@@7 0) (< $$0@@7 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@7)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@7)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@7)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@7))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@4))
)))) (=> (and (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (and (|b#$Boolean| ($Boolean (forall ((config_address T@$Value) )  (=> ((_ is $Address) config_address) (|b#$Boolean| ($Boolean (forall ((config_type T@$Value) )  (=> ((_ is $Type) config_type) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 (|t#$Type| config_type)) 1) (|a#$Address| config_address)))) (|b#$Boolean| ($Boolean ($IsEqual_stratified config_address ($Address 173345816))))))))))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))))) (and (and (|b#$Boolean| ($Boolean (let (($range_1@@4 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@3 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@3)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@7 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@4)) $i_0@@7) (< $i_0@@7 (|i#$Integer| (|ub#$Range| $range_1@@4)))) (let ((i1 ($Integer $i_0@@7)))
(|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $Roles_RoleId_$memory) $EmptyTypeValueArray (|a#$Address| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@4 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@4)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1)))) $DiemSystem_ValidatorInfo_addr))))) $Roles_RoleId_role_id) ($Integer 3))))))))))))) (|b#$Boolean| ($Boolean (let (($range_1@@5 ($Range ($Integer 0) ($Integer (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@5 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@5)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators)))))))
(forall (($i_0@@8 Int) )  (=> (and (<= (|i#$Integer| (|lb#$Range| $range_1@@5)) $i_0@@8) (< $i_0@@8 (|i#$Integer| (|ub#$Range| $range_1@@5)))) (let ((i1@@0 ($Integer $i_0@@8)))
(|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (let ((addr@@6 ($Address 173345816)))
(|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| addr@@6)))) $DiemConfig_DiemConfig_payload)))) $DiemSystem_DiemSystem_validators))) (|i#$Integer| i1@@0)))) $DiemSystem_ValidatorInfo_consensus_voting_power) ($Integer 1))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 105399) 99764)))) inline$$DiemBlock_block_prologue_$def_verify$0$anon0_correct)))))
(let ((anon0_correct  (=> ((_ is $Address) vm) (=> (and (and (and (and ((_ is $Integer) round) (>= (|i#$Integer| round) 0)) (<= (|i#$Integer| round) $MAX_U64)) (and (and ((_ is $Integer) timestamp) (>= (|i#$Integer| timestamp) 0)) (<= (|i#$Integer| timestamp) $MAX_U64))) (and (and (and ((_ is $Vector) previous_block_votes) (let ((va@@28 (|v#$Vector| previous_block_votes)))
(let ((l@@28 (|l#$ValueArray| va@@28)))
 (and (and (<= 0 l@@28) (<= l@@28 $MAX_U64)) (forall ((x@@28 Int) ) (!  (=> (or (< x@@28 0) (>= x@@28 l@@28)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@28) x@@28))
)))))) (forall (($$0@@8 Int) ) (!  (=> (and (>= $$0@@8 0) (< $$0@@8 (|l#$ValueArray| (|v#$Vector| previous_block_votes)))) ((_ is $Address) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| previous_block_votes)) $$0@@8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| previous_block_votes)) $$0@@8))
))) (and ((_ is $Address) proposer) (= (ControlFlow 0 98372) 105399)))) anon0$1_correct))))
(let ((PreconditionGeneratedEntry_correct  (=> (= (ControlFlow 0 110918) 98372) anon0_correct)))
PreconditionGeneratedEntry_correct))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$GetFieldFromValue$0$dst@1 () T@$Value)
(declare-fun inline$$GetGlobal$0$dst () T@$Value)
(declare-fun $abort_flag@2@@0 () Bool)
(declare-fun $abort_flag@1@@0 () Bool)
(declare-fun inline$$GetGlobal$0$a@1 () Int)
(declare-fun inline$$GetGlobal$0$dst@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$ret0@2 () T@$Value)
(declare-fun $abort_code@2@@0 () Int)
(declare-fun call3formal@$ret0@0@@3 () T@$Value)
(declare-fun $abort_flag@0@@0 () Bool)
(declare-fun inline$$DiemBlock_get_current_block_height_$def_verify$0$$t3@1 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 116934) (let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon27_Else_correct true))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon27_Then_correct true))
(let ((inline$$GetFieldFromValue$0$anon0_correct  (=> (= inline$$GetFieldFromValue$0$dst@1 (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$GetGlobal$0$dst)) $DiemBlock_BlockMetadata_height)) (and (=> (= (ControlFlow 0 107449) 107475) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon27_Then_correct) (=> (= (ControlFlow 0 107449) 107465) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon27_Else_correct)))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Else_correct  (=> (and (not $abort_flag@2@@0) (= (ControlFlow 0 107455) 107449)) inline$$GetFieldFromValue$0$anon0_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct true))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon21_Else_correct  (=> (and (not true) (= (ControlFlow 0 107509) 107077)) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon21_Then_correct  (=> (= (ControlFlow 0 107519) 107077) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon20_Then_correct  (=> $abort_flag@1@@0 (and (=> (= (ControlFlow 0 107503) 107519) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon21_Then_correct) (=> (= (ControlFlow 0 107503) 107509) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon21_Else_correct)))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon26_Else_correct  (=> (and (not true) (= (ControlFlow 0 107485) 107077)) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon26_Then_correct  (=> (= (ControlFlow 0 107495) 107077) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Then_correct  (=> $abort_flag@2@@0 (and (=> (= (ControlFlow 0 107479) 107495) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon26_Then_correct) (=> (= (ControlFlow 0 107479) 107485) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon26_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then$1_correct  (=> (= $abort_flag@2@@0 true) (and (=> (= (ControlFlow 0 107395) 107479) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 107395) 107455) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Else_correct)))))
(let ((inline$$GetGlobal$0$anon3_Then_correct  (=> (and (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1)) (= (ControlFlow 0 107393) 107395)) inline$$GetGlobal$0$anon3_Then$1_correct)))
(let ((inline$$GetGlobal$0$anon3_Else_correct  (=> (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$GetGlobal$0$a@1) (=> (and (= inline$$GetGlobal$0$dst@1 (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0))) (= $abort_flag@2@@0 $abort_flag@1@@0)) (and (=> (= (ControlFlow 0 107341) 107479) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Then_correct) (=> (= (ControlFlow 0 107341) 107455) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon25_Else_correct))))))
(let ((inline$$GetGlobal$0$anon0_correct  (=> (= inline$$GetGlobal$0$a@1 (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0)) (and (=> (= (ControlFlow 0 107323) 107393) inline$$GetGlobal$0$anon3_Then_correct) (=> (= (ControlFlow 0 107323) 107341) inline$$GetGlobal$0$anon3_Else_correct)))))
(let ((inline$$GetGlobal$0$Entry_correct  (and (=> (= (ControlFlow 0 107317) (- 0 117494)) true) (=> (= (ControlFlow 0 107317) 107323) inline$$GetGlobal$0$anon0_correct))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Else_correct  (=> (and (not $abort_flag@1@@0) (= (ControlFlow 0 107401) 107317)) inline$$GetGlobal$0$Entry_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Then_correct  (=> (and $abort_flag@1@@0 (= (ControlFlow 0 107499) 107077)) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 107196) 107499) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 107196) 107401) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 107206) 107499) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Then_correct) (=> (= (ControlFlow 0 107206) 107401) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon24_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0  (=> (and (not $abort_flag@1@@0) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 107190) 107206) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Then_correct@@0) (=> (= (ControlFlow 0 107190) 107196) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon3_Else_correct@@0)))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon22_Then_correct  (=> (and (|b#$Boolean| inline$$DiemBlock_is_initialized_$def$0$$ret0@2) (= (ControlFlow 0 107220) 107190)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$1$anon0_correct@@0)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon23_Else_correct  (=> (and (not true) (= (ControlFlow 0 107069) 107077)) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon23_Then_correct  (=> (= (ControlFlow 0 107085) 107077) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon22_Else_correct  (=> (and (not (|b#$Boolean| inline$$DiemBlock_is_initialized_$def$0$$ret0@2)) (= $abort_code@2@@0 (|i#$Integer| call3formal@$ret0@0@@3))) (and (=> (= (ControlFlow 0 107063) 107085) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon23_Then_correct) (=> (= (ControlFlow 0 107063) 107069) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon23_Else_correct)))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon20_Else_correct  (=> (not $abort_flag@1@@0) (and (=> (= (ControlFlow 0 107051) 107220) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon22_Then_correct) (=> (= (ControlFlow 0 107051) 107063) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon22_Else_correct)))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon19_Else_correct  (=> (not $abort_flag@0@@0) (=> (and (and (and (= inline$$DiemBlock_get_current_block_height_$def_verify$0$$t3@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@1@@0)) (and (=> $abort_flag@1@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@1@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@3 ($Integer 5))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@3) (>= (|i#$Integer| call3formal@$ret0@0@@3) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@3) $MAX_U64))) (and (=> (= (ControlFlow 0 107045) 107503) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon20_Then_correct) (=> (= (ControlFlow 0 107045) 107051) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon20_Else_correct))))))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon19_Then_correct  (=> (and $abort_flag@0@@0 (= (ControlFlow 0 107523) 107077)) inline$$DiemBlock_get_current_block_height_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon4_correct  (=> (and (= $abort_flag@0@@0 false) (= inline$$DiemBlock_is_initialized_$def$0$$ret0@2 inline$$DiemBlock_is_initialized_$def$0$$t1@1)) (and (=> (= (ControlFlow 0 107003) 107523) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon19_Then_correct) (=> (= (ControlFlow 0 107003) 107045) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon19_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct  (=> (and (not true) (= (ControlFlow 0 107001) 107003)) inline$$DiemBlock_is_initialized_$def$0$anon4_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct  (=> (= (ControlFlow 0 107011) 107003) inline$$DiemBlock_is_initialized_$def$0$anon4_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct  (=> (and (not false) (= inline$$DiemBlock_is_initialized_$def$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0))))) (and (=> (= (ControlFlow 0 106995) 107011) inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct) (=> (= (ControlFlow 0 106995) 107001) inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0  (=> (not true) (and (=> (= (ControlFlow 0 106953) 107019) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 106953) 106995) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0  (and (=> (= (ControlFlow 0 106963) 107019) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct) (=> (= (ControlFlow 0 106963) 106995) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@0 ($Address 173345816))) (and (=> (= (ControlFlow 0 106947) 106963) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@0) (=> (= (ControlFlow 0 106947) 106953) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@0)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 106977) 106947)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@0)))
(let ((inline$$DiemBlock_get_current_block_height_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 107033) 106977)) inline$$DiemBlock_is_initialized_$def$0$anon0_correct)))
(let ((anon0$1_correct@@0  (=> (forall (($inv_addr@@5 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5)) (let ((va@@29 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))))
(let ((l@@29 (|l#$ValueArray| va@@29)))
 (and (and (<= 0 l@@29) (<= l@@29 $MAX_U64)) (forall ((x@@29 Int) ) (!  (=> (or (< x@@29 0) (>= x@@29 l@@29)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@29) x@@29))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_height)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_height)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_height)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events)) (let ((va@@30 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))))
(let ((l@@30 (|l#$ValueArray| va@@30)))
 (and (and (<= 0 l@@30) (<= l@@30 $MAX_U64)) (forall ((x@@30 Int) ) (!  (=> (or (< x@@30 0) (>= x@@30 l@@30)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@30) x@@30))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid)) (let ((va@@31 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))
(let ((l@@31 (|l#$ValueArray| va@@31)))
 (and (and (<= 0 l@@31) (<= l@@31 $MAX_U64)) (forall ((x@@31 Int) ) (!  (=> (or (< x@@31 0) (>= x@@31 l@@31)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@31) x@@31))
))))))) (forall (($$0@@9 Int) ) (!  (=> (and (>= $$0@@9 0) (< $$0@@9 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@9)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@9)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@9)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@9))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@5))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 107529) 107033)) inline$$DiemBlock_get_current_block_height_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@0  (=> (= (ControlFlow 0 116934) 107529) anon0$1_correct@@0)))
anon0_correct@@0)))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun $abort_flag@5@@0 () Bool)
(declare-fun account () T@$Value)
(declare-fun $abort_code@7@@0 () Int)
(declare-fun $DiemBlock_BlockMetadata_$memory@1 () T@$Memory)
(declare-fun $abort_flag@4@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@2| () T@$Memory)
(declare-fun $abort_code@5@@0 () Int)
(declare-fun $abort_code@6@@0 () Int)
(declare-fun $DiemBlock_BlockMetadata_$memory@0@@0 () T@$Memory)
(declare-fun $abort_code@1@@0 () Int)
(declare-fun $abort_flag@0@@1 () Bool)
(declare-fun $abort_code@2@@1 () Int)
(declare-fun $abort_flag@1@@1 () Bool)
(declare-fun $abort_code@3@@0 () Int)
(declare-fun $abort_flag@3@@0 () Bool)
(declare-fun |inline$$MoveToRaw$0$m'@0| () T@$Memory)
(declare-fun inline$$MoveTo$0$a@1 () Int)
(declare-fun |inline$$MoveToRaw$0$m'@1| () T@$Memory)
(declare-fun |Store_[$TypeValueArray,$int]$bool| (|T@[$TypeValueArray,Int]Bool| T@$TypeValueArray Int Bool) |T@[$TypeValueArray,Int]Bool|)
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?x2 Int) ( ?x3 Bool)) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?x1 ?x2)  ?x3)))
(assert (forall ( ( ?x0 |T@[$TypeValueArray,Int]Bool|) ( ?x1 T@$TypeValueArray) ( ?y1 T@$TypeValueArray) ( ?x2 Int) ( ?y2 Int) ( ?x3 Bool)) (=> (or  (not (= ?x1 ?y1)) (not (= ?x2 ?y2))) (= (|Select_[$TypeValueArray,$int]$bool| (|Store_[$TypeValueArray,$int]$bool| ?x0 ?x1 ?x2 ?x3) ?y1 ?y2) (|Select_[$TypeValueArray,$int]$bool| ?x0 ?y1 ?y2)))))
(declare-fun inline$$DiemBlock_BlockMetadata_pack$0$$struct@1 () T@$Value)
(declare-fun inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$res@0 () T@$Value)
(declare-fun inline$$Event_new_event_handle$0$t@0 () T@$TypeValue)
(declare-fun inline$$Not$0$dst@1 () T@$Value)
(declare-fun $abort_code@4@@0 () Int)
(declare-fun call3formal@$ret0@0@@4 () T@$Value)
(declare-fun inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t6@1 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$ret0@2@@0 () T@$Value)
(declare-fun $abort_flag@2@@1 () Bool)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$t1@1@@0 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 () T@$Value)
(declare-fun inline$$DiemBlock_is_initialized_$def$0$$ret0@1 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 117639) (let ((anon0$2_correct@@0  (and (=> (= (ControlFlow 0 109469) (- 0 119243)) (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 109469) (- 0 119258)) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 109469) (- 0 119275)) (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@5@@0)) (=> (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $abort_flag@5@@0) (and (=> (= (ControlFlow 0 109469) (- 0 119283)) (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (=> $abort_flag@5@@0 (or (or (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (and (=> (= (ControlFlow 0 109469) (- 0 119321)) (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 6))))))) (=> (=> $abort_flag@5@@0 (or (or (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 1)))) (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 2))))) (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (= $abort_code@7@@0 (|i#$Integer| ($Integer 6)))))) (and (=> (= (ControlFlow 0 109469) (- 0 119392)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))) (=> (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))) (=> (= (ControlFlow 0 109469) (- 0 119402)) (=> (not $abort_flag@5@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory@1) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) $DiemBlock_BlockMetadata_height) ($Integer 0))))))))))))))))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Else_correct  (=> (not $abort_flag@4@@0) (and (=> (= (ControlFlow 0 109351) (- 0 119087)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| |inline$$MoveToRaw$0$m'@2|) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (=> (and (and (= $abort_flag@5@@0 $abort_flag@4@@0) (= $abort_code@7@@0 $abort_code@5@@0)) (and (= $DiemBlock_BlockMetadata_$memory@1 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 109351) 109469))) anon0$2_correct@@0))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct  (=> (and (and (= $abort_flag@5@@0 true) (= $abort_code@7@@0 $abort_code@6@@0)) (and (= $DiemBlock_BlockMetadata_$memory@1 $DiemBlock_BlockMetadata_$memory@0@@0) (= (ControlFlow 0 108759) 109469))) anon0$2_correct@@0)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon5_correct  (=> (= $abort_code@6@@0 $abort_code@1@@0) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 109447) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon31_Else_correct  (=> (and (not true) (= (ControlFlow 0 109445) 109447)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon5_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon31_Then_correct  (=> (= (ControlFlow 0 109455) 109447) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon5_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon30_Then_correct  (=> $abort_flag@0@@1 (and (=> (= (ControlFlow 0 109439) 109455) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon31_Then_correct) (=> (= (ControlFlow 0 109439) 109445) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon31_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon9_correct  (=> (= $abort_code@6@@0 $abort_code@2@@1) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 109427) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon33_Else_correct  (=> (and (not true) (= (ControlFlow 0 109425) 109427)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon9_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon33_Then_correct  (=> (= (ControlFlow 0 109435) 109427) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon9_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon32_Then_correct  (=> $abort_flag@1@@1 (and (=> (= (ControlFlow 0 109419) 109435) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon33_Then_correct) (=> (= (ControlFlow 0 109419) 109425) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon33_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon15_correct  (=> (= $abort_code@6@@0 $abort_code@3@@0) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 109403) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon36_Else_correct  (=> (and (not true) (= (ControlFlow 0 109401) 109403)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon15_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon36_Then_correct  (=> (= (ControlFlow 0 109411) 109403) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon15_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon35_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 109395) 109411) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon36_Then_correct) (=> (= (ControlFlow 0 109395) 109401) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon36_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon23_correct  (=> (= $abort_code@6@@0 $abort_code@3@@0) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 109383) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon40_Else_correct  (=> (and (not true) (= (ControlFlow 0 109381) 109383)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon23_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon40_Then_correct  (=> (= (ControlFlow 0 109391) 109383) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon23_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon39_Then_correct  (=> $abort_flag@3@@0 (and (=> (= (ControlFlow 0 109375) 109391) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon40_Then_correct) (=> (= (ControlFlow 0 109375) 109381) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon40_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon27_correct  (=> (= $abort_code@6@@0 $abort_code@5@@0) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 |inline$$MoveToRaw$0$m'@2|) (= (ControlFlow 0 109363) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon42_Else_correct  (=> (and (not true) (= (ControlFlow 0 109361) 109363)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon27_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon42_Then_correct  (=> (= (ControlFlow 0 109371) 109363) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon27_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Then_correct  (=> $abort_flag@4@@0 (and (=> (= (ControlFlow 0 109355) 109371) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon42_Then_correct) (=> (= (ControlFlow 0 109355) 109361) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon42_Else_correct)))))
(let ((inline$$MoveToRaw$0$anon3_Then$1_correct  (=> (= $abort_code@5@@0 $EXEC_FAILURE_CODE) (=> (and (= $abort_flag@4@@0 true) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@0|)) (and (=> (= (ControlFlow 0 109311) 109355) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 109311) 109351) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveToRaw$0$anon3_Then_correct  (=> (and (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1) (= (ControlFlow 0 109309) 109311)) inline$$MoveToRaw$0$anon3_Then$1_correct)))
(let ((inline$$MoveToRaw$0$anon3_Else_correct  (=> (not (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1)) (=> (and (and (= |inline$$MoveToRaw$0$m'@1| ($Memory (|Store_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 true) (|Store_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray inline$$MoveTo$0$a@1 inline$$DiemBlock_BlockMetadata_pack$0$$struct@1))) (= $abort_code@5@@0 $abort_code@3@@0)) (and (= $abort_flag@4@@0 $abort_flag@3@@0) (= |inline$$MoveToRaw$0$m'@2| |inline$$MoveToRaw$0$m'@1|))) (and (=> (= (ControlFlow 0 109259) 109355) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Then_correct) (=> (= (ControlFlow 0 109259) 109351) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon41_Else_correct))))))
(let ((inline$$MoveTo$0$anon0$1_correct  (=> (= inline$$MoveTo$0$a@1 (|a#$Address| account)) (and (=> (= (ControlFlow 0 109317) 109309) inline$$MoveToRaw$0$anon3_Then_correct) (=> (= (ControlFlow 0 109317) 109259) inline$$MoveToRaw$0$anon3_Else_correct)))))
(let ((inline$$Signer_borrow_address$0$Entry_correct  (and (=> (= (ControlFlow 0 109105) (- 0 118972)) true) (=> (= (ControlFlow 0 109105) 109317) inline$$MoveTo$0$anon0$1_correct))))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon4_Else_correct  (=> (and (not true) (= (ControlFlow 0 108991) 109105)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon4_Then_correct  (=> (= (ControlFlow 0 108997) 109105) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon3_Then_correct  (=> (> 0 0) (and (=> (= (ControlFlow 0 108985) 108997) inline$$DiemBlock_BlockMetadata_pack$0$anon4_Then_correct) (=> (= (ControlFlow 0 108985) 108991) inline$$DiemBlock_BlockMetadata_pack$0$anon4_Else_correct)))))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon3_Else_correct  (=> (and (>= 0 0) (= (ControlFlow 0 108977) 109105)) inline$$Signer_borrow_address$0$Entry_correct)))
(let ((inline$$DiemBlock_BlockMetadata_pack$0$anon0_correct  (=> (and (and ((_ is $Integer) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1) (>= (|i#$Integer| inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1) 0)) (<= (|i#$Integer| inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1) $MAX_U64)) (=> (and (and (and (and (and (and (and ((_ is $Vector) inline$$Event_new_event_handle$0$res@0) (let ((va@@32 (|v#$Vector| inline$$Event_new_event_handle$0$res@0)))
(let ((l@@32 (|l#$ValueArray| va@@32)))
 (and (and (<= 0 l@@32) (<= l@@32 $MAX_U64)) (forall ((x@@32 Int) ) (!  (=> (or (< x@@32 0) (>= x@@32 l@@32)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@32) x@@32))
)))))) (= (|l#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid)) (let ((va@@33 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))
(let ((l@@33 (|l#$ValueArray| va@@33)))
 (and (and (<= 0 l@@33) (<= l@@33 $MAX_U64)) (forall ((x@@33 Int) ) (!  (=> (or (< x@@33 0) (>= x@@33 l@@33)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@33) x@@33))
))))))) (forall (($$0@@10 Int) ) (!  (=> (and (>= $$0@@10 0) (< $$0@@10 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@10)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@10)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@10)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| inline$$Event_new_event_handle$0$res@0)) $Event_EventHandle_guid))) $$0@@10))
))) true) (= inline$$DiemBlock_BlockMetadata_pack$0$$struct@1 ($Vector ($ValueArray (|Store_[$int]$Value| (|Store_[$int]$Value| ($MapConstValue $Error) 0 inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1) 1 inline$$Event_new_event_handle$0$res@0) 2)))) (and (=> (= (ControlFlow 0 108969) 108985) inline$$DiemBlock_BlockMetadata_pack$0$anon3_Then_correct) (=> (= (ControlFlow 0 108969) 108977) inline$$DiemBlock_BlockMetadata_pack$0$anon3_Else_correct))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon39_Else_correct  (=> (and (not $abort_flag@3@@0) (= (ControlFlow 0 109003) 108969)) inline$$DiemBlock_BlockMetadata_pack$0$anon0_correct)))
(let ((inline$$Event_new_event_handle$0$Entry_correct  (=> (= inline$$Event_new_event_handle$0$t@0 $DiemBlock_NewBlockEvent_type_value) (and (=> (= (ControlFlow 0 108803) 109375) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon39_Then_correct) (=> (= (ControlFlow 0 108803) 109003) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon39_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon37_Then_correct  (=> (|b#$Boolean| inline$$Not$0$dst@1) (=> (and (= inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t8@1 ($Integer 0)) (= (ControlFlow 0 108811) 108803)) inline$$Event_new_event_handle$0$Entry_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon20_correct  (=> (= $abort_code@6@@0 $abort_code@4@@0) (=> (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 108755) 108759)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon38_Else_correct  (=> (and (not true) (= (ControlFlow 0 108753) 108755)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon20_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon38_Then_correct  (=> (= (ControlFlow 0 108767) 108755) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon20_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon37_Else_correct  (=> (and (not (|b#$Boolean| inline$$Not$0$dst@1)) (= $abort_code@4@@0 (|i#$Integer| call3formal@$ret0@0@@4))) (and (=> (= (ControlFlow 0 108747) 108767) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon38_Then_correct) (=> (= (ControlFlow 0 108747) 108753) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon38_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon35_Else_correct  (=> (not $abort_flag@3@@0) (and (=> (= (ControlFlow 0 108735) 108811) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon37_Then_correct) (=> (= (ControlFlow 0 108735) 108747) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon37_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Else$1_correct  (=> (and (and (and (= inline$$DiemBlock_initialize_block_metadata_$def_verify$0$$t6@1 ($Integer 0)) (=> (|b#$Boolean| ($Boolean false)) $abort_flag@3@@0)) (and (=> $abort_flag@3@@0 (|b#$Boolean| ($Boolean false))) (=> (not $abort_flag@3@@0) (|b#$Boolean| ($Boolean ($IsEqual_stratified call3formal@$ret0@0@@4 ($Integer 6))))))) (and (and ((_ is $Integer) call3formal@$ret0@0@@4) (>= (|i#$Integer| call3formal@$ret0@0@@4) 0)) (<= (|i#$Integer| call3formal@$ret0@0@@4) $MAX_U64))) (and (=> (= (ControlFlow 0 108729) 109395) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon35_Then_correct) (=> (= (ControlFlow 0 108729) 108735) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon35_Else_correct)))))
(let ((inline$$Not$0$anon0_correct  (=> (and (= inline$$Not$0$dst@1 ($Boolean  (not (|b#$Boolean| inline$$DiemBlock_is_initialized_$def$0$$ret0@2@@0)))) (= (ControlFlow 0 108717) 108729)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Else$1_correct)))
(let ((inline$$Not$0$Entry_correct  (and (=> (= (ControlFlow 0 108707) (- 0 118733)) true) (=> (= (ControlFlow 0 108707) 108717) inline$$Not$0$anon0_correct))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Else_correct  (=> (and (not $abort_flag@2@@1) (= (ControlFlow 0 108723) 108707)) inline$$Not$0$Entry_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Then_correct  (=> (and (and $abort_flag@2@@1 (= $abort_code@6@@0 $abort_code@2@@1)) (and (= $DiemBlock_BlockMetadata_$memory@0@@0 $DiemBlock_BlockMetadata_$memory) (= (ControlFlow 0 109415) 108759))) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$Abort_correct)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon4_correct@@0  (=> (and (= $abort_flag@2@@1 $abort_flag@1@@1) (= inline$$DiemBlock_is_initialized_$def$0$$ret0@2@@0 inline$$DiemBlock_is_initialized_$def$0$$t1@1@@0)) (and (=> (= (ControlFlow 0 108637) 109415) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 108637) 108723) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct@@0  (=> (and (not true) (= (ControlFlow 0 108635) 108637)) inline$$DiemBlock_is_initialized_$def$0$anon4_correct@@0)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct@@0  (=> (= (ControlFlow 0 108645) 108637) inline$$DiemBlock_is_initialized_$def$0$anon4_correct@@0)))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct@@0  (=> (and (not $abort_flag@1@@1) (= inline$$DiemBlock_is_initialized_$def$0$$t1@1@@0 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1))))) (and (=> (= (ControlFlow 0 108629) 108645) inline$$DiemBlock_is_initialized_$def$0$anon6_Then_correct@@0) (=> (= (ControlFlow 0 108629) 108635) inline$$DiemBlock_is_initialized_$def$0$anon6_Else_correct@@0)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct@@0  (=> (and (and $abort_flag@1@@1 (= inline$$DiemBlock_is_initialized_$def$0$$ret0@1 $Error)) (and (= $abort_flag@2@@1 true) (= inline$$DiemBlock_is_initialized_$def$0$$ret0@2@@0 inline$$DiemBlock_is_initialized_$def$0$$ret0@1))) (and (=> (= (ControlFlow 0 108653) 109415) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Then_correct) (=> (= (ControlFlow 0 108653) 108723) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon34_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1  (=> (not true) (and (=> (= (ControlFlow 0 108587) 108653) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 108587) 108629) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct@@0)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1  (and (=> (= (ControlFlow 0 108597) 108653) inline$$DiemBlock_is_initialized_$def$0$anon5_Then_correct@@0) (=> (= (ControlFlow 0 108597) 108629) inline$$DiemBlock_is_initialized_$def$0$anon5_Else_correct@@0))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1  (=> (and (not $abort_flag@1@@1) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@1 ($Address 173345816))) (and (=> (= (ControlFlow 0 108581) 108597) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@1) (=> (= (ControlFlow 0 108581) 108587) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@1)))))
(let ((inline$$DiemBlock_is_initialized_$def$0$anon0_correct@@0  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 108611) 108581)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@1)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon32_Else_correct  (=> (and (not $abort_flag@1@@1) (= (ControlFlow 0 108667) 108611)) inline$$DiemBlock_is_initialized_$def$0$anon0_correct@@0)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon30_Else_correct  (=> (and (and (not $abort_flag@0@@1) (=> (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) $abort_flag@1@@1)) (and (=> $abort_flag@1@@1 (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816)))))) (=> $abort_flag@1@@1 (and (|b#$Boolean| ($Boolean  (not ($IsEqual_stratified account ($Address 173345816))))) (= $abort_code@2@@1 (|i#$Integer| ($Integer 2))))))) (and (=> (= (ControlFlow 0 108351) 109419) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon32_Then_correct) (=> (= (ControlFlow 0 108351) 108667) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon32_Else_correct)))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon2$1_correct  (=> (=> (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) $abort_flag@0@@1) (=> (and (=> $abort_flag@0@@1 (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (=> $abort_flag@0@@1 (and (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean  (not (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))))) (= $abort_code@1@@0 (|i#$Integer| ($Integer 1)))))) (and (=> (= (ControlFlow 0 108345) 109439) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon30_Then_correct) (=> (= (ControlFlow 0 108345) 108351) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon30_Else_correct))))))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon29_Else_correct  (=> (and (not true) (= (ControlFlow 0 108309) 108345)) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon29_Then_correct  (=> (= (ControlFlow 0 109463) 108345) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon2$1_correct)))
(let ((inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon0_correct  (=> (not false) (and (=> (= (ControlFlow 0 108303) 109463) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon29_Then_correct) (=> (= (ControlFlow 0 108303) 108309) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon29_Else_correct)))))
(let ((anon0$1_correct@@1  (=> (forall (($inv_addr@@6 Int) ) (!  (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6)) (let ((va@@34 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))))
(let ((l@@34 (|l#$ValueArray| va@@34)))
 (and (and (<= 0 l@@34) (<= l@@34 $MAX_U64)) (forall ((x@@34 Int) ) (!  (=> (or (< x@@34 0) (>= x@@34 l@@34)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@34) x@@34))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) 1)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))) $DiemTimestamp_CurrentTimeMicroseconds_microseconds)) $MAX_U64))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray $inv_addr@@6))
)) (=> (and (forall (($inv_addr@@7 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7)) (let ((va@@35 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))))
(let ((l@@35 (|l#$ValueArray| va@@35)))
 (and (and (<= 0 l@@35) (<= l@@35 $MAX_U64)) (forall ((x@@35 Int) ) (!  (=> (or (< x@@35 0) (>= x@@35 l@@35)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@35) x@@35))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_height)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_height)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_height)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events)) (let ((va@@36 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))))
(let ((l@@36 (|l#$ValueArray| va@@36)))
 (and (and (<= 0 l@@36) (<= l@@36 $MAX_U64)) (forall ((x@@36 Int) ) (!  (=> (or (< x@@36 0) (>= x@@36 l@@36)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@36) x@@36))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid)) (let ((va@@37 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))
(let ((l@@37 (|l#$ValueArray| va@@37)))
 (and (and (<= 0 l@@37) (<= l@@37 $MAX_U64)) (forall ((x@@37 Int) ) (!  (=> (or (< x@@37 0) (>= x@@37 l@@37)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@37) x@@37))
))))))) (forall (($$0@@11 Int) ) (!  (=> (and (>= $$0@@11 0) (< $$0@@11 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@11)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@11)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@11)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@11))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@7))
)) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))))))) (=> (and (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_Configuration_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean  (and (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemConfig_DiemConfig_$memory) ($TypeValueArray (|Store_[$int]$TypeValue| ($MapConstTypeValue $ErrorType) 0 $DiemSystem_DiemSystem_type_value) 1) (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemSystem_CapabilityHolder_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))))))) (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 109467) 108303))) inline$$DiemBlock_initialize_block_metadata_$def_verify$0$anon0_correct)))))
(let ((anon0_correct@@1  (=> (and ((_ is $Address) account) (= (ControlFlow 0 107702) 109467)) anon0$1_correct@@1)))
(let ((PreconditionGeneratedEntry_correct@@0  (=> (= (ControlFlow 0 117639) 107702) anon0_correct@@1)))
PreconditionGeneratedEntry_correct@@0)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(declare-fun inline$$DiemBlock_is_initialized_$def_verify$0$$t1@1 () T@$Value)
(declare-fun inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 () T@$Value)
(push 1)
(assert (not
 (=> (= (ControlFlow 0 0) 119424) (let ((inline$$DiemBlock_is_initialized_$def_verify$0$anon6_Else_correct true))
(let ((inline$$DiemBlock_is_initialized_$def_verify$0$anon6_Then_correct true))
(let ((inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Else_correct  (=> (and (not false) (= inline$$DiemBlock_is_initialized_$def_verify$0$$t1@1 ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2))))) (and (=> (= (ControlFlow 0 109993) 110009) inline$$DiemBlock_is_initialized_$def_verify$0$anon6_Then_correct) (=> (= (ControlFlow 0 109993) 109999) inline$$DiemBlock_is_initialized_$def_verify$0$anon6_Else_correct)))))
(let ((inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Then_correct true))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2  (=> (not true) (and (=> (= (ControlFlow 0 109951) 110017) inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 109951) 109993) inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Else_correct)))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2  (and (=> (= (ControlFlow 0 109961) 110017) inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Then_correct) (=> (= (ControlFlow 0 109961) 109993) inline$$DiemBlock_is_initialized_$def_verify$0$anon5_Else_correct))))
(let ((inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2  (=> (and (not false) (= inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$$t0@1@@2 ($Address 173345816))) (and (=> (= (ControlFlow 0 109945) 109961) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Then_correct@@2) (=> (= (ControlFlow 0 109945) 109951) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon3_Else_correct@@2)))))
(let ((inline$$DiemBlock_is_initialized_$def_verify$0$anon0_correct  (=> (and (not false) (= (ControlFlow 0 109975) 109945)) inline$$CoreAddresses_DIEM_ROOT_ADDRESS_$def$0$anon0_correct@@2)))
(let ((anon0$1_correct@@2  (=> (forall (($inv_addr@@8 Int) ) (!  (and (and (and (and (and ((_ is $Vector) (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8)) (let ((va@@38 (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))))
(let ((l@@38 (|l#$ValueArray| va@@38)))
 (and (and (<= 0 l@@38) (<= l@@38 $MAX_U64)) (forall ((x@@38 Int) ) (!  (=> (or (< x@@38 0) (>= x@@38 l@@38)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@38) x@@38))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_height)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_height)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_height)) $MAX_U64))) (and (and (and (and (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events)) (let ((va@@39 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))))
(let ((l@@39 (|l#$ValueArray| va@@39)))
 (and (and (<= 0 l@@39) (<= l@@39 $MAX_U64)) (forall ((x@@39 Int) ) (!  (=> (or (< x@@39 0) (>= x@@39 l@@39)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@39) x@@39))
)))))) (= (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) 2)) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_counter)) $MAX_U64))) (and ((_ is $Vector) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid)) (let ((va@@40 (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))
(let ((l@@40 (|l#$ValueArray| va@@40)))
 (and (and (<= 0 l@@40) (<= l@@40 $MAX_U64)) (forall ((x@@40 Int) ) (!  (=> (or (< x@@40 0) (>= x@@40 l@@40)) (= (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40) $Error)) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| va@@40) x@@40))
))))))) (forall (($$0@@12 Int) ) (!  (=> (and (>= $$0@@12 0) (< $$0@@12 (|l#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))))) (and (and ((_ is $Integer) (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@12)) (>= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@12)) 0)) (<= (|i#$Integer| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@12)) $MAX_U8))) :pattern ( (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$int]$Value| (|v#$ValueArray| (|v#$Vector| (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))) $DiemBlock_BlockMetadata_new_block_events))) $Event_EventHandle_guid))) $$0@@12))
)))) true) :pattern ( (|Select_[$TypeValueArray,$int]$Value| (|contents#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray $inv_addr@@8))
)) (=> (and (|b#$Boolean| ($Boolean  (=> (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemTimestamp_CurrentTimeMicroseconds_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816))))) (|b#$Boolean| ($Boolean (|Select_[$TypeValueArray,$int]$bool| (|domain#$Memory| $DiemBlock_BlockMetadata_$memory) $EmptyTypeValueArray (|a#$Address| ($Address 173345816)))))))) (= (ControlFlow 0 110023) 109975)) inline$$DiemBlock_is_initialized_$def_verify$0$anon0_correct))))
(let ((anon0_correct@@2  (=> (= (ControlFlow 0 119424) 110023) anon0$1_correct@@2)))
anon0_correct@@2)))))))))))
))
(set-info :status unsat)
(check-sat)
(pop 1)
(exit)
